/*
	This file include terawins t-con parameters.
*/
#include <linux/autoconf.h>

#define END_CMD						(-1)
#define TERAWINS_END				5

#if CONFIG_TERAWINS_TCON

/* 10" panel (800x480(37M) => 1024x600) */
#if (CONFIG_ARCPGU_DISPTYPE == 3)
//-- 16:9
int TerawinsInitCmdPage0[][2]=
{	/* Addr, Val */
    {  0x30, 0x42  },
    {  0x31, 0x70  },
    {  0x32, 0x3f  },
    {  0x33, 0xbf  },
    {  0x34, 0x00  },
    {  0x35, 0xbc  },
    {  0x36, 0x34  },
    {  0x37, 0x40  },
    {  0x38, 0x00  },
    {  0x39, 0x10  },
    {  0x3a, 0x00  },
    {  0x3b, 0x00  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x10  },

    {  0x50, 0x00  },

    {  0x60, 0x00  },
    {  0x61, 0x88  },
    {  0x62, 0x18  },
    {  0x63, 0x04  },//High Pass Filter   {  0x63, 0x0f  }, //mod by Eric 2007-09-20
    {  0x64, 0x04  },//Low Pass Filter    {  0x64, 0x04  },
    {  0x65, 0x08  },
    {  0x66, 0x08  },
    {  0x67, 0x1e  },
	{  0x68, 0x89  },//Contrast    {  0x68, 0x55  },//pwm
    {  0x69, 0x60  },//Bright    {  0x69, 0x73  },//    {  0x69, 0x72  },
    {  0x6a, 0x00  },
    {  0x6b, 0x7f  },
    {  0x6c, 0x80  },
    {  0x6d, 0x00  },
    {  0x6e, 0x10  },
    {  0x6f, 0x00  },

    {  0x72, 0x9f  },//    {  0x72, 0x00  },
    {  0x73, 0x18  },//    {  0x73, 0x19  },
    {  0x74, 0x99  },
    {  0x75, 0x19  },
    {  0x76, 0x00  },
    {  0x77, 0x00  },
    {  0x78, 0x00  },
    {  0x79, 0x00  },
    {  0x7a, 0x00  },
    {  0x7b, 0x00  },
    {  0x7c, 0x00  },
    {  0x7d, 0x10  },
    {  0x7e, 0x80  },
    {  0x7f, 0x80  },

	/* Flowbee@960608. */
    {  0x85, 0x5f  },

    {  0x90, 0x04  },//Dither_video    {  0x90, 0x05  },//Still    {  0x90, 0x04  },
    {  0x91, 0x07  },
    {  0x92, 0x00  },
    {  0x93, 0x00  },
    {  0x94, 0x00  },
    {  0x95, 0x00  },
    {  0x96, 0x00  },
    {  0x97, 0x00  },
    {  0x98, 0x00  },
    {  0x99, 0x02  },
    {  0x9a, 0x40  },
    {  0x9b, 0x00  },
    {  0x9c, 0x00  },
    {  0x9d, 0x10  },
    {  0x9e, 0x80  },
    {  0x9f, 0x80  },

    {  0xb0, 0x20  },
    {  0xb1, 0x00  },
    {  0xb2, 0x0f  },
    {  0xb3, 0x00  },
    {  0xb4, 0x00  },
    {  0xb5, 0x04  },
    {  0xb6, 0x58  },
    {  0xb7, 0x02  },
    {  0xb8, 0x3a  },
    {  0xb9, 0x04  },
    {  0xba, 0x58  },
    {  0xbb, 0x02  },
    {  0xbc, 0x20  },
    {  0xbd, 0x00  },
    {  0xbe, 0x04  },
    {  0xbf, 0x00  },

	{  0xc0, 0x01  },//RGB666
    {  0xc1, 0x08  },//    {  0xc1, 0x00  },
    {  0xc2, 0x00  },
    {  0xc3, 0x00  },
    {  0xc4, 0x00  },
    {  0xc5, 0x60  },
    {  0xc6, 0x05  },
    {  0xc7, 0x00  },
    {  0xc8, 0x45  },
    {  0xc9, 0x03  },
    {  0xca, 0x02  },
    {  0xcb, 0x00  },
    {  0xcc, 0x00  },
    {  0xcd, 0x00  },
    {  0xce, 0x00  },
    {  0xcf, 0x00  },

    {  0xd0, 0x00  },
    {  0xd1, 0x00  },
    {  0xd2, 0x00  },
    {  0xd3, 0x00  },
    {  0xd4, 0x00  },
    {  0xd5, 0x00  },
    {  0xd6, 0x00  },
    {  0xd7, 0x00  },
    {  0xd8, 0x00  },
    {  0xd9, 0x00  },
    {  0xda, 0x00  },
    {  0xdb, 0x00  },
    {  0xdc, 0x00  },
    {  0xdd, 0x04  },
    {  0xde, 0x58  },
    {  0xdf, 0x02  },

    {  0xe0, 0xb0  },
    {  0xe1, 0xc0  },
    {  0xe2, 0x00  },
    {  0xe3, 0x00  },
    {  0xe4, 0x00  },
    {  0xe5, 0x00  },
    {  0xe6, 0x07  },
    {  0xe7, 0x80  },
    {  0xe8, 0x00  },
    {  0xe9, 0x60  },
    {  0xea, 0x07  },
    {  0xeb, 0x80  },
    {  0xec, 0xc0  },
    {  0xed, 0x80  },
    {  0xee, 0x00  },
    {  0xef, 0x00  },
	{  END_CMD, END_CMD  },
};

int TerawinsInitCmdPage1[][2]=
{	/* Addr, Val */
    {  0x20, 0x00  },
    {  0x21, 0xff  },
    {  0x22, 0x03  },
    {  0x23, 0x00  },
    {  0x24, 0x21  },
    {  0x25, 0x00  },
    {  0x26, 0x00  },
    {  0x27, 0x00  },
    {  0x28, 0x00  },
    {  0x29, 0x00  },
    {  0x2a, 0x00  },
    {  0x2b, 0x01  },
    {  0x2c, 0x12  },
    {  0x2d, 0x05  },
    {  0x2e, 0x68  },
    {  0x2f, 0x01  },

    {  0x30, 0x00  },
    {  0x31, 0x0f  },
    {  0x32, 0x00  },
    {  0x33, 0x0f  },
    {  0x34, 0x00  },
    {  0x35, 0x00  },
    {  0x36, 0x00  },
    {  0x37, 0x00  },
    {  0x38, 0x00  },
    {  0x39, 0x00  },
    {  0x3a, 0x00  },
    {  0x3b, 0x00  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },

    {  0xb0, 0x95  },
    {  0xb1, 0x00  },
    {  0xb2, 0xcc  },
    {  0xb3, 0x95  },
    {  0xb4, 0x32  },
    {  0xb5, 0x68  },
    {  0xb6, 0x95  },
    {  0xb7, 0x81  },
    {  0xb8, 0xc0  },
    {  0xb9, 0x00  },
    {  0xba, 0x00  },
    {  0xbb, 0x00  },
    {  0xbc, 0x00  },
    {  0xbd, 0x00  },
    {  0xbe, 0x00  },
    {  0xbf, 0x00  },

    {  0xd0, 0x30  },
    {  0xd1, 0x00  },
    {  0xd2, 0x10  },
    {  0xd3, 0x01  },
    {  0xd4, 0x01  },
    {  0xd5, 0x4c  },//    {  0xd5, 0x49  },
    {  0xd6, 0x00  },
    {  0xd7, 0x20  },
    {  0xd8, 0x03  },
    {  0xd9, 0x2a  },
    {  0xda, 0x00  },
    {  0xdb, 0xe0  },
    {  0xdc, 0x01  },
    {  0xdd, 0x00  },
    {  0xde, 0x03  },//    {  0xde, 0x02  },
    {  0xdf, 0x4c  },
	{  END_CMD, END_CMD  },
};

/* 7" panel 800x480(37M) */
#elif (CONFIG_ARCPGU_DISPTYPE == 4)
//-- 16:9
int TerawinsInitCmdPage0[][2]=
{	/* Addr, Val */
    {  0x30, 0x03  },
    {  0x31, 0x70  },
    {  0x32, 0x3f  },//    {  0x32, 0x1b  },
    {  0x33, 0x3f  },
    {  0x34, 0x00  },
    {  0x35, 0xbc  },
    {  0x36, 0xbc  },
    {  0x37, 0x40  },
    {  0x38, 0x50  },
    {  0x39, 0x10  },
    {  0x3a, 0x20  },
    {  0x3b, 0x03  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },

    {  0x50, 0x00  },

    {  0x60, 0x00  },
    {  0x61, 0x88  },
    {  0x62, 0x18  },
    {  0x63, 0x04  },//High Pass Filter   {  0x63, 0x0f  }, //mod by Eric 2007-09-20
    {  0x64, 0x04  },//Low Pass Filter    {  0x64, 0x04  },
    {  0x65, 0x08  },
    {  0x66, 0x88  },
    {  0x67, 0x1e  },
	{  0x68, 0x89  },//Contrast    {  0x68, 0x55  },//pwm

	#if CONFIG_UDRL_INVERSE
	{  0x69, 0x81  },//Bright    {  0x69, 0x73  },//    {  0x69, 0x72  },
	#else
	{  0x69, 0x6c  },//Bright    {  0x69, 0x73  },//    {  0x69, 0x72  },
	#endif

    {  0x6a, 0x00  },
    {  0x6b, 0x7f  },
    {  0x6c, 0x82  },
    {  0x6d, 0x00  },
    {  0x6e, 0x10  },
    {  0x6f, 0x00  },

    {  0x72, 0x00  },//    {  0x72, 0x00  },
    {  0x73, 0x20  },//    {  0x73, 0x19  },
    {  0x74, 0x00  },
    {  0x75, 0x20  },
    {  0x76, 0x00  },
    {  0x77, 0x00  },
    {  0x78, 0x00  },
    {  0x79, 0x00  },
    {  0x7a, 0x00  },
    {  0x7b, 0x00  },
    {  0x7c, 0x00  },
    {  0x7d, 0x10  },
    {  0x7e, 0x80  },
    {  0x7f, 0x80  },

	/* Flowbee@960608. */
    {  0x84, 0x00  },
    {  0x85, 0x5b  },

    {  0x90, 0x04  },//Dither_video    {  0x90, 0x05  },//Still    {  0x90, 0x04  },
    {  0x91, 0x07  },
    {  0x92, 0x00  },
    {  0x93, 0x00  },
    {  0x94, 0x00  },
    {  0x95, 0x00  },
    {  0x96, 0x00  },
    {  0x97, 0x00  },
    {  0x98, 0x00  },
    {  0x99, 0x02  },
    {  0x9a, 0x40  },
    {  0x9b, 0x00  },
    {  0x9c, 0x00  },
    {  0x9d, 0x10  },
    {  0x9e, 0x80  },
    {  0x9f, 0x80  },

    {  0xb0, 0x20  },
    {  0xb1, 0x00  },
    {  0xb2, 0x0f  },
    {  0xb3, 0x00  },
    {  0xb4, 0x25  },
    {  0xb5, 0x03  },
    {  0xb6, 0xe0  },
    {  0xb7, 0x02  },
    {  0xb8, 0x64  },
    {  0xb9, 0x04  },
    {  0xba, 0x0d  },
    {  0xbb, 0x02  },
    {  0xbc, 0x20  },
    {  0xbd, 0x00  },
    {  0xbe, 0x04  },
    {  0xbf, 0x00  },

	{  0xc0, 0x01  },//RGB666
    {  0xc1, 0x08  },
    {  0xc2, 0x00  },
    {  0xc3, 0x00  },
    {  0xc4, 0x00  },
    {  0xc5, 0x60  },
    {  0xc6, 0x05  },
    {  0xc7, 0x00  },
    {  0xc8, 0x39  },
    {  0xc9, 0x03  },
    {  0xca, 0x02  },
    {  0xcb, 0x00  },
    {  0xcc, 0x00  },
    {  0xcd, 0x00  },
    {  0xce, 0x00  },
    {  0xcf, 0x00  },

//    {  0xd0, 0x00  },
//    {  0xd1, 0x00  },
//    {  0xd2, 0x00  },
//    {  0xd3, 0x00  },
//    {  0xd4, 0x00  },
//    {  0xd5, 0x00  },
//    {  0xd6, 0x00  },
//    {  0xd7, 0x00  },
    {  0xd8, 0x00  },
    {  0xd9, 0x00  },
    {  0xda, 0x00  },
    {  0xdb, 0x00  },
    {  0xdc, 0x25  },
    {  0xdd, 0x03  },
    {  0xde, 0xe0  },
    {  0xdf, 0x02  },

    {  0xe0, 0xb1  },

    #if	CONFIG_FASHION_STAR	// Up/Down
    {  0xe1, 0xc0  },//Fashion Star
	#else
		#if CONFIG_UDRL_INVERSE
	    {  0xe1, 0xf0  },//Skymedi
		#else
	    {  0xe1, 0x00  },//Billionton
	    #endif
	#endif

    {  0xe2, 0x00  },
    {  0xe3, 0x00  },
    {  0xe4, 0x00  },
    {  0xe5, 0x00  },
    {  0xe6, 0x07  },
    {  0xe7, 0x80  },
    {  0xe8, 0x00  },//    {  0xe8, 0x10  },
    {  0xe9, 0x60  },
    {  0xea, 0x07  },
    {  0xeb, 0x80  },
    {  0xec, 0xc0  },
    {  0xed, 0x80  },
    {  0xee, 0x00  },
    {  0xef, 0x00  },
	{  END_CMD, END_CMD  },
};

int TerawinsInitCmdPage1[][2]=
{	/* Addr, Val */
    {  0x20, 0x28  },//    {  0x20, 0x20  },
    {  0x21, 0x7b  },
    {  0x22, 0xc5  },
    {  0x23, 0x03  },
    {  0x24, 0x0c  },
    {  0x25, 0xc5  },
    {  0x26, 0x03  },
    {  0x27, 0xb9  },
    {  0x28, 0x03  },
    {  0x29, 0x29  },
    {  0x2a, 0x00  },
    {  0x2b, 0x06  },//Still    {  0x2b, 0x06  },//Video    {  0x2b, 0x07  },
    {  0x2c, 0x18  },
    {  0x2d, 0x03  },
    {  0x2e, 0x00  },
    {  0x2f, 0x00  },

    {  0x30, 0x00  },
    {  0x31, 0x90  },
    {  0x32, 0x03  },
    {  0x33, 0x35  },
    {  0x34, 0x00  },
    {  0x35, 0x02  },
    {  0x36, 0x80  },
    {  0x37, 0x02  },
    {  0x38, 0x00  },
    {  0x39, 0x00  },
    {  0x3a, 0x00  },
    {  0x3b, 0x00  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },

    {  0xb0, 0x95  },
    {  0xb1, 0x00  },
    {  0xb2, 0xe0  },//    {  0xb2, 0xe0  },
    {  0xb3, 0x95  },//    {  0xb3, 0x91  },//    {  0xb3, 0x8e  },//    {  0xb3, 0x74  },
    {  0xb4, 0x00  },//    {  0xb4, 0x32  },
    {  0xb5, 0x68  },
    {  0xb6, 0x95  },
    {  0xb7, 0x81  },
    {  0xb8, 0xc0  },
    {  0xb9, 0x00  },
    {  0xba, 0x00  },
    {  0xbb, 0x00  },
    {  0xbc, 0x00  },
    {  0xbd, 0x00  },
    {  0xbe, 0x00  },
    {  0xbf, 0x00  },

    {  0xd0, 0x30  },
    {  0xd1, 0x00  },
    {  0xd2, 0x08  },//    {  0xd2, 0x0a  },
    {  0xd3, 0x01  },
    {  0xd4, 0x01  },
    {  0xd5, 0x44  },//Still    {  0xd5, 0x37  },//Video    {  0xd5, 0x3b  },
    {  0xd6, 0x00  },
    {  0xd7, 0x60  },//Still    {  0xd7, 0x25  },//Video    {  0xd7, 0x20  },
    {  0xd8, 0x03  },//    {  0xd8, 0x02  },
    {  0xd9, 0x2a  },//    {  0xd9, 0x08  },
    {  0xda, 0x00  },
    {  0xdb, 0xe0  },
    {  0xdc, 0x01  },
    {  0xdd, 0x00  },
    {  0xde, 0x02  },
    {  0xdf, 0x0c  },
	{  END_CMD, END_CMD  },
};

/* Innolux 800x600 LCD panel. */
#elif (CONFIG_ARCPGU_DISPTYPE == 5)
// 37 MHz RGB666
int TerawinsInitCmdPage0[][2]=
{	/* Addr, Val */
    {  0x30, 0x03  },
    {  0x31, 0x70  },//RGB666
    {  0x32, 0x3f  },
    {  0x33, 0x3f  },
    {  0x34, 0x00  },
    {  0x35, 0xbc  },
    {  0x36, 0xbc  },//    {  0x36, 0x34  },
    {  0x37, 0x40  },
    {  0x38, 0x50  },
    {  0x39, 0x10  },
    {  0x3a, 0x20  },
    {  0x3b, 0x03  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },//    {  0x3f, 0x10  },

	/* Flowbee@960608. */
    {  0x50, 0x00  },//    {  0x50, 0x30  },

    {  0x60, 0x00  },
    {  0x61, 0x88  },
    {  0x62, 0x18  },
    {  0x63, 0x04  },//High Pass Filter   {  0x63, 0x0f  }, //mod by Eric 2007-09-20
    {  0x64, 0x04  },//    {  0x64, 0x03  },//Low Pass Filter    {  0x64, 0x04  },
    {  0x65, 0x08  },
    {  0x66, 0x88  },
    {  0x67, 0x1e  },
#if defined(GUI_STYLE_COMTEK) //20080701
	{  0x68, 0x70  },
	{  0x69, 0x80  },
#elif defined(CONFIG_FASHION_STAR)
	{  0x68, 0x80  },
	{  0x69, 0x88  },
#else
	{  0x68, 0x89  },//	{  0x68, 0x7d  },//Contrast    {  0x68, 0x55  },//pwm
	#if CONFIG_UDRL_INVERSE
	{  0x69, 0x81  },//Bright    {  0x69, 0x73  },//    {  0x69, 0x72  },
	#else
	{  0x69, 0x60  },//Bright    {  0x69, 0x73  },//    {  0x69, 0x72  },
	#endif
#endif
    {  0x6a, 0x00  },
    {  0x6b, 0x7f  },
    {  0x6c, 0x82  },
    {  0x6d, 0x00  },
    {  0x6e, 0x10  },
    {  0x6f, 0x00  },

    {  0x72, 0x0b  },//Still    {  0x72, 0x0b  },//Video    {  0x72, 0xd1  },
    {  0x73, 0x20  },//Still    {  0x73, 0x20  },//Video    {  0x73, 0x1f  },
    {  0x74, 0x00  },
    {  0x75, 0x20  },
    {  0x76, 0x00  },
    {  0x77, 0x00  },
    {  0x78, 0x00  },
    {  0x79, 0x00  },
    {  0x7a, 0x00  },
    {  0x7b, 0x00  },
    {  0x7c, 0x00  },
    {  0x7d, 0x10  },
    {  0x7e, 0x80  },
    {  0x7f, 0x80  },

    {  0x85, 0x1f  },//27MHz    {  0x85, 0x1f  },//54MHz    {  0x85, 0x14  },

    {  0x90, 0x04  },//Dither_video    {  0x90, 0x05  },//Still    {  0x90, 0x04  },
    {  0x91, 0x87  },//on    {  0x91, 0x07  },//off    {  0x91, 0x87  },
    {  0x92, 0x00  },
    {  0x93, 0x00  },
    {  0x94, 0x00  },
    {  0x95, 0x00  },
    {  0x96, 0x00  },
    {  0x97, 0x00  },
    {  0x98, 0x00  },
    {  0x99, 0x02  },
    {  0x9a, 0x40  },
    {  0x9b, 0x00  },
    {  0x9c, 0x00  },
    {  0x9d, 0x10  },
    {  0x9e, 0x80  },
    {  0x9f, 0x80  },

    {  0xb0, 0x20  },
    {  0xb1, 0x00  },

    {  0xb2, 0x0e  },//27MHz    {  0xb2, 0x0e  },//54MHz    {  0xb2, 0x17  },

    {  0xb3, 0x00  },
    {  0xb4, 0x25  },
    {  0xb5, 0x03  },
#if defined(GUI_STYLE_COMTEK) //20080701
    {  0xb6, 0x70  },
#else
    {  0xb6, 0x59  },//960828    {  0xb6, 0x58  },
#endif
    {  0xb7, 0x02  },

    {  0xb8, 0xff  },//27MHz    {  0xb8, 0x86  },//54MHz    {  0xb8, 0xcb  },
    {  0xb9, 0x04  },//27MHz    {  0xb9, 0x05  },//27MHz    {  0xb9, 0x04  },

    {  0xba, 0x6d  },
    {  0xbb, 0x02  },
    {  0xbc, 0x20  },
    {  0xbd, 0x00  },
    {  0xbe, 0x04  },
    {  0xbf, 0x00  },

	{  0xc0, 0x01  },//RGB666
    {  0xc1, 0x08  },
    {  0xc2, 0x12  },//on    {  0xc2, 0x00  },//off    {  0xc2, 0x12  },
    {  0xc3, 0x00  },
    {  0xc4, 0x00  },
    {  0xc5, 0x60  },
    {  0xc6, 0x05  },
    {  0xc7, 0x00  },

    {  0xc8, 0x36  },//27MHz    {  0xc8, 0x3c  },//54MHz    {  0xc8, 0x19  },

    {  0xc9, 0x02  },
    {  0xca, 0x02  },
    {  0xcb, 0x00  },
    {  0xcc, 0x00  },
    {  0xcd, 0x00  },
    {  0xce, 0x00  },
    {  0xcf, 0x00  },

    {  0xd0, 0x00  },
    {  0xd1, 0x00  },
    {  0xd2, 0x00  },
    {  0xd3, 0x00  },
    {  0xd4, 0x00  },
    {  0xd5, 0x00  },
    {  0xd6, 0x00  },
    {  0xd7, 0x00  },
    {  0xd8, 0x00  },
    {  0xd9, 0x00  },
    {  0xda, 0x00  },
    {  0xdb, 0x00  },
    {  0xdc, 0x25  },
    {  0xdd, 0x03  },
    {  0xde, 0x58  },
    {  0xdf, 0x02  },

    {  0xe0, 0xb1  },
    #if	CONFIG_FASHION_STAR	// Up/Down
    {  0xe1, 0xc0  },//Fashion Star
	#else
		#if CONFIG_UDRL_INVERSE
	    {  0xe1, 0xf0  },//Skymedi
		#else
	    {  0xe1, 0x00  },//Billionton
	    #endif
	#endif
    {  0xe2, 0x00  },
    {  0xe3, 0x00  },
    {  0xe4, 0x00  },
    {  0xe5, 0x00  },
    {  0xe6, 0x07  },
    {  0xe7, 0x80  },
    {  0xe8, 0x00  },// pwm
    {  0xe9, 0x60  },// pwm
    {  0xea, 0x07  },
    {  0xeb, 0x80  },
    {  0xec, 0xc0  },
    {  0xed, 0x00  },//    {  0xed, 0x10  },
    {  0xee, 0x00  },
    {  0xef, 0x00  },
	{  END_CMD, END_CMD  },
};

int TerawinsInitCmdPage1[][2]=
{	/* Addr, Val */
    {  0x20, 0x28  },
    {  0x21, 0x7b  },
    {  0x22, 0xc5  },
    {  0x23, 0x03  },
    {  0x24, 0x0c  },
    {  0x25, 0xc5  },
    {  0x26, 0x03  },
    {  0x27, 0xb9  },
    {  0x28, 0x03  },
    {  0x29, 0x29  },
    {  0x2a, 0x00  },
    {  0x2b, 0x06  },//Still    {  0x2b, 0x06  },//Video    {  0x2b, 0x07  },
    {  0x2c, 0x18  },
    {  0x2d, 0x03  },
    {  0x2e, 0x00  },
    {  0x2f, 0x00  },

    {  0x30, 0x00  },
    {  0x31, 0x90  },
    {  0x32, 0x03  },
    {  0x33, 0x35  },
    {  0x34, 0x00  },
    {  0x35, 0x02  },
    {  0x36, 0x80  },
    {  0x37, 0x02  },
    {  0x38, 0x00  },
    {  0x39, 0x00  },
    {  0x3a, 0x00  },
    {  0x3b, 0x00  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },

    {  0xb0, 0x95  },
    {  0xb1, 0x00  },
    {  0xb2, 0xe8  },//    {  0xb2, 0xe0  },
    {  0xb3, 0x95  },//    {  0xb3, 0x91  },//    {  0xb3, 0x8e  },//    {  0xb3, 0x74  },
    #if CONFIG_FASHION_STAR
    {  0xb4, 0x14  },
	#else
    {  0xb4, 0x00  },//    {  0xb4, 0x32  },
	#endif
    {  0xb5, 0x68  },
    {  0xb6, 0x95  },
    {  0xb7, 0x81  },
    {  0xb8, 0xc0  },
    {  0xb9, 0x00  },
    {  0xba, 0x00  },
    {  0xbb, 0x00  },
    {  0xbc, 0x00  },
    {  0xbd, 0x00  },
    {  0xbe, 0x00  },
    {  0xbf, 0x00  },

    {  0xd0, 0x30  },
    {  0xd1, 0x00  },
    {  0xd2, 0x08  },//    {  0xd2, 0x0a  },
    {  0xd3, 0x01  },
    {  0xd4, 0x01  },
    {  0xd5, 0x37  },//Still    {  0xd5, 0x37  },//Video    {  0xd5, 0x3b  },
    {  0xd6, 0x00  },
    {  0xd7, 0x25  },//Still    {  0xd7, 0x25  },//Video    {  0xd7, 0x20  },
    {  0xd8, 0x03  },//    {  0xd8, 0x02  },
    {  0xd9, 0x11  },//960824    {  0xd9, 0x12  },
    {  0xda, 0x00  },
    {  0xdb, 0x58  },
    {  0xdc, 0x02  },
    {  0xdd, 0x00  },
    {  0xde, 0x03  },//    {  0xde, 0x02  },
    {  0xdf, 0x0c  },
	{  END_CMD, END_CMD  },
};

#elif (CONFIG_ARCPGU_DISPTYPE == 6)
//-- 1366x768 LCD panel
int TerawinsInitCmdPage0[][2]=
{	/* Addr, Val */
    {  0x30, 0x42  },
    {  0x31, 0x70  },
    {  0x32, 0x3f  },
    {  0x33, 0xbf  },
    {  0x34, 0x00  },
    {  0x35, 0xbc  },
    {  0x36, 0x34  },
    {  0x37, 0x40  },
    {  0x38, 0x00  },
    {  0x39, 0x10  },
    {  0x3a, 0x00  },
    {  0x3b, 0x00  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x10  },

    {  0x50, 0x00  },

    {  0x54, 0x20  },
    {  0x55, 0x03  },
    {  0x56, 0xe0  },
    {  0x57, 0x01  },

    {  0x60, 0x00  },
    {  0x61, 0x88  },
    {  0x62, 0x18  },
    {  0x63, 0x0f  },//High Pass Filter   {  0x63, 0x0f  }, //mod by Eric 2007-09-20
    {  0x64, 0x04  },//Low Pass Filter    {  0x64, 0x04  },
    {  0x65, 0x08  },
    {  0x66, 0x08  },
    {  0x67, 0x1e  },
	{  0x68, 0x89  },//Contrast    {  0x68, 0x55  },//pwm
    {  0x69, 0x60  },//Bright    {  0x69, 0x73  },//    {  0x69, 0x72  },
    {  0x6a, 0x00  },
    {  0x6b, 0x7f  },
    {  0x6c, 0x80  },
    {  0x6d, 0x00  },
    {  0x6e, 0x10  },
    {  0x6f, 0x00  },

    {  0x72, 0x76  },
    {  0x73, 0x12  },
    {  0x74, 0x00  },
    {  0x75, 0x14  },
    {  0x76, 0x00  },
    {  0x77, 0x00  },
    {  0x78, 0x00  },
    {  0x79, 0x00  },
    {  0x7a, 0x00  },
    {  0x7b, 0x00  },
    {  0x7c, 0x00  },
    {  0x7d, 0x10  },
    {  0x7e, 0x80  },
    {  0x7f, 0x80  },

	/* Flowbee@960608. */
	{  0x82, 0xa8  },
    {  0x85, 0x5f  },

    {  0x90, 0x05  },//Dither_video    {  0x90, 0x05  },//Still    {  0x90, 0x04  },
    {  0x91, 0x07  },
    {  0x92, 0x00  },
    {  0x93, 0x00  },
    {  0x94, 0x00  },
    {  0x95, 0x00  },
    {  0x96, 0x00  },
    {  0x97, 0x00  },
    {  0x98, 0x00  },
    {  0x99, 0x02  },
    {  0x9a, 0x40  },
    {  0x9b, 0x00  },
    {  0x9c, 0x00  },
    {  0x9d, 0x10  },
    {  0x9e, 0x80  },
    {  0x9f, 0x80  },

    {  0xb0, 0x00  },//    {  0xb0, 0x20  },
    {  0xb1, 0x00  },
    {  0xb2, 0x24  },//    {  0xb2, 0x0f  },
    {  0xb3, 0x00  },
    {  0xb4, 0x56  },//    {  0xb4, 0x00  },
    {  0xb5, 0x05  },//    {  0xb5, 0x04  },
    {  0xb6, 0x00  },//    {  0xb6, 0x58  },
    {  0xb7, 0x03  },//    {  0xb7, 0x02  },
    {  0xb8, 0x4c  },//    {  0xb8, 0x3a  },
    {  0xb9, 0x07  },//    {  0xb9, 0x04  },
    {  0xba, 0x33  },//    {  0xba, 0x58  },
    {  0xbb, 0x03  },//    {  0xbb, 0x02  },
    {  0xbc, 0x20  },
    {  0xbd, 0x00  },
    {  0xbe, 0x00  },//    {  0xbe, 0x04  },
    {  0xbf, 0x00  },

	{  0xc0, 0x01  },//RGB666
    {  0xc1, 0x08  },
    {  0xc2, 0x00  },
    {  0xc3, 0x00  },
    {  0xc4, 0x00  },
    {  0xc5, 0x60  },
    {  0xc6, 0x05  },
    {  0xc7, 0x00  },
    {  0xc9, 0x02  },//    {  0xc9, 0x03  },
    {  0xca, 0x01  },//    {  0xca, 0x02  },
    {  0xc8, 0x30  },//    {  0xc8, 0x45  },
    {  0xcb, 0x00  },
    {  0xcc, 0x00  },
    {  0xcd, 0x00  },
    {  0xce, 0x00  },
    {  0xcf, 0x00  },

    {  0xd0, 0x00  },
    {  0xd1, 0x00  },
    {  0xd2, 0x00  },
    {  0xd3, 0x00  },
    {  0xd4, 0x00  },
    {  0xd5, 0x00  },
    {  0xd6, 0x00  },
    {  0xd7, 0x00  },
    {  0xd8, 0x00  },
    {  0xd9, 0x00  },
    {  0xda, 0x00  },
    {  0xdb, 0x00  },
    {  0xdc, 0x56  },//    {  0xdc, 0x00  },
    {  0xdd, 0x05  },//    {  0xdd, 0x04  },
    {  0xde, 0x00  },//    {  0xde, 0x58  },
    {  0xdf, 0x03  },//    {  0xdf, 0x02  },

    {  0xe0, 0xa0  },//    {  0xe0, 0xb0  },
    {  0xe1, 0xc0  },
    {  0xe2, 0x00  },
    {  0xe3, 0x00  },
    {  0xe4, 0x00  },
    {  0xe5, 0x00  },
    {  0xe6, 0x07  },
    {  0xe7, 0x80  },
    {  0xe8, 0x10  },//    {  0xe8, 0x00  },
    {  0xe9, 0x60  },
    {  0xea, 0x07  },
    {  0xeb, 0x80  },
    {  0xec, 0xc0  },
    {  0xed, 0x80  },
    {  0xee, 0x00  },
    {  0xef, 0x00  },
	{  END_CMD, END_CMD  },
};

int TerawinsInitCmdPage1[][2]=
{	/* Addr, Val */
    {  0x20, 0x00  },
    {  0x21, 0xff  },
    {  0x22, 0x03  },
    {  0x23, 0x00  },
    {  0x24, 0x21  },
    {  0x25, 0x00  },
    {  0x26, 0x00  },
    {  0x27, 0x00  },
    {  0x28, 0x00  },
    {  0x29, 0x00  },
    {  0x2a, 0x00  },
    {  0x2b, 0x01  },
    {  0x2c, 0x12  },
    {  0x2d, 0x05  },
    {  0x2e, 0x68  },
    {  0x2f, 0x01  },

    {  0x30, 0x00  },
    {  0x31, 0x0f  },
    {  0x32, 0x00  },
    {  0x33, 0x0f  },
    {  0x34, 0x00  },
    {  0x35, 0x00  },
    {  0x36, 0x00  },
    {  0x37, 0x00  },
    {  0x38, 0x00  },
    {  0x39, 0x00  },
    {  0x3a, 0x00  },
    {  0x3b, 0x00  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },

    {  0xb0, 0x95  },
    {  0xb1, 0x00  },
    {  0xb2, 0xcc  },
    {  0xb3, 0x95  },
    {  0xb4, 0x32  },
    {  0xb5, 0x68  },
    {  0xb6, 0x95  },
    {  0xb7, 0x81  },
    {  0xb8, 0xc0  },
    {  0xb9, 0x00  },
    {  0xba, 0x00  },
    {  0xbb, 0x00  },
    {  0xbc, 0x00  },
    {  0xbd, 0x00  },
    {  0xbe, 0x00  },
    {  0xbf, 0x00  },

    {  0xd0, 0x30  },
    {  0xd1, 0x00  },
    {  0xd2, 0x10  },
    {  0xd3, 0x01  },
    {  0xd4, 0x01  },
    {  0xd5, 0x4c  },
    {  0xd6, 0x00  },
    {  0xd7, 0x20  },
    {  0xd8, 0x03  },
    {  0xd9, 0x2a  },
    {  0xda, 0x00  },
    {  0xdb, 0xe0  },
    {  0xdc, 0x01  },
    {  0xdd, 0x00  },
    {  0xde, 0x01  },//    {  0xde, 0x03  },
    {  0xdf, 0x4c  },
	{  END_CMD, END_CMD  },
};

#else	// TV

int TerawinsInitCmdPage0[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

int TerawinsInitCmdPage1[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

#endif

int Terawins640x480Page0[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

int Terawins640x480Page1[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};


int Terawins720x480Page0[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

int Terawins720x480Page1[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};


int Terawins720x576Page0[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

int Terawins720x576Page1[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};


int Terawins800x600Page0[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

int Terawins800x600Page1[][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

int *TerawinsCmdTbl[TERAWINS_END*2]=
{
	(&(TerawinsInitCmdPage0[0][0])),
	(&(TerawinsInitCmdPage1[0][0])),
	(&(Terawins640x480Page0[0][0])),
	(&(Terawins640x480Page1[0][0])),
	(&(Terawins720x480Page0[0][0])),
	(&(Terawins720x480Page1[0][0])),
	(&(Terawins720x576Page0[0][0])),
	(&(Terawins720x576Page1[0][0])),
	(&(Terawins800x600Page0[0][0])),
	(&(Terawins800x600Page1[0][0])),
};

#endif


