/******************************************************************************
 * Copyright Codito Technologies (www.codito.com) Oct 01, 2004
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *****************************************************************************/

#include <linux/sched.h>
#include <linux/mm.h>

/* page functions */

void clear_page(void *page)
{
	unsigned long dummy;
	unsigned long end;
	
	__asm__ __volatile__(
		"add   %1, %0, %3\n\t"
		"1:\n\t"
		"sub   %0, %0, 4\n\t"
		"st.a  0, [%0, 4]\n\t"
		"st.a  0, [%0, 4]\n\t"
		"st.a  0, [%0, 4]\n\t" 
		"st.a  0, [%0, 4]\n\t" 
		"st.a  0, [%0, 4]\n\t" 
		"st.a  0, [%0, 4]\n\t" 
		"st.a  0, [%0, 4]\n\t" 
		"st.a  0, [%0, 4]\n\t"
		"add   %0, %0, 4\n\t"		
		"brne   %0, %1, 1b\n\t"
		:"=r"(dummy), "=r"(end)
		:"0"(page),"i"(PAGE_SIZE)
		:"memory"
	);
}


void copy_page(void *to, void *from)
{
	unsigned long page_to, page_from;
	unsigned long reg1, reg2, reg3, reg4;
	unsigned long end;

	__asm__ __volatile__(
		"add   %2, %0, %9\n\t"
		"sub   %1, %1, 4\n\t"
		"1:\n\t"
		"sub   %0, %0, 4\n\t"
		"ld.a  %3, [%1, 4]\n\t"
		"ld.a  %4, [%1, 4]\n\t"
		"ld.a  %5, [%1, 4]\n\t" 
		"ld.a  %6, [%1, 4]\n\t" 
		"st.a  %3, [%0, 4]\n\t"
		"st.a  %4, [%0, 4]\n\t"
		"st.a  %5, [%0, 4]\n\t" 
		"st.a  %6, [%0, 4]\n\t"
		"ld.a  %3, [%1, 4]\n\t"
		"ld.a  %4, [%1, 4]\n\t"
		"ld.a  %5, [%1, 4]\n\t" 
		"ld.a  %6, [%1, 4]\n\t" 
		"st.a  %3, [%0, 4]\n\t"
		"st.a  %4, [%0, 4]\n\t"
		"st.a  %5, [%0, 4]\n\t" 
		"st.a  %6, [%0, 4]\n\t"
		"add   %0, %0, 4\n\t"
		"brne  %0, %2, 1b\n\t"       
		:"=r"(page_to),"=r"(page_from),"=r"(end),
		"=&r"(reg1),"=&r"(reg2),"=&r"(reg3),"=&r"(reg4)
		:"0"(to),"1"(from),"i"(PAGE_SIZE)
	);

}

/* Initialize the new pgd with invalid ptes */

void pgd_init(unsigned long page)
{
	int zero = 0;
	unsigned long dummy1, dummy2;
	__asm__ __volatile__(
		"sub   %0, %0, 4\n\t"
		"1:\n\t"
		"st.a  %2, [%0, 4]\n\t"
		"st.a  %2, [%0, 4]\n\t"
		"st.a  %2, [%0, 4]\n\t" 
		"st.a  %2, [%0, 4]\n\t" 
		"st.a  %2, [%0, 4]\n\t" 
		"st.a  %2, [%0, 4]\n\t" 
		"st.a  %2, [%0, 4]\n\t" 
		"st.a  %2, [%0, 4]\n\t"
		"sub.f %1, %1, 1\n\t"
		"nop \n\t"
		"bnz   1b\n\t"       
		:"=r"(dummy1), "=r"(dummy2)
		:"r"(zero),"0"(page),
		"1"(USER_PTRS_PER_PGD/8)
	);
 
}
