/******************************************************************************
 * Copyright Codito Technologies (www.codito.com) Oct 01, 2004
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *****************************************************************************/


	/* /arch/arcnommu/kernel/head.S */

#include <linux/linkage.h>
#include <linux/config.h>
	.cpu A7

#ifdef CONFIG_KERNEL_ATAG
	.data
	.globl atag_head
	.align 4
atag_head:
		.long 0
#endif

	.section .text.init, "ax",@progbits
	.type stext, @function
	.globl stext
stext:
	sr	1,[0x47]	; Invalidate the data cache.

#ifdef CONFIG_KERNEL_ATAG
	;adding support for atag parsing 
	;If kernel parameters are passed by u-boot, then
	; r0 = 0
	; r1 = magic number (board identity)
	; r2 = address of ATAG parameter list 
	cmp	r0, 0x0
	jne	no_params
	lr	r3, [identity]
	cmp	r1, r3
	jne	no_params
	st	r2, [atag_head]

no_params:
#endif

 	mov_s	r2, _bss_start 	; Clear down the BSS
#ifdef CONFIG_ARC_CMDLINE
	ldw	r0,[r2,0]	; Leave the command in place, if we're using it.
	add	r2,r2,r0	; Command format is 2-bytes string length at _bss_start, followed by the command string
	add	r2,r2,2
	mov	r3,r2
	and	r2,r2,0xfffffffc
	add	r2,r2,4
__clear_word:
	stb.ab	0, [r3,1]
	brlt	r3,r2,__clear_word
#endif

	mov_s	r3, _bss_end
__clear_bss:	
  	st.ab	0, [r2,4]
  	brlt	r2, r3, __clear_bss

#ifdef CONFIG_ARC_CMDLINE
	mov_s	r2, _bss_start	;  Copy the command passed in via BSS
	ldw	r0,[r2,0]
        stw	0,[r2,0]
	tst	r0,0xffffffff
	jz	__cmddone
	mov_s	r3, command_line
	add	r2,r2,2

__cmdloop:
	ldb	r4,[r2]
	stb.ab  0,[r2,1]
	stb.ab	r4,[r3,1]
	
	sub.f	r0,r0,1
	jnz	__cmdloop
		
__cmddone:
#endif
	
	
; 	lr	r1,[identity]
; 	and	r2, r1, 0x000000ff   ;store in r2 the processor version
	
; 	asr	r1, r1, 8
; 	and	r1, r1, 0x000000ff     ;store in r3 the processor id  

; 	st	r2, [processor_version]
; 	st	r1, [processor_id]

	mov	fp, 0
	mov 	sp,init_task_union + 8192

	/* Jump to start of kernel initialization routine */
	jal	start_kernel

