/********************************************************************
	created:	2007/05/08
	filename: 	FontDB.c
	file base:	FontDB
	file ext:	c
	author:		
	purpose:	ŪëإߦrDatabase
*********************************************************************/

#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include "string.h"
#include "FontDB.h"

/*
////////////////////////////////////////////////
//	Description: ryz
////////////////////////////////////////////////

	Description Size			1 DWORD
	
	CharSet						1 BYTE
	Font Size(Level)			1 WORD
	
	rԭzr				256 Bytes

////////////////////////////////////////////////
//	Prediction Table
////////////////////////////////////////////////

	Prediction Structure Size	1 DWORD

	Prediction Table Number		1 WORD

[
	Size of Table1				1 WORD
	Table1 Content				TableSize1 * Byte
]
[
	Size of Table2...
	Table2 Content...
]
	...

////////////////////////////////////////////////
//	Huffman Table
////////////////////////////////////////////////

	Huffman Structure Size		1 DWORD

	Huffman Table Number		1 WORD

[
	Node Number for Table1		1 WORD
	Nodes						HuffmanTreeNodeNumber * Nodes
	{
		index		1 WORD
		value		1 DWORD
		length_bit	1 WORD
		code		Bytes[VLC]
	}
]
[
	Node Number for Table2...
	Nodes for Table2...
]
	...

////////////////////////////////////////////////
//	Font Index: r޳
////////////////////////////////////////////////

	Font Index Size				1 DWORD
	
	Total Character Number		1 WORD
	HIBYTE Range Number			1 WORD
	LOBYTE Range Number			1 WORD
	Correspond Number			1 WORD

	HIBYTE_Code_Ranges			HIBYTERangeNumber * CodeRange
	{
		start		1 Byte
		end			1 Byte
	}	
	...
	LOBYTE_Code_Ranges			LOBYTERangeNumber * CodeRange
	{
		start		1 Byte
		end			1 Byte
	}
	...
	Corresponds					CorrespondNumber * Correspond
	{
		High_Index	1 Byte
		Low_Index	1 Byte
	}
	...

	Code Word Lengths(byte)		TotalCharacterNumber * WORD
	
////////////////////////////////////////////////
//	Code Word: rsX
////////////////////////////////////////////////

	Code Word Structure Size	1 DWORD

	Code Words					TotalCharacterNumber * BYTE[VLC]
	...
*/

/**************************************************
//	Private
**************************************************/
bool Code_to_Index(FONT_DB* pFontDB, WORD Code, DWORD* pIndex);
bool File_Read_BYTE(FILE* fid, BYTE* pinbyte);
bool File_Read_WORD(FILE* fid, WORD* pinword);
///080514
bool File_Read_nWORD(FILE* fid, WORD* pinword, DWORD nWord);
/// 
bool File_Read_DWORD(FILE* fid, DWORD* pindword);
bool Restore_Prediction256(BYTE* CharBuffer, WORD CharWidth, WORD CharHeight, WORD BufferWidthAlign, PREDICT* pPredict);
///080116
bool Code_Cover(FONT_DB* pFontDB, WORD Code);
/// 

FONT_DB* Create_FontDB(char* FileName)
{
	FONT_DB* pFontDB;
	bool bSuccess = false;
	bool bFail = false;

	//ɮפUcm
	DWORD pos_description;	//Descriptionbɮפ_I
	DWORD pos_predict;		//Prediction Tablebɮפ_I
	DWORD pos_huffman;		//Huffman Tablebɮפ_I
	DWORD pos_index;		//Indexbɮפ_I
	DWORD pos_codeword;		//Code Wordbɮפ_I

	//Huffmanϥ
	WORD Huffman_Node_Num = 0;
	WORD index, length_bit, length_byte;
	DWORD value;
	BYTE code[MAX_CODE_LENGTH_BYTE] = {0};

	DWORD offset;
	WORD len;
	int i, j;

	if (!FileName) return NULL;
	pFontDB = (FONT_DB*)malloc(sizeof(FONT_DB));
	if (!pFontDB) return NULL;
	memset(pFontDB, 0, sizeof(FONT_DB));

///080430
#ifdef FONTDB_PRIVATE_CODEPAGE
	pFontDB->cd_utf8_2_local = (iconv_t)-1;
	pFontDB->cd_local_2_ucs2 = (iconv_t)-1;
#endif
///

	for (;;)
	{
		//Ūr
		pFontDB->FontFile = fopen(FileName, "rb");
		if (!pFontDB->FontFile) break;

		//m
		if (0 != fseek(pFontDB->FontFile, 0, SEEK_SET)) break;

		//ŪJUƵc}Ym
		pos_description = 4;
		if (!File_Read_DWORD(pFontDB->FontFile, &offset)) break;	//description size
		if (0 != fseek(pFontDB->FontFile, offset, SEEK_CUR)) break;	//pass description
		pos_predict = pos_description + offset + 4;
		if (!File_Read_DWORD(pFontDB->FontFile, &offset)) break;	//prediction size
		if (0 != fseek(pFontDB->FontFile, offset, SEEK_CUR)) break;	//pass prediction
		pos_huffman = pos_predict + offset + 4;
		if (!File_Read_DWORD(pFontDB->FontFile, &offset)) break;	//huffman size
		if (0 != fseek(pFontDB->FontFile, offset, SEEK_CUR)) break;	//pass huffman
		pos_index = pos_huffman + offset + 4;
		if (!File_Read_DWORD(pFontDB->FontFile, &offset)) break;	//index size
		if (0 != fseek(pFontDB->FontFile, offset, SEEK_CUR)) break;	//pass index
		pos_codeword = pos_index + offset + 4;
		if (!File_Read_DWORD(pFontDB->FontFile, &offset)) break;	//codeword size
		if (0 != fseek(pFontDB->FontFile, offset, SEEK_CUR)) break;	//pass codeword
		
	//Description
		if (0 != fseek(pFontDB->FontFile, pos_description, SEEK_SET)) break;
		if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->CharSet)) break;
		if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->FontSize)) break;

	//Prediction
		if (0 != fseek(pFontDB->FontFile, pos_predict, SEEK_SET)) break;
		if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->Predict_Table_Num)) break;
		for (i=0; i<pFontDB->Predict_Table_Num; i++)
		{
			if (!(pFontDB->Predict_Table[i]=(PREDICT*)malloc(sizeof(PREDICT)))) {bFail = true; break;}
			if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->Predict_Table[i]->size)) {bFail = true; break;}
			for (j=0; j<pFontDB->Predict_Table[i]->size; j++)
			{
				if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->Predict_Table[i]->table[j])) {bFail = true; break;}
			}
			//if (fread(&pFontDB->Predict_Table[i]->table, sizeof(BYTE), pFontDB->Predict_Table[i]->size, pFontDB->FontFile) != pFontDB->Predict_Table[i]->size) {bFail = true; break;}
		}
		if (bFail) break;

	//Huffman
		if (0 != fseek(pFontDB->FontFile, pos_huffman, SEEK_SET)) break;
		if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->Huffman_Table_Num)) break;
		if (pFontDB->Huffman_Table_Num > MAX_HUFFMAN_TABLE_NUM) break;
		for (i=0; i<pFontDB->Huffman_Table_Num; i++)
		{
			if (!File_Read_WORD(pFontDB->FontFile, &Huffman_Node_Num)) {bFail = true; break;}
			if (!(pFontDB->HuffTable[i]=Create_Huffman(Huffman_Node_Num))) {bFail = true; break;}
			for (j=0; j<Huffman_Node_Num; j++)
			{
				if (!File_Read_WORD(pFontDB->FontFile, &index)) {bFail = true; break;}
				if (!File_Read_DWORD(pFontDB->FontFile, &value)) {bFail = true; break;}
				if (!File_Read_WORD(pFontDB->FontFile, &length_bit)) {bFail = true; break;}
				length_byte = (length_bit+7)/8;
				memset(code, 0, MAX_CODE_LENGTH_BYTE);
				if (length_byte != fread(code, sizeof(BYTE), length_byte, pFontDB->FontFile)) {bFail = true; break;}
				if (!Set_Huffman_Node(pFontDB->HuffTable[i], (WORD)j/*index*/, value, 0)) {bFail = true; break;}
				if (!Define_Huffman_Code(pFontDB->HuffTable[i], (WORD)j/*index*/, length_bit, code)) {bFail = true; break;}
			}
			if (bFail) break;
			//إHuffman Tree
			if (!Read_Huffman_Table(pFontDB->HuffTable[i])) {bFail = true; break;}
		}
		if (bFail) break;

	//Code Index
		if (0 != fseek(pFontDB->FontFile, pos_index, SEEK_SET)) break;
		if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->Total_Char_Num)) break;
		if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->High_Byte_Range_Num)) break;
		if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->Low_Byte_Range_Num)) break;
		if (!File_Read_WORD(pFontDB->FontFile, &pFontDB->Correspond_Num)) break;
		for (i=0; i<pFontDB->High_Byte_Range_Num; i++)
		{
			if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->High_Byte_Range[i].Start)) {bFail = true; break;}
			if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->High_Byte_Range[i].End)) {bFail = true; break;}
		}
		if (bFail) break;
		for (i=0; i<pFontDB->Low_Byte_Range_Num; i++)
		{
			if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->Low_Byte_Range[i].Start)) {bFail = true; break;}
			if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->Low_Byte_Range[i].End)) {bFail = true; break;}
		}
		if (bFail) break;
		for (i=0; i<pFontDB->Correspond_Num; i++)
		{
			if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->Correspond[i].High_Index)) {bFail = true; break;}
			if (!File_Read_BYTE(pFontDB->FontFile, &pFontDB->Correspond[i].Low_Index)) {bFail = true; break;}
		}
		if (bFail) break;

		//tmCodePos(Code Index)
		pFontDB->CodePos = (DWORD*)malloc((pFontDB->Total_Char_Num+1)*sizeof(DWORD));
		if (!pFontDB) break;
		pFontDB->CodePos[0] = pos_codeword;
		offset = pFontDB->CodePos[0];

		///080514 offset@Ū
		WORD *LenBuf = (WORD*)malloc(pFontDB->Total_Char_Num*sizeof(WORD));
		if (!LenBuf) {bFail = true; break;}
		if (!File_Read_nWORD(pFontDB->FontFile, LenBuf, pFontDB->Total_Char_Num)) {bFail = true; break;}
		WORD *pLen = LenBuf;
		for (i=1; i<=pFontDB->Total_Char_Num; i++)
		{
			offset += (DWORD)(*pLen);
			pFontDB->CodePos[i] = offset;
			pLen++;
		}
		free(LenBuf);
		/*
		for (i=1; i<=pFontDB->Total_Char_Num; i++)
		{
			if (!File_Read_WORD(pFontDB->FontFile, &len)) {bFail = true; break;}
			offset += (DWORD)len;
			pFontDB->CodePos[i] = offset;
		}
		*/
		///

		if (bFail) break;

		bSuccess = true;
		break;
	}
	//DMSG("OK2\n");
	if (!bSuccess)
	{
		if (pFontDB)
		{
			if (pFontDB->CodePos) free(pFontDB->CodePos);
			if (pFontDB->HuffTable)
			{
				for (i=0; i<pFontDB->Huffman_Table_Num; i++)
				{
					Release_Huffman(&pFontDB->HuffTable[i]);
				}
			}
			if (pFontDB->FontFile) fclose(pFontDB->FontFile);
			free(pFontDB);
		}
		return NULL;
	}
	//DMSG("OK3\n");
	return pFontDB;
}

///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
int FontDB_Set_Private_CodePage(FONT_DB* pFontDB, char* strCode)
{
	if (!pFontDB || !strCode) return -1;

	pFontDB->bUsePrivateCodepage = 0;

	//X
	if (pFontDB->cd_utf8_2_local != (iconv_t)-1)
	{
		iconv_close(pFontDB->cd_utf8_2_local);
		pFontDB->cd_utf8_2_local = (iconv_t)-1;
	}
	if (pFontDB->cd_local_2_ucs2 != (iconv_t)-1)
	{
		iconv_close(pFontDB->cd_local_2_ucs2);
		pFontDB->cd_local_2_ucs2 = (iconv_t)-1;
	}
	//]X
	if (   0 != strcmp(strCode, CODE_PAGE_NAME_UCS_2)
		&& 0 != strcmp(strCode, CODE_PAGE_NAME_UTF_8)
	   )
	{
		pFontDB->cd_utf8_2_local = iconv_open(strCode, CODE_PAGE_NAME_UTF_8);
		if (pFontDB->cd_utf8_2_local == (iconv_t)-1)
		{
			return -1;
		}

		pFontDB->cd_local_2_ucs2 = iconv_open(CODE_PAGE_NAME_UCS_2, strCode);
		if (pFontDB->cd_local_2_ucs2 == (iconv_t)-1)
		{
			iconv_close(pFontDB->cd_utf8_2_local);
			pFontDB->cd_utf8_2_local = (iconv_t)-1;
			return -1;
		}

		pFontDB->bUsePrivateCodepage = 1;
	}

	return 0;
}
#endif
///

bool Draw_Char_Image(FONT_DB* pFontDB, WORD Code, BYTE* ImageBuffer, WORD *pOutCharHeight, WORD *pOutCharWidth)
{
	DWORD index, pos_code;
	WORD length_byte;
	HUFFMAN *pHuff, *pHuffSize;
	BYTE* bitstr;
	bool bSuccess = false;
	bool bFail = false;
	WORD CodeIndex, CodeLength, CurBitPos;
	WORD CharWidth, CharHeight;
	BYTE *pChar;
	BYTE bitmask, *pByte;
	WORD decode_size, image_size;
	int i, k;

	if (!pFontDB || !pFontDB->FontFile || !pFontDB->CodePos)
	{
		return false;
	}
	
	/*
	if (!ImageBuffer)
	{
		return false;
	}
	*/

	if (!pOutCharHeight || !pOutCharWidth)
	{
		return false;
	}

	//ǳHuffman Table
	pHuff = pFontDB->HuffTable[0];
	if (!pHuff && pFontDB->Huffman_Table_Num > 0)
	{
		return false;
	}
	pHuffSize = pFontDB->HuffTable[1];
	if (!pHuffSize && pFontDB->Huffman_Table_Num > 1)
	{
		return false;
	}
	
	//Code Wordm
	if (!Code_to_Index(pFontDB, Code, &index))
	{
		return false;
	}
	pos_code = pFontDB->CodePos[index];

	//ɮפCode Wordm
	if (0 != fseek(pFontDB->FontFile, pos_code, SEEK_SET))
	{
		return false;
	}

	//tmbit stringȦsŶ
	length_byte = (WORD)(pFontDB->CodePos[index+1] - pFontDB->CodePos[index]);
	bitstr = (BYTE*)malloc(length_byte);
	if (!bitstr)
	{
		return false;
	}

	for (;;)
	{
		//qɮŪbit string
		if (length_byte != fread(bitstr, sizeof(BYTE), length_byte, pFontDB->FontFile))
		{
			break;
		}

		//Mwre
		if (Code > 0x00FF)	//Φr
		{
			CurBitPos = 0;
			if (!Huffman_Decode_Once(pHuffSize, bitstr, CurBitPos, &CodeIndex, &CodeLength))
			{
				break;
			}
			CharHeight = (WORD)(pHuffSize->NodeTable[CodeIndex].value);
			CurBitPos += CodeLength;
			if (!Huffman_Decode_Once(pHuffSize, bitstr, CurBitPos, &CodeIndex, &CodeLength))
			{
				break;
			}
			CharWidth = (WORD)(pHuffSize->NodeTable[CodeIndex].value);
			CurBitPos += CodeLength;
		}
		else				//bΦr
		{
			//Ūe(bsXeWORD)
			CharHeight = (WORD)(*bitstr) * 256 + (WORD)*(bitstr+1);
			CharWidth = (WORD)*(bitstr+2) * 256 + (WORD)*(bitstr+3);
		}

		//YImageBufferNULLܥuDre
		if (ImageBuffer != NULL)
		{
			image_size = CharHeight * CharWidth;

			//ݭnhuffman decode
			decode_size = (image_size + 7) >> 3;

			//NBufferM
			memset(ImageBuffer, 0, image_size);
			
			if (Code > 0xFF)	//
			{
				if (!Huffman_Decode_Multiple_Bytes(pHuff, bitstr, CurBitPos, decode_size, ImageBuffer))
				{
					bFail = true;
					break;
				}
				
				//wsX٭
				if (!Restore_Prediction256(ImageBuffer, 
										CharWidth, CharHeight, CharWidth,
										pFontDB->Predict_Table[0])
				   )
				{
					break;
				}
			}
			else	//b
			{
				pChar = ImageBuffer;
				pByte = bitstr + 4;

				for (i=0; i<decode_size; i++)
				{
					//JImageBuffer
					bitmask = 0x80;
					for (k=0; k<8; k++)
					{
						if (*pByte & bitmask)
						{
							*pChar = 1;
						}
						bitmask >>= 1;
						pChar++;
					}
					pByte++;
				}
			}
		}

///070831 rYp
#ifdef USE_DESC_TV	//HDTVɤ~ݭnϥYp
		if (pFontDB->bScaleDown)
		{
			if (ImageBuffer != NULL)
			{
				BYTE *pRowChar, *pRowScale, *pScale;
				int j;
				WORD ScaleH, ScaleW;

				ScaleH = CharHeight >> 1;
				ScaleW = CharWidth >> 1;
				pRowChar = ImageBuffer;
				pRowScale = ImageBuffer;
				for (i=0; i<ScaleH; i++)
				{
					pChar = pRowChar;
					pScale = pRowScale;
					for (j=0; j<ScaleW; j++)
					{
						k = *pChar + *(pChar+1) + *(pChar+CharWidth) + *(pChar+CharWidth+1);

						if (k < 2) *pScale = 0;		//@bHUI
						else *pScale = 1;			//@bHW1NI

						pScale++;
						pChar += 2;
					}
					pRowChar += (CharWidth<<1);
					pRowScale += ScaleW;
				}
			}
			CharHeight >>= 1;
			CharWidth >>= 1;
		}
#endif
///	

		bSuccess = true;
		*pOutCharHeight = CharHeight;
		*pOutCharWidth = CharWidth;
		break;
	}

	free(bitstr);
	return bSuccess;
}

bool Release_FontDB(FONT_DB** ppFontDB)
{
	int i;
	bool bRet = true;

	if (!ppFontDB || !(*ppFontDB))
	{
		return false;
	}

///080430 X
#ifdef FONTDB_PRIVATE_CODEPAGE
	if ((*ppFontDB)->cd_utf8_2_local != (iconv_t)-1)
	{
		iconv_close((*ppFontDB)->cd_utf8_2_local);
		(*ppFontDB)->cd_utf8_2_local = (iconv_t)-1;
	}
	if ((*ppFontDB)->cd_local_2_ucs2 != (iconv_t)-1)
	{
		iconv_close((*ppFontDB)->cd_local_2_ucs2);
		(*ppFontDB)->cd_local_2_ucs2 = (iconv_t)-1;
	}
#endif

	//Code Index
	if ((*ppFontDB)->CodePos) free((*ppFontDB)->CodePos);

	//Huffman Table
	for (i=0; i<(*ppFontDB)->Huffman_Table_Num; i++)
	{
		if (!Release_Huffman(&(*ppFontDB)->HuffTable[i]))
		{
			bRet = false;
		}
	}

	//Prediction Table
	for (i=0; i<(*ppFontDB)->Predict_Table_Num; i++)
	{
		if ((*ppFontDB)->Predict_Table[i])
		{
			free((*ppFontDB)->Predict_Table[i]);
		}
	}

	if ((*ppFontDB)->FontFile) fclose((*ppFontDB)->FontFile);
	free(*ppFontDB);
	*ppFontDB = NULL;

	return bRet;
}

bool Restore_Prediction256(BYTE* CharBuffer, WORD CharWidth, WORD CharHeight, WORD BufferWidthAlign, PREDICT* pPredict)
{
//
//		|--------------|		
//		|128 | 64 | 32 | 
//		|--------------|
//		| 16 |  8 |  4 |	Xnwm
//		|--------------|	QΥWKӦVӷindex
//		|  2 |  1 |  X |
//		|--------------|
//

	int x, y;
	BYTE *pRow, *pChar;
	BYTE index;
	BYTE* PTABLE;
	WORD BufferWidthAlign2;

	if (!CharBuffer || !pPredict || pPredict->size != 256) return false;

	BufferWidthAlign2 = BufferWidthAlign * 2;

	PTABLE = pPredict->table;

	//wsX
	pRow = CharBuffer;

	//W|Ӧm
	pChar = CharBuffer;
	if (PTABLE[0] == 1)
	{
		if (*pChar == 0) *pChar = 1;
		else *pChar = 0;
	}
	if (PTABLE[*pChar] == 1)
	{
		if (*(pChar+1) == 0) *(pChar+1) = 1;
		else *(pChar+1) = 0;
	}
	if (PTABLE[(*pChar)<<2] == 1)
	{
		if (*(pChar+BufferWidthAlign) == 0) *(pChar+BufferWidthAlign) = 1;
		else *(pChar+BufferWidthAlign) = 0;
	}
	if (PTABLE[((*pChar)<<3) | ((*(pChar+1))<<2) | *(pChar+BufferWidthAlign)] == 1)
	{
		if (*(pChar+BufferWidthAlign+1) == 0) *(pChar+BufferWidthAlign+1) = 1;
		else *(pChar+BufferWidthAlign+1) = 0;
	}

	//Ĥ@C
	pChar = CharBuffer + 2;
	for (x=2; x<CharWidth; x++)
	{
		if (PTABLE[*(pChar-1) | ((*(pChar-2))<<1)] == 1)
		{
			if (*pChar == 0) *pChar = 1;
			else *pChar = 0;
		}
		pChar++;
	}

	//ĤGC
	pChar = CharBuffer + BufferWidthAlign + 2;
	for (x=2; x<CharWidth; x++)
	{
		if (PTABLE[*(pChar-1) | ((*(pChar-2))<<1) | ((*(pChar-BufferWidthAlign))<<2) | ((*(pChar-BufferWidthAlign-1))<<3) | ((*(pChar-BufferWidthAlign-2))<<4)] == 1)
		{
			if (*pChar == 0) *pChar = 1;
			else *pChar = 0;
		}
		pChar++;
	}

	//Ĥ@
	pChar = CharBuffer + BufferWidthAlign2;
	for (y=2; y<CharHeight; y++)
	{
		if (PTABLE[((*(pChar-BufferWidthAlign))<<2) | ((*(pChar-BufferWidthAlign2))<<5)] == 1)
		{
			if (*pChar == 0) *pChar = 1;
			else *pChar = 0;
		}
		pChar += BufferWidthAlign;
	}

	//ĤG
	pChar = CharBuffer + BufferWidthAlign2 + 1;
	for (y=2; y<CharHeight; y++)
	{
		if (PTABLE[*(pChar-1) | ((*(pChar-BufferWidthAlign))<<2) | ((*(pChar-BufferWidthAlign-1))<<3) | ((*(pChar-BufferWidthAlign2))<<5) | ((*(pChar-BufferWidthAlign2-1))<<6)] == 1)
		{
			if (*pChar == 0) *pChar = 1;
			else *pChar = 0;
		}
		pChar += BufferWidthAlign;
	}
	
	//lm
	pRow = CharBuffer + BufferWidthAlign2 + 2;
	for (y=2; y<CharHeight; y++)
	{
		pChar = pRow;
		for (x=2; x<CharWidth; x++)
		{
			index = 0;
			index <<= 1;
			index |= *(pChar-BufferWidthAlign2-2);
			index <<= 1;
			index |= *(pChar-BufferWidthAlign2-1);
			index <<= 1;
			index |= *(pChar-BufferWidthAlign2);
			index <<= 1;
			index |= *(pChar-BufferWidthAlign-2);
			index <<= 1;
			index |= *(pChar-BufferWidthAlign-1);
			index <<= 1;
			index |= *(pChar-BufferWidthAlign);
			index <<= 1;
			index |= *(pChar-2);
			index <<= 1;
			index |= *(pChar-1);
			if (PTABLE[index] == 1)
			{
				if (*pChar == 0) *pChar = 1;
				else *pChar = 0;
			}
			pChar++;
		}
		pRow += BufferWidthAlign;
	}

	return true;
}

bool Code_to_Index(FONT_DB* pFontDB, WORD Code, DWORD* pIndex)
{
	DWORD acc;
	BYTE HI_BYTE, LO_BYTE;
	BYTE HI_Start, LO_Start, HI_End, LO_End, HI_Idx, LO_Idx;
	int c;
	if (!pFontDB || !pIndex) return false;

	*pIndex = 0;
	HI_BYTE = (BYTE)(Code >> 8);		//Code / 256
	LO_BYTE = (BYTE)(Code & 0x00FF);	//Code % 256

	acc = 0;
	//`NCorrespondHI/LO RangeѤpjƧ
	for (c=0; c<pFontDB->Correspond_Num; c++)
	{
		HI_Idx = pFontDB->Correspond[c].High_Index;
		LO_Idx = pFontDB->Correspond[c].Low_Index;
		HI_Start = pFontDB->High_Byte_Range[HI_Idx].Start;
		HI_End = pFontDB->High_Byte_Range[HI_Idx].End;
		LO_Start = pFontDB->Low_Byte_Range[LO_Idx].Start;
		LO_End = pFontDB->Low_Byte_Range[LO_Idx].End;

		if (  pFontDB->High_Byte_Range[HI_Idx].End >= HI_BYTE
			&&
			  pFontDB->Low_Byte_Range[LO_Idx].End >= LO_BYTE
			&&
			  pFontDB->High_Byte_Range[HI_Idx].Start <= HI_BYTE
			&&
			  pFontDB->Low_Byte_Range[LO_Idx].Start <= LO_BYTE
		   )
		{
			//Codeb϶
			*pIndex = acc + (DWORD)(HI_BYTE-HI_Start) * (LO_End-LO_Start+1) + (LO_BYTE-LO_Start);
			break;
		}
		else
		{
			//֥[Ӽ
			acc += (DWORD)(HI_End-HI_Start + 1) * (LO_End - LO_Start + 1);
		}
	}
	if (c >= pFontDB->Correspond_Num) return false;

	return true;
}

///080116
bool Code_Cover(FONT_DB* pFontDB, WORD Code)
{
	BYTE HI_BYTE, LO_BYTE;
	BYTE HI_Start, LO_Start, HI_End, LO_End, HI_Idx, LO_Idx;
	int c;
	if (!pFontDB) return false;

	HI_BYTE = (BYTE)(Code >> 8);		//Code / 256
	LO_BYTE = (BYTE)(Code & 0x00FF);	//Code % 256

	//`NCorrespondHI/LO RangeѤpjƧ
	for (c=0; c<pFontDB->Correspond_Num; c++)
	{
		HI_Idx = pFontDB->Correspond[c].High_Index;
		LO_Idx = pFontDB->Correspond[c].Low_Index;
		HI_Start = pFontDB->High_Byte_Range[HI_Idx].Start;
		HI_End = pFontDB->High_Byte_Range[HI_Idx].End;
		LO_Start = pFontDB->Low_Byte_Range[LO_Idx].Start;
		LO_End = pFontDB->Low_Byte_Range[LO_Idx].End;

		if (  pFontDB->High_Byte_Range[HI_Idx].End >= HI_BYTE
			&&
			  pFontDB->Low_Byte_Range[LO_Idx].End >= LO_BYTE
			&&
			  pFontDB->High_Byte_Range[HI_Idx].Start <= HI_BYTE
			&&
			  pFontDB->Low_Byte_Range[LO_Idx].Start <= LO_BYTE
		   )
		{
			//Codeb϶
			return true;
		}
	}

	return false;
}
///

bool File_Read_BYTE(FILE* fid, BYTE* pinbyte)
{
	if (!fid || !pinbyte) return false;
	if (1 != fread(pinbyte, sizeof(BYTE), 1, fid)) return false;
	return true;
}

bool File_Read_WORD(FILE* fid, WORD* pinword)
{
	BYTE inbyte[2];
	if (!fid || !pinword) return false;
	if (2 != fread(inbyte, sizeof(BYTE), 2, fid)) return false;
	*pinword = (WORD)inbyte[0] * 256 + (WORD)inbyte[1];
	return true;
}

///080514
bool File_Read_nWORD(FILE* fid, WORD* pinword, DWORD nWord)
{
	DWORD i;
	WORD *pword = NULL;
	if (!fid || !pinword) return false;
	if (nWord != fread(pinword, sizeof(WORD), nWord, fid)) return false;
	pword = pinword;
	for (i=0; i<nWord; i++)
	{
		*pword = ((*pword>>8) | (*pword<<8));
		pword++;
	}
	return true;
}
/// 

bool File_Read_DWORD(FILE* fid, DWORD* pindword)
{
	BYTE inbyte[4];
	if (!fid || !pindword) return false;
	if (4 != fread(inbyte, sizeof(BYTE), 4, fid)) return false;
	*pindword = (DWORD)inbyte[0]*16777216 + (DWORD)inbyte[1]*65536 + (DWORD)inbyte[2]*256 + (DWORD)inbyte[3];
	return true;
}


