/********************************************************************
	created:	2007/05/04
	filename: 	Huffman.h
	file base:	Huffman
	file ext:	h
	author:		
	purpose:	إHuffman Code Table
*********************************************************************/

/**************************************************
//	API for Users
**************************************************/
#ifndef _BYTE_WORD_
#define _BYTE_WORD_
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

#ifndef _BOOL_
#define _BOOL_
typedef unsigned char bool;
//#define bool Uint8//BOOL
#define true 1//TRUE
#define false 0//FALSE
#endif

#define MAX_CODE_LENGTH_BYTE 32	//sX̪ȩw32Byte(256bits)

typedef struct _NODE
{
	WORD index;
	DWORD value;
	DWORD freq;
	WORD code_length_bit;
	BYTE code[MAX_CODE_LENGTH_BYTE];
}node;

//Huffman CodeDƵc
typedef struct _HUFFMAN
{
	WORD nNodeNum;
	node* NodeTable;
	void* _private;
}HUFFMAN;

//lHuffmanc
HUFFMAN* Create_Huffman(WORD nNodeNum);

//bNode Table[J@
bool Set_Huffman_Node(HUFFMAN *pHuff, WORD Index, DWORD Value, DWORD Frequency);

//ΤwFrequencyisX
bool Huffman_Build(HUFFMAN *pHuff);

//NϥΪ̤wsVLCX[JNode Table
bool Define_Huffman_Code(HUFFMAN *pHuff, WORD Index, WORD code_length_bit, BYTE Code[MAX_CODE_LENGTH_BYTE]);

//wsXNode TableƮwؤJTree(private)
bool Read_Huffman_Table(HUFFMAN *pHuff);

//ѽXAǤJCode WordAǦ^Ĥ@ӸѥXindexAtȪܿ~
bool Huffman_Decode_Once(HUFFMAN *pHuff, BYTE *Bitstring, WORD StartBit, WORD* pRetIndex, WORD* pRetLenBit);
bool Huffman_Decode_Multiple_Bytes(HUFFMAN *pHuff, BYTE *Bitstring, WORD StartBit, WORD nDecodeNum, BYTE *OutBuf);

//HuffmancŶ
bool Release_Huffman(HUFFMAN **ppHuff);


