#include "events.h"
Uint8 isMusicStopPressed = FALSE;
//------------------------------------------------------------------------------------------------
void UpdateAUD()
{
	FRAME *elmf;
	Uint32 PrevFrameNO, CurrFrameNO;

	elmf = &ELMachines[active_index].frame;
	
	PrevFrameNO = elmf->active_frame_index;
	CurrFrameNO = elmf->active_frame_index = elmf->active_icon_index / MUSIC_BAR_NUM;
	
	if(PrevFrameNO == CurrFrameNO)
		DrawFocusedICON(RGB1, 1);
	else
		AudDisplay();
}
//------------------------------------------------------------------------------------------------
// Audio	Callbacks																			       	    
//------------------------------------------------------------------------------------------------
void A_UpEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;
	
	isMusicStopPressed = FALSE;
	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);
	elmf->active_icon_index -= 1;
	if(elmf->active_icon_index == -1)
	{
		elmf->active_icon_index += AudCount;
		
		tmplist = AudioList;
		while(tmplist != NULL && i < AudCount)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrAudListPos = tmplist;
		AudDisplay();
	}
	else
	{
		elmf->CurrAudListPos = elmf->CurrAudListPos->prev;
		UpdateAUD();
	}
}
//------------------------------------------------------------------------------------------------
void A_DownEvent()
{
	FRAME *elmf;
	
	isMusicStopPressed = FALSE;
	elmf = &ELMachines[active_index].frame;
	
	DrawFocusedICON(RGB1, -1);
	elmf->active_icon_index += 1;
	if(elmf->active_icon_index == AudCount)
	{
		elmf->active_icon_index = 0;
		elmf->CurrAudListPos = AudioList->next;
		AudDisplay();
	}
	else
	{
		elmf->CurrAudListPos = elmf->CurrAudListPos->next;
		UpdateAUD();
	}
}
//------------------------------------------------------------------------------------------------
void A_RightEvent()
{
	A_NextEvent();
}
//------------------------------------------------------------------------------------------------
void A_LeftEvent()
{
	A_PrevEvent();
}
//------------------------------------------------------------------------------------------------
void A_NextEvent()
{
	FRAME *elmf;
	int ICONum, MoveStep;
	LIST *tmplist;
	Uint32 i = 0;
	
	isMusicStopPressed = FALSE;
	elmf = &ELMachines[active_index].frame;
	ICONum = MUSIC_BAR_NUM;
	MoveStep = ICONum - (elmf->active_icon_index % ICONum);
	elmf->active_icon_index = elmf->active_icon_index + MoveStep;

	if(elmf->active_icon_index > (AudCount - 1))
	{
		elmf->active_icon_index = 0;
		elmf->CurrAudListPos = AudioList->next;
	}
	else
	{
		tmplist = elmf->CurrAudListPos;
		while(tmplist != NULL && i < MoveStep)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrAudListPos = tmplist;
	}
	AudDisplay();
}
//------------------------------------------------------------------------------------------------
void A_PrevEvent()
{
	FRAME *elmf;
	int ICONum, MoveStep;
	LIST *tmplist;
	Uint32 i = 0;
	
	isMusicStopPressed = FALSE;
	elmf = &ELMachines[active_index].frame;
	ICONum = MUSIC_BAR_NUM;
	MoveStep = ICONum + (elmf->active_icon_index % ICONum);
	elmf->active_icon_index = elmf->active_icon_index - MoveStep;

	if(elmf->active_icon_index < 0)
	{
		if((AudCount % ICONum) == 0)
			elmf->active_icon_index = AudCount - ICONum;
		else
			elmf->active_icon_index = AudCount - (AudCount % ICONum);
		
		tmplist = AudioList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrAudListPos = tmplist;
	}
	else
	{
		tmplist = elmf->CurrAudListPos;
		while(tmplist != NULL && i < MoveStep)
		{
			tmplist = tmplist->prev;
			i++;
		}
		elmf->CurrAudListPos = tmplist;
	}
	AudDisplay();
}
//------------------------------------------------------------------------------------------------
void A_PlayPauseEvent()
{
	if(isMusicStopPressed)
	{
		DrawFocusedICON(RGB1, 0);
		isMusicStopPressed = FALSE;
	}
	else
	{
		set_ir_value((unsigned long)0x70);
	}
}
//------------------------------------------------------------------------------------------------
// Raymond 2008/04/09
void A_ForwardEvent()
{
	set_ir_value((unsigned long)0x7D);
	isMusicStopPressed = FALSE;
}
//------------------------------------------------------------------------------------------------
void A_BackwardEvent()
{
	set_ir_value((unsigned long)0x7B);
	isMusicStopPressed = FALSE;
}

//------------------------------------------------------------------------------------------------
void A_StopEvent()
{
	KillAudioProcess();
	isOnlyAudPrcsForked = FALSE;
	isMusicStopPressed = TRUE;
}
//------------------------------------------------------------------------------------------------
void A_EnterEvent()
{
#ifdef WINGUI
	A_PlayPauseEvent();
#else
	isMusicStopPressed = FALSE;
	DrawFocusedICON(RGB1, 0);
#endif
}
//------------------------------------------------------------------------------------------------
void A_EscEvent()
{
	isMusicStopPressed = FALSE;
	ELMachines[active_index].Shutdown(0);
	active_index = MT_ACTIVE;
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
}
