#include "events.h"

#if defined(GUI_STYLE_COMTEK)
Sint8 CalSelectedAutoPwrOnOffTime = 0;

//------------------------------------------------------------------------------------------------
void SaveCalAutoPwrOnSetupToRTC(struct tm tm)
{
	int fd;
	struct rtc_wkalrm sRtcWkalrm;//On

	if((fd = open("/dev/rtc", O_RDWR)) == -1){
		perror("/dev/rtc");
		return;
	}

	memset(&sRtcWkalrm, 0x00, sizeof(sRtcWkalrm));

	if((setup->cal_autopwr_on_hour[tm.tm_wday] < setup->cal_autopwr_off_hour[tm.tm_wday])
		||((setup->cal_autopwr_on_hour[tm.tm_wday] == setup->cal_autopwr_off_hour[tm.tm_wday])
			&&(setup->cal_autopwr_on_minute[tm.tm_wday] < setup->cal_autopwr_off_minute[tm.tm_wday]))){
		if(tm.tm_wday == 6)
			tm.tm_wday = 0;
		else
			tm.tm_wday += 1;
	}

	sRtcWkalrm.time.tm_hour = setup->cal_autopwr_on_hour[tm.tm_wday];
	sRtcWkalrm.time.tm_min = setup->cal_autopwr_on_minute[tm.tm_wday];
	ioctl(fd, RTC_WKALM_SET, &sRtcWkalrm);
	ioctl(fd, RTC_AIE_ON, NULL);//enable

	close(fd);

}
//------------------------------------------------------------------------------------------------
void SaveCalProgDownload()
{
#define FTP_SKYDEMO_INFO_KEY		4444
#define FTP_LOST_SERVER			-5
#define FTP_DOWNLOAD_NO_FINISH	-4
#define FTP_PROFILE_ERROR			-3
#define FTP_NO_PROFILE				-2
#define FTP_LOCAL_ERROR			-1
#define FTP_ALL_FINISH				0

	typedef struct{
		int	filenum;
		char	filename[32];
		int	filesize;
		int	total;
		int	result;
		int	status;
	}FTP_RESULT;

	typedef struct{
		long int	msg_type;
		FTP_RESULT	ftp;
	}MSG_RESULT;

	MSG_RESULT ftp_data;

	int ftp_id;
	pid_t pid;
	int status;
	int orgfilesize = 0;
	Sint8 CurPercent = 0;

	MT_EscEvent();
	active_index = PROG_DOWNLOAD_ACTIVE;
	ELMachines[PROG_DOWNLOAD_ACTIVE].Init();
	ELMachines[PROG_DOWNLOAD_ACTIVE].Display();
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork failure!");
			DMSG("Fork to Power Off Fail!");
			break;
		case 0:
			//child process
			execl("/tmp/sky_ftp", "sky_ftp", NULL);
			_EXIT;
		default:
			//parent process
			ftp_id = msgget((key_t)FTP_SKYDEMO_INFO_KEY, 0660|IPC_CREAT);
			ftp_data.msg_type = 1;
			ftp_data.ftp.total = 0;
			ftp_data.ftp.filesize = 0;
			ftp_data.ftp.result = 1;
			while(ftp_data.ftp.result){
				if(msgrcv(ftp_id, (void *)&ftp_data, sizeof(FTP_RESULT), 1, IPC_NOWAIT) == -1){
					usleep(10000);
				}
				else{
					if(ftp_data.ftp.result == FTP_LOST_SERVER){
						RefreshProgDownDisplay(-1, NULL, -5);
						break;
					}
					else if(ftp_data.ftp.result == FTP_DOWNLOAD_NO_FINISH){
						RefreshProgDownDisplay(-1, NULL, -4);
						break;
					}
					else if(ftp_data.ftp.result == FTP_PROFILE_ERROR){
						RefreshProgDownDisplay(-1, NULL, -3);
						break;
					}
					else if(ftp_data.ftp.result == FTP_NO_PROFILE){
						RefreshProgDownDisplay(-1, NULL, -2);
						break;
					}
					else if(ftp_data.ftp.result == FTP_LOCAL_ERROR){
						RefreshProgDownDisplay(-1, NULL, -1);
						break;
					}

					if((ftp_data.ftp.filesize != 0) && (ftp_data.ftp.filenum != 0)){
						if(orgfilesize == 0)
							orgfilesize = ftp_data.ftp.filesize;

						CurPercent = 100*ftp_data.ftp.total/orgfilesize;

						//printf("filenum(%d), CurPercent(%d), total(%d), filesize(%d)\n",ftp_data.ftp.filenum,CurPercent,ftp_data.ftp.total,orgfilesize);

						RefreshProgDownDisplay(ftp_data.ftp.filenum, ftp_data.ftp.filename, CurPercent);
						if(CurPercent == 100)
							orgfilesize = 0;
					}
				}
			}
			if(ftp_id>=0){
				if (msgctl(ftp_id, IPC_RMID, 0) == -1){
					printf("Can't remove ftp_id(%d)", ftp_id);
				}
			}
			if(ftp_data.ftp.result == FTP_ALL_FINISH)
				RefreshProgDownDisplay(-1, NULL, 0);
			//sync();
			//while(waitpid(pid,&status,0)==0);
			waitpid(pid, &status, 0);
			break;
	}
}
#endif
//------------------------------------------------------------------------------------------------
void KillCalAlarmProcess()
{
	if(!waitpid(pid_aud, &sts_aud, WNOHANG))
	{
#if 0
		while(kill(pid_aud, SIGKILL) == -1);
#else
		//KILL("mplayer");
		KILL(pid_aud);
#endif
#ifdef NET_MOD
		while(waitpid(pid_img, &sts_aud, 0) == 0);
#else
		while(waitpid(pid_aud, &sts_aud, 0) <= 0);
#endif
	}
}
//------------------------------------------------------------------------------------------------
void Cal_UpEvent()
{
#if defined(GUI_STYLE_COMTEK)
	Uint8 DayIndex, ItemIndex;

	DayIndex = CalSelectedAutoPwrOnOffTime / 5;
	ItemIndex = CalSelectedAutoPwrOnOffTime % 5;

	//0:Auto power on hour, 1:Auto power on minute, 2:Program Download, 3:Auto power off hour, 4:Auto power off minute
	if(ItemIndex == 0){
		setup->cal_autopwr_on_hour[DayIndex]++;
		setup->cal_autopwr_on_hour[DayIndex] %= 24;
	}
	else if(ItemIndex == 1){
		setup->cal_autopwr_on_minute[DayIndex]++;
		setup->cal_autopwr_on_minute[DayIndex] %= 60;
	}
	else if(ItemIndex == 3){
		setup->cal_autopwr_off_hour[DayIndex]++;
		setup->cal_autopwr_off_hour[DayIndex] %= 24;
	}
	else if(ItemIndex == 4){
		setup->cal_autopwr_off_minute[DayIndex]++;
		setup->cal_autopwr_off_minute[DayIndex] %= 60;
	}

	RefreshCalDisplay(1);
#else
	if(isCalAlarmRinging != 1 && AudCount > 0)//working when alarm not ringingadn any audio existed
	{
		FRAME *elmf;
		LIST *tmplist;
		Uint32 i = 0;

		elmf = &ELMachines[active_index].frame;

		elmf->active_icon_index -= 1;
		if(elmf->active_icon_index == -1)
		{
			elmf->active_icon_index += AudCount;

			tmplist = AudioList;
			while(tmplist != NULL && i < AudCount)
			{
				tmplist = tmplist->next;
				i++;
			}
			elmf->CurrAudListPos = tmplist;
			DecodeSSAUD();
		}
		else
		{
			elmf->CurrAudListPos = elmf->CurrAudListPos->prev;
			DecodeSSAUD();
		}
	}
#endif
}
//------------------------------------------------------------------------------------------------
void Cal_DownEvent()
{
#if defined(GUI_STYLE_COMTEK)
	Uint8 DayIndex, ItemIndex;

	DayIndex = CalSelectedAutoPwrOnOffTime / 5;
	ItemIndex = CalSelectedAutoPwrOnOffTime % 5;

	//0:Auto power on hour, 1:Auto power on minute, 2:Program Download, 3:Auto power off hour, 4:Auto power off minute
	if(ItemIndex == 0){
		setup->cal_autopwr_on_hour[DayIndex]--;
		if(setup->cal_autopwr_on_hour[DayIndex]== -1)
			setup->cal_autopwr_on_hour[DayIndex] = 23;
	}
	else if(ItemIndex == 1){
		setup->cal_autopwr_on_minute[DayIndex]--;
		if(setup->cal_autopwr_on_minute[DayIndex] == -1)
			setup->cal_autopwr_on_minute[DayIndex] = 59;
	}
	else if(ItemIndex == 3){
		setup->cal_autopwr_off_hour[DayIndex]--;
		if(setup->cal_autopwr_off_hour[DayIndex] == -1)
			setup->cal_autopwr_off_hour[DayIndex] = 23;
	}
	else if(ItemIndex == 4){
		setup->cal_autopwr_off_minute[DayIndex]--;
		if(setup->cal_autopwr_off_minute[DayIndex] == -1)
			setup->cal_autopwr_off_minute[DayIndex] = 59;
	}

	RefreshCalDisplay(1);
#else
	if(isCalAlarmRinging != 1 && AudCount > 0)//working when alarm not ringing and any audio existed
	{
		FRAME *elmf;

		elmf = &ELMachines[active_index].frame;

		elmf->active_icon_index += 1;
		elmf->active_icon_index %= AudCount;
		elmf->CurrAudListPos = elmf->CurrAudListPos->next;
		if(elmf->CurrAudListPos != NULL)
			DecodeSSAUD();
		else
		{
			elmf->CurrAudListPos = AudioList->next;
			DecodeSSAUD();
		}
	}
#endif
}
//------------------------------------------------------------------------------------------------
void Cal_LeftEvent()
{
#if defined(GUI_STYLE_COMTEK)
	//Total is 35 items, (5 items * 7 days -> 35 -> 0~34)
	CalSelectedAutoPwrOnOffTime--;
	if(CalSelectedAutoPwrOnOffTime < 0)
		CalSelectedAutoPwrOnOffTime = 34;
#endif
	RefreshCalDisplay(-1);
}
//------------------------------------------------------------------------------------------------
void Cal_RightEvent()
{
#if defined(GUI_STYLE_COMTEK)
	//Total is 35 items, (5 items * 7 days -> 35 -> 0~34)
	CalSelectedAutoPwrOnOffTime++;
	if(CalSelectedAutoPwrOnOffTime > 34)
		CalSelectedAutoPwrOnOffTime = 0;
#endif
	RefreshCalDisplay(1);
}
//------------------------------------------------------------------------------------------------
void Cal_StopEvent()
{
#if defined(GUI_STYLE_COMTEK)
	MT_EscEvent();
#else
	if(isCalAlarmRinging == 1)
	{
		//kill audio process
		KillCalAlarmProcess();

		isCalAlarmRinging = -1;
//		setup->alarm_setup_idx = SETUP_OFF;
//		SaveUserSetupToMem();
//		LoadUserSetupFromMem();

		//Draw Alarm Info
		if(prev_active_index != FI_ACTIVE)
			DrawAlarmInfo(RGB1, 0);
		else
			DrawAlarmInfo(RGB0, 0);
	}
	else
	{
		KillAudioProcess();
		isSSAudPrcsForked = FALSE;
	}
#endif
}
//------------------------------------------------------------------------------------------------
void Cal_EnterEvent()
{
#if defined(GUI_STYLE_COMTEK)
	Uint8 DayIndex, ItemIndex;

	DayIndex = CalSelectedAutoPwrOnOffTime / 5;
	ItemIndex = CalSelectedAutoPwrOnOffTime % 5;

	//0:Auto power on hour, 1:Auto power on minute, 2:Program Download, 3:Auto power off hour, 4:Auto power off minute
	if(ItemIndex == 2){
		if(setup->cal_program_download[DayIndex] == FALSE)
			setup->cal_program_download[DayIndex] = TRUE;
		else
			setup->cal_program_download[DayIndex] = FALSE;
	}
	RefreshCalDisplay(1);
#else
	if(isCalAlarmRinging == 1)
	{
		//kill audio process
		KillCalAlarmProcess();

		isCalAlarmRinging = 0;
//		setup->alarm_setup_idx = SETUP_OFF;
//		SaveUserSetupToMem();
//		LoadUserSetupFromMem();

		//Draw Alarm Info
		if(prev_active_index != FI_ACTIVE)
			DrawAlarmInfo(RGB1, 0);
		else
			DrawAlarmInfo(RGB0, 0);
	}
	else
	{
		//071101 ^{bɶ
		RefreshCalDisplay(-127);
	}
#endif
}
//------------------------------------------------------------------------------------------------
void Cal_EscEvent()
{
#if defined(GUI_STYLE_COMTEK)
	time_t t;
	struct tm tm;

	time(&t);
	memcpy(&tm, localtime(&t), sizeof(tm));

	SaveUserSetup();
	SaveCalAutoPwrOnSetupToRTC(tm);
#endif
	CalEvent();
}
//------------------------------------------------------------------------------------------------
void Cal_PlayPuseEvent()
{
	if(isCalAlarmRinging == 1)
		return;

	if(isSSAudPrcsForked)//the value is not set if the mplayer is not forked
	{
		set_ir_value((unsigned long)0x70);
	}
	else
	{
		if(AudCount > 0)
			DecodeSSAUD();
	}
}
