#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <netdb.h>

#define _EXIT					_exit(errno == ENOENT ? 127 : 126)

void call_skytest(){

	printf("=========calling skytest=====\n");

	pid_t pid;
	int status;
	pid = fork();

	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			fprintf(stderr, "Fork to call skytest Fail!\n");
			break;

		case 0:
		
			execl("/sky/skytest", "skytest", NULL);


			_EXIT;
		default:
			waitpid(pid, &status, 0);
			if(WIFEXITED(status))
			{
			}						
			break;
	}
}
 

static long long myfile_get_file_len(char *filename){

    int des_fd = open(filename, O_RDONLY, 0644);
	printf("des_fd=%d\n",des_fd);
    if (des_fd < 0){
        printf("[get_file_len]error open des_file,filename=%s\n",filename);
		return 0;
    }else{
		printf("[get_file_len]open %s success\n",filename);
	}
	long long filesize=lseek(des_fd,0,SEEK_END);

	printf("filesize=%d\n",filesize);
	close(des_fd);

	return filesize;

}



int calltest_is_testmode(){
	
	EnforceRenewPartitionInfo();
	printf("after enforcerenew\n");
	int len=myfile_get_file_len("/mnt/sknand/testmode.aaa");
	printf("calltest_is_testmode,len=%d\n",len);

	if (len>0){
		return 1;
	}
	return 0;
};

int calltest_startup_check_testmode(){


	int testmode=calltest_is_testmode();
	if (testmode){
		printf("==========STARTING TEST AP=====\n");
		call_skytest();
		printf("...........system halt.......\n");
		sleep(1000);

	}
}

#define CARDSLOT_READ_GPIO_BITDATA     6
typedef struct _sGPIO
{
    unsigned int _reg;
    unsigned int _mask_bit;
    unsigned int _data;
}
GPIO;


int calltest_check_key_to_startup(){
	int fd;
	if((fd = open("/dev/slot0", O_RDWR)) == -1) {
		printf("open \"/dev/slot0\" failed\n");
		return -1;
	}
	GPIO myGPIO;

	int ret=0;

	// GPIO 0
	myGPIO._reg = 1;
	myGPIO._mask_bit = 0x000f;
	ioctl(fd, CARDSLOT_READ_GPIO_BITDATA, &myGPIO);

	printf("check gpio 0123=%x\n",myGPIO._data);
	if ((myGPIO._data & 0x0000000f) == 0x0f)
	{
		printf("----press 4 key to enter test mode---\n");
		ret=1;


	}
	close(fd);
	
	return ret;
	
	
};


