#include "events.h"
#include "FList.h"

//------------------------------------------------------------------------------------------------
/**
 * copyFiles()
 * only copy single file from the selected storage devcice to "/backup/" in the main storage device.
 * now default main storage is HD
 */
Uint8 CopyFile(char *dest)
{
	FRAME *elmf;
	char s[LEN_XL], d[LEN_XL], fname[LEN_XL];
	pid_t pid;
	int stat, isFileExisted = 0;
	LIST *list, *node;
	
	FILE *fp;
	char tempbuf[LEN_XL] = "";
	long filesize = 0L;

	///071213 from
	GetPath(s);
	switch (prev_active_index)
	{
	case I_ACTIVE:
	case FI_ACTIVE:
		elmf = &ELMachines[I_ACTIVE].frame;
		strcat(s, elmf->CurrImgListPos->fname);
		break;
	case A_ACTIVE:
		elmf = &ELMachines[A_ACTIVE].frame;
		strcat(s, elmf->CurrAudListPos->fname);
		break;
	case V_ACTIVE:
	case FV_ACTIVE:
		elmf = &ELMachines[V_ACTIVE].frame;
		strcat(s, elmf->CurrVidListPos->fname);
		break;
	}
	///

	//to
	///071203
	if (  (dev_mnted_enbled_flags.sdmmc && strcmp(dest, SDMMC_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.cf && strcmp(dest, CF_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.usb && strcmp(dest, USB_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.xdsm && strcmp(dest, XDSM_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.msx && strcmp(dest, MS_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.hd && strcmp(dest, HD_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.flash && strcmp(dest, FLASH_PATH) == 0)
	   )
	{
		strcpy(d, dest);
	}
	else
	{
		return false;
	}
	/*
	if(dev_mnted_enbled_flags.hd)
		strcpy(d, HD_PATH);
	else
		strcpy(d, FLASH_PATH);
	*/
	///
	//strcat(d, "backup/");
	//ˬdϺЪŶ
	sprintf(tempbuf, "du -sk \'%s\'", s);
	fp = popen(tempbuf, "r");
	filesize = 0L;
	fscanf(fp, "%d", &filesize);
	pclose(fp);
	///071211
	if (filesize > GetPathFreeSize(d))	//Ŷ
	///
	{
		return false;
	}

	//TODO: check file exist

	if(!isFileExisted)
	{
		//copy
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("fork failure!");
				DMSG("Fork to Copy Files Fail!");
				return false;
				//exit(1);
			case 0:
				//child process
				execl("/bin/cp", "cp", "-f", s, d, NULL);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &stat, 0);
				///071211
				system("sync");
				///
				break;
		}
	}
	return true;
}
//------------------------------------------------------------------------------------------------
/**
 * DeleteFile()
 * only delete a single file on the main storage device
 * now default main storage is HD
 */
void DeleteFile()
{
	FRAME *elmf;
	char s[LEN_XL], d[LEN_XL];
	pid_t pid;
	int stat;

	///071213 from
	LIST **pPos = NULL;
	LIST *RemoveNode = NULL;
	Uint32 *pCount = NULL;
	GetPath(s);
	switch (prev_active_index)
	{
	case I_ACTIVE:
	case FI_ACTIVE:
		elmf = &ELMachines[I_ACTIVE].frame;
		strcat(s, elmf->CurrImgListPos->fname);
		pPos = &(elmf->CurrImgListPos);
		pCount = &ImgCount;
		break;
	case A_ACTIVE:
		elmf = &ELMachines[A_ACTIVE].frame;
		strcat(s, elmf->CurrAudListPos->fname);
		pPos = &(elmf->CurrAudListPos);
		pCount = &AudCount;
		break;
	case V_ACTIVE:
	case FV_ACTIVE:
		elmf = &ELMachines[V_ACTIVE].frame;
		strcat(s, elmf->CurrVidListPos->fname);
		pPos = &(elmf->CurrVidListPos);
		pCount = &VidCount;
		break;
	}
	///

	//doing remove
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork failure!");
			DMSG("Fork to Delete Files Error!");
			return;
			//exit(1);
		case 0:
			//child process
			remove(s);
			_EXIT;
		default:
			//parent process
			waitpid(pid, &stat, 0);
			///071211
			system("sync");
			///
			break;
	}

	//seek the list
	///071213
	RemoveNode = *pPos;
	*pPos = ((*pPos)->next ? (*pPos)->next : (*pPos)->prev);
	///

	//remove from list
	///071213
	if (RemoveNode)
	{
		RemoveNode->prev->next = RemoveNode->next;
		if (RemoveNode->next)
			RemoveNode->next->prev = RemoveNode->prev;
		free(RemoveNode);
		(*pCount)--;
		if (elmf->active_icon_index == *pCount)
			elmf->active_icon_index--;
	}
	///
	
/*
	if(isDebugMode)
	{
		if(!strcmp(SelectedMT, ICONText4MT[video]))
			list = VideoList->next;
		else if(!strcmp(SelectedMT, ICONText4MT[music]))
			list = AudioList->next;
		else if(!strcmp(SelectedMT, ICONText4MT[photo]))
			list = ImageList->next;
		
		int isMatched = 0;
		while(list != NULL)
		{
			PRINTF("%s <-> %s : %d\n", fname, list->fname, strcmp(fname, list->fname));
			if(!strcmp(fname, list->fname))
				isMatched++;
			list = list->next;
		}
		
		PRINTF("after deleted, matched: %d\n", isMatched);
	}
*/
}
//------------------------------------------------------------------------------------------------
///070625
Uint8 CopySelectedFiles(char *dest)
{
	FLIST *pTempList;
	pid_t pid;
	int stat;
	char d[LEN_XL];
	Uint8 bFileChecked = FALSE;

	FILE *fp;
	char tempbuf[LEN_XL] = "";
	long long filesize = 0L;

	if (prev_active_index != FLDR_ACTIVE) return;
	if ((pTempList = FolderList_GetHeadPos(FolderList)) == NULL) return;

	///071203
	if (  (dev_mnted_enbled_flags.sdmmc && strcmp(dest, SDMMC_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.cf && strcmp(dest, CF_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.usb && strcmp(dest, USB_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.xdsm && strcmp(dest, XDSM_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.msx && strcmp(dest, MS_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.hd && strcmp(dest, HD_PATH) == 0)
		||
		  (dev_mnted_enbled_flags.flash && strcmp(dest, FLASH_PATH) == 0)
	   )
	{
		strcpy(d, dest);
	}
	else
	{
		return false;
	}
	/*
	if(dev_mnted_enbled_flags.hd)
		strcpy(dest, HD_PATH);
	else
		strcpy(dest, FLASH_PATH);
	*/
	///

	while (pTempList)
	{
		if (pTempList->attribute & Mask_IsChecked)
		{
			bFileChecked = TRUE;

			///070723 ˬdϺЪŶ
			sprintf(tempbuf, "du -sk \'%s\'", pTempList->fname);
			fp = popen(tempbuf, "r");
			filesize = 0L;
			fscanf(fp, "%d", &filesize);
			pclose(fp);
			///071211
			if (filesize > GetPathFreeSize(d))
			///
			{
				return false;
			}

			//copy
			pid = fork();
			switch(pid)
			{
				case -1:
					perror("fork failure!");
					DMSG("Fork to Copy Files Fail!");
					return false;
					//exit(1);
				case 0:
					//child process
					execl("/bin/cp", "cp", "-rf", pTempList->fname, d, NULL);
					_EXIT;
				default:
					//parent process
					waitpid(pid, &stat, 0);
					break;
			}
		}
		pTempList = pTempList->next;
	}

	//Sɮ׳QܡAܭnƻsCurFldrListPos
	if (!bFileChecked && strcmp(CurrFldrListPos->fname, "..") != 0)
	{
		///070723 ˬdϺЪŶ
		sprintf(tempbuf, "du -sk \'%s\'", CurrFldrListPos->fname);
		fp = popen(tempbuf, "r");
		filesize = 0L;
		fscanf(fp, "%d", &filesize);
		pclose(fp);
		///071211
		if (filesize > GetPathFreeSize(d))
		///
		{
			return false;
		}

		//copy
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("fork failure!");
				DMSG("Fork to Copy Files Fail!");
				return false;
				//exit(1);
			case 0:
				//child process
				execl("/bin/cp", "cp", "-rf", CurrFldrListPos->fname, d, NULL);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &stat, 0);
				break;
		}
	}

	///071211
	system("sync");
	///
	
	return true;
}
///
//------------------------------------------------------------------------------------------------
///070625
Uint8 DeleteSelectedFiles()
{
	FLIST *pTempList, *pNextList;
	pid_t pid;
	int stat;
	Uint8 bFileChecked = FALSE;
	Uint8 bListUpdated = FALSE;

	if (prev_active_index != FLDR_ACTIVE) return;
	if ((pTempList = FolderList_GetHeadPos(FolderList)) == NULL) return;

	while (pTempList)
	{
		pNextList = pTempList->next;
		if (pTempList->attribute & Mask_IsChecked)
		{
			bFileChecked = TRUE;
			
			//doing remove
			pid = fork();
			switch(pid)
			{
				case -1:
					perror("fork failure!");
					DMSG("Fork to Delete Files Fail!");
					return;
					//exit(1);
				case 0:
					//child process
					execl("/bin/rm", "rm", "-rf", pTempList->fname, NULL);
					//remove(pTempList->fname);
					_EXIT;
				default:
					//parent process
					waitpid(pid, &stat, 0);
					if (FolderList_RemoveAt(&FolderList, pTempList))
						bListUpdated = TRUE;
					break;
			}
		}
		pTempList = pNextList;
	}

	if (!bFileChecked && strcmp(CurrFldrListPos->fname, "..") != 0)
	{
		//doing remove
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("fork failure!");
				DMSG("Fork to Delete Files Fail!");
				return;
				//exit(1);
			case 0:
				//child process
				execl("/bin/rm", "rm", "-rf", CurrFldrListPos->fname, NULL);
				//remove(CurrFldrListPos->fname);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &stat, 0);
				if (FolderList_RemoveAt(&FolderList, CurrFldrListPos))
					bListUpdated = TRUE;
				break;
		}
	}

	///071211
	if (bListUpdated)
	{
		system("sync");
	}
	///

	return bListUpdated;
}
///
//------------------------------------------------------------------------------------------------
void Confirm_LeftEvent()
{
	isUserConfirmed = (isUserConfirmed + 1) % 2;
	//ConfirmDisplay(); Comment out and take place the fellowing one by Richard Li @04/14/2007
	DrawConfirmButtonFocus();
}
//------------------------------------------------------------------------------------------------
void Confirm_RightEvent()
{
	Confirm_LeftEvent();
}
//------------------------------------------------------------------------------------------------
void Confirm_EnterEvent()
{
	int j;
	FRAME *elmf;
	Uint8 bCopySuccess = true;
		
	elmf = &ELMachines[active_index].frame;

	if(isUserConfirmed)
	{
		if(setup->main_menu_idx == L1_CopyDelete_Setup)
		{
			if(setup->cpydel_idx == L2_CopyDelete_Copy)
			{
                ///071203
                char dest[LEN_XL] = {0};
                switch (setup->cpy_idx)
                {
                case COPY_TO_SDMMC:
                    strcpy(dest, SDMMC_PATH);   break;
                case COPY_TO_CF:
                    strcpy(dest, CF_PATH);      break;
                case COPY_TO_USB:
                    strcpy(dest, USB_PATH);     break;
                case COPY_TO_XD:
                    strcpy(dest, XDSM_PATH);    break;
                case COPY_TO_MS:
                    strcpy(dest, MS_PATH);      break;
                case COPY_TO_HD:
                    strcpy(dest, HD_PATH);      break;
                case COPY_TO_FLASH:
                    strcpy(dest, FLASH_PATH);   break;
                default:
                    break;
                }
#ifdef WINGUI	// xenia, 2008/06/10
				A_StopEvent();
#endif
                if (*dest != '\0')
                {
                    if (prev_active_index == FLDR_ACTIVE)
                        bCopySuccess = CopySelectedFiles(dest);
                    else
                        bCopySuccess = CopyFile(dest);
                }
                /*
				if(setup->cpy_idx == 1)
				{

					///070625
					if (prev_active_index == FLDR_ACTIVE)
					{
						bCopySuccess = CopySelectedFiles();
					}
					else
					///
						bCopySuccess = CopyFile();
				}
                */
                ///
			}
			else
			{
				if(setup->del_idx == L2_CopyDelete_Delete)
				{
					if (prev_active_index == FLDR_ACTIVE)
					{
						if (DeleteSelectedFiles())
							isFolderListUpdate = TRUE;
					}
					else
						DeleteFile();
				}
			}
		}
		//reset by exit SETUP_L1_ACTIVE
		//isUserConfirmed = FALSE;
	}

	ELMachines[active_index].Shutdown(0);//BK
	active_index = SETUP_L2_ACTIVE;
	ELMachines[active_index].Init();
	//ELMachines[active_index].Display();
	SetupEvent();

	/*
	///070723 ƻs(ϺЪŶ)
	if (!bCopySuccess)
	{
		MessageBox("Disk Full! Press <Enter>");
	}
	*/
	///
}
