#include "events.h"
#include "drawutil.h"
#include <sys/ipc.h>
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>

extern Uint8 isCardReaderOn;

//------------------------------------------------------------------------------------------------
void InsertItem(char *filename, LIST *List, Uint8 type)
{
	LIST *newList = NULL, *tmpList = NULL;

	MEMALLOC(newList, LIST, 1);

	strcpy(newList->fname, filename);

	///070613 ݪsbList->prev
	tmpList = List->prev;
	if (!tmpList)
	{
		tmpList = List;
		while(tmpList->next != NULL)
			tmpList = tmpList->next;
	}
	List->prev = newList;
	/*
	tmpList = List;
	while(tmpList->next != NULL)
		tmpList = tmpList->next;
	*/
	///
	
	newList->next = NULL;
	newList->prev = tmpList;
	tmpList->next = newList;

	switch(type)
	{
		case 0:
			ImgCount++;
			break;
		case 1:
			AudCount++;
			break;
		case 2:
			VidCount++;
			break;
	}
}
//------------------------------------------------------------------------------------------------
int strcasecmp(const char *s1, const char *s2)
{
	char c1, c2;
	while ((c1 = tolower(*s1++)) == (c2 = tolower(*s2++)))
	{
		if (c1 == 0)
			return 0;
	}
	return ((Uint8)c1 - (Uint8)c2);
}
//------------------------------------------------------------------------------------------------
/* Compare S1 and S2 as strings holding indices/version numbers,
    returning less than, equal to or greater than zero 
    if S1 is less than, equal to or greater than S2
*/
int strverscmp(const char *s1, const char *s2)
{

	//states: S_N: normal, S_I: comparing integral part, S_F: comparing
	//fractionnal parts, S_Z: idem but with leading Zeroes only
	#define  S_N    0x0
	#define  S_I    0x4
	#define  S_F    0x8
	#define  S_Z    0xC

	//result_type: CMP: return diff; LEN: compare using len_diff/diff
	#define  CMP    2
	#define  LEN    3
	
	const unsigned char *p1 = (const unsigned char *) s1;
	const unsigned char *p2 = (const unsigned char *) s2;
	unsigned char c1, c2;
	int state;
	int diff;

	//Symbol(s)    0       [1-9]   others  (padding)
	//Transition   (10) 0  (01) d  (00) x  (11) -
	static const unsigned int next_state[] =
	{
	/* state     x    d     0      - */
	/* S_N */S_N, S_I, S_Z, S_N,
	/* S_I */S_N, S_I, S_I, S_I,
	/* S_F */S_N, S_F, S_F, S_F,
	/* S_Z */S_N, S_F, S_Z, S_Z
	};

	static const int result_type[] =
	{
	//state   x/x  x/d  x/0  x/-  d/x  d/d  d/0  d/-
	//          0/x  0/d  0/0  0/-  -/x  -/d  -/0  -/-

	/* S_N */ CMP, CMP, CMP, CMP, CMP, LEN, CMP, CMP,
	               CMP, CMP, CMP, CMP, CMP, CMP, CMP, CMP,
	/* S_I */  CMP, -1,  -1,  CMP, +1,  LEN, LEN, CMP,
	               +1,  LEN, LEN, CMP, CMP, CMP, CMP, CMP,
	/* S_F */ CMP, CMP, CMP, CMP, CMP, LEN, CMP, CMP,
	               CMP, CMP, CMP, CMP, CMP, CMP, CMP, CMP,
	/* S_Z */ CMP, +1,  +1,  CMP, -1,  CMP, CMP, CMP,
	               -1,  CMP, CMP, CMP
	};

	if (p1 == p2)
	return 0;

	c1 = *p1++;
	c2 = *p2++;
	/* Hint: '0' is a digit too.  */
	state = S_N | ((c1 == '0') + (isdigit (c1) != 0));

	while ((diff = c1 - c2) == 0 && c1 != '\0')
	{
		state = next_state[state];
		c1 = *p1++;
		c2 = *p2++;
		state |= (c1 == '0') + (isdigit (c1) != 0);
	}

	state = result_type[state << 2 | (((c2 == '0') + (isdigit (c2) != 0)))];

	switch (state)
	{
		case CMP:
			return diff;
		case LEN:
			while (isdigit (*p1++))
				if (!isdigit (*p2++))
					return 1;
			return isdigit (*p2) ? -1 : diff;
		default:
		return state;
	}
}
//------------------------------------------------------------------------------------------------
/**
 * now only comparing .extension
 */
Uint8 IsSupportedJPG(char *ext)
{
	if(
		     !strcasecmp(ext, ".jpg")
		 || !strcasecmp(ext, ".jpeg")
		 || !strcasecmp(ext, ".jpe")
		 || !strcasecmp(ext, ".jfif")
		 || !strcasecmp(ext, ".jfi")
		 || !strcasecmp(ext, ".jng")
	)
		return TRUE;
	else
		return FALSE;
}
//------------------------------------------------------------------------------------------------
/**
 * now only comparing .extension
 */
Uint8 IsSupportedBMP(char *ext)
{
	if(!strcasecmp(ext, ".bmp"))
		return TRUE;
	else
		return FALSE;
}
//------------------------------------------------------------------------------------------------
/**
 * now only comparing .extension
 */
Uint8 IsSupportedTIFF(char *ext)
{
	if(
		     !strcasecmp(ext, ".tiff")
		 || !strcasecmp(ext, ".tif")
	)
		return TRUE;
	else
		return FALSE;
}
//------------------------------------------------------------------------------------------------
/**
 * now only comparing .extension
 */
Uint8 IsSupportedAudio(char *ext)
{
	if(
		     !strcasecmp(ext, ".mp3")
		 || !strcasecmp(ext, ".wma")
		 || !strcasecmp(ext, ".aac")
		 || !strcasecmp(ext, ".m4a")
		 || !strcasecmp(ext, ".wav")
		 || !strcasecmp(ext, ".ogg")
	)
		return TRUE;
	else
		return FALSE;
}
//------------------------------------------------------------------------------------------------
/**
 * now only comparing .extension
 */
Uint8 IsSupportedVideo(char *ext)
{
	if(
		     !strcasecmp(ext, ".avi")
		 || !strcasecmp(ext, ".mpg")
		 || !strcasecmp(ext, ".dat")
		 || !strcasecmp(ext, ".mp4")
		 || !strcasecmp(ext, ".mov")
		 || !strcasecmp(ext, ".3gp")
		 || !strcasecmp(ext, ".mpeg")
		 || !strcasecmp(ext, ".divx")
		 || !strcasecmp(ext, ".flv")
		 || !strcasecmp(ext, ".vob")
//		 || !strcasecmp(ext, ".wmv")
	)
		return TRUE;
	else
		return FALSE;
}
//------------------------------------------------------------------------------------------------
void AddtoList(char *filename, Uint8 type)
{
	switch(type)
	{
		case 0://Image
			InsertItem(filename, ImageList, 0);
			break;
		case 1://Audio
			InsertItem(filename, AudioList, 1);
			break;
		case 2://Video
			InsertItem(filename, VideoList, 2);
			break;
	}
}
//------------------------------------------------------------------------------------------------
/**
 * //new added by bk@070409 - add parameter "type" for searching the speciafied media type files
 * void SearchFileNoSorting(char *path, int type)
 *     char *path: the place to parsing recursively
 *     int type:
 *         0x1 is searching image files
 *         0x2 is searching audio files
 *         0x4 is searching video files
 *         0x7 is searching 3 kinds of media files
 *         0x2, 0x110, 0x101... is the same as above
 *     Uint8 isAbsolutePathReturned:
 *         true(1) - the filename string in list will be absolute path
 *         false(0) - not
 */
void SearchFileNoSorting(char *path, Uint8 type, Uint8 isAbsolutePathReturned, Uint8 strict)
{
	DIR *dir;
	struct dirent *dent;
	struct stat buf;
	char *p;
	char filename[LEN_XL], childPath[LEN_XL];
	char cwd[LEN_XL], *pCwd;
	static char dirname[LEN_XL];
	int i, Len;
	struct bmp_state *bmp_h;
	struct tiff_hdr *tiff_h;
	
	if((dir = opendir(path)) == NULL)
	{
		DPRINTF("Error opening directory '%s'!\n", path);
		return;
		//exit(1);
	}
	chdir(path);
	
	//suppose the search path must be under /mnt/xxx... - bk @ 080115
	if(strict > 0)
	{
		getcwd(cwd, LEN_XL);
		strcat(cwd, "/");
		pCwd =strchr(strchr(cwd + 1 , '/') + 1, '/') + 1;
		if(pCwd == NULL)
		{
			strcpy(cwd, "");
			pCwd = cwd;
		}
	}
	
	while((dent = readdir(dir)) != NULL)
	{
		lstat(dent->d_name, &buf);
		if(S_ISDIR(buf.st_mode))
		{
			// Found a directory, but ignore . and .. 
			if(  strcmp(".", dent->d_name) == 0
			   || strcmp("..", dent->d_name) == 0
			   || strcmp("Recycled", dent->d_name) == 0	//071102 귽^
			  )
				continue;

			if(isAbsolutePathReturned)
			{
				strcpy(childPath, path);
				strcat(childPath, dent->d_name);
				strcat(childPath, "/");
				//SearchFileNoSorting(childPath, type, isAbsolutePathReturned, strict);
				//bk @ 080115
				if(strict <= 0)//no strict
					SearchFileNoSorting(childPath, type, isAbsolutePathReturned, strict);
				else//strict
				{
					if(strict < DEPTH_OF_HD_NAS_SEARCH)
						SearchFileNoSorting(childPath, type, isAbsolutePathReturned, strict + 1);
				}
			}
			else
			{
//				strcat(dirname, dent->d_name);
//				strcat(dirname, "/");
//				//PRINTF("Dir = %s\n", dirname);
//				SearchFileNoSorting(dent->d_name, type, isAbsolutePathReturned, strict);
				//bk @ 080115
				if(strict <= 0)//no strict
				{
					strcat(dirname, dent->d_name);
					strcat(dirname, "/");
					//PRINTF("Dir = %s\n", dirname);
					SearchFileNoSorting(dent->d_name, type, isAbsolutePathReturned, strict);
				}
				else//strict
				{
					if(strict < DEPTH_OF_HD_NAS_SEARCH)
						SearchFileNoSorting(dent->d_name, type, isAbsolutePathReturned, strict + 1);
				}
			}
		}
		if(S_ISREG(buf.st_mode))
		{
			//Found a regular file
			if(!(p = strrchr(dent->d_name, '.')))
				continue;
			memset(filename, 0, LEN_XL);
//			if(isAbsolutePathReturned)
//				strcat(filename, path);
//			else
//				strcat(filename, dirname);
			//bk @ 080115
			if(strict <= 0)
			{
				if(isAbsolutePathReturned)
					strcat(filename, path);
				else
					strcat(filename, dirname);
			}
			else
			{
				strcat(filename, pCwd);
			}
			strcat(filename, dent->d_name);
			//PRINTF("Full path = %s\n", filename);

			//new added by bk@070409 - add for searching the speciafied media type files
			if(type & MT_PHOTO)
			{
				/**
				 * important!!!
				 * if modifying any type of image, plz also modify function DrawEXIF() in drawutil.c
				 */
				if(IsSupportedJPG(p))
					AddtoList(filename, 0);
				//special case for bmp
				else if(IsSupportedBMP(p))
				{
					bmp_h = (struct bmp_state *)GetBmpHdr(dent->d_name);
					if (bmp_h != NULL)
					{
						AddtoList(filename, 0);
						FreeBmpHdr(bmp_h);
					}
				}
				else if(IsSupportedTIFF(p))
				{
					tiff_h = (struct tiff_hdr *)GetTiffHdr(dent->d_name);
					if (tiff_h != NULL)
					{
						AddtoList(filename, 0);
						FreeTiffHdr(tiff_h);
					}
				}
			}
			if(type & MT_MUSIC)
			{
				if(IsSupportedAudio(p))
					AddtoList(filename, 1);
			}
			if(type & MT_VIDEO)
			{
				if(IsSupportedVideo(p))
					AddtoList(filename, 2);
			}
		}
	}
	chdir("..");
	if(strict <= 0 && dirname != NULL)
	{
		Len = strlen(dirname);
		dirname[Len - 1] = '\0';
		for(i = Len - 2; i >= 0; i--)
		{
			if(dirname[i] == '/')
				break;
			else
				dirname[i] = '\0';
		}
		//PRINTF("dirname = %s\n", dirname);
	}
	closedir(dir);
}
//------------------------------------------------------------------------------------------------
void AddtoStatList(char *dirpath, char *fname, struct stat *st)
{
	STAT_LIST *NewStatList = NULL, *TmpStatList = NULL;
	
	MEMALLOC(NewStatList, STAT_LIST, 1);
	//NewStatList->SubStat.st_dev = st->st_dev;
	strcpy(NewStatList->SubStat.path, dirpath);
	strcpy(NewStatList->SubStat.filename, fname);	
	NewStatList->SubStat.st_ino = st->st_ino;
	NewStatList->SubStat.st_mtime = st->st_mtime;
	NewStatList->SubStat.st_size = st->st_size;

	TmpStatList = SubStatList->prev;
	if (!TmpStatList)
	{
		TmpStatList = SubStatList;
		while(TmpStatList->next != NULL)
			TmpStatList = TmpStatList->next;
	}
	SubStatList->prev = NewStatList;
	NewStatList->next = NULL;
	NewStatList->prev = TmpStatList;
	TmpStatList->next = NewStatList;
	ListNum++;
	//PRINTF("N=%d\n", ListNum);
}
//------------------------------------------------------------------------------------------------
int CompareMTimeDescending(const void *e1p, const void *e2p)
{
	const SUB_STAT **e1, **e2;

	e1 = (const SUB_STAT **)e1p;
	e2 = (const SUB_STAT **)e2p;

	if((*e1)->st_mtime > (*e2)->st_mtime)
		return -1;
	else if((*e1)->st_mtime == (*e2)->st_mtime)
		return 0;
	else
		return 1;
}
//------------------------------------------------------------------------------------------------
int CompareMTimeAscending(const void *e1p, const void *e2p)
{
	const SUB_STAT **e1, **e2;

	e1 = (const SUB_STAT **)e1p;
	e2 = (const SUB_STAT **)e2p;

	if((*e1)->st_mtime < (*e2)->st_mtime)
		return -1;
	else if((*e1)->st_mtime == (*e2)->st_mtime)
		return 0;
	else
		return 1;
}
//------------------------------------------------------------------------------------------------
int CompareFSizeDescending(const void *e1p, const void *e2p)
{
	const SUB_STAT **e1, **e2;

	e1 = (const SUB_STAT **)e1p;
	e2 = (const SUB_STAT **)e2p;

	if((*e1)->st_size > (*e2)->st_size)
		return -1;
	else if((*e1)->st_size == (*e2)->st_size)
		return 0;
	else
		return 1;
}
//------------------------------------------------------------------------------------------------
int CompareFSizeAscending(const void *e1p, const void *e2p)
{
	const SUB_STAT **e1, **e2;

	e1 = (const SUB_STAT **)e1p;
	e2 = (const SUB_STAT **)e2p;

	if((*e1)->st_size < (*e2)->st_size)
		return -1;
	else if((*e1)->st_size == (*e2)->st_size)
		return 0;
	else
		return 1;
}
//------------------------------------------------------------------------------------------------
int CompareAlphabetDescending(const void *e1p, const void *e2p)
{
	const SUB_STAT **e1, **e2;
	int res;

	e1 = (const SUB_STAT **)e1p;
	e2 = (const SUB_STAT **)e2p;

	res = strverscmp((*e1)->filename, (*e2)->filename);
	if(res > 0)
		return -1;
	else if(res == 0)
		return 0;
	else
		return 1;
}
//------------------------------------------------------------------------------------------------
int CompareAlphabetAscending(const void *e1p, const void *e2p)
{
	const SUB_STAT **e1, **e2;
	int res;

	e1 = (const SUB_STAT **)e1p;
	e2 = (const SUB_STAT **)e2p;

	res = strverscmp((*e1)->filename, (*e2)->filename);
	if(res < 0)
		return -1;
	else if(res == 0)
		return 0;
	else
		return 1;
}
//------------------------------------------------------------------------------------------------
void SortingByFunction(Uint8 type, Uint8 isAbsolutePathReturned)
{
	SUB_STAT **ListArray = NULL;
	STAT_LIST *tmpStat = NULL;
	ULint32 i;

	int (*CompareFunc[SORTING_ITEM_NUM])(const void*, const void*) = 
	{
		NULL,
		CompareMTimeDescending,
		CompareMTimeAscending,
		CompareFSizeDescending,
		CompareFSizeAscending,
		CompareAlphabetDescending,
		CompareAlphabetAscending
	};
	MEMALLOC(ListArray, SUB_STAT*, ListNum);

	tmpStat = SubStatList->next;
	for(i = 0; i < ListNum; i++)
	{
		if(tmpStat != NULL)
		{
			ListArray[i] = &(tmpStat->SubStat);
		}
		tmpStat = tmpStat->next;
	}
	//qsort
	qsort(ListArray, ListNum, sizeof(SUB_STAT*), CompareFunc[setup->sorting_idx]);
#if 0
	for(i = 0; i < ListNum; i++)
	{
		PRINTF("After->dir_path = %s\n", ListArray[i]->path);
		if(setup->sorting_idx == ByDescendingTime)
			PRINTF("After->time = %d\n", ListArray[i]->st_mtime);
		else if(setup->sorting_idx == ByAscendingTime)
			PRINTF("After->time = %d\n", ListArray[i]->st_mtime);
		else if(setup->sorting_idx == ByDescendingSize)
			PRINTF("After->size = %d\n", ListArray[i]->st_size);
		else if(setup->sorting_idx == ByAscendingSize)
			PRINTF("After->size = %d\n", ListArray[i]->st_size);
	}
#endif
	//Make 3 lists
	DIR *dir;
	struct dirent *dent;
	char *p;
	char localpath[LEN_XL], fullfilename[LEN_XL];
	struct bmp_state *bmp_h;
	struct tiff_hdr *tiff_h;
	
	for(i = 0; i < ListNum; i++)
	{
		memset(localpath, 0, LEN_XL);
		strcpy(localpath, ListArray[i]->path); 
		if((dir = opendir(localpath)) == NULL)
		{
			DPRINTF("Error opening directory '%s'!\n", localpath);
			return;
		}
		chdir(localpath);
		while((dent = readdir(dir)) != NULL)
		{
			if(ListArray[i]->st_ino != dent->d_ino)
				continue;
			if(!(p = strrchr(dent->d_name, '.')))
				continue;
			//get the file based on i_node
			memset(fullfilename, 0, LEN_XL);
			if(isAbsolutePathReturned)
			{
				strcat(fullfilename, localpath);
				strcat(fullfilename, dent->d_name);
			}
			else
			{
				Uint16 i, j = 0, len, n = 0;
				len = strlen(localpath);
				for(i = 0; i < len; i++)
				{
					if(n < 3 && localpath[i] == '/')
					{
						n++;
					}
					if(n == 3)
						fullfilename[j++] = localpath[i+1];
				}
				strcat(fullfilename, dent->d_name);
			}
				
			if(type & MT_PHOTO)
			{
				if(IsSupportedJPG(p))
				{
					//PRINTF("filename to be added = %s\n", fullfilename);
					AddtoList(fullfilename, 0);
				}
				else if(IsSupportedBMP(p))
				{
					bmp_h = (struct bmp_state *)GetBmpHdr(dent->d_name);
					if (bmp_h != NULL)
					{
						//PRINTF("filename to be added = %s\n", fullfilename);
						AddtoList(fullfilename, 0);
						FreeBmpHdr(bmp_h);
					}
				}
				else if(IsSupportedTIFF(p))
				{
					tiff_h = (struct tiff_hdr *)GetTiffHdr(dent->d_name);
					if (tiff_h != NULL)
					{
						//PRINTF("filename to be added = %s\n", fullfilename);
						AddtoList(fullfilename, 0);
						FreeTiffHdr(tiff_h);
					}
				}
			}
			if(type & MT_MUSIC)
			{
				if(IsSupportedAudio(p))
				{
					//PRINTF("filename to be added = %s\n", fullfilename);
					AddtoList(fullfilename, 1);
				}
			}
			if(type & MT_VIDEO)
			{
				if(IsSupportedVideo(p))
				{
					//PRINTF("filename to be added = %s\n", fullfilename);
					AddtoList(fullfilename, 2);
				}
			}
		}
		closedir(dir);
	}
	for(i = 0; i < ListNum; i++)
		FREEMEMORY(ListArray[i]);
	FREEMEMORY(ListArray);
	//free SubStatList
	STAT_LIST *prevList, *nextList;

	prevList = nextList = NULL;
	prevList = SubStatList;
	while(prevList != NULL)
	{
		nextList = prevList->next;
		FREEMEMORY(prevList);
		SubStatList = NULL;
	}
}
//------------------------------------------------------------------------------------------------
void SearchFileStat(char *path, Uint8 strict)
{
	DIR *dir;
	struct dirent *dent;
	struct stat buf;
	char *p;
	char fullpath[LEN_XL];
	
	if((dir = opendir(path)) == NULL)
	{
		DPRINTF("Error opening directory '%s'!\n", path);
		return;
		//exit(1);
	}
	chdir(path);
	while((dent = readdir(dir)) != NULL)
	{
		memset(fullpath, 0, LEN_XL);
		strcat(fullpath, path);
		lstat(dent->d_name, &buf);
		if(S_ISDIR(buf.st_mode))
		{
			// Found a directory, but ignore . and .. 
			if(strcmp(".", dent->d_name) == 0 || strcmp("..", dent->d_name) == 0)
				continue;
			strcat(fullpath, dent->d_name);
			strcat(fullpath, "/");
			//SearchFileStat(fullpath, strict);
			//bk @ 080115
			if(strict <= 0)//no strict
				SearchFileStat(fullpath, strict);
			else//strict
			{
				if(strict < DEPTH_OF_HD_NAS_SEARCH)
					SearchFileStat(fullpath, strict + 1);
			}
		}
		else if(S_ISREG(buf.st_mode))
		{
			//PRINTF("filename = %s\n", dent->d_name);
			AddtoStatList(fullpath, dent->d_name, &buf);
		}
	}
	chdir("..");
	closedir(dir);
}
//------------------------------------------------------------------------------------------------
void SearchFileSorting(char *path, Uint8 type, Uint8 isAbsolutePathReturned, Uint8 strict)
{
	SubStatList = NULL;
	MEMALLOC(SubStatList, STAT_LIST, 1);
	ListNum = 0;
	SearchFileStat(path, strict);
	SortingByFunction(type, isAbsolutePathReturned);
}
//------------------------------------------------------------------------------------------------
//search all sub-folders under path, stirct is 0 (no strict) - bk @ 080108
void SearchFileByType(char *path, Uint8 type, Uint8 isAbsolutePathReturned)
{
	SearchFileByTypeStrict(path, type, isAbsolutePathReturned, 0);
/*
	if(setup->sorting_idx == NoSorting)
	{
		SearchFileNoSorting(path, type, isAbsolutePathReturned);
	}
	else
	{
		SearchFileSorting(path, type, isAbsolutePathReturned);
	}
*/
}
//------------------------------------------------------------------------------------------------
/**
 * bk @ 080108
 * just only search to limited sub-folders under path
 * strict <= 0, search all folders
 * strict is N (> 0), search down to DEPTH_OF_HD_NAS_SEARCH-th folders
 * 		and now is in the depth of N folder
 */
void SearchFileByTypeStrict(char *path, Uint8 type, Uint8 isAbsolutePathReturned, Uint8 strict)
{
	if(setup->sorting_idx == NoSorting)
	{
		SearchFileNoSorting(path, type, isAbsolutePathReturned, strict);
	}
	else
	{
		SearchFileSorting(path, type, isAbsolutePathReturned, strict);
	}
}
//------------------------------------------------------------------------------------------------
void SearchFileAllTypes(char *path)
{
	InitList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
	SearchFileByType(path, MT_PHOTO | MT_MUSIC | MT_VIDEO, FALSE);
}
//------------------------------------------------------------------------------------------------
///080521
void MakeIAVList()
{
	pthread_t vfork_thread;
	void *vfork_thread_result;
	COORD show_str_pos = desc->MiscTextCoord[44];

	show_process_msg(FrameText[setup->Language][46],show_str_pos,1);

	pthread_create(&(vfork_thread), NULL, (void *)(&MakeIAVList_Thread), NULL);
	pthread_join(vfork_thread, &vfork_thread_result);

	stop_show_process_msg();	
}

void MakeIAVList_Thread()
{
	int i;
	if(!strcmp(SelectedDev, DEVICE_CF_NAME))
	{
		SearchFileAllTypes(CF_PATH);
	}
	else if(!strcmp(SelectedDev, DEVICE_SDMMC_NAME))
	{
		SearchFileAllTypes(SDMMC_PATH);
	}
	else if(!strcmp(SelectedDev, DEVICE_xD_NAME))
	{
		SearchFileAllTypes(XDSM_PATH);
	}
	else if(!strcmp(SelectedDev, DEVICE_MS_NAME))
	{
		SearchFileAllTypes(MS_PATH);
	}
	else if(!strcmp(SelectedDev, DEVICE_USB_NAME))
	{
		SearchFileAllTypes(USB_PATH);
	}
	else if(!strcmp(SelectedDev, DEVICE_FLASH_NAME))
	{
		SearchFileAllTypes(FLASH_PATH);
	}
	else if(!strcmp(SelectedDev, DEVICE_CARD_READER_NAME))
	{
		//Umount all mounted devices
		for(i = 0; i < MAX_MOUNTED_DEV; i++)
			UmountDecive(i);
		//SavePrevMountedDeviceStatus();
		EnableReader();
	}
#ifdef BLUETOOTH_MOD
	else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
	{
		SearchFileAllTypes(BT_PATH);
	}
#endif
	
	//Handle selected storage has no music
	if(AudCount == 0 && dev_mnted_enbled_flags.flash)
	{
		if(
				!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
			||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
			||	!strcmp(SelectedDev, DEVICE_NET_NAME)
#endif
		)
			;
		else
		{
			isFlashMusicUsed = TRUE;
			SearchFileByType(FLASH_PATH, MT_MUSIC, TRUE);
		}
	}
}
/// 
//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void LoadBTDeviceList()
{
	FILE *fp;
	char str[BT_DVC_LEN];
	int i = 0, num = 0;
	
	//Open Descriptor file from somewhere
	if(!(fp = fopen(BT_DEVICE_LIST_FILE_NAME, "r")))
	{
		DMSG("Failed to open bt device list file!\n");
		return;
	}
	else
	{
		//comment
		fscanf(fp, "%d\n", &num);
		smbtop->num = num;
#if 0
		PRINTF("bt device num = %d\n", smbtop->num);
#endif
		for(i = 0; i < num; i++)
		{
			memset(str, '\0', BT_DVC_LEN);
			fgets(str, BT_DVC_LEN, fp);
			strcpy(smbtop->push_service[i].name, str);
			
			memset(str, '\0', BT_DVC_LEN);
			fgets(str, BT_DVC_LEN, fp);
			strcpy(smbtop->push_service[i].addr, str);
			
			fscanf(fp, "%d\n", &num);
			smbtop->push_service[i].channel = num;
#if 0
			PRINTF("device[%d]=[%s][%s][%d]\n", 
				i, 
				smbtop->push_service[i].name, 
				smbtop->push_service[i].addr, 
				smbtop->push_service[i].channel
			);
#endif
		}
		smbtop->num = i;
		smbtop->complete = FALSE;
		fclose(fp);
	}
}
//------------------------------------------------------------------------------------------------
void SaveBTDeviceList()
{
	FILE *fp;
	int i;
	char tmp[LEN_S];
	
	if(!(fp = fopen(BT_DEVICE_LIST_FILE_NAME, "w")))
	{
		DMSG("Failed to open bt device list file!\n");
		return;
	}
	else
	{
		memset(tmp, '\0', LEN_S);
		sprintf(tmp, "%d", smbtop->num);
		fputs(tmp, fp);fputs("\n", fp);
		for(i = 0; smbtop != NULL && i < smbtop->num; i++)
		{
			fputs(smbtop->push_service[i].name, fp);fputs("\n", fp);
			fputs(smbtop->push_service[i].addr, fp);fputs("\n", fp);
			fprintf(fp, "%d\n", smbtop->push_service[i].channel);
		}
		fclose(fp);
		system("sync");
	}
}
//------------------------------------------------------------------------------------------------
void ForkBTProcesses()
{
	int status;

	if(isBTDonglePlugged())//just detect dongle plugging, just fork once
	{
		if(!isBTPrcsForked)
		{
			//fork sdpd
			pid_bt_sdpd = fork();
			switch(pid_bt_sdpd)
			{
				case -1:
					perror("Fork bt_sdpd failed!");
					DMSG("Fork bt_sdpd failed!");
					break;
				case 0:
					//child process
					execl("/bin/sdpd", "sdpd", NULL);
					_EXIT;
				default:
					//parent process
					waitpid(pid_bt_sdpd, &status, 0);
//					if(WIFEXITED(status))
//					{
						DMSG("Forking bt_sdpd success!!!");
//					}
					break;
			}

			//fork hcid
			pid_bt_hcid = fork();
			switch(pid_bt_hcid)
			{
				case -1:
					perror("Fork bt_hcid failed!");
					DMSG("Fork bt_hcid failed!");
					break;
				case 0:
					//child process
					execl("/bin/hcid", "hcid", NULL);
					_EXIT;
				default:
					//parent process
					waitpid(pid_bt_hcid, &status, 0);
//					if(WIFEXITED(status))
//					{
						DMSG("Forking bt_hcid success!!!");
//					}
					break;
			}

			//fork sobexsrv
			pid_bt_sobexsrv = fork();
			switch(pid_bt_sobexsrv)
			{
				case -1:
					perror("Fork bt_sobexsrv failed!");
					DMSG("Fork bt_sobexsrv failed!");
					break;
				case 0:
					//child process
					sleep(1);//waiting for hcid init ready
					execl("/bin/sobexsrv", "sobexsrv", NULL);
					_EXIT;
				default:
					//parent process
					waitpid(pid_bt_sobexsrv, &status, 0);
//					if(WIFEXITED(status))
//					{
						sleep(1);//waiting for bt_sobexsrv shared memory ready
						DMSG("Forking bt_sobexsrv success!!!\n");
//					}
					break;
			}
			
//			//fork orz
//			if(smbtop == NULL)
//				ScanBTOPushDevices();
			
			//shared memory - smbt
			shm_bt_id = shmget(SHM_KEY_BT, sizeof(shm_bt), 0);
			DPRINTF("shared memory bt id: %d\n", shm_bt_id);
			if(shm_bt_id != -1)//get sm success
			{
				smbt = (shm_bt *) shmat(shm_bt_id, NULL, 0);
				if(!smbt)//attach fail
				{
					DMSG("shmat bt fail!");
				}
			}else//get sm fail
			{
				DMSG("shmget bt fail!");
			}

			//shared memory - smbtop
			shm_btop_id = shmget(SHM_KEY_BT_SCAN_OPUSH, sizeof(shm_bt_opush), 0);
			DPRINTF("shared memory btop id: %d\n", shm_btop_id);
			if(shm_btop_id != -1)//get sm success
			{
				smbtop = (shm_bt_opush *) shmat(shm_btop_id, NULL, 0);
				if(!smbtop)//attach fail
				{
					DMSG("shmat btop fail!");
				}
			}else//get sm fail
			{
				//create the shared memory
				shm_btop_id = shmget(SHM_KEY_BT_SCAN_OPUSH, sizeof(shm_bt_opush), IPC_CREAT | 0666);
				smbtop = (shm_bt_opush *) shmat(shm_btop_id, NULL, 0);
				DMSG("shmget btop fail!");
				DPRINTF(" new shared memory btop id: %d\n", shm_btop_id);
				//load from device list
				LoadBTDeviceList();
			}
			
			isBTPrcsForked = TRUE;
			BTActNum = 0L;
		}
	}
	else
	{
		if(isBTPrcsForked)
			KillBTProcesses();
	}
}
//------------------------------------------------------------------------------------------------
void ScanBTOPushDevices()
{
	pid_bt_orz = fork();
	switch(pid_bt_orz)
	{
		case -1:
			perror("Fork bt_orz failed!");
			DMSG("Fork bt_orz failed!");
			break;
		case 0:
			//child process
			//system("date");//TODO: for scanning test
			execl("/bin/orz", "orz", NULL);
			_EXIT;
		default:
			//parent process
//			waitpid(pid_bt_orz, &sts_orz, WNOHANG);
//			if(WIFEXITED(sts_orz))
//			{
//				sleep(1);//waiting for bt_orz shared memory ready
				DMSG("Forking bt_orz over!!!\n");
//			}
			isBTScanningOPush = TRUE;//shm_bt_opush->complete also will be reset by orz process
			break;
	}
}
#endif
//------------------------------------------------------------------------------------------------
// Device Selection Callbacks																		    
//------------------------------------------------------------------------------------------------
void DS_UpEvent()
{
	FRAME *elmf;
	int idx;

	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);

	///080320
	ITEM_DATA *pItem = &(elmf->item_data);
	pItem->curr_item--;
	if (pItem->curr_item < 0)
		pItem->curr_item += pItem->total_item;
	elmf->active_icon_index = pItem->curr_item;
	/*
	idx = elmf->active_icon_index - 1;
	if(idx < 0)
	{
#ifdef NET_MOD
		if(dev_mnted_enbled_flags.net)
		{
			idx += (num_enabled_dev - 1);
		}
		else
		{
			idx += num_enabled_dev;
		}
#else
		idx += num_enabled_dev;
#endif
	}
	elmf->active_icon_index = idx;
	*/
	///

	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void DS_DownEvent()
{
	FRAME *elmf;
	int idx;

	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);

	///080320
	ITEM_DATA *pItem = &(elmf->item_data);
	pItem->curr_item++;
	pItem->curr_item %= pItem->total_item;
	elmf->active_icon_index = pItem->curr_item;
	/*
	idx = elmf->active_icon_index + 1;
#ifdef NET_MOD
	if(dev_mnted_enbled_flags.net)
	{
		elmf->active_icon_index = idx % (num_enabled_dev - 1);
	}
	else
	{
		elmf->active_icon_index = idx % num_enabled_dev;
	}
#else
	elmf->active_icon_index = idx % num_enabled_dev;
#endif
	*/
	///

	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void DS_LeftEvent()
{
	DS_UpEvent();
}
//------------------------------------------------------------------------------------------------
void DS_RightEvent()
{
	DS_DownEvent();
}
//------------------------------------------------------------------------------------------------
void DS_PlayPauseEvent()
{
	DS_EnterEvent();
}
//nelly add 6/23/2008 for wps push button 
#ifdef NET_MOD
//#include "skyutil.h" 
#define WPS_SUPPORT
void DS_RotateEvent()
{
#ifdef WPS_SUPPORT	
	if(start_wps_pbc()<0)
	  printf("RUN WPS FAILED!\n");
#endif	  
}
#endif
//------------------------------------------------------------------------------------------------
#if defined(SHOW_PROC_MSG)
static uint8 alarm_count = 0;
static uint8 in_process_pre_state = 0xff;
void show_process_msg_alarm_handler(int nothing)
{    		
	int i;
	FRAME *elmf;
	Uint16 *dest = (Uint16*)RGB1;	
	int string_len;
	char show_str[60];

//	PRINTF("[show_process_msg_alarm_handler]\n");
	
	elmf = &ELMachines[active_index].frame; 	
	
	string_len = strlen(elmf->frametextmsg);
	memset(show_str,0x00,60);	
	strcpy(show_str,elmf->frametextmsg);

	alarm_count++;

	if (alarm_count>=19)
	{
		memcpy(elmf->rgbtemplate,RGB0, RGB_FRAMEBUFF_SIZE);
		alarm_count = 0;
	}

	for (i=0;i<alarm_count;i++)
		show_str[string_len+i] = '.';

	// -------------------------------------------------------------	

	if (elmf->num_icon)
		DuplicateBitmap((Uint16 *)elmf->rgbtemplate, (Uint16 *)elmf->icon_arr[alarm_count%2].iconbuff,
						  	elmf->icon_arr[alarm_count%2].icoord.x, elmf->icon_arr[alarm_count%2].icoord.y,
						  	elmf->icon_arr[alarm_count%2].icoord.width, elmf->icon_arr[alarm_count%2].icoord.height);

	FontTextOutFormat(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate,elmf->frametextmsgcoord.x, elmf->frametextmsgcoord.y,show_str, BLUE_1555, DT_LEFT);	
	memcpy(dest, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	
	RGB2YUV(1, 1);	//RBG->YUV for TV encoder	

	alarm(1);
//	pgu_switch_to_buffer(1);
}
#endif
void show_process_msg(char *str,COORD pos,unsigned char timesec)
{
#if defined(SHOW_PROC_MSG)

	FRAME *elmf;
	Uint16 *dest = (Uint16*)RGB1;
	unsigned char i;

	in_process_pre_state = active_index;
	active_index = SHOW_IN_PROCESS_ACTIVE;

	//PRINTF(" SHOW_IN_PROCESS_ACTIVE %d\n",SHOW_IN_PROCESS_ACTIVE);
	
	alarm_count = 0;

	elmf = &ELMachines[active_index].frame; 
	elmf->active_icon_index = 0;
	elmf->num_icon = 0;
	
	if (!(desc->MiscICONIMG[3]&&desc->MiscICONIMG[5]))
		return;
	
#if 0
	struct itimerval t;    	
	t.it_interval.tv_usec = 0;    
	t.it_interval.tv_sec = 1;    
	t.it_value.tv_usec = 0;    
	t.it_value.tv_sec = timesec;
#endif
	tcon_clear_icon();	

	if (elmf->icon_arr)
	{
		FreeICONBuffer();	
		FreeICONS();
	}
			
	elmf->rgbtemplate = InitFrameBackground(bkg_blank);
	memcpy(RGB0,elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);	
	elmf->frametextmsg = str;	
	elmf->frametextmsgcoord.x = pos.x;
	elmf->frametextmsgcoord.y = pos.y;	
	elmf->num_icon = 2;
	MEMALLOC(elmf->icon_arr, ICON, elmf->num_icon);		
	for (i=0;i<elmf->num_icon;i++)		// pos 3,5
	{
		elmf->icon_arr[i].fname = desc->MiscICONIMG[3+(i*2)];        //i_sandglass
		elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[5].x;	 // for not to modify i_sandglass co .. we just use sandglass invert 
		elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[5].y;
		elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[5].width;
		elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[5].height;			
		FillupICONImageBuffer(i);
	}

	//PRINTF("icoord.x %d,icoord.y %d\n",elmf->icon_arr[1].icoord.x,elmf->icon_arr[1].icoord.y);
	
	DuplicateBitmap((Uint16 *)elmf->rgbtemplate, (Uint16 *)elmf->icon_arr[1].iconbuff,
				  	elmf->icon_arr[1].icoord.x, elmf->icon_arr[1].icoord.y,
				  	elmf->icon_arr[1].icoord.width, elmf->icon_arr[1].icoord.height);
	
	FontTextOutFormat(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate,elmf->frametextmsgcoord.x, elmf->frametextmsgcoord.y,elmf->frametextmsg, BLUE_1555, DT_LEFT);		
	memcpy(dest, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);		
//	pgu_set_alpha(setup->sys_alpha);
//	pgu_enable_overlay(1);
	RGB2YUV(1, 1);		

	signal(SIGALRM, show_process_msg_alarm_handler); 	
	alarm(1);
#if 0
	if(setitimer( ITIMER_REAL, &t, NULL) < 0 )
	{     
		DPRINTF("Alarm timer  Start Failed\n");
	}
#endif
#endif
}

void stop_show_process_msg(void)
{
#if defined(SHOW_PROC_MSG)

	FRAME *elmf;	

	//PRINTF("[stop_show_process_msg]\n");

	elmf = &ELMachines[active_index].frame;

	if (elmf->num_icon)
	{
	
		signal(SIGALRM,SIG_DFL);
		alarm(0);
#if 0	
		struct itimerval t;    	
		t.it_value.tv_sec = 0;
		t.it_interval.tv_sec = 0;
		if(setitimer( ITIMER_REAL, &t, NULL) < 0)
		{     
			DPRINTF("Alarm timer  Stop Failed\n");
		}					
#endif	
		ResetBackgroundInfo();	
		FreeICONBuffer();
		FreeICONS();
	}
	active_index = in_process_pre_state;	
#endif
}

void DS_EnterEvent()
{
	//when isCardReaderOn == TRUE, it represents now the Card Reader is on in TV mode, there has no
	//active state machine, thus, we don't have to do machine shutdown!!! 
	if(!isCardReaderOn)
	{
		ELMachines[active_index].Shutdown(0);
	}
    DBG_MSG("<skydemo> invoking device %s\n", SelectedDev);

/*rywu20080516 removed
#ifdef NET_MOD
	if(!strcmp(SelectedDev, DEVICE_RSS_NAME))
	{		
		//Fork a.out==>rss reader
		pid_rss = fork();
		switch(pid_rss)
		{
			case -1:
				perror("Fork failed!");
				return;
			case 0:
				sleep(1);
				chdir(FLASH_PATH);
				//execl("/bin/rss", "rss", NULL);//==>OK
				//execl("/bin/a.out", "a.out", "/bin/rss.xml", "downloaded.xml", FLASH_PATH, "1", NULL);
				execl("/bin/a.out", "a.out", "/tmp/conf/channels.xml", "downloaded.xml", FLASH_PATH, "1", NULL);
				_EXIT;
			default:
				active_index = RSS_ACTIVE;
				ELMachines[active_index].Init();
				ELMachines[active_index].Display();
				return;
		}
	}
#endif
*/

///080521
	MakeIAVList();

	if(!strcmp(SelectedDev, DEVICE_CARD_READER_NAME))
	{
		active_index = USB2PC_CONN_ACTIVE;
	}

#ifdef BLUETOOTH_MOD
	else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
	{
		ForkBTProcesses();//TODO: in the future, it will integrated with bt setup
		active_index = BT_ACTIVE;
	}
#endif
///080321 Net Device(Service) Selection Page
#ifdef NET_MOD
	else if (!strcmp(SelectedDev, DEVICE_NET_NAME))
	{
		DBG_MSG("<skydemo> into net-device\n");
#ifdef SUPPORT_RSS
		//rywu20080516++
		//This will force state into network device state.
		active_index = NET_DS_ACTIVE;
		
		//use this flag to stop detecting IO changing
		extra_control->ignore_io = 1;
		DBG_MSG("<skydemo> ignore IO -->\n");
		
		//create a thread to handle network event
		pthread_create(&(extra_control->network_thread), NULL, (void *)(&network_thread), extra_control);
		//rywu20080516--
#else
		///080324 T{AȦsb
		if (  dev_mnted_enbled_flags.net)
		///
		{
			active_index = NET_DS_ACTIVE;
		}
#endif
	}
#endif
	//go into FLDR_ACTIVE when selected device is hd or nas (performance issue) - bk @ 080104
	else if(
			!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
		||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
#endif
	)
	{
		active_index = FLDR_ACTIVE;
	}
#ifdef IP_CAM_MOD
	else if (!strcmp(SelectedDev, DEVICE_IPCAM_NAME))
	{
		active_index = IP_CAM_ACTIVE;
	}
#endif
	else
	{
#ifdef MEDIALINK
		///080501 MEDIALINKy{
		if (ImgCount)
		{
			SelectedMT = ICONText4MT[photo];
			active_index = I_ACTIVE;
		}
		else if (VidCount)
		{
			SelectedMT = ICONText4MT[video];
			active_index = V_ACTIVE;
		}
		else if (AudCount)
		{
			SelectedMT = ICONText4MT[music];
			active_index = A_ACTIVE;
		}
		else
		{
			SelectedMT = ICONText4MT[folder];
			active_index = FLDR_ACTIVE;
		}
#else
		active_index = MT_ACTIVE;
		ELMachines[active_index].frame.active_icon_index = photo;
#endif
	}
	DBG_MSG("<skydemo>    active_index = %d\n", active_index);
	
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
///
}
//------------------------------------------------------------------------------------------------
///080322
#ifdef NET_MOD
void Net_DS_UpEvent()
{
	DS_UpEvent();
}
//------------------------------------------------------------------------------------------------
void Net_DS_DownEvent()
{
	DS_DownEvent();
}
//------------------------------------------------------------------------------------------------
void Net_DS_LeftEvent()
{
	Net_DS_UpEvent();
}
//------------------------------------------------------------------------------------------------
void Net_DS_RightEvent()
{
	Net_DS_DownEvent();
}
//------------------------------------------------------------------------------------------------
void Net_DS_EnterEvent()
{
	pid_t pid;
	int status;
	Uint8 i;

#ifdef SUPPORT_RSS
	//rywu20080516++
    char channel_file[64];
    char recycle[2];
    char main_path[32];
    char sub_path[32];
    //rywu20080516--

    //rywu20080616++
    FILE *fp;
    char buf[80];
    //rywu20080616--

	if(!strcmp(SelectedDev, DEVICE_RSS_NAME) || 
       !strcmp(SelectedDev, DEVICE_RSS_FRAME_CHANNEL_NAME) ||//rywu20080516
       !strcmp(SelectedDev, DEVICE_RSS_PICASA_NAME) )//rywu20080516
	{		
        //rywu20080516++
        if(!strcmp(SelectedDev, DEVICE_RSS_NAME))//use as Flickr
        {
            strcpy(channel_file, RSS_FLICKR_CONFIG_FILE);
            strcpy(recycle, RECYCLE_MODE_NONE);
            strcpy(main_path, MAIN_DOWNLOAD_PATH);
            strcpy(sub_path, "/flickr");//rywu20080530
        }
        else if(!strcmp(SelectedDev, DEVICE_RSS_FRAME_CHANNEL_NAME))
        {
            strcpy(channel_file, RSS_FRAME_CHANNEL_CONFIG_FILE);
            strcpy(recycle, RECYCLE_MODE_ERASE_ALL_FILE);
            strcpy(main_path, MAIN_DOWNLOAD_PATH);
            //rywu20080715 strcpy(sub_path, "/frame_channel");
            strcpy(sub_path, FRAME_CHANNEL_SUB_DOWNLOAD_PATH);//rywu20080715
        }
        else if(!strcmp(SelectedDev, DEVICE_RSS_PICASA_NAME))
        {
            strcpy(channel_file, RSS_PICASA_CONFIG_FILE);
            strcpy(recycle, RECYCLE_MODE_NONE);
            strcpy(main_path, MAIN_DOWNLOAD_PATH);
            strcpy(sub_path, "/picasa");//rywu20080530
        }
        //rywu20080516--		
        
        //rywu20080616++
        //make recovery file
        unlink("/tmp/conf/rss_recover");
        fp = fopen("/tmp/conf/rss_recover", "w+");
        if(fp == 0)
        {
            DBG_MSG("<skydemo>    Huston, can't create recovery file !!!\n");
        }
        else
        {
            sprintf(buf, "WEB_SITE=%s\n", SelectedDev);
            fputs(buf, fp);
            sprintf(buf, "RSS_FEED=%s\n", channel_file);
            fputs(buf, fp);
            sprintf(buf, "MAIN_PATH=%s\n", main_path);
            fputs(buf, fp);
            sprintf(buf, "SUB_PATH=%s\n", sub_path);
            fputs(buf, fp);
            sprintf(buf, "RECYCLE_MODE=%s\n", recycle);
            fputs(buf, fp);
            
            if(!strcmp(SelectedDev, DEVICE_RSS_NAME))//use as Flickr
            {
                sprintf(buf, "DISPLAY_MODE=%d\n", THUMBNAIL_MODE);
            }
            else if(!strcmp(SelectedDev, DEVICE_RSS_FRAME_CHANNEL_NAME))
            {
                sprintf(buf, "DISPLAY_MODE=%d\n", SLIDE_SHOW_MODE);
            }
            else if(!strcmp(SelectedDev, DEVICE_RSS_PICASA_NAME))
            {
                sprintf(buf, "DISPLAY_MODE=%d\n", THUMBNAIL_MODE);
            }
            fputs(buf, fp);
            
            fclose(fp);
            DBG_MSG("<skydemo>    recovery file is done.\n");
        }
        //rywu20080616--
                
        
		//Fork a.out==>rss reader
		pid_rss = fork();
		switch(pid_rss)
		{
			case -1:
				perror("Fork failed!");
				return;
			case 0:
				sleep(1);
				chdir(FLASH_PATH);
				//execl("/bin/rss", "rss", NULL);//==>OK
				//execl("/bin/a.out", "a.out", "/bin/rss.xml", "downloaded.xml", FLASH_PATH, "1", NULL);
				//execl("/bin/a.out", "a.out", "/tmp/conf/channels.xml", "downloaded.xml", FLASH_PATH, "1", NULL);
                DBG_MSG("<skydemo> call RSS in Net_DS_EnterEvent\n");
                execl("/sky/sky_rss", "sky_rss", "-f", channel_file, "-d", main_path, "-s", sub_path, "-r", recycle, NULL);//rywu20080516
				_EXIT;
			default:
			    ELMachines[active_index].Shutdown(0);//rywu20080516
				active_index = RSS_ACTIVE;
				ELMachines[active_index].Init();
				ELMachines[active_index].Display();
				return;
		}
	}
	else 
#endif
    ELMachines[active_index].Shutdown(0);//bk@080626
    if(!strcmp(SelectedDev, DEVICE_NAS_NAME))
	{
		active_index = FLDR_ACTIVE;
	}
#ifdef IP_CAM_MOD
	else if (!strcmp(SelectedDev, DEVICE_IPCAM_NAME))
	{
		active_index = IP_CAM_ACTIVE;
	}
#endif
///080430
#ifdef WEB_APP_MOD
	else if (0
			 #ifdef WEB_APP_WEATHER
			 || !strcmp(SelectedDev, WEBAPP_WEATHER_NAME)
			 #endif
			 #ifdef WEB_APP_NEWS
			 || !strcmp(SelectedDev, WEBAPP_NEWS_NAME)
			 #endif
			 #ifdef WEB_APP_EZPEER
			 || !strcmp(SelectedDev, WEBAPP_EZPEER_NAME)
			 #endif
			)
	{
		active_index = WEB_APP_ACTIVE;
	}
#endif
///

	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
}
//------------------------------------------------------------------------------------------------
void Net_DS_EscEvent()
{
//rywu20080516++
#ifdef SUPPORT_RSS
    DBG_MSG("<skydemo> start to terminate network_thread\n");
	extra_control->network_thread_state = 0;
	pthread_join(extra_control->network_thread, &(extra_control->network_thread_result));
	DBG_MSG("<skydemo> terminating network_thread done\n");
        
    extra_control->ignore_io = 0;
    DBG_MSG("<skydemo> ignore IO <--\n");
#endif
//rywu20080516--
    
	CloseSystem();
	InitSystem(INITSYS_CALL_BY_NORMAL);
}
#endif
///
//------------------------------------------------------------------------------------------------
