#ifndef _EVENT_CALLBACK_HEADER_
#define _EVENT_CALLBACK_HEADER_
#include "skydemo.h"
#include "generalevents.h"
///080504
#ifdef WEB_APP_MOD
#include "webapp.h"
#endif
///
//------------------------------------------------------------------------------------------------
// Function phototype
//------------------------------------------------------------------------------------------------

// Device Selection----------------------------------------------------------------------------------
void InsertItem(char *filename, LIST *List, Uint8 type);
int strcasecmp(const char *s1, const char *s2);
int strverscmp(const char *s1, const char *s2);
Uint8 IsSupportedJPG(char *ext);
Uint8 IsSupportedBMP(char *ext);
Uint8 IsSupportedTIFF(char *ext);
Uint8 IsSupportedAudio(char *ext);
Uint8 IsSupportedVideo(char *ext);
void AddtoList(char *filename, Uint8 type);
void SearchFileNoSorting(char *path, Uint8 type, Uint8 isAbsolutePathReturned, Uint8 strict);
void AddtoStatList(char *dirpath, char *fname, struct stat *st);
int CompareMTimeDescending(const void *e1p, const void *e2p);
int CompareMTimeAscending(const void *e1p, const void *e2p);
int CompareFSizeDescending(const void *e1p, const void *e2p);
int CompareFSizeAscending(const void *e1p, const void *e2p);
int CompareAlphabetDescending(const void *e1p, const void *e2p);
int CompareAlphabetAscending(const void *e1p, const void *e2p);
void SortingByFunction(Uint8 type, Uint8 isAbsolutePathReturned);
void SearchFileStat(char *path, Uint8 strict);
void SearchFileSorting(char *path, Uint8 type, Uint8 isAbsolutePathReturned, Uint8 strict);
void SearchFileByType(char *path, Uint8 type, Uint8 isAbsolutePathReturned);
void SearchFileByTypeStrict(char *path, Uint8 type, Uint8 isAbsolutePathReturned, Uint8 strict);
void SearchFileAllTypes(char *path);
///080521
void MakeIAVList();
void MakeIAVList_Thread();
///
// -------------- cywang for show inprocess msg ----------------------------
void show_process_msg_alarm_handler(int nothing);
void show_process_msg(char *str,COORD pos,unsigned char timesec);
void stop_show_process_msg(void);
// ---------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void LoadBTDeviceList();
void SaveBTDeviceList();
void ForkBTProcesses();
void ScanBTOPushDevices();
#endif
void DS_UpEvent();
void DS_DownEvent();
void DS_LeftEvent();
void DS_RightEvent();
void DS_PlayPauseEvent();
void DS_EnterEvent();
// Media Type--------------------------------------------------------------------------------------
void MT_LeftEvent();
void MT_RightEvent();
void MT_UpEvent();
void MT_DownEvent();
void MT_PlayPauseEvent();
void MT_EnterEvent();
void MT_EscEvent();
// Setup L1/L2/L3----------------------------------------------------------------------------------
//Sint16 ReadFromRTC(Uint8 time);
//void Write2RTC(Uint8 time);
void GetTime(struct tm *tm);
void SetTime(Sint16 year, Sint8 month, Sint8 day, Sint8 hour, Sint8 minute, Sint8 second);
void SaveAutoPwrSetupToRTC();
#if defined(GUI_STYLE_COMTEK)
void SaveCalProgDownload();
void SaveCalAutoPwrOnSetupToRTC(struct tm tm);
#endif
long long GetFlashFreeSize();
///071203
long GetPathFreeSize(char* PATH);
///
///071204
int isWriteProtected(const char *DeviceName);
///
void CopyDefaultUserSetupFile();
void Reset();
int formatFlash();
///080325 knD(L/R)
void SetAudioChannel(Sint8 channel);
///

void SETUP_L1_UpEvent();
void SETUP_L1_DownEvent();
void SETUP_L1_RightEvent();
void SETUP_L1_PlayPauseEvent();
void SETUP_L1_EnterEvent();

void SETUP_L2_UpEvent();
void SETUP_L2_DownEvent();
void SETUP_L2_LeftEvent();
void SETUP_L2_PlayPauseEvent();
void SETUP_L2_EnterEvent();

void SETUP_L3_UpEvent();
void SETUP_L3_DownEvent();
void SETUP_L3_LeftEvent();
void SETUP_L3_RightEvent();
void SETUP_L3_PlayPauseEvent();
void SETUP_L3_EnterEvent();
void SetupToMenuEvent();
// Image------------------------------------------------------------------------------------------
void UpdateIMG();
void I_UpEvent();
void I_DownEvent();
void I_LeftEvent();
void I_RightEvent();
void I_NextEvent();
void I_PrevEvent();
void I_PlayPauseEvent();
void I_EnterEvent();
void I_EscEvent();
// Full Image---------------------------------------------------------------------------------------
void FI_UpEvent();
void FI_DownEvent();
void FI_LeftEvent();
void FI_RightEvent();
void FI_NextEvent();
void FI_PrevEvent();
void FI_StopEvent();
void FI_RotateEvent();
void FI_ZoomEvent();
void FI_EnterEvent();
void FI_EscEvent();
void FI_SwitchResolutionEvent();
// Audio-------------------------------------------------------------------------------------------
extern Uint8 isMusicStopPressed;
void UpdateAUD();
void A_UpEvent();
void A_DownEvent();
void A_LeftEvent();
void A_RightEvent();
void A_NextEvent();
void A_PrevEvent();
void A_PlayPauseEvent();
// Raymond 2008/04/09
void A_ForwardEvent();
void A_BackwardEvent();
//
void A_StopEvent();
void A_EnterEvent();
void A_EscEvent();
// Video-------------------------------------------------------------------------------------------
void UpdateVID();
void V_UpEvent();
void V_DownEvent();
void V_LeftEvent();
void V_RightEvent();
void V_NextEvent();
void V_PrevEvent();
void V_PlayPauseEvent();
void V_EnterEvent();
void V_EscEvent();
// Full Video----------------------------------------------------------------------------------------
void FV_NextEvent();
void FV_PrevEvent();
void FV_LeftEvent();
void FV_RightEvent();
void FV_StopEvent();
void FV_PlayPauseEvent();
void FV_ForwardEvent();
void FV_BackwardEvent();
void FV_EscEvent();
// Slideshow---------------------------------------------------------------------------------------
void SS_UpEvent();
void SS_DownEvent();
void SS_LeftEvent();
void SS_RightEvent();
void SS_StopEvent();
void SS_PlayPauseEvent();
void SS_EscEvent();
// PC Connection-----------------------------------------------------------------------------------
void USB2PC_CONN_EscEvent();
// Confirm Window----------------------------------------------------------------------------------
Uint8 CopyFile(char *dest);
void DeleteFile();
void Confirm_LeftEvent();
void Confirm_RightEvent();
void Confirm_EnterEvent();

///070625
Uint8 CopySelectedFiles(char *dest);
Uint8 DeleteSelectedFiles();
///

// Calendar and Time--------------------------------------------------------------------------------
void KillCalAlarmProcess();
void Cal_UpEvent();
void Cal_DownEvent();
void Cal_LeftEvent();
void Cal_RightEvent();
void Cal_StopEvent();
void Cal_EnterEvent();
void Cal_EscEvent();
void Cal_PlayPuseEvent();
// Folder-------------------------------------------------------------------------------------------
///070604 FolderEvent
void UpdateFLDR();			//s
void FLDR_UpEvent();		//W@
void FLDR_DownEvent();		//U@
void FLDR_LeftEvent();		//^W@hؿ
void FLDR_RightEvent();		//iJ
void FLDR_NextEvent();		//U@
void FLDR_PrevEvent();		//W@
void FLDR_PlayPauseEvent();
void FLDR_EnterEvent();		//iJ
void FLDR_EscEvent();		//X
void FLDR_RepeatEvent();	//ɮ
void FLDR_StopEvent();
void FLDR_SSEvent();
///
// BT-------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void UpdateBTFldrDisplay();	//s ؿ ɮ
void UpdateBTFldrDisplay();	//s Ū޸˸m
void BT_UpEvent();			//W@
void BT_DownEvent();		//U@
void BT_LeftEvent();			//^W@hؿ
void BT_RightEvent();		//iJ
void BT_NextEvent();			//U@
void BT_PrevEvent();			//W@
void BT_PlayPauseEvent();
void BT_EnterEvent();		//iJ
void BT_EscEvent();			//X
void BT_RepeatEvent();		//ɮ
void BT_PrevDvcEvent();
void BT_NextDvcEvent();
void BT_ScanDvcEvent();
void BT_TxEvent();
void BT_StopEvent();
extern COORD BTDvcRegion;
#endif
// FLDR_FI------------------------------------------------------------------------------------------
void FLDR_FI_EscEvent();
void FLDR_FI_SwitchResolutionEvent();
// FLDR_FV------------------------------------------------------------------------------------------
void FLDR_FV_EscEvent();
void FLDR_FV_ZoomEvent();
extern char InAudioChannelsProcess;
//RSS---------------------------------------------------------------------------------------------
#ifdef NET_MOD
//rywu20080516++
#ifdef SUPPORT_RSS
void RSS_EscEvent();
void RSS_UpEvent();
void RSS_DownEvent();
void RSS_LeftEvent();
void RSS_RightEvent();
void RSS_EnterEvent();
void RSS_SlideShow();
void tx_msg_to_rss_client(RSS_SESSION_INFO_ID rss_session, unsigned char message);
void framechannel_thread(RSS_SESSION_INFO_ID rss_session);
void rss_signal_thread(RSS_SESSION_INFO_ID rss_session);//rywu20080616
#endif
//rywu20080516--

///080322
void Net_DS_UpEvent();
void Net_DS_DownEvent();
void Net_DS_LeftEvent();
void Net_DS_RightEvent();
void Net_DS_EnterEvent();
void Net_DS_EscEvent();
///
void DS_RotateEvent();//nelly add 6/23/2008 for wps push button
#endif
//HD Auto CP---------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
char* getTimestamp();
Uint8 CopyFromTo(char *src, char* dest);
void HDAutoCP_LeftEvent();
void HDAutoCP_RightEvent();
void HDAutoCP_EnterEvent();
void HDAutoCP_EscEvent();
#endif
#ifdef IP_CAM_MOD
void IP_CAM_UpEvent();
void IP_CAM_DownEvent();
void IP_CAM_EscEvent();
void IP_CAM_EnterEvent();
void IP_CAM_RepeatEvent();
void IP_CAM_RotateEvent();
FLIST* Build_IP_Cam_List();
void DrawIPCam(IPCAM_DATA ipcam_data[], int nCam);
void CloseIPCam();
void DrawIPCamTag();
#endif

//------------------------------------------------------------------------------------------------
extern Uint32 yuv_idx;
extern char *ConfirmText;
extern struct tm currTime;
#endif
