#ifndef _FB_UTIL_H_
#define _FB_UTIL_H_
//------------------------------------------------------------------------------------------------
#include "pgu_lib.h"
//#include "caption.c"
//#include "font7x14.c"
//#include "taipei16.c"
//#include "iso8859_15_26.c"
#include "color.h"
#include "types.h"

///080212
#include "textutil.h"
///

//------------------------------------------------------------------------------------------------

#define SCALE_SHIFT		16

#define CAPTION_FONT_WIDTH			13
#define CAPTION_FONT_HEIGHT			26
#define CAPTION_FONT_START_CHAR		32

//#define _7x14_FONT_WIDTH				7
//#define _7x14_FONT_HEIGHT			14
//#define _7x14_FONT_START_CHAR		32

///070815
//#define FONT_WIDTH	CAPTION_FONT_WIDTH
//#define FONT_HEIGHT	CAPTION_FONT_HEIGHT
///
//------------------------------------------------------------------------------------------------
typedef struct yuv_frame_t
{
	unsigned char *YBuf;
	unsigned char *UBuf;
	unsigned char *VBuf;
	unsigned short xdim, ydim, format;
} yuv_frame;
//------------------------------------------------------------------------------------------------
/* Flowbee: Software OSD. */
typedef enum
{
	SLIDE_IN_START,
	SLIDE_IN_JPEG,
	SLIDE_IN_TR,
	SLIDE_IN_TR2JPEG,
}SLIDE_INDEX;
//------------------------------------------------------------------------------------------------
typedef enum
{
	IN_VOLUME,
	IN_MUTE,
	IN_START,
}VOLUME_INDEX;
//------------------------------------------------------------------------------------------------
extern unsigned char jpeg_state;
extern unsigned char tr_state;
extern unsigned char slide_state;
extern struct _osd_info osd_info;
//------------------------------------------------------------------------------------------------
int InitPGU();
void ClosePGU();
void DuplicateBitmap(Uint16 *dest, Uint16 *src, Uint16 x, Uint16 y, Uint16 w, Uint16 h);
void DuplicateBlockBitmap(Uint16 *dest, Uint16 *src, Uint16 x, Uint16 y, Uint16 w, Uint16 h);
///070926
void BlendBlock(Uint8 *destY, Uint8 *destU, Uint8 *destV, Uint16 destyuvwidth, Uint16 destyuvx, Uint16 destyuvy,
				Uint16 *srcRGB, Uint16 srcrgbwidth, Uint16 srcrgbx, Uint16 srcrgby,
				Uint8 *srcY, Uint8 *srcU, Uint8 *srcV, Uint16 srcyuvwidth, Uint16 srcyuvx, Uint16 srcyuvy,
				Uint16 w, Uint16 h);
///
///070920
void CopyBlockYUV420(Uint8 *destY, Uint8 *destU, Uint8 *destV, Uint16 destwidth, Uint16 destx, Uint16 desty, 
						Uint8 *srcY, Uint8 *srcU, Uint8 *srcV, Uint16 srcwidth, Uint16 srcx, Uint16 srcy, Uint16 w, Uint16 h);
///
void CopyBlockBitmap(Uint16 *dest, Uint16 aligndest, Uint16 xdest, Uint16 ydest, Uint16 *src, Uint16 alignsrc, Uint16 xsrc, Uint16 ysrc, Uint16 w, Uint16 h);
void DrawRectBitmap(Uint16 *dest, Uint16 x, Uint16 y, Uint16 w, Uint16 h, Uint16 color);
void DrawShapeBitmap(Uint16 *dest, Uint16 *src, Uint16 x, Uint16 y, Uint16 w, Uint16 h);

//void TextOutEnglishCaption(Uint16 *dest, Uint16 x, Uint16 y, char *str, Uint16 color);
//void TextOutEnglish7x14(unsigned short *RGBFrame, int x, int y, char* str, unsigned short color);
//void TextOutBig5(unsigned short *RGBFrame, int x, int y, char* str, unsigned short color);
void DrawBorder(Uint16 *dest, Uint16 xL, Uint16 xR, Uint16 yT, Uint16 yB, Uint16 borderThick, Uint16 color); 
//void TextOutISO_8859_15(unsigned short *RGBFrame, int x, int y, char* str, unsigned short color);

///080417 ebY
void DrawArrowHead(Uint16 *dest, Uint16 destwidth, Uint16 x, Uint16 y, Uint16 w, Uint16 h, Uint16 direction, Uint16 color);
///
void SwitchYUV(Uint32 bufno);
void SwitchRGB(Uint32 bufno);

unsigned int GetYUVPixel(yuv_frame *frame, unsigned short x, unsigned short y);
void SetYUVPixel(yuv_frame *frame, unsigned short x, unsigned short y, unsigned int pixel);
void ClearYUVBlank(yuv_frame *frame, unsigned short x, unsigned short y, unsigned short len);
unsigned int ScaleYUV(unsigned int col0, unsigned int col1, int part, int all, int div);
//void RotateYUV(int src, int dst, int degree);
//void InitZoomPanRotate();
//void GetNextZoomInBase();
//void CheckPanBound();
//void Pan();
void ZoomImage();
void PanUp();
void PanDown();
void PanLeft();
void PanRight();
void RotateImage();
int TurnBacklightPGU(int on_off);
void SetMSB(Uint16 *rgbBuf, Uint16 bufwidth, Uint32 x, Uint32 y, Uint32 width, Uint32 height, Uint8 on, Uint16 filtoutcolor);
void SetRGBuffMSB(Uint8 bufno, Uint8 *srcbuff, Uint8 on, Uint32 x, Uint32 y, Uint32 w, Uint32 h, Uint16 filtoutcolor);
void SetRGBuffBlockMSB(Uint8 bufno, Uint8 *srcbuff, Uint8 on, Uint32 x, Uint32 y, Uint32 w, Uint32 h, Uint16 filtoutcolor);
void ConvertThumbnail2YUV(Uint8 *rgbbuff, Uint8 yuvno, Uint8 n, Uint8 w, Uint8 h);

///070913
void RGBShape2YUV(Uint8 *rgbbuff, Uint8 yuvno, Uint16 x, Uint16 y, Uint16 w, Uint16 h);
///

void RGBlock2YUVBlock(Uint8 *rgbbuff, Uint8 yuvno, Uint16 x, Uint16 y, Uint16 w, Uint16 h);
void RGBlock2YUVBlock_Raster(Uint8 *rgbbuff, Uint8 yuvno, Uint16 x, Uint16 y, Uint16 w, Uint16 h);
void RGB2YUV(Uint8 rgbno, Uint8 yuvno);
int osd_parser(void);
void clear_osd_info(void);
int GetDisplayIndex(void);

#ifdef USE_DESC_TV
int SetDisplayNTSC(unsigned long pguOnOff);
int SetDisplayPAL(unsigned long pguOnOff);
int SetDisplayHDTV(unsigned long pguOnOff);
int SetDisplayLCD(unsigned long pguOnOff);
int SetDisplayInterface(unsigned long _if);
#endif
//------------------------------------------------------------------------------------------------
extern Uint32 yuv_idx;
extern Uint16 OUTPUT_XRES;
extern Uint16 OUTPUT_YRES;
extern Uint32 RESOLUTION_SIZE;
extern Uint32 RGB_FRAMEBUFF_SIZE;
extern Uint32 RGB_VOLBUFF_SIZE;
extern Uint8 *framebuf, *RGB0, *RGB1;
extern int degree;
extern float zoom;

///070721 nYUV
//bool bCalculateYUVTable;
//Uint8 YUVTable[3][32][32][32];
//extern Uint8 ****YUVTable;
///

#endif
