#include "events.h"
//------------------------------------------------------------------------------------------------
extern int isExifAvailable;
//------------------------------------------------------------------------------------------------
// Full Image Callbacks																				    
//------------------------------------------------------------------------------------------------
void FI_UpEvent()
{
	if(zoom <= 1)
	{
		FI_PrevEvent();
	}
	else
	{
		if(!isExifAvailable)
		{
			printf("No enough image info to pan!\n");
			return;
		}
		
		switch(degree)
		{
			case 0:
				PanUp();
				break;
			case 1:
				PanLeft();
				break;
			case 2:
				PanDown();
				break;
			case 3:
				PanRight();
				break;
		}
		/* Flowbee. */
		osd_parser();
	}
}
//------------------------------------------------------------------------------------------------
void FI_DownEvent()
{
	if(zoom <= 1)
	{
		FI_NextEvent();
	}
	else
	{
		if(!isExifAvailable)
		{
			printf("No enough image info to pan!\n");
			return;
		}
		
		switch(degree)
		{
			case 0:
				PanDown();
				break;
			case 1:
				PanRight();
				break;
			case 2:
				PanUp();
				break;
			case 3:
				PanLeft();
				break;
		}
		/* Flowbee. */
		osd_parser();
	}
}
//------------------------------------------------------------------------------------------------
void FI_LeftEvent()
{
	if(zoom <= 1)
	{
		FI_PrevEvent();
	}
	else
	{
		if(!isExifAvailable)
		{
			printf("No enough image info to pan!\n");
			return;
		}
		
		switch(degree)
		{
			case 0:
				PanLeft();
				break;
			case 1:
				PanDown();
				break;
			case 2:
				PanRight();
				break;
			case 3:
				PanUp();
				break;
		}
		/* Flowbee. */
		osd_parser();
	}
}
//------------------------------------------------------------------------------------------------
void FI_RightEvent()
{
	if(zoom <= 1)
	{
		FI_NextEvent();
	}
	else
	{
		if(!isExifAvailable)
		{
			printf("No enough image info to pan!\n");
			return;
		}
		
		switch(degree)
		{
			case 0:
				PanRight();
				break;
			case 1:
				PanUp();
				break;
			case 2:
				PanLeft();
				break;
			case 3:
				PanDown();
				break;
		}
		/* Flowbee. */
		osd_parser();
	}
}
//------------------------------------------------------------------------------------------------
void FI_NextEvent()
{
	FRAME *elmf;
	
	elmf = &ELMachines[I_ACTIVE].frame;
	elmf->active_icon_index += 1;
	if(elmf->active_icon_index == ImgCount)
	{
		elmf->active_icon_index = 0;
		elmf->CurrImgListPos = ImageList->next;
	}
	else
	{
		elmf->CurrImgListPos = elmf->CurrImgListPos->next;
	}
	
	degree = 0;
	zoom = 0.0;
	
	FImgDisplay();
}
//------------------------------------------------------------------------------------------------
void FI_PrevEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;
	
	elmf = &ELMachines[I_ACTIVE].frame;
	elmf->active_icon_index -= 1;
	if(elmf->active_icon_index == -1)
	{
		elmf->active_icon_index = ImgCount - 1;
		tmplist = ImageList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
	}
	else
	{
		elmf->CurrImgListPos = elmf->CurrImgListPos->prev;
	}
	
	degree = 0;
	zoom = 0.0;
	
	FImgDisplay();
}
//------------------------------------------------------------------------------------------------
void FI_StopEvent()
{
	ELMachines[active_index].Shutdown(0);
	active_index = I_ACTIVE;
	
	degree = 0;
	zoom = 0.0;
	
	//modified by bk@070407 - modified for mute, volume situation
	//ImgDisplay();
	ELMachines[active_index].Display();
}
//------------------------------------------------------------------------------------------------
void FI_RotateEvent()
{
	if(!isExifAvailable)
	{
		printf("No enough image info to pan!\n");
		return;
	}
	
	degree = (degree + 1) % 4;
	RotateImage();
	pgu_switch_to_buffer(yuv_idx);
	
	//SwitchYUV(yuv_idx);
	yuv_idx = (yuv_idx == 1)? 0 : 1;
	osd_parser();
}
//------------------------------------------------------------------------------------------------
void FI_ZoomEvent()
{
	if(!isExifAvailable)
	{
		printf("No enough image info to pan!\n");
		return;
	}
	
	ZoomImage();
	pgu_switch_to_buffer(yuv_idx);
	
	//SwitchYUV(yuv_idx);
	yuv_idx = (yuv_idx == 1)? 0 : 1;
	/* Flowbee. */
	osd_parser();
}
//------------------------------------------------------------------------------------------------
//added by xenia
void FI_EnterEvent()
{
	ELMachines[active_index].Shutdown(0);
	active_index = FI_ACTIVE;
	
	degree = 0;
	zoom = 0.0;
	
	//FImgDisplay();
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
}
//------------------------------------------------------------------------------------------------
void FI_EscEvent()
{
	FI_StopEvent();
}
//------------------------------------------------------------------------------------------------
void FI_SwitchResolutionEvent()
{
#ifdef USE_DESC_LCD
	return;
#else
  #ifndef TV_FI_SWITCH_RESOLUTION
	return;
  #endif
#endif
	
	//following case is under defined USE_DESC_TV && TV_FI_SWITCH_RESOLUTION
	
	//close info
	if(isInfoPressed)
		InfoEvent();
	
	//now is 1080i
	if(currFIDspMode == DISP_HDTV)
	{
#ifdef TV_FI_SWITCH_RESOLUTION_PAL
		currFIDspMode = DISP_PAL;
#else
		currFIDspMode = DISP_NTSC;
#endif
	}
	//now is 480i
	else if(currFIDspMode == DISP_NTSC)
		currFIDspMode = DISP_HDTV;
	//now is 576i (PAL)
	else if(currFIDspMode == DISP_PAL)
		currFIDspMode = DISP_HDTV;
	//unkown mode
	else
		return;
	
	pgu_set_display_index(currFIDspMode, 1);
	InitDisplayParameter(currFIDspMode);
	
	degree = 0;
	zoom = 0.0;
	
	ELMachines[active_index].Display();
}
