#include "events.h"
#include "parser.h"
Uint8 isVideoPaused = 0;
//------------------------------------------------------------------------------------------------
// Full Video Callbacks																				    
//------------------------------------------------------------------------------------------------
void FV_NextEvent()
{
	FRAME *elmf;
	char s[LEN_XL];
	FileInfo finfo;
	Sint8 isPlayable = -1;
	
	elmf = &ELMachines[V_ACTIVE].frame;
	isVideoPaused = FALSE;

	//move CurrVidList to next
	elmf->active_icon_index += 1;
	if(elmf->active_icon_index == VidCount)
	{
		elmf->active_icon_index = 0;
		elmf->CurrVidListPos = VideoList->next;
	}
	else
	{
		elmf->CurrVidListPos = elmf->CurrVidListPos->next;
	}
	
	KillVideoProcess();//bk @ 071225 - mantis 355
	switch(setup->vid_rpt_idx)
	{
		//bFV_ACTIVEANۦܤ֦@videoi
		case SETUP_AV_REPEAT_ONELOOP:
			while(1)
			{
				GetPath(s);
				strcat(s, elmf->CurrVidListPos->fname);
				isPlayable = MediaParser(s, &finfo);
				
				if(isPlayable == PlayableVideo)
					break;
				else
				{
					//check if end of the list
					if(elmf->active_icon_index < VidCount - 1)
					{
						elmf->active_icon_index += 1;
						elmf->CurrVidListPos = elmf->CurrVidListPos->next;
					}
					//current at end of list
					else
						break;
				}
			}
			break;
		case SETUP_AV_REPEAT_CONTI:
			while(1)
			{
				GetPath(s);
				strcat(s, elmf->CurrVidListPos->fname);
				isPlayable = MediaParser(s, &finfo);
				
				if(isPlayable == PlayableVideo)
					break;
				else
				{
					elmf->active_icon_index += 1;
					if(elmf->active_icon_index == VidCount)
					{
						elmf->active_icon_index = 0;
						elmf->CurrVidListPos = VideoList->next;
					}
					else
						elmf->CurrVidListPos = elmf->CurrVidListPos->next;
				}
			}
			break;
		case SETUP_AV_REPEAT_OFF:
		case SETUP_AV_REPEAT_SINGLE:
			GetPath(s);
			strcat(s, elmf->CurrVidListPos->fname);
			isPlayable = MediaParser(s, &finfo);
			break;
		default:
			break;
	}

	if(isPlayable == PlayableVideo)
		FVidDisplay();
	else
		FV_StopEvent();
	
//	FRAME *elmf;
//	char s[LEN_XL];
//	FileInfo finfo;
//	
//	elmf = &ELMachines[V_ACTIVE].frame;
//	elmf->active_icon_index += 1;
//	if(elmf->active_icon_index == VidCount)
//	{
//		elmf->active_icon_index = 0;
//		elmf->CurrVidListPos = VideoList->next;
//	}
//	else
//	{
//		elmf->CurrVidListPos = elmf->CurrVidListPos->next;
//	}
//	
//	isVideoPaused = FALSE;
//	GetPath(s);
//	strcat(s, elmf->CurrVidListPos->fname);
//	if(MediaParser(s, &finfo) == PlayableVideo)
//		FVidDisplay();
//	//else
//	//	PRINTF("\n%s is not supported!\n", s);
	
}
//------------------------------------------------------------------------------------------------
void FV_PrevEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;
	char s[LEN_XL];
	FileInfo finfo;
	
	elmf = &ELMachines[V_ACTIVE].frame;
	elmf->active_icon_index -= 1;
	if(elmf->active_icon_index == -1)
	{
		elmf->active_icon_index = VidCount - 1;
		tmplist = VideoList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
	}
	else
	{
		elmf->CurrVidListPos = elmf->CurrVidListPos->prev;
	}

	KillVideoProcess();//bk @ 071225 - mantis 355
	isVideoPaused = FALSE;
	GetPath(s);
	strcat(s, elmf->CurrVidListPos->fname);
	if(MediaParser(s, &finfo) == PlayableVideo)
		FVidDisplay();//pre playing video process will be killed
	else
	{
		KillVideoProcess();
		isVidPrcsForked = FALSE;

		switch(setup->vid_rpt_idx)
		{
			//back to V_ACTIVE
			case SETUP_AV_REPEAT_OFF:
			case SETUP_AV_REPEAT_SINGLE:
				FV_StopEvent();
				break;
			//do nothing
			case SETUP_AV_REPEAT_ONELOOP:
			case SETUP_AV_REPEAT_CONTI:
				isVidPrcsForked = TRUE;//HandleVideo() flag
				break;
			//back to V_ACTIVE
			default:
				FV_StopEvent();
				break;
		}
	}
}
//------------------------------------------------------------------------------------------------
void FV_LeftEvent()
{
	FV_PrevEvent();
}
//------------------------------------------------------------------------------------------------
void FV_RightEvent()
{
	FV_NextEvent();
}
//------------------------------------------------------------------------------------------------
void FV_StopEvent()
{
#ifdef SET_VID_SKY_PRIO
	SkyPrio = getpriority(PRIO_PROCESS, 0);
  	setpriority(PRIO_PROCESS, 0, SkyPrio - VID_SKY_PRIO_LVL);
#endif
	ELMachines[active_index].Shutdown(0);
	active_index = V_ACTIVE;
	/* Flowbee. */
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);	
	VidDisplay();
}
//------------------------------------------------------------------------------------------------
void FV_PlayPauseEvent()
{
	set_ir_value((unsigned long)0x70);
	isVideoPaused = (isVideoPaused + 1) % 2;	
	//PRINTF("isVideoPaused: %d\n", isVideoPaused);
}
//------------------------------------------------------------------------------------------------
void FV_ForwardEvent()
{
	//set_ir_value((unsigned long)0x435B1b);//barry @ 071023
	set_ir_value((unsigned long)0x7D);
	isVideoPaused = FALSE;
}
//------------------------------------------------------------------------------------------------
void FV_BackwardEvent()
{
	//set_ir_value((unsigned long)0x445B1b);//barry @ 071023
	set_ir_value((unsigned long)0x7B);
	isVideoPaused = FALSE;
}
//------------------------------------------------------------------------------------------------
void FV_EscEvent()
{
	FV_StopEvent();
}
