#include "events.h"

//------------------------------------------------------------------------------------------------
// event util function
//------------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
char* getTimestamp()
{
	static char OutBuf[LEN_L] = {0};
	time_t t;
	struct tm tm;
	
	time(&t);
	memcpy(&tm, localtime(&t), sizeof(tm));
	sprintf(OutBuf, "%04d%02d%02d-%02d%02d%02d", 
		tm.tm_year+1900, tm.tm_mon+1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
	
	return OutBuf;
}

Uint8 CopyFromTo(char *src, char* dest)
{
	char strCmd[LEN_XL] = {0};
	
	//T{source
	if (access(src, R_OK) != 0)
	{
		MSG("access copy source error!");
		return FALSE;
	}
	
	//
	/*
	sprintf(strCmd, "/bin/cp -rf \'%s/.\' \'%s\'", src, DestDirName);
	system(strCmd);
	*/
	pid_hd_cp = fork();
	switch(pid_hd_cp)
	{
		case -1:
			perror("Fork to copy Files Fail!\n");
			DMSG("Fork to copy Files Fail!\n");
			return FALSE;
		case 0://child process
			sprintf(strCmd, "%s/.", src);
			execl("/bin/cp", "cp", "-rf", strCmd, dest, NULL);
			_EXIT;
		default://parent process
			DMSG("Fork to copy Files success!");
			break;
	}
	
	return TRUE;
}
//------------------------------------------------------------------------------------------------
// key events
//------------------------------------------------------------------------------------------------
void HDAutoCP_LeftEvent()
{
	if(StsOfCpData2HD != 0)
		return;
	
	userSelection = (userSelection + 1) % 2;
	DrawHDAutoCPSelectionFocus();
}
//------------------------------------------------------------------------------------------------
void HDAutoCP_RightEvent()
{
	HDAutoCP_LeftEvent();
}
//------------------------------------------------------------------------------------------------
void HDAutoCP_EnterEvent()
{
	FRAME *elmf;
	Uint16 *dest = (Uint16*)RGB1, FONT_HEIGHT = 26;
	Uint16  cx1 = 0, cy1 = 0, cx2 = 0, cy2 = 0, cx3 = 0, cy3 = 0, w = 0;
	long long filesize = 0L;
	char strCmd[LEN_XL] = {0}, DestDirName[LEN_XL] = {0};
	FILE *fp = NULL;
	
	if(userSelection == 1)//yes is selected
	{
		//init
		elmf = &ELMachines[active_index].frame;
		if (g_pFontDB_Local)
			FONT_HEIGHT = g_pFontDB_Local->FontSize;
		//
		StsOfCpData2HD = 1;
		
		//pos
		cx1 =  updateRegion.x + (updateRegion.width >> 1);
		cy1 = updateRegion.y; 
		cx2 = updateRegion.x + (updateRegion.width >> 1);
		cy2 = cy1 + FONT_HEIGHT; 
		cx3 = cx1;
		cy3 = cy2 + FONT_HEIGHT;
		w = GetFontStringWidth(g_pFontDB_Local, FrameText[setup->Language][45]);
		
		//erase selection
		DuplicateBlockBitmap(dest, (Uint16*)elmf->bkgrdbuff, updateRegion.x, updateRegion.y, updateRegion.width, FONT_HEIGHT << 1);

		//msg
		FontTextOutFormat(g_pFontDB_Local, dest, cx2, cy2, FrameText[setup->Language][44], BLUE_1555, DT_CENTER);
		FontTextOutFormat(g_pFontDB_Local, dest, cx3, cy3, FrameText[setup->Language][45], RED_1555, DT_CENTER);
		RGBlock2YUVBlock((Uint8*)dest, 1,( OUTPUT_XRES - w) >> 1, cy2 , w, updateRegion.height << 1);
		
		//ˬdCARDŶ
		sprintf(strCmd, "du -sk \'%s\'", inDvcPath);
		if ((fp = popen(strCmd, "r")) == NULL)
		{
			MSG("get source size error!");
			FontTextOutFormat(g_pFontDB_Local, dest, cx1, cy1, "Copy Fail!", RED_1555, DT_CENTER);
		}else
		{
			fscanf(fp, "%d", &filesize);
			pclose(fp);
			sizeOfCard = filesize;
		}
		
		//not enough space
		if (sizeOfCard > freeSizeOfHD)//Ŷ
		{
			MSG("Not enough free space to copy!");
			FontTextOutFormat(g_pFontDB_Local, dest, cx1, cy1, "Not enough space!", RED_1555, DT_CENTER);
			StsOfCpData2HD = -1;
		}
		//copy
		else
		{
			//}ؿ: DestDirName\timeststamp
			sprintf(DestDirName, "%s/%s/%s", HD_PATH, HD_AUTOCP_ROOT_NAME, getTimestamp());
			sprintf(strCmd, "mkdir -p \'%s\'", DestDirName);
			system(strCmd);
			
			DPRINTF("copy from \'%s\' to \'%s\'\n", inDvcPath, DestDirName);
			if(CopyFromTo(inDvcPath, DestDirName))
				FontTextOutFormat(g_pFontDB_Local, dest, cx1, cy1, "0%", RED_1555, DT_CENTER);
			else
				FontTextOutFormat(g_pFontDB_Local, dest, cx1, cy1, "Copy Fail!", RED_1555, DT_CENTER);
		}
		
		RGBlock2YUVBlock((Uint8*)dest, 1, updateRegion.x, updateRegion.y , updateRegion.width, updateRegion.height);
	}
	else
	{
		ELMachines[active_index].Shutdown(0);
		active_index = prev_active_index;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}
//------------------------------------------------------------------------------------------------
void HDAutoCP_EscEvent()
{
	if(StsOfCpData2HD != 0)//functioned only when copy finished or copying
	{
		//shutdown the machine
		ELMachines[active_index].Shutdown(0);
		active_index = prev_active_index;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}
#endif

