#include "events.h"
//------------------------------------------------------------------------------------------------
void UpdateIMG()
{
	FRAME *elmf;
	int PrevFrameNO, CurrFrameNO;

	elmf = &ELMachines[active_index].frame;
	
	PrevFrameNO = elmf->active_frame_index;
	CurrFrameNO = elmf->active_frame_index = elmf->active_icon_index/ICON_NUM_PER_FRAME;
	
	if(PrevFrameNO == CurrFrameNO)
		DrawFocusedICON(RGB1, 1);
	else
		ImgDisplay();
}
//------------------------------------------------------------------------------------------------
// Image	 Callbacks																				    
//------------------------------------------------------------------------------------------------
void I_UpEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;
		
	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);
	elmf->active_icon_index -= ICON_NUM_PER_ROW;
	CurrPhotoIdx4SSCal = elmf->active_icon_index;
	//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);
	
	if(elmf->active_icon_index < 0)
	{
		if(ImgCount % ICON_NUM_PER_FRAME > 0)
			elmf->active_icon_index += ((int)(ImgCount / ICON_NUM_PER_ROW) + 1) * ICON_NUM_PER_ROW;
		else
			elmf->active_icon_index += ((int)(ImgCount / ICON_NUM_PER_ROW)) * ICON_NUM_PER_ROW;
		
		if(elmf->active_icon_index > ImgCount - 1)
		{
			if(ImgCount % ICON_NUM_PER_FRAME < ICON_NUM_PER_ROW)
				elmf->active_icon_index = ImgCount - 1;
			else
				elmf->active_icon_index = elmf->active_icon_index - ICON_NUM_PER_ROW;
		}
		CurrPhotoIdx4SSCal = elmf->active_icon_index;
		//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);

		tmplist = ImageList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
		ImgDisplay();
	}
	else
	{
		tmplist = elmf->CurrImgListPos;
		while(tmplist != NULL && i < ICON_NUM_PER_ROW)
		{
			tmplist = tmplist->prev;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
		UpdateIMG();
	}
}
//------------------------------------------------------------------------------------------------
void I_DownEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;
		
	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);
	elmf->active_icon_index += ICON_NUM_PER_ROW;
	CurrPhotoIdx4SSCal = elmf->active_icon_index;
	//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);

	if(elmf->active_icon_index > ImgCount - 1)
	{
		if(0 < (ImgCount % ICON_NUM_PER_FRAME) && (ImgCount % ICON_NUM_PER_FRAME) < ICON_NUM_PER_ROW)//only one row at the last frame
		{
			if(elmf->active_icon_index % ICON_NUM_PER_FRAME < ICON_NUM_PER_ROW)
				elmf->active_icon_index = ImgCount - 1;
			else
				elmf->active_icon_index %= ICON_NUM_PER_ROW;
		}else
			elmf->active_icon_index %= ICON_NUM_PER_ROW;

		CurrPhotoIdx4SSCal = elmf->active_icon_index;
		//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);
		
		tmplist = ImageList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
		ImgDisplay();
	}
	else
	{
		tmplist = elmf->CurrImgListPos;
		while(tmplist != NULL && i < ICON_NUM_PER_ROW)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
		UpdateIMG();
	}
}
//------------------------------------------------------------------------------------------------
void I_LeftEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;

	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);	
	elmf->active_icon_index -= 1;
	CurrPhotoIdx4SSCal = elmf->active_icon_index;
	//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);
	
	if(elmf->active_icon_index == -1)
	{
		elmf->active_icon_index += ImgCount;
		CurrPhotoIdx4SSCal = elmf->active_icon_index;
		//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);
		
		tmplist = ImageList;
		while(tmplist != NULL && i < ImgCount)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
		ImgDisplay();
	}
	else
	{
		elmf->CurrImgListPos = elmf->CurrImgListPos->prev;
		UpdateIMG();
	}
}
//------------------------------------------------------------------------------------------------
void I_RightEvent()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);	
	elmf->active_icon_index += 1;
	CurrPhotoIdx4SSCal = elmf->active_icon_index;
	//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);

	if(elmf->active_icon_index == ImgCount)
	{
		elmf->active_icon_index = 0;
		CurrPhotoIdx4SSCal = elmf->active_icon_index;
		//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);

		elmf->CurrImgListPos = ImageList->next;
		ImgDisplay();
	}
	else
	{
		elmf->CurrImgListPos = elmf->CurrImgListPos->next;
		UpdateIMG();
	}
}
//------------------------------------------------------------------------------------------------
void I_NextEvent()
{
	FRAME *elmf;
	int ICONum, MoveStep;
	LIST *tmplist;
	Uint32 i = 0;
	
	elmf = &ELMachines[active_index].frame;
	ICONum = ICON_NUM_PER_FRAME;
	MoveStep = ICONum - (elmf->active_icon_index % ICONum);
	elmf->active_icon_index = elmf->active_icon_index + MoveStep;
	CurrPhotoIdx4SSCal = elmf->active_icon_index;
	//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);

	if(elmf->active_icon_index > (ImgCount - 1))
	{
		elmf->active_icon_index = 0;
		CurrPhotoIdx4SSCal = elmf->active_icon_index;
		//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);
		elmf->CurrImgListPos = ImageList->next;
	}
	else
	{
		tmplist = elmf->CurrImgListPos;
		while(tmplist != NULL && i < MoveStep)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
	}
	ImgDisplay();
}
//------------------------------------------------------------------------------------------------
void I_PrevEvent()
{
	FRAME *elmf;
	int ICONum, MoveStep;
	LIST *tmplist;
	Uint32 i = 0;
	
	elmf = &ELMachines[active_index].frame;
	ICONum = ICON_NUM_PER_FRAME;
	MoveStep = ICONum + (elmf->active_icon_index % ICONum);
	elmf->active_icon_index = elmf->active_icon_index - MoveStep;
	CurrPhotoIdx4SSCal = elmf->active_icon_index;
	//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);

	if(elmf->active_icon_index < 0)
	{
		if((ImgCount % ICONum) == 0)
			elmf->active_icon_index = ImgCount - ICONum;
		else
			elmf->active_icon_index = ImgCount - (ImgCount % ICONum);

		CurrPhotoIdx4SSCal = elmf->active_icon_index;
		//PRINTF("CurrPhotoIdx4SSCal = %d\n", CurrPhotoIdx4SSCal);
			
		tmplist = ImageList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
	}
	else
	{
		tmplist = elmf->CurrImgListPos;
		while(tmplist != NULL && i < MoveStep)
		{
			tmplist = tmplist->prev;
			i++;
		}
		elmf->CurrImgListPos = tmplist;
	}
	ImgDisplay();
}
//------------------------------------------------------------------------------------------------
void I_PlayPauseEvent()
{
	I_EnterEvent();
}
//------------------------------------------------------------------------------------------------
void I_EnterEvent()
{
	active_index = FI_ACTIVE;
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
}
//------------------------------------------------------------------------------------------------
void I_EscEvent()
{
	ELMachines[active_index].Shutdown(0);
	active_index = MT_ACTIVE;
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
}
