#include "types.h"

#ifdef IP_CAM_MOD
#include "events.h"

#define URL_PLAY_AP			"urlplay"
#define URL_PLAY_AP_PATH	"/sky/urlplay"

//------------------------------------------------------------------------------------------------
void IP_CAM_UpEvent()
{
	if (isIPCamFullView) return;
	CloseIPCam();
    FLDR_UpEvent();
}
//------------------------------------------------------------------------------------------------
void IP_CAM_DownEvent()
{
	if (isIPCamFullView) return;
	CloseIPCam();
	FLDR_DownEvent();
}
//------------------------------------------------------------------------------------------------
void IP_CAM_EscEvent()
{
	if (isIPCamFullView)
	{
		CloseIPCam();
		isIPCamFullView = FALSE;
		IPCamDisplay();
	}
	else
	{
		///080516 ^NetDS
		ELMachines[active_index].Shutdown(0);
		active_index = NET_DS_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
		/*
		CloseSystem();
		InitSystem();
		*/
		///
	}
}
//------------------------------------------------------------------------------------------------
void IP_CAM_EnterEvent()
{
	if (isIPCamFullView) return;

	if (FolderList)
	{
		CloseIPCam();
		isIPCamFullView = TRUE;
		IPCamDisplay();
	}
}
//------------------------------------------------------------------------------------------------
void IP_CAM_RepeatEvent()
{
	if (isIPCamFullView) return;

	if (FolderList)
	{
		//̦he\MAX_IPCAM_NUMcam
		if (0 == (CurrFldrListPos->attribute & Mask_IsChecked))
		{
			if (nIPCamSelected >= MAX_IPCAM_NUM) return;
			nIPCamSelected++;
		}
		else	//
		{
			nIPCamSelected--;
		}

		/*
		//̦he\4cam
		if (0 == (CurrFldrListPos->attribute & Mask_IsChecked))
		{
			int nSelect = 0;
			FLIST *pTempList = FolderList_GetHeadPos(FolderList);
			while (pTempList)
			{
				if (pTempList->attribute & Mask_IsChecked)
				{
					if (++nSelect > MAX_IPCAM_NUM) return;
				}
				pTempList = pTempList->next;
			}
		}
		*/
		FLDR_RepeatEvent();

		//ܽs
		DrawIPCamTag();
	}
}
//------------------------------------------------------------------------------------------------
void IP_CAM_RotateEvent()
{
	if (isIPCamFullView) return;
	CloseIPCam();
	FolderList_Free(&FolderList);
	FolderList = Build_IP_Cam_List();

	nIPCamSelected = 0;
	DrawIPCamTag();

	UpdateFLDR();
}
//------------------------------------------------------------------------------------------------
FLIST* Build_IP_Cam_List()
{
	char searchipcam[] = "/sky/SearchIPCam";
	FLIST *IPList = NULL;
	FILE *fid = NULL;
	char buf[LEN_XL] = {0};
	int n = 0, ipnum[4] = {0};

	if ((fid = popen(searchipcam, "r")) != NULL)
	{
		while (!feof(fid))
		{
			fgets(buf, LEN_XL, fid);
			n = sscanf(buf, "%d.%d.%d.%d", &ipnum[0], &ipnum[1], &ipnum[2], &ipnum[3]);
			if (  n == 4
				&&
				  ipnum[0]>=0 && ipnum[0]<256
				&&
				  ipnum[1]>=0 && ipnum[1]<256
				&&
				  ipnum[2]>=0 && ipnum[2]<256
				&&
				  ipnum[3]>=0 && ipnum[3]<256
			   )
			{
				sprintf(buf, "%03d.%03d.%03d.%03d", ipnum[0], ipnum[1], ipnum[2], ipnum[3]);
				//Ūsip~n(P̫@ipP)
				if (!IPList || strcmp(buf, IPList->prev->fname))
				{
					FolderList_AddTail(&IPList, buf, 0);
				}
			}
		}
		pclose(fid);
	}

	return IPList;
}
//------------------------------------------------------------------------------------------------
void DrawIPCam(IPCAM_DATA ipcam_data[], int nCam)
{
	if (nCam > MAX_IPCAM_NUM || nCam <= 0) return;

	//wҰʪurl_play
	CloseIPCam();

	char cmdbuf[(MAX_IPCAM_NUM*6+2) * LEN_L] = {0};
	char* argv[MAX_IPCAM_NUM*6+2] = {0};
	int i, argn;
	for (i=0; i<MAX_IPCAM_NUM*6+2; i++)
	{
		argv[i] = cmdbuf + i*LEN_L;
	}

	argn = 0;
	sprintf(argv[argn++], URL_PLAY_AP);
	for (i=0; i<nCam; i++)
	{
		sprintf(argv[argn++], "-ip%d", i);
		sprintf(argv[argn++], "%s", ipcam_data[i].IP);
		sprintf(argv[argn++], "-id%d", i);
		sprintf(argv[argn++], "%s:%s", ipcam_data[i].ID, ipcam_data[i].PW);
		sprintf(argv[argn++], "-pos%d", i);
		sprintf(argv[argn++], "%d,%d,%d,%d",
				ipcam_data[i].POS.x, ipcam_data[i].POS.y,
				ipcam_data[i].POS.width, ipcam_data[i].POS.height);		
	}
	argv[argn++] = NULL;

	//Ұurl_play
	pid_url_play = fork();
	switch(pid_url_play)
	{
	case -1:
		perror("Fork failed!");
		DMSG("Fork to url_play Fail");
		break;
	case 0:
		execv(URL_PLAY_AP_PATH, argv);
		_EXIT;
	default:
		isUrlPlayForked = TRUE;
		break;
	}	
}
//------------------------------------------------------------------------------------------------
void CloseIPCam()
{
	//wҰʪurl_play
	if (isUrlPlayForked && !waitpid(pid_url_play, &sts_url_play, WNOHANG))
	{
		KILL(pid_url_play);

		while(waitpid(pid_url_play, &sts_url_play, 0) == 0);
		isUrlPlayForked = FALSE;
	}
}
//------------------------------------------------------------------------------------------------
void DrawIPCamTag()
{
	int len;
	char tag[LEN_L] = {0};
	FRAME *elmf = &ELMachines[active_index].frame;

	sprintf(tag, "%02d/%02d", nIPCamSelected, MAX_IPCAM_NUM);
	len = GetFontStringWidth(g_pFontDB_Default, tag);

	DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)elmf->rgbtemplate,
						 desc->MiscTextCoord[21].x, desc->MiscTextCoord[21].y,
						 len, g_pFontDB_Default->FontSize);

	FontTextOut(g_pFontDB_Default, (Uint16*)RGB1,
				desc->MiscTextCoord[21].x, desc->MiscTextCoord[21].y,
				tag, BLUE_1555);

	RGBlock2YUVBlock(RGB1, 1, desc->MiscTextCoord[21].x, desc->MiscTextCoord[21].y,
					 len, g_pFontDB_Default->FontSize);
}
//------------------------------------------------------------------------------------------------
#endif
