#ifndef _IR_HEADER_
#define _IR_HEADER_
//------------------------------------------------------------------------------------------------
#include "types.h"
//------------------------------------------------------------------------------------------------
#define ADDR 	0x80
#define ADDR_	0x77

//Key Value bo̩wqݭnΨ쪺
#define	DETECT 		0xff
#define	SETUP 		0x28
#define	INFO 		0xff
#define	POWER 		0xb0
#define	REPEAT		0xff
#define	UP 			0xa8
#define	ESC			0x30
#define	PLUS 		0x90
#define	LEFT 		0x00
#define	ENTER 		0x80
#define	RIGHT 		0x40
#define	MINUS 		0x10
#define	PLAYPAUSE	0xff
#define	DOWN 		0xa0
#define	STOP 		0xff
#define	MUTE 		0xff
#define	PREV 		0xff
#define	BACKWARD	0xff
#define	FORWARD	0xff
#define	NEXT 		0xff
#define	CAL			0xff
#define	ROTATE 		0x20
#define	ZOOM 		0x60
#define	SLIDESHOW	0x50
#define	TVOUTPUT	0xe8
#define	KEYA		0x88
#define	KEYB		0xc0
#define	KEYC		0xe0
#define	INVALID		0Xff


typedef enum
{
	SW1 = LEFT,		SW2 = RIGHT, 		SW3 = ENTER, 	SW4 = DOWN, 	SW5 = UP,
	SW6 = ESC, 		SW7 = SLIDESHOW, 	SW8 = SETUP, 	SW9 = MINUS, 	SW10 = PLUS
}SCAN_KEYS;
#define MAX_NUM_IR_EVENTS	32
typedef enum
{
#ifdef NET_MOD
	DS_EVENTS				= 9,//nelly modify 6/23/2008 for wps push button
#else	
	DS_EVENTS				= 8,
#endif	
	MT_EVENTS				= 10,
	SETUP_L1_EVENTS		= 6,
	SETUP_L2_EVENTS		= 6,
	SETUP_L3_EVENTS		= 7,
	I_EVENTS				= 13,
	FI_EVENTS				= 14,
	A_EVENTS				= 13,
	V_EVENTS				= 12,
	FV_EVENTS				= 7,
	SS_EVENTS				= 6,
	PC_CONN_EVENTS		= 1,
	NO_STORAGE_EVENTS	= 0,
	CONFIRM_EVENTS		= 3,
	CAL_EVENTS 			= 8,
	FLDR_EVENTS			= 13,
	FW_UPGRADE_EVENTS	= 0,
	BT_EVENTS				= 19,
	FLDR_FI_EVENTS			= 1,
	FLDR_FV_EVENTS		= 4,
	NET_DS_EVENTS			= 8,
	RSS_EVENTS				= 8,//rywu20080516 changed it from 2 to 8
	IP_CAM_EVENTS		= 6,
	///080504
	WEB_APP_EVENTS		= 14,
	///
	HD_AUTOCP_EVENTS		= 5,
	SHOW_IN_PROCESS_MESSAGE_EVENTS = 0
}NUM_IR_EVENTS;
// Physical addresses of IR registers--------------------------------------------------------------------
#define IR3_CON 	0xC1FC2004
//#define IR3CAN 	0xC1FC2008
//#define IR3CBN 	0xC1FC200C
//#define IR3CCN 	0xC1FC2010
#define IR3CD1		0xC1FC2014
#define IR3CD2		0xC1FC2018
#define IR3CD3		0xC1FC201C
#define IR3CD4		0xC1FC2020
// Values for setting to IR registers => Done by Jinn in driver
//#define VAL_IR3_CON		0x00000100

//#define VAL_IR3CAN		0x00004D28//(70MHz)
//#define VAL_IR3CAN		0x0000B292//(162MHz)
//#define VAL_IR3CAN		0x0000A3AE//(148.5MHz)

//#define VAL_IR3CBN		0x00000067
//#define VAL_IR3CCN		0x00000010

#define REG_CARD_USB			0xC0FC1840
#define REG_SCAN_KEY_DIR		0xC1FC0000
#define REG_SCAN_KEY			0xC1FC0004

#define FETCHBIT(x)		((x & 0x80000000) >> 31)
#define FETCHBIT_8(x)		((x & 0x80) >> 7)
#define CAST32(addr)		(*(Uint32 *)(&addr))
//------------------------------------------------------------------------------------------------
int MapMemory();
void UnmapMemory();
#ifdef TV_SWITCH_MOD
Sint8 EnableTVSwitch();
Sint8 DisableTVSwitch();
#endif
Uint8 ParseIRegister();
Uint8 ParseScanKeyRegister();
Uint8 GetIRScanKey();
//------------------------------------------------------------------------------------------------
extern Uint8 *LBase_CARD_USB;
extern int LBase_CARD_USB_idx;
#endif



