#include "ir.h"
#include "skydemo.h"
#include "drawutil.h"
//------------------------------------------------------------------------------------------------
static int mmfd;
int tv_switch_fd;
// Logical address for user space program
Uint8 *LBase_CARD_USB = NULL;
int LBase_CARD_USB_idx = 0;

static Uint8 *LBase_IR3_CON = NULL;
static int LBase_IR3_CON_idx = 0;
static Uint8 *LBase_IR3CD4 = NULL, *LBase_IR3CD3 = NULL, *LBase_IR3CD2 = NULL, *LBase_IR3CD1 = NULL;
static int LBase_IR3CD4_idx = 0, LBase_IR3CD3_idx = 0, LBase_IR3CD2_idx = 0, LBase_IR3CD1_idx = 0;

static Uint8 *LBase_SCAN_KEY_DIR = NULL;
static int LBase_SCAN_KEY_DIR_idx = 0;

static Uint8 *LBase_SCAN_KEY = NULL;
static int LBase_SCAN_KEY_idx = 0;
//------------------------------------------------------------------------------------------------
int MapMemory()
{
	Uint32 phy_base;
	
	// Open file: /dev/mem for read and wirte!
	if ((mmfd = open("/dev/mem", O_RDWR)) == -1)
	{
		DMSG("Map Memory for IR Fail!");
		return ERRORCODE_DEVICE;
		//exit(1);
	}
	phy_base = REG_CARD_USB & 0xffff0000;
	LBase_CARD_USB = (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_CARD_USB_idx = REG_CARD_USB - phy_base;
	//PRINTF("0x%x\n", LBase_CARD_USB_idx);
	//PRINTF("0x%x\n", LBase_CARD_USB);

	phy_base = IR3_CON & 0xffff0000;
	LBase_IR3_CON = (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_IR3_CON_idx = IR3_CON - phy_base;
	//PRINTF("0x%x\n", LBase_IR3_CON_idx);
	//PRINTF("0x%x\n", LBase_IR3_CON);

	phy_base = IR3CD4 & 0xffff0000;
	LBase_IR3CD4 = (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_IR3CD4_idx = IR3CD4 - phy_base;
	//PRINTF("0x%x\n", LBase_IR3CD4_idx);
	//PRINTF("0x%x\n", LBase_IR3CD4);

	phy_base = IR3CD3 & 0xffff0000;
	LBase_IR3CD3 = (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_IR3CD3_idx = IR3CD3 - phy_base;
	//PRINTF("0x%x\n", LBase_IR3CD3_idx);
	//PRINTF("0x%x\n", LBase_IR3CD3);

	phy_base = IR3CD2 & 0xffff0000;
	LBase_IR3CD2 = (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_IR3CD2_idx = IR3CD2 - phy_base;
	//PRINTF("0x%x\n", LBase_IR3CD2_idx);
	//PRINTF("0x%x\n", LBase_IR3CD2);

	phy_base = IR3CD1 & 0xffff0000;
	LBase_IR3CD1 = (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_IR3CD1_idx = IR3CD1 - phy_base;
	//PRINTF("0x%x\n", LBase_IR3CD1_idx);
	//PRINTF("0x%x\n", LBase_IR3CD1);

	phy_base = REG_SCAN_KEY_DIR & 0xffff0000;
	LBase_SCAN_KEY_DIR= (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_SCAN_KEY_DIR_idx = REG_SCAN_KEY_DIR - phy_base;
	//PRINTF("0x%x\n", LBase_SCAN_KEY_DIR_idx);
	//PRINTF("0x%x\n", LBase_SCAN_KEY_DIR);

	phy_base = REG_SCAN_KEY & 0xffff0000;
	LBase_SCAN_KEY = (Uint8 *)mmap(0, 0x10000, PROT_READ | PROT_WRITE, MAP_SHARED, mmfd, phy_base);
	LBase_SCAN_KEY_idx = REG_SCAN_KEY - phy_base;
	//PRINTF("0x%x\n", LBase_SCAN_KEY_idx);
	//PRINTF("0x%x\n", LBase_SCAN_KEY);

	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
void UnmapMemory()
{
	munmap(LBase_IR3_CON, 0x10000);
	munmap(LBase_IR3CD4, 0x10000);
	munmap(LBase_IR3CD3, 0x10000);
	munmap(LBase_IR3CD2, 0x10000);
	munmap(LBase_IR3CD1, 0x10000);
	munmap(LBase_CARD_USB, 0x10000);
	munmap(LBase_SCAN_KEY_DIR, 0x10000);
	munmap(LBase_SCAN_KEY, 0x10000);
	
	close(mmfd);
}
//------------------------------------------------------------------------------------------------
#ifdef TV_SWITCH_MOD
Sint8 EnableTVSwitch()
{
	// open device handle
	if((tv_switch_fd = open("/dev/slot0", O_RDWR)) == -1)
	{
		PRINTF("open \"/dev/slot0\" failed\n");
		return ERRORCODE_FILE;
	}
	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
Sint8 DisableTVSwitch()
{
	close(tv_switch_fd);
}
#endif
//------------------------------------------------------------------------------------------------
Uint8 ParseIRegister()
{
	int i, j, k, m, count0, count1;
	Uint32 ir_tmp_val, ir3cdx_val[4];
	Uint8 parsed_val[4];
	
	//DMSG("In while loop, waiting for key down!\n");
	if((CAST32(LBase_IR3_CON[LBase_IR3_CON_idx]) & 0x00000002) > 0)
	{
		// Get value from IR registers
		ir3cdx_val[0] = CAST32(LBase_IR3CD4[LBase_IR3CD4_idx]);
		ir3cdx_val[1] = CAST32(LBase_IR3CD3[LBase_IR3CD3_idx]);
		ir3cdx_val[2] = CAST32(LBase_IR3CD2[LBase_IR3CD2_idx]);
		ir3cdx_val[3] = CAST32(LBase_IR3CD1[LBase_IR3CD1_idx]);
		#if 0
		for(i = 0; i < 4; i++)
		{
			PRINTF("ir3cdx_val[%d] = %x\n", i, ir3cdx_val[i]);	
		}
		#endif
		memset(parsed_val, 0, 4 * sizeof(Uint8));
#ifdef	NEC_IR_PROTOCAL
		k = 7, m = 0, count0 = 0;
		// Parsing
		for(i = 1; i < 4; i++)
		{
			for(j = 0; j < 32; j++)
			{
				ir_tmp_val = FETCHBIT(ir3cdx_val[i]);
				ir3cdx_val[i] <<= 1;
				if(ir_tmp_val == 1)
				{
					if(count0 == 3)
					{
						parsed_val[m] |= 1 << k;
						count0 = 0;
						k--;
					}
					else if(count0 == 1)
					{
						count0 = 0;
						k--;
					}
					if(k == -1)
					{
						k = 7;
						m++;
					}
				}
				else
					count0++;
			}
		}
		if(count0 == 3)
			parsed_val[m] |= 1;
		// Verification
		#if 0
		for(i = 0; i < 4; i++)
		{
			if(i == 0)			PRINTF("ADDR = ");
			else if(i == 1)		PRINTF("addr = ");
			else if(i == 2)		PRINTF("CMD = ");
			else        		PRINTF("cmd = ");
			
			PRINTF("0x%x\n", parsed_val[i]);
		}
		PRINTF("\n");
		#endif
		// Reset IR3_CON
		CAST32(LBase_IR3_CON[LBase_IR3_CON_idx]) = 0x00000102;
		if(parsed_val[0] == ADDR && parsed_val[1] == ADDR_)
		{
			if((parsed_val[2] ^ parsed_val[3]) == 0xFF)
				return parsed_val[2];
			else
				return INVALID;
		}
		else
			return INVALID;
#endif

#ifdef	SONY_IR_PROTOCAL
		memset(parsed_val, 0, 4 * sizeof(unsigned char));
		m = 0, count0 = 0, count1 = 0, k = 6;
		// Parsing
		for(i = 2; i < 4; i++)
		{
			for(j = 0; j < 32; j++)
			{
				ir_tmp_val = FETCHBIT(ir3cdx_val[i]);
				ir3cdx_val[i] <<= 1;
				if(ir_tmp_val == 1)	count1++;
				else				count0++;

				if(count0 > 1)
				{
					count0 = 0;
					continue;
				}
				if(count1 == 1 && count0 == 1)
				{
					count0 = count1 = 0;
					k--;
				}
				else if(count1 == 2 && count0 == 1)
				{
					parsed_val[m] |= 1 << k;
					count0 = count1 = 0;
					k--;
				}
				if(k == -1)
				{
					k = 4;
					if(m == 1)	break;
					m++;
				}
			}
		}
		// Verification
		#if 0
		for(i = 0; i < 2; i++)
		{
			if(i == 0)
			{
				PRINTF("Command = ");
			}
			else if(i == 1)
			{
				PRINTF("Address = ");
			}
			PRINTF("0x%x\n", parsed_val[i]);
		}
		PRINTF("\n");
		#endif
		usleep(150000);
		// Reset IR3_CON
		CAST32(LBase_IR3_CON[LBase_IR3_CON_idx]) = 0x00000102;
		if(parsed_val[1] == ADDR)
		{
			return parsed_val[0];
		}
		else
			return INVALID;
		
#endif
	}
	else
	{
		//PRINTF("Invalid key = 0x%x\n", INVALID);
		return INVALID;
	}
}
//------------------------------------------------------------------------------------------------
#if 1 /* jinn - 2007/08/08 - use io control */
#define DELAY	                    12
#define CARDSLOT_SET_GPIOXY_DIR    3
#define CARDSLOT_READ_GPIOXY_DATA  4
#define CARDSLOT_WRITE_GPIOXY_DATA 5

#define SET_DIR(X) { \
     _tempVal = X; \
	ioctl(_fd, CARDSLOT_SET_GPIOXY_DIR, &_tempVal); \
}

#define SET_DATA(X) { \
     _tempVal = X; \
	ioctl(_fd, CARDSLOT_WRITE_GPIOXY_DATA, &_tempVal); \
}

#define GET_DATA(X) { \
	ioctl(_fd, CARDSLOT_READ_GPIOXY_DATA, &X); \
}

#define RETURN_SCAN_KEY_FUN(X) { \
     SET_DIR( 0xfffffff8 ); \
     close(_fd); \
     return X; \
}

#ifdef SYNAPTICS_OT
Uint8 ParseOneTouchRegister(void)
{
	int fd;
	unsigned char ret = INVALID;
	unsigned char key;
	fd = open("/dev/touchkey", O_RDONLY);
	if(fd<0)
		return ret;

	/* read one byte */
	if(read(fd, &key, 1) == 1)
	{	
		switch(key)
		{
			case 0x01:
				ret = ESC;
				break;
			case 0x02:
				ret = ROTATE;
				break;
			case 0x04:
				ret = UP;
				break;
			case 0x08:
				ret = ENTER;
				break;
			case 0x10:
				ret = DOWN;
				break;			
			case 0x20:
				ret = SLIDESHOW;
				break;			
			case 0x40:
				ret = PLUS;
				break;			
			case 0x80:
				ret = MINUS;
				break;			
		}
	}
	close(fd);
	
	return ret;
}
#endif

Uint8 ParseScanKeyRegister()
{
// davison @ 2008/02/14
#ifdef TOUCHKEY_MOD
// Synaptics OneTouch
#ifdef SYNAPTICS_OT
	return ParseOneTouchRegister();
#endif
#endif

	#define 	TIME	50000//0.05second mod by Eric
	int    _fd;
	Uint32 _tempVal;
	static Uint8 y1x1 = 0, y1x2 = 0, y1x3 = 0;
	static Uint8 y2x1 = 0, y2x2 = 0, y2x3 = 0;
	static Uint8 y3x1 = 0, y3x2 = 0;
	static Uint8 y4x1 = 0, y4x2 = 0;

	// open device handle
	if((_fd = open("/dev/slot0", O_RDWR)) == -1)
	{
		PRINTF("open \"/dev/slot0\" failed\n");
		return INVALID;
	}
	//--------------------------------------------------------------------------------------------
	//Set bit12(Y1) DIR to 0(input)
	SET_DIR( 0xffffeff8 );
	usleep(DELAY);
	//Pull all y[12:15] bits low
	SET_DATA( 0xffff0fff );
	GET_DATA( _tempVal );
	if(_tempVal & 0x00000001)//if x1 == 1
	{
		usleep(TIME);
		//PRINTF("SW1\n");
		RETURN_SCAN_KEY_FUN( SW1 );
	}
	if(_tempVal & 0x00000002)//if x2 == 1
	{
		usleep(TIME);
		//PRINTF("SW5\n");
		RETURN_SCAN_KEY_FUN( SW5 );
	}
	if(_tempVal & 0x00000004)//if x3 == 1
	{
		usleep(TIME);
		//PRINTF("SW9\n");
		RETURN_SCAN_KEY_FUN( SW9 );
	}
	//--------------------------------------------------------------------------------------------
	//Set bit13(Y2) DIR to 0(input)
	SET_DIR( 0xffffdff8 );
	usleep(DELAY);
	//Pull all y[12:15] bits low
	SET_DATA( 0xffff0fff );
	GET_DATA( _tempVal );
	if(_tempVal & 0x00000001)//if x1 == 1
	{
		usleep(TIME);
		//PRINTF("SW2\n");
		RETURN_SCAN_KEY_FUN( SW2 );
	}
	if(_tempVal & 0x00000002)//if x2 == 1
	{
		usleep(TIME);
		//PRINTF("SW6\n");
		RETURN_SCAN_KEY_FUN( SW6 );
	}
	if(_tempVal & 0x00000004)//if x3 == 1
	{
		usleep(TIME);
		//PRINTF("SW10\n");
		RETURN_SCAN_KEY_FUN( SW10 );
	}
	//--------------------------------------------------------------------------------------------
	//Set bit14(Y3) DIR to 0(input)
	SET_DIR( 0xffffbff8 );
	usleep(DELAY);
	//Pull all y[12:15] bits low
	SET_DATA( 0xffff0fff );
	GET_DATA( _tempVal );
	if(_tempVal & 0x00000001)//if x1 == 1
	{
		usleep(TIME);
		//PRINTF("SW3\n");
		RETURN_SCAN_KEY_FUN( SW3 );
	}
	if(_tempVal & 0x00000002)//if x2 == 1
	{
		usleep(TIME);
		//PRINTF("SW7\n");
		RETURN_SCAN_KEY_FUN( SW7 );
	}
	
#ifdef WINGUI
	if(_tempVal & 0x00000004)//if x3 == 1
	{
		usleep(TIME);
		//PRINTF("SW11 ENTER\n");
		RETURN_SCAN_KEY_FUN( SW11 );
	}
#endif
	//--------------------------------------------------------------------------------------------
	//Set bit15(Y4) DIR to 0(input)
	SET_DIR( 0xffff7ff8 );
	usleep(DELAY);
	//Pull all y[12:15] bits low
	SET_DATA( 0xffff0fff );
	GET_DATA( _tempVal );
	if(_tempVal & 0x00000001)//if x1 == 1
	{
		usleep(TIME);
		//PRINTF("SW4\n");
		RETURN_SCAN_KEY_FUN( SW4 );
	}
	if(_tempVal & 0x00000002)//if x2 == 1
	{
		usleep(TIME);
		//PRINTF("SW8\n");
		RETURN_SCAN_KEY_FUN( SW8 );
	}
	RETURN_SCAN_KEY_FUN( INVALID );
}
#else
Uint8 ParseScanKeyRegister()
{
#if 1
	#define DELAY	12
	Uint32 ScanKeyDir, ScanKeyVal;

//	static Uint8 y1x1 = 0, y1x2 = 0, y1x3 = 0;
//	static Uint8 y2x1 = 0, y2x2 = 0, y2x3 = 0;
//	static Uint8 y3x1 = 0, y3x2 = 0;
//	static Uint8 y4x1 = 0, y4x2 = 0;

	ScanKeyDir = CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]);
	//PRINTF("ScanKeyDir = %x\n", ScanKeyDir);//fe30
	ScanKeyVal = CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]);
	//PRINTF("ScanKeyVal = %x\n", ScanKeyVal);//6f0

	//Set bit12(Y1) DIR to 0(input)
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) &= 0xffffefff;
	usleep(DELAY);
	//Pull all y[12:15] bits low
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
//		if(y1x1)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW1\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y1x1 = 1;
			return SW1;
		}
	}
//	else
//		y1x1 = 0;

	if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
//		if(y1x2)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW5\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y1x2 = 1;
			return SW5;
		}
	}
//	else
//		y1x2 = 0;

	if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000004) >> 2)//if x3 == 1
	{
//		if(y1x3)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW9\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y1x3 = 1;
			return SW9;
		}
	}
//	else
//		y1x3 = 0;
	//--------------------------------------------------------------------------------------------
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	//Set bit13(Y2) DIR to 0(input)
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) &= 0xffffdfff;
	usleep(DELAY);
	//Pull all y[12:15] bits low
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
//		if(y2x1)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW2\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y2x1 = 1;
			return SW2;
		}
	}
//	else
//		y2x1 = 0;
	
	if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
//		if(y2x2)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW6\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y2x2 = 1;
			return SW6;
		}
	}
//	else
//		y2x2 = 0;

	if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000004) >> 2)//if x3 == 1
	{
//		if(y2x3)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW10\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y2x3 = 1;
			return SW10;
		}
	}
//	else
//		y2x3 = 0;
	//--------------------------------------------------------------------------------------------
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	//Set bit14(Y3) DIR to 0(input)
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) &= 0xffffbfff;
	usleep(DELAY);
	//Pull all y[12:15] bits low
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
//		if(y3x1)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW3\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y3x1 = 1;
			return SW3;
		}
	}
//	else
//		y3x1 = 0;

	if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
//		if(y3x2)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW7\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y3x2 = 1;
			return SW7;
		}
	}
//	else
//		y3x2 = 0;
	//--------------------------------------------------------------------------------------------
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	//Set bit15(Y4) DIR to 0(input)
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) &= 0xffff7fff;
	usleep(DELAY);
	//Pull all y[12:15] bits low
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
//		if(y4x1)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW4\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y4x1 = 1;
			return SW4;
		}
	}
//	else
//		y4x1 = 0;

	if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
//		if(y4x2)
		{
//			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			return INVALID;
		}
//		else
		{
			//PRINTF("SW8\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
//			y4x2 = 1;
			return SW8;
		}
	}
//	else
//		y4x2 = 0;

	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) = ScanKeyVal;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	return INVALID;
#else//doesn't work correctly!!!
	Uint32 ScanKeyDir, ScanKeyVal, tmpScanKeyVal, tmpScanKeyDir;
	static Uint8 y1x1 = 0, y1x2 = 0, y1x3 = 0;
	static Uint8 y2x1 = 0, y2x2 = 0, y2x3 = 0;
	static Uint8 y3x1 = 0, y3x2 = 0;
	static Uint8 y4x1 = 0, y4x2 = 0;

	ScanKeyVal = (CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff);
	//PRINTF("ScanKeyVal = %x\n", ScanKeyVal);//6f0 => all data values of Y1, Y2, Y3, Y4 are 0
	ScanKeyDir = (CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) |= 0xf000);
	//PRINTF("ScanKeyDir = %x\n", ScanKeyDir);//fe30 => all directions of Y1, Y2, Y3, Y4 are output(1)

	//--------------------------------------------------------------------------------------------
	//restore the value of Y set
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	//Set data values: {Y4, Y3, Y2, Y1} = {0, 0, 0, 1}
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) |= 0x1000;
	tmpScanKeyDir = CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]);
	tmpScanKeyDir &= 0xffff0fff;
	tmpScanKeyDir |= 0x1000;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = tmpScanKeyDir;
	//Read X1, X2, X3
	tmpScanKeyVal = CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]);
	if(tmpScanKeyVal & 0x00000001)//if x1 == 1
	//if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
		if(y1x1)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW1\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y1x1 = 1;
			return SW1;
		}
	}
	else
		y1x1 = 0;

	if((tmpScanKeyVal & 0x00000002) >> 1)//if x2 == 1
	//if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
		if(y1x2)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW5\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y1x2 = 1;
			return SW5;
		}
	}
	else
		y1x2 = 0;

	if((tmpScanKeyVal & 0x00000004) >> 2)//if x3 == 1
	//if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000004) >> 2)//if x3 == 1
	{
		if(y1x3)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW9\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y1x3 = 1;
			return SW9;
		}
	}
	else
		y1x3 = 0;
	//--------------------------------------------------------------------------------------------
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) = ScanKeyVal;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	//restore the value of Y set
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	//Set data values: {Y4, Y3, Y2, Y1} = {0, 0, 1, 0}
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) |= 0x2000;
	tmpScanKeyDir = CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]);
	tmpScanKeyDir &= 0xffff0fff;
	tmpScanKeyDir |= 0x2000;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = tmpScanKeyDir;
	//Read X1, X2, X3
	tmpScanKeyVal = CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]);
	if(tmpScanKeyVal & 0x00000001)//if x1 == 1
	//if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
		if(y2x1)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW2\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y2x1 = 1;
			return SW2;
		}
	}
	else
		y2x1 = 0;
	
	if((tmpScanKeyVal & 0x00000002) >> 1)//if x2 == 1
	//if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
		if(y2x2)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW6\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y2x2 = 1;
			return SW6;
		}
	}
	else
		y2x2 = 0;

	if((tmpScanKeyVal & 0x00000004) >> 2)//if x3 == 1
	//if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000004) >> 2)//if x3 == 1
	{
		if(y2x3)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW10\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y2x3 = 1;
			return SW10;
		}
	}
	else
		y2x3 = 0;
	//--------------------------------------------------------------------------------------------
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) = ScanKeyVal;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	//restore the value of Y set
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	//Set data values: {Y4, Y3, Y2, Y1} = {0, 1, 0, 0}
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) |= 0x4000;
	tmpScanKeyDir = CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]);
	tmpScanKeyDir &= 0xffff0fff;
	tmpScanKeyDir |= 0x4000;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = tmpScanKeyDir;
	//Read X1, X2, X3
	tmpScanKeyVal = CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]);
	if(tmpScanKeyVal & 0x00000001)//if x1 == 1
	//if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
		if(y3x1)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW3\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y3x1 = 1;
			return SW3;
		}
	}
	else
		y3x1 = 0;

	if((tmpScanKeyVal & 0x00000002) >> 1)//if x2 == 1
	//if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
		if(y3x2)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW7\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y3x2 = 1;
			return SW7;
		}
	}
	else
		y3x2 = 0;
	//--------------------------------------------------------------------------------------------
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) = ScanKeyVal;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	//restore the value of Y set
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) &= 0xffff0fff;
	//Set data values: {Y4, Y3, Y2, Y1} = {1, 0, 0, 0}
	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) |= 0x8000;
	tmpScanKeyDir = CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]);
	tmpScanKeyDir &= 0xffff0fff;
	tmpScanKeyDir |= 0x8000;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = tmpScanKeyDir;
	//Read X1, X2, X3
	tmpScanKeyVal = CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]);
	if(tmpScanKeyVal & 0x00000001)//if x1 == 1
	//if(CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000001)//if x1 == 1
	{
		if(y4x1)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW4\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y4x1 = 1;
			return SW4;
		}
	}
	else
		y4x1 = 0;

	if((tmpScanKeyVal & 0x00000002) >> 1)//if x2 == 1
	//if((CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) & 0x00000002) >> 1)//if x2 == 1
	{
		if(y4x2)
		{
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			return INVALID;
		}
		else
		{
			//PRINTF("SW8\n");
			CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
			y4x2 = 1;
			return SW8;
		}
	}
	else
		y4x2 = 0;

	CAST32(LBase_SCAN_KEY[LBase_SCAN_KEY_idx]) = ScanKeyVal;
	CAST32(LBase_SCAN_KEY_DIR[LBase_SCAN_KEY_DIR_idx]) = ScanKeyDir;
	return INVALID;
#endif
}
#endif

#ifdef LEADTEK
// for Leadtek key pad and cover detector
// Xenia 02/2008
typedef struct _sGPIO
{
    unsigned int _reg;
    unsigned int _mask_bit;
    unsigned int _data;
}
GPIO;

#define CARDSLOT_SHOW_GPIO             0
#define CARDSLOT_READ_GPIO_REG         1
#define CARDSLOT_WRITE_GPIO_REG        2
#define CARDSLOT_SET_GPIOXY_DIR        3
#define CARDSLOT_READ_GPIOXY_DATA      4
#define CARDSLOT_WRITE_GPIOXY_DATA     5
#define CARDSLOT_READ_GPIO_BITDATA     6
#define CARDSLOT_WRITE_GPIO_BITDATA    7

#define GIOP_DIR_REG                   0
#define GIOP_DATA_REG                  1

Uint8 ParseScanLeadtekKeyRegister()
{
	static long long pre_time=0;
	long long now=get_msec();
	long long diff=now-pre_time;
	if (diff> 300 || diff<0){
	
	}else{
		return INVALID;
	}
	
	#define 	TIME	50000//0.05second mod by Eric
	int    _fd;
	GPIO myGPIO;
	unsigned int _data[2];
	
	// open device handle
	if((_fd = open("/dev/slot0", O_RDWR)) == -1)
	{
		PRINTF("open \"/dev/slot0\" failed\n");
		return INVALID;
	}
	
	// GPIO 0
	myGPIO._reg      = 1;
	myGPIO._mask_bit = 0x0001;
	ioctl(_fd, CARDSLOT_READ_GPIO_BITDATA, &myGPIO);
	if ((myGPIO._data & 0x00000001) == 1)
	{
		//PRINTF("GPIO 0 = %x\n", myGPIO._data);
		pre_time=get_msec();
		close(_fd);
		return (SW1);
	}
	
	// GPIO 1
	myGPIO._reg      = 1;
	myGPIO._mask_bit = 0x0002;
	ioctl(_fd, CARDSLOT_READ_GPIO_BITDATA, &myGPIO);
	if ((myGPIO._data & 0x00000002) == 2)
	{
		//PRINTF("GPIO 1 = %x\n", myGPIO._data);
		pre_time=get_msec();
		close(_fd);
		return (SW2);
	}
	
	// GPIO 2
	myGPIO._reg      = 1;
	myGPIO._mask_bit = 0x0004;
	ioctl(_fd, CARDSLOT_READ_GPIO_BITDATA, &myGPIO);
	if ((myGPIO._data & 0x00000004) == 4)
	{
		//PRINTF("GPIO 2 = %x\n", myGPIO._data);
		//PRINTF("GPIO 2 = %x\n", myGPIO._data);
		pre_time=get_msec();
		close(_fd);
		return (SW3);
	}
	
	// GPIO 3
	myGPIO._reg      = 1;
	myGPIO._mask_bit = 0x0008;
	ioctl(_fd, CARDSLOT_READ_GPIO_BITDATA, &myGPIO);
	if ((myGPIO._data & 0x00000008) == 8)
	{
		//PRINTF("GPIO 3 = %x\n", myGPIO._data);
		//PRINTF("GPIO 3 = %x\n", myGPIO._data);
		pre_time=get_msec();
		close(_fd);
		return (SW4);
	}
	
	// EGPIO 5
	_data[0] = 3;
	_data[1] = 0;
	ioctl(_fd, CARDSLOT_READ_GPIO_REG, _data);
	if ((_data[1] & 0x00000020) == 0x0 )
	{
		//PRINTF("CoverOn EGPIO 5 = 0x%08x\n", _data[1]);
		// Cover On
		pre_time=get_msec();
		isCoverOn = TRUE;
		TurnBacklightPGU(0);
	} else
	{
		//PRINTF("CoverOff EGPIO 5 = 0x%08x\n", _data[1]);
		
		if (isCoverOn == TRUE)
		{
			pre_time=get_msec();
			isCoverOn = FALSE;
			TurnBacklightPGU(1);
		}
	}
	
	close(_fd);
	return (INVALID);
}
#endif
//------------------------------------------------------------------------------------------------
Uint8 GetIRScanKey()
{
	Uint8 ir_key_val, scan_key_val;

	ir_key_val = ParseIRegister();
#ifndef LBC
	if(ir_key_val == INVALID)
	{
		// for Leadtek key pad and cover detector// Xenia 02/2008
		#ifndef LEADTEK
		scan_key_val = ParseScanKeyRegister();
		#else
		scan_key_val = ParseScanLeadtekKeyRegister();
		#endif
		return scan_key_val;
	}
	else
#endif
	{
		return ir_key_val;
	}
}
