/*------------------------------------------------------------------------------
Doubly linked list structure used for linking entries
------------------------------------------------------------------------------*/
typedef struct _LIST_ENTRY {
	struct _LIST_ENTRY *ForwardLink;
	struct _LIST_ENTRY *BackwardLink;
} LIST_ENTRY, *LIST_ENTRY_ID;

/*------------------------------------------------------------------------------
List head structure
------------------------------------------------------------------------------*/
typedef struct {
	LIST_ENTRY    Link;
	unsigned long EntryCount;
} LIST_CONTAINER, *LIST_CONTAINER_ID;


/*------------------------------------------------------------------------------
Function prototype declaration
------------------------------------------------------------------------------*/
__inline void ListInitList(LIST_CONTAINER_ID pList);
__inline char ListEmpty(LIST_CONTAINER_ID pList);
__inline LIST_ENTRY_ID ListGetHead(LIST_CONTAINER_ID pList);
__inline LIST_ENTRY_ID ListGetTail(LIST_CONTAINER_ID pList);
__inline void ListPushHead(LIST_CONTAINER_ID pList, LIST_ENTRY_ID pEntry);
__inline void ListPushTail(LIST_CONTAINER_ID pList, LIST_ENTRY_ID pEntry);
__inline LIST_ENTRY_ID ListPopHead(LIST_CONTAINER_ID pList);
__inline LIST_ENTRY_ID ListPopTail(LIST_CONTAINER_ID pList);
__inline LIST_ENTRY_ID ListNextEntry(LIST_ENTRY_ID pEntry);
__inline LIST_ENTRY_ID ListPrevEntry(LIST_ENTRY_ID pEntry);
__inline char ListOk(LIST_CONTAINER_ID pList);
__inline unsigned long ListGetSize(LIST_CONTAINER_ID pList);

