#include "machinedisplay.h"
#include "events.h"
#include "drawutil.h"
#include "parser.h"

#include "FList.h"
#include "FWUpgrade.h"

//------------------------------------------------------------------------------------------------
char *ConfirmText;
Uint32 yuv_idx = 0;

#ifdef USE_DESC_TV
	char dCropAfterScaling[LEN_L], panAfterScaling[LEN_L];
	int WidthOfScrBorder, HeightOfScrBorder, isLowPassMode = FALSE;
#endif
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
//Robert 2007-12-30 move initial value in InitDisplayParameter()
int shift480 = 0;	//shift for 800x480 only
extern Uint8 isGWSet;		//0: none; bit_1(1): got mac; bit_2(2): wired; bit_3(4):wireless;
extern pid_t dhcp_pid;
extern int dhcpsts;
Uint8 GetLocalIP(char *ipaddr_buff)
{
	FILE *fp;
	//char str[LEN_XL], *prefix_str = "Lease of ", *endfix_str = " obtained", *pp, *ep;
	char str[LEN_XL];
	int len;

	if(!(fp = fopen("/tmp/ip.txt", "r")))
	{
		DMSG("Failed to open ip.txt!\n");
		return 0;
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		//PRINTF("ipaddr(%d) = %s\n",strlen(str), str);
		if(strlen(str)>0)
		{
			len = strlen(str);
			//Robert 2007-12-30 remove tail '\n'
			if (str[len-1] == '\n')
				len--;
			memcpy(ipaddr_buff, str, len);
			fclose(fp);
			return 1;
		}
		else
		{
			fclose(fp);
			return 0;
		}
	}
	fclose(fp);
	return 1;
}
//------------------------------------------------------------------------------------------------
Uint8 GetSharedDir(char *shdir_buff)
{
	FILE *fp;
	char str[LEN_XL], tmp[LEN_XL], *prefix_str = "ip0=", *pp;
	Uint8 i, j, k = 0;

	if(!(fp = fopen("/tmp/conf/mountNet", "r")))
	{
		DMSG("Failed to open file!\n");
		return 0;
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		memset(tmp, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		if(pp = strstr(str, prefix_str))
		{
			pp = pp + strlen(prefix_str)+3;		//("//) length is 3
			memcpy(tmp, pp, strlen(str)-7);
			for(i=0;i<64;i++)	//tyhuang: we suppose the string length < 64
			{
				if(tmp[i] == 47 || tmp[i] == 92)	//'/'=47 or '\'=92
					break;
			}
			i++;	//skip '/'
			pp += i;
			for(j=i;j<64;j++) //tyhuang: we suppose the string length < 64
			{
				if(tmp[j] == 34)	//'"'=34
					break;
			}
			memcpy(shdir_buff, pp, (j-i));
			//PRINTF("shdir_buff = %s\n", shdir_buff);
			fclose(fp);
			return 1;
		}
	}
	fclose(fp);
	return 0;
}

Uint8 GetSSID(char *ssid_buff)
{
	FILE *fp;
	char str[64], tmp[32], *prefix_str = "SSID=", *pp;
	Uint8 i= 0;

	if(!(fp = fopen("/tmp/conf/rt73sta.dat", "r")))
	{
		DMSG("Failed to open /tmp/conf/rt73sta.dat\n");
		return 0;
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * 64);
		memset(tmp, 0, sizeof(char) * 32);
		fgets(str, 64, fp);
		if(pp = strstr(str, prefix_str))
		{
			pp = pp + strlen(prefix_str);
			memcpy(tmp, pp, strlen(str)-strlen(prefix_str));
			for(i=0;i<32;i++)	//tyhuang: we suppose the string length < 32
			{
				if(tmp[i] == 10)
					break;
			}
			fclose(fp);
			if(i==0)
			{
//				PRINTF("no SSID\n");
				return 0;
			}
			else
			{
				memcpy(ssid_buff, pp, i);
//				PRINTF("ssid_buff = %s\n", ssid_buff);
				return 1;
			}
		}
	}
	fclose(fp);
	return 0;
}
Uint8 GetAuthMode(char *auth_buff,unsigned char *type)
{
	FILE *fp;
	char str[32], tmp[8], *prefix_str = "AuthMode=", *pp;
	Uint8 i= 0;

	if(!(fp = fopen("/tmp/conf/rt73sta.dat", "r")))
	{
		DMSG("Failed to open /tmp/conf/rt73sta.dat\n");
		return 0;
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * 32);
		memset(tmp, 0, sizeof(char) * 8);
		fgets(str, 32, fp);
		if(pp = strstr(str, prefix_str))
		{
			pp = pp + strlen(prefix_str);
			memcpy(tmp, pp, strlen(str)-strlen(prefix_str));
			for(i=0;i<8;i++)	//tyhuang: we suppose the string length < 8
			{
				if(tmp[i] == 10)
					break;
			}
			fclose(fp);
			if(i<3)
			{
//				PRINTF("no Auth or Error(%d)\n",i);
				return 0;
			}
			else
			{

				memcpy(auth_buff, pp, i);
//				PRINTF("auth_buff = %s\n", auth_buff);
				if(pp = strstr(str, "OPEN"))
					*type = 1;
				else if(pp = strstr(str, "SHARED"))
					*type = 2;
				else if(pp = strstr(str, "WEPAUTO"))
					*type = 3;
				else if(pp = strstr(str, "WPAPSK"))
					*type = 4;
				else if(pp = strstr(str, "WPA2PSK"))
					*type = 5;
				else
				{
					*type = 0;
					return 0;
				}
				return 1;
			}
		}
	}
	fclose(fp);
	return 0;
}
Uint8 GetEncrypType(char *encryp_buff,unsigned char *type)
{
	FILE *fp;
	char str[32], tmp[8], *prefix_str = "EncrypType=", *pp;
	Uint8 i= 0;

	if(!(fp = fopen("/tmp/conf/rt73sta.dat", "r")))
	{
		DMSG("Failed to open /tmp/conf/rt73sta.dat\n");
		return 0;
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * 32);
		memset(tmp, 0, sizeof(char) * 8);
		fgets(str, 32, fp);
		if(pp = strstr(str, prefix_str))
		{
			pp = pp + strlen(prefix_str);
			memcpy(tmp, pp, strlen(str)-strlen(prefix_str));
			for(i=0;i<8;i++)	//tyhuang: we suppose the string length < 8
			{
				if(tmp[i] == 10)
					break;
			}
			fclose(fp);
			if(i<3)
			{
//				PRINTF("no Encry or Error(%d)\n",i);
				return 0;
			}
			else
			{
				memcpy(encryp_buff, pp, i);
//				PRINTF("encryp_buff(%d) = %s\n",i, encryp_buff);
				if(pp = strstr(encryp_buff, "NONE"))
					*type = 1;
				else if(pp = strstr(encryp_buff, "WEP"))
					*type = 2;
				else if(pp = strstr(encryp_buff, "TKIP"))
					*type = 3;
				else if(pp = strstr(encryp_buff, "AES"))
					*type = 4;
				else
				{
					*type = 0;
					return 0;
				}
				return 1;
			}
		}
	}
	fclose(fp);
	return 0;
}
Uint8 GetRunKeyID(int *keyid,unsigned char *auth_type)
{
	FILE *fp;
	char str[32], *prefix_str = "DefaultKeyID=", *pp;

	if(*auth_type==0 || *auth_type > 2)
	{
		if(*auth_type == 0)
		{
			*keyid = 0;
			return 0;
		}
		if(*auth_type > 2)
		{
			*keyid = 5;
			return 1;
		}
	}
	if(!(fp = fopen("/tmp/conf/rt73sta.dat", "r")))
	{
		DMSG("Failed to open /tmp/conf/rt73sta.dat\n");
		return 0;
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * 32);
		fgets(str, 32, fp);
		if(pp = strstr(str, prefix_str))
		{
			pp = pp + strlen(prefix_str);
			*keyid=*pp-0x30;
//			PRINTF("DefaultKeyID = %d\n", *keyid);
			fclose(fp);
			if(*keyid<5)
				return 1;
			else
				return 0;
		}
	}
	fclose(fp);
	return 0;
}

Uint8 GetRunKey(char *key_buff,int keyid)
{
	FILE *fp;
	char str[128], tmp[64], prefix_str[10], *pp;
	Uint8 i;

	switch(keyid)
	{
		case 1:
			strcpy(prefix_str,"Key1Str=");
			break;
		case 2:
			strcpy(prefix_str,"Key2Str=");
			break;
		case 3:
			strcpy(prefix_str,"Key3Str=");
			break;
		case 4:
			strcpy(prefix_str,"Key4Str=");
			break;
		case 5:
			strcpy(prefix_str,"WPAPSK=");
			break;
		default:		//error
			return 0;
	}
//	printf("\n prefix=%s\n",prefix_str);
	//return 1;
	if(!(fp = fopen("/tmp/conf/rt73sta.dat", "r")))
	{
		DMSG("Failed to open /tmp/conf/rt73sta.dat\n");
		return 0;
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * 128);
		memset(tmp, 0, sizeof(char) * 64);
		fgets(str, 128, fp);
		if(pp = strstr(str, prefix_str))
		{
			pp = pp + strlen(prefix_str);
			memcpy(tmp, pp, strlen(str)-strlen(prefix_str));
			for(i=0;i<64;i++)	//tyhuang: we suppose the string length < 8
			{
				if(tmp[i] == 10)
					break;
			}
			fclose(fp);
			if(i<8)
			{
//				PRINTF("no key(%d)\n",i);
				return 0;
			}
			else
			{
				memcpy(key_buff, pp, i);
//				PRINTF("key_buff = %s\n", key_buff);
				return 1;
			}
		}
	}
	fclose(fp);
	return 0;
}

#endif
//------------------------------------------------------------------------------------------------
void DSDisplay()
{
	FRAME *elmf;
	//rywu20080526++
#ifdef NET_MOD
	char localipaddr[IPADDR_LEN];
    char tmp[LEN_L];
    unsigned char net_device_mask;//rywu20080618
    unsigned char link_status;//rywu20080618
#endif
    //rywu20080526--

	/* Flowbee */
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);

	elmf = &ELMachines[active_index].frame;

	///070813
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_blank);
	//DrawFrameBackground(elmf->rgbtemplate);
	///
	DrawFrameICON(elmf->rgbtemplate);
	#ifdef LEADTEK
	DrawFrameTextMessage(elmf->rgbtemplate, LTK_YELLOW);
	#else
	DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
	#endif

#ifdef NET_MOD
	//rywu20080526++ no matter what mode is right now, we should show network information while link is on.
    memset(localipaddr, 0, IPADDR_LEN);

    //rywu20080618++
    //detect link status
    net_device_mask = detect_net_device();
    link_status = LINK_ERROR;
    if (net_device_mask & NETWORK_DEVICE_LAN)
    {
        link_status = detect_eth();
    }
    else if (net_device_mask & NETWORK_DEVICE_WIRELESS)
    {
        link_status = detect_wifi();
    }
    else if (net_device_mask & NETWORK_DEVICE_ADSL_MODEM)
    {
        link_status = detect_adsl();
    }
    //rywu20080618--

    //rywu20080624 re-detect link status
    isGWSet &= 0xfe;
    if (link_status == LINK_DONE)
    {
        isGWSet |= 0x01;
        
        //rywu20080806++
        KillNetSocket();
        ForkNETSocket();
        //rywu20080806--
    }

  //nelly modify 6/12/2008
	//if(GetLocalIP(localipaddr))
	if(GetLocalIP(localipaddr) && link_status == LINK_DONE)//rywu20080618 (detect_wifi()==LINK_DONE))
    {
        strcpy(tmp, "Local IP Address: ");
        strcat(tmp, localipaddr);
        FontTextOutFormat(
                g_pFontDB_Local,
                (Uint16 *)elmf->rgbtemplate,
                OUTPUT_XRES/2,
                OUTPUT_YRES-2*g_pFontDB_Local->FontSize,
                tmp,
                RED_1555,
                DT_CENTER);
    }
    //rywu20080526--

	//Draw Local IP Address
	if(dev_mnted_enbled_flags.nas)//rywu20080516 || dev_mnted_enbled_flags.rss)
	{
	    /*rywu20080526 moved the below code out of if(dev_mnted_enbled_flags.nas)
		char localipaddr[IPADDR_LEN];
		memset(localipaddr, 0, IPADDR_LEN);
		if(GetLocalIP(localipaddr))
		{
			char tmp[LEN_L] = "Local IP Address: ";
			strcat(tmp, localipaddr);
			FontTextOutFormat(g_pFontDB_Local,
								 (Uint16 *)elmf->rgbtemplate,
								 OUTPUT_XRES/2, //400,
								 OUTPUT_YRES-2*g_pFontDB_Local->FontSizek,//500-shift480,
								 tmp, RED_1555, DT_CENTER);
			//FontTextOutFormat(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, 500, 900, tmp, RED_1555, DT_CENTER);

			//PRINTF("x = %d\n", elmf->frametextmsgcoord.x);
			//PRINTF("y = %d\n", elmf->frametextmsgcoord.y);
		}*/
		char shared_dir[LEN_XL];
		memset(shared_dir, 0, LEN_XL);
		if(GetSharedDir(shared_dir))
		{
			char tmp[LEN_XL] = "Net Disk Shared Directory: ";
			strcat(tmp, shared_dir);
			FontTextOutFormat(g_pFontDB_Local,
								 (Uint16 *)elmf->rgbtemplate,
								 OUTPUT_XRES/2,//400,
								 OUTPUT_YRES-3*g_pFontDB_Local->FontSize,//530-shift480,
								 ///400, 940,
								 tmp, PURPLE_1555, DT_CENTER);
			/*
			FontTextOutFormat(g_pFontDB_Local,
								 (Uint16 *)elmf->rgbtemplate,
								 500, 940,
								 tmp, PURPLE_1555, DT_CENTER);
			*/
		}
	}
#endif
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGB2YUV(1, 1);	//RBG->YUV for TV encoder
	/* Flowbee */
	pgu_switch_to_buffer(1);
	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void MTDisplay()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070813
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_mt);
	//DrawFrameBackground(elmf->rgbtemplate);
	///

///070816 Medialinkestorage icon
#ifndef MEDIALINK
///
	DrawStorageICON(elmf->rgbtemplate);
	#ifdef LEADTEK
	DrawStorageText(elmf->rgbtemplate, LTK_WHITE);
	#else
	  #ifndef NO_WORD
	DrawStorageText(elmf->rgbtemplate, PURPLE_1555);
	  #endif
	#endif
#endif

	#if 0
	DrawFrameICON(elmf->rgbtemplate);
	#endif
	DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGB2YUV(1, 1);	//RBG->YUV for TV encoder
	pgu_switch_to_buffer(1);
	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void SetupL1Display()
{
	///070824 fix eñin Full Image
	memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
	///
	pgu_set_alpha(setup->sys_alpha);
	pgu_enable_overlay(1);
	DrawL1Menu(0);
}
//------------------------------------------------------------------------------------------------
void SetupL2Display()
{
	pgu_set_alpha(setup->sys_alpha);
	pgu_enable_overlay(1);
	DrawL2Menu(0);
}
//------------------------------------------------------------------------------------------------
void SetupL3Display()
{
	pgu_set_alpha(setup->sys_alpha);
	pgu_enable_overlay(1);
	DrawL3Menu(0);
}
//------------------------------------------------------------------------------------------------
/*
void ImgDisplay()
{
	FRAME *elmf;
	ULint32 i = 0L, j = 0L, StopPos;
	Uint8 ICONum;
	LIST *StartList;
	char s[LEN_XL];
	pid_t pid;
	int status;
	char **ImgExecv;
	FILE *fn;
	unsigned int flags=0;

	int diff_sec, diff_usec;
	struct timeval tv, tv_start;

	elmf = &ELMachines[active_index].frame;
	DrawFrameBackground(elmf->rgbtemplate);
	DrawStorageICON(elmf->rgbtemplate);
	DrawStorageText(elmf->rgbtemplate, ORANGE_1555);
	DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);

	elmf->active_frame_index = elmf->active_icon_index / ICON_NUM_PER_FRAME;
	StopPos = elmf->active_frame_index * ICON_NUM_PER_FRAME;

	StartList = ImageList->next;
	while(StartList != NULL && j < StopPos)
	{
		StartList = StartList->next;
		j++;
	}
	if((elmf->active_frame_index + 1) * ICON_NUM_PER_FRAME > ImgCount)
		ICONum = ImgCount % ICON_NUM_PER_FRAME;
	else
		ICONum = ICON_NUM_PER_FRAME;

	if(yuv_idx == 1)
		yuv_idx = 0;

	gettimeofday(&tv_start, 0);
	flags = 0;
	fn = fopen("/tmp/jpgflag.txt", "w");
	fwrite(&flags, 4, 1, fn);
	fclose(fn);

	ImgExecv = malloc( sizeof(char *)*(ICONum+1 + 10) );
	ImgExecv[0] = malloc( strlen("skyview")+1);
	sprintf(ImgExecv[0], "%s", "skyview");
	ImgExecv[1] = malloc( strlen("-thumbnail")+1);
	sprintf(ImgExecv[1], "%s", "-thumbnail");
	ImgExecv[2] = malloc( strlen("-rgb")+1);
	sprintf(ImgExecv[2], "%s", "-rgb");
	ImgExecv[3] = malloc( strlen("0")+1);
	sprintf(ImgExecv[3], "%s", "0");
	ImgExecv[4] = malloc( strlen("-x")+1);
	sprintf(ImgExecv[4], "%s", "-x");
	ImgExecv[5] = malloc( strlen(desc->ICONWidth)+1);
	sprintf(ImgExecv[5], "%s", desc->ICONWidth);
	ImgExecv[6] = malloc( strlen("-y")+1);
	sprintf(ImgExecv[6], "%s", "-y");
	ImgExecv[7] = malloc( strlen(desc->ICONHeight)+1);
	sprintf(ImgExecv[7], "%s", desc->ICONHeight);

	while(StartList != NULL && i < ICONum)
	{
		GetPath(s);
		strcat(s, StartList->fname);
		ImgExecv[8+i] = malloc( strlen(s)+1 );
		sprintf(ImgExecv[8+i], "%s", s);
		i++;
		StartList = StartList->next;
	}
	ImgExecv[8+i] = NULL;

	i = 0;

	while(i < ICONum)
	{
	    if (i==0)
	    {
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				exit(1);
			case 0:
				//child process
				if (i==0)
				{
					RGB2YUV(1, 1);	//RBG->YUV for TV encoder
					pgu_switch_to_buffer(1);

					execv("/sky/skyview", ImgExecv);
				}
				_EXIT;
			default:
				diff_usec = diff_sec = 0;
				while(diff_sec < 1 && diff_usec < 200000)
				{
					usleep(10);

					gettimeofday(&tv, 0);
					diff_sec = tv.tv_sec - tv_start.tv_sec;
					if (tv.tv_usec >= tv_start.tv_usec)
					{
						diff_usec = tv.tv_usec - tv_start.tv_usec;
					}
					else
					{
						diff_usec = 1000000 - tv_start.tv_usec + tv.tv_usec;
						diff_sec--;
					}
				}
//PRINTF("#### time --  %d.%.6d   diff_usec=%d (%s)\n", diff_sec, diff_usec, diff_usec, "start i");

				break;
		}
	    }


		flags=0;
		while( (flags & (1<<i)) == 0)
		{
			fn = fopen("/tmp/jpgflag.txt", "r");
			fread(&flags, 4, 1, fn);
			fclose(fn);
			if ( (flags & (1<<i)) == 0)
			{
				usleep(100);
				usleep(100);
			}
		}

		DrawThumbnail2(elmf->rgbtemplate, i, ICON_WIDTH, ICON_HEIGHT);
		ConvertThumbnail2YUV(elmf->rgbtemplate, 1, i, ICON_WIDTH, ICON_HEIGHT);

		i++;
	}

//  gettimeofday(&tv, 0);
//  diff_sec = tv.tv_sec - tv_start.tv_sec;
//  if (tv.tv_usec >= tv_start.tv_usec)
//  {
//    diff_usec = tv.tv_usec - tv_start.tv_usec;
//  }
//  else
//  {
//    diff_usec = 1000000 - tv_start.tv_usec + tv.tv_usec;
//    diff_sec--;
//  }

  waitpid(pid, &status, 0);

  while(i<ICONum)
  {
	DrawThumbnail2(elmf->rgbtemplate, i, ICON_WIDTH, ICON_HEIGHT);
	ConvertThumbnail2YUV(elmf->rgbtemplate, 1, i, ICON_WIDTH, ICON_HEIGHT);

  	i++;
  }

  i = 0;
  while( ImgExecv[i] != NULL )
  {
  	free(ImgExecv[i]);
  	i++;
  }
  free(ImgExecv);

//PRINTF("#### time --  %d.%.6d (%s)\n", diff_sec, diff_usec, "bf DrawFocused");
	DrawFocusedICON(RGB1);
}
*/
//------------------------------------------------------------------------------------------------
///* 070723 - integrated with Robert's thumbnail speed up
void ImgDisplay()
{
	FRAME *elmf;
	ULint32 i = 0L, j = 0L, StopPos;
	Uint8 ICONum;
	LIST *StartList;
	char s[LEN_XL];
	pid_t pid;
	int status;

	elmf = &ELMachines[active_index].frame;

	///070814
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_photo);
	//DrawFrameBackground(elmf->rgbtemplate);
	///

	DrawStorageICON(elmf->rgbtemplate);

///070816 Medialinkeicon text
#ifndef MEDIALINK
///
	#ifdef LEADTEK
	DrawStorageText(elmf->rgbtemplate, LTK_WHITE);
	#else
	  #ifndef NO_WORD
	DrawStorageText(elmf->rgbtemplate, PURPLE_1555);
	  #endif
	#endif
#endif

	#ifdef LEADTEK
	DrawFrameTextMessage(elmf->rgbtemplate, LTK_ORANGE);
	#else
		#ifdef WINGUI
		DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
		#else
		  #ifndef DARK_BLUE_DESIGN
		DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
		  #else
		DrawFrameTextMessage(elmf->rgbtemplate, MEDIA_FRAMEMESSAGE);
		  #endif
		#endif
	#endif
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGB2YUV(1, 1);	//RBG->YUV for TV encoder
	pgu_switch_to_buffer(1);

	elmf->active_frame_index = elmf->active_icon_index / ICON_NUM_PER_FRAME;
	StopPos = elmf->active_frame_index * ICON_NUM_PER_FRAME;

	StartList = ImageList->next;
	while(StartList != NULL && j < StopPos)
	{
		StartList = StartList->next;
		j++;
	}
	if((elmf->active_frame_index + 1) * ICON_NUM_PER_FRAME > ImgCount)
		ICONum = ImgCount % ICON_NUM_PER_FRAME;
	else
		ICONum = ICON_NUM_PER_FRAME;

	if(yuv_idx == 1)
		yuv_idx = 0;

	while(StartList != NULL && i < ICONum)
	{
		GetPath(s);
		strcat(s, StartList->fname);
		//DPRINTF("Path of image file = %s\n", s);
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DPRINTF("Fork to Draw Photo Thumbnail No.%d Fail!\n", i);
				break;
				//exit(1);
			case 0:
				//child process
				///memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
				execl("/sky/skyview", "skyview", "-thumbnail", "-rgb", "0", "-x", desc->ICONWidth, "-y", desc->ICONHeight, s, NULL);
				_EXIT;
			default:
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
				{
					DrawThumbnail(elmf->rgbtemplate, i, ICON_WIDTH, ICON_HEIGHT);
					///070904
					DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate,
										elmf->icon_arr[i].icoord.x, elmf->icon_arr[i].icoord.y, elmf->icon_arr[i].icoord.width, elmf->icon_arr[i].icoord.height);
					ConvertThumbnail2YUV(RGB1, 1, i, ICON_WIDTH, ICON_HEIGHT);
					//ConvertThumbnail2YUV(elmf->rgbtemplate, 1, i, ICON_WIDTH, ICON_HEIGHT);
					///
				}
				break;
		}
		i++;
		StartList = StartList->next;
	}
	DrawFocusedICON(RGB1, 1);
}
//*/
//------------------------------------------------------------------------------------------------
void FImgDisplay()
{
	EVENT_LOOP_MACHINE *prevMachine;
	char *where;
	char s[LEN_XL];
	pid_t pid;
	int status;

	prevMachine = &ELMachines[I_ACTIVE];

	if(yuv_idx)// == 1
	{
		where = "1";
		yuv_idx = 0;
	}
	else// == 0
	{
		where = "0";
		yuv_idx = 1;
	}
	//DPRINTF("YUV(%s)\n", where);
	GetPath(s);
	strcat(s, prevMachine->frame.CurrImgListPos->fname);
	//DPRINTF("Path of image file = %s\n", s);
	DrawEXIF(s);
	/* Flowbee */
	if(osd_info.current_mode == I_ACTIVE)
	{
		osd_parser();
	}
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			DPRINTF("Fork to Draw Image: %s\n", s);
			break;
			//exit(1);
		case 0:
			//child process
#ifdef USE_DESC_LCD
			execl("/sky/skyview", "skyview", "-yuv", where, s, NULL);
#else
			memset((Uint8*)planes.Y[1 - yuv_idx], 0x10, RGB_FRAMEBUFF_SIZE >> 1);//Y
			memset((Uint8*)planes.U[1 - yuv_idx], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//U
			memset((Uint8*)planes.V[1 - yuv_idx], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//V
	#ifdef WINGUI
			if (setup->display_full_screen_idx)
				execl("/sky/skyview", "skyview", "-yuv", where, "-scalemode", "6", s, NULL);
			else
			{
				if(isLowPassMode)
					execl("/sky/skyview", "skyview", "-yuv", where, "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
				else
					execl("/sky/skyview", "skyview", "-yuv", where, "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
			}
	#else
			if(isLowPassMode)
				execl("/sky/skyview", "skyview", "-yuv", where, "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
			else
				execl("/sky/skyview", "skyview", "-yuv", where, "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
#endif
#endif
			_EXIT;
		default:
			//parent process
			waitpid(pid, &status, 0);
			if(WIFEXITED(status))
			{
				/* Flowbee@960407. */
				if(osd_parser())
					pgu_switch_to_buffer(1 - yuv_idx);
			}
			break;
	}
}
//------------------------------------------------------------------------------------------------
void AudDisplay()
{
	FRAME *elmf;
	char fname[LEN_XL];
	ULint32 i = 0L, j = 0L, k;
	Uint32 ICONum, StopPos;
	LIST *StartList;
	FileInfo finfo;
	Uint32 duration;
	char sDuration[LEN_M];
	Uint16 x, y;

	//KillAudioProcess();
	//isOnlyAudPrcsForked = FALSE;

	elmf = &ELMachines[active_index].frame;
	elmf->active_frame_index = elmf->active_icon_index / MUSIC_BAR_NUM;
	StopPos = elmf->active_frame_index * MUSIC_BAR_NUM;

	StartList = AudioList->next;
	while(StartList != NULL && j < StopPos)
	{
		StartList = StartList->next;
		j++;
	}
	if((elmf->active_frame_index + 1) * MUSIC_BAR_NUM > AudCount)
		ICONum = AudCount % ICONum;
	else
		ICONum = MUSIC_BAR_NUM;

	///070814
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_music);
	//DrawFrameBackground(elmf->rgbtemplate);
	///

	DrawStorageICON(elmf->rgbtemplate);

///070816 Medialinkeicon text
#ifndef MEDIALINK
///
	#ifdef LEADTEK
	DrawStorageText(elmf->rgbtemplate, LTK_WHITE);
	#else
	  #ifndef NO_WORD
	DrawStorageText(elmf->rgbtemplate, PURPLE_1555);
	  #endif
	#endif
#endif

	#ifdef LEADTEK
	DrawFrameTextMessage(elmf->rgbtemplate, LTK_YELLOW);
	#else
		#ifdef WINGUI
		DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
		#else
		  #ifndef DARK_BLUE_DESIGN
		DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
		  #else
		DrawFrameTextMessage(elmf->rgbtemplate, MEDIA_FRAMEMESSAGE);
		  #endif
		#endif
	#endif

	///071012 o̡AeIW
	DrawRepeatMode();
	///

	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGB2YUV(1, 1);	//RBG->YUV for TV encoder
	pgu_switch_to_buffer(1);

	for(k = 0; k < NUM_OF_AUDIO_LIST; k++)
	{
		isCurrMusicPlayble[k] = 0;
		memset(musicDurationList[k], '\0', LEN_M);
	}
	while(StartList != NULL && i < ICONum)
	{
		x = elmf->icon_arr[i].txtcoord.x;
		y = elmf->icon_arr[i].txtcoord.y;
		GetPath(fname);
		strcat(fname, StartList->fname);
		if(MediaParser(fname, &finfo) == PlayableMusic)
		{
			isCurrMusicPlayble[i] = 1;
			duration = (Uint32)finfo.AudioDuration;
			memset(sDuration, 0, LEN_M);
			sprintf(sDuration, "%2d:%02d", duration / 60, duration % 60);
			strcpy(musicDurationList[i], sDuration);
			//Draw Audio File Name
			///080201
			#ifdef WINGUI
			FontTextOutFileName(g_pFontDB_Local, StartList->fname,
								NLS_USE_UTF,
								FALSE,	//ܸ|
								BLACK_1555,
								(Uint16*)elmf->rgbtemplate, OUTPUT_XRES,
								x, y, elmf->icon_arr[i].txtcoord.width, 0);
			#else
			FontTextOutFileName(g_pFontDB_Local, StartList->fname,
								NLS_USE_UTF,
								FALSE,	//ܸ|
								#ifndef DARK_BLUE_DESIGN
								BLUE_1555,
								#else
								MUSIC_FILENAME,
								#endif
								(Uint16*)elmf->rgbtemplate, OUTPUT_XRES,
								x, y, elmf->icon_arr[i].txtcoord.width, 0);
			#endif
			//memset(fname, 0, LEN_XL);
			//GetSuitableLengthString(fname, StartList->fname, '~', 32/*23*/, TRUE);
			//FontTextOut(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, x, y, (BYTE*)fname, BLUE_1555);
			///

			//Draw duration
			#ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->rgbtemplate, x+elmf->icon_arr[i].txtcoord.width, y, sDuration, BLUE_1555);
			#else
			FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->rgbtemplate, x+elmf->icon_arr[i].txtcoord.width, y, sDuration, MUSIC_DURATION);
			#endif
		}
		else
		{
			memset(sDuration, 0, LEN_M);
			strcpy(sDuration, "--:--");
			strcpy(musicDurationList[i], sDuration);

			//Draw Audio File Name
			///080201
			#ifdef WINGUI
			FontTextOutFileName(g_pFontDB_Local, StartList->fname,
								NLS_USE_UTF,
								FALSE,	//ܸ|
								RED_1555,
								(Uint16*)elmf->rgbtemplate, OUTPUT_XRES,
								x, y, elmf->icon_arr[i].txtcoord.width, 0);
			#else
			FontTextOutFileName(g_pFontDB_Local, StartList->fname,
								NLS_USE_UTF,
								FALSE,	//ܸ|
								GREY40_1555,
								(Uint16*)elmf->rgbtemplate, OUTPUT_XRES,
								x, y, elmf->icon_arr[i].txtcoord.width, 0);
			#endif
			//memset(fname, 0, LEN_XL);
			//GetSuitableLengthString(fname, StartList->fname, '~', 32/*23*/, TRUE);
			//FontTextOut(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, x, y, fname, GREY40_1555);
			///

			//Draw duration
			FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->rgbtemplate, x+elmf->icon_arr[i].txtcoord.width, y, sDuration, GREY40_1555);
		}

		///080904
		DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate,
							desc->MiscTextCoord[30].x, y, desc->MiscTextCoord[30].width, g_pFontDB_Local->FontSize);
		RGBlock2YUVBlock(RGB1, 1, desc->MiscTextCoord[30].x, y, desc->MiscTextCoord[30].width, g_pFontDB_Local->FontSize);
		///

		i++;
		StartList = StartList->next;
	}

	#ifdef USE_DESC_TV
	if(isMutePressed)
		DrawMute();
	#endif

	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void VidDisplay()
{
	FRAME *elmf;
	ULint32 i = 0L, j = 0L, StopPos;
	Uint8 ICONum;
	LIST *StartList;
	char s[LEN_XL];
	pid_t pid;
	int status, w, h;
	FileInfo finfo;
	Uint32 thumbnialsize;
	Uint8 videonotsupportidx;

	elmf = &ELMachines[active_index].frame;

	#ifdef USE_DESC_TV
	if(isMutePressed)
		MuteEvent();
	if(isVolumePressed)
		pgu_enable_tv_osd(0);
	memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
	#endif

	printf("Video Preview Display\n");//to avoid arc kernel bug

	///070814
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_video);
	//DrawFrameBackground(elmf->rgbtemplate);
	///

	DrawStorageICON(elmf->rgbtemplate);

///070816 Medialinkeicon text
#ifndef MEDIALINK
///
	#ifdef LEADTEK
	DrawStorageText(elmf->rgbtemplate, LTK_WHITE);
	#else
	  #ifndef NO_WORD
	DrawStorageText(elmf->rgbtemplate, PURPLE_1555);
	  #endif
	#endif
#endif

	#ifdef LEADTEK
	DrawFrameTextMessage(elmf->rgbtemplate, LTK_ORANGE);
	#else
		#ifdef WINGUI
		DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
		#else
		  #ifndef DARK_BLUE_DESIGN
		DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
		  #else
		DrawFrameTextMessage(elmf->rgbtemplate, MEDIA_FRAMEMESSAGE);
		  #endif
		#endif
	#endif
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGB2YUV(1, 1);//RBG->YUV for TV encoder
	pgu_switch_to_buffer(1);

	elmf->active_frame_index = elmf->active_icon_index / ICON_NUM_PER_FRAME;
	StopPos = elmf->active_frame_index * ICON_NUM_PER_FRAME;

	StartList = VideoList->next;
	while(StartList != NULL && j < StopPos)
	{
		StartList = StartList->next;
		j++;
	}
	if((elmf->active_frame_index + 1) * ICON_NUM_PER_FRAME > VidCount)
		ICONum = VidCount % ICON_NUM_PER_FRAME;
	else
		ICONum = ICON_NUM_PER_FRAME;

	thumbnialsize = ICON_WIDTH * ICON_HEIGHT * 2;
	videonotsupportidx = ICON_NUM_PER_FRAME;

	while(StartList != NULL && i < ICONum)
	{
		GetPath(s);
		strcat(s, StartList->fname);
		//DPRINTF("Path of video file = %s\n", s);
		if(MediaParser(s, &finfo) == PlayableVideo)
		{
			pid = fork();
			switch(pid)
			{
				case -1:
					perror("Fork failed!");
					DPRINTF("Fork to Draw Video Preview Thumbnail of '%s' Fail!\n", s);
					break;
					//exit(1);
				case 0:
					//child process
					//memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
					////execl("/sky/mplayer", "mplayer", "-vo", "arcpgufb", "-nosound", "-preview", "-really-quiet", "-sx", desc->ICONWidth, "-sy", desc->ICONHeight, s, NULL);
					//execl("/sky/mplayer", "mplayer", "-nosound", "-preview", "-really-quiet", "-sx", desc->ICONWidth, "-sy", desc->ICONHeight, s, NULL);
					w = atoi(desc->ICONWidth);
					h = atoi(desc->ICONHeight);
					memset(RGB0, 0, w * h * 4);//070611 - raymond
					if(finfo.FileType == FILE_TYPE_AVI)
						execl("/sky/mplayer", "mplayer", "-nosound", "-demuxer", "3", "-preview", "-really-quiet", "-sx", desc->ICONWidth, "-sy", desc->ICONHeight, s, NULL);
					else if(finfo.FileType == FILE_TYPE_ASF)
						execl("/sky/mplayer", "mplayer", "-nosound", "-demuxer", "6", "-preview", "-really-quiet", "-sx", desc->ICONWidth, "-sy", desc->ICONHeight, s, NULL);
					else if(finfo.FileType == FILE_TYPE_MOV)
						execl("/sky/mplayer", "mplayer", "-nosound", "-demuxer", "7", "-preview", "-really-quiet", "-sx", desc->ICONWidth, "-sy", desc->ICONHeight, s, NULL);
					else
						execl("/sky/mplayer", "mplayer", "-nosound", "-preview", "-really-quiet", "-sx", desc->ICONWidth, "-sy", desc->ICONHeight, s, NULL);
					_EXIT;
				default:
					waitpid(pid, &status, 0);
					if(WIFEXITED(status))
					{
						DrawThumbnail(elmf->rgbtemplate, i, ICON_WIDTH, ICON_HEIGHT);
						///070905
						DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate,
											elmf->icon_arr[i].icoord.x, elmf->icon_arr[i].icoord.y, elmf->icon_arr[i].icoord.width, elmf->icon_arr[i].icoord.height);
						ConvertThumbnail2YUV(RGB1, 1, i, ICON_WIDTH, ICON_HEIGHT);
						//ConvertThumbnail2YUV(elmf->rgbtemplate, 1, i, ICON_WIDTH, ICON_HEIGHT);
						///
					}
					break;
			}
		}
		else
		{
			//DPRINTF("Not support this video file = %s\n", s);

			//Set VidoNotSupport Thumbnail position & Draw it
			elmf->icon_arr[videonotsupportidx].icoord = elmf->icon_arr[i].icoord;
			memcpy(RGB0, elmf->icon_arr[videonotsupportidx].iconbuff, thumbnialsize);

			DrawThumbnail(elmf->rgbtemplate, videonotsupportidx, ICON_WIDTH, ICON_HEIGHT);
			///070905
			DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate,
								elmf->icon_arr[videonotsupportidx].icoord.x, elmf->icon_arr[videonotsupportidx].icoord.y, elmf->icon_arr[videonotsupportidx].icoord.width, elmf->icon_arr[videonotsupportidx].icoord.height);
			ConvertThumbnail2YUV(RGB1, 1, videonotsupportidx, ICON_WIDTH, ICON_HEIGHT);
			//ConvertThumbnail2YUV(elmf->rgbtemplate, 1, videonotsupportidx, ICON_WIDTH, ICON_HEIGHT);
			///

			//reset not_support_icon image position
			elmf->icon_arr[ICON_NUM_PER_FRAME].icoord.x = 0;
			elmf->icon_arr[ICON_NUM_PER_FRAME].icoord.y = 0;
		}
		i++;
		StartList = StartList->next;
	}
	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void FVidDisplay()
{
	EVENT_LOOP_MACHINE *prevMachine;
	char s[LEN_XL];
	int prio;
	Uint8 displayMode;

	//turn off playing time osd to avoid flashing when switching video (video repeat, next, prev) by bk @ 070911
	displayMode = GetDisplayIndex();
#ifdef USE_DESC_LCD
	if(
			displayMode == DISP_800x600_LCD
		|| 	displayMode == DISP_800x480_LCD
		|| 	displayMode == DISP_1024x600_LCD
		|| 	displayMode == DISP_800x480_LCD_25MHZ
	)
	{
		tcon_clear_all_osd_item();
	}
  #ifdef USE_DESC_TV
	else
  #endif
#endif
#ifdef USE_DESC_TV
	{
		pgu_enable_tv_osd(0);
		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
	}
#endif

	/* Flowbee@960506. */
	if(isMutePressed || isVolumePressed)
	{
		#if USE_TERAWINS_TCON
		tcon_clear_mute_vol();
		#else
		pgu_enable_overlay(0);
		#endif
	}
	KillVideoProcess();
	isVidPrcsForked = FALSE;

	prevMachine = &ELMachines[V_ACTIVE];

	GetPath(s);
	strcat(s, prevMachine->frame.CurrVidListPos->fname);
	//DPRINTF("Path of video file = %s\n", s);

	set_ir_value((unsigned long)0x0);//reset ir_value
	pid_vid = fork();
	switch(pid_vid)
	{
		case -1:
			perror("Fork failed!");
			DPRINTF("Fork to Play Video '%s' Fail!\n", s);
			break;
			//exit(1);
		case 0:
			//child process
			//execl("/sky/mplayer", "mplayer", "-vo", "arcpgufb", "-ao", "oss", "-arcdemo", "-really-quiet", "-stime", "1", s, NULL);
			//execl("/sky/mplayer", "mplayer", "-vo", "arcpgufb", "-ao", "oss", "-arcdemo", "-really-quiet", s, NULL);
			//execl("/sky/mplayer", "mplayer", "-vo", "arcpgufb", "-ao", "oss", "-really-quiet", s, NULL);
			execl("/sky/mplayer", "mplayer", "-arcdemo", "-quiet", s, NULL);//-arcdemo will cause problem while setup key pressed twice in V_ACTIVE state machine!
			//execl("/sky/mplayer", "mplayer", "-quiet", s, NULL);
			_EXIT;
		default:
			//parent process
			isVidPrcsForked = TRUE;
#ifdef SET_VID_PRIO
			prio = getpriority(PRIO_PROCESS, (int)pid_vid);
	      		setpriority(PRIO_PROCESS, (int)pid_vid, prio - VID_PRIO_LVL);
#endif
#ifdef SET_VID_SKY_PRIO
			SkyPrio = getpriority(PRIO_PROCESS, 0);
  			setpriority(PRIO_PROCESS, 0, SkyPrio + VID_SKY_PRIO_LVL);
#endif
			memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);//memset for tv displaying time - bk @ 070817
			//delay for drawing mute, vol if mplayer needs long time to init
			//sleep(2);
			int i = 0;
			for(i = 0; i < 100000; i++)
			{
				if(MPLAYER_INIT != get_mplayer_status())
					break;
			}
			if(isMutePressed)
			{
				DrawMute();
				#if USE_TERAWINS_TCON

				#else
				pgu_enable_overlay(1);
				osd_parser();
				#endif
			}
			else if(isVolumePressed)
			{
				DrawVolume();
				#if USE_TERAWINS_TCON

				#else
				pgu_enable_overlay(1);
				osd_parser();
				#endif
			}
			break;
	}
}
//------------------------------------------------------------------------------------------------
void DecodeSSIMG()
{
	FRAME *elmf;
	char s[LEN_XL];
	int prio;
	extern struct timeval TrDoneTime;
	extern Uint32 flg4GetNewTrDoneTime;

	elmf = &ELMachines[active_index].frame;

	GetPath(s);
	strcat(s, elmf->CurrImgListPos->fname);
	//DPRINTF("Path of image file = %s\n", s);

	pid_img = fork();
	switch(pid_img)
	{
		case -1:
			perror("Fork failed!");
			DMSG("Fork to SS Skyview Fail!");
			break;
			//exit(1);
		case 0:
			//child process
#ifdef USE_DESC_LCD
			execl("/sky/skyview", "skyview", "-yuv", "0", "-delay", s, NULL);
#else
			memset((Uint8*)planes.Y[0], 0x10, RGB_FRAMEBUFF_SIZE >> 1);//Y
			memset((Uint8*)planes.U[0], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//U
			memset((Uint8*)planes.V[0], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//V

	#ifdef WINGUI
			if (setup->display_full_screen_idx)
				execl("/sky/skyview", "skyview", "-yuv", "0", "-scalemode", "6", s, NULL);
			else
			{
				if(isLowPassMode)
					execl("/sky/skyview", "skyview", "-yuv", "0", "-delay", "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
				else
					execl("/sky/skyview", "skyview", "-yuv", "0", "-delay", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
			}
	#else

			if(isLowPassMode)
				execl("/sky/skyview", "skyview", "-yuv", "0", "-delay", "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
			else
				execl("/sky/skyview", "skyview", "-yuv", "0", "-delay", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
#endif
#endif
			_EXIT;
		default:
			//parent process
			if(!flg4GetNewTrDoneTime)
			{
				gettimeofday(&TrDoneTime, NULL);
				//PRINTF("TrDoneTime.tv_sec = %d\n", TrDoneTime.tv_sec);
				flg4GetNewTrDoneTime = 1;
			}

			#if 0
			if(!isSSImgPrcsForked)
				waitpid(pid_img, &sts_img, 0);
			#endif
			isSSImgPrcsForked = TRUE;
			slide_state = SLIDE_IN_JPEG;
#ifdef SET_SS_IMG_PRIO
			prio = getpriority(PRIO_PROCESS, (int)pid_img);
			setpriority(PRIO_PROCESS, (int)pid_img, prio + SS_IMG_PRIO_LVL);//reduce skyview priority
#endif
			break;
	}
}
//------------------------------------------------------------------------------------------------
void DecodeSSAUD()
{
	FRAME *elmf;
	char s[LEN_XL];
	int prio;

	elmf = &ELMachines[active_index].frame;

	KillAudioProcess();
	isSSAudPrcsForked = FALSE;

	memset(s, 0, LEN_XL);
	if(!isFlashMusicUsed)
		GetPath(s);
	strcat(s, elmf->CurrAudListPos->fname);
	//DPRINTF("Path of audio file = %s\n", s);

	pid_aud = fork();
	switch(pid_aud)
	{
		case -1:
			perror("Fork failed!");
			DPRINTF("Fork to Decode SS Audio '%s' Fail!\n", s);
			break;
			//exit(1);
		case 0:
			//child process
			execl("/sky/mplayer", "mplayer", "-acache", "-arcdemo", "-really-quiet", "-novideo", s, NULL);
			//execl("/sky/mplayer", "mplayer", "-acache", "-really-quiet", s, NULL);
			_EXIT;
		default:
			//parent process
			isSSAudPrcsForked = TRUE;
#ifdef SET_SS_AUD_PRIO
			prio = getpriority(PRIO_PROCESS, (int)pid_aud);
			setpriority(PRIO_PROCESS, (int)pid_aud, prio - SS_AUD_PRIO_LVL);
#endif
			break;
	}
}
//------------------------------------------------------------------------------------------------
void SSDisplay()
{
	FRAME *elmf;
	char s[LEN_XL];
	pid_t pid;
	int status;
	LIST *StartList = NULL;
	ULint32 i = 0;

	/* Flowbee@960510. */
	slide_state = SLIDE_IN_START;
	jpeg_state = IN_START;
	tr_state = IN_START;
	clear_osd_info();

	elmf = &ELMachines[active_index].frame;
#if 0
	elmf->CurrImgListPos = ImageList->next;
#else
	StartList = ImageList->next;
	while(StartList != NULL && i < CurrPhotoIdx4SSCal)
	{
		StartList = StartList->next;
		i++;
	}
	elmf->CurrImgListPos = StartList;
#endif
	elmf->CurrAudListPos = AudioList->next;

#if 1
	///070816
	memset(RGB1, 0, RGB_FRAMEBUFF_SIZE);
	// for LeadTek, by Xenia 2007/12/04
	#ifdef LEADTEK
	DrawFrameBackground(RGB1);
	#else
	DrawFrameTextMessage(RGB1, YELLOW_1555);
	#endif
	/*
	DrawFrameBackground(elmf->rgbtemplate);
	DrawFrameTextMessage(elmf->rgbtemplate, BLUE_1555);
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	*/
	///

	//RBG->YUV for TV encoder
	RGB2YUV(1, 0);
	pgu_switch_to_buffer(0);
#endif

#ifdef SET_SS_SKY_PRIO
	SkyPrio = getpriority(PRIO_PROCESS, 0);
  	setpriority(PRIO_PROCESS, 0, SkyPrio + SS_SKY_PRIO_LVL);// + reduces priority
#endif

	GetPath(s);
	strcat(s, elmf->CurrImgListPos->fname);
	//DPRINTF("Path of image file = %s\n", s);

	pid = fork();
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			DPRINTF("Fork to Display SS Image '%s' Fail!\n", s);
			return;
			//exit(1);
		case 0:
			//child process
#ifdef USE_DESC_LCD
			execl("/sky/skyview", "skyview", "-yuv", "1", "-delay", s, NULL);
#else
			memset((Uint8*)planes.Y[1], 0x10, RGB_FRAMEBUFF_SIZE >> 1);//Y
			memset((Uint8*)planes.U[1], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//U
			memset((Uint8*)planes.V[1], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//V

	#ifdef WINGUI
			if (setup->display_full_screen_idx)
				execl("/sky/skyview", "skyview", "-yuv", "1", "-scalemode", "6", s, NULL);
			else
			{
				if(isLowPassMode)
					execl("/sky/skyview", "skyview", "-yuv", "1", "-delay", "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
				else
					execl("/sky/skyview", "skyview", "-yuv", "1", "-delay", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
			}
	#else
			if(isLowPassMode)
				execl("/sky/skyview", "skyview", "-yuv", "1", "-delay", "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
			else
				execl("/sky/skyview", "skyview", "-yuv", "1", "-delay", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, s, NULL);
	#endif
#endif
			_EXIT;
		default:
			//parent process
			waitpid(pid, &status, 0);
			sleep(1);
			if(WIFEXITED(status))
				pgu_switch_to_buffer(1);
			break;
	}

#ifdef NAS_SL_IMG_ONLY
	if(dev_mnted_enbled_flags.nas != 1)
#endif
	{
		if(AudCount != 0)
			DecodeSSAUD();
	}
	//fixed bug by bk@070408 - when only one image, SS will be exception
	if(CurrPhotoIdx4SSCal != ImgCount - 1)
		elmf->CurrImgListPos = elmf->CurrImgListPos->next;
	DecodeSSIMG();
}
//------------------------------------------------------------------------------------------------
void USB2PConnDisplay()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070814
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_usb2pconn);
	//DrawFrameBackground(elmf->rgbtemplate);
	///

	#ifdef WINGUI
	DrawFrameTextMessage(elmf->rgbtemplate, YELLOW_1555);
	#else
	  #ifdef DARK_BLUE_DESIGN
	DrawFrameTextMessage(elmf->rgbtemplate, WHITE_1555);
	  #else
	DrawFrameTextMessage(elmf->rgbtemplate, BLUE_1555);
	  #endif
	#endif

	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);

	//RBG->YUV for TV encoder
	RGB2YUV(1, 1);
#ifdef NET_MOD
	{
		char show_buffer[LEN_XL];
		char tmp[LEN_XL];
		memset(show_buffer, 0, LEN_XL);
		unsigned char mode_id;
		int id;

		umount(NET_PATH);
		if (dhcp_pid > 0)
		{
			//KILL(dhcp_pid);
			dhcpsts = 0;
			kill(dhcp_pid,9);
			waitpid(dhcp_pid, &dhcpsts, WNOHANG);
			dhcp_pid = 0;
		}
		usleep(100);						//tyhuang: wait system ip layer down
		if( (isGWSet & 2)!=0 )
			system("ifconfig eth0 down");	//check down
		if( (isGWSet & 4)!=0 )
			system("ifconfig rausb0 down");	//check down
		isGWSet = 0;
		if(GetSSID(show_buffer))
		{
			///080328
			shift480 = (OUTPUT_YRES==480 ? 100 : 0);
			///

			strcpy(tmp,"SSID:");
			strcat(tmp, show_buffer);
			FontTextOutFormat(g_pFontDB_Local,
			(Uint16 *)elmf->rgbtemplate,
			OUTPUT_XRES/2-30, 350-shift480,"Wireless Setting", RED_1555, DT_CENTER);
			FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, OUTPUT_XRES,
			200, 380-shift480,400, tmp, ORANGE_1555);
			memset(show_buffer, 0, strlen(show_buffer));
			if(GetAuthMode(show_buffer,&mode_id))
			{
				strcpy(tmp,"AuthMode:");
				strcat(tmp, show_buffer);
				FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, OUTPUT_XRES,
			200, 410-shift480,400, tmp, ORANGE_1555);
				memset(show_buffer, 0, strlen(show_buffer));
				if(GetEncrypType(show_buffer,&mode_id))
				{
					strcpy(tmp,"Encryption:");
					strcat(tmp, show_buffer);
					FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, OUTPUT_XRES,
					200, 440-shift480,400, tmp, ORANGE_1555);
					if(GetRunKeyID(&id,&mode_id))
					{
						memset(show_buffer, 0, strlen(show_buffer));
						if(GetRunKey(show_buffer,id))
						{
							strcpy(tmp,"RunningKey:");
							strcat(tmp, show_buffer);
							FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, OUTPUT_XRES,
							200, 470-shift480,400, tmp, ORANGE_1555);
							RGBlock2YUVBlock((Uint8 *)elmf->rgbtemplate,1,200,350-shift480,400,180);
							//printf("********** ok ***************\n");
						}
						else
							RGBlock2YUVBlock((Uint8 *)elmf->rgbtemplate,1,200,350-shift480,400,180);
					}
				}
			}
		}
	}
#endif
	pgu_switch_to_buffer(1);

}
//------------------------------------------------------------------------------------------------
void NoStorageDisplay()
{
	FRAME *elmf;

	/* Flowbee */
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);

	elmf = &ELMachines[active_index].frame;

	///070816
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_nodevice);
	//DrawFrameBackground(elmf->rgbtemplate);
	///

	DrawFrameTextMessage(elmf->rgbtemplate, BLUE_1555);

	// INFO
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	/* Flowbee */
	RGB2YUV(1, 1);
	pgu_switch_to_buffer(1);
	pgu_start_pgu();
}
//------------------------------------------------------------------------------------------------
/**
  * It's a sub event looping machine. Because of only using on delete, copy events, it is now bounded only on
  * setup_active. This display will pop out a confirm window to that user select.
  *     init - only register key function.
  *     display - draw on MiscBuf memory, final copy to framebuf and switch to overlay mode to display
  *     shutdown - reset register key, and back to setup
  */
void ConfirmDisplay()
{
	FRAME *elmf;
	Uint16 cx, cy, Len, w, h;
	unsigned long buf_x, xres, yres;
	Uint16 FONT_HEIGHT = 26;
	if (g_pFontDB_Local) FONT_HEIGHT = g_pFontDB_Local->FontSize;

	elmf = &ELMachines[active_index].frame;

	pgu_get_yuv_resolution(&buf_x, &xres, &yres);
	cx = (Uint16)xres >> 1;
	cy = (Uint16)yres >> 1;

	w = FONT_HEIGHT * 10;
	if ((Len = GetFontStringWidth(g_pFontDB_Local, ConfirmText)) > w) w = Len;
	w += (w >> 1);
	h = g_pFontDB_Local->FontSize * 8;

	//draw box and border
	DrawRectBitmap((Uint16 *)elmf->rgbtemplate, cx-(w>>1), cy-(h>>1), w, h, WHITE_1555);
	//DrawRectBitmap((Uint16 *)elmf->rgbtemplate, (OUTPUT_XRES - 360) / 2, 200, 360, 200, WHITE_1555);
	DrawBorder((Uint16 *)elmf->rgbtemplate, cx-(w>>1), cx+(w>>1), cy-(h>>1), cy+(h>>1), 2, BLACK_1555);
	//DrawBorder((Uint16 *)elmf->rgbtemplate, (OUTPUT_XRES - 360) / 2, (OUTPUT_XRES + 360) / 2, 200, 400, 2, BLACK_1555);

	//draw 2 buttons and border
	DrawBorder((Uint16 *)elmf->rgbtemplate, cx-5*FONT_HEIGHT, cx-FONT_HEIGHT, cy+FONT_HEIGHT/2, cy+FONT_HEIGHT*5/2, 2, BLACK_1555);
	//DrawBorder((Uint16 *)elmf->rgbtemplate, (OUTPUT_XRES - 240) / 2, (OUTPUT_XRES -40) / 2, 320, 370, 2, BLACK_1555);
	DrawBorder((Uint16 *)elmf->rgbtemplate, cx+FONT_HEIGHT, cx+5*FONT_HEIGHT, cy+FONT_HEIGHT/2, cy+FONT_HEIGHT*5/2, 2, BLACK_1555);
	//DrawBorder((Uint16 *)elmf->rgbtemplate, (OUTPUT_XRES + 40) / 2, (OUTPUT_XRES + 240) / 2, 320, 370, 2, BLACK_1555);


	//draw 2 buttons words and confirm msg
	FontTextOutFormat(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, cx-3*FONT_HEIGHT, cy+FONT_HEIGHT, FrameText[setup->Language][15], BLACK_1555, DT_CENTER);
	//FontTextOut(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, (OUTPUT_XRES - 180) / 2, 330, FrameText[setup->Language][15], BLACK_1555);
	FontTextOutFormat(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, cx+3*FONT_HEIGHT, cy+FONT_HEIGHT, FrameText[setup->Language][16], BLACK_1555, DT_CENTER);
	//FontTextOut(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, (OUTPUT_XRES + 100) / 2, 330, FrameText[setup->Language][16], BLACK_1555);
	FontTextOutFormat(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, cx, cy-2*FONT_HEIGHT, ConfirmText, BLACK_1555, DT_CENTER);
	//FontTextOut(g_pFontDB_Local, (Uint16 *)elmf->rgbtemplate, (OUTPUT_XRES - 300) / 2, 250, ConfirmText, BLACK_1555);

 	DrawConfirmButtonFocus();
}
//------------------------------------------------------------------------------------------------
void CalDisplay()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070815 templateܦI
	Uint8* dest = RGB1;
	if (prev_active_index == FI_ACTIVE) dest = RGB0;
	//Uint8* dest = elmf->rgbtemplate;
	///

	if(!isCalPressed)
	{
//movie down, playing audio after draw screen
//		if(AudCount != 0)
//		{
//			elmf->CurrAudListPos = AudioList->next;
//			DecodeSSAUD();
//		}

		///070825 MI
		memset(dest, 0, RGB_FRAMEBUFF_SIZE);
		///

		///070815
		CopyBlockBitmap((Uint16*)dest, OUTPUT_XRES, elmf->framecoord.x, elmf->framecoord.y,
						(Uint16*)elmf->rgbtemplate, elmf->framecoord.width, 0, 0, elmf->framecoord.width, elmf->framecoord.height);
		/*
#ifdef USE_DESC_TV
		if(prev_active_index == FI_ACTIVE && GetDisplayIndex() == DISP_HDTV)
			;
		else
#endif
			DrawFrameBackground(dest);
		*/
		///

		//DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
		isCalDrawedFirstTime = TRUE;
		DrawCalendarTime(dest, 0, 0);
		DrawAlarmInfo(dest, 0);
		isCalDrawedFirstTime = FALSE;
		//
		if(prev_active_index == FI_ACTIVE)
		{
			pgu_set_alpha(setup->cal_alpha);
			pgu_enable_overlay(1);
			SetRGBuffMSB(0, dest, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
			osd_parser();
		}
		else
		{
#if !defined(GUI_STYLE_COMTEK)
			//draw CalImage
			DrawCalImage(dest);
#endif
			//
			//RBG->YUV for TV encoder
			memcpy(RGB0, dest, RGB_FRAMEBUFF_SIZE);
			/* Flowbee */
			RGB2YUV(0, 0);
			pgu_switch_to_buffer(0);
		}

		if(AudCount != 0)
		{
			elmf->CurrAudListPos = AudioList->next;
			DecodeSSAUD();
		}
	}
	else
	{
		/*
		if(prev_active_index == FI_ACTIVE)
		{
			pgu_enable_overlay(0);
			pgu_switch_to_buffer(1 - yuv_idx);
		}
		else
		{
			pgu_switch_to_buffer(1);
		}
		*/
	}
}
//------------------------------------------------------------------------------------------------

///070606
void FldrDisplay()
{
	FRAME *elmf;

	FLIST *pTempList;
	int i, x, y, maxw, bgNum;
	char RootPath[LEN_XL];
	char CurrentPath[LEN_XL];
	char DisplayPath[LEN_XL] = "/";
	char *p, *q;
	Uint32 len;

	elmf = &ELMachines[active_index].frame;

	switch(active_index)
	{
#ifdef BLUETOOTH_MOD
	case BT_ACTIVE:
		bgNum = bkg_bt;
		break;
#endif
	case FLDR_ACTIVE:
		bgNum = bkg_folder;
		break;
	}
/*
	if(active_index == BT_ACTIVE)
		bgNum = bkg_bt;
	else if(active_index == FLDR_ACTIVE)
		bgNum = bkg_folder;
*/
	///070814
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bgNum);
	//DrawFrameBackground(elmf->rgbtemplate);
	///
	#ifdef LEADTEK
	DrawFrameTextMessage(elmf->rgbtemplate, LTK_ORANGE);
	#else
		#ifdef WINGUI
		DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
		#else
		  #ifndef DARK_BLUE_DESIGN
		DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
		  #else
		DrawFrameTextMessage(elmf->rgbtemplate, MEDIA_FRAMEMESSAGE);
		  #endif
		#endif
	#endif
	DrawStorageICON(elmf->rgbtemplate);

///070816 Medialinkeicon text
#ifndef MEDIALINK
///
	#ifdef LEADTEK
	DrawStorageText(elmf->rgbtemplate, LTK_WHITE);
	#else
	  #ifndef NO_WORD
	DrawStorageText(elmf->rgbtemplate, PURPLE_1555);
	  #endif
	#endif
#endif

	//ܥثe|
	GetPath(RootPath);	//   /mnt/device_name/

	///080204
	getcwd(CurrentPath, LEN_XL);
	if (*(CurrentPath + strlen(CurrentPath) - 1) != '/')
		strcat(CurrentPath, "/");
	#ifdef WINGUI
	FontTextOutFileName(g_pFontDB_Local, CurrentPath + strlen(RootPath) - 1,
						NLS_USE_UTF, TRUE, BLACK_1555,
						(Uint16*)elmf->rgbtemplate, OUTPUT_XRES,
						desc->MiscTextCoord[21].x, desc->MiscTextCoord[21].y,
						desc->MiscTextCoord[21].width, desc->MiscTextCoord[21].height);
	#else
	FontTextOutFileName(g_pFontDB_Local, CurrentPath + strlen(RootPath) - 1,
						#ifndef DARK_BLUE_DESIGN	
						NLS_USE_UTF, TRUE, BLUE_1555,
						#else
						NLS_USE_UTF, TRUE, SELECTED_FILENAME,
						#endif
						(Uint16*)elmf->rgbtemplate, OUTPUT_XRES,
						desc->MiscTextCoord[21].x, desc->MiscTextCoord[21].y,
						desc->MiscTextCoord[21].width, desc->MiscTextCoord[21].height);
	#endif
	/*
	if (*(q = RootPath + strlen(RootPath) - 1) == '/') *q = '\0';
	p = strchr(strchr(RootPath, '/')+1, '/')+1;	//ĤG '/'

	strcat(DisplayPath, p);					//Jdevice_name
	getcwd(CurrentPath, LEN_XL);
	ConvertFileNameOnDisplay(DisplayPath, CurrentPath + strlen(RootPath), 1);
	FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, OUTPUT_XRES, desc->MiscTextCoord[21].x, desc->MiscTextCoord[21].y,
					0, DisplayPath, BLUE_1555);
	*/
	///

	RGBlock2YUVBlock(elmf->rgbtemplate, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);

	pgu_switch_to_buffer(1);
	//FLISTɦW
	UpdateFLDR();
}
///
//------------------------------------------------------------------------------------------------

///070629 Firmware Upgrade
void FWUpgradeDisplay()
{
	Uint8 ret;
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	Uint16* dest = (Uint16*)RGB1;

	memcpy(dest, elmf->bkgrdbuff, RGB_FRAMEBUFF_SIZE);

	///080414
	//Release_FontDB(&g_pFontDB_Local);
	//g_pFontDB_Local = Create_FontDB(desc->FontFileName[3]);	//²餤
	//FontTextOut(g_pFontDB_Local, dest, 50, 250, "ڸ! Ժ...", BLUE_1555);
	///
	if (GetDisplayIndex()== DISP_NTSC)//TV
	{
		FontTextOut(g_pFontDB_Default, dest, 50, 300, "Upgrading Firmware. Please Wait...", BLUE_1555);
	}
	else if(GetDisplayIndex() == DISP_HDTV)//1080i
	{
		FontTextOut(g_pFontDB_Default, dest, 100, 300, "Upgrading Firmware. Please Wait...", BLUE_1555);
	}
	else if(GetDisplayIndex() == DISP_PAL)//PAL
	{
		FontTextOut(g_pFontDB_Default, dest, 50, 300, "Upgrading Firmware. Please Wait...", BLUE_1555);
	} else
	{
		FontTextOut(g_pFontDB_Default, dest, 50, 300, "Upgrading Firmware. Please Wait...", BLUE_1555);
	}


	RGBlock2YUVBlock((Uint8*)dest, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);

	pgu_switch_to_buffer(1);

	umount("/sky_solid");//bk @ 080402
	umount("/tmp/conf");//bk @ 080514
	//do not umount for nand flash upgrading - bk@080806
	//umount(FLASH_PATH);//bk @ 080514

	ret = FW_Upgrade();

	///080414 Ybnand flashsANlɮקR
	if (0 == strcmp(FW_PATH_NAME, FLASH_PATH))
	{
		char cmd[LEN_XL] = {0};
		sprintf(cmd, "rm -f %s%s", FW_PATH_NAME, FW_FILE_NAME);
		system(cmd);
		system("sync");
	}
    ///

	DuplicateBlockBitmap(dest, (Uint16*)elmf->bkgrdbuff, 0, 250, OUTPUT_XRES, 100);

	if (ret == 0)	//ɮפ
	{
//		FontTextOut(g_pFontDB_Local, dest, 50, 250, "ļʽ! ȰγSD/U Ȼ¿...", BLUE_1555);
		FontTextOut(g_pFontDB_Default, dest, 100, 300, "Binary File Error! Remove SD/Pendrive & Reboot.", BLUE_1555);
	}
	else if (ret == 1)	//s
	{
//		FontTextOut(g_pFontDB_Local, dest, 50, 250, "ʧ! ȰγSD/U Ȼ¿...", BLUE_1555);
		FontTextOut(g_pFontDB_Default, dest, 100, 300, "Error! Remove SD/Pendrive & Reboot.", BLUE_1555);
	}
	else if (ret == 2)     //Success
	{
//		FontTextOut(g_pFontDB_Local, dest, 50, 250, "³ɹ! ȰγSD/U Ȼ¿...", BLUE_1555);
		FontTextOut(g_pFontDB_Default, dest, 100, 300, "Successfully! Remove SD/Pendrive & Reboot.", BLUE_1555);
	}
	RGBlock2YUVBlock((Uint8*)dest, 1, 0, 250, OUTPUT_XRES, 100);

	while(1)	//YX|sҰskydemoAGwhile (1)ϱotΰ
	{
		sleep(1);	///080414
	}
	//exit(1);
}
///

//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void BTDisplay()
{
	FRAME *elmf;
	char RootPath[LEN_XL], CurrentPath[LEN_XL], DisplayPath[LEN_XL] = "/", *p, *q;

	//draw basic conponent
	elmf = &ELMachines[active_index].frame;
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_bt);
	DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
	DrawStorageICON(elmf->rgbtemplate);
#ifndef MEDIALINK
	DrawStorageText(elmf->rgbtemplate, PURPLE_1555);
#endif

	//ܥثe|
	GetPath(RootPath);	//   /mnt/sknand/My Received File/ //TODO: monitoring if error
	if (*(q = RootPath + strlen(RootPath) - 1) == '/') *q = '\0';
	p = strchr(strchr(RootPath, '/')+1, '/')+1;	//ĤG '/'
	strcat(DisplayPath, p);					//Jdevice_name
	getcwd(CurrentPath, LEN_XL);
	ConvertFileNameOnDisplay(DisplayPath, CurrentPath + strlen(RootPath), 1);
	FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate
 		, OUTPUT_XRES, desc->MiscTextCoord[21].x, desc->MiscTextCoord[21].y, 0, DisplayPath, BLUE_1555);

	//copy all to display
	RGBlock2YUVBlock(elmf->rgbtemplate, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);
	pgu_switch_to_buffer(1);

	//FLISTɦW
	UpdateBTFldrDisplay();

	//display Bluetooth device list
	UpdateBTDvcDisplay();
}
#endif
//------------------------------------------------------------------------------------------------
void FldrFIDisplay()
{
//	EVENT_LOOP_MACHINE *prevMachine;
//	char *where;
//	char s[LEN_XL];
	pid_t pid;
	int status;

//	prevMachine = &ELMachines[I_ACTIVE];
//
//	if(yuv_idx)// == 1
//	{
//		where = "1";
//		yuv_idx = 0;
//	}
//	else// == 0
//	{
//		where = "0";
//		yuv_idx = 1;
//	}
//	//PRINTF("YUV(%s)\n", where);
//
//	GetPath(s);
//	strcat(s, prevMachine->frame.CurrImgListPos->fname);
//	//DPRINTF("Path of image file = %s\n", s);
//	DrawEXIF(s);
//	/* Flowbee */
//	if(osd_info.current_mode == I_ACTIVE)
//	{
//		osd_parser();
//	}
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			DPRINTF("Fork to Draw Image: %s\n", CurrFldrListPos->fname);
			break;
			//exit(1);
		case 0:
			//child process
#ifdef USE_DESC_LCD
			execl("/sky/skyview", "skyview", "-yuv", "0", CurrFldrListPos->fname, NULL);
#else
			memset((Uint8*)planes.Y[0], 0x10, RGB_FRAMEBUFF_SIZE >> 1);//Y
			memset((Uint8*)planes.U[0], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//U
			memset((Uint8*)planes.V[0], 0x80, RGB_FRAMEBUFF_SIZE >> 3);//V

	#ifdef WINGUI
			if (setup->display_full_screen_idx)
				execl("/sky/skyview", "skyview", "-yuv", "0", "-scalemode", "6", CurrFldrListPos->fname, NULL);
			else
			{
				if(isLowPassMode)
					execl("/sky/skyview", "skyview", "-yuv", "0", "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, CurrFldrListPos->fname, NULL);
				else
					execl("/sky/skyview", "skyview", "-yuv", "0", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, CurrFldrListPos->fname, NULL);
			}
	#else
			if(isLowPassMode)
				execl("/sky/skyview", "skyview", "-yuv", "0", "-lowpass", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, CurrFldrListPos->fname, NULL);
			else
				execl("/sky/skyview", "skyview", "-yuv", "0", "-dcrop", dCropAfterScaling, "-pan", panAfterScaling, CurrFldrListPos->fname, NULL);
	#endif
#endif
			_EXIT;
		default:
			//parent process
			waitpid(pid, &status, 0);
			if(WIFEXITED(status))
			{
//				/* Flowbee@960407. */
//				if(osd_parser())
					pgu_switch_to_buffer(0);
			}
			break;
	}
}
//------------------------------------------------------------------------------------------------
void FldrFVDisplay()
{
//	EVENT_LOOP_MACHINE *prevMachine;
//	char s[LEN_XL];
	int prio;
	Uint8 displayMode;

	//turn off playing time osd to avoid flashing when switching video (video repeat, next, prev) by bk @ 070911
	displayMode = GetDisplayIndex();
#ifdef USE_DESC_LCD
	if(
			displayMode == DISP_800x600_LCD
		|| 	displayMode == DISP_800x480_LCD
		|| 	displayMode == DISP_1024x600_LCD
		|| 	displayMode == DISP_800x480_LCD_25MHZ
	)
	{
		tcon_clear_all_osd_item();
	}
  #ifdef USE_DESC_TV
	else
  #endif
#endif
#ifdef USE_DESC_TV
	{
		pgu_enable_tv_osd(0);
		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
	}
#endif

	KillFldrVideoProcess();
	isFldrVidPrcsForked = FALSE;

//	/* Flowbee@960506. */
//	if(isMutePressed || isVolumePressed)
//	{
//		#if USE_TERAWINS_TCON
//		tcon_clear_mute_vol();
//		#else
//		pgu_enable_overlay(0);
//		#endif
//	}
//
//	prevMachine = &ELMachines[V_ACTIVE];
//	GetPath(s);
//	strcat(s, prevMachine->frame.CurrVidListPos->fname);
//	//DPRINTF("Path of video file = %s\n", s);
//
	set_ir_value((unsigned long)0x0);//reset ir_value
	pid_fldr_vid = fork();
	switch(pid_fldr_vid)
	{
		case -1:
			perror("Fork failed!");
			DPRINTF("Fork to Play Video '%s' Fail!\n", CurrFldrListPos->fname);
			break;
			//exit(1);
		case 0:
			//child process
			execl("/sky/mplayer", "mplayer", "-arcdemo", "-quiet", CurrFldrListPos->fname, NULL);//-arcdemo will cause problem while setup key pressed twice in V_ACTIVE state machine!
			_EXIT;
		default:
			//parent process
			isFldrVidPrcsForked = TRUE;
#ifdef SET_VID_PRIO
			prio = getpriority(PRIO_PROCESS, (int)pid_fldr_vid);
	      	setpriority(PRIO_PROCESS, (int)pid_fldr_vid, prio - VID_PRIO_LVL);
#endif
#ifdef SET_VID_SKY_PRIO
			SkyPrio = getpriority(PRIO_PROCESS, 0);
  			setpriority(PRIO_PROCESS, 0, SkyPrio + VID_SKY_PRIO_LVL);
#endif
			memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);//memset for tv displaying time - bk @ 070817
//			/* Flowbee@960506. */
//			sleep(1);
//			if(isMutePressed)
//			{
//				DrawMute();
//				#if USE_TERAWINS_TCON
//
//				#else
//				pgu_enable_overlay(1);
//				osd_parser();
//				#endif
//			}
//			else if(isVolumePressed)
//			{
//				DrawVolume();
//				#if USE_TERAWINS_TCON
//
//				#else
//				pgu_enable_overlay(1);
//				osd_parser();
//				#endif
//			}
			break;
	}
}
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
///080321
void NetDSDisplay()
{
	FRAME *elmf;

    DBG_MSG("<skydemo> NetDSDisplay -->\n");

	elmf = &ELMachines[active_index].frame;
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_blank);
	DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);
	DrawFrameICON(elmf->rgbtemplate);

//#ifdef NET_MOD
	//Draw Local IP Address
	if(dev_mnted_enbled_flags.nas)//rywu20080516 || dev_mnted_enbled_flags.rss)
	{
		char localipaddr[IPADDR_LEN];
		memset(localipaddr, 0, IPADDR_LEN);
		if(GetLocalIP(localipaddr))
		{
			char tmp[LEN_L] = "Local IP Address: ";
			strcat(tmp, localipaddr);
			FontTextOutFormat(g_pFontDB_Local,
								 (Uint16 *)elmf->rgbtemplate,
								 OUTPUT_XRES/2/*400*/,
								 OUTPUT_YRES-2*g_pFontDB_Local->FontSize/*500-shift480*/,
								 tmp, RED_1555, DT_CENTER);
			/*
			FontTextOutFormat(g_pFontDB_Local,
								 (Uint16 *)elmf->rgbtemplate,
								 500, 900,
								 tmp, RED_1555, DT_CENTER);
			*/

			//PRINTF("x = %d\n", elmf->frametextmsgcoord.x);
			//PRINTF("y = %d\n", elmf->frametextmsgcoord.y);
		}
		char shared_dir[LEN_XL];
		memset(shared_dir, 0, LEN_XL);
		if(GetSharedDir(shared_dir))
		{
			char tmp[LEN_XL] = "Net Disk Shared Directory: ";
			strcat(tmp, shared_dir);
			FontTextOutFormat(g_pFontDB_Local,
								 (Uint16 *)elmf->rgbtemplate,
								 OUTPUT_XRES/2,//400,
								 OUTPUT_YRES-3*g_pFontDB_Local->FontSize,//530-shift480,
								 tmp, PURPLE_1555, DT_CENTER);
			/*
			FontTextOutFormat(g_pFontDB_Local,
								 (Uint16 *)elmf->rgbtemplate,
								 500, 940,
								 tmp, PURPLE_1555, DT_CENTER);
			*/
		}
	}
//#endif
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	memcpy(RGB0, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);//rywu20080620
	RGB2YUV(1, 1);	//RBG->YUV for TV encoder
	/* Flowbee */
	pgu_switch_to_buffer(1);
	DrawFocusedICON(RGB1, 1);

	DBG_MSG("<skydemo> NetDSDisplay <--\n");
}
///

#ifdef SUPPORT_RSS
void RSSDisplay()
{
    /*rywu20080516 removed
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);
	InitFrameBackground(bkg_blank);
	memcpy(RGB1, elmf->bkgrdbuff, RGB_FRAMEBUFF_SIZE);
	DrawFrameTextMessage(RGB1, BLUE_1555);
	RGB2YUV(1, 1);
	pgu_switch_to_buffer(1);
	pgu_start_pgu();*/

    //rywu20080516++
    FRAME *elmf;
	ULint32 i = 0L, j = 0L;
	char file_name[LEN_XL];
	pid_t pid;
	int status;
	unsigned char update_icon_index;
	unsigned char last_icon_index;
	unsigned char focus_image_index;
	int	focus_page_index;
	COORD text_area;
    RSS_IMAGE_INFO_ID rss_file_info;
    char str[32];

    DBG_MSG("<skydemo> RSSDisplay -->\n");

    elmf = &ELMachines[active_index].frame;

    //the below is for framechannel
    if (rss_session->web_provider == WEB_FRAMECHANNEL)
    {
        if (rss_session->is_draw_outline == 0)
        {
            elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_blank);
            memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
            memcpy(RGB0, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);//rywu20080617
            if (rss_session->skip_draw_message == 0)//rywu20080616
            {
                RGB2YUV(1, 1);	//RBG->YUV for TV encoder
            }
            usleep(100000);//rywu20080616
            pgu_switch_to_buffer(1);
            rss_session->is_draw_outline = 1;
        }
        DBG_MSG("<skydemo> RSSDisplay <--\n");
        //For framechannel, there is no need to draw anything about thumbnail,
        //so we return here. And there will be a thread taking over to run
        //slide show for framechannel.
        return;
    }

    //
    //the below is for thumbnail mode initially, such as flickr/picasa
    //
    if (rss_session->is_draw_outline == 0)
    {
        DBG_MSG("<skydemo> draw outline\n");
        //draw outline of thumbnail page
        elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_photo);
        DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
        memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
        if (rss_session->skip_draw_message == 0)//rywu20080616
        {
            RGB2YUV(1, 1);	//RBG->YUV for TV encoder
        }
        pgu_switch_to_buffer(1);
        if (rss_session->skip_draw_message == 0)//rywu20080616
        {
        draw_thumbnail_number(RGB1, rss_session);

        //draw on-going message
        text_area.x = desc->MiscTextCoord[8].x + ((desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width)>>2);
        text_area.y = desc->MiscTextCoord[8].y - 3;
        text_area.width = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width - ((desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width)>>2);
        text_area.height= g_pFontDB_Default->FontSize;
        DBG_MSG("<skydemo>   draw text(%d, %d, %d, %d)\n", text_area.x, text_area.y, text_area.width, text_area.height);
        if (rss_session->current_state == IPC_DOWNLOAD_START)
            {
                //sprintf(str, "%s", "downloading ...");
                if (rss_session->rest_frame_count > 0)//rywu20080616
                {
                    if (rss_session->rest_frame_count == 1)//rywu20080616
                    {
                        sprintf(str, "Download... (%d item left)", rss_session->rest_frame_count);
                    }
                    else
                    {
                        sprintf(str, "Download... (%d items left)", rss_session->rest_frame_count);
                    }
                    draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
                }
            }
            else if (rss_session->current_state == IPC_RETRIEVE_FEED_INFORMATION)
            {
                sprintf(str, "%s", "Gathering RSS information");
                draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
            }
        }
        rss_session->is_draw_outline = 1;
    }

    if (ListGetSize(&rss_session->image_on_use_list) > 0)
    {
	    if (rss_session->display_mode == THUMBNAIL_MODE)
	    {
	    	//first time to display
	    	if (rss_session->image_update_mode == INITIAL_UPDATE)
	    	{
                //point to first image to be drawn
	    		rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);

                //set start draw index
                update_icon_index = 0;

                //set last draw index
	    		last_icon_index = rss_session->total_file_amount - 1;
	    		if (rss_session->total_file_amount > ICON_NUM_PER_FRAME)
	    		{
	    			last_icon_index = ICON_NUM_PER_FRAME - 1;
	    		}

	    		//set global focus index
	    		rss_session->focus_image_no	= 0;

                //set local focus index
	    		focus_image_index			= rss_session->focus_image_no;
	    	}
	    	//only update new inserting image(s)
	    	if (rss_session->image_update_mode == PARTIAL_UPDATE)
	    	{
                //calculate page number and focus number for local use
	    		focus_page_index	= rss_session->focus_image_no/ICON_NUM_PER_FRAME;
				focus_image_index	= rss_session->focus_image_no%ICON_NUM_PER_FRAME;

                //set start image to null as default
				rss_file_info = (RSS_IMAGE_INFO_ID)0;

				//whether these update images are in same page or not
                if (rss_session->total_file_amount == 1)
                {
                    //set start draw index
                    update_icon_index = 0;

                    //set last draw index
                    last_icon_index = 0;

                    //point to first image to be drawn
                    rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
                }
                else
                {
                    if (((rss_session->last_handled_image_no)/ICON_NUM_PER_FRAME) == focus_page_index)
                    {
                        //set start draw index
                        update_icon_index = (rss_session->last_handled_image_no%ICON_NUM_PER_FRAME)+1;

                        //check whether updated image is in next page or not
                        if (update_icon_index < ICON_NUM_PER_FRAME)
                        {
                            //set last draw index
                            if (((rss_session->total_file_amount-1)/ICON_NUM_PER_FRAME) == focus_page_index)
                            {
                                last_icon_index = ((rss_session->total_file_amount-1)%ICON_NUM_PER_FRAME);
                            }
                            else
                            {
                                last_icon_index = ICON_NUM_PER_FRAME - 1;
                            }

                            //point to first image to be drawn
                            rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
                            for(i=0; i<(rss_session->last_handled_image_no+1); i++)
                            {
                                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
                            }
                        }
                    }
                }
	    	}
	    	//redraw whole page, and this should be used when back from full-image mode
	    	if (rss_session->image_update_mode == TOTALLY_UPDATE)
	    	{
	    		//calculate page number and focus number for local use
	    		focus_page_index	= rss_session->focus_image_no/ICON_NUM_PER_FRAME;
				focus_image_index	= rss_session->focus_image_no%ICON_NUM_PER_FRAME;

                //set start draw index
				update_icon_index = 0;

                //set last draw index
				if (((rss_session->total_file_amount-1)/ICON_NUM_PER_FRAME) == focus_page_index)
                {
                    last_icon_index = ((rss_session->total_file_amount-1)%ICON_NUM_PER_FRAME);
				}
				else
				{
					last_icon_index = ICON_NUM_PER_FRAME - 1;
}

                //point to first image to be drawn
				rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
				for(i=0; i<(focus_page_index*ICON_NUM_PER_FRAME); i++)
				{
				    rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
				}
	    	}

            //set handled image index to last
            rss_session->last_handled_image_no = rss_session->total_file_amount - 1;

            if (rss_file_info != 0)
            {
                DBG_MSG("<skydemo> %d - %d, focus %d, %s\n",
                       update_icon_index,
                       last_icon_index,
                       focus_image_index,
                       rss_file_info->file_name);
            }
            //begin to draw iamge(s)
            while(rss_file_info != 0 && update_icon_index <= last_icon_index)
            {
                sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
                if (update_icon_index == focus_image_index)
                {
                    rss_thumbnail_image_update(file_name, update_icon_index, 1);
                }
                else
                {
                    rss_thumbnail_image_update(file_name, update_icon_index, 0);
                }
                update_icon_index++;
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            }

            //draw ratio(position) of current focus number within all files
            draw_thumbnail_number(RGB1, rss_session);
        }//end if (THUMBNAIL_MODE)
        else
        {
            DBG_MSG("<skydemo> full image mode is running. --> do nothing\n");
        }

    }//end if (ListGetSize(&rss_session->image_on_use_list) > 0)

    DBG_MSG("<skydemo> RSSDisplay <--\n");
    //rywu20080516--
}

//rywu20080516 added
void rss_thumbnail_image_update(char *file_name, unsigned char update_icon_index, unsigned char is_focus)
{
    FRAME *elmf;
    int ret;
    pid_t pid;
	int status;
    //char command[256];

    elmf = &ELMachines[active_index].frame;
    DBG_MSG("<skydemo> %d update (icon%d, w%s, h%s)%s in thumbnail\n",
           active_index, update_icon_index, desc->ICONWidth, desc->ICONHeight, file_name);

    if(yuv_idx == 1)
    {
        yuv_idx = 0;
    }
    pid = fork();
    switch(pid)
    {
        case -1:
            DBG_MSG("<skydemo> fork failed!!\n");
            break;

        case 0:
            system("sync");
            execl("/sky/skyview", "skyview", "-thumbnail", "-rgb", "0", "-x", desc->ICONWidth, "-y", desc->ICONHeight, file_name, NULL);
            /*sprintf(command, "/sky/skyview -thumbnail -rgb 0 -x %s -y %s %s", desc->ICONWidth, desc->ICONHeight, file_name);
            system(command);*/
            _EXIT;

        default:
            /*DBG_MSG("<skydemo> draw something?! coord(%d, %d, %d, %d)\n",
                       elmf->icon_arr[update_icon_index].icoord.x,
                       elmf->icon_arr[update_icon_index].icoord.y,
                       elmf->icon_arr[update_icon_index].icoord.width,
                       elmf->icon_arr[update_icon_index].icoord.height);
            DBG_MSG("<skydemo> draw something?! (w%d, h%d)\n",
                       ICON_WIDTH, ICON_HEIGHT);*/
            waitpid(pid, &status, 0);
            if(WIFEXITED(status))
            {
                DrawThumbnail(
                        elmf->rgbtemplate,
                        update_icon_index,
                        ICON_WIDTH,
                        ICON_HEIGHT);
                DuplicateBlockBitmap(
                        (Uint16 *)RGB1,
                        (Uint16 *)elmf->rgbtemplate,
                        elmf->icon_arr[update_icon_index].icoord.x,
                        elmf->icon_arr[update_icon_index].icoord.y,
                        elmf->icon_arr[update_icon_index].icoord.width,
                        elmf->icon_arr[update_icon_index].icoord.height);
                ConvertThumbnail2YUV(
                        RGB1,
                        1,
                        update_icon_index,
                        ICON_WIDTH,
                        ICON_HEIGHT);
            }
            //rywu20080529++
            else
            {
                DBG_MSG("<skydemo>    Huston, skyview is down\n");
                return;
            }
            //rywu20080529--
            //DBG_MSG("<skydemo> hahaha~~\n");
            break;
    }//end switch

    //DBG_MSG("<skydemo> draw focus?! = %d\n", is_focus);
    //DrawFocusedICON(RGB1, update_icon_index);
    draw_thumbnail_fcous_icon(RGB1, update_icon_index, is_focus);
}

//rywu20080516 added
void rss_full_image_update(char *file_name)
{
    char where[2];
	pid_t pid;
	int status;


	if(yuv_idx)// == 1
	{
		strcpy(where, "1");
		yuv_idx = 0;
	}
	else// == 0
	{
		strcpy(where, "0");
		yuv_idx = 1;
	}

    pid = fork();
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			DPRINTF("Fork to Draw Image: %s\n");
			break;
			//exit(1);
		case 0:
			//child process
			execl("/sky/skyview", "skyview", "-yuv", where, file_name, NULL);
			_EXIT;
		default:
			//parent process
			waitpid(pid, &status, 0);
			if(WIFEXITED(status))
			{
				pgu_switch_to_buffer(1 - yuv_idx);
			}
            else
            {
                DBG_MSG("<skydemo> Huston, skyview is down...\n");
            }
			break;
	}
}
#endif //end #ifdef SUPPORT_RSS

#endif
//------------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
void HDAutoCPDisplay()
{
	FRAME *elmf;
	Uint16 *dest = (Uint16*)RGB1, FONT_HEIGHT = 26;
	Uint16 cx1 = 0, cy1 = 0, cx2 =0, cy2 = 0;
	char msg[LEN_XL];

	//init
	elmf = &ELMachines[active_index].frame;
	if (g_pFontDB_Local)
		FONT_HEIGHT = g_pFontDB_Local->FontSize;
	memset(msg, '\0', LEN_XL);

	//the updateRegion is 8 font's width, 1 font's height
	updateRegion.width = FONT_HEIGHT << 3;
	updateRegion.height = FONT_HEIGHT;
	updateRegion.x = (OUTPUT_XRES - updateRegion.width) >> 1;
	updateRegion.y = (OUTPUT_YRES >> 1) - FONT_HEIGHT;
	cx1 = updateRegion.x + (updateRegion.width >> 1);
	cy1 = updateRegion.y - FONT_HEIGHT;
	cx2 = cx1;
	cy2 = updateRegion.y;

	//background
	memcpy(dest, elmf->bkgrdbuff, RGB_FRAMEBUFF_SIZE);

	//msg
	strcpy(msg, "copy data from ");strcat(msg, inDvcName);strcat(msg, " to HD");
	FontTextOutFormat(g_pFontDB_Local, dest, cx1, cy1, msg, BLUE_1555, DT_CENTER);
	FontTextOutFormat(g_pFontDB_Local, dest, cx2, cy2, "?", RED_1555, DT_CENTER);

	//switch pgu to display
	RGBlock2YUVBlock((Uint8*)dest, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);
	pgu_switch_to_buffer(1);

	//draw selection
	DrawHDAutoCPSelectionFocus();
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef IP_CAM_MOD
void IPCamDisplay()
{
	FRAME *elmf = &ELMachines[active_index].frame;

	if (!isIPCamFullView)	//ip listҦ
	{
		elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_folder);

		//DrawFrameTextMessage(elmf->rgbtemplate, GREY40_1555);
		//DrawStorageICON(elmf->rgbtemplate);

		memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
		RGBlock2YUVBlock(elmf->rgbtemplate, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);

		pgu_switch_to_buffer(1);
		//FLISTɦW
		UpdateFLDR();

		//ܽs
		DrawIPCamTag();
	}
	else	//ùҦ
	{
		FLIST *pTempList = NULL;
		int nCam = 0;
		IPCAM_DATA ipcam_data[MAX_IPCAM_NUM] = {0};

		//Mŵe
		memset(RGB1, 0, RGB_FRAMEBUFF_SIZE);
		RGB2YUV(1, 1);

		//Cipcam
        pTempList = FolderList_GetHeadPos(FolderList);
		while (pTempList)
		{
			if (pTempList->attribute & Mask_IsChecked)
			{
				strcpy(ipcam_data[nCam].IP, pTempList->fname);
				strcpy(ipcam_data[nCam].ID, "admin");
				strcpy(ipcam_data[nCam].PW, "admin");
				nCam++;
				if (nCam >= MAX_IPCAM_NUM) break;
			}
			pTempList = pTempList->next;
		}

		//SQܪipcam,NܥΫ쪺ipcam
		if (nCam == 0 && CurrFldrListPos)
		{
			strcpy(ipcam_data[nCam].IP, CurrFldrListPos->fname);
			strcpy(ipcam_data[nCam].ID, "admin");
			strcpy(ipcam_data[nCam].PW, "admin");
			nCam++;
		}

		//ھipcamƶqMwܦm
		switch(nCam)
		{
		case 1:	//1ipcam, ù
			if (OUTPUT_XRES * 3 >= OUTPUT_YRES * 4)	//eù(4:3HW)
			{
				ipcam_data[0].POS.height = OUTPUT_YRES;
				ipcam_data[0].POS.width = ipcam_data[0].POS.height * 4 / 3;
			}
			else	//ù(4:3)
			{
				ipcam_data[0].POS.width = OUTPUT_XRES;
				ipcam_data[0].POS.height = ipcam_data[0].POS.width * 3 / 4;
			}
			ipcam_data[0].POS.x = OUTPUT_XRES/2 - ipcam_data[0].POS.width/2;
			ipcam_data[0].POS.y = OUTPUT_YRES/2 - ipcam_data[0].POS.height/2;
			break;
		case 2:	//2ipcam, kæC
			if (OUTPUT_XRES * 3 >= OUTPUT_YRES * 8)
			{
				ipcam_data[0].POS.height = OUTPUT_YRES;
				ipcam_data[0].POS.width = ipcam_data[0].POS.height * 4 / 3;
			}
			else
			{
				ipcam_data[0].POS.width = OUTPUT_XRES / 2;
				ipcam_data[0].POS.height = ipcam_data[0].POS.width * 3 / 4;
			}
			ipcam_data[0].POS.x = OUTPUT_XRES/2 - ipcam_data[0].POS.width;
			ipcam_data[0].POS.y = OUTPUT_YRES/2 - ipcam_data[0].POS.height/2;
			ipcam_data[1].POS = ipcam_data[0].POS;
			ipcam_data[1].POS.x = OUTPUT_XRES/2;
			break;
		case 3:	//3ipcamHW, Цr
		case 4:
			if (OUTPUT_XRES * 3 >= OUTPUT_YRES * 4)	//eù(4:3HW)
			{
				ipcam_data[0].POS.height = OUTPUT_YRES / 2;
				ipcam_data[0].POS.width = ipcam_data[0].POS.height * 4 / 3;
			}
			else	//ù(4:3)
			{
				ipcam_data[0].POS.width = OUTPUT_XRES / 2;
				ipcam_data[0].POS.height = ipcam_data[0].POS.width * 3 / 4;
			}
			ipcam_data[0].POS.x = OUTPUT_XRES/2 - ipcam_data[0].POS.width;
			ipcam_data[0].POS.y = OUTPUT_YRES/2 - ipcam_data[0].POS.height;
			ipcam_data[1].POS = ipcam_data[0].POS;
			ipcam_data[1].POS.x = OUTPUT_XRES / 2;
			ipcam_data[2].POS = ipcam_data[0].POS;
			ipcam_data[2].POS.y = OUTPUT_YRES / 2;
			ipcam_data[3].POS = ipcam_data[0].POS;
			ipcam_data[3].POS.x = OUTPUT_XRES / 2;
			ipcam_data[3].POS.y = OUTPUT_YRES / 2;
			break;
		default:
			break;
		}

		//}lipcame
		DrawIPCam(ipcam_data, nCam);
	}
}
#endif
//------------------------------------------------------------------------------------------------
#if defined(GUI_STYLE_COMTEK)
void ProgDownloadDisplay()
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	Uint8* dest = RGB1;

	//delete background
	memset(dest, 0, RGB_FRAMEBUFF_SIZE);

	CopyBlockBitmap((Uint16*)dest, OUTPUT_XRES, elmf->framecoord.x, elmf->framecoord.y,
						(Uint16*)elmf->rgbtemplate, elmf->framecoord.width, 0, 0, elmf->framecoord.width, elmf->framecoord.height);

	DuplicateBlockBitmap((Uint16*)dest, (Uint16*)elmf->bkgrdbuff, 0, 0, OUTPUT_XRES, 100);

	FontTextOut(g_pFontDB_Default, (Uint16*)dest, 150, 50, "Program download. Please wait...", BLUE_1555);

	RGBlock2YUVBlock((Uint8*)dest, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);

}
#endif
//------------------------------------------------------------------------------------------------
void MachineDisplay()
{
	switch(active_index)
	{
		case DS_ACTIVE:
			DSDisplay();
			break;
		case MT_ACTIVE:
			MTDisplay();
			break;
		case SETUP_L1_ACTIVE:
			SetupL1Display();
			break;
		case SETUP_L2_ACTIVE:
			SetupL2Display();
			break;
		case SETUP_L3_ACTIVE:
			SetupL3Display();
			break;
		case I_ACTIVE:
			ImgDisplay();
			break;
		case FI_ACTIVE:
			FImgDisplay();
			break;
		case A_ACTIVE:
			AudDisplay();
			break;
		case V_ACTIVE:
			VidDisplay();
			break;
		case FV_ACTIVE:
			FVidDisplay();
			break;
		case SS_ACTIVE:
			SSDisplay();
			break;
		case USB2PC_CONN_ACTIVE:
			USB2PConnDisplay();
			break;
		case NO_STORAGE_ACTIVE:
			NoStorageDisplay();
			break;
		case CONFIRM_ACTIVE:
			ConfirmDisplay();
			break;
		case CAL_ACTIVE:
			CalDisplay();
			break;
		///070606 Folder View
		case FLDR_ACTIVE:
			FldrDisplay();
			break;
		///
		case FW_UPGRADE_ACTIVE:
			FWUpgradeDisplay();
			break;
#ifdef BLUETOOTH_MOD
		case BT_ACTIVE:
			BTDisplay();
			break;
#endif
		case FLDR_FI_ACTIVE:
			FldrFIDisplay();
			break;
		case FLDR_FV_ACTIVE:
			FldrFVDisplay();
			break;
#ifdef NET_MOD
		///080321
		case NET_DS_ACTIVE:
			NetDSDisplay();
			break;
#endif
#ifdef SUPPORT_RSS //rywu20080516
		case RSS_ACTIVE:
			RSSDisplay();
			break;
#endif
#ifdef HD_AUTOCP_MOD
		case HD_AUTOCP_ACTIVE:
			HDAutoCPDisplay();
			break;
#endif
#ifdef IP_CAM_MOD
	case IP_CAM_ACTIVE:
			IPCamDisplay();
			break;
#endif
///080430
#ifdef WEB_APP_MOD
	case WEB_APP_ACTIVE:
			WebAppDisplay();
			break;
#endif
///
#if defined(GUI_STYLE_COMTEK)
		case PROG_DOWNLOAD_ACTIVE:
			ProgDownloadDisplay();
			break;
#endif
	}
/*	//add by bk@070404
	//recover original overlay situation
	if(isMutePressed && !isSetupPressed)
	{
		DrawMute();
		TurnOnOverlayMode();
	}
	if(isVolumePressed && !isSetupPressed)
	{
		DrawVolume();
		TurnOnOverlayMode();
	}*/
}
