#include "keymap.h"

///080504
#include "types.h"
#ifdef WEB_APP_MOD
#include "webapp.h"
#endif
///

//------------------------------------------------------------------------------------------------
Uint32 Hash(Uint8 k)
{
	srand((Uint32)k);
    	return ((Uint32)(rand() % MAX_NUM_IR_EVENTS));
}
//------------------------------------------------------------------------------------------------
void RegisterhTable(Uint8 irscankey, pfEvent e)
{
	Uint32 i;
	IR_SCANKEY_EVENTS *irscanevt = NULL, *irscanevt_tmp = NULL;

	MEMALLOC(irscanevt, IR_SCANKEY_EVENTS, 1);

	i = Hash(irscankey);

	irscanevt->ir_scan_key = irscankey;
	irscanevt->ir_scan_key_evt = e;
	irscanevt->next = NULL;//irscanevt->next = irscanevt;

	if(ELMachines[active_index].hTable[i] == NULL)
		ELMachines[active_index].hTable[i] = irscanevt;
	else
	{
		irscanevt_tmp = ELMachines[active_index].hTable[i];
		while(irscanevt_tmp->next != NULL)//while(irscanevt_tmp->next != irscanevt_tmp)
			irscanevt_tmp = irscanevt_tmp->next;
		irscanevt_tmp->next = irscanevt;
	}
}
//------------------------------------------------------------------------------------------------
void FillupBKGrdImageBuffer()
{
	FRAME *elmf;
	char *fn;
	pid_t pid;
	int status;
	Uint16 width, height;
	char w[LEN_S], h[LEN_S];
	Uint32 size;

	elmf = &ELMachines[active_index].frame;
	fn = elmf->fname;
	width = elmf->framecoord.width;
	height = elmf->framecoord.height;
	sprintf(w, "%d", width);
	sprintf(h, "%d", height);
	size = width * height * 2;
#if 0
	PRINTF("width = %d\n", width);
	PRINTF("height = %d\n", height);
	PRINTF("w = %s\n", w);
	PRINTF("h = %s\n", h);
#endif


	if(strstr(fn, ".bmp") || strstr(fn, ".BMP"))
	{
		elmf->bkgrdbuff = (Uint8 *)LoadBmpFile(fn);
		if (!elmf->bkgrdbuff)
			DMSG("Load Background Bmp Fail!");
	}
	else if(strstr(fn, ".jpg") || strstr(fn, ".JPG"))
	{
		MEMALLOC(elmf->bkgrdbuff, Uint8, size);
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to Load Background Jpg Fail!");
				break;
				//exit(1);
			case 0:
				//child process
				//bk@070509 - if active is setup and pre_active is FV, software decode BG forcely. In the future, it maybe be need to add Confrim_active Situation
				if(active_index == SETUP_L1_ACTIVE || active_index == SETUP_L2_ACTIVE || active_index == SETUP_L3_ACTIVE)
				{
					if(prev_active_index == FV_ACTIVE || prev_active_index == FI_ACTIVE)//forcely software decode
						execl("/sky/skyview", "skyview", "-rgb", "0", "-swdecode", "-x", w, "-y", h, fn, NULL);
					else
						execl("/sky/skyview", "skyview", "-rgb", "0", "-x", w, "-y", h, fn, NULL);
				}
				else if(active_index == CAL_ACTIVE)
				{
					if(prev_active_index == FI_ACTIVE)//forcely software decode
						execl("/sky/skyview", "skyview", "-rgb", "0", "-swdecode", "-x", w, "-y", h, fn, NULL);
					else
						execl("/sky/skyview", "skyview", "-rgb", "0", "-x", w, "-y", h, fn, NULL);
				}
				else
					execl("/sky/skyview", "skyview", "-rgb", "0", "-x", w, "-y", h, fn, NULL);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
				{
					memcpy(elmf->bkgrdbuff, RGB0, size);
				}
				break;
		}
	}
}
//------------------------------------------------------------------------------------------------
Uint8* InitFrameBackground(Uint8 bkgrd_num)
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070814
	FreeBackgroundBuff();
	///

	// Initialize the Frame Background
	elmf->fname = desc->bkgrdImg[bkgrd_num];
	elmf->framecoord = desc->bkgrdCoord[bkgrd_num];
	// Fill up background buffer
	FillupBKGrdImageBuffer();

	return (Uint8*)(elmf->bkgrdbuff);
}
//------------------------------------------------------------------------------------------------
void InitFrameTextMessage(char *frametextmsg, COORD *frametextmsgcoord)
{
	FRAME *elmf;

	if(active_index == FI_ACTIVE)
		elmf = &ELMachines[I_ACTIVE].frame;
	else
		elmf = &ELMachines[active_index].frame;
	//Init hint text for a frame
	if(frametextmsg != NULL)
		elmf->frametextmsg = frametextmsg;
	if(frametextmsgcoord != NULL)
		elmf->frametextmsgcoord = (*frametextmsgcoord);
}
//------------------------------------------------------------------------------------------------
void InitVolumeBuffer()
{
	FRAME *elmf;
	unsigned long buf_w, w, h;
	elmf = &ELMachines[active_index].frame;
	Uint16 FONT_HEIGHT = g_pFontDB_Default->FontSize;
///070831
#ifdef USE_DESC_TV
	if (g_pFontDB_Default->bScaleDown)
	{
		FONT_HEIGHT >>= 1;
	}
#endif
///

	if(active_index == FV_ACTIVE || active_index == FLDR_FV_ACTIVE)
		RGB_VOLBUFF_SIZE = (Uint32)800 * (FONT_HEIGHT+2) * 2;
	else
		RGB_VOLBUFF_SIZE = (Uint32)OUTPUT_XRES * (FONT_HEIGHT+2) * 2;

	posOfVol.x = 0;
	posOfVol.y = 0;
	posOfVol.width = GetFontStringWidth(g_pFontDB_Default, "VOL          ") + 2;
	posOfVol.height = FONT_HEIGHT + 2;

	posOfMute.x = 10;
	posOfMute.y = 10;
	posOfMute.width = GetFontStringWidth(g_pFontDB_Default, "MUTE") + 2;
	posOfMute.height = FONT_HEIGHT + 2;
	//posOfVol = {0, 0, 211, 28};
	//posOfMute = {10, 10, 60, 28};
	MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
}
//------------------------------------------------------------------------------------------------

///070907
int DecodeRGBImage(Uint8 **dest, char *fn, Uint16 width, Uint16 height)
{
	if (!dest) return -1;
	pid_t pid;
	int status;
	char w[10], h[10];
	Uint32 size;
	sprintf(w, "%d", width);
	sprintf(h, "%d", height);
	size = width * height * 2;
#if 0
	PRINTF("width = %d\n", width);
	PRINTF("height = %d\n", height);
	PRINTF("w = %s\n", w);
	PRINTF("h = %s\n", h);
#endif

	if(strstr(fn, ".bmp") || strstr(fn, ".BMP"))
	{
		*dest = (Uint8 *)LoadBmpFile(fn);
		if (!dest)
			DMSG("Load Icon Bmp Fail!");
	}
	else if(strstr(fn, ".jpg") || strstr(fn, ".JPG"))
	{
		MEMALLOC(*dest, Uint8, size);
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to Load Icon Jpg Fail!");
				break;
				//exit(1);
			case 0:
				//child process
				execl("/sky/skyview", "skyview", "-rgb", "0", "-x", w, "-y", h, fn, NULL);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
				{
					memcpy((Uint8*)(*dest), RGB0, size);
				}
				break;
		}
	}
	return 0;
}
///

//------------------------------------------------------------------------------------------------
void FillupICONImageBuffer(Uint8 n)
{
	FRAME *elmf;
	char *fn;
	pid_t pid;
	int status;
	Uint16 width, height;
	char w[10], h[10];
	Uint32 size;

	elmf = &ELMachines[active_index].frame;
	fn = elmf->icon_arr[n].fname;
	width = elmf->icon_arr[n].icoord.width;
	height = elmf->icon_arr[n].icoord.height;
	sprintf(w, "%d", width);
	sprintf(h, "%d", height);
	size = width * height * 2;
#if 0
	PRINTF("width = %d\n", width);
	PRINTF("height = %d\n", height);
	PRINTF("w = %s\n", w);
	PRINTF("h = %s\n", h);
#endif

	if(strstr(fn, ".bmp") || strstr(fn, ".BMP"))
	{
		elmf->icon_arr[n].iconbuff = (Uint8 *)LoadBmpFile(fn);
		if (!elmf->icon_arr[n].iconbuff)
			DMSG("Load Icon Bmp Fail!");
	}
	else if(strstr(fn, ".jpg") || strstr(fn, ".JPG"))
	{
		MEMALLOC(elmf->icon_arr[n].iconbuff, Uint8, size);
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to Load Icon Jpg Fail!");
				break;
				//exit(1);
			case 0:
				//child process
				execl("/sky/skyview", "skyview", "-rgb", "0", "-x", w, "-y", h, fn, NULL);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
				{
					memcpy(elmf->icon_arr[n].iconbuff, RGB0, size);
				}
				break;
		}
	}
}
//------------------------------------------------------------------------------------------------
void InitFrameICON(Uint8 ICONum)
{
	FRAME *elmf;
	Uint8 i, j, k;
	Uint8 Num;

	elmf = &ELMachines[active_index].frame;

///080320
	ITEM_DATA *pItem = &(elmf->item_data);
///

	switch(active_index)
	{
		case DS_ACTIVE:

		///080320
#ifdef NET_MOD
		case NET_DS_ACTIVE:
#endif
			elmf->num_icon = ICONum * 2 + 1/*for Sandglass icon*/;
			MEMALLOC(elmf->icon_arr, ICON, elmf->num_icon);

			//TODO - for black icon block test
			elmf->icon_arr[0].fname = desc->ICONFilename4DS[0][pItem->index[0]];
			elmf->icon_arr[0].icoord = desc->DSCoord[0][0][0];
			FillupICONImageBuffer(0);

			for (i=0; i<pItem->total_item; i++)
			{
				//ori
				elmf->icon_arr[i].fname = desc->ICONFilename4DS[0][pItem->index[i]];
				elmf->icon_arr[i].icoord = desc->DSCoord[0][i][0];
				FillupICONImageBuffer(i);
				//focus
				elmf->icon_arr[i+pItem->total_item].fname = desc->ICONFilename4DS[1][pItem->index[i]];
				elmf->icon_arr[i+pItem->total_item].icoord = desc->DSCoord[1][i][0];
				FillupICONImageBuffer(i+pItem->total_item);
			}
			break;
		///

		case MT_ACTIVE:
#if 0
			elmf->num_icon = ICONum * 2 + 3/*for image, audio and video error icons*/ + 1/*for sandglass icon*/ + 1/*for storage icon*/;
			MEMALLOC(elmf->icon_arr, ICON, elmf->num_icon);
			j = 0;
			for(i = 0; i < elmf->num_icon - 1 - 1; i++)
			{
				k = i % ICONum;
				if(i != 0 && k == 0)
					j++;
				elmf->icon_arr[i].fname = desc->ICONFilename4MT[j][k];
				elmf->icon_arr[i].icoord = desc->MTCoord[j][k][0];
				FillupICONImageBuffer(i);
				elmf->icon_arr[i].txtcoord = desc->MTCoord[j][k][1];
			}
			InitMiscICON(i);
			InitStorageICON(i + 1);
#else
			elmf->num_icon = ICONum + 3/*for image, audio and video error icons*/ + 1/*for sandglass icon*/ + 1/*for storage icon*/;
			MEMALLOC(elmf->icon_arr, ICON, elmf->num_icon);
			j = 1;

			//TODO - for black icon block test
			elmf->icon_arr[0].fname = desc->ICONFilename4MT[1][0];
			elmf->icon_arr[0].icoord = desc->MTCoord[1][0][0];
			FillupICONImageBuffer(0);

			for(i = 0; i < elmf->num_icon - 1 - 1; i++)
			{
				k = i % ICONum;
				if(i != 0 && k == 0)
					j++;
				elmf->icon_arr[i].fname = desc->ICONFilename4MT[j][k];
				elmf->icon_arr[i].icoord = desc->MTCoord[j][k][0];
				FillupICONImageBuffer(i);
				elmf->icon_arr[i].txtcoord = desc->MTCoord[j][k][1];
			}
			InitMiscICON(i);
			InitStorageICON(i + 1);
#endif
			break;
	}
//	elmf->active_icon_index = 0;
}
//------------------------------------------------------------------------------------------------
void InitFrameThumbNail(Uint8 ThumbNailNums)
{
	FRAME *elmf;
	Uint32 i;

	elmf = &ELMachines[active_index].frame;

	switch(active_index)
	{
		case I_ACTIVE:
			elmf->num_icon = ThumbNailNums + 1/*for sandglass icon*/ + 1/*for storage icon*/;
			break;
		case A_ACTIVE:
#if defined(KINGSTON)
			elmf->num_icon = ThumbNailNums + 1/*for musicplayed icon*/ + 1/*for musicnotsupport icon*/ + 1/*for sandglass icon*/
				+ 6/*LL, LR, RR, mute, vol, volx1*/ + 1/*for storage icon*/;
#else
			elmf->num_icon = ThumbNailNums + 1/*for musicplayed icon*/ + 1/*for musicnotsupport icon*/ + 1/*for sandglass icon*/ + 1/*for storage icon*/;
#endif
			break;
		case V_ACTIVE:
			elmf->num_icon = ThumbNailNums + 1/*for videonotsupport icon*/ + 1/*for sandglass icon*/ + 1/*for storage icon*/;
			break;
		case FLDR_ACTIVE:
			elmf->num_icon = ThumbNailNums //+ 1/*for folder icon*/ + 1/*for music icon*/ + 1/*for video icon*/
											+ 1/*for fileselect icon*/ + 1/*for sandglass icon*/ + 1/*for storage icon*/;
			break;
#ifdef BLUETOOTH_MOD
		case BT_ACTIVE:
			elmf->num_icon = ThumbNailNums //+ 1/*for folder icon*/ + 1/*for music icon*/ + 1/*for video icon*/
											+ 1/*for storage icon*/;
			break;
#endif
#ifdef IP_CAM_MOD
		case IP_CAM_ACTIVE:
			elmf->num_icon = ThumbNailNums + 1/*for fileselect icon*/;
			break;
#endif
        //rywu20080516++
#ifdef SUPPORT_RSS//rywu20080519 NET_MOD
        case RSS_ACTIVE:
			elmf->num_icon = ThumbNailNums + 1/*for sandglass icon*/ + 1/*for storage icon*/;
			break;
#endif
        //rywu20080516--
	}
	MEMALLOC(elmf->icon_arr, ICON, elmf->num_icon);

	for(i = 0; i < ThumbNailNums; i++)
	{
		switch(active_index)
		{
			case I_ACTIVE:
			case V_ACTIVE:
#ifdef SUPPORT_RSS//rywu20080519 NET_MOD
            case RSS_ACTIVE://rywu20080516
#endif
				elmf->icon_arr[i].icoord = desc->XbyYCoord[i];
                /*printf("(%d, %d, %d, %d)\n",
                       elmf->icon_arr[i].icoord.x,
                       elmf->icon_arr[i].icoord.y,
                       elmf->icon_arr[i].icoord.width,
                       elmf->icon_arr[i].icoord.height);*/
				break;
			case A_ACTIVE:
				elmf->icon_arr[i].txtcoord = desc->MusicBarCoord[i];
				elmf->icon_arr[i].icoord = desc->MusicIconCoord[i];
				break;
			case FLDR_ACTIVE:
				elmf->icon_arr[i].txtcoord = desc->FolderBarCoord[i];
				elmf->icon_arr[i].icoord = desc->FolderIconCoord[i];
				break;
#ifdef BLUETOOTH_MOD
			case BT_ACTIVE:
				if(i < FOLDER_BAR_NUM)
				{
					elmf->icon_arr[i].txtcoord = desc->BTFldrBarCoord[i];
					elmf->icon_arr[i].icoord = desc->BTFldrIconCoord[i];
				}else
				{
					elmf->icon_arr[i].txtcoord = desc->BTDvcBarCoord[i - FOLDER_BAR_NUM];
					//elmf->icon_arr[i].icoord = desc->BTDvcIconCoord[i];
				}
				break;
#endif
#ifdef IP_CAM_MOD
			case IP_CAM_ACTIVE:
				elmf->icon_arr[i].txtcoord = desc->FolderBarCoord[i];
				elmf->icon_arr[i].icoord = desc->FolderIconCoord[i];
				break;
#endif
		}
	}

	InitMiscICON(i);

	elmf->active_icon_index = 0;
	elmf->active_frame_index = 0;
	switch(active_index)
	{
		case I_ACTIVE:
			elmf->CurrImgListPos = ImageList->next;
			break;
		case A_ACTIVE:
			elmf->CurrAudListPos = AudioList->next;
			break;
		case V_ACTIVE:
			elmf->CurrVidListPos = VideoList->next;
			break;
	}
}
//------------------------------------------------------------------------------------------------
void InitStorageICON(Uint8 i)
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;

	if(!strcmp(SelectedDev, DEVICE_HD_NAME))
	{
		elmf->icon_arr[i].fname = desc->HD[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][0][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][0][1];
	}
	else if(!strcmp(SelectedDev, DEVICE_CF_NAME))
	{
		elmf->icon_arr[i].fname = desc->CF[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][1][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][1][1];
	}
	else if(!strcmp(SelectedDev, DEVICE_SDMMC_NAME))
	{
		elmf->icon_arr[i].fname = desc->SDMMC[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][2][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][2][1];
	}
	else if(!strcmp(SelectedDev, DEVICE_xD_NAME))
	{
		elmf->icon_arr[i].fname = desc->XDSM[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][3][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][3][1];
	}
	else if(!strcmp(SelectedDev, DEVICE_MS_NAME))
	{
		elmf->icon_arr[i].fname = desc->MS[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][4][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][4][1];
	}
	else if(!strcmp(SelectedDev, DEVICE_USB_NAME))
	{
		elmf->icon_arr[i].fname = desc->USB[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][5][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][5][1];
	}
	else if(!strcmp(SelectedDev, DEVICE_FLASH_NAME))
	{
		elmf->icon_arr[i].fname = desc->FLASH[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][7][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][7][1];
	}
#ifdef BLUETOOTH_MOD
	else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
	{
		elmf->icon_arr[i].fname = desc->BT[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][8][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][8][1];
	}
#endif
#ifdef NET_MOD
	else if(!strcmp(SelectedDev, DEVICE_RSS_NAME))
	{
		elmf->icon_arr[i].fname = desc->RSS[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][10][0];
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][10][1];
	}
	else if(!strcmp(SelectedDev, DEVICE_NAS_NAME))
	{
		elmf->icon_arr[i].fname = desc->NAS[2];
		elmf->icon_arr[i].icoord = desc->DSCoord[2][11][0];//rywu20080806 change 9 to 11
		elmf->icon_arr[i].txtcoord= desc->DSCoord[2][11][1];//rywu20080806 change 9 to 11
	}
#endif
	FillupICONImageBuffer(i);
}
//------------------------------------------------------------------------------------------------
void InitMiscICON(Uint32 i)
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;

	switch(active_index)
	{
		case DS_ACTIVE:
///080321
#ifdef NET_MOD
		case NET_DS_ACTIVE:
#endif
///
		case MT_ACTIVE:
			elmf->icon_arr[i].fname = desc->MiscICONIMG[3];//i_sandglass
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[3].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[3].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[3].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[3].height;
			FillupICONImageBuffer(i);
			break;
		case I_ACTIVE:
			elmf->icon_arr[i].fname = desc->MiscICONIMG[3];//i_sandglass
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[3].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[3].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[3].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[3].height;
			FillupICONImageBuffer(i);
			InitStorageICON(i + 1);
			break;
		case A_ACTIVE:
			elmf->icon_arr[i].fname = desc->MiscICONIMG[1];//i_musicplayed
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[1].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[1].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[1].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[1].height;
			FillupICONImageBuffer(i);
			elmf->icon_arr[i + 1].fname = desc->MiscICONIMG[2];//i_musicnotsupport
			elmf->icon_arr[i + 1].icoord.x = desc->MiscICONCoord[2].x;
			elmf->icon_arr[i + 1].icoord.y = desc->MiscICONCoord[2].y;
			elmf->icon_arr[i + 1].icoord.width = desc->MiscICONCoord[2].width;
			elmf->icon_arr[i + 1].icoord.height= desc->MiscICONCoord[2].height;
			FillupICONImageBuffer(i + 1);
			elmf->icon_arr[i + 2].fname = desc->MiscICONIMG[3];//i_sandglass
			elmf->icon_arr[i + 2].icoord.x = desc->MiscICONCoord[3].x;
			elmf->icon_arr[i + 2].icoord.y = desc->MiscICONCoord[3].y;
			elmf->icon_arr[i + 2].icoord.width = desc->MiscICONCoord[3].width;
			elmf->icon_arr[i + 2].icoord.height= desc->MiscICONCoord[3].height;
			FillupICONImageBuffer(i + 2);
#if defined(KINGSTON)
			elmf->icon_arr[i + 3].fname = desc->MiscICONIMG[6];//LR
			elmf->icon_arr[i + 3].icoord.x = desc->MiscICONCoord[6].x;
			elmf->icon_arr[i + 3].icoord.y = desc->MiscICONCoord[6].y;
			elmf->icon_arr[i + 3].icoord.width = desc->MiscICONCoord[6].width;
			elmf->icon_arr[i + 3].icoord.height= desc->MiscICONCoord[6].height;
			FillupICONImageBuffer(i + 3);
			elmf->icon_arr[i + 4].fname = desc->MiscICONIMG[7];//LL
			elmf->icon_arr[i + 4].icoord.x = desc->MiscICONCoord[7].x;
			elmf->icon_arr[i + 4].icoord.y = desc->MiscICONCoord[7].y;
			elmf->icon_arr[i + 4].icoord.width = desc->MiscICONCoord[7].width;
			elmf->icon_arr[i + 4].icoord.height= desc->MiscICONCoord[7].height;
			FillupICONImageBuffer(i + 4);
			elmf->icon_arr[i + 5].fname = desc->MiscICONIMG[8];//RR
			elmf->icon_arr[i + 5].icoord.x = desc->MiscICONCoord[8].x;
			elmf->icon_arr[i + 5].icoord.y = desc->MiscICONCoord[8].y;
			elmf->icon_arr[i + 5].icoord.width = desc->MiscICONCoord[8].width;
			elmf->icon_arr[i + 5].icoord.height= desc->MiscICONCoord[8].height;
			FillupICONImageBuffer(i + 5);
			elmf->icon_arr[i + 6].fname = desc->MiscICONIMG[9];//mute
			elmf->icon_arr[i + 6].icoord.x = desc->MiscICONCoord[9].x;
			elmf->icon_arr[i + 6].icoord.y = desc->MiscICONCoord[9].y;
			elmf->icon_arr[i + 6].icoord.width = desc->MiscICONCoord[9].width;
			elmf->icon_arr[i + 6].icoord.height= desc->MiscICONCoord[9].height;
			FillupICONImageBuffer(i + 6);
			elmf->icon_arr[i + 7].fname = desc->MiscICONIMG[10];//vol
			elmf->icon_arr[i + 7].icoord.x = desc->MiscICONCoord[10].x;
			elmf->icon_arr[i + 7].icoord.y = desc->MiscICONCoord[10].y;
			elmf->icon_arr[i + 7].icoord.width = desc->MiscICONCoord[10].width;
			elmf->icon_arr[i + 7].icoord.height= desc->MiscICONCoord[10].height;
			FillupICONImageBuffer(i + 7);
			elmf->icon_arr[i + 8].fname = desc->MiscICONIMG[11];//volx1
			elmf->icon_arr[i + 8].icoord.x = desc->MiscICONCoord[11].x;
			elmf->icon_arr[i + 8].icoord.y = desc->MiscICONCoord[11].y;
			elmf->icon_arr[i + 8].icoord.width = desc->MiscICONCoord[11].width;
			elmf->icon_arr[i + 8].icoord.height= desc->MiscICONCoord[11].height;
			FillupICONImageBuffer(i + 8);
			InitStorageICON(i + 9);
#else
			InitStorageICON(i + 3);
#endif
			break;
		case V_ACTIVE:
			elmf->icon_arr[i].fname = desc->MiscICONIMG[0];//i_videonotsupport
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[0].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[0].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[0].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[0].height;
			FillupICONImageBuffer(i);
			elmf->icon_arr[i + 1].fname = desc->MiscICONIMG[3];//i_sandglass
			elmf->icon_arr[i + 1].icoord.x = desc->MiscICONCoord[3].x;
			elmf->icon_arr[i + 1].icoord.y = desc->MiscICONCoord[3].y;
			elmf->icon_arr[i + 1].icoord.width = desc->MiscICONCoord[3].width;
			elmf->icon_arr[i + 1].icoord.height= desc->MiscICONCoord[3].height;
			FillupICONImageBuffer(i + 1);
			InitStorageICON(i + 2);
			break;
		case FLDR_ACTIVE:
			/*
			elmf->icon_arr[i].fname = desc->MiscICONIMG[5];//folderw
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[5].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[5].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[5].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[5].height;
			FillupICONImageBuffer(i);
			elmf->icon_arr[i+1].fname = desc->MiscICONIMG[6];//musicw
			elmf->icon_arr[i+1].icoord.x = desc->MiscICONCoord[6].x;
			elmf->icon_arr[i+1].icoord.y = desc->MiscICONCoord[6].y;
			elmf->icon_arr[i+1].icoord.width = desc->MiscICONCoord[6].width;
			elmf->icon_arr[i+1].icoord.height= desc->MiscICONCoord[6].height;
			FillupICONImageBuffer(i+1);
			elmf->icon_arr[i+2].fname = desc->MiscICONIMG[7];//videow
			elmf->icon_arr[i+2].icoord.x = desc->MiscICONCoord[7].x;
			elmf->icon_arr[i+2].icoord.y = desc->MiscICONCoord[7].y;
			elmf->icon_arr[i+2].icoord.width = desc->MiscICONCoord[7].width;
			elmf->icon_arr[i+2].icoord.height= desc->MiscICONCoord[7].height;
			FillupICONImageBuffer(i+2);
			*/
			elmf->icon_arr[i].fname = desc->MiscICONIMG[4];//i_fileselect
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[4].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[4].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[4].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[4].height;
			FillupICONImageBuffer(i);
			elmf->icon_arr[i+1].fname = desc->MiscICONIMG[3];//i_sandglass
			elmf->icon_arr[i+1].icoord.x = desc->MiscICONCoord[3].x;
			elmf->icon_arr[i+1].icoord.y = desc->MiscICONCoord[3].y;
			elmf->icon_arr[i+1].icoord.width = desc->MiscICONCoord[3].width;
			elmf->icon_arr[i+1].icoord.height= desc->MiscICONCoord[3].height;
			FillupICONImageBuffer(i+1);
			InitStorageICON(i+2);
			break;
#ifdef BLUETOOTH_MOD
		case BT_ACTIVE:
/*
			elmf->icon_arr[i].fname = desc->MiscICONIMG[4];//i_fileselect
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[4].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[4].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[4].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[4].height;
			FillupICONImageBuffer(i);
			elmf->icon_arr[i+1].fname = desc->MiscICONIMG[3];//i_sandglass
			elmf->icon_arr[i+1].icoord.x = desc->MiscICONCoord[3].x;
			elmf->icon_arr[i+1].icoord.y = desc->MiscICONCoord[3].y;
			elmf->icon_arr[i+1].icoord.width = desc->MiscICONCoord[3].width;
			elmf->icon_arr[i+1].icoord.height= desc->MiscICONCoord[3].height;
			FillupICONImageBuffer(i+1);
*/
			InitStorageICON(i);
			break;
#endif
#ifdef IP_CAM_MOD
		case IP_CAM_ACTIVE:
			elmf->icon_arr[i].fname = desc->MiscICONIMG[4];//i_fileselect
			elmf->icon_arr[i].icoord.x = desc->MiscICONCoord[4].x;
			elmf->icon_arr[i].icoord.y = desc->MiscICONCoord[4].y;
			elmf->icon_arr[i].icoord.width = desc->MiscICONCoord[4].width;
			elmf->icon_arr[i].icoord.height= desc->MiscICONCoord[4].height;
			FillupICONImageBuffer(i);
			break;
#endif
	}
}
//------------------------------------------------------------------------------------------------
void DSInit()
{
	COORD show_str_pos;
	FRAME *elmf;

#ifdef SUPPORT_RSS
    int got_net_device = 0;//rywu20080516
#endif

	elmf = &ELMachines[active_index].frame;

	elmf->active_icon_index = 0;
	isFlashMusicUsed = FALSE;
	FreeList(MT_MUSIC);
	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///

	///070813
	//InitFrameBackground(bkg_blank);
	///

	InitFrameTextMessage(FrameText[setup->Language][7], &desc->MiscTextCoord[4]);

	///080319 lئITEM_DATA
	int i;
	ITEM_DATA *pItem = &(elmf->item_data);
	memset(pItem, 0, sizeof(ITEM_DATA));
	pItem->item_array = IconTxtArr4DS;
	for (i=0; i<num_enabled_dev; i++)
	{
		//o@ݭnܪضbo
		if (  strcmp(pItem->item_array[i], DEVICE_SDMMC_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_CF_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_MS_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_FLASH_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_CARD_READER_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_USB_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_xD_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_HD_NAME) == 0
#ifdef NET_MOD
			||
			  strcmp(pItem->item_array[i], DEVICE_NET_NAME) == 0
#endif
#ifdef BLUETOOTH_MOD
			||
			  strcmp(pItem->item_array[i], DEVICE_BT_NAME) == 0
#endif
		   )
		{
			pItem->index[pItem->total_item++] = i;
		}
	}

//rywu20080516++
#ifdef SUPPORT_RSS
    //force to show network icon in Device Select state
    for (i=0; i<num_enabled_dev; i++)
    {
        if (!strcmp(pItem->item_array[i], DEVICE_NET_NAME))
        {
            got_net_device = 1;
        }
    }
    if (!got_net_device)
    {
        strcpy(desc->ICONFilename4DS[0][i], desc->NET[0]);
        strcpy(desc->ICONFilename4DS[1][i], desc->NET[1]);
        IconTxtArr4DS[i] = DEVICE_NET_NAME;
        pItem->index[pItem->total_item++] = i++;
    }
#endif
//rywu20080516--

	/*
	if (SelectedDev)
	{
		for (i=0; i<pItem->total_item; i++)
		{
			if (strcmp(SelectedDev, pItem->item_array[pItem->index[i]]) == 0)
			//if (pItem->index[i] == *((Sint8*)(pItem->pvalue)))
			{
				pItem->curr_item = i;	//ιw]m
				break;
			}
		}
	}
	*/
	///

	///070813
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///
	//PRINTF("rss = %d\n", dev_mnted_enbled_flags.rss);
	//PRINTF("nas = %d\n", dev_mnted_enbled_flags.nas);

	///080320
	InitFrameICON(pItem->total_item);
	//InitFrameICON(num_enabled_dev);
	///

	// Allocate lists for auto slideshow

	show_str_pos.x = desc->MiscTextCoord[44].x;
	show_str_pos.y = desc->MiscTextCoord[44].y;
	show_process_msg(FrameText[setup->Language][46],show_str_pos,1);
#if !defined(KINGSTON)
	SearchFileByDevice(MT_PHOTO | MT_MUSIC, Mounted_Device);
#endif
	stop_show_process_msg();
}
//------------------------------------------------------------------------------------------------
void MTInit()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	CurrPhotoIdx4SSCal = 0;
	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///
	//InitFrameBackground(bkg_blank);

	///070813
	//InitFrameBackground(bkg_mt);
	///

	InitFrameTextMessage(FrameText[setup->Language][8], &desc->MiscTextCoord[5]);

	///070813
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///
	InitFrameICON(MAX_NUM_MTICON);
	///071012 lئITEM_DATA
	int i;
	ITEM_DATA *pItem = &(elmf->item_data);
	memset(pItem, 0, sizeof(ITEM_DATA));
	pItem->pvalue = (void*)(&elmf->active_icon_index);
	for (i=0; i<MAX_NUM_MTICON; i++)
	{
		switch (i)
		{
		case calendar:
			if (isRTCWorking)
			{
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
			}
			break;
		default:
			pItem->index[pItem->total_item] = i;
			pItem->total_item++;
			break;
		}
	}

	for (i=0; i<pItem->total_item; i++)
	{
		if (pItem->index[i] == *((Sint8*)(pItem->pvalue)))
			pItem->curr_item = i;	//ιw]m
	}

	//071024 sե setup->xxxidx 
	*((Sint8*)(pItem->pvalue)) = pItem->index[pItem->curr_item];
	///
}
//------------------------------------------------------------------------------------------------
void SetupL1Init()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070815
	elmf->rgbtemplate = InitFrameBackground(bkg_setup);
	//InitFrameBackground(bkg_setup);
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///

	///071011 lئITEM_DATA
	int i;
	ITEM_DATA *pItem = &(elmf->item_data);
	memset(pItem, 0, sizeof(ITEM_DATA));
	pItem->pvalue = (void*)(&setup->main_menu_idx);
	for (i=0; i<MAIN_MENU_ITEM_NUM; i++)
	{
		switch (i)
		{
			case L1_AutoPower_Setup:
		#if defined(GUI_STYLE_COMTEK)
				break;
		#endif
			case L1_CalendarTimeAlarm_Setup:
			case L1_AutoPlay_Setup:
				if (isRTCWorking)
				{
					pItem->index[pItem->total_item] = i;
					pItem->total_item++;
	 			}
				break;
			case L1_CopyDelete_Setup:
				if (isCopyAllowed() || isDelAllowed())
				{
					pItem->index[pItem->total_item] = i;
					pItem->total_item++;
				}
				break;
			default:
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
				break;
		}
	}

	for (i=0; i<pItem->total_item; i++)
	{
		if (pItem->index[i] == *((Sint8*)(pItem->pvalue)))
			pItem->curr_item = i;	//ιw]m
	}

	//071024 sե setup->xxxidx 
	*((Sint8*)(pItem->pvalue)) = pItem->index[pItem->curr_item];
	///
}
//------------------------------------------------------------------------------------------------
void SetupL2Init()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070815
	elmf->rgbtemplate = InitFrameBackground(bkg_setup);
	//InitFrameBackground(bkg_setup);
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///

	///071024 lئITEM_DATA
	int i;
	ITEM_DATA *pItem = &(elmf->item_data);
	memset(pItem, 0, sizeof(ITEM_DATA));

	switch (setup->main_menu_idx)
	{
	case L1_System_Setup:
		pItem->pvalue = (void*)(&setup->sys_idx);
		pItem->item_array = setup->sys_item;
		for (i=0; i<SYS_ITEM_NUM; i++)
		{
			switch (i)
			{
			case L2_System_PowerSavingMode:
				if (isRTCWorking)
				{
					pItem->index[pItem->total_item] = i;
					pItem->total_item++;
				}
				break;
			case L2_System_BrightnessContrast:
#ifdef USE_DESC_LCD
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
#endif
				break;
			case L2_System_FlashFormat:
				if(prev_active_index == DS_ACTIVE && dev_mnted_enbled_flags.flash)
				{
					pItem->index[pItem->total_item] = i;
					pItem->total_item++;
				}
				break;
			default:
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
				break;
			}
		}
		break;
	case L1_Slideshow_Setup:
		pItem->pvalue = (void*)(&setup->ss_idx);
		pItem->item_array = setup->ss_item;
		for (i=0; i<SS_ITEM_NUM; i++)
		{
			pItem->index[pItem->total_item] = i;
			pItem->total_item++;
		}
		break;
	case L1_AV_Setup:
		pItem->pvalue = (void*)(&setup->av_idx);
		pItem->item_array = setup->av_item;
		for (i=0; i<AV_ITEM_NUM; i++)
		{
			switch(i)
			{
			case L2_AV_VidTimeDsplyMode:
#ifdef VIDEO_TIME_DISPLAY_MOD
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
#endif
				break;
			default:
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
				break;
			}
		}
		break;
	case L1_CalendarTimeAlarm_Setup:
		pItem->pvalue = (void*)(&setup->caltimealarm_idx);
		pItem->item_array = setup->caltimealarm_item;
		for (i=0; i<CALTIMEALARM_ITEM_NUM; i++)
		{
#ifdef LEADTEK
			if(i == L2_CalTimeAlarm_AlphaValue)
				continue;
#endif
			pItem->index[pItem->total_item] = i;
			pItem->total_item++;
		}
		break;
	case L1_CopyDelete_Setup:
		pItem->pvalue = (void*)(&setup->cpydel_idx);
		pItem->item_array = setup->cpydel_item;
		for (i=0; i<CPYDEL_ITEM_NUM; i++)
		{
			switch (i)
			{
			case L2_CopyDelete_Copy:
				if (!isCopyAllowed())
					pItem->status[pItem->total_item] = 1;
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
				break;
			case L2_CopyDelete_Delete:
				if (!isDelAllowed())
					pItem->status[pItem->total_item] = 1;
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
				break;
			default:
				break;
			}
		}
		break;
	case L1_AutoPower_Setup:
		pItem->pvalue = (void*)(&setup->autopwr_idx);
		pItem->item_array = setup->autopwr_item;
		for (i=0; i<AUTOPWR_ITEM_NUM; i++)
		{
			pItem->index[pItem->total_item] = i;
			pItem->total_item++;
		}
		break;
	case L1_AutoPlay_Setup:
		pItem->pvalue = (void*)(&setup->autoplay_idx);
		pItem->item_array = setup->autoplay_item;
		for (i=0; i<AUTOPLAY_ITEM_NUM; i++)
		{
			pItem->index[pItem->total_item] = i;
			pItem->total_item++;
		}
		break;
	default:
		break;
	}

	for (i=0; i<pItem->total_item; i++)
	{
		if (pItem->index[i] == *((Sint8*)(pItem->pvalue)))
			pItem->curr_item = i;	//ιw]m
	}

	//sե setup->xxxidx 
	*((Sint8*)(pItem->pvalue)) = pItem->index[pItem->curr_item];
}
//------------------------------------------------------------------------------------------------
void SetupL3Init()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070815
	elmf->rgbtemplate = InitFrameBackground(bkg_setup);
	//InitFrameBackground(bkg_setup);
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///

	//get current time for calendar time setup
	if(setup->main_menu_idx == L1_CalendarTimeAlarm_Setup && setup->caltimealarm_idx == L2_CalTimeAlarm_CalendarTime)
	{
		GetTime(&currTime);
		setup->year = currTime.tm_year + 1900;
		setup->month = currTime.tm_mon + 1;
		setup->day = currTime.tm_mday;
		setup->hour = currTime.tm_hour;
		setup->minute = currTime.tm_min;
		setup->second = currTime.tm_sec;
	}

    ///071128
	int i;
	ITEM_DATA *pItem = &(elmf->item_data);
	memset(pItem, 0, sizeof(ITEM_DATA));
    pItem->items_per_page = 10;

	switch(setup->main_menu_idx)
	{
	case L1_System_Setup:
        pItem->title = setup->sys_item[setup->sys_idx];
        switch(setup->sys_idx)
        {
        case L2_System_Language:
			pItem->title = LangTitle;//080514
            pItem->pvalue = (void*)(&setup->lang_idx);
            pItem->item_array = langStr;//setup->lang_item;

			///080118
			if (access(desc->FontFileName[NUM_OF_FONT_FILE-1], R_OK) == 0)
			{
				for (i=0; i<LANG_ITEM_NUM; i++)
				{
					pItem->index[pItem->total_item] = i;
					pItem->total_item++;
				}
			}
			else
			///
			{
				///071204
				if (access(desc->FontFileName[1], R_OK) == 0)
				{
					pItem->index[pItem->total_item] = SETUP_LANG_English;
					pItem->total_item++;
					pItem->index[pItem->total_item] = SETUP_LANG_Italiano;
					pItem->total_item++;
					pItem->index[pItem->total_item] = SETUP_LANG_Deutsch;
					pItem->total_item++;
					pItem->index[pItem->total_item] = SETUP_LANG_Francais;
					pItem->total_item++;
					pItem->index[pItem->total_item] = SETUP_LANG_Espanol;
					pItem->total_item++;
					pItem->index[pItem->total_item] = SETUP_LANG_Portuguese;
					pItem->total_item++;
					pItem->index[pItem->total_item] = SETUP_LANG_Dutch;
					pItem->total_item++;
				}
				if (access(desc->FontFileName[2], R_OK) == 0)
				{
					pItem->index[pItem->total_item] = SETUP_LANG_CHT;
					pItem->total_item++;
				}
				if (access(desc->FontFileName[3], R_OK) == 0)
				{
					pItem->index[pItem->total_item] = SETUP_LANG_CHS;
					pItem->total_item++;
				}
				if (access(desc->FontFileName[4], R_OK) == 0)
				{
					pItem->index[pItem->total_item] = SETUP_LANG_JP;
					pItem->total_item++;
				}
				if (access(desc->FontFileName[5], R_OK) == 0)
				{
					pItem->index[pItem->total_item] = SETUP_LANG_KR;
					pItem->total_item++;
				}
			}
			/*
			for (i=0; i<LANG_ITEM_NUM; i++)
			{
				pItem->index[pItem->total_item] = i;
				pItem->total_item++;
			}
			*/
			///
            break;
        case L2_System_PowerSavingMode:
            pItem->pvalue = (void*)(&setup->pwrsav_idx);
            pItem->item_array = setup->pwrsav_item;
            for (i=0; i<PWRSAV_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_System_DefaultSetting:
            pItem->pvalue = (void*)(&setup->reset_idx);
            pItem->item_array = setup->reset_item;
            for (i=0; i<RESET_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_System_Status:
            pItem->item_array = setup->sys_sts_item;
            break;
        case L2_System_AlphaValue:
            pItem->pvalue = (void*)(&setup->sys_alpha);
            break;
        case L2_System_Homepage:
            pItem->pvalue = (void*)(&setup->homepage_idx);
            pItem->item_array = setup->homepage_item;
            for (i=0; i<HOMEPAGE_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_System_BrightnessContrast:
            pItem->pvalue = (void*)(&SelectedBrightContrast);
            break;
        case L2_System_FileSortingMehod:
            pItem->pvalue = (void*)(&setup->sorting_idx);
            pItem->item_array = setup->sorting_item;
            for (i=0; i<SORTING_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
	case L2_System_FlashFormat:
		pItem->pvalue = (void*)(&setup->flsh_fmt_idx);
		pItem->item_array = setup->flsh_fmt_item;
            for (i=0; i<FLASH_FORMAT_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
		break;
		}
		break;
	case L1_Slideshow_Setup:
        pItem->title = setup->ss_item[setup->ss_idx];
        switch(setup->ss_idx)
        {
        case L2_Slideshow_RepeatMode:
            pItem->pvalue = (void*)(&setup->ss_rpt_idx);
            pItem->item_array = setup->ss_rpt_item;
            for (i=0; i<SS_RPT_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_Slideshow_IntervalTime:
            pItem->pvalue = (void*)(&setup->ss_interval_idx);
            pItem->item_array = setup->ss_interval_item;
#ifdef LEADTEK
		for (i=0; i<SS_SPEED_ITEM_NUM_LEADTEK; i++)
#else
            for (i=0; i<SS_SPEED_ITEM_NUM; i++)
#endif
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_Slideshow_TransitionEffect:
            pItem->pvalue = (void*)(&setup->ss_effect_idx);
            pItem->item_array = setup->ss_effect_item;
            for (i=0; i<SS_EFFECT_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        }
        break;
	case L1_AV_Setup:
        pItem->title = setup->av_item[setup->av_idx];
        switch(setup->av_idx)
        {
        case L2_AV_AudioRepeatMode:
            pItem->pvalue = (void*)(&setup->aud_rpt_idx);
            pItem->item_array = setup->aud_rpt_item;
            for (i=0; i<AUD_RPT_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_AV_VideoRepeatMode:
            pItem->pvalue = (void*)(&setup->vid_rpt_idx);
            pItem->item_array = setup->vid_rpt_item;
            for (i=0; i<VID_RPT_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
#ifdef WINGUI
	case L2_Display_Full_Screen:
		pItem->pvalue = (void*)(&setup->display_full_screen_idx);
		pItem->item_array = setup->display_full_screen_item;
		for (i=0; i<DISPLAY_FULL_SCREEN_ITEM_NUM; i++)
		{
		    pItem->index[pItem->total_item] = i;
		    pItem->total_item++;
		}
		break;
#endif
        case L2_AV_VidTimeDsplyMode:
            pItem->pvalue = (void*)(&setup->vid_time_dsply_idx);
            pItem->item_array = setup->vid_time_dsply_item;
            for (i=0; i<VID_TIME_DSPLY_MODE_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
			break;
		///080325
		case L2_AV_AudioChannel:
			pItem->pvalue = (void*)(&setup->aud_chnl_idx);
			pItem->item_array = setup->aud_chnl_item;
			for (i=0; i<AUD_CHNL_ITEM_NUM; i++)
			{
				pItem->index[pItem->total_item] = i;
                pItem->total_item++;
			}
			break;
		///
        }
        break;
	case L1_CalendarTimeAlarm_Setup:
        pItem->title = setup->caltimealarm_item[setup->caltimealarm_idx];
        switch(setup->caltimealarm_idx)
        {
        case L2_CalTimeAlarm_CalendarTime:
            pItem->pvalue = (void*)(&SelectedCalTime);
            break;
        case L2_CalTimeAlarm_AlphaValue:
            pItem->pvalue = (void*)(&setup->cal_alpha);
			break;
        case L2_CalTimeAlarm_AlarmSetupMode:
            pItem->pvalue = (void*)(&setup->alarm_setup_idx);
            pItem->item_array = setup->alarm_setup_item;
            for (i=0; i<ALARM_SETUP_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
			break;
        case L2_CalTimeAlarm_Alarm:
            pItem->pvalue = (void*)(&SelectedAlarmTime);
            break;
		}
		break;
	case L1_CopyDelete_Setup:
		pItem->title = setup->cpydel_item[setup->cpydel_idx];
        switch(setup->cpydel_idx)
        {
        case L2_CopyDelete_Copy:
            pItem->pvalue = (void*)(&setup->cpy_idx);
            pItem->item_array = SETUP_COPY_TO_DEVICE;
            if (dev_mnted_enbled_flags.sdmmc
                && 0 != strcmp(SelectedDev, DEVICE_SDMMC_NAME))
            {
                if (isWriteProtected(DEVICE_SDMMC_NAME))
                    pItem->status[pItem->total_item] = 1;   //g
                pItem->index[pItem->total_item] = COPY_TO_SDMMC;
                pItem->total_item++;
            }
            if (dev_mnted_enbled_flags.cf
                && 0 != strcmp(SelectedDev, DEVICE_CF_NAME))
            {
                if (isWriteProtected(DEVICE_CF_NAME))
                    pItem->status[pItem->total_item] = 1;
                pItem->index[pItem->total_item] = COPY_TO_CF;
                pItem->total_item++;
            }
            if (dev_mnted_enbled_flags.usb
                && 0 != strcmp(SelectedDev, DEVICE_USB_NAME))
            {
                if (isWriteProtected(DEVICE_USB_NAME))
                    pItem->status[pItem->total_item] = 1;
                pItem->index[pItem->total_item] = COPY_TO_USB;
                pItem->total_item++;
            }
            if (dev_mnted_enbled_flags.xdsm
                && 0 != strcmp(SelectedDev, DEVICE_xD_NAME))
            {
                if (isWriteProtected(DEVICE_xD_NAME))
                    pItem->status[pItem->total_item] = 1;
                pItem->index[pItem->total_item] = COPY_TO_XD;
                pItem->total_item++;
            }
            if (dev_mnted_enbled_flags.msx
                && 0 != strcmp(SelectedDev, DEVICE_MS_NAME))
            {
                if (isWriteProtected(DEVICE_MS_NAME))
                    pItem->status[pItem->total_item] = 1;
                pItem->index[pItem->total_item] = COPY_TO_MS;
                pItem->total_item++;
            }
            if (dev_mnted_enbled_flags.hd
                && 0 != strcmp(SelectedDev, DEVICE_HD_NAME))
            {
                if (isWriteProtected(DEVICE_HD_NAME))
                    pItem->status[pItem->total_item] = 1;
                pItem->index[pItem->total_item] = COPY_TO_HD;
                pItem->total_item++;
            }
            if (dev_mnted_enbled_flags.flash
                && 0 != strcmp(SelectedDev, DEVICE_FLASH_NAME))
            {
                if (isWriteProtected(DEVICE_FLASH_NAME))
                    pItem->status[pItem->total_item] = 1;
                pItem->index[pItem->total_item] = COPY_TO_FLASH;
                pItem->total_item++;
            }
            break;
        case L2_CopyDelete_Delete:
            pItem->pvalue = (void*)(&setup->del_idx);
            pItem->item_array = setup->del_item;
            for (i=0; i<DEL_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        }
        break;
	case L1_AutoPower_Setup:
		pItem->title = setup->autopwr_item[setup->autopwr_idx];
        switch(setup->autopwr_idx)
        {
        case L2_AutoPower_Mode:
            pItem->pvalue = (void*)(&setup->autopwr_setup_idx);
            pItem->item_array = setup->autopwr_setup_item;
            for (i=0; i<AUTOPWR_SETUP_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_AutoPower_OnOffTime:
            pItem->pvalue = (void*)(&SelectedAutoPwrOnOffTime);
            break;
        }
        break;
	case L1_AutoPlay_Setup:
        pItem->title = setup->autoplay_item[setup->autoplay_idx];
        switch(setup->autoplay_idx)
        {
        case L2_AutoPlay_Mode:
            pItem->pvalue = (void*)(&setup->autoplay_setup_idx);
            pItem->item_array = setup->autoplay_setup_item;
            for (i=0; i<AUTOPLAY_SETUP_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        case L2_AutoPlay_Selected_Media:
            pItem->pvalue = (void*)(&setup->autoplay_selected_media_idx);
            pItem->item_array = setup->autoplay_selected_media_item;
            for (i=0; i<AUTOPLAY_SELECT_ITEM_NUM; i++)
            {
                pItem->index[pItem->total_item] = i;
                pItem->total_item++;
            }
            break;
        }
        break;
	}

    if (pItem->total_item > 0)  //зǪﶵ
    {
        for (i=0; i<pItem->total_item; i++)
    	{
    		if (pItem->index[i] == *((Sint8*)(pItem->pvalue)))
    			pItem->curr_item = i;	//ιw]m
    	}
    	//sե setup->xxxidx 
    	*((Sint8*)(pItem->pvalue)) = pItem->index[pItem->curr_item];

        //եheadm
        if (pItem->curr_item >= pItem->items_per_page)
        {
            pItem->head_item = pItem->curr_item - pItem->items_per_page + 1;
        }
    }
    ///
}
//------------------------------------------------------------------------------------------------
void ImgInit()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///
	///070814
	//InitFrameBackground(bkg_photo);
	///
	InitFrameTextMessage(FrameText[setup->Language][0], &desc->MiscTextCoord[0]);
	///070814
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///
	InitFrameThumbNail(ICON_NUM_PER_FRAME);
	///070814
	//MEMALLOC(elmf->osdbuff, Uint8, RGB_FRAMEBUFF_SIZE);
	///
}
//------------------------------------------------------------------------------------------------
void FImgInit()
{
	//FRAME *elmf;
	//elmf = &ELMachines[active_index].frame;
	//
	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///
	///070814
	//MEMALLOC(elmf->osdbuff, Uint8, RGB_FRAMEBUFF_SIZE);
	///

//for fashionstar switching resolution request - bk @ 071114
#ifdef USE_DESC_TV
  #ifdef TV_FI_SWITCH_RESOLUTION

	//current display mode is different from current FI display mode
	if(pgu_get_display_index() != currFIDspMode)
	{
		pgu_set_display_index(currFIDspMode, 1);
		InitDisplayParameter(currFIDspMode);
		//p.s. volumebuffer@˫Oj (]쥻allocswitch᪺jBswitchȨSΨ)
	}

  #endif
#endif
}
//------------------------------------------------------------------------------------------------
void AudInit()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///
	///070814
	//InitFrameBackground(bkg_music);
	///

	InitFrameTextMessage(FrameText[setup->Language][1], &desc->MiscTextCoord[1]);

	///070814
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///

	InitFrameThumbNail(MUSIC_BAR_NUM);

	///070814
	//MEMALLOC(elmf->osdbuff, Uint8, RGB_FRAMEBUFF_SIZE);
	///

#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(1);
#endif
}
//------------------------------------------------------------------------------------------------
void VidInit()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///
	///070814
	//InitFrameBackground(bkg_video);
	///
	InitFrameTextMessage(FrameText[setup->Language][2], &desc->MiscTextCoord[2]);
	///070814
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///
	InitFrameThumbNail(ICON_NUM_PER_FRAME);
}
//------------------------------------------------------------------------------------------------
void FVidInit()
{
	FRAME *elmf;
	Uint8 displayMode;
	elmf = &ELMachines[active_index].frame;

///070816
#ifdef USE_DESC_TV
	if(origDisplayMode == DISP_HDTV && GetDisplayIndex() == DISP_HDTV)
	{
#ifdef TV_FI_SWITCH_RESOLUTION_PAL
		displayMode = DISP_PAL;
#else
		displayMode = DISP_NTSC;
#endif
		SetDisplayInterface(displayMode);
		InitDisplayParameter(displayMode);

		///070831 rYp
		g_pFontDB_Default->bScaleDown = true;
		g_pFontDB_Local->bScaleDown = true;
		///
	}
#endif
///

	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///
	/* Flowbee reset the pixel clock of LCD panel. */
	//pgu_set_clkcfg(5);

#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(1);
#endif
}
//------------------------------------------------------------------------------------------------
void SSInit()
{
	FRAME *elmf;
	Uint8 displayMode = DISP_NTSC;
	COORD frametextmsgcoord = {250, 220, 0, 0};

	elmf = &ELMachines[active_index].frame;

	///070815
	//	InitFrameBackground(bkg_blank);
	///

	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///

	#ifdef LEADTEK
	InitFrameBackground(bkg_slideshow);
	#else
	InitFrameTextMessage(FrameText[setup->Language][11], &desc->MiscTextCoord[9]);
	#endif
	///070815
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///

	/* Flowbee reset the pixel clock of LCD panel. */
	//pgu_set_clkcfg(5);

#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(1);
#endif
}
//------------------------------------------------------------------------------------------------
void USB2PConnIinit()
{
	FRAME *elmf;
	COORD frametextmsgcoord = {100, 100, 0, 0};

	elmf = &ELMachines[active_index].frame;
	///070814
	//InitFrameBackground(bkg_usb2pconn);
	///
	InitFrameTextMessage(FrameText[setup->Language][12], &desc->MiscTextCoord[12]);
	///070814
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///
}
//------------------------------------------------------------------------------------------------
void NoStorageInit()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	///070816
	//InitFrameBackground(bkg_nodevice);
	///
	InitFrameTextMessage(FrameText[setup->Language][6], &desc->MiscTextCoord[3]);
	///070816
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///
}
//------------------------------------------------------------------------------------------------
void ConfirmInit()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
}
//------------------------------------------------------------------------------------------------
void CalInit()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
///070815
/*
#ifdef USE_DESC_TV
	if (GetDisplayIndex() == DISP_HDTV && prev_active_index == FI_ACTIVE)
	{
		///070815
		elmf->rgbtemplate = InitFrameBackground(bkg_cal_hdtv);
		//InitFrameBackground(bkg_cal_hdtv);
		///
	}
	else
#endif
*/

	if (prev_active_index == FI_ACTIVE)	//Full Image
	{
		///070815
		elmf->rgbtemplate = InitFrameBackground(bkg_cal_fi);
		//InitFrameBackground(bkg_cal_fi);
		///
	}
	else
	{
		///070815
		elmf->rgbtemplate = InitFrameBackground(bkg_cal);
		//InitFrameBackground(bkg_cal);
		///
	}

	///070815
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///

///070815
/*
#ifdef USE_DESC_TV
	if(prev_active_index == FI_ACTIVE && GetDisplayIndex() == DISP_HDTV)
	{
		DrawFrameBackground(elmf->rgbtemplate);
		FREEMEMORY(elmf->bkgrdbuff);
		MEMALLOC(elmf->bkgrdbuff, Uint8, OUTPUT_XRES*desc->YRES*2);
		memcpy(elmf->bkgrdbuff, elmf->rgbtemplate, OUTPUT_XRES*desc->YRES*2);
	}
#endif
*/
///
	///070820
	InitVolumeBuffer();
	//MEMALLOC(elmf->volumebuff, Uint8, RGB_VOLBUFF_SIZE);
	///

#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(1);
#endif
}
//------------------------------------------------------------------------------------------------

///070605 Folderl
void FldrInit()
{
	FRAME *elmf;
	char RootPath[LEN_XL];
	int i;
	COORD* pcoIcon;

	elmf = &ELMachines[active_index].frame;
	FOLDER_BAR_NUM = desc->FolderBarNum;

	///070814
	//InitFrameBackground(bkg_folder);
	///

	InitVolumeBuffer();

	InitFrameTextMessage(FrameText[setup->Language][4], &desc->MiscTextCoord[24]);

	///070814
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///

	InitFrameThumbNail(FOLDER_BAR_NUM);
	GetPath(RootPath);
	chdir(RootPath);
	FolderList = FolderList_Build(".");

	elmf->active_icon_index = 0;
	CurrFldrListPos = FolderList;

	///pFolder Vieweϰ쪺d
	FldrRegion.x = elmf->icon_arr[0].icoord.x;
	FldrRegion.y = elmf->icon_arr[0].icoord.y;
	FldrRegion.width = elmf->icon_arr[0].txtcoord.x + elmf->icon_arr[0].txtcoord.width - elmf->icon_arr[0].icoord.x;
	FldrRegion.height = elmf->icon_arr[FOLDER_BAR_NUM-1].icoord.y + elmf->icon_arr[FOLDER_BAR_NUM-1].icoord.height -elmf->icon_arr[0].icoord.y;
	if((FldrRegion.y + FldrRegion.height) < (desc->MiscTextCoord[6].y + g_pFontDB_Local->FontSize))
		FldrRegion.height = (desc->MiscTextCoord[6].y + g_pFontDB_Local->FontSize) - FldrRegion.y;

#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(1);
#endif
	/*
	FldrRegion.x= elmf->icon_arr[0].txtcoord.x;
	FldrRegion.width= elmf->icon_arr[0].txtcoord.x + elmf->icon_arr[0].txtcoord.width;
	FldrRegion.y = elmf->icon_arr[0].txtcoord.y;
	FldrRegion.height= elmf->icon_arr[0].txtcoord.y + elmf->icon_arr[0].txtcoord.height;
	for (i=1; i<FOLDER_BAR_NUM; i++)
	{
		if (elmf->icon_arr[i].txtcoord.x < FldrRegion.x)
			FldrRegion.x = elmf->icon_arr[i].txtcoord.x;
		if (elmf->icon_arr[i].txtcoord.x+elmf->icon_arr[i].txtcoord.width > FldrRegion.width)
			FldrRegion.width = elmf->icon_arr[i].txtcoord.x + elmf->icon_arr[i].txtcoord.width;
		if (elmf->icon_arr[i].txtcoord.y < FldrRegion.y)
			FldrRegion.y = elmf->icon_arr[i].txtcoord.y;
		if (elmf->icon_arr[i].txtcoord.y+elmf->icon_arr[i].txtcoord.height > FldrRegion.height)
			FldrRegion.height = elmf->icon_arr[i].txtcoord.y + elmf->icon_arr[i].txtcoord.height ;
	}
	FldrRegion.width = FldrRegion.width - FldrRegion.x + 1;
	FldrRegion.height= FldrRegion.height - FldrRegion.y + 1;
	*/

	/*
	//echeckϰ
	pcoIcon = &(elmf->icon_arr[elmf->num_icon-3].icoord);
	if (FldrRegion.x < pcoIcon->width)					//ɼeפ
	{
		FldrRegion.width += FldrRegion.x;
		FldrRegion.x = 0;
	}
	else											//ɳѾlŶ
	{
		FldrRegion.width += pcoIcon->width;
		FldrRegion.x -= pcoIcon->width;
	}
	for (i=0; i<FOLDER_BAR_NUM; i++)
	{
		if (elmf->icon_arr[i].txtcoord.x < pcoIcon->width)
			elmf->icon_arr[i].icoord.x = 0;
		else
			elmf->icon_arr[i].icoord.x = elmf->icon_arr[i].txtcoord.x - pcoIcon->width;
		elmf->icon_arr[i].icoord.y = elmf->icon_arr[i].txtcoord.y;
		elmf->icon_arr[i].icoord.width = pcoIcon->width;
		elmf->icon_arr[i].icoord.height = pcoIcon->height;
	}
	*/
	///
}
///

//------------------------------------------------------------------------------------------------

///070629
void FWUpgradeInit()
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	///070816
	elmf->rgbtemplate = InitFrameBackground(bkg_fwupgrade);
	//InitFrameBackground(bkg_fwupgrade);
	//MEMALLOC(elmf->rgbtemplate, Uint8, RGB_FRAMEBUFF_SIZE);
	///
}
///
//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void BTInit()
{
	FRAME *elmf;
	char RootPath[LEN_XL];

	elmf = &ELMachines[active_index].frame;
	FOLDER_BAR_NUM = desc->BTFldrBarNum;
	BT_DVC_BAR_NUM = desc->BTDvcBarNum;

	InitFrameTextMessage(FrameText[setup->Language][29], &desc->MiscTextCoord[39]);
	InitFrameThumbNail(FOLDER_BAR_NUM + BT_DVC_BAR_NUM);
	GetPath(RootPath);
	chdir(RootPath);
	FolderList = FolderList_Build(".");

	elmf->active_icon_index = 0;
	CurrFldrListPos = FolderList;
	currBTDvcIdx = 0;

	//pFolder Vieweϰ쪺d, the parameter is sharing with Folder
	FldrRegion.x = elmf->icon_arr[0].icoord.x;
	FldrRegion.y = elmf->icon_arr[0].icoord.y;
	FldrRegion.width = elmf->icon_arr[0].txtcoord.x + elmf->icon_arr[0].txtcoord.width - elmf->icon_arr[0].icoord.x;
	FldrRegion.height = elmf->icon_arr[FOLDER_BAR_NUM - 1].icoord.y + elmf->icon_arr[FOLDER_BAR_NUM - 1].icoord.height - elmf->icon_arr[0].icoord.y;
	//pDevice Vieweϰ쪺d
	BTDvcRegion.x = elmf->icon_arr[FOLDER_BAR_NUM].txtcoord.x;
	BTDvcRegion.y = elmf->icon_arr[FOLDER_BAR_NUM].txtcoord.y;
	BTDvcRegion.width = elmf->icon_arr[FOLDER_BAR_NUM].txtcoord.width;
	BTDvcRegion.height
		= elmf->icon_arr[FOLDER_BAR_NUM + BT_DVC_BAR_NUM - 1].txtcoord.y
		+ elmf->icon_arr[FOLDER_BAR_NUM + BT_DVC_BAR_NUM - 1].txtcoord.height
		- elmf->icon_arr[FOLDER_BAR_NUM].txtcoord.y;

#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(1);
#endif
}
#endif
//------------------------------------------------------------------------------------------------
void FldrFIInit()
{
//	InitVolumeBuffer();
	CloseOSD();//turn on volume, and clear OSD at the same time

//for fashionstar switching resolution request - bk @ 071114
#ifdef USE_DESC_TV
  #ifdef TV_FI_SWITCH_RESOLUTION

	//current display mode is different from current FI display mode
	if(pgu_get_display_index() != currFIDspMode)
	{
		pgu_set_display_index(currFIDspMode, 1);
		InitDisplayParameter(currFIDspMode);
		//p.s. volumebuffer@˫Oj (]쥻allocswitch᪺jBswitchȨSΨ)
	}

  #endif
#endif
}
//------------------------------------------------------------------------------------------------
void FldrFVInit()
{
	Uint8 displayMode;

///070816
#ifdef USE_DESC_TV
	if(origDisplayMode == DISP_HDTV && GetDisplayIndex() == DISP_HDTV)
	{
#ifdef TV_FI_SWITCH_RESOLUTION_PAL
		displayMode = DISP_PAL;
#else
		displayMode = DISP_NTSC;
#endif
		SetDisplayInterface(displayMode);
		InitDisplayParameter(displayMode);

		///070831 rYp
		g_pFontDB_Default->bScaleDown = true;
		g_pFontDB_Local->bScaleDown = true;
		///
	}
#endif
///

	InitVolumeBuffer();
	CloseOSD();//turn on volume, and clear OSD at the same time
}
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
///080321
void NetDSInit()
{
#ifdef SUPPORT_RSS
    int j;//rywu20080526
    int got_rss_device = 0;//rywu20080516
#endif

	FRAME *elmf;

	DBG_MSG("<skydemo> NetDSInit --> %d\n", num_enabled_dev);

	elmf = &ELMachines[active_index].frame;
	elmf->active_icon_index = 0;
	InitVolumeBuffer();
	InitFrameTextMessage(FrameText[setup->Language][7], &desc->MiscTextCoord[4]);

	///080319 lئITEM_DATA
	int i;
	ITEM_DATA *pItem = &(elmf->item_data);
	memset(pItem, 0, sizeof(ITEM_DATA));
	pItem->item_array = IconTxtArr4DS;
	for (i=0; i<num_enabled_dev; i++)
	{
		//o@ݭnܪضbo
		if (  strcmp(pItem->item_array[i], DEVICE_RSS_NAME) == 0
			||
			  strcmp(pItem->item_array[i], DEVICE_NAS_NAME) == 0
//#ifdef IP_CAM_MOD
//			||
//			  strcmp(pItem->item_array[i], DEVICE_IPCAM_NAME) == 0
//#endif
		   )
		{
		    DBG_MSG("<skydemo> total icon num = %d, %s\n", i, pItem->item_array[i]);
			pItem->index[pItem->total_item++] = i;
		}
	}

#ifdef IP_CAM_MOD
	strcpy(desc->ICONFilename4DS[0][i], desc->IPCAM[0]);
	strcpy(desc->ICONFilename4DS[1][i], desc->IPCAM[1]);
	IconTxtArr4DS[i] = DEVICE_IPCAM_NAME;
	pItem->index[pItem->total_item++] = i++;
#endif

///080429
#ifdef WEB_APP_MOD
	#ifdef WEB_APP_WEATHER
		strcpy(desc->ICONFilename4DS[0][i], desc->WEBAPP_WEATHER[0]);
		strcpy(desc->ICONFilename4DS[1][i], desc->WEBAPP_WEATHER[1]);
		IconTxtArr4DS[i] = WEBAPP_WEATHER_NAME;
		pItem->index[pItem->total_item++] = i++;
	#endif
	#ifdef WEB_APP_NEWS
		strcpy(desc->ICONFilename4DS[0][i], desc->WEBAPP_NEWS[0]);
		strcpy(desc->ICONFilename4DS[1][i], desc->WEBAPP_NEWS[1]);
		IconTxtArr4DS[i] = WEBAPP_NEWS_NAME;
		pItem->index[pItem->total_item++] = i++;
	#endif
	#ifdef WEB_APP_EZPEER
		strcpy(desc->ICONFilename4DS[0][i], desc->WEBAPP_EZPEER[0]);
		strcpy(desc->ICONFilename4DS[1][i], desc->WEBAPP_EZPEER[1]);
		IconTxtArr4DS[i] = WEBAPP_EZPEER_NAME;
		pItem->index[pItem->total_item++] = i++;
	#endif
#endif
///

//rywu20080516++
#ifdef SUPPORT_RSS
    //force to show Flickr icon in Network Device Select state
    for (j=0; j<num_enabled_dev; j++) //rywu20080526 change i to j
    {
        if (!strcmp(pItem->item_array[j], DEVICE_RSS_NAME))
        {
            got_rss_device = 1;

            strcpy(desc->ICONFilename4DS[0][j], desc->RSS[0]);//rywu20080620
            strcpy(desc->ICONFilename4DS[1][j], desc->RSS[1]);//rywu20080620
        }
    }
    if (!got_rss_device)
    {
        strcpy(desc->ICONFilename4DS[0][i], desc->RSS[0]);
        strcpy(desc->ICONFilename4DS[1][i], desc->RSS[1]);
        IconTxtArr4DS[i] = DEVICE_RSS_NAME;
        DBG_MSG("<skydemo> %d, %s\n", i, pItem->item_array[i]);
        pItem->index[pItem->total_item++] = i++;
    }

    //force to show FrameChannel icon in Network Device Select state
    strcpy(desc->ICONFilename4DS[0][i], desc->rss_frame_channel[0]);
    strcpy(desc->ICONFilename4DS[1][i], desc->rss_frame_channel[1]);
    IconTxtArr4DS[i] = DEVICE_RSS_FRAME_CHANNEL_NAME;
    pItem->index[pItem->total_item++] = i++;

    //force to show Picasa icon in Network Device Select state
    strcpy(desc->ICONFilename4DS[0][i], desc->rss_picasa[0]);
    strcpy(desc->ICONFilename4DS[1][i], desc->rss_picasa[1]);
    IconTxtArr4DS[i] = DEVICE_RSS_PICASA_NAME;
    pItem->index[pItem->total_item++] = i++;
#endif
//rywu20080516--

	///080530 SiconNX
	if (pItem->total_item == 0)
	{
		CloseSystem();
		InitSystem(INITSYS_CALL_BY_NORMAL);
	}

	///080320
	InitFrameICON(pItem->total_item);
	//InitFrameICON(num_enabled_dev);

	DBG_MSG("<skydemo> NetDSInit <--\n");
}

//rywu20080516 added
#ifdef SUPPORT_RSS
void RSSInit()
{
    FRAME *elmf;
    RSS_IMAGE_INFO_ID rss_file_info;
    int i;
    struct sockaddr_in addr;
    char str[80];//rywu20080715

    DBG_MSG("<skydemo> RSSInit -->\n");

    //
    //allocate memory for RSS structure
    //
    //rywu20080616 rss_session = (RSS_SESSION_INFO_ID)malloc(RSS_SESSION_INFO_SIZE);
    memset((char *)rss_session, 0x00, RSS_SESSION_INFO_SIZE);
    rss_session->is_draw_outline = 0;
    rss_session->inform_rss_link_status = 0;
    rss_session->is_sky_rss_running     = 0;//rywu20080616
    rss_session->is_run_slide_show      = 0;//rywu20080616
    rss_session->is_rss_struct_ready    = 1;//rywu20080709
    rss_session->slideshow_time_tag     = 0;//rywu20080709
    rss_session->message_time_tag       = 0;//rywu20080709

    /*rywu20080616
    rss_session->skip_draw_message = 0;
    if (extra_control->from_rss_recover == 1)
    {
        rss_session->skip_draw_message = 1;
    }
    */

    //
    //allocate memory for list structure
    //
    ListInitList(&rss_session->image_free_list);
	ListInitList(&rss_session->image_on_use_list);
	rss_file_info = (RSS_IMAGE_INFO_ID)malloc(RSS_IMAGE_INFO_SIZE * MAX_RSS_FILE_QTY);
	if (rss_file_info == NULL)
	{
		DBG_MSG("<skydemo> allocating list memory failed\n");
		return;
	}
    rss_session->file_list_addr = (unsigned char *)rss_file_info;
	for (i=0; i<MAX_RSS_FILE_QTY; i++)
	{
	    //printf("   0x%x\n", *((unsigned char *)rss_file_info));
		ListPushTail(&rss_session->image_free_list, &rss_file_info->link);
		rss_file_info++;
	}

    elmf = &ELMachines[active_index].frame;
    InitVolumeBuffer();
    InitFrameTextMessage(FrameText[setup->Language][0], &desc->MiscTextCoord[0]);
    InitFrameThumbNail(ICON_NUM_PER_FRAME);

    //rywu20080616++
    rss_session->rx_msg_id = msgget((key_t)3012, 0660|IPC_CREAT);
    if(rss_session->rx_msg_id == -1)
	{
        DBG_MSG("<skydemo> RSSInit <-- msgget (rx_msg_id) failed.\n");
		return;
	}

    //rywu20080707 rss_session->act_lock = 0;

    pthread_create(&(rss_session->rss_signal_thread), NULL, (void *)(&rss_signal_thread), rss_session);

    DBG_MSG("<skydemo> device name = %s\n", SelectedDev);
    rss_session->web_provider = WEB_UNKNOWN;
    if(!strcmp(SelectedDev, DEVICE_RSS_NAME))
    {
        rss_session->web_provider = WEB_FLICKR;
    }
    else if (!strcmp(SelectedDev, DEVICE_RSS_FRAME_CHANNEL_NAME))
    {
        rss_session->web_provider = WEB_FRAMECHANNEL;
        
        //rywu20080715++
        //1. when entering RSS mode from main page, it means system is fine, 
        //   then it is not necessary to remove cache files of FrameChannel.
        //2. when entering RSS mode from rss_recover, it means system is just reboot, 
        //   then displaying cache files of FrameChannel to let user know system is alive.
        if (extra_control->from_rss_recover == 0)
        {
            //erase cache directory
            sprintf(str, "rm -rf %s%s", MAIN_DOWNLOAD_PATH, FRAME_CHANNEL_SUB_DOWNLOAD_PATH);
            system(str);
                
            //create folder to download files
            sprintf(str, "mkdir %s%s", MAIN_DOWNLOAD_PATH, FRAME_CHANNEL_SUB_DOWNLOAD_PATH);
            system(str);
            sync();
        }
        //rywu20080715--
    }
    else if(!strcmp(SelectedDev, DEVICE_RSS_PICASA_NAME))
    {
        rss_session->web_provider = WEB_PICASA;
    }

    //keep last display mode
    rss_session->last_display_mode = extra_control->last_rss_display_mode;

    //set flag to skip showing downloading/frame image
    rss_session->skip_draw_message = 0;//set not skipping draw message image
    if (extra_control->from_rss_recover == 1)
    {
        if (rss_session->web_provider == WEB_FRAMECHANNEL ||
            rss_session->last_display_mode == SLIDE_SHOW_MODE)
        {
            rss_session->skip_draw_message = 1;
        }
    }

    rss_session->display_mode = THUMBNAIL_MODE;//set default display mode
    if (rss_session->web_provider == WEB_FRAMECHANNEL ||
        rss_session->last_display_mode == SLIDE_SHOW_MODE)
    {
        rss_session->display_mode = SLIDE_SHOW_MODE;
        pthread_create(&(rss_session->framechannel_thread), NULL, (void *)(&framechannel_thread), rss_session);
    }
    /*rywu20080709
    while(1)
	{
        rss_session->tx_msg_id = msgget((key_t)3014, 0660|IPC_CREAT);
        if(rss_session->tx_msg_id == -1)
    	{
            DBG_MSG("<sky_rss> RSSInit <-- tx_msg_id msgget failed.\n");
    		sleep(1);
    		continue;
    	}
    	else
    	{
    		DBG_MSG("<sky_rss> RSSInit <-- tx_msg_id ok.\n");
    		break;
		}
    }*/
    //rywu20080616--
    
    //rywi20080709a++
    rss_session->tx_msg_id = msgget((key_t)3014, 0660|IPC_CREAT);
    if(rss_session->tx_msg_id == -1)
	{
        DBG_MSG("<skydemo> RSSInit <-- msgget(tx_msg_id) failed.\n");
		return;
	}
	//rywu20080709--
	
    DBG_MSG("<skydemo> RSSInit <--\n");
}
#endif //#ifdef SUPPORT_RSS
#endif
//------------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
void HDAutoCPInit()
{
	FRAME *elmf;
	char DestDirRoot[LEN_XL] = {0}, strCmd[LEN_XL] = {0};

	elmf = &ELMachines[active_index].frame;
	elmf->rgbtemplate = InitFrameBackground(bkg_hdautocp);

	StsOfCpData2HD = 0;
	userSelection = 0;
	pid_hd_cp = 0;
	sizeOfCard = 0L;
	freeSizeOfHD = 0L;
	//updateRegion.x = 0;
	//updateRegion.y = 0;
	//updateRegion.width = 0;
	//updateRegion.height = 0;

	//check root dir
	sprintf(DestDirRoot, "%s%s/", HD_PATH, HD_AUTOCP_ROOT_NAME);
	sprintf(strCmd, "mkdir -p \'%s\' ", DestDirRoot);
	system(strCmd);

	//ˬdϺЪŶ
	freeSizeOfHD = GetPathFreeSize(HD_PATH);
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef IP_CAM_MOD
void IPCamInit()
{
	FRAME *elmf;
	int i, n, ipnum[4];
	COORD* pcoIcon;
	FILE* fid;
	char buf[LEN_XL];

	elmf = &ELMachines[active_index].frame;
	FOLDER_BAR_NUM = desc->FolderBarNum;

	//InitFrameTextMessage(FrameText[setup->Language][4], &desc->MiscTextCoord[24]);

	InitFrameThumbNail(FOLDER_BAR_NUM);
	/*
	GetPath(RootPath);
	chdir(RootPath);
	FolderList = FolderList_Build(".");
	*/

	FolderList_Free(&FolderList);
	FolderList = Build_IP_Cam_List();

	nIPCamSelected = 0;
	elmf->active_icon_index = 0;
	CurrFldrListPos = FolderList;

	///pFolder Vieweϰ쪺d
	FldrRegion.x = elmf->icon_arr[0].icoord.x;
	FldrRegion.y = elmf->icon_arr[0].icoord.y;
	FldrRegion.width = elmf->icon_arr[0].txtcoord.x + elmf->icon_arr[0].txtcoord.width - elmf->icon_arr[0].icoord.x;
	FldrRegion.height = elmf->icon_arr[FOLDER_BAR_NUM-1].icoord.y + elmf->icon_arr[FOLDER_BAR_NUM-1].icoord.height -elmf->icon_arr[0].icoord.y;
	if((FldrRegion.y + FldrRegion.height) < (desc->MiscTextCoord[6].y + g_pFontDB_Local->FontSize))
		FldrRegion.height = (desc->MiscTextCoord[6].y + g_pFontDB_Local->FontSize) - FldrRegion.y;
}
#endif
//------------------------------------------------------------------------------------------------
#if defined(GUI_STYLE_COMTEK)
void ProgDownloadInit()
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	elmf->rgbtemplate = InitFrameBackground(bkg_fwupgrade);
}
#endif
//------------------------------------------------------------------------------------------------
void MachineInit()
{
	Uint8 i, numirevt;

	numirevt = ELMachines[active_index].num_ir_evt;
	// Register a hash table
	for(i = 0; i < numirevt; i++)
		RegisterhTable(Keys[active_index][i], Values[active_index][i]);
	switch(active_index)
	{
		case DS_ACTIVE:
			DSInit();
			break;
		case MT_ACTIVE:
			MTInit();
			break;
		case SETUP_L1_ACTIVE:
			SetupL1Init();
			break;
		case SETUP_L2_ACTIVE:
			SetupL2Init();
			break;
		case SETUP_L3_ACTIVE:
			SetupL3Init();
			break;
		case I_ACTIVE:
			ImgInit();
			break;
		case FI_ACTIVE:
			FImgInit();
			break;
		case A_ACTIVE:
			AudInit();
			break;
		case V_ACTIVE:
			VidInit();
			break;
		case FV_ACTIVE:
			FVidInit();
			break;
		case SS_ACTIVE:
			SSInit();
			break;
		case USB2PC_CONN_ACTIVE:
			USB2PConnIinit();
			break;
		case NO_STORAGE_ACTIVE:
			NoStorageInit();
			break;
		case CONFIRM_ACTIVE:
			ConfirmInit();
			break;
		case CAL_ACTIVE:
			CalInit();
			break;
		///070606 Folder View
		case FLDR_ACTIVE:
			FldrInit();
			break;
		///
		case FW_UPGRADE_ACTIVE:
			FWUpgradeInit();
			break;
#ifdef BLUETOOTH_MOD
		case BT_ACTIVE:
			BTInit();
			break;
#endif
		case FLDR_FI_ACTIVE:
			FldrFIInit();
			break;
		case FLDR_FV_ACTIVE:
			FldrFVInit();
			break;
#ifdef NET_MOD
		///080321
		case NET_DS_ACTIVE:
			NetDSInit();
			break;
#endif
#ifdef SUPPORT_RSS//rywu20080516
		case RSS_ACTIVE:
			RSSInit();
			break;
#endif
#ifdef HD_AUTOCP_MOD
		case HD_AUTOCP_ACTIVE:
			HDAutoCPInit();
			break;
#endif
#ifdef IP_CAM_MOD
		case IP_CAM_ACTIVE:
			IPCamInit();
			break;
#endif
///080430
#ifdef WEB_APP_MOD
	case WEB_APP_ACTIVE:
			WebAppInit();
			break;
#endif
///
#if defined(GUI_STYLE_COMTEK)
		case PROG_DOWNLOAD_ACTIVE:
			ProgDownloadInit();
			break;
#endif
	}
	//MSG("Active Machine = ");MACHINE_NAME(active_index);	PRINTF(" with %d IR Events.\n", numirevt);
}
