#include "machineshutdown.h"
#include "FList.h"
Uint32 isSSPrcsStoppedwSIGSTOP = 0;//is a flag used for stopped processes(pid_img/pid_aud/pid_tr with SIGSTOP),
								   //when it is set and AP wants to kill any of them, then we must use system
								   //call, kill(pid, SIGKILL) instead of KILL(); because KILL() only send SIGQUIT and
								   //SIGTERM to those stopped processes, which only receive SIGKILL and SIGCONT.
char InAudioChannelsProcess = 0;
//------------------------------------------------------------------------------------------------
void KillImageProcess()
{
	if(ImgCount != 0)
	{
		if(isSSImgPrcsForked && !waitpid(pid_img, &sts_img, WNOHANG))
		{
			if(isSSPrcsStoppedwSIGSTOP)
			{
				while(kill(pid_img, SIGCONT) == -1);
			}
			//KILL("skyview");
			//KILL("djpeg");
			KILL(pid_img);
			//DMSG("KILL returned!\n");
/*
			for(;;)
			{
				if(waitpid(pid_img, &sts_img, 0) <= 0)
				{
					DMSG("img has not been reaped!\n");	
				}
				else
				{
					DMSG("img has been reaped!\n");
					break;
				}
			}
*/
#ifdef NET_MOD
			while(waitpid(pid_img, &sts_img, 0) == 0);
#else		
			while(waitpid(pid_img, &sts_img, 0) <= 0);
#endif
		}
	}
}
//------------------------------------------------------------------------------------------------
void KillAudioProcess()
{
	if(AudCount != 0)
	{
		if(isSSAudPrcsForked && !waitpid(pid_aud, &sts_aud, WNOHANG))
		{
			if(isSSPrcsStoppedwSIGSTOP)
			{
				while(kill(pid_aud, SIGKILL) == -1);
			}
			else
			{
				//KILL("mplayer");
				KILL(pid_aud);
				//DMSG("KILL returned!\n");
			}
/*
			for(;;)
			{
				if(waitpid(pid_aud, &sts_aud, 0) <= 0)
				{
					DMSG("aud has not been reaped!\n");	
				}
				else
				{
					DMSG("aud has been reaped!\n");
					break;
				}
			}
*/
#ifdef NET_MOD
			while(waitpid(pid_aud, &sts_aud, 0) == 0);
#else
			while(waitpid(pid_aud, &sts_aud, 0) <= 0);
#endif
		}

		if(isOnlyAudPrcsForked && !waitpid(pid_aud, &sts_aud, WNOHANG))
		{
			if(isSSPrcsStoppedwSIGSTOP)
			{
				while(kill(pid_aud, SIGKILL) == -1);
			}
			else
			{
				//KILL("mplayer");
				KILL(pid_aud);
				//DMSG("KILL returned!\n");
			}
#ifdef NET_MOD
			while(waitpid(pid_aud, &sts_aud, 0) == 0);
#else
			while(waitpid(pid_aud, &sts_aud, 0) <= 0);
#endif
		}
	}
}
//------------------------------------------------------------------------------------------------
void KillTrProcess()
{
	if(isSSTrPrcsForked && !waitpid(pid_tr, &sts_tr, WNOHANG))
	{
		if(isSSPrcsStoppedwSIGSTOP)
		{
			while(kill(pid_tr, SIGKILL) == -1);
		}
		else
		{
			//KILL("tr");
			KILL(pid_tr);
			//DMSG("KILL returned!\n");
		}
/*
		for(;;)
		{
			if(waitpid(pid_tr, &sts_tr, 0) <= 0)
			{
				DMSG("tr has not been reaped!\n");	
			}
			else
			{
				DMSG("tr has been reaped!\n");
				break;
			}
		}
*/
#ifdef NET_MOD
			while(waitpid(pid_tr, &sts_tr, 0) == 0);
#else	
		while(waitpid(pid_tr, &sts_tr, 0) <= 0);
#endif
	}
}
//------------------------------------------------------------------------------------------------
void KillVideoProcess()
{
	if(VidCount != 0)
	{
		if(isVidPrcsForked && !waitpid(pid_vid, &sts_vid, WNOHANG))
		{
		#if 0
			while(kill(pid_vid, SIGKILL) == -1);
		#else
			//KILL("mplayer");
			KILL(pid_vid);
			tcon_clear_subtitle();//barry
		#endif
#ifdef NET_MOD
			while(waitpid(pid_vid, &sts_vid, 0) == 0);
#else
			while(waitpid(pid_vid, &sts_vid, 0) <= 0);
#endif
		}
	}
}
//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void KillBTProcesses()
{
	pid_t pid;
	int status;

	pid = fork();
	switch(pid)
	{
		case -1:
			perror("KillBTProcesses failed!");
			DMSG("KillBTProcesses failed!");
			break;
		case 0:
			//child process
			system("killall sdpd hcid sobexsrv orz");
			_EXIT;
		default:
			//parent process
			if(pid_bt_orz != 0)
				waitpid(pid_bt_orz, &sts_orz, 0);//the orz may be zombie (terminated by skydemo, not by itself)
#ifdef NET_MOD
			while(waitpid(pid, &status, 0) == 0);
#else
			while(waitpid(pid, &status, 0) <= 0);
#endif
//			if(WIFEXITED(status))
//				DMSG("KillBTProcesses success!!!");
			break;
	}

	if(isBTPrcsForked)
		smbtop->complete = FALSE;
	isBTScanningOPush = FALSE;
	isBTPrcsForked = FALSE;
	isBTPrcssBusy  = FALSE;
	shmdt(smbt);
	shmdt(smbtop);
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD

//rywu20080516
#ifdef SUPPORT_RSS
void KillRSSProcess()
{
    int status;
    // shutdown rss network module
    DBG_MSG("<skydemo> KillRSSProcess -->\n");
    tx_msg_to_rss_client(rss_session, IPC_SHUTDOWN);
    //waitpid(pid_rss, &status, 0);
    //rywu20080623 sleep(1);
    
    system("killall curl");//rywu20080616
    sync();//rywu20080806 system("sync;sync");//rywu20080624
    
    //rywu20080623 system("killall sky_rss");
    waitpid(pid_rss, &status, 0);//rywu20080623
    
    
    //remove recovery file
    unlink("/tmp/conf/rss_recover");
    sync();//rywu20080806 system("sync;sync");
    
    extra_control->from_rss_recover = 0;//rywu20080616
    extra_control->last_rss_display_mode = THUMBNAIL_MODE;//rywu20080616

    DBG_MSG("<skydemo> KillRSSProcess <--\n");

    return;
}
#endif //#ifdef SUPPORT_RSS

#endif
//------------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
void KillHDCopyProcesses()
{
	pid_t pid;
	int status;
	
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("Kill hd_cp failed!");
			DMSG("Kill hd_cp failed!");
			break;
		case 0:
			//child process
			system("killall -9 cp");
			_EXIT;
		default:
			//parent process
			if(pid_hd_cp != 0)
				waitpid(pid_hd_cp, &sts_hd_cp, 0);//may be zombie (terminated by skydemo, not by itself)
#ifdef NET_MOD
			while(waitpid(pid, &status, 0) == 0);
#else
			while(waitpid(pid, &status, 0) <= 0);
#endif
			break;
	}
}
#endif
//------------------------------------------------------------------------------------------------
void KillFldrAudioProcess()
{
	if(isFldrAudPrcsForked && !waitpid(pid_fldr_aud, &sts_fldr_aud, WNOHANG))
	{
		//KILL("mplayer");
		KILL(pid_fldr_aud);
#ifdef NET_MOD
		while(waitpid(pid_fldr_aud, &sts_fldr_aud, 0) == 0);
#else
		while(waitpid(pid_fldr_aud, &sts_fldr_aud, 0) <= 0);
#endif
	}
}
//------------------------------------------------------------------------------------------------
void KillFldrVideoProcess()
{
	if(isFldrVidPrcsForked && !waitpid(pid_fldr_vid, &sts_fldr_vid, WNOHANG))
	{
	#if 0
		while(kill(pid_fldr_vid, SIGKILL) == -1);
	#else
		//KILL("mplayer");
		KILL(pid_fldr_vid);
		tcon_clear_subtitle();//barry
	#endif
#ifdef NET_MOD
		while(waitpid(pid_fldr_vid, &sts_fldr_vid, 0) == 0);
#else
		while(waitpid(pid_fldr_vid, &sts_fldr_vid, 0) <= 0);
#endif
	}
}
//------------------------------------------------------------------------------------------------
void FreeBackgroundBuff()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;
	FREEMEMORY(elmf->bkgrdbuff);
}
//------------------------------------------------------------------------------------------------
void ResetBackgroundInfo()
{
	FRAME *elmf;
	COORD init_coord = {0, 0, 0, 0};
	
	elmf = &ELMachines[active_index].frame;
	if(elmf->bkgrdbuff != NULL)
	{
		elmf->fname = NULL;
		elmf->framecoord = init_coord;
		FreeBackgroundBuff();
		elmf->frametextmsg = NULL;
		elmf->frametextmsgcoord = init_coord;
	}
}
//------------------------------------------------------------------------------------------------
void FreeICONBuffer()
{
	FRAME *elmf;
	Uint8 i;
	
	elmf = &ELMachines[active_index].frame;
	//DBG_MSG("num_icon = %d\n", elmf->num_icon);
	for(i = 0; i < elmf->num_icon; i++)
		FREEMEMORY(elmf->icon_arr[i].iconbuff);
}
//------------------------------------------------------------------------------------------------
void FreeICONS()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;
	FREEMEMORY(elmf->icon_arr);
	if(elmf->icon_arr != NULL)
	{
		elmf->num_icon = 0;
		elmf->active_icon_index = 0;
		elmf->active_frame_index = 0;
	}
}
//------------------------------------------------------------------------------------------------
void FreeOSDBuffer()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;
	FREEMEMORY(elmf->osdbuff);
}
//------------------------------------------------------------------------------------------------
void FreeRGBTemplateBuffer()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;
	FREEMEMORY(elmf->rgbtemplate);
}
//------------------------------------------------------------------------------------------------
void FreeVolumeBuffer()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;
	FREEMEMORY(elmf->volumebuff);
}
//------------------------------------------------------------------------------------------------
void CloseOSD()
{
	if(isMutePressed || isInfoPressed || isVolumePressed)
	{
		if(isMutePressed)
		{
			SetSoundDeviceVolume(volume);
			isMutePressed = FALSE;
		}
		if(isInfoPressed)
			isInfoPressed = FALSE;
		if(isVolumePressed)
			isVolumePressed = FALSE;

		#if USE_TERAWINS_TCON
		tcon_clear_mute_vol();
		#endif
		pgu_enable_overlay(0);
		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
	}
}
//------------------------------------------------------------------------------------------------
void DSShutDown()
{
	FreeVolumeBuffer();
	ResetBackgroundInfo();

	///070813
	//FreeRGBTemplateBuffer();
	///
	
	FreeICONBuffer();
	FreeICONS();
	if(strcmp(SelectedDev, DEVICE_AUTOSS_NAME))
		FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
	CloseOSD();
}
//------------------------------------------------------------------------------------------------
void MTShutDown()
{
	FreeVolumeBuffer();
	ResetBackgroundInfo();

	///070813
	//FreeRGBTemplateBuffer();
	///
	
	FreeICONBuffer();
	FreeICONS();
	CloseOSD();
}
//------------------------------------------------------------------------------------------------
void SetupL1ShutDown()
{
	ResetBackgroundInfo();
	///070815
	//FreeRGBTemplateBuffer();
	///
}
//------------------------------------------------------------------------------------------------
void SetupL2ShutDown()
{
	ResetBackgroundInfo();
	///070815
	//FreeRGBTemplateBuffer();
	///
}
//------------------------------------------------------------------------------------------------
void SetupL3ShutDown()
{
	ResetBackgroundInfo();
	///070815
	//FreeRGBTemplateBuffer();
	///
}
//------------------------------------------------------------------------------------------------
void ImgShutDown()
{
	FreeVolumeBuffer();
	ResetBackgroundInfo();
	
	///070814
	//FreeRGBTemplateBuffer();
	///
	FreeICONBuffer();
	
	FreeICONS();
	///070814
	//FreeOSDBuffer();
	///
	CloseOSD();
}
//------------------------------------------------------------------------------------------------
void FImgShutDown()
{
	FreeVolumeBuffer();
	///070814
	//FreeOSDBuffer();
	///
	CloseOSD();
//	isPreKeyRotate = 0;

#ifdef USE_DESC_TV
	
  //for fashionstar switching resolution request - bk @ 071114
  #ifdef TV_FI_SWITCH_RESOLUTION
	if(currFIDspMode != origDisplayMode)
	{
		pgu_set_display_index(origDisplayMode, 1);
		InitDisplayParameter(currFIDspMode);
	}
  #endif
	
	//it should be departed - bk @ 071114
	//check if switch back to TV by bk @ 070707
	if(origDisplayMode == DISP_NTSC && GetDisplayIndex() == DISP_HDTV)//switch back to TV
	{
		SetDisplayInterface(DISP_NTSC);
		InitDisplayParameter(DISP_NTSC);
	}
#endif
}
//------------------------------------------------------------------------------------------------
void AudShutDown()
{
	KillAudioProcess();
	isOnlyAudPrcsForked = FALSE;
	FreeVolumeBuffer();
	ResetBackgroundInfo();
	
	///070814
	//FreeRGBTemplateBuffer();
	///
	
	FreeICONBuffer();
	FreeICONS();

	///070814
	//FreeOSDBuffer();
	///
	CloseOSD();
	
#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(0);
#endif
}
//------------------------------------------------------------------------------------------------
void VidShutDown()
{
	FreeVolumeBuffer();
	ResetBackgroundInfo();

	///070814
	//FreeRGBTemplateBuffer();
	///
	
	FreeICONBuffer();
	FreeICONS();
	CloseOSD();
}
//------------------------------------------------------------------------------------------------
void FVidShutDown()
{
	Uint8 displayMode;
	//bk@070609 - must before the following line - KillVideoProcess();
	if(isVideoPaused)
	{
		FV_PlayPauseEvent();
		//set_ir_value((unsigned long)0x0);//reset ir_value
		isVideoPausedBySetup = FALSE;
	}
	set_ir_value((unsigned long)0x0);//reset ir_value
	KillVideoProcess();
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);
	isVidPrcsForked = FALSE;
	FreeVolumeBuffer();
	
	//PRINTF("isVideoPaused: %d\n", isVideoPaused);
	CloseOSD();
	/* Flowbee reset the pixel clock of LCD panel. */
	//pgu_set_clkcfg(4);

	displayMode = GetDisplayIndex();

#ifdef USE_DESC_LCD
	if(
			displayMode == DISP_800x600_LCD
		|| 	displayMode == DISP_800x480_LCD
		|| 	displayMode == DISP_1024x600_LCD
		|| 	displayMode == DISP_800x480_LCD_25MHZ
	)
	{
		//pgu_clear_mplayer_time();
		tcon_clear_all_osd_item();
	}
#ifdef USE_DESC_TV
	else
#endif
#endif
///070816
#ifdef USE_DESC_TV
	{
		if(origDisplayMode == DISP_HDTV && (displayMode == DISP_NTSC || displayMode == DISP_PAL))
		{
			displayMode = DISP_HDTV;
			SetDisplayInterface(displayMode);
			InitDisplayParameter(displayMode);

			///070831 ٭rYp
			g_pFontDB_Default->bScaleDown = false;
			g_pFontDB_Local->bScaleDown = false;
			///
		}
		pgu_enable_tv_osd(0);
		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);		
	}
#endif
///
#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(0);
#endif
	
	if (InAudioChannelsProcess)
	{
		InAudioChannelsProcess = 0;
		SaveUserSetupToMem();
	}
	
	/*
	if(
			displayType == DISP_800x600_LCD
		|| 	displayType == DISP_800x480_LCD
		|| 	displayType == DISP_1024x600_LCD
		|| 	displayType == DISP_800x480_LCD_25MHZ
	)
	{
		//pgu_clear_mplayer_time();
		tcon_clear_all_osd_item();
	}else
	{
		pgu_enable_tv_osd(0);
		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
	}
	*/
}
//------------------------------------------------------------------------------------------------
void SSShutDown()
{
	KillImageProcess();
	isSSImgPrcsForked = FALSE;
	KillAudioProcess();
	isSSAudPrcsForked = FALSE;
	KillTrProcess();
	isSSTrPrcsForked = FALSE;
	isSSPrcsStoppedwSIGSTOP = 0;
	FreeVolumeBuffer();
	
	///070816
	//ResetBackgroundInfo();
	//FreeRGBTemplateBuffer();
	///
	
	CloseOSD();
	/* Flowbee reset the pixel clock of LCD panel. */
	//pgu_set_clkcfg(4);

#ifdef USE_DESC_TV
	//check if switch back to TV by bk @ 070707
	if(origDisplayMode == DISP_NTSC && GetDisplayIndex() == DISP_HDTV)//switch back to TV
	{
		SetDisplayInterface(DISP_NTSC);
		InitDisplayParameter(DISP_NTSC);
	}
#endif
	
#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(0);
#endif
}
//------------------------------------------------------------------------------------------------
void USB2PConnShutDown()
{
	ResetBackgroundInfo();

	///070814
	//FreeRGBTemplateBuffer();
	///
}
//------------------------------------------------------------------------------------------------
void NoStorageShutDown()
{
	ResetBackgroundInfo();
	
	///070816	
	//FreeRGBTemplateBuffer();
	///
}
//------------------------------------------------------------------------------------------------
void ConfirmShutDown()
{
	FreeRGBTemplateBuffer();
}
//------------------------------------------------------------------------------------------------
void CalShutDown()
{
	KillAudioProcess();
	isSSAudPrcsForked = FALSE;
	isCalAlarmRinging = -1;
	
	///070815
	memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
	///
	ResetBackgroundInfo();
	pgu_enable_overlay(0);
	///070815
	//FreeRGBTemplateBuffer();
	///
	
#ifdef SETTING_GPIO_MUTE
	if(
		prev_active_index != A_ACTIVE
		&& prev_active_index != FLDR_ACTIVE
#ifdef BLUETOOTH_MOD
		&& prev_active_index != BT_ACTIVE
#endif
	  )
		SetGPIOMute(0);
#endif
}
//------------------------------------------------------------------------------------------------

///070606
void FldrShutDown()
{
	pid_t pid;
	int status;

	//bk @ 071015 - it maybe be playing music
	KillFldrAudioProcess();
	isFldrAudPrcsForked = FALSE;
	
	char RootPath[LEN_XL];
	GetPath(RootPath);
	chdir(RootPath);

	FolderList_Free(&FolderList);
	ResetBackgroundInfo();

	///070814
	//FreeRGBTemplateBuffer();
	///

	FreeVolumeBuffer();
	FreeICONBuffer();
	FreeICONS();

	CloseOSD();
	
	///070628
	//sإList
	if (isFolderListUpdate)
	{
		isFolderListUpdate = FALSE;
		
		///071018
		switch (active_index)
		{
		case FLDR_ACTIVE:
			FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
			SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Selected_Device);
			break;
		//case BT_ACTIVE:
		//	SearchFileByDevice(MT_PHOTO | MT_MUSIC, Mounted_Device);
		//	break;
		default:
			break;
		}
/*
		pid = vfork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to Re-Search Files when Folderview Shutdowns!");
				break;
				//exit(1);
			case 0:
				SearchFileAllTypes(RootPath);
				_EXIT;
			default:
				waitpid(pid, &status, 0);
				break;
		}		
*/
		///
	}
	///
	
#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(0);
#endif
}
///

//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void BTShutDown()
{
	int isBTReceiving = FALSE, stat;
	char s[LEN_XL];
	pid_t pid;
	
	//remove the recieving file 
	if(smbt->dir == BT_DIR_RECV)//recieving
	{
		if(0 <= smbt->status && smbt->status < 100)//unfinished
		{
			isBTReceiving = TRUE;
			strcpy(s, smbt->name);
		}
	}
	
	KillBTProcesses();
	
	//delete the recieving file
	if(isBTReceiving)
	{
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("fork failure!");
				DMSG("Fork to Delete File Fail!");
				return;
			case 0:
				//child process
				execl("/bin/rm", "rm", "-rf", s, NULL);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &stat, 0);
				break;
		}
	}
	
	//release the part resources of folder
	FldrShutDown();
}
#endif
//------------------------------------------------------------------------------------------------
void FldrFIShutDown()
{
//	FreeVolumeBuffer();
//	CloseOSD();
//	isPreKeyRotate = 0;
	pgu_switch_to_buffer(1);
	
#ifdef USE_DESC_TV
	
  //for fashionstar switching resolution request - bk @ 071114
  #ifdef TV_FI_SWITCH_RESOLUTION
	if(currFIDspMode != origDisplayMode)
	{
		pgu_set_display_index(origDisplayMode, 1);
		InitDisplayParameter(currFIDspMode);
	}
  #endif
	
	//it should be departed - bk @ 071114
	//check if switch back to TV by bk @ 070707
	if(origDisplayMode == DISP_NTSC && GetDisplayIndex() == DISP_HDTV)//switch back to TV
	{
		SetDisplayInterface(DISP_NTSC);
		InitDisplayParameter(DISP_NTSC);
	}
#endif
}
//------------------------------------------------------------------------------------------------
void FldrFVShutDown()
{
	Uint8 displayMode;
	
//	//bk@070609 - must before the following line - KillVideoProcess();
//	if(isVideoPaused)
//	{
//		FV_PlayPauseEvent();
//		set_ir_value((unsigned long)0x0);//reset ir_value
//		isVideoPausedBySetup = FALSE;
//	}
	FreeVolumeBuffer();
	KillFldrVideoProcess();
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);
	isFldrVidPrcsForked = FALSE;
	set_ir_value((unsigned long)0x0);//reset ir_value
	
	//PRINTF("isVideoPaused: %d\n", isVideoPaused);
	CloseOSD();
	/* Flowbee reset the pixel clock of LCD panel. */
	//pgu_set_clkcfg(4);
	
	displayMode = GetDisplayIndex();
#ifdef USE_DESC_LCD
	if(
			displayMode == DISP_800x600_LCD
		|| 	displayMode == DISP_800x480_LCD
		|| 	displayMode == DISP_1024x600_LCD
		|| 	displayMode == DISP_800x480_LCD_25MHZ
	)
	{
		//pgu_clear_mplayer_time();
		tcon_clear_all_osd_item();
	}
#ifdef USE_DESC_TV
	else
#endif
#endif
///070816
#ifdef USE_DESC_TV
	{
		if(origDisplayMode == DISP_HDTV && (displayMode == DISP_NTSC || displayMode == DISP_PAL))
		{
			displayMode = DISP_HDTV;
			SetDisplayInterface(displayMode);
			InitDisplayParameter(displayMode);
			
			///070831 ٭rYp
			g_pFontDB_Default->bScaleDown = false;
			g_pFontDB_Local->bScaleDown = false;
			///
		}
		pgu_enable_tv_osd(0);
		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);		
	}
#endif
///
	
	if (InAudioChannelsProcess)
	{
		InAudioChannelsProcess = 0;
		SaveUserSetupToMem();
	}
}
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
///080321
void NetDSShutDown()
{
    DBG_MSG("<skydemo> NetDSShutDown(%d) -->\n", active_index);
	FreeVolumeBuffer();
	ResetBackgroundInfo();
	FreeICONBuffer();
	FreeICONS();
	CloseOSD();
	DBG_MSG("<skydemo> NetDSShutDown <--\n");
}
//rywu20080516
#ifdef SUPPORT_RSS
void RSSShutDown()
{
    DBG_MSG("<skydemo> RSSShutDown -->\n");

    if (rss_session->web_provider == WEB_FRAMECHANNEL)
    {
        DBG_MSG("<skydemo> start to terminate thread\n");
        rss_session->framechannel_thread_state = 0;
        pthread_join(rss_session->framechannel_thread, &(rss_session->framechannel_thread_result));
        DBG_MSG("<skydemo> terminating thread done\n");
    }
    
    KillRSSProcess();
    
    //rywu20080616++
    DBG_MSG("<skydemo>    terminate rss_signal_thread\n");
    rss_session->rss_signal_thread_state = 0;
    pthread_join(rss_session->rss_signal_thread, &(rss_session->rss_signal_thread_result));
    DBG_MSG("<skydemo>    terminating rss_signal_thread done\n");
    //rywu20080616--
    
    FreeBackgroundBuff();
    FreeVolumeBuffer();
	ResetBackgroundInfo();
	FreeICONBuffer();
	FreeICONS();
	CloseOSD();

    //rywu20080616++
    if (msgctl(rss_session->rx_msg_id, IPC_RMID, 0) == -1)
    {
        DBG_MSG("<skydemo> msgctl(IPC_RMID) rx_msg_id failed.\n");
	}
	//rywu20080709++
	if (msgctl(rss_session->tx_msg_id, IPC_RMID, 0) == -1)
    {
        DBG_MSG("<sky_rss> msgctl(IPC_RMID) tx_msg_id failed.\n");
	}
	//rywu20080709--
	
	//rywu20080707 rss_session->act_lock = 0;
    //rywu20080616--

    free(rss_session->file_list_addr);
    //rywu20080616 free(rss_session);
    //rywu20080616 rss_session = 0;
    
    rss_session->is_rss_struct_ready   = 0;//rywu20080709
    
    DBG_MSG("<skydemo> RSSShutDown <--\n");
}
#endif //#ifdef SUPPORT_RSS

#endif
//------------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
void HDAutoCPShutDown()
{
	if(StsOfCpData2HD == 1)
		KillHDCopyProcesses();
	
	StsOfCpData2HD = 0;
	userSelection = 0;
	pid_hd_cp = 0;
	sizeOfCard = 0L;
	freeSizeOfHD = 0L;
	
	ResetBackgroundInfo();
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef IP_CAM_MOD
void IPCamShutDown()
{
	//wҰʪurl_play
	CloseIPCam();
	isIPCamFullView = FALSE;
	FolderList_Free(&FolderList);

	ResetBackgroundInfo();
	FreeICONBuffer();
	FreeICONS();
}
#endif
//------------------------------------------------------------------------------------------------
void ExtraShutdown()
{
	extern Uint8 prev_active_index;

	switch(active_index)
	{
		case FI_ACTIVE:
			active_index = I_ACTIVE;
			ELMachines[active_index].Shutdown(0);
			break;
		case FV_ACTIVE:
			active_index = V_ACTIVE;
			ELMachines[active_index].Shutdown(0);
			break;
		case CAL_ACTIVE:
			active_index = prev_active_index;
			ELMachines[active_index].Shutdown(1);
			isCalPressed = FALSE;
			break;
		case SETUP_L1_ACTIVE:
		case SETUP_L2_ACTIVE:
		case SETUP_L3_ACTIVE:
			active_index = prev_active_index;
			ELMachines[active_index].Shutdown(1);
			isSetupPressed = FALSE;
			break;
		case CONFIRM_ACTIVE:
			//shutdown setup active
			active_index = SETUP_L2_ACTIVE;
			//ELMachines[active_index].Init();
			SetupEvent();
			
			active_index = prev_active_index;
			ELMachines[active_index].Shutdown(1);
			isUserConfirmed = FALSE;
			break;
		case FLDR_FI_ACTIVE:
		case FLDR_FV_ACTIVE:
			active_index = prev_active_index;
			ELMachines[active_index].Shutdown(0);
			break;
	}
}
//------------------------------------------------------------------------------------------------
void MachineShutDown(Uint8 extra)
{
	Uint8 i;
	IR_SCANKEY_EVENTS *irevt_prev, *irevt_next;

#if 0
	PRINTF("pid_img = %d\n", pid_img);
	PRINTF("pid_aud = %d\n", pid_aud);
	PRINTF("pid_vid = %d\n", pid_vid);
#endif
	//-----------------------------
	switch(active_index)
	{
		case DS_ACTIVE:
			DSShutDown();
			break;
		case MT_ACTIVE:
			MTShutDown();
			break;
		case SETUP_L1_ACTIVE:
			SetupL1ShutDown();
			break;
		case SETUP_L2_ACTIVE:
			SetupL2ShutDown();
			break;
		case SETUP_L3_ACTIVE:
			SetupL3ShutDown();
			break;
		case I_ACTIVE:
			ImgShutDown();
			break;
		case FI_ACTIVE:
			FImgShutDown();
			break;
		case A_ACTIVE:
			AudShutDown();
			break;
		case V_ACTIVE:
			VidShutDown();
			break;
		case FV_ACTIVE:
			FVidShutDown();
			break;
		case SS_ACTIVE:
			SSShutDown();
			break;
		case USB2PC_CONN_ACTIVE:
			USB2PConnShutDown();
			break;
		case NO_STORAGE_ACTIVE:
			NoStorageShutDown();
			break;
		case CONFIRM_ACTIVE:
			ConfirmShutDown();
			break;
		case CAL_ACTIVE:
			CalShutDown();
			break;
		case FLDR_ACTIVE:
			FldrShutDown();
			break;
#ifdef BLUETOOTH_MOD
		case BT_ACTIVE:
			BTShutDown();
			break;
#endif
		case FLDR_FI_ACTIVE:
			FldrFIShutDown();
			break;
		case FLDR_FV_ACTIVE:
			FldrFVShutDown();
			break;
#ifdef NET_MOD
		///080321
		case NET_DS_ACTIVE:
			NetDSShutDown();
			break;
#endif
#ifdef SUPPORT_RSS//rywu20080516
		case RSS_ACTIVE:
			RSSShutDown();
			break;
#endif
#ifdef HD_AUTOCP_MOD
		case HD_AUTOCP_ACTIVE:
			HDAutoCPShutDown();
			break;
#endif
#ifdef IP_CAM_MOD
		case IP_CAM_ACTIVE:
			IPCamShutDown();
			break;
#endif
///080430
#ifdef WEB_APP_MOD
		case WEB_APP_ACTIVE:
			WebAppShutDown();
			break;
#endif
///
	}
	// Reset hash table
	for(i = 0; i < MAX_NUM_IR_EVENTS; i++)
	{
		irevt_prev = irevt_next = NULL;
		irevt_prev = ELMachines[active_index].hTable[i];
		while(irevt_prev != NULL)
		{
			irevt_next = irevt_prev->next;
			FREEMEMORY(irevt_prev);
			irevt_prev = irevt_next;
		}
		ELMachines[active_index].hTable[i] = NULL;
	}
	
	//added by bk @ 070705 - check if saving user setup is necessary
	//shutdown will save only when not SETUP L1, L2, L3 active. setup handle save by itself
	if(isUSetupNeededSaving && 
			active_index != SETUP_L1_ACTIVE && active_index != SETUP_L2_ACTIVE && active_index != SETUP_L3_ACTIVE && active_index != CONFIRM_ACTIVE)
		SaveUserSetup();
	
	//MSG("Shutdown Machine = ");MACHINE_NAME(active_index);PRINTF("\n");
	if(extra)
		ExtraShutdown();	
}
