#include "events.h"
//------------------------------------------------------------------------------------------------
// RSS callbacks																					    
//------------------------------------------------------------------------------------------------
#ifdef SUPPORT_RSS
//rywu20080516 added
void RSS_SlideShow()
{
    //rywu20080616++
    FILE *fp;
    int offset;
    char buf[80];
    char *target;
    //rywu20080616--
    
    DBG_MSG("<skydemo> RSS_SlideShow -->\n");
    if (rss_session->web_provider == WEB_FRAMECHANNEL ||
        rss_session->display_mode == SLIDE_SHOW_MODE)
    {
        DBG_MSG("<skydemo> RSS_SlideShow(0) <--\n");
        return;
    }
    rss_session->display_mode = SLIDE_SHOW_MODE;
    pthread_create(&(rss_session->framechannel_thread), NULL, (void *)(&framechannel_thread), rss_session);
    
    //rywu20080616++
    //modify DISPLAY_MODE to slide show
    fp = fopen("/tmp/conf/rss_recover", "r+");
    if(fp == 0) 
    {
        DBG_MSG("<skydemo>    can't open rss_recover\n");
    }
    else
    {
        //search configuration
        while(!feof(fp))
        {
            offset = ftell(fp);
            DBG_MSG("<skydemo>     offset = %d\n", offset);
            if (fgets(buf, 80, fp) == NULL)
            {
                break;
            }
            
            if ((target = strstr(buf, "DISPLAY_MODE=")) != NULL)
            {
                //back to DISPLAY_MODE position
                fseek(fp, offset, SEEK_SET);
                
                //update content
                //NOTE : DISPLAY_MODE is the last item of this file, so we can update it directly.
                sprintf(buf, "DISPLAY_MODE=%d\n", rss_session->display_mode);
                fputs(buf, fp);
            }
        }
        fclose(fp); 
    }
    //rywu20080616--
    
    DBG_MSG("<skydemo> RSS_SlideShow <--\n");
}

//rywu20080516 added
void RSS_EscEvent()
{
    DBG_MSG("<skydemo> RSS_EscEvent -->\n");
	pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));

    //for easy understanding, I left the exit code here.
    if (rss_session->web_provider == WEB_FRAMECHANNEL) 
    {
        //for exiting thread quickly, turn off flag here.
        rss_session->framechannel_thread_state = 0;

        pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
        
        ELMachines[active_index].Shutdown(0);
        SelectedDev = DEVICE_FLASH_NAME;
        active_index = NET_DS_ACTIVE;
        ELMachines[active_index].Init();
        ELMachines[active_index].Display();
        DBG_MSG("<skydemo> RSS_EscEvent(exit framechannel)<--\n");
        return;
    }
    
    if (rss_session->display_mode == THUMBNAIL_MODE)
    {
        pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
        
        ELMachines[active_index].Shutdown(0);
        SelectedDev = DEVICE_FLASH_NAME;
        active_index = NET_DS_ACTIVE;
        ELMachines[active_index].Init();
        ELMachines[active_index].Display();
    }
    else if (rss_session->display_mode == FULL_IMAGE_MODE)
    { 
        rss_session->display_mode = THUMBNAIL_MODE;
        rss_session->image_update_mode = TOTALLY_UPDATE;
        rss_session->is_draw_outline = 0;
        RSSDisplay();
        pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    }
    else if (rss_session->display_mode == SLIDE_SHOW_MODE)
    {
        DBG_MSG("<skydemo> start to terminate thread in slide-show mode\n");
        rss_session->framechannel_thread_state = 0;
        pthread_join(rss_session->framechannel_thread, &(rss_session->framechannel_thread_result));
        DBG_MSG("<skydemo> slide-show terminats thread done\n");
        
        rss_session->skip_draw_message = 0;//rywu20080616
        
        rss_session->display_mode = THUMBNAIL_MODE;
        rss_session->image_update_mode = TOTALLY_UPDATE;
        rss_session->is_draw_outline = 0;
        RSSDisplay();
        pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    }
        
    DBG_MSG("<skydemo> RSS_EscEvent <--\n");
}

//rywu20080516 added
void RSS_UpEvent()
{
    unsigned char current_focus_image_index;
    unsigned char next_focus_image_index;
	int	current_focus_page_index;
    int	next_focus_page_index;
    RSS_IMAGE_INFO_ID rss_file_info;
    int i;
    char file_name[LEN_XL];

    DBG_MSG("<skydemo> RSS_UpEvent -->\n");

    if (rss_session->web_provider == WEB_FRAMECHANNEL ||
        rss_session->display_mode == SLIDE_SHOW_MODE) 
    {
        DBG_MSG("<skydemo> RSS_UpEvent(exit framechannel)<--\n");
        return;
    }
    
    pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));
    if (rss_session->display_mode == THUMBNAIL_MODE)
    {
        //focus image is the last one, no right icon to be moved in
        if (rss_session->focus_image_no < ICON_NUM_PER_ROW)
        {
        	pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
            DBG_MSG("<skydemo> RSS_UpEvent(1)<--\n");
            return;
        }
    
        //check if moving into previous page
        current_focus_page_index = rss_session->focus_image_no/ICON_NUM_PER_FRAME;
        current_focus_image_index = rss_session->focus_image_no%ICON_NUM_PER_FRAME;
        next_focus_page_index = (rss_session->focus_image_no-ICON_NUM_PER_ROW)/ICON_NUM_PER_FRAME;
        next_focus_image_index = (rss_session->focus_image_no-ICON_NUM_PER_ROW)%ICON_NUM_PER_FRAME;

        if (current_focus_page_index == next_focus_page_index) 
        {
            //update global focus image number
            rss_session->focus_image_no -= ICON_NUM_PER_ROW;
    
            //draw new focus image
            rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
            for(i=0; i<rss_session->focus_image_no; i++)
            {
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            }
            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            
            rss_thumbnail_image_update(file_name, next_focus_image_index, 1);
            
            //draw old focus image
            for (i=0; i<ICON_NUM_PER_ROW; i++) 
            {
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            }
            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            rss_thumbnail_image_update(file_name, current_focus_image_index, 0);

            //draw ratio(position) of current focus number within all files
            draw_thumbnail_number(RGB1, rss_session);
        }
        else
        {
            //update global focus image number
            rss_session->focus_image_no -= ICON_NUM_PER_ROW;
            rss_session->image_update_mode = TOTALLY_UPDATE;
            rss_session->is_draw_outline = 0;
            RSSDisplay();
        }
    }//end if (THUMBNAIL_MODE)
    if (rss_session->display_mode == FULL_IMAGE_MODE)
    {
        if (rss_session->focus_image_no == 0)
        {
        	pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
            DBG_MSG("<skydemo> RSS_UpEvent(2) <--\n");
            return;
        }

        rss_session->focus_image_no--;
        rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
        for(i=0; i<rss_session->focus_image_no; i++)
        {
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
        }
        sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
        rss_full_image_update(file_name);
    }//end if (FULL_IMAGE_MODE)
    pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    DBG_MSG("<skydemo> RSS_UpEvent <--\n");
}

//rywu20080516 added
void RSS_DownEvent()
{
    unsigned char current_focus_image_index;
    unsigned char next_focus_image_index;
	int	current_focus_page_index;
    int	next_focus_page_index;
    RSS_IMAGE_INFO_ID rss_file_info;
    int i;
    char file_name[LEN_XL];

    DBG_MSG("<skydemo> RSS_DownEvent -->\n");

    if (rss_session->web_provider == WEB_FRAMECHANNEL ||
        rss_session->display_mode == SLIDE_SHOW_MODE)
    {
        DBG_MSG("<skydemo> RSS_UpEvent(exit framechannel)<--\n");
        return;
    }
    
    pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));
    if (rss_session->display_mode == THUMBNAIL_MODE)
    {
        //focus image is the last one, no right icon to be moved in
        if ((rss_session->focus_image_no+ICON_NUM_PER_ROW) > (rss_session->total_file_amount-1))
        {
            //check if moving into next page
            current_focus_page_index = rss_session->focus_image_no/ICON_NUM_PER_FRAME;
            current_focus_image_index = rss_session->focus_image_no%ICON_NUM_PER_FRAME;
            next_focus_page_index = (rss_session->total_file_amount-1)/ICON_NUM_PER_FRAME;
            next_focus_image_index = (rss_session->total_file_amount-1)%ICON_NUM_PER_FRAME;
            //if current_focus_page_index == next_focus_page_index, it means no need to down one line
            if (current_focus_page_index != next_focus_page_index)
            {
                //update global focus image number
                rss_session->focus_image_no = rss_session->total_file_amount-1;
                rss_session->image_update_mode = TOTALLY_UPDATE;
                rss_session->is_draw_outline = 0;
                RSSDisplay();
            }
            pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
            DBG_MSG("<skydemo> RSS_DownEvent(1) <--\n");
            return;
        }
    
        //check if moving into next page
        current_focus_page_index = rss_session->focus_image_no/ICON_NUM_PER_FRAME;
        current_focus_image_index = rss_session->focus_image_no%ICON_NUM_PER_FRAME;
        next_focus_page_index = (rss_session->focus_image_no+ICON_NUM_PER_ROW)/ICON_NUM_PER_FRAME;
        next_focus_image_index = (rss_session->focus_image_no+ICON_NUM_PER_ROW)%ICON_NUM_PER_FRAME;

        if (current_focus_page_index == next_focus_page_index) 
        {
            //draw old focus image
            rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
            for(i=0; i<rss_session->focus_image_no; i++)
            {
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            }
            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            rss_thumbnail_image_update(file_name, current_focus_image_index, 0);
    
            //draw new focus image
            for (i=0; i<ICON_NUM_PER_ROW; i++) 
            {
                //image = image->next;
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            }
            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            rss_thumbnail_image_update(file_name, next_focus_image_index, 1);
    
            //update global focus image number
            rss_session->focus_image_no += ICON_NUM_PER_ROW;

            //draw ratio(position) of current focus number within all files
            draw_thumbnail_number(RGB1, rss_session);
        }
        else
        {
            //update global focus image number
            rss_session->focus_image_no += ICON_NUM_PER_ROW;
            rss_session->image_update_mode = TOTALLY_UPDATE;
            rss_session->is_draw_outline = 0;
            RSSDisplay();
        }
    }//end if (THUMBNAIL_MODE)
    if (rss_session->display_mode == FULL_IMAGE_MODE) 
    {
        //focus image is the last one, no right icon to be moved in
        if (rss_session->focus_image_no == (rss_session->total_file_amount - 1))    
        {
        	pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
            DBG_MSG("<skydemo> RSS_DownEvent(2) <--\n");
            return;
        }

        rss_session->focus_image_no++;
        rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
        for(i=0; i<rss_session->focus_image_no; i++)
        {
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
        }
        sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
        rss_full_image_update(file_name);
    }//end if (FULL_IMAGE_MODE)
    pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    DBG_MSG("<skydemo> RSS_DownEvent <--\n");
}

//rywu20080516 added
void RSS_LeftEvent()
{
    unsigned char current_focus_image_index;
    unsigned char next_focus_image_index;
	int	current_focus_page_index;
    int	next_focus_page_index;
    RSS_IMAGE_INFO_ID rss_file_info;
    int i;
    char file_name[LEN_XL];

    DBG_MSG("<skydemo> RSS_LeftEvent -->\n");

    if (rss_session->web_provider == WEB_FRAMECHANNEL ||
        rss_session->display_mode == SLIDE_SHOW_MODE)
    {
        DBG_MSG("<skydemo> RSS_UpEvent(exit framechannel)<--\n");
        return;
    }
    
	pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));
    //focus image is the last one, no right icon to be moved in
    if (rss_session->focus_image_no == 0)
    {
    	pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
        DBG_MSG("<skydemo> RSS_LeftEvent(1) <--\n");
        return;
    }

    if (rss_session->display_mode == THUMBNAIL_MODE)
    {
        //check if moving into previous page
        current_focus_page_index = rss_session->focus_image_no/ICON_NUM_PER_FRAME;
        current_focus_image_index = rss_session->focus_image_no%ICON_NUM_PER_FRAME;
        next_focus_page_index = (rss_session->focus_image_no-1)/ICON_NUM_PER_FRAME;
        next_focus_image_index = (rss_session->focus_image_no-1)%ICON_NUM_PER_FRAME;
        if (current_focus_page_index == next_focus_page_index) 
        {
            //draw new focus image
            rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
            for(i=0; i<(rss_session->focus_image_no-1); i++)
            {
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            }
            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            rss_thumbnail_image_update(file_name, next_focus_image_index, 1);
    
            //draw old focus image
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            rss_thumbnail_image_update(file_name, current_focus_image_index, 0);
    
            //update global focus image number
            rss_session->focus_image_no--;

            //draw ratio(position) of current focus number within all files
            draw_thumbnail_number(RGB1, rss_session);
        }
        else
        {
            rss_session->image_update_mode = TOTALLY_UPDATE;
            rss_session->focus_image_no--;
            rss_session->is_draw_outline = 0;
            RSSDisplay();
        }
    }//end if (THUMBNAIL_MODE)
    if (rss_session->display_mode == FULL_IMAGE_MODE)
    {
        rss_session->focus_image_no--;
        rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
        for(i=0; i<rss_session->focus_image_no; i++)
        {
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
        }
        sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
        rss_full_image_update(file_name);
    }//end if (FULL_IMAGE_MODE)
    pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    DBG_MSG("<skydemo> RSS_LeftEvent <--\n");
}

//rywu20080516 added
void RSS_RightEvent()
{
    unsigned char current_focus_image_index;
    unsigned char next_focus_image_index;
	int	current_focus_page_index;
    int	next_focus_page_index;
    RSS_IMAGE_INFO_ID rss_file_info;
    int i;
    char file_name[LEN_XL];

    DBG_MSG("<skydemo> RSS_RightEvent -->\n");

    if (rss_session->web_provider == WEB_FRAMECHANNEL ||
        rss_session->display_mode == SLIDE_SHOW_MODE)
    {
        DBG_MSG("<skydemo> RSS_UpEvent(exit framechannel)<--\n");
        return;
    }

	pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));
    //focus image is the last one, no right icon to be moved in
    if (rss_session->focus_image_no == (rss_session->total_file_amount - 1))
    {
    	pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
        DBG_MSG("<skydemo> RSS_RightEvent(1) <--\n");
        return;
    }

    if (rss_session->display_mode == THUMBNAIL_MODE)
    {
        //check if moving into next page
        current_focus_page_index = rss_session->focus_image_no/ICON_NUM_PER_FRAME;
        current_focus_image_index = rss_session->focus_image_no%ICON_NUM_PER_FRAME;
        next_focus_page_index = (rss_session->focus_image_no+1)/ICON_NUM_PER_FRAME;
        next_focus_image_index = (rss_session->focus_image_no+1)%ICON_NUM_PER_FRAME;

        if (current_focus_page_index == next_focus_page_index) 
        {
            //draw old focus image
            rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
            for(i=0; i<rss_session->focus_image_no; i++)
            {
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            }

            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            rss_thumbnail_image_update(file_name, current_focus_image_index, 0);
    
            //draw new focus image
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
            sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
            rss_thumbnail_image_update(file_name, next_focus_image_index, 1);
    
            //update global focus image number
            rss_session->focus_image_no++;

            //draw ratio(position) of current focus number within all files
            draw_thumbnail_number(RGB1, rss_session);
        }
        else
        {
            //update global focus image number
            rss_session->focus_image_no++;
            rss_session->image_update_mode = TOTALLY_UPDATE;
            rss_session->is_draw_outline = 0;
            RSSDisplay();
        }
    }//end if (THUMBNAIL_MODE)
    if (rss_session->display_mode == FULL_IMAGE_MODE)
    {
        rss_session->focus_image_no++;
        rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
        for(i=0; i<rss_session->focus_image_no; i++)
        {
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
        }
        sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
        rss_full_image_update(file_name);
    }//end if (FULL_IMAGE_MODE)
	pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    DBG_MSG("<skydemo> RSS_RightEvent <--\n");
}

//rywu20080516 added
void RSS_EnterEvent()
{
    unsigned char current_focus_image_index;
    unsigned char next_focus_image_index;
	int	current_focus_page_index;
    int	next_focus_page_index;
    RSS_IMAGE_INFO_ID rss_file_info;
    int i;
    char file_name[LEN_XL];

    DBG_MSG("<skydemo> RSS_EnterEvent -->\n");

    if (rss_session->web_provider == WEB_FRAMECHANNEL ||
        rss_session->display_mode == SLIDE_SHOW_MODE)
    {
        DBG_MSG("<skydemo> RSS_UpEvent(exit framechannel)<--\n");
        return;
    }

	pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));//rywu20080616 rss_mutex_on(&rss_session->msg_block->own);
    //if there is no image stored, we can't enter full image mode
    if (rss_session->display_mode == THUMBNAIL_MODE && rss_session->total_file_amount > 0)
    {
        rss_session->display_mode = FULL_IMAGE_MODE;
    
        rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
        for(i=0; i<rss_session->focus_image_no; i++)
        {
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
        }
        sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
        rss_full_image_update(file_name);
    }
	pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    DBG_MSG("<skydemo> RSS_EnterEvent <--\n");
}

//rywu20080516 added to run slide show for FrameChannel initially.
//But you may use it to run slide show for other mode.
void framechannel_thread(RSS_SESSION_INFO_ID rss_session)
{
    RSS_IMAGE_INFO_ID rss_file_info;
    int count_down = 0;
    char file_name[LEN_XL];
    char str[128];
    int src, dest;
    int i=0, j=0;
    COORD text_area;
    FRAME *elmf;
    RSS_IMAGE_INFO_ID check_file_info;
    unsigned char is_match;
    pid_t pid;
    int status;
    int is_skyview_error;
    char dcrop_str[16];
    int is_tr_error;
    
    DBG_MSG("<skydemo> framechannel_thread -->(%d)\n", getpid());

    rss_session->framechannel_thread_state = 1;

    //wait for background image been drawn.
    if (rss_session->web_provider == WEB_FRAMECHANNEL)//rywu20080616
    {
        //rywu20080715++
        /*while(rss_session->is_draw_outline && rss_session->framechannel_thread_state)
        {
            DBG_MSG("<skydemo> rgbtemplate not ready. %d\n", i++);
            usleep(200000);
            elmf = &ELMachines[active_index].frame;
        }*/
        while(rss_session->is_draw_outline==0 && rss_session->framechannel_thread_state)
        {
            DBG_MSG("<skydemo> rgbtemplate not ready. %d\n", i++);
            sleep(1);
        }
        elmf = &ELMachines[active_index].frame;
        //rywu20080715--
    
        //show something during waiting
        while(ListGetSize(&rss_session->image_on_use_list)==0 && 
              rss_session->framechannel_thread_state)
        {
            usleep(400000);
            text_area.x = desc->bkgrdCoord[0].x + ((desc->bkgrdCoord[0].x + desc->bkgrdCoord[0].width)>>2);
            text_area.y = desc->bkgrdCoord[0].y + ((desc->bkgrdCoord[0].y + desc->bkgrdCoord[0].height)>>1);
            text_area.width = (desc->bkgrdCoord[0].width - text_area.x)>>1;
            text_area.height= g_pFontDB_Default->FontSize;//rywu20080715 (desc->bkgrdCoord[0].height>>2);
            if (rss_session->current_state == IPC_NO_UPDATE)
            {
                strcpy(str, "No update picture ");
            }
            else if (rss_session->current_state == IPC_NETWORK_UNAVAILABLE)
            {
                strcpy(str, "Network unavailable");
            }
            else if (rss_session->current_state == IPC_CANNOT_RESOLVE_HOST)
            {
                strcpy(str, "Can't resovle host");
            }
            else if (rss_session->current_state == IPC_RX_TIMEOUT)
            {
                strcpy(str, "Receive time-out");
            }
            else if (rss_session->current_state == IPC_CONFIG_FILE_BROKEN)
            {
                strcpy(str, "Config file corrupted or lost");
            }
            else
            {
                strcpy(str, "Download ");
                for (j=0; j<i; j++)
                {
                    strcat(str, ".");
                }
                i=(i++)%16;
            }
            if (rss_session->skip_draw_message == 0)//rywu20080616
            {
                draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
            }
        }
    }
    
    //rywu20080617++
    if (rss_session->web_provider == WEB_FLICKR ||
        rss_session->web_provider == WEB_PICASA)
    {
        elmf = &ELMachines[active_index].frame;
        
        text_area.x = desc->MiscTextCoord[8].x + ((desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width)>>2);
        text_area.y = desc->MiscTextCoord[8].y - 3;
        text_area.width = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width - ((desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width)>>2);
        text_area.height= g_pFontDB_Default->FontSize;
        
        if (rss_session->skip_draw_message == 0)//rywu20080624 skip show message on screen
        {
            i = 6;
            while(i--)
            {
                sprintf(str, "Enter slide show after %d seconds", i);
                draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
                sleep(1);
            }
        }
    }
    //rywu20080617--
    
    rss_file_info = (RSS_IMAGE_INFO_ID)0;
    while(rss_session->framechannel_thread_state) 
    {
        rss_session->slideshow_time_tag = (int)time((time_t *)NULL);//rywu20080709
        
        //display image within this period
        if(count_down && rss_session->framechannel_thread_state)//rywu20080620
        {
            //for debug
            /*if (count_down > 30) //over 30 seconds
            {
                DBG_MSG("<skydemo> count_down(%d) > 30 ...too odd\n", count_down);
            }*/
            
            sleep(1);
            count_down--;
            rss_session->slideshow_time_tag = 0;//rywu20080709
            continue;
        }
        
        //rywu20080616++
        //wait for sky_rss remove directory
        if (rss_session->current_state == IPC_RESET_RSS_SESSION)
        {
            sleep(1);
            rss_session->slideshow_time_tag = 0;//rywu20080709
            continue;
        }
        //rywu20080616--
        
        DBG_MSG("<skydemo> ready to show -->\n");
        pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));
        
        /*
        if (rss_file_info == 0 ||
            ListGetSize(&rss_session->image_on_use_list) == 0)
        {
            rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
        }
        else
        {
            rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
        }

        //check if still within image_on_use_list
        is_match = 0;
        j = ListGetSize(&rss_session->image_on_use_list);
        check_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
        for(i=0; i<j; i++)
        {
            if (check_file_info == rss_file_info)
            {
                is_match = 1;
                break;
            }
            else
            {
                check_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&check_file_info->link);
            }
        }
        if (!is_match)
        {
            DBG_MSG("<skydemo>    got not matched one\n");
            rss_file_info = 0;
        }
                
        //if there is still no image incoming, then just wait...
        if(rss_file_info == 0) 
        {
            pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&rss_session->msg_block->own);
            DBG_MSG("<skydemo> ready to show(0) <--\n");
            sleep(1);
            continue;
        }   
        */
        
        //rywu20080521++
        if (ListGetSize(&rss_session->image_on_use_list) > 0)
        {
            if (rss_file_info == 0)
            {
                rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
                if (rss_file_info == 0)
                {
                    printf("<skydemo> (1)Huston, I saw a ghost...\n");
                }
                rss_session->focus_image_no = 0;//rywu20080616
            }
            else
            {
                rss_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&rss_file_info->link);
                
                //check if still within image_on_use_list
                is_match = 0;
                j = ListGetSize(&rss_session->image_on_use_list);
                check_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
                for(i=0; i<j; i++)
                {
                    if (check_file_info == rss_file_info)
                    {
                        is_match = 1;
                        rss_session->focus_image_no++;//rywu20080616
                        break;
                    }
                    else
                    {
                        check_file_info = (RSS_IMAGE_INFO_ID)ListNextEntry(&check_file_info->link);
                    }
                }
                
                //get 1st file, if necessary
                if (!is_match)
                {
                    DBG_MSG("<skydemo>    got not matched one\n");
                    rss_file_info = (RSS_IMAGE_INFO_ID)ListGetHead(&rss_session->image_on_use_list);
                    rss_session->focus_image_no = 0;//rywu20080616
                    if (rss_file_info == 0)
                    {
                        printf("<skydemo> (2)Huston, I saw a ghost...\n");
                    }
                }
            }
        }
        else
        {
            pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
            rss_file_info = (RSS_IMAGE_INFO_ID)0;
            count_down = 0;//rywu20080527
            sleep(1);
            rss_session->slideshow_time_tag = 0;//rywu20080709
            DBG_MSG("<skydemo> ready to show(0) <--\n");
            continue;
        }
        //rywu20080521--
        
        
        DBG_MSG("<skydemo>    show duration...\n");
        count_down = rss_file_info->duration;
        
        
        /*rywu20080612
        //rywu20080529b++
        src_str[0] = '1';
        src_str[1] = '\0';
        dest_str[0] = '0';
        dest_str[1] = '\0';
        yuv_idx = 0;
        //rywu20080529b--
        */
        
        //rywu20080707 system("sync;sync");//rywu20080611
        //rywu20080707 usleep(50000);//rywu20080611
        sprintf(file_name, "%s/%s", rss_session->file_dir, rss_file_info->file_name);
        DBG_MSG("<skydemo> show %s for %d seconds\n", rss_file_info->file_name, count_down);

        is_skyview_error = 0; //rywu20080528
        pid = fork();
		switch(pid)
		{
			case -1:
				DBG_MSG("<skydemo>    fork skyview failed\n");
				break;
				//exit(1);
			case 0:
				//child process
				/*rywu20080611
				sprintf(x_res, "%d", OUTPUT_XRES);
				sprintf(y_res, "%d", OUTPUT_YRES);
				execl("/sky/skyview", "skyview", "-yuv", src_str, "-delay", "-x", x_res, "-y", y_res, file_name, NULL);
				*/
				
				//rywu20080611++
				sprintf(dcrop_str, "%d/%d", OUTPUT_XRES, OUTPUT_YRES);
				execl("/sky/skyview", "skyview", "-yuv", "0", "-delay", "-dcrop", dcrop_str, "-pan", "0/0/0/0", file_name, NULL);
				//rywu20080611--
				
				_EXIT;
			default:
				//parent process
				DBG_MSG("<skydemo>    skyview pid = %d\n", pid);
				waitpid(pid, &status, 0);
				if(!WIFEXITED(status))
                {
                    is_skyview_error = 1;
                }
                /*
                //rywu20080611++
                is_skyview_error = 1;
                i=0;
                while(i++ < 20)//wait for 2 seconds as most
                {
                    usleep(100000);
                    if(waitpid(pid, &status, WNOHANG))
                    {
                        is_skyview_error = 0;
                        break;
                    }
                }
                //rywu20080611--
                */
                break;
		}
		//rywu20080528
		if (is_skyview_error == 1)
        {
            DBG_MSG("<skydemo> ready to show(1) <--\n");
            kill(pid, SIGSTOP);//rywu20080611
            pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
            continue;
        }
		
        //is_tr_error = 0;//rywu20080611
        pid = fork();
		switch(pid)
		{
			case -1:
				DBG_MSG("<skydemo>    fork tr failed\n");
				break;
				//exit(1);
			case 0:
				//child process
				//rywu20080611 execl("/sky/tr", "tr", "-s", src_str, "-d", dest_str, "-t", "0", NULL);
				execl("/sky/tr", "tr", "-s", "0", "-d", "1", "-t", "0", NULL);
				_EXIT;
			default:
				//parent process
				DBG_MSG("<skydemo>    tr      pid = %d\n", pid);
				waitpid(pid, &status, 0);
				/*
				//rywu20080611++
				is_tr_error = 1;
				i=0;
                while(i++ < 15)//wait for 3 seconds as most
                {
                    usleep(200000);
                    if(waitpid(pid, &status, WNOHANG))
                    {
                        is_tr_error = 0;
                        break;
                    }
                }*/
                //rywu20080611--
                break;
		}
		/*
		//rywu20080611++
        if (is_tr_error == 1)
        {
            DBG_MSG("<skydemo> ready to show(2) <--\n");
            kill(pid, SIGSTOP);
            pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&rss_session->msg_block->own);
            continue;
        }
        //rywu20080611--
        */
        
        pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
        usleep(500000);//rywu20080616
        rss_session->slideshow_time_tag = 0;//rywu20080709
        DBG_MSG("<skydemo> ready to show <--\n");
    }
    DBG_MSG("<skydemo> framechannel_thread <--\n");
}


//rywu20080616 added
void rss_signal_thread(RSS_SESSION_INFO_ID rss_session)
{
    RSS_IMAGE_INFO_ID rss_file_info;
    COORD text_area;
    FRAME *elmf;
    char str[32];
    long int msg_to_receive;
    MSG_DATA msg_data;
    RSS_DATA_ID msg_block;
    
    DBG_MSG("<skydemo> rss_signal_thread --> (%d)\n", getpid());
    
    rss_session->rss_signal_thread_state = 1;
    while(rss_session->rss_signal_thread_state)
    {
        rss_session->message_time_tag = (int)time((time_t *)NULL);//rywu20080709
        
        msg_to_receive = 1;
        if (msgrcv(rss_session->rx_msg_id, (void *)&(msg_data), RSS_DATA_SIZE, msg_to_receive, IPC_NOWAIT) == -1)
        {
            usleep(10000);
            continue;
    	}
    	msg_block = (RSS_DATA_ID)&(msg_data.data);
    	
    	if (msg_block->magic_number != 0x55aa)
    	{
    	    DBG_MSG("<skydemo>    wrong magic number\n");
    	    usleep(10000);
            continue;
        }
    	
    	pthread_mutex_lock(&act_lock);//rywu20080707 rss_mutex_on(&(rss_session->act_lock));
    	
    	elmf = &ELMachines[active_index].frame;
        DBG_MSG("<skydemo> got msg type = %d\n", msg_block->type);
    
        //Flickr, Picasa both deploy thumbnail mode, so we prepare text area information here before using.
        if (rss_session->web_provider != WEB_FRAMECHANNEL) 
        {
            text_area.x = desc->MiscTextCoord[8].x + ((desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width)>>2);
            text_area.y = desc->MiscTextCoord[8].y - 3;
            text_area.width = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width - ((desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width)>>2);
            text_area.height= g_pFontDB_Default->FontSize;
            DBG_MSG("<skydemo>   draw text(%d, %d, %d, %d)\n", text_area.x, text_area.y, text_area.width, text_area.height);
        }
    
        switch(msg_block->type)
        {
            case IPC_INIT://l
                //DBG_MSG("<skydemo> index(%d, IPC_INIT)\n", active_index);
                //initialize values
                //rywu20080616 rss_session->display_mode			= THUMBNAIL_MODE;
                rss_session->total_file_amount		= ImgCount;
                rss_session->last_handled_image_no  = ImgCount - 1;
                rss_session->focus_image_no			= 0;
    			rss_session->image_update_mode		= INITIAL_UPDATE;//first time to show
                rss_session->current_state          = IPC_INIT;
                rss_session->inform_rss_link_status = 1;
                rss_session->is_sky_rss_running     = 1;
                sprintf(rss_session->file_dir, "%s", msg_block->file_dir);
                DBG_MSG("<skydemo>   buffered file size = %d, dir = %s\n", 
                       rss_session->total_file_amount, rss_session->file_dir);
                       
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
                draw_text_message(RGB1, (COORD *)&text_area, "Initializing ...", GREY40_1555, 1);
                break;
    
            case IPC_RESET_RSS_SESSION:
                DBG_MSG("<skydemo> reset rss session\n");
                rss_session->current_state = IPC_RESET_RSS_SESSION;
                
                if (rss_session->web_provider == WEB_FRAMECHANNEL) 
                {
                    while (ListGetSize(&rss_session->image_on_use_list)) 
                    {
                        rss_file_info = (RSS_IMAGE_INFO_ID)ListPopHead(&rss_session->image_on_use_list);
                        ListPushTail(&rss_session->image_free_list, &rss_file_info->link);
                    }
                    DBG_MSG("<skydemo>   free list size   = %d\n", ListGetSize(&rss_session->image_free_list));
                    DBG_MSG("<skydemo>   on-use list size = %d\n", ListGetSize(&rss_session->image_on_use_list));
                    break;
                }
                
                //except FrameChannel, add necessary code in below.
                break;
                
            case IPC_DOWNLOAD_START://}lU
                DBG_MSG("<skydemo> download session start\n");
    
                rss_session->current_state = IPC_DOWNLOAD_START;
    
                // For each RSS session of FrameChannel, we should not cache any image as FrameChannel's spec said.
                // So, at the beginning of new session, we need to remove all file information here.
                // Of course, you can also remove them when download complete. But I decide to do it here. ^_^
                if (rss_session->web_provider == WEB_FRAMECHANNEL) 
                {
                    while (ListGetSize(&rss_session->image_on_use_list)) 
                    {
                        rss_file_info = (RSS_IMAGE_INFO_ID)ListPopHead(&rss_session->image_on_use_list);
                        ListPushTail(&rss_session->image_free_list, &rss_file_info->link);
                    }
                }
    
                DBG_MSG("<skydemo>   free list size   = %d\n", ListGetSize(&rss_session->image_free_list));
                DBG_MSG("<skydemo>   on-use list size = %d\n", ListGetSize(&rss_session->image_on_use_list));
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
                
                if (msg_block->rest_frame_count > 0)
                {
                    if (msg_block->rest_frame_count > 1)
                    {
                        sprintf(str, "Download... (%d items left)", msg_block->rest_frame_count);
                    }
                    else if (msg_block->rest_frame_count == 1)
                    {
                        sprintf(str, "Download... (%d item left)", msg_block->rest_frame_count);
                    }
                    draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
                }
                break;
    
            case IPC_DOWNLOAD_ONE_FILE_OK://U@ɮOK
            	DBG_MSG("<skydemo> insert new file : %s\n", msg_block->file_name);
    
                //rss_session->current_state = IPC_DOWNLOAD_ONE_FILE_OK;
    
                //queue file information into list
                rss_file_info = (RSS_IMAGE_INFO_ID)ListPopHead(&rss_session->image_free_list);
                if (rss_file_info == 0)
                {
                    DBG_MSG("<skydemo> image free list is empty!!\n");
                    //rywu20080618a++
                    sprintf(str, "Exceed max(%d) file descriptors", MAX_RSS_FILE_QTY);
                    draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
                    //rywu20080618a--
                    break;
                }
                strcpy(rss_file_info->file_name, msg_block->file_name);
                rss_file_info->duration = msg_block->duration;
                ListPushTail(&rss_session->image_on_use_list, &rss_file_info->link);
                
                rss_session->total_file_amount = ListGetSize(&rss_session->image_on_use_list);
                rss_session->image_update_mode = PARTIAL_UPDATE;//update few thumbnail image
                
                ELMachines[active_index].Display();
                
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
                
                if (msg_block->rest_frame_count < 0)
                {
                    sprintf(str, "Show existing image");
                }
                else
                {
                    if (msg_block->rest_frame_count > 1)
                    {
                        sprintf(str, "Download... (%d items left)", msg_block->rest_frame_count);
                    }
                    else if (msg_block->rest_frame_count == 1)
                    {
                        sprintf(str, "Download... (%d item left)", msg_block->rest_frame_count);
                    }
                    else 
                    {
                        sprintf(str, "Download complete");//rywu20080618a , msg_block->rest_frame_count);
                        DBG_MSG("<skydemo> download complete\n");
                        DBG_MSG("<skydemo>    free list size   = %d\n", ListGetSize(&rss_session->image_free_list));
                        DBG_MSG("<skydemo>    on-use list size = %d\n", ListGetSize(&rss_session->image_on_use_list));
                        
                        //rywu20080616 rss_session->is_run_slide_show      = 1;
                    }
                }
                draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
                break;
    
            case IPC_DOWNLOAD_COMPLETE://`/ϥΪ̫}
                rss_session->current_state = IPC_DOWNLOAD_COMPLETE;
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Download complete", GREY40_1555, 1);
                
                DBG_MSG("<skydemo> download complete\n");
                DBG_MSG("<skydemo>   free list size   = %d\n", ListGetSize(&rss_session->image_free_list));
                DBG_MSG("<skydemo>   on-use list size = %d\n", ListGetSize(&rss_session->image_on_use_list));
                
                rss_session->is_run_slide_show      = 1;
    			break;
    
    		case IPC_MEMORY_NOT_ENOUGH://OХdeq
                rss_session->current_state = IPC_MEMORY_NOT_ENOUGH;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
                
                if (rss_session->rss_link_status == LINK_STATUS_DOWN)
                {
                    draw_text_message(RGB1, (COORD *)&text_area, "Network unavailable", RED_1555, 1);
                }
                else
                {
                    draw_text_message(RGB1, (COORD *)&text_area, "Not enough space", RED_1555, 1);
                }
    			break;
    
    		case IPC_FILE_WRITE_FAIL://OХdLkgJ
                rss_session->current_state = IPC_FILE_WRITE_FAIL;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                if (rss_session->rss_link_status == LINK_STATUS_DOWN)
                {
                    draw_text_message(RGB1, (COORD *)&text_area, "Network unavailable", RED_1555, 1);
                }
                else
                {
                    draw_text_message(RGB1, (COORD *)&text_area, "Write failed", RED_1555, 1);
                }
            	break;
    
    		case IPC_NO_SUBSCRIBED_CHANNEL://Sq\WD
                rss_session->current_state = IPC_NO_SUBSCRIBED_CHANNEL;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "No subscribed channel", RED_1555, 1);
            	break;
    
    		case IPC_CONFIG_FILE_BROKEN://WD]wɷl
                rss_session->current_state = IPC_CONFIG_FILE_BROKEN;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Config file corrupted or lost", RED_1555, 1);
            	break;
    
    		case IPC_NETWORK_UNAVAILABLE://Lks
                rss_session->current_state = IPC_NETWORK_UNAVAILABLE;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Network unavailable", RED_1555, 1);
            	break;
    
    		case IPC_CHANNEL_UNREADABLE://LkŪYWD==>RSS Reader|۰ʵ
                rss_session->current_state = IPC_CHANNEL_UNREADABLE;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Channel unreadable", RED_1555, 1);
            	break;
    
    		case IPC_NO_UPDATE://SsӤiѤU
                rss_session->current_state = IPC_NO_UPDATE;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "No update pictures", GREY40_1555, 1);
                
                if (ListGetSize(&rss_session->image_on_use_list) > 0)
                {
                    rss_session->is_run_slide_show      = 1;
                }
                
            	break;
    
            case IPC_INVALID_ARGUMENT://Ѽƿ~
                rss_session->current_state = IPC_INVALID_ARGUMENT;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Wrong parameters", RED_1555, 1);
                break;
                
            case IPC_SHUTDOWN://shutdown rss client
                rss_session->current_state = IPC_INVALID_ARGUMENT;
    
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Shutdown rss client", RED_1555, 1);
                break;
               
            case IPC_NETWORK_AVAILABLE:
                rss_session->current_state = IPC_NETWORK_AVAILABLE;
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
                
                rss_session->rest_frame_count = msg_block->rest_frame_count;
                if (msg_block->rest_frame_count > 0)
                {
                    if (msg_block->rest_frame_count == 1)
                    {
                        sprintf(str, "Download... (%d item left)", msg_block->rest_frame_count);
                    }
                    else
                    {
                        sprintf(str, "Download... (%d items left)", msg_block->rest_frame_count);
                    }
                }
                else
                {
                    sprintf(str, "Initializing ...");
                }
                draw_text_message(RGB1, (COORD *)&text_area, str, GREY40_1555, 1);
                break;
                
            case IPC_RETRIEVE_FEED_INFORMATION:
                rss_session->current_state = IPC_RETRIEVE_FEED_INFORMATION;
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Gathering RSS information", GREY40_1555, 1);
                break;
                
                
            case IPC_CANNOT_RESOLVE_HOST:
                rss_session->current_state = IPC_CANNOT_RESOLVE_HOST;
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Can't resolve host", RED_1555, 1);
                break;
                
            case IPC_RX_TIMEOUT:
                rss_session->current_state = IPC_RX_TIMEOUT;
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Receive time-out", RED_1555, 1);
                break;
            
            default:
                rss_session->current_state = IPC_UNKNOWN_ERROR;
                if (rss_session->web_provider == WEB_FRAMECHANNEL ||
                    rss_session->display_mode != THUMBNAIL_MODE)
                {
                    //FrameChannel does not show the below message.
                    break;
                }
    
                draw_text_message(RGB1, (COORD *)&text_area, "Unknown error", RED_1555, 1);
                break;
        }//end switch(msg_block->type)
    
        pthread_mutex_unlock(&act_lock);//rywu20080707 rss_mutex_off(&(rss_session->act_lock));
    	
    	if (rss_session->is_run_slide_show)
        {
            //reset flag
            rss_session->is_run_slide_show      = 0;
            
            //begin to run slide show
            RSS_SlideShow();
        }
        
        rss_session->message_time_tag = 0;//rywu20080709
    }//end while(rss_session->rss_signal_thread)
    
    DBG_MSG("<skydemo> rss_signal_thread <--\n");
}//end rss_signal_thread


//rywu20080516 added
void tx_msg_to_rss_client(RSS_SESSION_INFO_ID rss_session, unsigned char message)
{
	DBG_MSG("<skydemo> tx_msg_to_rss_client(%d) -->\n", message);
    
    //rywu20080616++
    MSG_DATA msg_data;
    RSS_DATA_ID rss_content;
    
    rss_content = (RSS_DATA_ID)&(msg_data.data);
    
    msg_data.msg_type = 2;
    rss_content->type = message;
    rss_content->magic_number = 0xaa55;
    
    if (msgsnd(rss_session->tx_msg_id, (void *)&msg_data, RSS_DATA_SIZE, 0) == -1)
    {
        printf("<skydemo>    msgsnd failed!!\n");
    }
    //rywu20080616--
    
    
    DBG_MSG("<skydemo> tx_msg_to_rss_client <--\n");
}

//rywu20080516 added to detect network link status.
extern Uint8 isGWSet;
void network_thread(EXTRA_CONTROL_ID extra_control)
{
	unsigned char network_mask;
	unsigned char current_lan_status, new_lan_status, lan_link_status;
	unsigned char current_wireless_status, new_wireless_status, wireless_link_status;
	unsigned char current_adsl_status, new_adsl_status, adsl_link_status;
	
	DBG_MSG("<skydemo> network_thread -->(%d) \n", getpid());
	
	//get mounted network device
	extra_control->net_device_mounted = NO_NETWORK_DEVICE;
	if (isGWSet & 0x02) //bit_1
	{
		extra_control->net_device_mounted |= NETWORK_DEVICE_LAN;
	}
	if (isGWSet & 0x04)	//bit_2
	{
		extra_control->net_device_mounted |= NETWORK_DEVICE_WIRELESS;
	}
	
	//get link status
	extra_control->link_status = LINK_STATUS_DOWN;
	if (isGWSet & 0x01) //bit_0
	{
		extra_control->link_status |= LINK_STATUS_ACTIVE;
	}
	
    extra_control->network_thread_state = 1;
    while(extra_control->network_thread_state) 
    {
        sleep(2);
		//DBG_MSG("<skydemo> detect network -->\n");
		network_mask = detect_net_device();
		
		//
		//check LAN device plug/unplug
		//
		current_lan_status	= extra_control->net_device_mounted&NETWORK_DEVICE_LAN;
		new_lan_status		= network_mask&NETWORK_DEVICE_LAN;
		if (current_lan_status < new_lan_status)
		{
			//LAN device plug-in
            DBG_MSG("<skydemo> ether plug-in\n");
			set_network_on(NETWORK_DEVICE_LAN);
		}
		else if (current_lan_status > new_lan_status)
		{
			//LAN device unplug
            DBG_MSG("<skydemo> ether unplug\n");
			//you can do something here.
            
		}
		
		//check link status while device is plug-in
		//if device is unplug, link status is off as default.
		lan_link_status = LINK_STATUS_DOWN;
		if (new_lan_status)
		{
			if (detect_eth() == LINK_DONE)
			{
                //DBG_MSG("<skydemo> ether LINK_STATUS_ACTIVE\n");
				lan_link_status = LINK_STATUS_ACTIVE;
			}
			else
			{
                //DBG_MSG("<skydemo> ether LINK_STATUS_DOWN\n");
				lan_link_status = LINK_STATUS_DOWN;
			}
		}
		
		//
		//check wireless LAN device plug/unplug
		//
		current_wireless_status	= extra_control->net_device_mounted&NETWORK_DEVICE_WIRELESS;
		new_wireless_status		= network_mask&NETWORK_DEVICE_WIRELESS;
		if (current_wireless_status < new_wireless_status)
		{
			//wireless LAN device plug-in
            DBG_MSG("<skydemo> wifi plug-in\n");
			set_network_on(NETWORK_DEVICE_WIRELESS);
		}
		else if (current_wireless_status > new_wireless_status)
		{
			//wireless LAN device unplug
            DBG_MSG("<skydemo> wifi unplug\n");
			//you can do something here.
		}
		
		//check link status while device is plug-in
		//if device is unplug, link status is off as default.
		wireless_link_status = LINK_STATUS_DOWN;
		if (new_wireless_status)
		{	
			if (detect_wifi() == LINK_DONE)
			{
                //DBG_MSG("<skydemo> wifi LINK_STATUS_ACTIVE\n");
				wireless_link_status = LINK_STATUS_ACTIVE;
			}
			else
			{
                //DBG_MSG("<skydemo> wifi LINK_STATUS_DOWN\n");
				wireless_link_status = LINK_STATUS_DOWN;
			}
		}
		
		//rywu20080529++
		//
		//check ADSL device plug/unplug
		//
		current_adsl_status	= extra_control->net_device_mounted&NETWORK_DEVICE_ADSL_MODEM;
		new_adsl_status		= network_mask&NETWORK_DEVICE_ADSL_MODEM;
		if (current_adsl_status < new_adsl_status)
		{
			//ADSL device plug-in
            DBG_MSG("<skydemo> adsl plug-in\n");
			set_network_on(NETWORK_DEVICE_ADSL_MODEM);
		}
		else if (current_adsl_status > new_adsl_status)
		{
			//LAN device unplug
            DBG_MSG("<skydemo> adsl unplug\n");
			//you can do something here.
		}
		
		//check link status while device is plug-in
		//if device is unplug, link status is off as default.
		adsl_link_status = LINK_STATUS_DOWN;
		if (new_adsl_status)
		{
			if (detect_adsl() == LINK_DONE)
			{
                //DBG_MSG("<skydemo> adsl LINK_STATUS_ACTIVE\n");
				adsl_link_status = LINK_STATUS_ACTIVE;
			}
			else
			{
                //DBG_MSG("<skydemo> adsl LINK_STATUS_DOWN\n");
				adsl_link_status = LINK_STATUS_DOWN;
			}
		}
		//rywu20080529--
		
		//check link state transition
		if (extra_control->link_status != (lan_link_status | wireless_link_status | adsl_link_status))//rywu20080529 modified
		{
			//from link-down to link-active
			if ((lan_link_status | wireless_link_status | adsl_link_status) == LINK_STATUS_ACTIVE)//rywu20080529 modified
			{
				DBG_MSG("<skydemo> (%d, %d, %d)LINK_STATUS_ACTIVE\n", lan_link_status, wireless_link_status, adsl_link_status);
				
				if (lan_link_status)
                {
                    set_network_on(NETWORK_DEVICE_LAN);
                }
                if (wireless_link_status)
                {
                    set_network_on(NETWORK_DEVICE_WIRELESS);
                }
                //rywu20080529++
                if (adsl_link_status)
                {
                    set_network_on(NETWORK_DEVICE_ADSL_MODEM);
                }
                //rywu20080529--
			}
			//from link-active to link-down
			if ((lan_link_status | wireless_link_status | adsl_link_status) == LINK_STATUS_DOWN)//rywu20080529 modified
			{
			    DBG_MSG("<skydemo> (%d, %d, %d)LINK_STATUS_DOWN\n", lan_link_status, wireless_link_status, adsl_link_status);
			    
			    /*rywu20080721
			    //rywu20080709++
			    if (extra_control->net_device_mounted&NETWORK_DEVICE_LAN)
                {
                    set_network_off(NETWORK_DEVICE_LAN);
                }
                else if (extra_control->net_device_mounted&NETWORK_DEVICE_WIRELESS)
                {
                    set_network_off(NETWORK_DEVICE_WIRELESS);
                }
                else if (extra_control->net_device_mounted&NETWORK_DEVICE_ADSL_MODEM)
                {
                    set_network_off(NETWORK_DEVICE_ADSL_MODEM);
                }
                //rywu20080709--
                */
			}
			
			//trigger status changing
			extra_control->link_status_changed = 1;
		}
		
		
		//keep latest link status
		extra_control->link_status = (lan_link_status | wireless_link_status | adsl_link_status); //rywu20080529 modified
		
		//keep latest mounted information
		extra_control->net_device_mounted = network_mask;
		
		//DBG_MSG("<skydemo> detect network <--\n");
    }
    
    DBG_MSG("<skydemo> network_thread <--\n");
}

#endif //end #ifdef SUPPORT_RSS
