/*
    //------------------------------------------------------------------
    //
    // The timing to re-run skydemo,
    //      1. skydemo crashed, including zombie process
    //      2. sky_rss crashed, including zombie process
    //
    //------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <time.h>
#include <linux/reboot.h>
#include <time.h>

#ifdef _DEBUG
    #define DBG_MSG(str, args...)   	printf(str, ##args)
#else
    #define DBG_MSG(str, args...)
#endif

#define CHECK_INTERVAL 60 //seconds
#define RSS_RECOVER_FILE    "/tmp/conf/rss_recover" //keep recover information

int main(void) 
{
	int play_time = 0;
	FILE *fp;
	char *target;
    unsigned char is_sky_rss_found = 0;
    unsigned char sky_rss_count = 0;
    unsigned char need_reboot = 0;
    char buf[80];
    
    int i;
    time_t timestamp;
    
    play_time = CHECK_INTERVAL * 5;//let system booting complete
    while(1)
    {
        if (play_time)
        {
            sleep(1);
            play_time--;
        }
        else
        {
            DBG_MSG("<chk_rss>    begin to checking ...\n");
                        
            //set check interval again
            play_time = CHECK_INTERVAL;
            
            //check recover file existing or not.
            //chk_rss only can run while this file is existing.
            //It means current is running rss function.
            fp = fopen(RSS_RECOVER_FILE, "r");
            if(fp == 0) 
            {
                DBG_MSG("<chk_rss>    no recover file.\n");
                
                //not in rss mode, then enter sleep duratioin
                continue;
            }
            fclose(fp);
            
            //-----------------------------
            //check sky_rss, skydemo
            //
            is_sky_rss_found = 0;
            sky_rss_count = 0;
            need_reboot = 0;
            unlink("/tmp/all_process");
            system("ps > /tmp/all_process");
            fp = fopen("/tmp/all_process", "r");
            if(fp == 0) 
            {
                DBG_MSG("<chk_rss>    Huston, can't open all_process.\n");
            }
            else
            {
                //Skip the 1st line
                //rywu20080715 for(i=0;i<1;i++)
                {
                    if(fscanf(fp, "%*[^\n]\n") < 0)
                    {
                        fclose(fp);
                        
                        //Empty or missing line, or read error.
                        DBG_MSG("<chk_rss>    Empty or missing line, or read error.\n");
                        continue;//rywu20080715 return -1;
                    }
                }
	
                //read 2nd line to get ppp0 information
                while(!feof(fp))
                {
                    fgets(buf, 80, fp);  
                    
                    //check sky_rss
                    target = strstr(buf, "sky_rss");
                    if (target != NULL)
                    {
                        is_sky_rss_found = 1;
                        sky_rss_count++;
                        
                        if ((*(target-1))=='[' && (*(target+7))==']')
                        {
                            DBG_MSG("<chk_rss>    %s", buf);
                            sky_rss_count--;
                            need_reboot = 1;
                        }
                    }
                    
                    target = strstr(buf, "skydemo");
                    if (target != NULL)
                    {
                        if (*(target-1)=='[' && *(target+7)==']')
                        {
                            DBG_MSG("<chk_rss>    %s", buf);
                            need_reboot = 1;
                        }
                    }
                }
    
                fclose(fp);
                unlink("/tmp/all_process");
                sync();
                
                if (need_reboot || (sky_rss_count < 3))
                {
                    time(&timestamp);
                    printf("<chk_rss>    reboot system(%d, %d) at %s\n", need_reboot, sky_rss_count, ctime(&timestamp));
                    system("ps");
                    reboot(LINUX_REBOOT_CMD_RESTART);
                }
            }
            //
            //check sky_rss, skydemo
            //-----------------------------
            
            DBG_MSG("<chk_rss>    checking done ...\n");
        }//end if (play_time)
    }//end while(1)
    
    return 0;
}

