#include "skydemo.h"
#include "machineinit.h"
#include "machinedisplay.h"
#include "machineshutdown.h"
#include "skyutil.h"
#include "drawutil.h"
//-- Flowbee 2008-02-19 terawins osd
#include "arc_tcon.h"

#ifdef LEADTEK
	#include "calltest.h"
#endif

///080507
#include "types.h"
#ifdef WEB_APP_MOD
#include "webapp.h"
#endif
///
// Global-----------------------------------------------------------------------------------------
int SkyPrio;
Uint8 active_index;
EVENT_LOOP_MACHINE ELMachines[NUM_EVENT_LOOP_MACHINES];

Uint32 ICON_NUM_PER_FRAME = 0, ICON_NUM_PER_ROW = 0, MUSIC_BAR_NUM = 0, ICON_WIDTH = 0, ICON_HEIGHT = 0;

DEVICE_FLAG dev_mnted_enbled_flags = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
DEVICE_FLAG 	dev_pre_mnted_enbled_flags = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
Uint8 num_mounted_dev = 0, num_enabled_dev = 0;

Uint8 origDisplayMode = DISP_800x600_LCD, currFIDspMode = -1;

SLint32 CurrPhotoIdx4SSCal = 0;//The index of the photo for starting slideshow, by Richard @ 2007/10/18

char *IconTxtArr4DS[LEN_M];
char *SelectedDev;
char *ICONText4MT[LEN_M];
char *SelectedMT;

///071023 Reaction Icon Group
REACTION_ICON_GROUP *g_pReaction_Icon_Group = NULL;

///070606 FolderView
FLIST *FolderList = NULL;
Uint8 FOLDER_BAR_NUM = 0;

//for sorting
STAT_LIST *SubStatList = NULL;
ULint32 ListNum = 0;

pid_t pid_img = 0, pid_aud = 0, pid_vid = 0, pid_tr = 0;
int sts_img, sts_aud, sts_vid, sts_tr;
LIST *ImageList = NULL, *AudioList = NULL, *VideoList = NULL;
Uint32 ImgCount = 0, AudCount = 0, VidCount = 0;

pid_t pid_fldr_aud = 0, pid_fldr_vid = 0;
int sts_fldr_aud, sts_fldr_vid;
#ifdef BATTERY_MOD
int BatteryVal = -1;
#endif
//**********
// Global Flags
//**********
Uint8 isSSImgPrcsForked = FALSE, isSSAudPrcsForked = FALSE, isSSTrPrcsForked = FALSE, isVidPrcsForked = FALSE, isOnlyAudPrcsForked = FALSE;
Uint8 isSetupPressed = FALSE, isInfoPressed = FALSE, isCalPressed = FALSE, isUSetupNeededSaving = FALSE, isAutoPwrSttngChngd = FALSE;
Uint8 isMutePressed = FALSE, isVolumePressed = FALSE, isUserConfirmed = FALSE;
Uint8 isDebugMode = TRUE;
Sint8 isCalAlarmRinging = -1;//-1: today is not playable; 0: today is playable, but now is not palying; 1: now is playing
///071011 RTCsb
Uint8 isRTCWorking = FALSE;
///070610 rFlag
Uint8 isLanguageChanged = FALSE;
///070625 ﭵ֭ƼҦ
Uint8 isAudioRepeatModeChanged = FALSE;
Uint8 isSortingMethodChanged = FALSE;
Uint8 isFlashFormatted = FALSE;
Uint8 isFlashMusicUsed = FALSE;//When selected storage has no music in SS, using music in flash. By Richard @ 2007/10/08
Uint8 isFolderListUpdate = FALSE;
Uint8 isFldrVidPrcsForked = FALSE, isFldrAudPrcsForked = FALSE;
Uint8 isCardReaderOn = FALSE;
Uint8 hasEnteredCardReaderMode = FALSE;
Uint8 isCoverOn = FALSE; // for Leadtek cover detector, by Xenia 02/2008
Uint8 isExitPressed = FALSE; // for WINGUI, by Xenia 2008/06/10

#ifdef BLUETOOTH_MOD
int shm_bt_id, shm_btop_id;
pid_t pid_bt_sdpd = 0, pid_bt_hcid = 0, pid_bt_sobexsrv = 0, pid_bt_orz = 0;
int sts_orz;
Uint8 isBTPrcsForked = FALSE, isBTPrcssBusy = FALSE, isBTScanningOPush = FALSE;
ULint32 BTActNum = 0L;
//070927 - bt, copy from folder
shm_bt *smbt;
shm_bt_opush *smbtop;
Uint8 BT_DVC_BAR_NUM = 0;
#endif

#ifdef SUPPORT_RSS
//rywu20080616++
//RSS_SESSION_INFO_ID rss_session;
//EXTRA_CONTROL_ID extra_control;
unsigned char rss_session_data_buffer[RSS_SESSION_INFO_SIZE];
RSS_SESSION_INFO_ID rss_session = (RSS_SESSION_INFO_ID)&(rss_session_data_buffer);
unsigned char extra_control_data_buffer[EXTRA_CONTROL_SIZE];
EXTRA_CONTROL_ID extra_control = (EXTRA_CONTROL_ID)&(extra_control_data_buffer);
//rywu20080616--

pthread_mutex_t	act_lock;//rywu20080707
#endif

#ifdef NET_MOD
pid_t pid_rss = 0;
int sts_rss;
Uint8 isGWSet = 0;	//0: none; 1: wired; 2:wireless
unsigned int net_slideshow = 0;
extern int shift480;
extern pid_t dhcp_pid;
extern int dhcpsts;
#if NET_DISABLE
extern unsigned char wifi_down;
extern unsigned char cifs_down;
#endif
#endif

#ifdef TV_SWITCH_MOD
Uint32 TVIF = CVBS, tvDispMode = DISP_NTSC;
#endif

#ifdef HD_AUTOCP_MOD
pid_t pid_hd_cp = 0;
int sts_hd_cp = 0;
Sint32 userSelection = 0, StsOfCpData2HD = 0;
long sizeOfCard = 0L, freeSizeOfHD = 0L;
char *inDvcName, *inDvcPath;
COORD updateRegion = {0, 0, 0, 0};
#endif

#ifdef IP_CAM_MOD
Uint8 isIPCamFullView = 0;
Uint8 isUrlPlayForked = 0;
pid_t pid_url_play = 0;
int sts_url_play = 0;
int nIPCamSelected = 0;
#endif

#ifdef FAKEPOWER
int isPowerOn = FALSE;//TODO: fake power debug
#else
int isPowerOn = TRUE;
#endif

#if defined(GUI_STYLE_COMTEK)
Uint8 isCalSaveSetupFlag = 0; //0:Don't work, 1:Working, 2:OK
#endif

static Uint8 NumIREvts[NUM_EVENT_LOOP_MACHINES] = 
{
	/* 1*/DS_EVENTS, 
	/* 2*/MT_EVENTS, 
	/* 3*/SETUP_L1_EVENTS, 
	/* 4*/SETUP_L2_EVENTS,
	/* 5*/SETUP_L3_EVENTS,
	/* 6*/I_EVENTS,
	/* 7*/FI_EVENTS,
	/* 8*/A_EVENTS,
	/* 9*/V_EVENTS,
	/*10*/FV_EVENTS,
	/*11*/SS_EVENTS,
	/*12*/PC_CONN_EVENTS,
	/*13*/NO_STORAGE_EVENTS,
	/*14*/CONFIRM_EVENTS,
	/*15*/CAL_EVENTS,
	/*16*/FLDR_EVENTS,
	/*17*/FW_UPGRADE_EVENTS,
#ifdef BLUETOOTH_MOD
	/*18*/BT_EVENTS,
#endif
	/*19*/FLDR_FI_EVENTS,
	/*20*/FLDR_FV_EVENTS
#ifdef NET_MOD
	/*21*/,NET_DS_EVENTS
#ifdef SUPPORT_RSS
	/*22*/,RSS_EVENTS
#endif
#ifdef IP_CAM_MOD
	/*23*/,IP_CAM_EVENTS
#endif
///080504
#ifdef WEB_APP_MOD
	/*24*/,WEB_APP_EVENTS
#endif
///
#endif
#ifdef HD_AUTOCP_MOD
	/*25*/,HD_AUTOCP_EVENTS
#endif

	,SHOW_IN_PROCESS_MESSAGE_EVENTS
#if defined(GUI_STYLE_COMTEK)
	/*26*/,PROG_DOWNLOAD_EVENTS
#endif
};
//------------------------------------------------------------------------------------------------
void ForkSkytest()
{
	pid_t pid;
	int status;
	
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			break;
		case 0:
			//child process
#ifdef AUTOTEST
			DPRINTF("Auto-testing gets started.\n");
			execl("/sky/skytest", "skytest", "skymedi", NULL);
#endif
			_EXIT;
		default:
			//parent process
			waitpid(pid, &status, 0);
			DPRINTF("Auto-testing is successfully done.\n");
			break;
	}
}
//------------------------------------------------------------------------------------------------
void IRScanKeyEventHandler(Uint8 irscankey)
{
	IR_SCANKEY_EVENTS *irscanevt_tmp;
    	Uint32 i;
	static Uint8 j = 0, q[4] = {0};

//for fashionstar switching resolution request - bk @ 071114
#ifdef USE_DESC_TV
  #ifdef TV_FI_SWITCH_RESOLUTION
	
	if(active_index == FI_ACTIVE || active_index == FLDR_FI_ACTIVE)
		//the resolution is different from original display mode
		if(currFIDspMode != origDisplayMode)
			//setting the following keys to invalid
			if(irscankey == INFO || irscankey == SETUP || irscankey == CAL)
				irscankey = INVALID;
	
  #endif
#endif
	
	i = Hash(irscankey);
	irscanevt_tmp = ELMachines[active_index].hTable[i];
	while(irscanevt_tmp != NULL)
	{
       	if(irscanevt_tmp->ir_scan_key == irscankey)
       	{
#ifdef USE_DESC_LCD
  #ifdef LEADTEK
			if(irscankey != PLUS && irscankey != MINUS)
  #endif
			tcon_show_icon(0);
#endif

#ifdef USE_DESC_TV
  #ifdef LEADTEK
			if(irscankey != PLUS && irscankey != MINUS)
  #endif
			DrawReactionIcon(irscankey, 1);
#endif
			if(active_index == DS_ACTIVE)
			{
				for(j = 0; j < 4; j++)
				{
					q[j] = 0;
				}
			}
			irscanevt_tmp->ir_scan_key_evt();
			//disable sandglass OSD icon
#ifdef USE_DESC_LCD
  #ifdef LEADTEK
			if(irscankey != PLUS && irscankey != MINUS)
  #endif
			tcon_clear_icon();
#endif

#ifdef USE_DESC_TV
  #ifdef LEADTEK
			if(irscankey != PLUS && irscankey != MINUS)
  #endif
			DrawReactionIcon(irscankey, -1);
#endif

			break;
       	}
       	else
       	{
			irscanevt_tmp = irscanevt_tmp->next;
       	}
	}
	if(irscanevt_tmp == NULL)	//Lkey
	{	
#ifdef USE_DESC_LCD
		tcon_clear_icon();
		tcon_show_icon(1);
#endif
#ifdef USE_DESC_TV
		DrawReactionIcon(INVALID, 1);
#endif

		usleep(500);
#ifdef USE_DESC_LCD
		tcon_clear_icon();
#endif

#ifdef USE_DESC_TV
		DrawReactionIcon(INVALID, -1);
#endif
		//For auto-testing
		if(active_index == DS_ACTIVE)
		{
			if(irscankey == PREV)
			{
				q[0] = 1;
			}
			if(q[0] == 1 && irscankey == BACKWARD)
			{
				q[1] = 1;
			}
			if(q[0] == 1 && q[1] == 1 && irscankey == FORWARD)
			{
				q[2] = 1;
			}
			if(q[0] == 1 && q[1] == 1 && q[2] == 1 && irscankey == NEXT)
			{
				q[3] = 1;
			}
			if(q[0] == 1 && q[1] == 1 && q[2] == 1 && q[3] == 1)
			{
				//fork Mathee's skytest!!!
				ForkSkytest();
				for(j = 0; j < 4; j++)
				{
					q[j] = 0;
				}
			}
		}
	}
}
//------------------------------------------------------------------------------------------------
void InitList(Uint8 type)
{
	if(type & MT_PHOTO)
	{
		ImgCount = 0;
		ImageList = NULL;
		MEMALLOC(ImageList, LIST, 1);
	}
	if(type & MT_MUSIC)
	{
		AudCount = 0;
		AudioList = NULL;
		MEMALLOC(AudioList, LIST, 1);
	}
	if(type & MT_VIDEO)
	{
		VidCount = 0;
		VideoList = NULL;
		MEMALLOC(VideoList, LIST, 1);
	}
}
//------------------------------------------------------------------------------------------------
void FreeList(Uint8 type)
{
	LIST *prevList, *nextList;

	if(type & MT_PHOTO)
	{
		prevList = nextList = NULL;
		prevList = ImageList;
		while(prevList != NULL)
		{
			nextList = prevList->next;
			FREEMEMORY(prevList);
			prevList = nextList;
		}
		ImageList = NULL;
		ImgCount = 0;
	}
	if(type & MT_MUSIC)
	{
		prevList = nextList = NULL;
		prevList = AudioList;
		while(prevList != NULL)
		{
			nextList = prevList->next;
			FREEMEMORY(prevList);
			prevList = nextList;
		}
		AudioList = NULL;
		AudCount = 0;
	}
	if(type & MT_VIDEO)
	{
		prevList = nextList = NULL;
		prevList = VideoList;
		while(prevList != NULL)
		{
			nextList = prevList->next;
			FREEMEMORY(prevList);
			prevList = nextList;
		}
		VideoList = NULL;
		VidCount = 0;
	}
}
//------------------------------------------------------------------------------------------------
void CloseSystem()
{
	Uint8 i;
	static Uint8 isKillallExec = 0;

	DMSG("Close system\n");
	//fix tr bug (mantis 117,124 - robert) by bk @ 071009
	if(active_index == SS_ACTIVE)
	{
		pgu_switch_to_buffer(1);
	}
	ELMachines[active_index].Shutdown(1);
 	if(active_index != NO_STORAGE_ACTIVE)
 	{
		FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
 	}

#ifdef USE_DESC_TV
	hasEnteredCardReaderMode = FALSE;
#endif
 	
#ifdef NET_MOD	
	//Dongle is plugged OUT!!!
	if(
#if NET_DISABLE
	(wifi_down==0) && 
#endif	
	(dev_mnted_enbled_flags.nas && isGWSet == 0)	
	)	//plug out = isGWSet zero
	{
		umount("/mnt/net0");
		//umount("/mnt/net1");
		//umount("/mnt/net2");
		//umount("/mnt/net3");
		//system("killall cifsd");
		printf("unmount network \n");
	}
#if NET_DISABLE
	wifi_down=0; 
#endif
	dev_mnted_enbled_flags.net = 0;
	dev_mnted_enbled_flags.nas = 0;
	//dev_mnted_enbled_flags.rss = 0;
		
	//printf("demo isGWSet=%d\n",isGWSet);
	//printf("wifi down=%d\n",wifi_down);
	if(CheckGWIP("eth0")==0 && CheckGWIP("rausb0")==0)	//no gateway as no network: kill it once
	{		
		isGWSet = 0;
//Robert 2007-12-30
//		system("killall -9 udhcpc");
		if (dhcp_pid > 0)
		{
			KILL(dhcp_pid);
			waitpid(dhcp_pid, &dhcpsts, 0);
			dhcp_pid = 0;
		}

		if(isSocketCreated)
		{
			KillNetSocket();
		}
	}
#endif
//#ifdef IP_CAM_MOD
//	dev_mnted_enbled_flags.ipcam = 0;
//#endif

	//Umount all devices
	for(i = 0; i < MAX_MOUNTED_DEV; i++)
	{
		UmountDecive(i);
	}
}
//------------------------------------------------------------------------------------------------
void ProcessSkyDemo()
{
	Uint8 irscan_key;
		
#if 0	//tyhuang: use check cifs debug to keep alive
	Uint32 pass = 0;
#endif
	// Wait for and handle events!!!
	while(1)
	{
#ifdef USE_DESC_TV
		//defined(TV_AUTO_CARDREADER_MODE_OFF) will never enter cardreader mode
		//because isCardReaderOn is always FALSE
		if(!hasEnteredCardReaderMode && isCardReaderOn)
		{
			hasEnteredCardReaderMode = TRUE;
			SelectedDev = DEVICE_CARD_READER_NAME;
			DS_EnterEvent();
		}
#endif
#ifdef BATTERY_MOD
		//-- Flowbee test battery detect
		BatteryVal = pgu_read_battery_val();

		#if 0
		if(BatteryVal != -1)
		{
			DPRINTF("\n--- battery : %d ---\n", BatteryVal);
		}
		#endif
		
		if(BatteryVal < 660 && BatteryVal >= 0)
		{
			terawins_show_battery(0);
		}
#endif
		
		irscan_key = GetIRScanKey();
		usleep(1);//CANNOT be taken out!!!!!!!!!!!!!!!!by Richard

		if(irscan_key == INVALID)
		{
			goto Monitor;
		}
#if defined(KINGSTON)//kingston software tv switch
		else if(irscan_key == TVOUTPUT)
		{
			SWTVSwitch();
			break;
		}
#endif
		else if(irscan_key == POWER)
		{
#ifdef FAKEPOWER
			PowerOnOffMode();
  #ifdef LEADTEK_TV
  			SetLEDOnOff();
  #endif
#else
			//POWER OFF ==> CUT OFF THE POWER!!!
			MSG("POWER OFF\n");
			break;
#endif
		}
		else
		{
#ifdef FAKEPOWER
			if(isPowerOn)
#endif
			if(!CheckIfOnPwrSavMode())
				IRScanKeyEventHandler(irscan_key);
		}
Monitor:
		if(!isSSImgPrcsForked && !isSSAudPrcsForked && !isVidPrcsForked && !isOnlyAudPrcsForked && !isFldrAudPrcsForked && !isFldrVidPrcsForked)
		{
			MonitorPwrSavAlarm();
		}
		else
		{
			MonitorMultimediaProcesses();
		}
		usleep(1);//CANNOT be taken out!!!!!!!!!!!!!!!!by Richard
        
#ifdef SUPPORT_RSS
        if (extra_control->ignore_io == 0) //rywu20080516
#endif
        {
		MonitorDevices();
        }
        
		MonitorCalTime();
		MonitorAutoPwrOff();
		MonitorAudioTime();
		//MonitorVideoTime();//marked, because of checking by isVideoForked

#ifdef BLUETOOTH_MOD
		MonitorBTAction();
		MonitorScanningOPushDvcs();
#endif
//move to the end of the loop
/*
#if defined(TV_SWITCH_MOD) && !defined(KINGSTON)
		if(MonitorTVSwitch() != TVIF)
		{
			break;
		}
#endif
*/

#ifdef NET_MOD

//rywu20080516++
#ifdef SUPPORT_RSS
		MonitorExtraInfo(extra_control);
#endif
//rywu20080516--
		
		MonitorNetConfig();
#endif

#ifdef HD_AUTOCP_MOD
		MonitorHDCopyStatus();
#endif

#if defined(TV_SWITCH_MOD) && !defined(KINGSTON)
		if(MonitorTVSwitch() != TVIF)
		{
			break;
		}
#endif
	}
}
//------------------------------------------------------------------------------------------------
void StartActiveMachine(Uint8 active)
{
	static Uint8 isBooting = TRUE;
	Uint8 defaultActive = DS_ACTIVE;
	Sint8 card = -1, isCardIO = 0;
/*	Sint8 dev_io[MAX_MOUNTED_DEV] = {0, 0, 0, 0, 0, 0, 0, 0};//0: no change; 1: card in; -1: card out
	
	//record card io
	dev_io[SDMMC]	 = dev_mnted_enbled_flags.sdmmc	- dev_pre_mnted_enbled_flags.sdmmc;
	dev_io[CF]		 = dev_mnted_enbled_flags.cf 	  	- dev_pre_mnted_enbled_flags.cf;
	dev_io[USB]		 = dev_mnted_enbled_flags.usb	- dev_pre_mnted_enbled_flags.usb;
	dev_io[XDSM]	 = dev_mnted_enbled_flags.xdsm	- dev_pre_mnted_enbled_flags.xdsm;
	dev_io[MS]		 = dev_mnted_enbled_flags.msx	- dev_pre_mnted_enbled_flags.msx;
	dev_io[HD]		 = dev_mnted_enbled_flags.hd		- dev_pre_mnted_enbled_flags.hd;
	dev_io[FLASH]	 = dev_mnted_enbled_flags.flash	- dev_pre_mnted_enbled_flags.flash;
	dev_io[NET]		 = dev_mnted_enbled_flags.net	 	- dev_pre_mnted_enbled_flags.net;
	//check card out
	if(dev_io[SDMMC] == -1)
	{
		card = SDMMC;
		isCardIO = -1;
	}
	else if(dev_io[CF] == -1)
	{
		card = CF;
		isCardIO = -1;
	}
	else if(dev_io[USB] == -1)
	{
		card = USB;
		isCardIO = -1;
	}
	else if(dev_io[XDSM] == -1)
	{
		card = XDSM;
		isCardIO = -1;
	}
	else if(dev_io[MS] == -1)
	{
		card = MS;
		isCardIO = -1;
	}
	else if(dev_io[NET] == -1)
	{
		card = NET;
		isCardIO = -1;
	}
	else if(dev_io[HD] == -1)
	{
		card = HD;
		isCardIO = -1;
	}
	else if(dev_io[FLASH] == -1)
	{
		card = FLASH;
		isCardIO = -1;
	}
	//check card in
	if(dev_io[SDMMC] == 1)
	{
		card = SDMMC;
		isCardIO = 1;
	}
	else if(dev_io[CF] == 1)
	{
		card = CF;
		isCardIO = 1;
	}
	else if(dev_io[USB] == 1)
	{
		card = USB;
		isCardIO = 1;
	}
	else if(dev_io[XDSM] == 1)
	{
		card = XDSM;
		isCardIO = 1;
	}
	else if(dev_io[MS] == 1)
	{
		card = MS;
		isCardIO = 1;
	}
	else if(dev_io[NET] == 1)
	{
		card = NET;
		isCardIO = 1;
	}
	else if(dev_io[HD] == 1)
	{
		card = HD;
		isCardIO = 1;
	}
	else if(dev_io[FLASH] == 1)
	{
		card = FLASH;
		isCardIO = 1;
	}
*/
	GetInOutDevice(&isCardIO, &card);
	
	if(isBooting || isCardIO != 0)//booting or card io
	{
		active_index = active;
		if(isBooting)
			isBooting = FALSE;
	}
	else//no card in or out
	{
#ifdef NET_MOD
		if(dev_mnted_enbled_flags.nas && net_slideshow == 1)	//keep playing slideshow
			active_index = active;
		else
#endif
		active_index = defaultActive;
	}
	
	//make list
	if(active_index != DS_ACTIVE)
	{
		if(isCardIO == 1)//card in
		{
			//search SDMMC
			if(card == SDMMC)
			{
				SearchFileAllTypes(SDMMC_PATH);
				SelectedDev = DEVICE_SDMMC_NAME;
			}
			//search CF
			else if(card == CF)
			{
				SearchFileAllTypes(CF_PATH);
				SelectedDev = DEVICE_CF_NAME;
			}
			//search USB
			else if(card == USB)
			{
				SearchFileAllTypes(USB_PATH);
				SelectedDev = DEVICE_USB_NAME;
			}
			//search XDSM
			else if(card == XDSM)
			{
				SearchFileAllTypes(XDSM_PATH);
				SelectedDev = DEVICE_xD_NAME;
			}
			//search MS
			else if(card == MS)
			{
				SearchFileAllTypes(MS_PATH);
				SelectedDev = DEVICE_MS_NAME;
			}
			//search HD
			else if(card == HD)
			{
//				SearchFileAllTypes(HD_PATH);
//				SelectedDev = DEVICE_HD_NAME;
				active_index = defaultActive;
			}
			//search FLASH
			else if(card == FLASH)
			{
				SearchFileAllTypes(FLASH_PATH);
				SelectedDev = DEVICE_FLASH_NAME;
			}
#ifdef NET_MOD
			//search NAS
			else if(card == NET)
			{
				active_index = defaultActive;
			}
#endif
		}
		else//no card in (card out or no changed), searched by specified card order
		{
#ifdef NET_MOD
			if(dev_mnted_enbled_flags.nas && net_slideshow == 1)	//keep playing slideshow
			{
				SelectedDev = DEVICE_NAS_NAME;
			}
			else
#endif
			//search SDMMC
			if(dev_mnted_enbled_flags.sdmmc)
			{
				SearchFileAllTypes(SDMMC_PATH);
				SelectedDev = DEVICE_SDMMC_NAME;
			}
			//search CF
			else if(dev_mnted_enbled_flags.cf)
			{
				SearchFileAllTypes(CF_PATH);
				SelectedDev = DEVICE_CF_NAME;
			}
			//search USB
			else if(dev_mnted_enbled_flags.usb)
			{
				SearchFileAllTypes(USB_PATH);
				SelectedDev = DEVICE_USB_NAME;
			}
			//search XDSM
			else if(dev_mnted_enbled_flags.xdsm)
			{
				SearchFileAllTypes(XDSM_PATH);
				SelectedDev = DEVICE_xD_NAME;
			}
			//search MS
			else if(dev_mnted_enbled_flags.msx)
			{
				SearchFileAllTypes(MS_PATH);
				SelectedDev = DEVICE_MS_NAME;
			}
			//search HD
			else if(dev_mnted_enbled_flags.hd)
			{
//				SearchFileAllTypes(HD_PATH);
//				SelectedDev = DEVICE_HD_NAME;
				active_index = defaultActive;
			}
			//search FLASH
			else if(dev_mnted_enbled_flags.flash)
			{
				SearchFileAllTypes(FLASH_PATH);
				SelectedDev = DEVICE_FLASH_NAME;
			}
#ifdef NET_MOD
			//search NAS
			else if(dev_mnted_enbled_flags.nas)
			{
				active_index = defaultActive;
			}
#endif
		}
	}

	//check list size
	isFlashMusicUsed = FALSE;//reset the flag go into card in/out rule
	switch(active_index)
	{
		case I_ACTIVE:
		case SS_ACTIVE:
			if(ImgCount > 0)
			{
				if(AudCount == 0 && dev_mnted_enbled_flags.flash)
				{
					isFlashMusicUsed = TRUE;
					InitList(MT_MUSIC);
					SearchFileByType(FLASH_PATH, MT_MUSIC, TRUE);
				}
				SelectedMT = ICONText4MT[photo];
				pgu_switch_to_buffer(1);//SwitchYUV(1);//flowbee @ 070821
			}
			else
			{
				FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
				active_index = defaultActive;
#if NET_DISABLE		//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
		if(wifi_down ==1)
		{			
			wifi_down = 0;
			DetectEvent();
		}
#endif 
			}
			break;
		case A_ACTIVE:
			if(AudCount > 0)
			{
				SelectedMT = ICONText4MT[music];
				pgu_switch_to_buffer(1);//SwitchYUV(1);//flowbee @ 070821
			}
			else
			{
				FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
				active_index = defaultActive;
#if NET_DISABLE		//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
		if(wifi_down ==1)
		{			
			wifi_down = 0;
			DetectEvent();
		}
#endif 
			}
			break;
		case V_ACTIVE:
			if(VidCount > 0)
			{
				if(AudCount == 0 && dev_mnted_enbled_flags.flash)
				{
					isFlashMusicUsed = TRUE;
					InitList(MT_MUSIC);
					SearchFileByType(FLASH_PATH, MT_MUSIC, TRUE);
				}
				SelectedMT = ICONText4MT[video];
				pgu_switch_to_buffer(1);//SwitchYUV(1);//flowbee @ 070821
			}
			else
			{
				FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
				active_index = defaultActive;
#if NET_DISABLE		//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
		if(wifi_down ==1)
		{			
			wifi_down = 0;
			DetectEvent();
		}
#endif 
			}
			break;
	}
}
//------------------------------------------------------------------------------------------------
void SearchFileByDevice(Uint8 type, Uint8 dev)
{
	///080625
	static Uint8 virgin = TRUE;
	///

	InitList(type);
	
	if(dev == Mounted_Device)//only for DS_ACTIVE
	{
		///080624
		int i;
		DeviceSearchSequence *pDevSeq = NewDeviceSearchSequence(DefDevTabel);
		if (pDevSeq)
		{
		#ifdef AUTO_PLAY_NEW_DEV
			//sJd
			Sint8 inOut = 0, whichDevice = 0;
			GetInOutDevice(&inOut, &whichDevice);
			if (inOut == 1 && !virgin)
			{
				SetDeviceSearchSequence(pDevSeq, whichDevice, 0);
			}
		#endif
			for (i=0; i<pDevSeq->nDevice; i++)
			{
				SearchFileByType(pDevSeq->Labels[i]->path, type, TRUE);
			}
		}
		FREEMEMORY(pDevSeq);
		///
/*
		if(dev_mnted_enbled_flags.sdmmc)
		{
			SearchFileByType(SDMMC_PATH, type, TRUE);
		}
		if(dev_mnted_enbled_flags.cf)
		{
			SearchFileByType(CF_PATH, type, TRUE);
		}
		if(dev_mnted_enbled_flags.usb)
		{
			SearchFileByType(USB_PATH, type, TRUE);
		}
		if(dev_mnted_enbled_flags.xdsm)
		{
			SearchFileByType(XDSM_PATH, type, TRUE);
		}
		if(dev_mnted_enbled_flags.msx)
		{
			SearchFileByType(MS_PATH, type, TRUE);
		}
#if 0
		if(dev_mnted_enbled_flags.hd)
		{
			SearchFileByType(HD_PATH, type, TRUE);
		}
#endif
		if(dev_mnted_enbled_flags.flash)
		{
			SearchFileByType(FLASH_PATH, type, TRUE);
		}
#if 0
#ifdef NET_MOD
		if(dev_mnted_enbled_flags.nas)
		{
			SearchFileByType(NET_PATH, type, TRUE);
		}
#endif
#endif
*/
	}
	else if(dev == Selected_Device)
	{
		if(!strcmp(SelectedDev, DEVICE_SDMMC_NAME))
		{
			SearchFileByType(SDMMC_PATH, type, FALSE);
		}
		else if(!strcmp(SelectedDev, DEVICE_CF_NAME))
		{
			SearchFileByType(CF_PATH, type, FALSE);
		}
		else if(!strcmp(SelectedDev, DEVICE_USB_NAME))
		{
			SearchFileByType(USB_PATH, type, FALSE);
		}
		else if(!strcmp(SelectedDev, DEVICE_xD_NAME))
		{
			SearchFileByType(XDSM_PATH, type, FALSE);
		}
		else if(!strcmp(SelectedDev, DEVICE_MS_NAME))
		{
			SearchFileByType(MS_PATH, type, FALSE);
		}
#if 0//bk @ 080108
		else if(!strcmp(SelectedDev, DEVICE_HD_NAME))
		{
			SearchFileByType(HD_PATH, type, FALSE);
		}
#endif
		else if(!strcmp(SelectedDev, DEVICE_FLASH_NAME))
		{
			SearchFileByType(FLASH_PATH, type, FALSE);
		}
#if 0
#ifdef NET_MOD
		else if(!strcmp(SelectedDev, DEVICE_NAS_NAME))
		{
			SearchFileByType(NET_PATH, type, FALSE);
		}
#endif
#endif
	}

	///080625
	virgin = FALSE;
	///
}
//------------------------------------------------------------------------------------------------

void InitSystem(INITSYS_CALL_T IsPoweron)
{
	Uint8 i, isAutoPlayOn = 0;
	COORD show_str_pos;
	time_t t;
	struct tm tm;

	MSG("Init System!\n");

	for(i = 0; i < MAX_MOUNTED_DEV; i++)
	{
		UmountDecive(i);
	}

	time(&t);
	memcpy(&tm, localtime(&t), sizeof(tm));

/*	if(
		setup->autopwr_setup_idx == SETUP_ON &&
		setup->autoplay_setup_idx == SETUP_ON &&
		tm.tm_hour == setup->autopwr_on_hour &&
		tm.tm_min == setup->autopwr_on_minute
	  )*/
	 if (setup->autoplay_setup_idx==SETUP_ON)
	{
		isAutoPlayOn = IsPoweron;   // 1;		// cywang , not to run auto play
		sleep(1);//must have!!!waitng for drivers ready, for example, USB
	}

	EnforceRenewPartitionInfo();
	num_mounted_dev = DetectDeviceMountedStatus();
	//DPRINTF("num_mounted_dev = %d\n", num_mounted_dev);

	num_enabled_dev = DetectUSB2PCConnection(num_mounted_dev);
	//DPRINTF("num_enabled_dev = %d\n", num_enabled_dev);
#ifdef USE_DESC_TV
  #ifndef TV_AUTO_CARDREADER_MODE_OFF
	if(isCardReaderOn)
	{
		return;
	}
  #endif
#endif

#ifdef BLUETOOTH_MOD
	num_enabled_dev = DetectBTDongle(num_enabled_dev);
#endif

#ifdef NET_MOD
	DetectNetDongle();

//rywu20080616++
#ifdef SUPPORT_RSS
    extra_control->from_rss_recover = 0;
    if (rss_recover(extra_control))
    {
        DBG_MSG("<skedemo>    rss_recover succeed \n");
        return;
    }
    else
    {
        //rywu20080806++
        unlink("/tmp/conf/rss_recover");
        sync();
        //rywu20080806--
        
        DBG_MSG("<skedemo>    no need to run recover or recover fail\n");
    }
#endif
//rywu20080616--

//#ifdef IP_CAM_MOD
//	num_enabled_dev = DetectIPCam(num_enabled_dev);
//#endif

	//DPRINTF("***num_enabled_dev = %d\n", num_enabled_dev);
	if(dev_mnted_enbled_flags.nas && net_slideshow == 1)	//keep playing slideshow
	{
		SelectedDev = DEVICE_NAS_NAME;
		active_index = FLDR_ACTIVE;
		StartActiveMachine(active_index);
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();		//skip the folder page; sometimes it crushes system
		FLDR_SSEvent();
		return;
	}
#endif

	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);

	#ifdef WINGUI
	if (isExitPressed == FALSE)
	{
		isAutoPlayOn = 1;
		sleep(1);
	}
	//setup->autoplay_selected_media_idx = SETUP_AUTOPLAY_SS;
	#endif
		
	if(num_enabled_dev > 0)
	{
		if(isAutoPlayOn)
		{
			//SelectedDev = "AUTOPLAY";//used with SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Mounted_Device); as below!
			if(setup->autoplay_selected_media_idx == SETUP_AUTOPLAY_SS)
			{
				show_str_pos.x = desc->MiscTextCoord[44].x;
				show_str_pos.y = desc->MiscTextCoord[44].y;
				show_process_msg(FrameText[setup->Language][46],show_str_pos,1);
				SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Mounted_Device);			
				stop_show_process_msg();							

				if (ImgCount)
				{								
					setup->ss_rpt_idx = SETUP_ON;
					SelectedDev = DEVICE_AUTOSS_NAME;
					active_index = SS_ACTIVE;
					ELMachines[active_index].Init();
					ELMachines[active_index].Display();
				}
				else
					isAutoPlayOn = 0;
				
			}
			else if(setup->autoplay_selected_media_idx == SETUP_AUTOPLAY_VIDEO)
			//else if(0)
			{
				setup->vid_rpt_idx = 	SETUP_AV_REPEAT_CONTI;
				active_index = V_ACTIVE;
				StartActiveMachine(active_index);
				if(VidCount != 0)
				{
					pgu_stop_pgu();
				}
				ELMachines[active_index].Init();
				ELMachines[active_index].Display();
				if(active_index == V_ACTIVE)
				{
					V_EnterEvent();
				}
			}
			else if(setup->autoplay_selected_media_idx == SETUP_AUTOPLAY_MUSIC)
			//else if(0)
			{
				setup->aud_rpt_idx = 	SETUP_AV_REPEAT_CONTI;
				active_index = A_ACTIVE;
				StartActiveMachine(active_index);
				ELMachines[active_index].Init();
				ELMachines[active_index].Display();
			}
		}

		if(!isAutoPlayOn)
		{
			StartActiveMachine(setup->HomepageMode);
			if(active_index == MT_ACTIVE)
				ELMachines[active_index].frame.active_icon_index = photo;
#ifndef HD_AUTOCP_MOD
			ELMachines[active_index].Init();
			ELMachines[active_index].Display();
#else //define HD_AUTOCP_MOD
			static Sint8 isBooting = TRUE;//booting, getInOutDevice() is meaningless
			Sint8 io = 0, card = -1;
			
			if(!isBooting && dev_mnted_enbled_flags.hd)
				GetInOutDevice(&io, &card);
			if(io == 1)//device in
			{
				//the inserted device is card, and it will detect hd when booting
				if(
					   card == SDMMC
					|| card == CF
					|| card == USB
					|| card == XDSM
					|| card == MS
				)
				{
					prev_active_index = active_index;
					active_index = HD_AUTOCP_ACTIVE;
					
					switch(card)
					{
						case SDMMC:
							inDvcPath = SDMMC_PATH;
							inDvcName = DEVICE_SDMMC_NAME;
							break;
						case CF:
							inDvcPath = CF_PATH;
							inDvcName = DEVICE_CF_NAME;
							break;
						case USB:
							inDvcPath = USB_PATH;
							inDvcName = DEVICE_USB_NAME;
							break;
						case XDSM:
							inDvcPath = XDSM_PATH;
							inDvcName = DEVICE_xD_NAME;
							break;
						case MS:
							inDvcPath = MS_PATH;
							inDvcName = DEVICE_MS_NAME;
							break;
						default://no reasonable
							break;
					}
				}
			}
		
			isBooting = FALSE;
			ELMachines[active_index].Init();
			ELMachines[active_index].Display();
#endif
		}
	}
	else
	{
		active_index = NO_STORAGE_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}

	#ifdef WINGUI
	// xenia, 2008/06/10
	isExitPressed = FALSE;
	#endif
}
//------------------------------------------------------------------------------------------------
void InitEventLoopMachines()
{
	Uint8 i, j;
	COORD init_coord = {0, 0, 0, 0};
	
	// Initialize ELMachiines with initial values
	for(i = 0; i < NUM_EVENT_LOOP_MACHINES; i++)
	{
		ELMachines[i].frame.fname = NULL;
		ELMachines[i].frame.bkgrdbuff = NULL;
		ELMachines[i].frame.rgbtemplate = NULL;
		ELMachines[i].frame.osdbuff = NULL;
		ELMachines[i].frame.volumebuff = NULL;
		ELMachines[i].frame.framecoord = init_coord;
		ELMachines[i].frame.frametextmsg = NULL;
		ELMachines[i].frame.frametextmsgcoord = init_coord;
		ELMachines[i].frame.num_icon = 0;
		ELMachines[i].frame.icon_arr = NULL;
		ELMachines[i].frame.active_icon_index = 0;
		ELMachines[i].frame.active_frame_index = 0;
		ELMachines[i].frame.CurrImgListPos = NULL;
		ELMachines[i].frame.CurrAudListPos = NULL;
		ELMachines[i].frame.CurrVidListPos = NULL;
		
		ELMachines[i].num_ir_evt = NumIREvts[i];
		
		for(j = 0; j < MAX_NUM_IR_EVENTS; j++)
			ELMachines[i].hTable[j] = NULL;

		ELMachines[i].Init = MachineInit;
		ELMachines[i].Display = MachineDisplay;
		ELMachines[i].Shutdown = MachineShutDown;
	}
}
//------------------------------------------------------------------------------------------------
void InitDisplayParameter(Uint8 displayMode)
{
	unsigned long buf_w = 0, xres = 0, yres = 0;

#ifdef USE_DESC_LCD	
	if(
			displayMode == DISP_800x600_LCD
		|| 	displayMode == DISP_800x480_LCD
		|| 	displayMode == DISP_1024x600_LCD
		||	displayMode == DISP_800x480_LCD_25MHZ
		||	displayMode == DISP_1366x768_LCD
	)
	{
		desc = &descLCD;
	}
#endif
#ifdef USE_DESC_TV
	if(
			displayMode == DISP_NTSC
		|| 	displayMode == DISP_HDTV
		|| 	displayMode == DISP_PAL
	)
	{
		desc = &descTV;
	}
#endif

	pgu_get_yuv_resolution(&buf_w, &xres, &yres);
	OUTPUT_XRES = (Uint16)xres;
	OUTPUT_YRES = (Uint16)yres;
	
#ifdef USE_DESC_TV
	WidthOfScrBorder = ((int)OUTPUT_XRES * TV_BORDER) / 100;
	HeightOfScrBorder = ((int)OUTPUT_YRES * TV_BORDER) / 100;
	memset(dCropAfterScaling, '\0', LEN_L);
	memset(panAfterScaling, '\0', LEN_L);
	sprintf(dCropAfterScaling, "%d/%d", 
		OUTPUT_XRES - (WidthOfScrBorder  << 1), 
		OUTPUT_YRES - (HeightOfScrBorder << 1)
	);
	sprintf(panAfterScaling, "0/0/%d/%d", WidthOfScrBorder, HeightOfScrBorder);
	
	if(pgu_get_tv_interface() == SKY_TV_CVBS_SVIDEO && (displayMode == DISP_NTSC  || displayMode == DISP_PAL))
		isLowPassMode = TRUE;
#endif
	
	PRINTF("Resolution: %d x %d\n", OUTPUT_XRES, OUTPUT_YRES);

//Robert 2007-12-30 shift480 value initial, move from machinedisplay.c
#ifdef NET_MODE
	if (xres == 800 && yres == 480)
	{
		shift480 = 100;
	}
#endif
	
	RESOLUTION_SIZE = (Uint32)OUTPUT_XRES * (Uint32)OUTPUT_YRES;
	RGB_FRAMEBUFF_SIZE = (Uint32)OUTPUT_XRES * (Uint32)OUTPUT_YRES * 2;
	///070820 RGB_VOLBUFF_SIZE令ھڦrjpʺAվ
	//RGB_VOLBUFF_SIZE = (Uint32)OUTPUT_XRES * 30 * 2;
	///

	InitPGU();//reinit rgb0, rgb1...
}
//------------------------------------------------------------------------------------------------
void InitParameter()
{
	Uint8 i;

	origDisplayMode = GetDisplayIndex();
	currFIDspMode = origDisplayMode;//for fashionstar switching resolution request - bk @ 071115
	InitDisplayParameter(origDisplayMode);

	ICON_NUM_PER_FRAME = desc->ICONNumPerFrame;
	ICON_NUM_PER_ROW = desc->ICONNumPerRow;
	MUSIC_BAR_NUM = desc->MusicBarNum;
	//move to FldrInit() by bk @ 070928
	//FOLDER_BAR_NUM = desc->FolderBarNum;
	//move to BTInit() by bk @ 070928
	//BT_FLDR_BAR_NUM = desc->BTFldrBarNum;
	//BT_DVC_BAR_NUM = desc->BTDvcBarNum;
	
	ICON_WIDTH = atoi(desc->ICONWidth);
	ICON_HEIGHT = atoi(desc->ICONHeight);
	
	for(i = 0; i < 3; i++)
	{
		strcpy(desc->ICONFilename4MT[i][photo], desc->PHOTO[i]);
		strcpy(desc->ICONFilename4MT[i][music], desc->MUSIC[i]);
		strcpy(desc->ICONFilename4MT[i][video], desc->VIDEO[i]);
		strcpy(desc->ICONFilename4MT[i][calendar], desc->CALENDAR[i]);
		strcpy(desc->ICONFilename4MT[i][folder], desc->SETUPMENU[i]);
		strcpy(desc->ICONFilename4MT[i][setupmenu], desc->FOLDER[i]);
	}
	ICONText4MT[photo] = FrameText[setup->Language][photo];
	ICONText4MT[music] = FrameText[setup->Language][music];
	ICONText4MT[video] = FrameText[setup->Language][video];
	ICONText4MT[calendar] = FrameText[setup->Language][calendar];
	ICONText4MT[folder] = FrameText[setup->Language][folder];
	ICONText4MT[setupmenu] = FrameText[setup->Language][setupmenu];
}
//------------------------------------------------------------------------------------------------
int InitFont()
{
	///070828
	char *localfontfn = NULL;
	///
	///070815 iconv
	char strCode[LEN_L] = {0};
	///

	//ŪJw]r
	g_pFontDB_Default = Create_FontDB(desc->FontFileName[0]);

	//ŪJϰr	
	switch (setup->Language)
	{
		case SETUP_LANG_English:
		case SETUP_LANG_Italiano:
		case SETUP_LANG_Deutsch:
		case SETUP_LANG_Francais:
		case SETUP_LANG_Espanol:
		case SETUP_LANG_Portuguese:
		case SETUP_LANG_Dutch:
			localfontfn = desc->FontFileName[1];
			strcpy(strCode, CODE_PAGE_NAME_ISO8859_1);
			break;
		case SETUP_LANG_CHT:
			localfontfn = desc->FontFileName[2];
			strcpy(strCode, CODE_PAGE_NAME_BIG_5);
            break;
        case SETUP_LANG_CHS:
            localfontfn = desc->FontFileName[3];
			strcpy(strCode, CODE_PAGE_NAME_GB2312);
            break;
		case SETUP_LANG_JP:
			localfontfn = desc->FontFileName[4];
			strcpy(strCode, CODE_PAGE_NAME_SJIS);
            break;
		case SETUP_LANG_KR:
			localfontfn = desc->FontFileName[5];
			strcpy(strCode, CODE_PAGE_NAME_KSC);
			break;
		///080601 Russian
		case SETUP_LANG_RUS:
			strcpy(strCode, CODE_PAGE_NAME_CYRILLIC);
			break;
		///
		default:
			break;
	}

	///070815 iconv
	if (*strCode)
	{			
		if (  access(desc->FontFileName[NUM_OF_FONT_FILE-1], R_OK) == 0
			&&
			  ((g_pFontDB_Unicode=Create_FontDB(desc->FontFileName[NUM_OF_FONT_FILE-1])) != NULL)
		   )
		{
			g_pFontDB_Local = g_pFontDB_Unicode;

			///080527
			localfontfn = desc->FontFileName[NUM_OF_FONT_FILE-1];
			///
			g_cd_utf8_2_ucs2 = iconv_open (CODE_PAGE_NAME_UCS_2, CODE_PAGE_NAME_UTF_8);
			g_cd_local_2_ucs2 = iconv_open(CODE_PAGE_NAME_UCS_2, strCode);
		}
		else
		{
			///070828
			g_pFontDB_Local = Create_FontDB(localfontfn);
			///
			g_cd_utf8_2_local = iconv_open(strCode, CODE_PAGE_NAME_UTF_8);
		}
	}
	///

	if (!g_pFontDB_Local)
		g_pFontDB_Local = g_pFontDB_Default;

///070824 MwO_ϥΤϿ
#ifdef USE_FONTAA
	if (GetDisplayIndex() == DISP_NTSC || GetDisplayIndex() == DISP_PAL)
	{
		g_pFontDB_Default->bUseFontAA = TRUE;
		g_pFontDB_Local->bUseFontAA = TRUE;
	}
#endif
///

	ICONText4MT[0] = FrameText[setup->Language][0];
	ICONText4MT[1] = FrameText[setup->Language][1];
	ICONText4MT[2] = FrameText[setup->Language][2];
	ICONText4MT[3] = FrameText[setup->Language][3];
	ICONText4MT[4] = FrameText[setup->Language][4];
	ICONText4MT[5] = FrameText[setup->Language][5];	

	if (!g_pFontDB_Default || !g_pFontDB_Local)
	{
		return ERRORCODE_FILE;
	}

	if (localfontfn)
	{
		///070828 ͦrɪlinkmplayerϥ
		unlink("/tmp/font.lnk");
		symlink(localfontfn, "/tmp/font.lnk");
		///
	}
	
	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
void CloseFont()
{
	///080115 iconv
	if (g_cd_utf8_2_local != (iconv_t)-1)
		iconv_close(g_cd_utf8_2_local);
	if (g_cd_utf8_2_ucs2 != (iconv_t)-1)
		iconv_close(g_cd_utf8_2_ucs2);
	if (g_cd_local_2_ucs2 != (iconv_t)-1)
		iconv_close(g_cd_local_2_ucs2);
	g_cd_utf8_2_local = (iconv_t)-1;
	g_cd_utf8_2_ucs2 = (iconv_t)-1;
	g_cd_local_2_ucs2 = (iconv_t)-1;
	/// 

	///070828 rɪlink
	unlink("/tmp/font.lnk");
	///

	if (g_pFontDB_Local != g_pFontDB_Default)
	{
		Release_FontDB(&g_pFontDB_Local);
	}
	else
	{
		g_pFontDB_Local = NULL;
	}
	Release_FontDB(&g_pFontDB_Default);
	//Release_FontDB(&g_pFontDB_Caption);
	///080118
	g_pFontDB_Unicode = NULL;
	///
}
//------------------------------------------------------------------------------------------------
///070917
int InitReactionIcons()
{
	int i, area, max_area;
	REACTION_ICON *pIcon, **Icon, **KeyIcon;
	Uint8 bSuccess = FALSE;
	char *fname;

	//M
	FreeReactionIcons();
	
	for (;;)
	{
		MEMALLOC(g_pReaction_Icon_Group, REACTION_ICON_GROUP, 1);
		if (!g_pReaction_Icon_Group) break;
		
		//MEMALLOC(g_pReaction_Icon_Group->Icon, REACTION_ICON*, MAX_NUM_REACTION_ICON);
		g_pReaction_Icon_Group->Icon = (REACTION_ICON**)malloc((MAX_NUM_REACTION_ICON)*sizeof(REACTION_ICON*));
		if (!g_pReaction_Icon_Group->Icon) break;
		memset(g_pReaction_Icon_Group->Icon, 0, (MAX_NUM_REACTION_ICON)*sizeof(REACTION_ICON*));
		
		//MEMALLOC(g_pReaction_Icon_Group->KeyIconTable, REACTION_ICON*, 256);
		g_pReaction_Icon_Group->KeyIconTable = (REACTION_ICON**)malloc(256*sizeof(REACTION_ICON*));
		if (!g_pReaction_Icon_Group->KeyIconTable) break;
		memset(g_pReaction_Icon_Group->KeyIconTable, 0, 256*sizeof(REACTION_ICON*));

		KeyIcon = g_pReaction_Icon_Group->KeyIconTable;
		Icon = g_pReaction_Icon_Group->Icon;
		max_area = 0;

		//ŪCReaction Icon
		for (i=0; i<MAX_NUM_REACTION_ICON; i++)
		{
			if (strcmp(strrchr(desc->ReactionICONIMG[i], '/'), "/null") != 0)
			{
				MEMALLOC(Icon[i], REACTION_ICON, 1);
				if ((pIcon = Icon[i]) == NULL) break;

				pIcon->icoord = desc->ReactionICONCoord[i];
				if (0 != DecodeRGBImage(&(pIcon->iconbuff), desc->ReactionICONIMG[i], pIcon->icoord.width, pIcon->icoord.height))
				{
					FREEMEMORY(pIcon->iconbuff);
					FREEMEMORY(Icon[i]);
					continue;
				}
				area = pIcon->icoord.width * pIcon->icoord.height;
				if (area > max_area) max_area = area;
			}
		}

		//tmó]w@Ӧ@Ϊtemp buffer
		if (max_area > 0)
		{
			MEMALLOC(g_pReaction_Icon_Group->tempbuff, Uint8, max_area*2);
			if (!g_pReaction_Icon_Group->tempbuff) break;
			for (i=0; i<MAX_NUM_REACTION_ICON; i++)
			{
				if ((pIcon = Icon[i]) != NULL)
				{
					pIcon->pY = g_pReaction_Icon_Group->tempbuff;
					pIcon->pU = pIcon->pY + pIcon->icoord.width*pIcon->icoord.height;
					pIcon->pV = pIcon->pU + (pIcon->icoord.width>>1)*(pIcon->icoord.height>>1);
				}
			}
		}

//إKey->Icon(g_pReaction_Icon_Group->KeyIconTable[])
#ifdef INVALID
		KeyIcon[INVALID]		= Icon[2];
#endif    
//------------------------------
#ifdef POWER
		KeyIcon[POWER]		= Icon[4];
#endif
#ifdef ESC
		KeyIcon[ESC]		= Icon[5];
#endif
#ifdef ENTER
		KeyIcon[ENTER]		= Icon[6];
#endif
//V------------------------------
#ifdef UP
		KeyIcon[UP]			= Icon[8];
#endif
#ifdef DOWN
		KeyIcon[DOWN]		= Icon[9];
#endif
#ifdef LEFT
		KeyIcon[LEFT]		= Icon[10];
#endif
#ifdef RIGHT
		KeyIcon[RIGHT]		= Icon[11];
#endif
//q------------------------------
#ifdef MUTE
		KeyIcon[MUTE]		= Icon[14];
#endif
#ifdef MINUS
		KeyIcon[MINUS]		= Icon[15];
#endif
#ifdef PLUS
		KeyIcon[PLUS]		= Icon[16];
#endif
//------------------------------
#ifdef STOP
		KeyIcon[STOP]		= Icon[18];
#endif
#ifdef PLAYPAUSE
		KeyIcon[PLAYPAUSE]	= Icon[20];
#endif
#ifdef PREV
		KeyIcon[PREV]		= Icon[22];
#endif
#ifdef NEXT
		KeyIcon[NEXT]		= Icon[23];
#endif
#ifdef BACKWARD
		KeyIcon[BACKWARD]	= Icon[24];
#endif
#ifdef FORWARD
		KeyIcon[FORWARD]	= Icon[25];
#endif
//\------------------------------
#ifdef INFO
		KeyIcon[INFO]		= Icon[26];
#endif
#ifdef CONFIRM
		KeyIcon[CONFIRM]	= Icon[27];
#endif
#ifdef REPEAT
		KeyIcon[REPEAT]		= Icon[28];
#endif
#ifdef ROTATE
		KeyIcon[ROTATE]		= Icon[30];
#endif
#ifdef ZOOM
		KeyIcon[ZOOM]		= Icon[32];
#endif
//ֳt------------------------------
#ifdef SETUP
		KeyIcon[SETUP]		= Icon[36];
#endif
#ifdef SLIDESHOW
		KeyIcon[SLIDESHOW]	= Icon[37];
#endif
#ifdef CAL
		KeyIcon[CAL]		= Icon[38];
#endif
#ifdef PHOTO
		KeyIcon[PHOTO]		= Icon[39];
#endif
#ifdef MUSIC
		KeyIcon[MUSIC]		= Icon[49];
#endif
#ifdef VIDEO
		KeyIcon[VIDEO]		= Icon[41];
#endif
#ifdef FOLDER
		KeyIcon[FOLDER]		= Icon[42];
#endif
#ifdef DETECT
		KeyIcon[DETECT]		= Icon[43];
#endif
#ifdef CARD
		KeyIcon[CARD]		= Icon[44];
#endif  

		for (i=0; i<256; i++)
		{
			if (KeyIcon[i] == NULL)	//إiconNF|
			{
				KeyIcon[i] = Icon[0];
			}
		}

		bSuccess = TRUE;
		break;
	}

	//~Bz
	if (bSuccess == FALSE)
	{
		FreeReactionIcons();
		return ERRORCODE_MEMORY;
	}

	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
void FreeReactionIcons()
{
	int i;
	REACTION_ICON **Icon;
	if (g_pReaction_Icon_Group)
	{
		if ((Icon = g_pReaction_Icon_Group->Icon) != NULL)
		{
			for (i=0; i<MAX_NUM_REACTION_ICON; i++)
			{	
				if (Icon[i])
				{
					FREEMEMORY(Icon[i]->iconbuff);
					//FREEMEMORY(Icon[i]->tempbuff);
					FREEMEMORY(Icon[i]);
				}
			}
		}
		FREEMEMORY(g_pReaction_Icon_Group->Icon);
		FREEMEMORY(g_pReaction_Icon_Group->KeyIconTable);
		FREEMEMORY(g_pReaction_Icon_Group->tempbuff);
		FREEMEMORY(g_pReaction_Icon_Group);
	}
}
///
//------------------------------------------------------------------------------------------------
///070913
int InitGlobalObject()
{
	Uint8 bSuccess = FALSE;
	int fd;

	///071011 O_RTC								
	if ((fd = open("/dev/rtc", O_RDWR)) >= 0)
	{
		isRTCWorking = TRUE;
		close(fd);
	}
	///
	
	for (;;)
	{
		if (InitFont() != ERRORCODE_SUCCESS) break;
															DMSG("InitFont() ok!");
#ifdef USE_DESC_TV
 		if (InitReactionIcons() != ERRORCODE_SUCCESS) break;
 															DMSG("InitReactionIcons() ok!");
#endif
		bSuccess = TRUE;
		break;
	}

	if (!bSuccess) return ERRORCODE_FAIL;
	return ERRORCODE_SUCCESS;
}
void FreeGlobalObject()
{
#ifdef USE_DESC_TV
	FreeReactionIcons();
#endif
	CloseFont();
}

#ifdef SUPPORT_RSS
/*rywu20080707 
//rywu20080516 added to function as semaphore
void rss_mutex_on(unsigned char *token)
{
    while (*token) 
    {
        usleep(10000);
    }
    *token = 1;
}

//rywu20080516 added to function as semaphore
void rss_mutex_off(unsigned char *token)
{
    *token = 0;
}
*/
//rywu20080516 added
void extra_info_init()
{
	//allocate memory
	//rywu20080616 extra_control = (EXTRA_CONTROL_ID)malloc(EXTRA_CONTROL_SIZE);
    memset((char *)extra_control, 0x00, EXTRA_CONTROL_SIZE);
    
    //DBG_MSG("<skydemo> extra_info_init memory size = %d\n", EXTRA_CONTROL_SIZE);
    
    //initialize related parameters
    extra_control->ignore_io = 0;
    extra_control->net_device_mounted = 0;
    extra_control->link_status = 0;
    extra_control->link_status_changed = 0;
    /*DBG_MSG("<skydemo> init value = %d, %d, %d, %d\n", 
            extra_control->ignore_io,
            extra_control->net_device_mounted,
            extra_control->link_status,
            extra_control->link_status_changed);*/
            
    extra_control->from_rss_recover = 0;//rywu20080616
    extra_control->last_rss_display_mode = THUMBNAIL_MODE;//rywu20080616
}

//rywu20080516 added
void extra_info_close()
{
	//free memory
	//rywu20080616 free(extra_control);
}

//rywu20080616 added
int rss_recover(EXTRA_CONTROL_ID extra_control)
{
    FILE *fp;
    char buf[80];
    char web_site[32];
    char channel_file[64];
    char main_path[32];
    char sub_path[32];
    char recycle[4];
    char display_mode[4];
    int len;
    int insurance = 0;
    char *target;
    
    //rywu20080715++
    DIR *dir;
    struct dirent *ptr;
    int i;
    //rywu20080715--
    
    DBG_MSG("<skydemo> rss_recover -->\n");
    
    fp = fopen("/tmp/conf/rss_recover", "r");
    if(fp == 0) 
    {
        DBG_MSG("<skydemo> rss_recover(0) <--\n");
        return 0;
    }
    else
    {
        //search configuration
        while(!feof(fp))
        {
            if (fgets(buf, 80, fp) == NULL)
            {
                DBG_MSG("<skydemo> rss_recover(0.1) <--\n");
                break;
            }
            //len = strlen(buf);
            
            if ((target = strstr(buf, "WEB_SITE=")) != NULL)
            {
                sprintf(web_site, "%s", target+9);
                len = strlen(web_site);
                web_site[len-1] = '\0';//skip "\n"
                DBG_MSG("<skydemo>     web_site(%d) = %s\n", len-1, web_site);
                insurance++;
            }
            else if ((target = strstr(buf, "RSS_FEED=")) != NULL)
            {
                sprintf(channel_file, "%s", target+9);
                len = strlen(channel_file);
                channel_file[len-1] = '\0';//skip "\n"
                DBG_MSG("<skydemo>     channel_file(%d) = %s\n", len-1, channel_file);
                insurance++;
            }
            else if ((target = strstr(buf, "MAIN_PATH=")) != NULL)
            {
                sprintf(main_path, "%s", target+10);
                len = strlen(main_path);
                main_path[len-1] = '\0';//skip "\n"
                DBG_MSG("<skydemo>     main_path(%d) = %s\n", len-1, main_path);
                insurance++;
            }
            else if ((target = strstr(buf, "SUB_PATH=")) != NULL)
            {
                sprintf(sub_path, "%s", target+9);
                len = strlen(sub_path);
                sub_path[len-1] = '\0';//skip "\n"
                DBG_MSG("<skydemo>     sub_path(%d) = %s\n", len-1, sub_path);
                insurance++;
            }
            else if ((target = strstr(buf, "RECYCLE_MODE=")) != NULL)
            {
                sprintf(recycle, "%s", target+13);
                len = strlen(recycle);
                recycle[len-1] = '\0';//skip "\n"
                DBG_MSG("<skydemo>     recycle(%d) = %s\n", len-1, recycle);
                insurance++;
            }
            //rywu20080616++
            else if ((target = strstr(buf, "DISPLAY_MODE=")) != NULL)
            {
                sprintf(display_mode, "%s", target+13);
                len = strlen(display_mode);
                display_mode[len-1] = '\0';//skip "\n"
                DBG_MSG("<skydemo>     display_mode(%d) = %s\n", len-1, display_mode);
                insurance++;
            }
            //rywu20080616--
            else
            {
                DBG_MSG("<skydemo>     unknown config = %s\n", buf);
}
        }
        fclose(fp);
        
        //if configuration is not enough, then quit.
        if (insurance < 5)
        {
            DBG_MSG("<skydemo>     unmatched items = %d\n", insurance);
            DBG_MSG("<skydemo> rss_recover(1) <--\n");
            return 0;
        }
        
        //only FrameChannel needs recovery.
        DBG_MSG("<skydemo>    %d(%s) vs %d(%s)\n", strlen(web_site), web_site, strlen(DEVICE_RSS_FRAME_CHANNEL_NAME), DEVICE_RSS_FRAME_CHANNEL_NAME);
        /*rywu20080616
        if (strcmp(web_site, DEVICE_RSS_FRAME_CHANNEL_NAME))
        {
            DBG_MSG("<skydemo> rss_recover(2) <--\n");
            return 0;
        }
        */
        
        //rywu20080715++
        //if no files existing within download folder, then return to main page.
        sprintf(buf, "%s%s", main_path, sub_path);
        i = 0;
        dir = opendir(buf);
        if (dir==NULL)
        {
            DBG_MSG("<skydemo>    target folder not existing\n");
    	    return 0;
        }
        else
        {
            while((ptr=readdir(dir))!=NULL)
            {
                i++;
                if (i>2)
                {
                   break; 
                }
            }
            closedir(dir);
        }
        if (i < 3)
        {
            DBG_MSG("<skydemo>    no files in download folder.\n");
            return 0;
        }
        //rywu20080715--
        
        //kill all previous process
        system("killall sky_rss");
        system("killall curl");
        system("killall skyview");
        system("killall tr");
        system("sync;sync");//rywu20080624
    
	    //initialize related parameters
        extra_control->ignore_io = 1;
        extra_control->net_device_mounted = 0;
        extra_control->link_status = 0;
        extra_control->link_status_changed = 0;
        
        //create network thread
        pthread_create(&(extra_control->network_thread), NULL, (void *)(&network_thread), extra_control);
    
        //assign device name
        if(!strcmp(web_site, DEVICE_RSS_NAME))
        {   
            SelectedDev = DEVICE_RSS_NAME;
        }
        else if (!strcmp(web_site, DEVICE_RSS_FRAME_CHANNEL_NAME))
        {
            SelectedDev = DEVICE_RSS_FRAME_CHANNEL_NAME;
        }
        else if(!strcmp(web_site, DEVICE_RSS_PICASA_NAME))
        {   
            SelectedDev = DEVICE_RSS_PICASA_NAME;
        }
    
        //fork sky_rss
        pid_rss = fork();
        switch(pid_rss)
        {
            case -1:
                perror("pid_rss fork failed!");
                DBG_MSG("<skydemo> rss_recover(3) <--\n");
                system("touch /tmp/rss_recover_fail");
                return 0;
            
            case 0:
                sleep(2);
                DBG_MSG("<skydemo>    call RSS in rss_recover\n");
                execl("/sky/sky_rss", "sky_rss", "-f", channel_file, "-d", main_path, "-s", sub_path, "-r", recycle, NULL);
                _EXIT;
                
            default:
                extra_control->from_rss_recover = 1;//rywu20080616
                extra_control->last_rss_display_mode = atoi(display_mode);//rywu20080616
                active_index = RSS_ACTIVE;
                ELMachines[active_index].Init();
                ELMachines[active_index].Display();
                break;
        }
        DBG_MSG("<skydemo> rss_recover <--\n");
        return 1;
    }
}//end rss_recover()

#endif //end #ifdef SUPPORT_RSS

///
//------------------------------------------------------------------------------------------------
int main(int argc, char *argv[])
{
#ifdef FAKEPOWER
	//get current LED to check sw power on/off
	isPowerOn = GetLEDOnOff();
	SetLEDOnOff();
#endif
	
	//-- Flowbee 2008-04-10
	unsigned long origDM, origOX, origOY, currDM, currOX, currOY, currIF;
	
	MSG("Starting Skydemo Reference Design...by Skymedi\n");
#ifdef LEADTEK
	if (calltest_check_key_to_startup()){
		printf("----call_skytest enter test mode---\n");
		call_skytest();
		printf("...........system halt.......\n");
		sleep(100000);
		return;
	}
#endif

	// change skydemo priority
#if 0
	SkyPrio = getpriority(PRIO_PROCESS, 0);
  	setpriority(PRIO_PROCESS, 0, SkyPrio + 10);
#endif

	//usleep(1);PRINTF("\n******");system("/bin/date");usleep(1);//TODO: for RTC booting time test

	Uint8 bSuccess = FALSE;

#ifdef SUPPORT_RSS
    //erase structure content initially
    memset((char *)rss_session, 0x00, RSS_SESSION_INFO_SIZE);//rywu20080709
    
    extra_info_init();//rywu20080516
#endif

	for (;;)
	{
		if (pgu_open_fb() != ERRORCODE_SUCCESS) break;
															DMSG("pgu_open_fb() ok!");

		//-- Flowbee 2008-02-22 battery detect.
		pgu_open_uart2();
		//-- Flowbee 2008-02-19 terawins osd.
		#if USE_TERAWINS_TCON
		init_terawins_osd();
		#endif
#ifdef TV_SWITCH_MOD
  #if !defined(KINGSTON)
		if (EnableTVSwitch() != ERRORCODE_SUCCESS) break;
															DMSG("EnableTVSwitch() ok!");

		TVIF = MonitorTVSwitch();
  #else
  		//if (EnableTVSwitch() != ERRORCODE_SUCCESS) break;
															DMSG("EnableSoftwareTVSwitch() ok!");
		
		TVIF = LoadTVOutputMode();
  #endif

#if 1	//-- Flowbee 2008-04-10

		pgu_get_default_yuv_resolution(&currOX, &currOY);
		currDM = GetDisplayIndex();
		currIF = pgu_get_tv_interface();
		
		if(TVIF == CVBS_PAL)
		{
  			if( (currDM != DISP_PAL) || (currIF != SKY_TV_CVBS_SVIDEO) ){
				pgu_set_tv_interface(SKY_TV_CVBS_SVIDEO);
				SetDisplayPAL(isPowerOn);//720x576
			}
			else{
				pgu_reset_buf_resolution(currOX, currOY);
			}
			tvDispMode = DISP_PAL;
		}
		else if(TVIF == CVBS)
		{
  			if( (currDM != DISP_NTSC) || (currIF != SKY_TV_CVBS_SVIDEO) ){
				pgu_set_tv_interface(SKY_TV_CVBS_SVIDEO);
				SetDisplayNTSC(isPowerOn);//720x480
			}
			else{
				pgu_reset_buf_resolution(currOX, currOY);
			}
  			tvDispMode = DISP_NTSC;
		}
		else if(TVIF == YPbPr)
		{
 			if(currDM != DISP_HDTV){
				pgu_set_tv_interface(SKY_TV_YPBPR);
				SetDisplayHDTV(isPowerOn);//1920x1080
			}
			else{
				pgu_reset_buf_resolution(currOX, currOY);
			}
			tvDispMode = DISP_HDTV;
		}

  #if 0
		// flowbee
		pgu_start_pgu();
		printf("\n -- 1 --\n");
		sleep(1);
		
		//check driver tv output interface and switch it
		if(tvDispMode != pgu_get_tv_interface())
		{
			printf("\n tvDispMode: %d", tvDispMode);
			pgu_set_tv_interface(tvDispMode);
		}
		
		// flowbee
		pgu_start_pgu();
		printf("\n -- 2 --\n");
		sleep(1);
  #endif

#else//-- Flowbee 2008-04-10
		if(TVIF == CVBS)
		{
  #ifdef TV_CVBS_OUTPUT_IS_576I
			SetDisplayPAL();//720x576
			tvDispMode = DISP_PAL;
  #else
			SetDisplayNTSC();//720x480
			tvDispMode = DISP_NTSC;
  #endif
		}
		else if(TVIF == YPbPr)
		{
			SetDisplayHDTV();//1920x1080
			tvDispMode = DISP_HDTV;
		}
		
		//check driver tv output interface and switch it
		if(tvDispMode != pgu_get_tv_interface())
		{
			pgu_set_tv_interface(tvDispMode);
		}
#endif
#else//not TV_SWITCH_MOD
		//bk @ 071109
		//bug: Display error when skydemo respawn (mantis 333)
		//cause: If skydemo is crashed (ex: pan drive in/out) at playing video status (the resolution was changed at this time),
		//		the resolution is not switched back and skydemo is respawn, this bug will happen.
		//solution: when respawn, reset the dipslay mode if the resolution is not equal to orignal resolution.
		{
			//unsigned long origDM, origOX, origOY, currDM, currOX, currOY;
			pgu_get_original_disp_index(&origDM, &origOX, &origOY);
			pgu_get_yuv_resolution(&currDM, &currOX, &currOY);
			currDM = GetDisplayIndex();
			if(origDM != currDM)
			{
				pgu_set_display_index(origDM, 1);
			}
			else if(origOX != currOX || origOY != currOY)
			{
				pgu_reset_buf_resolution(origOX, origOY);
			}
		}
#endif
		//added by bk @ 071016
		//for issue - noise when slideshow (fade in/out) & inserting usb, kernel will kill skydemo
		pgu_switch_to_buffer(1);
		
		//solved clear sandglass (OSD) while the first focus is being drawn in Photo mode with USB being plugged out
		//when USB is plugged out, skydemo will reboot!!!
		//by Richard 2007/09/03
		#if USE_TERAWINS_TCON
		if (tcon_clear_all_osd_item() != ERRORCODE_SUCCESS) break;
		#endif
		//flowbee 2007-10-03
		if (pgu_enable_overlay(0) != ERRORCODE_SUCCESS) break;

		if (InitSetupMenu() != ERRORCODE_SUCCESS) break;
															DMSG("InitSetupMenu() ok!");
										
		//solved when card reader is on, then plug out USB, hostusb.switch is still equal to 1, so that rebooted system 
		//cannot find plugged-in devices except usb2pc and mount them correctly!
		//by Richard 2007/10/17
		DisableReader();

#ifdef USE_DESC_LCD
		if (ParseDescriptor(&descLCD, DESC_FILE_NAME_LCD) != ERRORCODE_SUCCESS) break;
															DMSG("ParseDescriptor() LCD ok!");
#endif

#ifdef USE_DESC_TV
	#ifdef TV_SWITCH_MOD
		if(TVIF == YPbPr)
		{
			if (ParseDescriptor(&descTV, DESC_FILE_NAME_1920X1080) != ERRORCODE_SUCCESS) break;
		}
		else if(TVIF == CVBS_PAL)
		{
			if (ParseDescriptor(&descTV, DESC_FILE_NAME_720X576) != ERRORCODE_SUCCESS) break;
		}
		else if(TVIF == CVBS)
		{
			if (ParseDescriptor(&descTV, DESC_FILE_NAME_720X480) != ERRORCODE_SUCCESS) break;
		}
	#else
		if (ParseDescriptor(&descTV, DESC_FILE_NAME_TV) != ERRORCODE_SUCCESS) break;
	#endif
															DMSG("ParseDescriptor() TV ok!");
#endif

		InitParameter();
															DMSG("InitParameter() ok!");

//		if (InitPGU() != ERRORCODE_SUCCESS) break;
//															DMSG("InitPGU() ok!");
//
		if (MapMemory() != ERRORCODE_SUCCESS) break;
															DMSG("MapMemory() ok!");

		InitEventLoopMachines();
															DMSG("InitEventLoopMachines() ok!");

#ifdef SETTING_GPIO_MUTE
		SetGPIOMute(0);
															DMSG("SetGPIOMute() ok!");
#endif

		UmountAllDevices();
															DMSG("UmountAllDevices() ok!");

		InitGlobalObject();
															DMSG("InitGlobalObject() ok!");
		InitSystem(INITSYS_CALL_BY_BOOTING);
															DMSG("InitSystem() ok!");
#ifdef LEADTEK
		calltest_startup_check_testmode();
#endif

//#ifdef FAKEPOWER
//			PowerOnOffMode();
//#endif

		ProcessSkyDemo();
															DMSG("ProcessSkyDemo() ok!");

		bSuccess = TRUE;
		break;
	}
	if (!bSuccess)
	{
		DMSG("Skydemo Paused for Debug!!");
		while (1);
	}

#ifdef SUPPORT_RSS
    extra_info_close();//rywu20080516
#endif
    
	CloseSystem();
	
	FreeGlobalObject();

#ifdef TV_SWITCH_MOD
	DisableTVSwitch();
#endif

	UnmapMemory();

	ClosePGU();

	return 0;
}
