#ifndef _SKY_DEMO_HEADER_
#define _SKY_DEMO_HEADER_

///070611
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
///

// Libs--------------------------------------------------------------------------------------------
#include "fbutil.h"
#include "skyinit.h"
#include "ir.h"
#include "types.h"
#include "FList.h"
///080212
#include "textutil.h"

//rywu20080516++
#include "list.h"
#include <pthread.h>
#include <sched.h>
//rywu20080516--

//------------------------------------------------------------------------------------------------
#define ERRORCODE_SUCCESS			0
#define ERRORCODE_FAIL				-1
#define ERRORCODE_MEMORY			-2
#define ERRORCODE_DEVICE				-3
#define ERRORCODE_FILE				-4
//------------------------------------------------------------------------------------------------
#define MT_PHOTO						0x1
#define MT_MUSIC						0x2
#define MT_VIDEO						0x4
//------------------------------------------------------------------------------------------------
#define DEVICE_SDMMC_NAME			"SDMMC"
#define DEVICE_CF_NAME				"CF"
#define DEVICE_USB_NAME				"USB"
#define DEVICE_xD_NAME				"xD"
#define DEVICE_MS_NAME				"MS"
#define DEVICE_HD_NAME				"HD"
#define DEVICE_FLASH_NAME			"FLASH"
#define DEVICE_CARD_READER_NAME	"CARD READER"
#define DEVICE_AUTOSS_NAME			"AUTOSS"
//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
#define DEVICE_BT_NAME				"BT"
#define SHM_KEY_BT					2850
#define SHM_KEY_BT_SCAN_OPUSH		2851
#define BT_DIR_SEND					1
#define BT_DIR_RECV					2
#define BT_DIR_DEL					3
#define BT_STATE_ABORT				200
#define BT_STATE_FAIL					300
#define BT_DVC_LEN					32
#define BT_DVC_MAC_LEN				18
#define BT_NUM_OF_MAX_SCAN_OPUSH	10
#endif
//------------------------------------------------------------------------------------------------
#ifdef TV_SWITCH_MOD
#define YPbPr							1 
#define CVBS							0//NTSC
#define VGA								2
#define CVBS_PAL						3
#define GET_GPIO_REG					1
#endif
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
//Robert 2007-12-30 fix buffer overflow
#define IPADDR_LEN					16
#define DEVICE_NET_NAME				"Net"

//rywu20080516++
#define DEVICE_RSS_NAME				"RSS"
#define DEVICE_RSS_FRAME_CHANNEL_NAME "RSS_FC"
#define DEVICE_RSS_PICASA_NAME "RSS_PICASA" 
//rywu20080516--

#define DEVICE_NAS_NAME				"Net Disk"
#endif
//------------------------------------------------------------------------------------------------
#ifdef IP_CAM_MOD
#define MAX_IPCAM_NUM				4
#define DEVICE_IPCAM_NAME			"IPCAM"
#endif
//------------------------------------------------------------------------------------------------
///080429
#ifdef WEB_APP_MOD
#define WEBAPP_WEATHER_NAME			"WEATHER"
#define WEBAPP_NEWS_NAME			"NEWS"
#define WEBAPP_EZPEER_NAME			"EZPEER"
#endif
///
//------------------------------------------------------------------------------------------------
#if 1
#define SET_SS_IMG_PRIO
#endif
#ifdef SET_SS_IMG_PRIO
	#define SS_IMG_PRIO_LVL			8
#endif
//------------------------------------------------------------------------------------------------
#if 1
#define SET_SS_AUD_PRIO
#endif
#ifdef SET_SS_AUD_PRIO
	#define SS_AUD_PRIO_LVL			20
#endif
//------------------------------------------------------------------------------------------------
#if 0
#define SET_SS_SKY_PRIO
#endif
#ifdef SET_SS_SKY_PRIO
	#define SS_SKY_PRIO_LVL			5
#endif
//------------------------------------------------------------------------------------------------
#if 1
#define SET_VID_PRIO
#endif
#ifdef SET_VID_PRIO
	#define VID_PRIO_LVL				20
#endif
//------------------------------------------------------------------------------------------------
#if 1
#define SET_VID_SKY_PRIO
#endif
#ifdef SET_VID_SKY_PRIO
	#define VID_SKY_PRIO_LVL			20
#endif
//------------------------------------------------------------------------------------------------
#if 1
#define SET_ONLY_AUD_PRIO
#endif
#ifdef SET_ONLY_AUD_PRIO
	#define ONLY_AUD_PRIO_LVL		15
#endif
//------------------------------------------------------------------------------------------------
#define MEMALLOC(obj, struc, n)	\
if(obj == NULL)\
{\
	if(obj != NULL)\
		free(obj);\
	if(!(obj = (struc *)malloc(n * sizeof(struc)))) \
	{\
		exit(1);\
	}\
	else\
	{\
		memset(obj, 0, n * sizeof(struc));\
	}\
}
//MSG("Failed to allocate " #obj " memory!");
//MSG("Succeeded to allocate " #obj " memory!");
#define FREEMEMORY(obj)\
if(obj != NULL)\
{\
	free(obj);\
	obj = NULL;\
}
//MSG("Succeeded to release " #obj " memory!");
#define KILL(pid)\
{\
	FILE *fp;\
	if(!(fp = fopen("/proc/forced_kill", "w")))\
	{\
		exit(1);\
	}\
	fwrite(&pid, sizeof(int), 1, fp);\
	fclose(fp);\
}
//MSG("Process" #process " is killed!");

#define NUM_EVENT_LOOP_MACHINES		26//̦h|WLoӼƥ

#define MAX_MOUNTED_DEV					8
/*
#define MACHINE_NAME(idx)	if(idx == 0)			PRINTF("DS_ACTIVE");\
								else if(idx == 1)		PRINTF("MT_ACTIVE");\
								else if(idx == 2)		PRINTF("SETUP_L1_ACTIVE");\
								else if(idx == 3)		PRINTF("SETUP_L2_ACTIVE");\
								else if(idx == 4)		PRINTF("SETUP_L3_ACTIVE");\
								else if(idx == 5)		PRINTF("I_ACTIVE");\
								else if(idx == 6)		PRINTF("FI_ACTIVE");\
								else if(idx == 7)		PRINTF("A_ACTIVE");\
								else if(idx == 8)		PRINTF("V_ACTIVE");\
								else if(idx == 9)		PRINTF("FV_ACTIVE");\
								else if(idx == 10)	PRINTF("SS_ACTIVE");\
								else if(idx == 11)	PRINTF("USB2PC_CONN_ACTIVE");\
								else if(idx == 12)	PRINTF("NO_STORAGE_ACTIVE");\
								else if(idx == 13)	PRINTF("CONFIRM_ACTIVE");\
								else if(idx == 14)	PRINTF("CAL_ACTIVE"); \
								else				PRINTF("ERROR ACTIVE!!!");
*/
//------------------------------------------------------------------------------------------------
typedef enum
{
	DS_ACTIVE = 0,
	MT_ACTIVE,
	SETUP_L1_ACTIVE,
	SETUP_L2_ACTIVE,
	SETUP_L3_ACTIVE,
	I_ACTIVE,
	FI_ACTIVE,
	A_ACTIVE,
	V_ACTIVE,
	FV_ACTIVE,
	SS_ACTIVE,
	USB2PC_CONN_ACTIVE,
	NO_STORAGE_ACTIVE,
	CONFIRM_ACTIVE,
	CAL_ACTIVE,
	FLDR_ACTIVE,
	FW_UPGRADE_ACTIVE,
#ifdef BLUETOOTH_MOD
	BT_ACTIVE,
#endif
	FLDR_FI_ACTIVE,
	FLDR_FV_ACTIVE,
#ifdef NET_MOD
	NET_DS_ACTIVE,
#ifdef SUPPORT_RSS //rywu20080526
	RSS_ACTIVE,
#endif
#ifdef IP_CAM_MOD
	IP_CAM_ACTIVE,
#endif
///080430
#ifdef WEB_APP_MOD
	WEB_APP_ACTIVE,
#endif
///
#endif
#ifdef HD_AUTOCP_MOD
	HD_AUTOCP_ACTIVE,
#endif
	SHOW_IN_PROCESS_ACTIVE,
#if defined(GUI_STYLE_COMTEK)
	PROG_DOWNLOAD_ACTIVE,
#endif
}ACTIVE_MACHINE_INDEX;


//------------------------------------------------------------------------------------------------
typedef enum
{
	INITSYS_CALL_BY_NORMAL,
	INITSYS_CALL_BY_BOOTING
}INITSYS_CALL_T;
//------------------------------------------------------------------------------------------------
enum {PlayableMusic = 3,  PlayableVideo = 2};
enum {photo = 0, music, video, calendar, folder, setupmenu};
enum {eth0 = 1, rausb0 = 2};
//------------------------------------------------------------------------------------------------
typedef struct
{
	Uint8 hd;
	Uint8 cf;
	Uint8 sdmmc;
	Uint8 xdsm;
	Uint8 msx;
	Uint8 usb;
	Uint8 usb2pconn;
	Uint8 flash;
	Uint8 bluetooth;
	Uint8 net;
	//Uint8 rss;
	Uint8 nas;
	//Uint8 ipcam;
}DEVICE_FLAG;
//------------------------------------------------------------------------------------------------
typedef struct _LIST
{
	char fname[LEN_XL];
	struct _LIST *prev;
	struct _LIST *next;
}LIST;
//------------------------------------------------------------------------------------------------
typedef struct
{	
	// ICON info
	char *fname;
	Uint8 *iconbuff;
	COORD icoord;
	COORD txtcoord;
}ICON;
//------------------------------------------------------------------------------------------------
///071011
typedef struct
{
	int total_item;
	void *pvalue;
	int index[32];
    ///071204
    Uint32 status[32];  //OYO_Q,ΨLݩ
    /// 
	int curr_item;
    ///071128
    int head_item;
    int items_per_page;
    char **item_array;
    char *title;
    ///
}ITEM_DATA;		//ΨӬ
///
//------------------------------------------------------------------------------------------------
typedef struct
{
	// FRAME background info
	char *fname;
	Uint8 *bkgrdbuff;
	Uint8 *rgbtemplate;
	Uint8 *osdbuff;
	Uint8 *volumebuff;
	COORD framecoord;
	char *frametextmsg;
	COORD frametextmsgcoord;
	// ICON info about the frame
	Uint32 num_icon;//numbers of icons per frame
	ICON *icon_arr;
	int active_icon_index;
	int active_frame_index;
	LIST *CurrImgListPos, *CurrAudListPos, *CurrVidListPos;
	///071011 ITEM_DATA
	ITEM_DATA item_data;
	///
}FRAME;
//------------------------------------------------------------------------------------------------
typedef void (*pfEvent)();
//------------------------------------------------------------------------------------------------
typedef struct _IR_SCANKEY_EVENTS
{
	Uint8 ir_scan_key;
	pfEvent ir_scan_key_evt;
	struct _IR_SCANKEY_EVENTS *next;
}IR_SCANKEY_EVENTS;
//------------------------------------------------------------------------------------------------
typedef struct
{
	FRAME frame;
	Uint8 num_ir_evt;
	IR_SCANKEY_EVENTS *hTable[MAX_NUM_IR_EVENTS];
	void (*Init)();
	void (*Display)();
	void (*Shutdown)(Uint8);
}EVENT_LOOP_MACHINE;
//------------------------------------------------------------------------------------------------
///070913 Reaction Icon Structure
typedef struct _REACTION_ICON
{
	COORD icoord;
	Uint8 *iconbuff;
	Uint8 *pY, *pU, *pV;
}REACTION_ICON;
///
///071022 Reaction Icon Corresponding Table Structure
typedef struct _REACTION_ICON_GROUP
{
	REACTION_ICON** KeyIconTable;
	REACTION_ICON** Icon;
	Uint8 *tempbuff;
}REACTION_ICON_GROUP;
//------------------------------------------------------------------------------------------------
typedef struct
{
	//dev_t st_dev;
	char path[LEN_XL];
	char filename[LEN_XL];
	ino_t st_ino;
	time_t st_mtime;
	off_t st_size;
}SUB_STAT;
//------------------------------------------------------------------------------------------------
typedef struct _STAT_LIST
{
	SUB_STAT SubStat;
	struct _STAT_LIST *prev;
	struct _STAT_LIST *next;
}STAT_LIST;
//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
typedef struct
{
	int dir;
	int status;
	unsigned long sn;
	char name[LEN_XL];
} shm_bt;//bt action
//------------------------------------------------------------------------------------------------
typedef struct// opush_service
{
	char name[BT_DVC_LEN];
	char addr[BT_DVC_MAC_LEN];
	int channel;
}__attribute__ ((packed)) opush_service;
//------------------------------------------------------------------------------------------------
typedef struct
{
	int complete;
	int num;
	opush_service push_service[BT_NUM_OF_MAX_SCAN_OPUSH];
}shm_bt_opush;//opush device
#endif
//------------------------------------------------------------------------------------------------
#ifdef SUPPORT_RSS

//rywu20080516++
#define IPC_INIT                    0x00  //l
#define IPC_DOWNLOAD_START          0x01   //}lU
#define IPC_DOWNLOAD_ONE_FILE_OK    0x02   //U@ɮOK
#define IPC_DOWNLOAD_COMPLETE       0x03   //`/ϥΪ̫}
#define IPC_RESET_RSS_SESSION       0x04    //rss session is reseting //rywu20080528
#define IPC_CONFIG_FILE_BROKEN      0x05   //WD]wɷl
#define IPC_NO_UPDATE               0x06   //SsӤiѤU
#define IPC_MEMORY_NOT_ENOUGH       0x07   //OХdeq
#define IPC_FILE_WRITE_FAIL         0x08   //OХdLkgJ
#define IPC_RETRIEVE_FEED_INFORMATION 0x09 //retrieve rss feed information

#define IPC_NO_SUBSCRIBED_CHANNEL   0x0a   //Sq\WD
#define IPC_NETWORK_UNAVAILABLE     0x0b   //Lks network link off
#define IPC_CHANNEL_UNREADABLE      0x0c   //LkŪYWD==>RSS Reader|۰ʵ
#define IPC_RSS_RUNNING             0x0d    //rss is running
#define IPC_NETWORK_AVAILABLE 	    0x0e	//network link on
#define IPC_SHUTDOWN		 	    0x0f	//shutdown rss client
#define IPC_INVALID_ARGUMENT        0x10   //Ѽƿ~

#define IPC_CANNOT_RESOLVE_HOST     0x20    //can't resolve host
#define IPC_RX_TIMEOUT              0x21    //rx time-out
#define IPC_UNKNOWN_ERROR           0xff

#define DOWNLOAD_DIR_LENGTH 128
#define MAX_FILE_NAME_LENGTH 64
typedef struct
{
    unsigned char own;
	unsigned char type;
    unsigned char web_site; //taget web site
    unsigned char duration; 
    int rest_frame_count; //rest frame of not downloading yet
    char file_dir[DOWNLOAD_DIR_LENGTH];
    char file_name[MAX_FILE_NAME_LENGTH];
    unsigned int magic_number;//rywu20080616
}RSS_DATA, *RSS_DATA_ID;
#define RSS_DATA_SIZE sizeof(RSS_DATA)

//rywu20080616++
typedef struct
{
    long int msg_type;
    unsigned char data[RSS_DATA_SIZE];
}MSG_DATA, *MSG_DATA_ID;
#define MSG_DATA_SIZE sizeof(MSG_DATA)
//rywu20080616--

#define	THUMBNAIL_MODE	0x00
#define	FULL_IMAGE_MODE	0x01
#define	SLIDE_SHOW_MODE	0x02

#define INITIAL_UPDATE	0x00
#define PARTIAL_UPDATE	0x01
#define TOTALLY_UPDATE	0x02

#define WEB_UNKNOWN             0x00
#define WEB_FLICKR              0x01
#define WEB_PICASA              0x02
#define WEB_FACEBOOK            0x03
#define WEB_FRAMECHANNEL        0x04

#define RSS_FLICKR_CONFIG_FILE  "/tmp/conf/flickr_channels.xml" //"/mnt/sknand/flickr_channels.xml"
#define RSS_PICASA_CONFIG_FILE  "/tmp/conf/picasa_channels.xml" //"/mnt/sknand/picasa_channels.xml"
#define RSS_FRAME_CHANNEL_CONFIG_FILE   "/tmp/conf/fc_channels.xml" //"/mnt/sknand/fc_channels.xml"
#define MAIN_DOWNLOAD_PATH   "/mnt/sknand"
#define FRAME_CHANNEL_SUB_DOWNLOAD_PATH   "/frame_channel"//rywu20080715
#define RECYCLE_MODE_AS_WILL    "0"
#define RECYCLE_MODE_NONE       "1"
#define RECYCLE_MODE_ERASE_ALL_FILE "2"

typedef struct
{
    char file_dir[DOWNLOAD_DIR_LENGTH];
	int total_file_amount;
	int focus_image_no;         //number value starts from 0
	int last_handled_image_no;  //number value starts from 0
	unsigned char current_state;
    unsigned char display_mode;
	unsigned char image_update_mode;
    unsigned char is_draw_outline;
    unsigned char web_provider;

    unsigned char *file_list_addr;
    LIST_CONTAINER	image_free_list;
    LIST_CONTAINER	image_on_use_list;

    int framechannel_thread_state;
    pthread_t framechannel_thread;
    void *framechannel_thread_result;
    
    //rywu20080616++
    int rss_signal_thread_state;
    pthread_t rss_signal_thread;
    void *rss_signal_thread_result;
    
    unsigned char is_sky_rss_running;
    unsigned char skip_draw_message;
    unsigned char is_run_slide_show;
    unsigned char last_display_mode;
    
    int tx_msg_id;
    int rx_msg_id;
    //rywu20080707 unsigned char act_lock;
    int rest_frame_count;
    //rywu20080616--
    
    unsigned char inform_rss_link_status;
    unsigned char rss_link_status;
    
    //rywu20080709++
    unsigned char is_rss_struct_ready;
    int slideshow_time_tag;
    int message_time_tag;
    //rywu20080709--
    
}RSS_SESSION_INFO, *RSS_SESSION_INFO_ID;
#define RSS_SESSION_INFO_SIZE sizeof(RSS_SESSION_INFO)

#define MAX_RSS_FILE_QTY    512//max allowed file amount
typedef struct _rss_image_info_
{
	LIST_ENTRY  link;
	char file_name[MAX_FILE_NAME_LENGTH];
    unsigned char duration;//second
}RSS_IMAGE_INFO, *RSS_IMAGE_INFO_ID;
#define RSS_IMAGE_INFO_SIZE sizeof(RSS_IMAGE_INFO)
/*rywu20080707
void rss_mutex_on(unsigned char *token);
void rss_mutex_off(unsigned char *token);
*/
void extra_info_init();
void extra_info_close();
#endif //end #ifdef SUPPORT_RSS

#define NO_NETWORK_DEVICE		0x00
#define NETWORK_DEVICE_LAN		0x01    //bit 0
#define NETWORK_DEVICE_WIRELESS	0x02    //bit 1
#define NETWORK_DEVICE_ADSL_MODEM 0x04  //rywu20080529 bit 2

#define LINK_STATUS_DOWN	0x00
#define LINK_STATUS_ACTIVE	0x01
typedef struct _my_control_
{
    unsigned char ignore_io;
    
    int network_thread_state;
    pthread_t network_thread;
    void *network_thread_result;
    
	unsigned char net_device_mounted;
    unsigned char link_status;
    unsigned char link_status_changed;
    unsigned char from_rss_recover;//rywu20080616
    unsigned char last_rss_display_mode;//rywu20080616
    
}EXTRA_CONTROL, *EXTRA_CONTROL_ID;
#define EXTRA_CONTROL_SIZE sizeof(EXTRA_CONTROL)

#ifdef SUPPORT_RSS
void network_thread(EXTRA_CONTROL_ID extra_control);//rywu20080616
int rss_recover(EXTRA_CONTROL_ID extra_control);//rywu20080616
#endif

#define     LINK_ERROR          -1
#define     LINK_DONE           0
#define     LINK_ETH_FAIL       1
#define     LINK_RALINK_FAIL    1
#define     LINK_ZYDAS_FAIL     2
//rywu20080516--

//nelly add 6/23/2008 for wps push button 
#define		NET_UNKNOWN				0
#define		ETH_GENERAL				1
#define		RALINK_WIRELESS		2
#define		ZYDAS_WIRELESS		3

//------------------------------------------------------------------------------------------------
#ifdef IP_CAM_MOD
typedef struct
{
	char IP[LEN_L];
	char ID[LEN_L];
	char PW[LEN_L];
	COORD POS;
}IPCAM_DATA;
#endif
//------------------------------------------------------------------------------------------------
// Function prototype--------------------------------------------------------------------------------
void IRScanKeyEventHandler(Uint8 irscankey);
void InitList(Uint8 type);
void FreeList(Uint8 type);
void CloseSystem();
void ProcessSkyDemo();
void StartActiveMachine(Uint8 active);
void SearchFileByDevice(Uint8 type, Uint8 dev);
void InitSystem(INITSYS_CALL_T IsPoweron);
void InitEventLoopMachines();
void InitDisplayParameter(Uint8 displayMode);
void InitParameter();
///070609 }һPr
int InitFont();
void CloseFont();
///
///070913 F|BrΨL쪫
int InitGlobalObject();
void FreeGlobalObject();
int InitReactionIcons();
void FreeReactionIcons();
///
//------------------------------------------------------------------------------------------------
extern int SkyPrio;
extern Uint8 prev_active_index;
extern Uint8 active_index;
extern EVENT_LOOP_MACHINE ELMachines[NUM_EVENT_LOOP_MACHINES];

extern Uint32 ICON_NUM_PER_FRAME, ICON_NUM_PER_ROW, MUSIC_BAR_NUM, ICON_WIDTH, ICON_HEIGHT;

extern DEVICE_FLAG dev_mnted_enbled_flags;
extern DEVICE_FLAG 	dev_pre_mnted_enbled_flags;
extern Uint8 num_mounted_dev, num_enabled_dev;

extern Uint8 origDisplayMode, currFIDspMode;

extern SLint32 CurrPhotoIdx4SSCal;//The index of the photo for starting slideshow, by Richard @ 2007/10/18

extern char *IconTxtArr4DS[LEN_M];
extern char *SelectedDev;
extern char *ICONText4MT[LEN_M];
extern char *SelectedMT;

extern Uint8 volume;
///071023 Reaction Icon Group
extern REACTION_ICON_GROUP *g_pReaction_Icon_Group;

///070606 FolderView
extern FLIST *FolderList;
extern Uint8 FOLDER_BAR_NUM;

//for sorting
extern STAT_LIST *SubStatList;
extern ULint32 ListNum;

extern pid_t pid_img, pid_aud, pid_vid, pid_tr;
extern int sts_img, sts_aud, sts_vid, sts_tr;
extern LIST *ImageList, *AudioList, *VideoList;
extern Uint32 ImgCount, AudCount, VidCount;

extern pid_t pid_fldr_aud, pid_fldr_vid;
extern int sts_fldr_aud, sts_fldr_vid;
#ifdef BATTERY_MOD
extern int BatteryVal;
#endif
//**********
// Global Flags
//**********
extern Uint8 isSSImgPrcsForked, isSSAudPrcsForked, isSSTrPrcsForked, isVidPrcsForked, isOnlyAudPrcsForked;
extern Uint8 isSetupPressed, isInfoPressed, isCalPressed, isUSetupNeededSaving, isAutoPwrSttngChngd;
extern Uint8 isMutePressed, isVolumePressed, isUserConfirmed;
extern Uint8 isVideoPaused, isVideoPausedBySetup;//, isPreKeyRotate;
extern Uint8 isDebugMode;
extern Sint8 isCalAlarmRinging;//-1: today is not playable; 0: today is playable, but now is not palying; 1: now is playing
///071011 RTCsb
extern Uint8 isRTCWorking;
///070610 rFlag
extern Uint8 isLanguageChanged;
///070625 ﭵ֭ƼҦ
extern Uint8 isAudioRepeatModeChanged;
extern Uint8 isSortingMethodChanged;
extern Uint8 isFlashFormatted;
extern Uint8 isFlashMusicUsed;//When selected storage has no music in SS, using music in flash. By Richard @ 2007/10/08
extern Uint8 isFolderListUpdate;
extern Uint8 isFldrVidPrcsForked, isFldrAudPrcsForked;
extern Uint8 isCoverOn; // for Leadtek cover detector, by Xenia 02/2008
extern Uint8 isExitPressed; // for WINGUI, by Xenia 2008/06/10

#ifdef BLUETOOTH_MOD
extern int shm_bt_id, shm_btop_id;
extern pid_t pid_bt_sdpd, pid_bt_hcid, pid_bt_sobexsrv, pid_bt_orz;
extern int sts_orz;
extern Uint8 isBTPrcsForked, isBTPrcssBusy, isBTScanningOPush;
extern ULint32 BTActNum;
//070927 - bt, copy from folder
extern shm_bt *smbt;
extern shm_bt_opush *smbtop;
extern int currBTDvcIdx;
extern Uint8 BT_DVC_BAR_NUM;
#endif

#ifdef NET_MOD
extern Uint32 isSocketCreated;

//rywu20080516++
extern pid_t pid_rss;
extern int sts_rss;

#ifdef SUPPORT_RSS
extern RSS_SESSION_INFO_ID rss_session;
extern EXTRA_CONTROL_ID extra_control;
extern pthread_mutex_t act_lock;//rywu20080707
#endif
//rywu20080516--

#endif

#ifdef USE_DESC_TV
extern Uint8 isCardReaderOn;
extern Uint8 hasEnteredCardReaderMode;
#endif

#ifdef TV_SWITCH_MOD
extern Uint32 TVIF;
#endif

#ifdef HD_AUTOCP_MOD
extern pid_t pid_hd_cp;
extern int sts_hd_cp;
extern Sint32 userSelection, StsOfCpData2HD;//-1: copy finished; 0: not copy; 1: copying
extern long sizeOfCard, freeSizeOfHD;//unit: KB
extern char *inDvcName, *inDvcPath;
extern COORD updateRegion;
#endif

#ifdef IP_CAM_MOD
extern Uint8 isIPCamFullView;
extern Uint8 isUrlPlayForked;
extern pid_t pid_url_play;
extern int sts_url_play;
extern int nIPCamSelected;
#endif

#ifdef FAKEPOWER
extern int isPowerOn;
#endif

#if defined(GUI_STYLE_COMTEK)
extern Uint8 isCalSaveSetupFlag; //0:Don't work, 1:Working, 2:OK
#endif

#endif
