/********************************************************************
	created:	2008/04/18
	filename: 	skyform.h
	file base:	skyform
	file ext:	h
	author:		
	purpose:	إߪ浲c
*********************************************************************/

#ifndef _SKY_FORM_H_
#define _SKY_FORM_H_

#include <stdio.h>
#include "types.h"
#include "skydemo.h"

#ifndef _BYTE_WORD_
#define _BYTE_WORD_
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

//--------------------------------------------------//
//		SKYBUFFER iܰʦȦsŶ					//
//--------------------------------------------------//
#define SKYBUFFER_BASE_DEFAULT_SIZE 1024

typedef struct _STRUCT_SKY_BUFFER_BASE_BLOCK_
{
	DWORD pos;
	DWORD size;
	struct _STRUCT_SKY_BUFFER_BASE_BLOCK_ *next;
	BYTE *base;
}SKYBUFFER_BASE_BLOCK;

typedef struct
{
	DWORD BlockSize;
	SKYBUFFER_BASE_BLOCK *pHeadBlock;
	SKYBUFFER_BASE_BLOCK *pCurrBlock;
}SKYBUFFER;

//sysbuffer
SKYBUFFER* SB_Open(DWORD BlockSize);

//buffer(PSB_Open۹)
void SB_Close(SKYBUFFER **ppBuf);

//bbuffertmsŶ
BYTE* SB_Alloc(SKYBUFFER *pBuf, DWORD size);

//bufferҦblock
void SB_Free(SKYBUFFER *pBuf);

//bbuffertm@sr
char* SB_String(SKYBUFFER *pBuf, char *src);
char* SB_nString(SKYBUFFER *pBuf, char *src, DWORD nChar);

//--------------------------------------------------//
//		SKYFORM xΪ浲c						//
//--------------------------------------------------//
#define SKYFORM_TAG_IGNORE		0		//#
#define SKYFORM_TAG_DATATYPE	1		//[D]
#define SKYFORM_TAG_CODING		2		//[C]
#define SKYFORM_TAG_SUBJECT		3		//[S]
#define SKYFORM_TAG_KEY			4		//[K]
#define SKYFORM_TAG_TABLE		5		//[T]
#define SKYFORM_TAG_FIELD		6		//[F]
#define SKYFORM_TAG_ITEM		7		//[I]
#define SKYFORM_TAG_VALUE		8		//[V]

#define SKYFORM_TAG_MAX_LINE_LEN 1024	//C̤jr

//ValueƭȮ榡
#define SKYFORM_FORMAT_UNKNOWN	0x0000	//w
#define SKYFORM_FORMAT_STRING	0x0001	//r
#define SKYFORM_FORMAT_FILENAME	0x0002	//ɦW
#define SKYFORM_FORMAT_PATH		0x0004	//Wsθ|
#define SKYFORM_FORMAT_NUMBER	0x0010	//Ʀr
#define SKYFORM_FORMAT_IMAGE	0x0100	//Ϥ

//xs椺ec
typedef struct _STRUCT_SKY_FORM_VALUE_
{
	WORD format;					//ƭȮ榡(rBϤBnBv)
	BYTE *data;						//Vƭȸ
	struct _STRUCT_SKY_FORM_VALUE_ *prev;	//W@
	struct _STRUCT_SKY_FORM_VALUE_ *next;	//U@
}SKYFORM_VALUE;

//浲c
typedef struct _STRUCT_SKY_FORM_TABLE_
{
	WORD nField;			//ƶq
	WORD nItem;				//Ƶ
	char *Name;				//W
	char **Field;			//r
	SKYFORM_VALUE ***Value;	//ƭȪ(G)
	//char ***Value;			//ƭȦr(G)
}SKYFORM_TABLE;

//歶Ƶc
typedef struct _STRUCT_SKY_FORM_
{
	char *DataType;			//ƫA
	char *Coding;			//sX覡
	char *Subject;			//DD
	WORD nKey;				//`
	char **Key;				//C
	WORD nTable;			//`
	SKYFORM_TABLE *Table;	//}C
	SKYBUFFER *pBuf;		//ƻPrsϰ
}SKYFORM;

//Ҥe
typedef struct _STRUCT_SKY_FORM_TAG_
{
	WORD type;				//ҫA
	WORD nIndex;			//޼ƥ 0/1/2
	WORD index[2];			//ޭ(̦h2)
	char *value;			//
}SKYFORM_TAG;

//qrŪ@Ӫ
SKYFORM* SKYFORM_CreateFormFromFile(char *srcfile);

//W[@ӷs
SKYFORM* SKYFORM_CreateEmptyForm();

//
void SKYFORM_ReleaseForm(SKYFORM **ppForm);

//qrŪX@
int SKYFORM_ParseTag(FILE *fid, SKYFORM_TAG *pTag);


//--------------------------------------------------//
//		FORMVIEW ܵc						//
//--------------------------------------------------//

#define FORMVIEW_MAX_FIELDS_PER_PAGE	16
#define FORMVIEW_MAX_ROWS_PER_PAGE		32

typedef struct _STRUCT_FORM_VIEW_CELL_
{
	//FORMVIEW_FIELD_CELL	*pField;	//VY
	char *key;						//W(VSKYFORMYKey)
	SKYFORM_VALUE *value;			//ƭ
    DWORD align;					//覡
	WORD color;						//C
	WORD invisible;					//O_
	WORD scroll;					//ʦ
	struct _STRUCT_FORM_VIEW_CELL_ *prev;	//xs
	struct _STRUCT_FORM_VIEW_CELL_ *next;	//kxs
}FORMVIEW_CELL;

typedef struct _STRUCT_FORM_VIEW_ROW_
{
	WORD nCell;					//xsƥ
	FORMVIEW_CELL *cell_list;	//xsC
	WORD attribute;				//ݩ(QĿBáBsi...)
	WORD invisible;				//O_
	struct _STRUCT_FORM_VIEW_ROW_ *prev;	//W@C
	struct _STRUCT_FORM_VIEW_ROW_ *next;	//U@C
}FORMVIEW_ROW;

typedef struct _STRUCT_FORM_VIEW_
{
	SKYFORM *pForm;				//V
	FONT_DB *pFontDB;			//ܪϥΪr
	int default_use_utf;		//w]ϥutf8/16 or not
	WORD dest_rgb;				//øsت
	WORD dest_yuv;				//øsت
    SKYBUFFER *pBuf;			//xs

	//~(view)
	COORD crdView;

	//ưϰ(data rows)
	COORD crdData;

	//DDC(subjects)
	//WORD nSubject;				//DDƥ
	FORMVIEW_ROW *subject_row;	//DDC
	COORD crdSubjectRow;		//DDCy(۹~)
	COORD crdSubjectCell;		//DDxsy(۹DDC)

	//DC(fields)
	//WORD nField;				//ƥ
	FORMVIEW_ROW *field_row;	//DC
	COORD crdFieldRow;			//DCy(۹~)
	COORD crdFieldCell[FORMVIEW_MAX_FIELDS_PER_PAGE];	//Dxsy(۹DC)

	//ƶئC(data items)
	WORD nDataRow;					//ƦCƥ
	FORMVIEW_ROW *datarow_list;		//ƦCC
	COORD crdDataRow[FORMVIEW_MAX_ROWS_PER_PAGE];	//Cy(۹ưϰ)
	//COORD crdDataCell[FORMVIEW_MAX_ROWS_PER_PAGE][FORMVIEW_MAX_FIELDS_PER_PAGE];	//xsy(۹C~)
	COORD crdDataCell[FORMVIEW_MAX_FIELDS_PER_PAGE];	//xsy(۹C~)

	//ܯ
	int lead_row_index;		//ùWĤ@Cs
	int curr_row_index;		//Ϋ쪺Cs
	int curr_playing_row_index;	//b񪺦C
	WORD nRowPerLine;			//P@uWܴXC
	WORD nLinePerPage;			//@̦hܴXդu
	//FORMVIEW_ROW *pCurrRow;		//Ϋ쪺C

	//v
	WORD *bkg_layer;		//ȦseVieweUI
	ICON *icn_label;		//Dϥ

}FORMVIEW;


//إ߻PMFORMVIEW
FORMVIEW* FORMVIEW_Create(SKYFORM *pForm);
FORMVIEW* FORMVIEW_CreateEmptyView();
void FORMVIEW_Close(FORMVIEW **ppView);

//FORMVIEWs
FORMVIEW_CELL* FORMVIEW_AddField(FORMVIEW *pView, WORD doc_table_index, WORD doc_field_index);
FORMVIEW_ROW* FORMVIEW_AddDataRow(FORMVIEW *pView, WORD doc_table_index, WORD doc_item_index);
FORMVIEW_ROW* FORMVIEW_AddEmptyDataRow(FORMVIEW *pView);
FORMVIEW_CELL* FORMVIEW_AddEmptyCell(FORMVIEW *pView, FORMVIEW_ROW *pRow);

//ŪFORMVIEWxs
FORMVIEW_ROW* FORMVIEW_GetDataRow(FORMVIEW *pView, WORD row_index);
FORMVIEW_CELL* FORMVIEW_GetDataCell(FORMVIEW *pView, WORD row_index, WORD cell_index);

//FORMVIEWøs
int FORMVIEW_DrawDataCell(FORMVIEW *pView, WORD data_row_index, WORD data_cell_index, BYTE draw_yuv);
int FORMVIEW_DrawFieldRow(FORMVIEW *pView, BYTE draw_yuv);
int FORMVIEW_DrawDataRow(FORMVIEW *pView, WORD row_index, BYTE draw_yuv);
int FORMVIEW_DrawData(FORMVIEW *pView, BYTE draw_yuv);
int FORMVIEW_DataFocus_PrevLine(FORMVIEW *pView);
int FORMVIEW_DataFocus_NextLine(FORMVIEW *pView);

//Φh
int FORMVIEW_ArrangeMultiLineCell(FORMVIEW *pView, WORD row_index, WORD cell_index);

//
int FORMVIEW_DataCell_ScrollUp(FORMVIEW *pView, WORD row_index, WORD cell_index);
int FORMVIEW_DataCell_ScrollDown(FORMVIEW *pView, WORD row_index, WORD cell_index);

//Ūini

/*
int FORMVIEW_SetViewCoord(FORMVIEW *pView, COORD crd);
int FORMVIEW_SetSubjectCoord(FORMVIEW *pView, COORD crd);
int FORMVIEW_SetFieldCoord(FORMVIEW *pView, COORD crd);
int FORMVIEW_SetDataCoord(FORMVIEW *pView, COORD crd, WORD nRowPerPage);
*/

#endif	//_SKY_FORM_H_

//
//	|ССССС
//	|	DD	|								<--Subject Row
//	|ССССССССССССССССС
//	|	D 	|	D	|	D	|		<--Field Row
// 	|ССССССССССССССССС
//	|	(0,0)	|	(1,0)	|	(2,0)	|		<--[Data]------
//	|ССССССССССССССССС		|				|
//	|	(0,1)	|	(1,1)	|	(2,1)	|		|	Data Rows	|
//	|ССССССССССССССССС		|				|
//	|	(0,2)	|	(1,2)	|	(2,2)	|		<----------------
//	|ССССССССССССССССС
//
