#include "custom.h"
#include "skyinit.h"
#include "fbutil.h"

///070608
#include "skydemo.h"
///

//------------------------------------------------------------------------------------------------
#ifdef USE_DESC_LCD
DESC descLCD;
#endif
#ifdef USE_DESC_TV
DESC descTV;
#endif

DESC *desc;
Uint8 SavedUserSetupItem[NUM_OF_USER_SETUP_ITEM], volume = 5;//for initialiation, move here
SKY_SETUP *setup;
SKY_SETUP *allSetup[LANG_ITEM_NUM];
char FIRMWARE_VERSION[LEN_L], defaultRevision[LEN_L];
//------------------------------------------------------------------------------------------------
int ParseDescriptor(DESC* pDesc, char *DescFileName)
{
	Uint8 i, j, k, m, len, n, p;
	FILE *fp;
	char str[LEN_XL];
	char s[10];

	PRINTF("Parsing Description File: %s.\n", DescFileName);
	if(!(fp = fopen(DescFileName, "r")))
	{
		MSG("Failed to open Description file!\n");
		return ERRORCODE_FILE;
		//exit(1);
	}

	// Skydemo Resolution
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line

	memset(str, 0, LEN_XL);
	memset(s, 0, LEN_M);
	fgets(str, LEN_XL, fp);
	len = strlen(str);
	m = 0;
	for(i = 0; i < len; i++)
	{
		if(str[i] >= 48 && str[i] <= 57)
			s[m++] = str[i];
		else if(str[i] == 'x' || str[i] == 'X')
		{
			pDesc->XRES = atoi(s);
			memset(s, 0, LEN_M);
			m = 0;
		}
		else
			continue;
	}
	pDesc->YRES = atoi(s);
#if 0
	PRINTF("XRES = %d\n", pDesc->XRES);
	PRINTF("YRES = %d\n\n", pDesc->YRES);
#endif
	// Background Image Filename and Coordinate Array
	memset(str, 0, LEN_XL);
	memset(s, 0, LEN_M);
	fgets(str, LEN_XL, fp);//discard this comment line
	m = n = 0;
	for(i = 0; i < MAX_NUM_BKIMG; i++)
	{
		memset(str, 0, LEN_XL);
		fscanf(fp, "%s", str);
		strcpy(pDesc->bkgrdImg[i], str);
		memset(str, 0, LEN_XL);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n += 1;
				if(n == 1)
				{
					pDesc->bkgrdCoord[i].x = atoi(s);
				}
				if(n == 2)
				{
					pDesc->bkgrdCoord[i].y = atoi(s);
				}
				if(n == 3)
				{
					pDesc->bkgrdCoord[i].width = atoi(s);
				}
				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				pDesc->bkgrdCoord[i].height = atoi(s);
				memset(s, 0, LEN_M);
				m = n = 0;
			}
			else
				continue;
		}
	}
#if 0
	for(i = 0; i < MAX_NUM_BKIMG; i++)
	{
		PRINTF("bkgrdImg[%d] = %s\t", i, pDesc->bkgrdImg[i]);
		PRINTF("(%3d, %3d, %3d, %3d)\n", pDesc->bkgrdCoord[i].x, pDesc->bkgrdCoord[i].y, pDesc->bkgrdCoord[i].width, pDesc->bkgrdCoord[i].height);
	}
	PRINTF("\n");
#endif
	// DS ICON Image Filename Array => 0: Original; 1: Focused; 2:Storage;
	// DS ICON Image and Text Coordinate Array
	//[3] => 0: Original; 1: Focused; 2:Storage;
	//[13] => 0:HD; 1:CF; 2:SDMMC; 3:XDSM; 4:MS;
	// 		  5:USB; 6:USB2PCONN; 7:FLASH; 8:BLUETOOTH; 9: NET;
	// 		  10: RSS; 11: NAS; 12:IPCAM 13:WEBAPP_WEATHER 13~14: RSS
	//		  15~17:WEB
	//[2] => 0: Image; 1:Text;
	for(p = 0; p < 3; p++)
	{
		memset(str, 0, LEN_XL);
		memset(s, 0, LEN_M);
		fgets(str, LEN_XL, fp);//discard this comment line
		m = n = 0;
		for(i = 0; i < MAX_NUM_DEV; i++)
		{
			memset(str, 0, LEN_XL);
			fscanf(fp, "%s", str);
			switch(i)
			{
			case 0:
				strcpy(pDesc->HD[p], str);
				break;
			case 1:
				strcpy(pDesc->CF[p], str);
				break;
			case 2:
				strcpy(pDesc->SDMMC[p], str);
				break;
			case 3:
				strcpy(pDesc->XDSM[p], str);
				break;
			case 4:
				strcpy(pDesc->MS[p], str);
				break;
			case 5:
				strcpy(pDesc->USB[p], str);
				break;
			case 6:
				strcpy(pDesc->USB2PCONN[p], str);
				break;
			case 7:
				strcpy(pDesc->FLASH[p], str);
				break;
			case 8:
				strcpy(pDesc->BT[p], str);
				break;
			case 9:
				strcpy(pDesc->NET[p], str);
				break;
			case 10:
				strcpy(pDesc->RSS[p], str);
				break;
			case 11:
				strcpy(pDesc->NAS[p], str);
				break;
			case 12:
				strcpy(pDesc->IPCAM[p], str);
                break;
            //rywu20080516++
            case 13:
				strcpy(pDesc->rss_frame_channel[p], str);
				break;
            case 14:
				strcpy(pDesc->rss_picasa[p], str);
				break;
            //rywu20080516--
///for WEB_APP_MOD
			case 15:
				strcpy(pDesc->WEBAPP_WEATHER[p], str);
				break;
			case 16:
				strcpy(pDesc->WEBAPP_NEWS[p], str);
				break;
			case 17:
				strcpy(pDesc->WEBAPP_EZPEER[p], str);
				break;
///
			default:
				break;
			}
			memset(str, 0, LEN_XL);
			fgets(str, LEN_XL, fp);
			len = strlen(str);
			j = 0;
			for(k = 0; k < len; k++)
			{
				if(str[k] >= 48 && str[k] <= 57)
					s[m++] = str[k];
				else if(str[k] == ',')
				{
					n += 1;
					if(n == 1)
					{
						pDesc->DSCoord[p][i][j].x = atoi(s);
					}
					if(n == 2)
					{
						pDesc->DSCoord[p][i][j].y = atoi(s);
					}
					if(n == 3)
					{
						pDesc->DSCoord[p][i][j].width = atoi(s);
					}
					memset(s, 0, LEN_M);
					m = 0;
				}
				else if(str[k] == ')')
				{
					pDesc->DSCoord[p][i][j].height = atoi(s);
					memset(s, 0, LEN_M);
					m = n = 0;
					j += 1;
				}
				else
					continue;
			}
		}
	}
#if 0
	for(p = 0; p < 3; p++)
	{
		for(i = 0; i < MAX_NUM_DEV; i++)
		{
			switch(i)
			{
			case 0:
				PRINTF("HD[%d] = %s\t\t", p, pDesc->HD[p]);
				break;
			case 1:
				PRINTF("CF[%d] = %s\t\t", p, pDesc->CF[p]);
				break;
			case 2:
				PRINTF("SDMMC[%d] = %s\t", p, pDesc->SDMMC[p]);
				break;
			case 3:
				PRINTF("XDSM[%d] = %s\t\t", p, pDesc->XDSM[p]);
				break;
			case 4:
				PRINTF("MS[%d] = %s\t\t", p, pDesc->MS[p]);
				break;
			case 5:
				PRINTF("USB[%d] = %s\t", p, pDesc->USB[p]);
				break;
			case 6:
				PRINTF("USB2PCONN[%d] = %s\t", p, pDesc->USB2PCONN[p]);
				break;
			case 7:
				PRINTF("FLASH[%d] = %s\t", p, pDesc->FLASH[p]);
				break;
			case 8:
				PRINTF("BT[%d] = %s\t", p, pDesc->BT[p]);
				break;
            case 10:
                PRINTF("RSS[%d] = %s\t", p, pDesc->RSS[p]);
				break;
			case 11:
				PRINTF("NAS[%d] = %s\t", p, pDesc->NAS[p]);
				break;
			case 12:
				PRINTF("IPCAM[%d] = %s\t", p, pDesc->IPCAM[p]);
                break;
            //rywu20080516++
            case 13:
				DBG_MSG("rss_frame_channel[%d] = %s\t", p, pDesc->rss_frame_channel[p]);
				break;
            case 14:
				DBG_MSG("rss_picasa[%d] = %s\t", p, pDesc->rss_picasa[p]);
				break;
            //rywu20080516--
			}
			for(j = 0; j < 2; j++)
			{
				PRINTF("(%3d, %3d, %3d, %3d) ",
						pDesc->DSCoord[p][i][j].x,
						pDesc->DSCoord[p][i][j].y,
						pDesc->DSCoord[p][i][j].width,
						pDesc->DSCoord[p][i][j].height);
			}
			PRINTF("\n");
		}
		PRINTF("\n");
	}
#endif
	// MT ICON Image Filename Array => 0: Original; 1: Focused; 2:Not found;
	// MT ICON Image and Text Coordinate Array
	//[3] => 0: Original; 1: Focused; 2:Not found;
	//[6] => 0:PHOTO; 1:MUSIC; 2:VIDEO; 3:CALENDAR; 4:SETUPMENU; 5:FOLDER;
	//[2] => 0: Image; 1:Text;
	for(p = 0; p < 3; p++)
	{
		memset(str, 0, LEN_XL);
		memset(s, 0, LEN_M);
		fgets(str, LEN_XL, fp);//discard this comment line
		m = n = 0;
		for(i = 0; i < MAX_NUM_MTICON; i++)
		{
			memset(str, 0, LEN_XL);
			fscanf(fp, "%s", str);
			switch(i)
			{
			case 0:
				strcpy(pDesc->PHOTO[p], str);
				break;
			case 1:
				strcpy(pDesc->MUSIC[p], str);
				break;
			case 2:
				strcpy(pDesc->VIDEO[p], str);
				break;
			case 3:
				strcpy(pDesc->CALENDAR[p], str);
				break;
			case 4:
				strcpy(pDesc->SETUPMENU[p], str);
				break;
			case 5:
				strcpy(pDesc->FOLDER[p], str);
				break;
			}
			memset(str, 0, LEN_XL);
			fgets(str, LEN_XL, fp);
			len = strlen(str);
			j = 0;
			for(k = 0; k < len; k++)
			{
				if(str[k] >= 48 && str[k] <= 57)
					s[m++] = str[k];
				else if(str[k] == ',')
				{
					n += 1;
					if(n == 1)
					{
						pDesc->MTCoord[p][i][j].x = atoi(s);
					}
					if(n == 2)
					{
						pDesc->MTCoord[p][i][j].y = atoi(s);
					}
					if(n == 3)
					{
						pDesc->MTCoord[p][i][j].width = atoi(s);
					}
					memset(s, 0, LEN_M);
					m = 0;
				}
				else if(str[k] == ')')
				{
					pDesc->MTCoord[p][i][j].height = atoi(s);
					memset(s, 0, LEN_M);
					m = n = 0;
					j += 1;
				}
				else
					continue;
			}
		}
	}
#if 0
	for(p = 0; p < 3; p++)
	{
		for(i = 0; i < MAX_NUM_MTICON; i++)
		{
			switch(i)
			{
			case 0:
				PRINTF("PHOTO[%d] = %s\t", p, pDesc->PHOTO[p]);
				break;
			case 1:
				PRINTF("MUSIC[%d] = %s\t", p, pDesc->MUSIC[p]);
				break;
			case 2:
				PRINTF("VIDEO[%d] = %s\t", p, pDesc->VIDEO[p]);
				break;
			case 3:
				PRINTF("CALENDAR[%d] = %s\t", p, pDesc->CALENDAR[p]);
				break;
			case 4:
				PRINTF("SETUPMENU[%d] = %s\t", p, pDesc->SETUPMENU[p]);
				break;
			case 5:
				PRINTF("FOLDER[%d] = %s\t", p, pDesc->FOLDER[p]);
				break;
			}
			for(j = 0; j < 2; j++)
			{
				PRINTF("(%3d, %3d, %3d, %3d) ",
						pDesc->MTCoord[p][i][j].x,
						pDesc->MTCoord[p][i][j].y,
						pDesc->MTCoord[p][i][j].width,
						pDesc->MTCoord[p][i][j].height);
			}
			PRINTF("\n");
		}
		PRINTF("\n");
	}
#endif
	// Misc Image Filename and Coordinate Array
	memset(str, 0, LEN_XL);
	memset(s, 0, LEN_M);
	fgets(str, LEN_XL, fp);//discard this comment line
	m = n = 0;
	for(i = 0; i < MAX_NUM_MISC_ICON; i++)
	{
		memset(str, 0, LEN_XL);
		fscanf(fp, "%s", str);

		strcpy(pDesc->MiscICONIMG[i], str);

		memset(str, 0, LEN_XL);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n += 1;
				if(n == 1)
				{
					pDesc->MiscICONCoord[i].x = atoi(s);
				}
				if(n == 2)
				{
					pDesc->MiscICONCoord[i].y = atoi(s);
				}
				if(n == 3)
				{
					pDesc->MiscICONCoord[i].width = atoi(s);
				}
				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				pDesc->MiscICONCoord[i].height = atoi(s);

				memset(s, 0, LEN_M);
				m = n = 0;
			}
			else
				continue;
		}
	}
#if 0
	for(i = 0; i < MAX_NUM_MISC_ICON; i++)
	{
		PRINTF("MiscICONIMG[%d] = %s\t", i, pDesc->MiscICONIMG[i]);
		PRINTF("(%3d, %3d, %3d, %3d)\n", pDesc->MiscICONCoord[i].x, pDesc->MiscICONCoord[i].y, pDesc->MiscICONCoord[i].width, pDesc->MiscICONCoord[i].height);
	}
	PRINTF("\n");
#endif

	//2007/10/22 Reaction Icons
	memset(str, 0, LEN_XL);
	memset(s, 0, LEN_M);
	fgets(str, LEN_XL, fp);//discard this comment line
	m = n = 0;
	for(i = 0; i < MAX_NUM_REACTION_ICON; i++)
	{
		memset(str, 0, LEN_XL);
		fscanf(fp, "%s", str);

		strcpy(pDesc->ReactionICONIMG[i], str);

		memset(str, 0, LEN_XL);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)	//0~9
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n += 1;
				if(n == 1)
				{
					pDesc->ReactionICONCoord[i].x = atoi(s);
				}
				if(n == 2)
				{
					pDesc->ReactionICONCoord[i].y = atoi(s);
				}
				if(n == 3)
				{
					pDesc->ReactionICONCoord[i].width = atoi(s);
				}
				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				pDesc->ReactionICONCoord[i].height = atoi(s);

				memset(s, 0, LEN_M);
				m = n = 0;
				break;
			}
			else
				continue;
		}
	}

	//Font Database FileName
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	for(i = 0; i < NUM_OF_FONT_FILE; i++)
	{
		memset(str, 0, LEN_XL);
		fscanf(fp, "%s\n", str);
		strcpy(pDesc->FontFileName[i], str);
	}

	// PHOTO/VIDEO Display Matrix
	memset(pDesc->ICONWidth, 0, LEN_M);
	memset(pDesc->ICONHeight, 0, LEN_M);
	pDesc->ICONNumPerFrame = pDesc->ICONNumPerRow = 0;

	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line

	memset(str, 0, LEN_XL);
	memset(s, 0, LEN_M);
	fgets(str, LEN_XL, fp);
	len = strlen(str);
	m = 0;
	for(i = 0; i < len; i++)
	{
		if(str[i] >= 48 && str[i] <= 57)
			s[m++] = str[i];
		else if(str[i] == 'x' || str[i] == 'X')
		{
			strcpy(pDesc->ICONWidth, s);

			memset(s, 0, LEN_M);
			m = 0;
		}
		else
			continue;
	}

	strcpy(pDesc->ICONHeight, s);

#if 0
	PRINTF("ICONWidth = %s\n", pDesc->ICONWidth);
	PRINTF("ICONHeight = %s\n\n", pDesc->ICONHeight);
#endif
	memset(str, 0, LEN_XL);
	memset(s, 0, LEN_M);
	fgets(str, LEN_XL, fp);
	len = strlen(str);
	m = 0;
	for(i = 0; i < len; i++)
	{
		if(str[i] >= 48 && str[i] <= 57)
			s[m++] = str[i];
		else if(str[i] == ':')
		{
			pDesc->ICONNumPerFrame = atoi(s);

			memset(s, 0, LEN_M);
			m = 0;
		}
		else
			continue;
	}

	pDesc->ICONNumPerRow = atoi(s);
#if 0
	PRINTF("ICONNumPerFrame = %d\n", pDesc->ICONNumPerFrame);
	PRINTF("ICONNumPerRow = %d\n\n", pDesc->ICONNumPerRow);
#endif
	for(i = 0; i < NUM_OF_IV_MATRIX; i++)
	{
		pDesc->XbyYCoord[i].x = pDesc->XbyYCoord[i].y = pDesc->XbyYCoord[i].width = pDesc->XbyYCoord[i].height = 0;
	}
	//position 6 lines, 6 positions per line
	for(i = 0; i < NUM_OF_IV_MATRIX / ROW_NUM_OF_IV_MATRIX; i++)
	{
		memset(str, 0, LEN_XL);
		fgets(str, LEN_XL, fp);

		Uint8 ICONPerFrame, ICONPerRow;
		ICONPerFrame = pDesc->ICONNumPerFrame;
		ICONPerRow = pDesc->ICONNumPerRow;

		if(i < ICONPerFrame / ICONPerRow)
		{
			k = 0;
			for(j  = 0; j < ICONPerRow; j++)
			{
				char x[LEN_M], y[LEN_M];
				memset(x, '\0', LEN_M);
				memset(y, '\0', LEN_M);
				while(str[k] != '(')
					k++;
				k++;
				for(m = 0; str[k] != ','; m++, k++)
					x[m] = str[k];
				k++;
				for(m = 0; str[k] != ')'; m++, k++)
					y[m] = str[k];

				pDesc->XbyYCoord[i * ICONPerRow + j].x = atoi(x);
				pDesc->XbyYCoord[i * ICONPerRow + j].y = atoi(y);
				pDesc->XbyYCoord[i * ICONPerRow + j].width= atoi(pDesc->ICONWidth);
				pDesc->XbyYCoord[i * ICONPerRow + j].height= atoi(pDesc->ICONHeight);
			}
		}
	}
#if 0
	for(i = 0; i < NUM_OF_IV_MATRIX / ROW_NUM_OF_IV_MATRIX; i++)
	{
		for(j = 0; j < ROW_NUM_OF_IV_MATRIX; j++)
		{
			PRINTF("(%3d, %3d, %3d, %3d) ",
					pDesc->XbyYCoord[i * ROW_NUM_OF_IV_MATRIX + j].x,
					pDesc->XbyYCoord[i * ROW_NUM_OF_IV_MATRIX + j].y,
					pDesc->XbyYCoord[i * ROW_NUM_OF_IV_MATRIX + j].width,
					pDesc->XbyYCoord[i * ROW_NUM_OF_IV_MATRIX + j].height);
			if(j != 0 && !(j % ROW_NUM_OF_IV_MATRIX))
				PRINTF("\n");
		}
		PRINTF("\n");
	}
#endif
	// MUSIC BAR Display
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line

	pDesc->MusicBarNum = atoi(str);

#if 0
	PRINTF("MusicBarNum = %d\n", pDesc->MusicBarNum);
#endif
	for(i = 0; i < NUM_OF_AUDIO_LIST; i++)
	{
		pDesc->MusicBarCoord[i].x = pDesc->MusicBarCoord[i].y = pDesc->MusicBarCoord[i].width = pDesc->MusicBarCoord[i].height = 0;
		pDesc->MusicIconCoord[i].x = pDesc->MusicIconCoord[i].y = pDesc->MusicIconCoord[i].width = pDesc->MusicIconCoord[i].height = 0;
	}
	m = 0;
	for(i = 0; i < pDesc->MusicBarNum; i++)
	{
		memset(str, 0, LEN_XL);
		memset(s, 0, LEN_M);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		n = 0;
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n++;
				if (n == 1)
					pDesc->MusicIconCoord[i].x = atoi(s);
				else if (n == 2)
					pDesc->MusicIconCoord[i].y = atoi(s);
				else if (n == 3)
					pDesc->MusicIconCoord[i].width= atoi(s);
				else if (n == 5)
					pDesc->MusicBarCoord[i].x= atoi(s);
				else if (n == 6)
					pDesc->MusicBarCoord[i].y= atoi(s);
				else if (n == 7)
					pDesc->MusicBarCoord[i].width= atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				n++;
				if (n == 4)
					pDesc->MusicIconCoord[i].height = atoi(s);
				else if (n == 8)
					pDesc->MusicBarCoord[i].height= atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
				if (n == 8) break;
			}
			else
				continue;
		}
	}
#if 0
	for(i = 0; i < pDesc->MusicBarNum; i++)
	{
		PRINTF("(%3d, %3d, %3d, %3d)\n",
				pDesc->MusicBarCoord[i].x,
				pDesc->MusicBarCoord[i].y,
				pDesc->MusicBarCoord[i].width,
				pDesc->MusicBarCoord[i].height);
	}
	PRINTF("\n");
#endif

///070612 Folder ViewyzPy
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	pDesc->FolderBarNum = atoi(str);

	for(i = 0; i < NUM_OF_FOLDER_LIST; i++)
	{
		pDesc->FolderBarCoord[i].x = pDesc->FolderBarCoord[i].y = pDesc->FolderBarCoord[i].width = pDesc->FolderBarCoord[i].height = 0;
		pDesc->FolderIconCoord[i].x = pDesc->FolderIconCoord[i].y = pDesc->FolderIconCoord[i].width = pDesc->FolderIconCoord[i].height = 0;
	}
	m = 0;
	for(i = 0; i < pDesc->FolderBarNum; i++)
	{
		//ŪiconPtextbary
		memset(str, 0, LEN_XL);
		memset(s, 0, LEN_M);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		n = 0;
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)	//Ʀr
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n++;
				if (n == 1)
					pDesc->FolderIconCoord[i].x = atoi(s);
				else if (n == 2)
					pDesc->FolderIconCoord[i].y = atoi(s);
				else if (n == 3)
					pDesc->FolderIconCoord[i].width = atoi(s);
				else if (n == 5)
					pDesc->FolderBarCoord[i].x = atoi(s);
				else if (n == 6)
					pDesc->FolderBarCoord[i].y = atoi(s);
				else if (n == 7)
					pDesc->FolderBarCoord[i].width = atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				n++;
				if (n == 4)
					pDesc->FolderIconCoord[i].height = atoi(s);
				else if (n == 8)
					pDesc->FolderBarCoord[i].height = atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
				if (n == 8) break;
			}
			else
				continue;
		}
	}
///

	//070927 BT folderyzPy
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	pDesc->BTFldrBarNum = atoi(str);

	for(i = 0; i < NUM_OF_BT_FLDR_LIST; i++)
	{
		pDesc->BTFldrBarCoord[i].x = pDesc->BTFldrBarCoord[i].y = pDesc->BTFldrBarCoord[i].width = pDesc->BTFldrBarCoord[i].height = 0;
		pDesc->BTFldrIconCoord[i].x = pDesc->BTFldrIconCoord[i].y = pDesc->BTFldrIconCoord[i].width = pDesc->BTFldrIconCoord[i].height = 0;
	}
	m = 0;
	for(i = 0; i < pDesc->BTFldrBarNum; i++)
	{
		//ŪiconPtextbary
		memset(str, 0, LEN_XL);
		memset(s, 0, LEN_M);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		n = 0;
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)	//Ʀr
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n++;
				if (n == 1)
					pDesc->BTFldrIconCoord[i].x = atoi(s);
				else if (n == 2)
					pDesc->BTFldrIconCoord[i].y = atoi(s);
				else if (n == 3)
					pDesc->BTFldrIconCoord[i].width = atoi(s);
				else if (n == 5)
					pDesc->BTFldrBarCoord[i].x = atoi(s);
				else if (n == 6)
					pDesc->BTFldrBarCoord[i].y = atoi(s);
				else if (n == 7)
					pDesc->BTFldrBarCoord[i].width = atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				n++;
				if (n == 4)
					pDesc->BTFldrIconCoord[i].height = atoi(s);
				else if (n == 8)
					pDesc->BTFldrBarCoord[i].height = atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
				if (n == 8) break;
			}
			else
				continue;
		}
	}

	//070927 BT deviceyzPy
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	pDesc->BTDvcBarNum = atoi(str);

	for(i = 0; i < NUM_OF_BT_DVC_LIST; i++)
	{
		pDesc->BTDvcBarCoord[i].x = pDesc->BTDvcBarCoord[i].y = pDesc->BTDvcBarCoord[i].width = pDesc->BTDvcBarCoord[i].height = 0;
		//pDesc->BTDvcIconCoord[i].x = pDesc->BTDvcIconCoord[i].y = pDesc->BTDvcIconCoord[i].width = pDesc->BTDvcIconCoord[i].height = 0;
	}
	m = 0;
	for(i = 0; i < pDesc->BTDvcBarNum; i++)
	{
		//ŪiconPtextbary
		memset(str, 0, LEN_XL);
		memset(s, 0, LEN_M);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		n = 0;
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)	//Ʀr
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n++;
				if (n == 1)
					pDesc->BTDvcIconCoord[i].x = atoi(s);
				else if (n == 2)
					pDesc->BTDvcIconCoord[i].y = atoi(s);
				else if (n == 3)
					pDesc->BTDvcIconCoord[i].width = atoi(s);
				else if (n == 5)
					pDesc->BTDvcBarCoord[i].x = atoi(s);
				else if (n == 6)
					pDesc->BTDvcBarCoord[i].y = atoi(s);
				else if (n == 7)
					pDesc->BTDvcBarCoord[i].width = atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				n++;
				if (n == 4)
					pDesc->BTDvcIconCoord[i].height = atoi(s);
				else if (n == 8)
					pDesc->BTDvcBarCoord[i].height = atoi(s);
				memset(s, 0, LEN_M);
				m = 0;
				if (n == 8) break;
			}
			else
				continue;
		}
	}

	// MISC TEXT Coordinates
	memset(str, 0, LEN_XL);
	fgets(str, LEN_XL, fp);//discard this comment line
	for(i = 0; i < NUM_OF_FRAME_MSG; i++)
	{
		pDesc->MiscTextCoord[i].x = pDesc->MiscTextCoord[i].y = pDesc->MiscTextCoord[i].width = pDesc->MiscTextCoord[i].height = 0;
	}
	m = 0;
	for(i = 0; i < NUM_OF_FRAME_MSG; i++)
	{
		memset(str, 0, LEN_XL);
		memset(s, 0, LEN_M);
		fgets(str, LEN_XL, fp);
		len = strlen(str);
		n = 0;
		for(j = 0; j < len; j++)
		{
			if(str[j] >= 48 && str[j] <= 57)
				s[m++] = str[j];
			else if(str[j] == ',')
			{
				n++;
				if (n == 1)
					pDesc->MiscTextCoord[i].x = atoi(s);
				else if (n == 2)
					pDesc->MiscTextCoord[i].y = atoi(s);
				else if (n == 3)
					pDesc->MiscTextCoord[i].width = atoi(s);

				memset(s, 0, LEN_M);
				m = 0;
			}
			else if(str[j] == ')')
			{
				n++;
				if (n == 4)
					pDesc->MiscTextCoord[i].height = atoi(s);

				memset(s, 0, LEN_M);
				m = 0;
				break;
			}
			else
				continue;
		}
	}
#if 0
	for(i = 0; i < NUM_OF_FRAME_MSG; i++)
	{
		PRINTF("(%3d, %3d, %3d, %3d)\n",
				pDesc->MiscTextCoord[i].x,
				pDesc->MiscTextCoord[i].y,
				pDesc->MiscTextCoord[i].width,
				pDesc->MiscTextCoord[i].height);
	}
	PRINTF("\n");
#endif
	fclose(fp);

	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
int InitSetupMenu()
{
	int i;

	allSetup[SETUP_LANG_English] = &setup_en;
	allSetup[SETUP_LANG_Italiano] = &setup_ita;
	allSetup[SETUP_LANG_Deutsch] = &setup_de;
	allSetup[SETUP_LANG_Francais] = &setup_fr;
	allSetup[SETUP_LANG_Espanol] = &setup_sp;
	allSetup[SETUP_LANG_Portuguese] = &setup_por;
	allSetup[SETUP_LANG_Dutch] = &setup_nl;
	allSetup[SETUP_LANG_CHT] = &setup_cht;
	allSetup[SETUP_LANG_CHS] = &setup_chs;
	allSetup[SETUP_LANG_JP] = &setup_jp;
	allSetup[SETUP_LANG_KR] = &setup_kr;
	allSetup[SETUP_LANG_RUS] = &setup_rus;

	//Init Setup menu
	SETUP_HOMEPAGE[0] = DS_ACTIVE;
	SETUP_HOMEPAGE[1] = MT_ACTIVE;
	SETUP_HOMEPAGE[2] = I_ACTIVE;
	SETUP_HOMEPAGE[3] = A_ACTIVE;
	SETUP_HOMEPAGE[4] = V_ACTIVE;

	///070817
	/*
	///070801
	origDisplayMode = GetDisplayIndex();
	///
	*/
	///

	for (i = 0; i < LANG_ITEM_NUM; i++)
	{
		allSetup[i]->homepage_item[0] = FrameText[i][7];
		allSetup[i]->homepage_item[1] = FrameText[i][8];
		allSetup[i]->homepage_item[2] = FrameText[i][0];
		allSetup[i]->homepage_item[3] = FrameText[i][1];
		allSetup[i]->homepage_item[4] = FrameText[i][2];
		allSetup[i]->HomepageMode = DS_ACTIVE;

///070817
/*
#ifdef USE_DESC_LCD
		if(  origDisplayMode == DISP_800x600_LCD
		   ||
		     origDisplayMode == DISP_800x480_LCD
		  )
		{
			//allSetup[i]->outputif_idx = 0;//LCD
			//allSetup[i]->OutputIFMode = DISP_800x600_LCD;
		}
#endif
#ifdef USE_DESC_TV
		if(origDisplayMode == DISP_NTSC || origDisplayMode == DISP_HDTV)
		{
			//allSetup[i]->outputif_idx = 1;//TV
			//allSetup[i]->OutputIFMode = origDisplayMode;
		}
#endif
*/
///
	}
	GetFirmwareInfo();

	//check the revision of User.setup
	checkUserSetupFile();

	if (LoadUserSetup() != ERRORCODE_SUCCESS)
		return ERRORCODE_FILE;

	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
void GetFirmwareInfo()
{
	FILE *fp;
	char *tmp, str[LEN_XL], *firmwareVerionLine = "Integrated Software Version";
	Sint8 isFirmwareVerionInfoFound = FALSE;
	int lenOfFV = strlen(firmwareVerionLine), i = 0;

	//Open Descriptor file from somewhere
	if(!(fp = fopen(FIRMWARE_VERSION_FILE_NAME, "r")))
	{
		DMSG("Failed to open firmware_version file!\n");
		//_EXIT;
	}
	else
	{
		while(!feof(fp))
		{
			memset(str, 0, sizeof(char) * LEN_XL);
			fgets(str, LEN_XL, fp);

			if(strstr(str, firmwareVerionLine))//found
			{
				//founded!
				//DPRINTF("Found %s\n", str);
				isFirmwareVerionInfoFound = TRUE;
				break;
			}
		}

		if(isFirmwareVerionInfoFound)
		{
			memset(FIRMWARE_VERSION, '\0', LEN_L);
			tmp = str + lenOfFV + 1;
			while(tmp[0] != ' ' && tmp != NULL)
			{
				FIRMWARE_VERSION[i] = tmp[0];
				i++;
				tmp++;
			}
		}
		fclose(fp);
	}
}
//------------------------------------------------------------------------------------------------
void LoadUserSetupFromMem()
{
	char str[LEN_XL];
//	static Uint8 isBooting = TRUE;
	int i = 0, t = 0;

	for(i = 0; i < NUM_OF_USER_SETUP_ITEM; i++)
	{
		switch(i)
		{
			case USER_SETUP_LANGUAGE:
				t = SavedUserSetupItem[i];
				setup = allSetup[t];
				setup->lang_idx = t;
				setup->Language = SETUP_LANG[setup->lang_idx];
				break;
			case USER_SETUP_POWERSAVING:
				setup->pwrsav_idx = SavedUserSetupItem[i];
				setup->PowerSavingMode = SETUP_PWRSAV[setup->pwrsav_idx];
				break;
			case USER_SETUP_SYS_ALPHA:
				setup->sys_alpha = SavedUserSetupItem[i];
				pgu_set_alpha(setup->sys_alpha);
				break;
			case USER_SETUP_HOMEPAGE:
				setup->homepage_idx = SavedUserSetupItem[i];
				setup->HomepageMode = SETUP_HOMEPAGE[setup->homepage_idx];
				break;
			case USER_SETUP_BRIGHTNESS:
				setup->brightness_idx = SavedUserSetupItem[i];
				setup->BrightnessMode = SETUP_BRIGHTNESS[setup->brightness_idx];
				pgu_set_backlight(setup->BrightnessMode);
				break;
			case USER_SETUP_CONTRAST:
				setup->contrast_idx = SavedUserSetupItem[i];
				setup->ContrastMode = SETUP_CONTRAST[setup->contrast_idx];
				pgu_set_contrast(setup->ContrastMode);
				break;
			case USER_SETUP_CAL_ALPHA:
				setup->cal_alpha = SavedUserSetupItem[i];
				break;
			case USER_SETUP_ALARM:
				setup->alarm_setup_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_ALARM_HOUR:
				setup->alarm_hour = SavedUserSetupItem[i];
				break;
			case USER_SETUP_ALARM_MIN:
				setup->alarm_minute = SavedUserSetupItem[i];
				break;
			case USER_SETUP_SS_REPEAT:
				setup->ss_rpt_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_SS_INTERVAL:
				setup->ss_interval_idx = SavedUserSetupItem[i];
				setup->SSIntervalTime = SETUP_SS_INTERVAL_TIME[setup->ss_interval_idx];
				break;
			case USER_SETUP_SS_EFFECT:
				setup->ss_effect_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_AUDIO_REPEAT:
				setup->aud_rpt_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_VIDEO_REPEAT:
				setup->vid_rpt_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_VIDEO_TIME_DSPLY:
				setup->vid_time_dsply_idx = SavedUserSetupItem[i];
				pgu_set_mplayer_time_on_off(setup->vid_time_dsply_idx);
				tcon_set_time_on_off(setup->vid_time_dsply_idx);
				break;
			case USER_SETUP_ATOPWR:
				setup->autopwr_setup_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_ATOPWR_ON_HOUR:
				setup->autopwr_on_hour = SavedUserSetupItem[i];
				break;
			case USER_SETUP_ATOPWR_ON_MIN:
				setup->autopwr_on_minute = SavedUserSetupItem[i];
				break;
			case USER_SETUP_ATOPWR_OFF_HOUR:
				setup->autopwr_off_hour = SavedUserSetupItem[i];
				break;
			case USER_SETUP_ATOPWR_OFF_MIN:
				setup->autopwr_off_minute = SavedUserSetupItem[i];
				break;
			case USER_SETUP_VOLUME:
				volume = SavedUserSetupItem[i];
				//SetSoundDeviceVolume(volume);
				break;
			case USER_SETUP_SORTING:
				setup->sorting_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_AUTOPLAY_MODE:
				setup->autoplay_setup_idx = SavedUserSetupItem[i];
				break;
			case USER_SETUP_AUTOPLAY_SELECTED_MEDIA:
				setup->autoplay_selected_media_idx = SavedUserSetupItem[i];
				break;
			///080325 knD(L/R)
			case USER_SETUP_AUDIO_CHANNEL:
				setup->aud_chnl_idx = SavedUserSetupItem[i];
				SetAudioChannel(setup->aud_chnl_idx);
				break;
#ifdef WINGUI
			case USER_SETUP_DISPLAY_SCREEN:
				setup->display_full_screen_idx  = SavedUserSetupItem[i];
				break;
#endif
			///
			default:
				break;
		}
	}
}
//------------------------------------------------------------------------------------------------
void SaveUserSetupToMem()
{
	//System Setup
	SavedUserSetupItem[USER_SETUP_LANGUAGE]				= setup->lang_idx;
	SavedUserSetupItem[USER_SETUP_POWERSAVING]				= setup->pwrsav_idx;
	SavedUserSetupItem[USER_SETUP_SYS_ALPHA]				= setup->sys_alpha;
	SavedUserSetupItem[USER_SETUP_HOMEPAGE]				= setup->homepage_idx;
	SavedUserSetupItem[USER_SETUP_BRIGHTNESS]				= setup->brightness_idx;
	SavedUserSetupItem[USER_SETUP_CONTRAST]				= setup->contrast_idx;
	SavedUserSetupItem[USER_SETUP_SORTING]					= setup->sorting_idx;

	//Calendar/Time/Alarm Setup
	SavedUserSetupItem[USER_SETUP_CAL_ALPHA]				= setup->cal_alpha;
	SavedUserSetupItem[USER_SETUP_ALARM]					= setup->alarm_setup_idx;
	if(setup->alarm_setup_idx == 0)
		isCalAlarmRinging = -1;
	SavedUserSetupItem[USER_SETUP_ALARM_HOUR]				= setup->alarm_hour;
	SavedUserSetupItem[USER_SETUP_ALARM_MIN]				= setup->alarm_minute;

	//Slideshow Setup
	SavedUserSetupItem[USER_SETUP_SS_REPEAT]				= setup->ss_rpt_idx;
	SavedUserSetupItem[USER_SETUP_SS_INTERVAL]				= setup->ss_interval_idx;
	SavedUserSetupItem[USER_SETUP_SS_EFFECT]				= setup->ss_effect_idx;

	//AV Setup
	SavedUserSetupItem[USER_SETUP_AUDIO_REPEAT]				= setup->aud_rpt_idx;
	SavedUserSetupItem[USER_SETUP_VIDEO_REPEAT]				= setup->vid_rpt_idx;
	SavedUserSetupItem[USER_SETUP_VIDEO_TIME_DSPLY]			= setup->vid_time_dsply_idx;

	//Auto Power Setup
	SavedUserSetupItem[USER_SETUP_ATOPWR]					= setup->autopwr_setup_idx;
	SavedUserSetupItem[USER_SETUP_ATOPWR_ON_HOUR]			= setup->autopwr_on_hour;
	SavedUserSetupItem[USER_SETUP_ATOPWR_ON_MIN]			= setup->autopwr_on_minute;
	SavedUserSetupItem[USER_SETUP_ATOPWR_OFF_HOUR]		= setup->autopwr_off_hour;
	SavedUserSetupItem[USER_SETUP_ATOPWR_OFF_MIN]			= setup->autopwr_off_minute;

	//Auto Play Setup
	SavedUserSetupItem[USER_SETUP_AUTOPLAY_MODE]			= setup->autoplay_setup_idx;
	SavedUserSetupItem[USER_SETUP_AUTOPLAY_SELECTED_MEDIA]	= setup->autoplay_selected_media_idx;

	SavedUserSetupItem[USER_SETUP_VOLUME]					= volume;

	///080325 knD(L/R)
	SavedUserSetupItem[USER_SETUP_AUDIO_CHANNEL]			= setup->aud_chnl_idx;
	///
#ifdef WINGUI
	SavedUserSetupItem[USER_SETUP_DISPLAY_SCREEN]			= setup->display_full_screen_idx;
#endif
	isUSetupNeededSaving = TRUE;
}
//------------------------------------------------------------------------------------------------
int LoadUserSetup()
{
	FILE *fp;
	char str[LEN_XL];
	int j = 0;
	static Uint8 isBooting = TRUE;

	//ѨMauto power on
	setup = allSetup[0];

	//Open Descriptor file from somewhere
	if(!(fp = fopen(USER_SETUP_FILE_NAME, "r")))
	{
		DMSG("Failed to open user setup file!\n");
		return ERRORCODE_FILE;
		//exit(1);
	}
	else
	{
		//comment
		for(j = 0; j < 8; j++)
			fgets(str, LEN_XL, fp);
		//$Revision: 1.46 $
		//using '#' as delimeter, start without '#', and end with '#'
		//order: (1)Language (2)Power Saving Mode (3)Sys Alpha Value (4)Homepage (5)Brightness (6)Contrast
		//       (7)Cal Alpha Value (8)Alarm Setup (9)Alarm Hour (10)Alarm Minute
		//       (11)Slide Show Repeat (12)Slide Show Interval (13)Slide Show Effect
		//       (14)Audio Repeat (15)Video Repeat (16)Video Time Display
		//       (17)Auto Power Setup (18)Auto Power On Hour (19)Auto Power On Minute (20)Auto Power Off Hour (21)Auto Power Off Minute
		//       (22)Volume (23)File Sorting Method (24)Auto Play Setup (25) Auto Play Selected Media (26)Audio Channel LR (27)Display Screen
		fgets(str, LEN_XL, fp);

		int i = 0, idx = 0, tokenIdx = 0, len = strlen(str), t;
		char tmp[10];
		memset(tmp, 0, 10);
		while(i < len && str[i] != '\0')//not eol
		{
			if(str[i] != '#')
				tmp[idx++] = str[i++];
			else
			{
				tmp[idx++] = '\0';
				i++;
				//PRINTF("***%s\n", tmp);
				switch(tokenIdx)
				{
					case USER_SETUP_LANGUAGE:
						t = atoi(tmp);
						setup = allSetup[t];
						setup->lang_idx = t;
						setup->Language = SETUP_LANG[setup->lang_idx];
						//PRINTF("%d\n", setup->lang_idx);
						SavedUserSetupItem[tokenIdx] = setup->lang_idx;
						break;
					case USER_SETUP_POWERSAVING:
						setup->pwrsav_idx = atoi(tmp);
						setup->PowerSavingMode = SETUP_PWRSAV[setup->pwrsav_idx];
						//PRINTF("%d\n", setup->pwrsav_idx);
						SavedUserSetupItem[tokenIdx] = setup->pwrsav_idx;
						break;
					case USER_SETUP_SYS_ALPHA:
						setup->sys_alpha = atoi(tmp);
						//PRINTF("%d\n", setup->sys_alpha);
						SavedUserSetupItem[tokenIdx] = setup->sys_alpha;
						//if(isBooting)
							pgu_set_alpha(setup->sys_alpha);
						break;
					case USER_SETUP_HOMEPAGE:
						setup->homepage_idx = atoi(tmp);
						setup->HomepageMode = SETUP_HOMEPAGE[setup->homepage_idx];
						//PRINTF("Homepage = %d\n", setup->homepage_idx);
						SavedUserSetupItem[tokenIdx] = setup->homepage_idx;
						break;
					case USER_SETUP_BRIGHTNESS:
						setup->brightness_idx = atoi(tmp);
						setup->BrightnessMode = SETUP_BRIGHTNESS[setup->brightness_idx];
						//PRINTF("%d\n", setup->brightness_idx);
						SavedUserSetupItem[tokenIdx] = setup->brightness_idx;
						//if(isBooting)
							pgu_set_backlight(setup->BrightnessMode);
						break;
					case USER_SETUP_CONTRAST:
						setup->contrast_idx = atoi(tmp);
						setup->ContrastMode = SETUP_CONTRAST[setup->contrast_idx];
						//PRINTF("%d\n", setup->contrast_idx);
						SavedUserSetupItem[tokenIdx] = setup->contrast_idx;
						//if(isBooting)
							pgu_set_contrast(setup->ContrastMode);
						break;
					case USER_SETUP_CAL_ALPHA:
						setup->cal_alpha = atoi(tmp);
						//PRINTF("%d\n", setup->cal_alpha);
						SavedUserSetupItem[tokenIdx] = setup->cal_alpha;
						break;
					case USER_SETUP_ALARM:
						setup->alarm_setup_idx = atoi(tmp);
						//PRINTF("%d\n", setup->alarm_setup_idx);
						SavedUserSetupItem[tokenIdx] = setup->alarm_setup_idx;
						if(setup->alarm_setup_idx == 0)
							isCalAlarmRinging = -1;
						break;
					case USER_SETUP_ALARM_HOUR:
						setup->alarm_hour = atoi(tmp);
						//PRINTF("%d\n", setup->alarm_hour);
						SavedUserSetupItem[tokenIdx] = setup->alarm_hour;
						break;
					case USER_SETUP_ALARM_MIN:
						setup->alarm_minute = atoi(tmp);
						//PRINTF("%d\n", setup->alarm_minute);
						SavedUserSetupItem[tokenIdx] = setup->alarm_minute;
						break;
					case USER_SETUP_SS_REPEAT:
						setup->ss_rpt_idx = atoi(tmp);
						//PRINTF("%d\n", setup->ss_rpt_idx);
						SavedUserSetupItem[tokenIdx] = setup->ss_rpt_idx;
						break;
					case USER_SETUP_SS_INTERVAL:
						setup->ss_interval_idx = atoi(tmp);
						setup->SSIntervalTime = SETUP_SS_INTERVAL_TIME[setup->ss_interval_idx];
						//PRINTF("%d\n", setup->ss_interval_idx);
						SavedUserSetupItem[tokenIdx] = setup->ss_interval_idx;
						break;
					case USER_SETUP_SS_EFFECT:
						setup->ss_effect_idx = atoi(tmp);
						//PRINTF("%d\n", setup->ss_effect_idx);
						SavedUserSetupItem[tokenIdx] = setup->ss_effect_idx;
						break;
					case USER_SETUP_AUDIO_REPEAT:
						setup->aud_rpt_idx = atoi(tmp);
						//PRINTF("%d\n", setup->aud_rpt_idx);
						SavedUserSetupItem[tokenIdx] = setup->aud_rpt_idx;
						break;
					case USER_SETUP_VIDEO_REPEAT:
						setup->vid_rpt_idx = atoi(tmp);
						//PRINTF("%d\n", setup->vid_rpt_idx);
						SavedUserSetupItem[tokenIdx] = setup->vid_rpt_idx;
						break;
					case USER_SETUP_VIDEO_TIME_DSPLY:
#ifdef VIDEO_TIME_DISPLAY_MOD
						setup->vid_time_dsply_idx = atoi(tmp);
#else
						setup->vid_time_dsply_idx = 0;
#endif
						//PRINTF("%d\n", setup->vid_time_dsply_idx);
						SavedUserSetupItem[tokenIdx] = setup->vid_time_dsply_idx;
						pgu_set_mplayer_time_on_off(setup->vid_time_dsply_idx);
						tcon_set_time_on_off(setup->vid_time_dsply_idx);
						break;
					case USER_SETUP_ATOPWR:
						setup->autopwr_setup_idx = atoi(tmp);
						//PRINTF("%d\n", setup->autopwr_setup_idx);
						SavedUserSetupItem[tokenIdx] = setup->autopwr_setup_idx;
						break;
					case USER_SETUP_ATOPWR_ON_HOUR:
						setup->autopwr_on_hour = atoi(tmp);
						//PRINTF("%d\n", setup->autopwr_on_hour);
						SavedUserSetupItem[tokenIdx] = setup->autopwr_on_hour;
						break;
					case USER_SETUP_ATOPWR_ON_MIN:
						setup->autopwr_on_minute = atoi(tmp);
						//PRINTF("%d\n", setup->autopwr_on_minute);
						SavedUserSetupItem[tokenIdx] = setup->autopwr_on_minute;
						break;
					case USER_SETUP_ATOPWR_OFF_HOUR:
						setup->autopwr_off_hour = atoi(tmp);
						//PRINTF("%d\n", setup->autopwr_off_hour);
						SavedUserSetupItem[tokenIdx] = setup->autopwr_off_hour;
						break;
					case USER_SETUP_ATOPWR_OFF_MIN:
						setup->autopwr_off_minute = atoi(tmp);
						//PRINTF("%d\n", setup->autopwr_off_minute);
						SavedUserSetupItem[tokenIdx] = setup->autopwr_off_minute;
						break;
					case USER_SETUP_VOLUME:
						volume = atoi(tmp);
						//PRINTF("%d\n", volume);
						SavedUserSetupItem[tokenIdx] = volume;
						if(isBooting)
							SetSoundDeviceVolume(volume);
						break;
					case USER_SETUP_SORTING:
						setup->sorting_idx = atoi(tmp);
						SavedUserSetupItem[tokenIdx] = setup->sorting_idx;
						break;
					case USER_SETUP_AUTOPLAY_MODE:
						setup->autoplay_setup_idx = atoi(tmp);
						SavedUserSetupItem[tokenIdx] = setup->autoplay_setup_idx;
						break;
					case USER_SETUP_AUTOPLAY_SELECTED_MEDIA:
						setup->autoplay_selected_media_idx = atoi(tmp);
						SavedUserSetupItem[tokenIdx] = setup->autoplay_selected_media_idx;
						break;
					///080325 knD(L/R)
					case USER_SETUP_AUDIO_CHANNEL:
						setup->aud_chnl_idx = atoi(tmp);
						SavedUserSetupItem[tokenIdx] = setup->aud_chnl_idx;
						SetAudioChannel(setup->aud_chnl_idx);
						break;
#ifdef WINGUI
					case USER_SETUP_DISPLAY_SCREEN:
						setup->display_full_screen_idx = atoi(tmp);
						SavedUserSetupItem[tokenIdx] = setup->display_full_screen_idx;
						break;
#endif
					///
					default:
						break;
				}
#if defined(GUI_STYLE_COMTEK)
				if((tokenIdx >= USER_CAL_AUTOPWR_ON_HOUR) && (tokenIdx < USER_CAL_AUTOPWR_ON_MIN))
					setup->cal_autopwr_on_hour[tokenIdx - USER_CAL_AUTOPWR_ON_HOUR] = atoi(tmp);
				else if((tokenIdx >= USER_CAL_AUTOPWR_ON_MIN) && (tokenIdx < USER_CAL_PROGRAM_DOWNLOAD))
					setup->cal_autopwr_on_minute[tokenIdx - USER_CAL_AUTOPWR_ON_MIN] = atoi(tmp);
				else if((tokenIdx >= USER_CAL_PROGRAM_DOWNLOAD) && (tokenIdx < USER_CAL_AUTOPWR_OFF_HOUR))
					setup->cal_program_download[tokenIdx - USER_CAL_PROGRAM_DOWNLOAD] = atoi(tmp);
				else if((tokenIdx >= USER_CAL_AUTOPWR_OFF_HOUR) && (tokenIdx < USER_CAL_AUTOPWR_OFF_MIN))
					setup->cal_autopwr_off_hour[tokenIdx - USER_CAL_AUTOPWR_OFF_HOUR] = atoi(tmp);
				else if((tokenIdx >= USER_CAL_AUTOPWR_OFF_MIN) && (tokenIdx < NUM_OF_USER_SETUP_ITEM))
					setup->cal_autopwr_off_minute[tokenIdx - USER_CAL_AUTOPWR_OFF_MIN] = atoi(tmp);
#endif
				idx = 0;
				memset(tmp, 0, 10);
				tokenIdx++;
			}
		}
		fclose(fp);
	}
	if(isBooting)
	{
		SaveAutoPwrSetupToRTC();
		if(!CompareUserBrightnessContrast())
			SaveUserBrightnessContrastSetup();
		isBooting = FALSE;
	}
	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
void SaveUserSetup()
{
	FILE *fp;

	if(!(fp = fopen(USER_SETUP_FILE_NAME, "w")))
	{
		DMSG("Failed to open user setup file!\n");
		return;
		//exit(1);
	}
	else
	{
		fputs(defaultRevision, fp);fputs("\n", fp);
		fputs("//using '#' as delimeter, start without '#', and end with '#'. \n", fp);
		fputs("//order: (1)Language (2)Power Saving Mode (3)Sys Alpha Value (4)Homepage (5)Brightness (6)Contrast\n", fp);
		fputs("//       (7)Cal Alpha Value (8)Alarm Setup (9)Alarm Hour (10)Alarm Minute\n", fp);
		fputs("//       (11)Slide Show Repeat (12)Slide Show Interval (13)Slide Show Effect \n", fp);
		fputs("//       (14)Audio Repeat (15)Video Repeat (16)Video Time Display\n", fp);
		fputs("//       (17)Auto Power Setup (18)Auto Power On Hour (19)Auto Power On Minute (20)Auto Power Off Hour (21)Auto Power Off Minute\n", fp);
#if defined(WINGUI) && defined(GUI_STYLE_COMTEK)
		fputs("//       (22)Volume (23)File Sorting Method (24)Auto Play Setup (25) Auto Play Selected Media (26)Audio Channel LR (27)Display Screen (28~63)Cal Setup\n", fp);
		fprintf(fp, "%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#\
			%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#\n\n",
			setup->lang_idx, setup->pwrsav_idx, setup->sys_alpha, setup->homepage_idx, setup->brightness_idx, setup->contrast_idx,
			setup->cal_alpha, setup->alarm_setup_idx, setup->alarm_hour, setup->alarm_minute,
			setup->ss_rpt_idx, setup->ss_interval_idx, setup->ss_effect_idx,
			setup->aud_rpt_idx, setup->vid_rpt_idx, setup->vid_time_dsply_idx,
			setup->autopwr_setup_idx, setup->autopwr_on_hour, setup->autopwr_on_minute, setup->autopwr_off_hour, setup->autopwr_off_minute,
			volume,
			setup->sorting_idx, setup->autoplay_setup_idx, setup->autoplay_selected_media_idx,
			///080325 knD(L/R)
			setup->aud_chnl_idx,
			setup->display_full_screen_idx
			///
			setup->cal_autopwr_on_hour[0], setup->cal_autopwr_on_hour[1], setup->cal_autopwr_on_hour[2], setup->cal_autopwr_on_hour[3],
			setup->cal_autopwr_on_hour[4], setup->cal_autopwr_on_hour[5], setup->cal_autopwr_on_hour[6],
			setup->cal_autopwr_on_minute[0], setup->cal_autopwr_on_minute[1], setup->cal_autopwr_on_minute[2], setup->cal_autopwr_on_minute[3],
			setup->cal_autopwr_on_minute[4], setup->cal_autopwr_on_minute[5], setup->cal_autopwr_on_minute[6],
			setup->cal_program_download[0], setup->cal_program_download[1], setup->cal_program_download[2], setup->cal_program_download[3],
			setup->cal_program_download[4], setup->cal_program_download[5], setup->cal_program_download[6],
			setup->cal_autopwr_off_hour[0], setup->cal_autopwr_off_hour[1], setup->cal_autopwr_off_hour[2], setup->cal_autopwr_off_hour[3],
			setup->cal_autopwr_off_hour[4], setup->cal_autopwr_off_hour[5], setup->cal_autopwr_off_hour[6],
			setup->cal_autopwr_off_minute[0], setup->cal_autopwr_off_minute[1], setup->cal_autopwr_off_minute[2], setup->cal_autopwr_off_minute[3],
			setup->cal_autopwr_off_minute[4], setup->cal_autopwr_off_minute[5], setup->cal_autopwr_off_minute[6]
		);
#elif defined(WINGUI) && !defined(GUI_STYLE_COMTEK)
		fputs("//       (22)Volume (23)File Sorting Method (24)Auto Play Setup (25) Auto Play Selected Media (26)Audio Channel LR (27)Display Screen\n", fp);
		fprintf(fp, "%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#\n\n",
			setup->lang_idx, setup->pwrsav_idx, setup->sys_alpha, setup->homepage_idx, setup->brightness_idx, setup->contrast_idx,
			setup->cal_alpha, setup->alarm_setup_idx, setup->alarm_hour, setup->alarm_minute,
			setup->ss_rpt_idx, setup->ss_interval_idx, setup->ss_effect_idx,
			setup->aud_rpt_idx, setup->vid_rpt_idx, setup->vid_time_dsply_idx,
			setup->autopwr_setup_idx, setup->autopwr_on_hour, setup->autopwr_on_minute, setup->autopwr_off_hour, setup->autopwr_off_minute,
			volume,
			setup->sorting_idx, setup->autoplay_setup_idx, setup->autoplay_selected_media_idx,
			///080325 knD(L/R)
			setup->aud_chnl_idx,
			setup->display_full_screen_idx
			///
		);
#elif defined(GUI_STYLE_COMTEK) && !defined(WINGUI)
		fputs("//       (22)Volume (23)File Sorting Method (24)Auto Play Setup (25) Auto Play Selected Media (26)Audio Channel LR (27~62)Cal Setup\n", fp);
		fprintf(fp, "%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#\
			%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#\n\n",
			setup->lang_idx, setup->pwrsav_idx, setup->sys_alpha, setup->homepage_idx, setup->brightness_idx, setup->contrast_idx,
			setup->cal_alpha, setup->alarm_setup_idx, setup->alarm_hour, setup->alarm_minute,
			setup->ss_rpt_idx, setup->ss_interval_idx, setup->ss_effect_idx,
			setup->aud_rpt_idx, setup->vid_rpt_idx, setup->vid_time_dsply_idx,
			setup->autopwr_setup_idx, setup->autopwr_on_hour, setup->autopwr_on_minute, setup->autopwr_off_hour, setup->autopwr_off_minute,
			volume,
			setup->sorting_idx, setup->autoplay_setup_idx, setup->autoplay_selected_media_idx,
			///080325 knD(L/R)
			setup->aud_chnl_idx,
			///
			setup->cal_autopwr_on_hour[0], setup->cal_autopwr_on_hour[1], setup->cal_autopwr_on_hour[2], setup->cal_autopwr_on_hour[3],
			setup->cal_autopwr_on_hour[4], setup->cal_autopwr_on_hour[5], setup->cal_autopwr_on_hour[6],
			setup->cal_autopwr_on_minute[0], setup->cal_autopwr_on_minute[1], setup->cal_autopwr_on_minute[2], setup->cal_autopwr_on_minute[3],
			setup->cal_autopwr_on_minute[4], setup->cal_autopwr_on_minute[5], setup->cal_autopwr_on_minute[6],
			setup->cal_program_download[0], setup->cal_program_download[1], setup->cal_program_download[2], setup->cal_program_download[3],
			setup->cal_program_download[4], setup->cal_program_download[5], setup->cal_program_download[6],
			setup->cal_autopwr_off_hour[0], setup->cal_autopwr_off_hour[1], setup->cal_autopwr_off_hour[2], setup->cal_autopwr_off_hour[3],
			setup->cal_autopwr_off_hour[4], setup->cal_autopwr_off_hour[5], setup->cal_autopwr_off_hour[6],
			setup->cal_autopwr_off_minute[0], setup->cal_autopwr_off_minute[1], setup->cal_autopwr_off_minute[2], setup->cal_autopwr_off_minute[3],
			setup->cal_autopwr_off_minute[4], setup->cal_autopwr_off_minute[5], setup->cal_autopwr_off_minute[6]
		);
#else
		fputs("//       (22)Volume (23)File Sorting Method (24)Auto Play Setup (25) Auto Play Selected Media (26)Audio Channel LR\n", fp);
		fprintf(fp, "%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#\n\n",
			setup->lang_idx, setup->pwrsav_idx, setup->sys_alpha, setup->homepage_idx, setup->brightness_idx, setup->contrast_idx,
			setup->cal_alpha, setup->alarm_setup_idx, setup->alarm_hour, setup->alarm_minute,
			setup->ss_rpt_idx, setup->ss_interval_idx, setup->ss_effect_idx,
			setup->aud_rpt_idx, setup->vid_rpt_idx, setup->vid_time_dsply_idx,
			setup->autopwr_setup_idx, setup->autopwr_on_hour, setup->autopwr_on_minute, setup->autopwr_off_hour, setup->autopwr_off_minute,
  #if defined(KINGSTON)//kingston want to save default volume value back
			VOLUME_DEFAULT,
  #else
			volume,
  #endif
			setup->sorting_idx, setup->autoplay_setup_idx, setup->autoplay_selected_media_idx,
			///080325 knD(L/R)
			setup->aud_chnl_idx
			///
		);
#endif
		fclose(fp);
		SaveConf();
		SaveUserBrightnessContrastSetup();
	}
	isUSetupNeededSaving = FALSE;
}
//------------------------------------------------------------------------------------------------
Uint8 CompareUserBrightnessContrast()
{
	FILE *fp;
	static char svdVal[20] = {'\0'}, currVal[20] = {'\0'};
	
	//open file
	if(!(fp = fopen(USER_BRIGHTNESS_CONTRAST_FILE_NAME, "r+")))
	{
		DMSG("Failed to open user brightness&contrast setup file - not existed!\n");
		return FALSE;
	}
	//compare the value string
	else
	{
		fgets(svdVal, LEN_XL, fp);
		fclose(fp);
		sprintf(currVal, "%d#%d#\n", setup->BrightnessMode, setup->ContrastMode);
		
		if(!strcmp(svdVal, currVal))
			return TRUE;
		else
			return FALSE;
	}
}
//------------------------------------------------------------------------------------------------
void SaveUserBrightnessContrastSetup()
{
	FILE *fp;

	if(!(fp = fopen(USER_BRIGHTNESS_CONTRAST_FILE_NAME, "w")))
	{
		DMSG("Failed to open user brightness&contrast setup file!\n");
		return;
	}
	else
	{
		fprintf(fp, "%d#%d#\n\n", setup->BrightnessMode, setup->ContrastMode);
		fclose(fp);
	}
}
//------------------------------------------------------------------------------------------------
#if defined(TV_SWITCH_MOD)
Uint8 LoadTVOutputMode()
{
	FILE *fp;
	int out = CVBS;//important!!!must not be declared to Uint8
	
	if(!(fp = fopen(TV_OUT_MODE_FILE_NAME, "r")))
	{
		DMSG("Failed to open user tv output mode setup file!\n");
		SaveUserTVOutModeSetup();
	}
	else
	{
		fscanf(fp, "%d\n", &out);
		fclose(fp);
	}
	
	return out;
}
//------------------------------------------------------------------------------------------------
void SaveUserTVOutModeSetup()
{
	FILE *fp;
	
	if(!(fp = fopen(TV_OUT_MODE_FILE_NAME, "w")))
	{
		DMSG("Failed to open user tv output mode setup file!\n");
		return;
	}
	else
	{
		fprintf(fp, "%d\n", TVIF);
		fclose(fp);
	}
}
#endif
//------------------------------------------------------------------------------------------------
void SaveConf()
{
	pid_t pid;
	int stat;

	//system("/bin/save_conf");
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork failure!");
			DMSG("Fork to save_conf Fail!");
			return;
			//_EXIT;
		case 0:
			//child process
			execl("/bin/save_conf", "save_conf", NULL);
			_EXIT;
		default:
			//parent process
			waitpid(pid, &stat, 0);
			//PRINTF("config saved completely!!!\n");
			break;
	}
}
//------------------------------------------------------------------------------------------------
/**
 * Check if the file User.setup in the reserved space is correct.
 * If checking failure, replace the file from default User.setup
 * checking rule:
 *     1. version number (in the first line of the file), it maybe be upgraded, modified or broken.
 *     2. to be continued...
 */
int checkUserSetupFile()
{
	FILE *fp;
	char tmpRevision[LEN_L];
	Sint8 isRevisionMatched = TRUE;
	static Uint8 isBooting = TRUE;

	if(isBooting)
	{
		memset(defaultRevision, 0, LEN_L);
		//Open Default User.setup Descriptor file from somewhere to get current correct revision info
		if(!(fp = fopen(USER_SETUP_DEFAULT_FILE_NAME, "r")))
		{
			DMSG("Failed to open default user setup file!\n");
			return ERRORCODE_FILE;
		}else
		{
			//get revision info (at the first line)
			fgets(defaultRevision, LEN_L, fp);
			if(defaultRevision[strlen(defaultRevision) - 1] == '\n' || defaultRevision[strlen(defaultRevision) - 1] == '\r')
				defaultRevision[strlen(defaultRevision) - 1] = '\0';
			if(defaultRevision[strlen(defaultRevision) - 2] == '\n' || defaultRevision[strlen(defaultRevision) - 2] == '\r')
				defaultRevision[strlen(defaultRevision) - 2] = '\0';
#ifdef _DEBUG
			char debugStr[LEN_L], *tmpStr = "Def User.setup rev: '";
			memset(debugStr, 0, LEN_L);
			strcpy(debugStr, tmpStr);
			strcat(debugStr, defaultRevision);
			strcat(debugStr, "'.\n");
			DMSG(debugStr);
#endif

			fclose(fp);
		}
	}
	isBooting = FALSE;

	//checking rule 1 - checking file revision
	if(isRevisionMatched)
	{
		//Open User.setup Descriptor file from somewhere to get current correct version info
		if(!(fp = fopen(USER_SETUP_FILE_NAME, "r")))
		{
			DMSG("Failed to open user setup file!\n");
			isRevisionMatched = FALSE;//supposed the file is not existed.
		}else
		{
			memset(tmpRevision, 0, LEN_L);
			//get revision info (at the first line)
			fgets(tmpRevision, LEN_L, fp);
			if(tmpRevision[strlen(tmpRevision) - 1] == '\n' || tmpRevision[strlen(tmpRevision) - 1] == '\r')
				tmpRevision[strlen(tmpRevision) - 1] = '\0';
			if(tmpRevision[strlen(tmpRevision) - 2] == '\n' || tmpRevision[strlen(tmpRevision) - 2] == '\r')
				tmpRevision[strlen(tmpRevision) - 2] = '\0';
#ifdef _DEBUG
			char debugStr[LEN_L], *tmpStr = "Tmp User.setup rev: '";
			memset(debugStr, 0, LEN_L);
			strcpy(debugStr, tmpStr);
			strcat(debugStr, tmpRevision);
			strcat(debugStr, "'.\n");
			DMSG(debugStr);
#endif

			fclose(fp);
			isRevisionMatched = !strcmp(defaultRevision, tmpRevision);
		}
	}

	//checking rule 2 - to be continued...
	//if(isRevisionMatched){}

	//check if the revision is not matched
	if(!isRevisionMatched)
	{
		DMSG("The revision of User.setup is not the same.\n");
		CopyDefaultUserSetupFile();
		SaveConf();
	}else
	{
		DMSG("The revision of User.setup is the same.\n");

		//check if USER_SETUP_SAVED_FILE_NAME is existed on /tmp/conf
		if(!(fp = fopen(USER_SETUP_SAVED_FILE_NAME, "r")))
		{
			//CopyDefaultUserSetupFile();
			DMSG("Failed to open saved user setup file!\n");
			SaveConf();
		}else
			fclose(fp);
	}

	return ERRORCODE_SUCCESS;
}
