#ifndef _SKY_UTIL_HEADER_
#define _SKY_UTIL_HEADER_
//------------------------------------------------------------------------------------------------
#include "skydemo.h"

//nelly add 3/8/2008
#include "types.h"
#ifdef ZYDAS_SUPPORT
	//nelly add 6/11/2008
	#define WPA_SUPPLICANT_SUPPORT
	#ifdef WPA_SUPPLICANT_SUPPORT
		#include "wireless.h"
		#define ZD_IOCTL_PARAM			(SIOCDEVPRIVATE + 2)
		#define ZD_PARAM_ROAMING		0x0001
		#define ZD_PARAM_SET_STATE	0x0008
		#define ZYDAS_WPA_DISCONNECTED	0
		#define ZYDAS_WPA_INACTIVE			1
		
		#define WPA_SUPPLICANT_UTILITY	"/bin/wpa_supplicant"
		#define	WPA_SUPPLICANT_CONF			"/tmp/conf/wpa_supplicant_psk.conf"
		
		typedef struct wpa_supplicant_conf_cmd{
			char	wpa_supplicant_cmd[50];	
			struct 	wpa_supplicant_conf_cmd	*next;
		}WPA_SUPPLICANT_CONF_CMD;
	#endif
	//nelly add 6/17/2008
	#define WPS_SUPPORT
	#ifdef WPS_SUPPORT
		#define WPS_UTILITY	"/bin/wps_enrollee"
		#define WPS_CONF	"/tmp/conf/wps.conf"
		
		typedef struct wps_conf_cmd{
			char	wps_cmd[100];	
			struct 	wps_conf_cmd	*next;
		}WPS_CONF_CMD;
	#endif
	
	#define	IWCONFIG_UTILITY	"/bin/iwconfig"
  #define IFCONFIG_UTILITY	"/sbin/ifconfig"
  #define IWPRIV_UTILITY	"/bin/iwpriv"
  
	struct spawn_handle {
		int		pipe[2];	/* pipe[0]=stdin, pipe[1]=stdout/stderr */
		pid_t	pid;		/* child process ID */
	};

	#define	SPAWN_NULL_IO			0	/* the parent doesn't have any terminal
									 * access to the clild. The child's stdin/
									 * stdout/stderr will be redirected to
									 * /dev/null
									 */
	#define	SPAWN_INPUT_ONLY		1	/* the parent only get input from child */
	#define	SPAWN_OUTPUT_ONLY		2	/* the parent only output something to
									 * child */
	#define	SPAWN_BIDIRECTIONAL_IO	3	/* the parent needs bidirectional terminal
									 * access from the child */

	#define	SPAWN_INPUT(s)			((s).pipe[0])
	#define	SPAWN_OUTPUT(s)			((s).pipe[1])
	int spawn_program(struct spawn_handle *handle, int iotype, const char *path, const char *arg, ...);
	int spawn_program_with_callback(struct spawn_handle *handle, void (*exec_callback)(const char *path, char *const argv[]), int iotype, const char *path, const char *arg, ...);
	void destroy_spawn_handle(struct spawn_handle *handle);
	int cleanup_spawn(struct spawn_handle *handle, int *status);
	int terminate_spawn(struct spawn_handle *handle);
	int detect_zydas_adapter();	
	void Zydas_Get_rt73sta_Info(char *item_name, char *buff,int buff_len);
	int Zydas_GetKeyParameter(char *in, char *dest, int destsize, char *source);
	int set_zydas_adapter();
	#ifdef WPA_SUPPLICANT_SUPPORT
		int	program_pid(const char *program);
		int kill_old_process(const char *proc_name,const char *signal);
		static void write_data(char *cmd,FILE *wpa_supplicant_conf);
		static int	write_to_conf(void (*pfun)(char *cmd,FILE *wpa_supplicant_conf));
		int WRITE_TO_CONF();
		static int	AddCmd(char *cmd);
		static void	FREE_WPA_SUPPLICANT_TABLE(WPA_SUPPLICANT_CONF_CMD  *wpa_supplicant_table);
		static void	FREE_WPA_SUPPLICANT_LIST();
		static int	zydas_set_param(char *ifname, int op, int arg);
	#endif
	#ifdef WPS_SUPPORT
		static void wps_write_data(char *cmd,FILE *wps_conf);
		static int	wps_write_to_conf(void (*pfun)(char *cmd,FILE *wps_conf));
		int WPS_WRITE_TO_CONF();
		static int	WPS_AddCmd(char *cmd);
		static void	FREE_WPS_TABLE(WPS_CONF_CMD  *wps_table);
		static void	FREE_WPS_LIST();
		int start_wps_pbc();
		int start_zydas_wps_pbc();
	#endif
#endif
//------------------------------------------------------------------------------------------------
typedef enum
{
	SDMMC = 0,
	CF,
	USB,
	XDSM,
	MS,
	HD,
	FLASH,
	NET
}DEV_NUM;

///080623 jM˸m
#define NUM_OF_SEARCH_DEV 7
typedef struct _STRUCT_DEVICE_LABEL_
{
	Sint8 dev_num;
	Uint8 search_flag;
	char dev_name[LEN_M];
	char path[LEN_L];
}DeviceLabel;

typedef struct _DEVICE_SEARCH_TABLE_
{
	DeviceLabel Labels[NUM_OF_SEARCH_DEV];
}DeviceSearchTable;

typedef struct _STRUCT_DEVICE_SEARCH_SEQUENCE_
{
	int nDevice;
	DeviceLabel* Labels[NUM_OF_SEARCH_DEV];
	DeviceSearchTable DevTable;
}DeviceSearchSequence;

static DeviceSearchTable DefDevTabel = 
{
	{
		{SDMMC,	1, DEVICE_SDMMC_NAME,	SDMMC_PATH},
		{CF,	1, DEVICE_CF_NAME,		CF_PATH},
		{USB,	1, DEVICE_USB_NAME,		USB_PATH},
		{XDSM,	1, DEVICE_xD_NAME,		XDSM_PATH},
		{MS,	1, DEVICE_MS_NAME,		MS_PATH},
		{HD,	0, DEVICE_HD_NAME,		HD_PATH},
		{FLASH,	1, DEVICE_FLASH_NAME,	FLASH_PATH}
	}
};

DeviceSearchSequence* NewDeviceSearchSequence(DeviceSearchTable DevTable);
int SetDeviceSearchSequence(DeviceSearchSequence *pSeq, Uint8 dev_num, Uint8 seq);
int RenewDeviceSearchSequence(DeviceSearchSequence *pSeq);
///
//------------------------------------------------------------------------------------------------
void DisableReader();
void EnableReader();
Uint8 IsCardChanged();
void EnforceRenewPartitionInfo();
Uint8 CheckDevMntedSts(char *name);
void UmountDecive(DEV_NUM dev_num);
void UmountAllDevices();
Uint8 MountDevice(Uint8 devNum, char **mnt_dev_argv);
Uint8 RenewDeviceMountedStatus(Uint8 NumMntDev);
Uint8 RenewUSB2PCConn(Uint8 Num);
Uint8 DetectDeviceMountedStatus();
Uint8 DetectUSB2PCConnection(Uint8 num);
void SavePrevMountedDeviceStatus();
void GetInOutDevice(Sint8 *inOut, Sint8 *whichDevice);
#ifdef BLUETOOTH_MOD
Uint8 DetectBTDongle(Uint8 num);
Uint8 isBTDonglePlugged();
#endif

#ifdef NET_MOD
void ForkNASMntProcess();
Uint8 CheckNASMntedStatus();
void KillNetSocket();
void RenewNetDongle(Uint8 *EnabledDevNum);
Uint8 CheckGWMAC(ULint32 *gw_ip);
Uint8 MountNETDevice();
void ForkNETSocket();
ULint32 CheckGWIP(char *ifname);
void ForkGetDHCPIProcess(char *ifname);
char *BasicFindSec(char *p_start);
int GetKeyParameter(char *in, char *dest, int destsize, char *source);
void Get_rt73sta_Info(char *item_name, char *buff);
void DetectNetDongle();
//rywu20080516++
unsigned char detect_net_device(void);
#ifdef SUPPORT_RSS
unsigned char set_network_on(unsigned char interface);
unsigned char set_network_off(unsigned char interface);
#endif

//-1/0/1 = error/linked/no-link; if -1, we skip the check for asix ic(no such IOCTL)
int detect_eth(void);
//-1/0/1/2 = error/linked/no-link(ralink)/no-link(atheros); if -1, we take as no wireless; 2/1/0=wireless on
int detect_wifi(void);
static int wifi_check = LINK_ERROR;
//rywu20080516--

int detect_adsl(void);//rywu20080529

#endif

#endif
