#include "events.h"
#include "machinedisplay.h"
//------------------------------------------------------------------------------------------------
static Uint8 stop = 1;
static Uint8 playpause = 0;
extern Uint32 isSSPrcsStoppedwSIGSTOP;
#ifdef NET_MOD
extern unsigned int	net_slideshow;
extern Uint8 isGWSet;		//0: none; bit_1(1): got mac; bit_2(2): wired; bit_3(4):wireless;
#endif
//------------------------------------------------------------------------------------------------
// Slideshow Callbacks																				    
//------------------------------------------------------------------------------------------------
void SS_UpEvent()
{
	if(AudCount > 0)//working when any audio existed
	{
		FRAME *elmf;
		//LIST *tmplist;
		Uint32 i = 0;

		elmf = &ELMachines[active_index].frame;

		///071031 ϥactive_icon_index,uCurrAudListPos
		elmf->CurrAudListPos = elmf->CurrAudListPos->prev;
		if (elmf->CurrAudListPos == AudioList)	//w}Y
		{
			for (i=0; i<AudCount; i++)
			{
				elmf->CurrAudListPos = elmf->CurrAudListPos->next;
			}
		}
		DecodeSSAUD();
		///
		stop = 1;
	}
}
//------------------------------------------------------------------------------------------------
void SS_DownEvent()
{
	if(AudCount > 0)//working when any audio existed
	{
		FRAME *elmf;

		elmf = &ELMachines[active_index].frame;

		///071031 ϥactive_icon_index,uCurrAudListPos
		elmf->CurrAudListPos = elmf->CurrAudListPos->next;
		if (elmf->CurrAudListPos == NULL)
		{
			elmf->CurrAudListPos = AudioList->next;
		}
		DecodeSSAUD();
		///
		stop = 1;
	}
}
//------------------------------------------------------------------------------------------------
void SS_LeftEvent()
{
}
//------------------------------------------------------------------------------------------------
void SS_RightEvent()
{
}
//------------------------------------------------------------------------------------------------
/* bk @080115
void SS_StopEvent()
{
	playpause = 0;
	if(stop)//stop audio first
	{
		KillAudioProcess();
		isSSAudPrcsForked = FALSE;
		stop = 0;
	}
	else//then stop image
	{
		stop = 1;
#ifdef SET_SS_SKY_PRIO
		SkyPrio = getpriority(PRIO_PROCESS, 0);
	  	setpriority(PRIO_PROCESS, 0, SkyPrio - SS_SKY_PRIO_LVL);
#endif
		ELMachines[active_index].Shutdown(1);
		//modified by bk@070409 - modified for AutoSlideShow
		if(!strcmp(SelectedDev, DEVICE_AUTOSS_NAME))//slideshow from DS_ACTIVE
		{	
			FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
			active_index = DS_ACTIVE;
		}
		else
		{
			active_index = MT_ACTIVE;
		}
		//fix tr bug (mantis 117 - robert) by bk @ 070903
		pgu_switch_to_buffer(1);
		
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
		pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);
		pgu_switch_to_buffer(1);
	}
}
*/
//------------------------------------------------------------------------------------------------
void SS_StopEvent()
{
	#ifndef WINGUI
	playpause = 0;
	if(stop)//stop audio first
	{
		KillAudioProcess();
		isSSAudPrcsForked = FALSE;
		stop = 0;
	}
	else//then stop image
	{
		SS_EscEvent();
	}
	#else
	SS_EscEvent();
	#endif
}
//------------------------------------------------------------------------------------------------
void SS_PlayPauseEvent()
{
	playpause %= 2;
	if(playpause == 0)//pause audio only
	{
		if(isSSImgPrcsForked)
		{
			if(pid_img != 0)
				kill(pid_img, SIGSTOP);
			if(pid_tr != 0)
				kill(pid_tr, SIGSTOP);
			isSSPrcsStoppedwSIGSTOP = 1;
		}
		
		if(isSSAudPrcsForked)
		{
			//set_ir_value((unsigned long)0x70);
			if(pid_aud != 0)
				kill(pid_aud, SIGSTOP);
			isSSPrcsStoppedwSIGSTOP = 1;
		}
	}
	else//play all
	{
		if(isSSImgPrcsForked)
		{
			if(pid_img != 0)
				kill(pid_img, SIGCONT);
			if(pid_tr != 0)
				kill(pid_tr, SIGCONT);
		}
		if(isSSAudPrcsForked)
			//set_ir_value((unsigned long)0x70);
			if(pid_aud != 0)
				kill(pid_aud, SIGCONT);
		isSSPrcsStoppedwSIGSTOP = 0;
	}
	playpause++;
/*
	playpause %= 4;
	if(playpause == 0)//pause audio only
	{
		if(isSSAudPrcsForked)
		{
			//set_ir_value((unsigned long)0x70);
			kill(pid_aud, SIGSTOP);
			isSSPrcsStoppedwSIGSTOP = 1;
		}
	}
	else if(playpause == 1)//pause image+tr only
	{
		if(isSSImgPrcsForked)
		{
			kill(pid_img, SIGSTOP);
			kill(pid_tr, SIGSTOP);
			isSSPrcsStoppedwSIGSTOP = 1;
		}
		if(isSSAudPrcsForked)
			//set_ir_value((unsigned long)0x70);
			kill(pid_aud, SIGCONT);
	}
	else if(playpause == 2)//pause all
	{
		if(isSSAudPrcsForked)
		{
			//set_ir_value((unsigned long)0x70);
			kill(pid_aud, SIGSTOP);
			isSSPrcsStoppedwSIGSTOP = 1;
		}
	}
	else//play all
	{
		if(isSSImgPrcsForked)
		{
			kill(pid_img, SIGCONT);
			kill(pid_tr, SIGCONT);
		}
		if(isSSAudPrcsForked)
			//set_ir_value((unsigned long)0x70);
			kill(pid_aud, SIGCONT);
	}
	playpause++;
*/
}
//------------------------------------------------------------------------------------------------
void SS_EscEvent()
{
	stop = 1;
	playpause = 0;

  #ifdef SET_SS_SKY_PRIO
	SkyPrio = getpriority(PRIO_PROCESS, 0);
  	setpriority(PRIO_PROCESS, 0, SkyPrio - SS_SKY_PRIO_LVL);
#endif
	ELMachines[active_index].Shutdown(1);
	//modified by bk@070410 - modified for AutoSlideShow
	if(!strcmp(SelectedDev, DEVICE_AUTOSS_NAME))//slideshow from DS_ACTIVE
	{
		FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
		active_index = DS_ACTIVE;
	}
	//bk @ 080116
	else if(
			!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
		||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
#endif
	)
	{
		FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
		active_index = DS_ACTIVE;
#ifdef NET_MOD
	net_slideshow = 0;
	if(isGWSet!=0)
		ForkNETSocket();		//come back to listen
#endif
	}
	else
	{
#ifdef MEDIALINK
		if (SelectedMT == ICONText4MT[photo])
			active_index = I_ACTIVE;
		else if (SelectedMT == ICONText4MT[video])
			active_index = V_ACTIVE;
		else if (SelectedMT == ICONText4MT[music])
			active_index = A_ACTIVE;
		else if (SelectedMT == ICONText4MT[folder])
			active_index = FLDR_ACTIVE;
#else
		active_index = MT_ACTIVE;
#endif
	}
	//fix tr bug (mantis 117 - robert) by bk @ 070824
	pgu_switch_to_buffer(1);

	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);
	pgu_switch_to_buffer(1);
}
