#ifndef _BASIC_DATA_TYPE_HEADER_
#define _BASIC_DATA_TYPE_HEADER_
//------------------------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>
#include <endian.h>
#include <signal.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <sys/time.h>
#include <dirent.h>
#include <time.h>
#include <linux/rtc.h>
#include <netinet/in.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "custom.h"
#include "displaymode.h"
//------------------------------------------------------------------------------------------------

//#define NEC_IR_PROTOCAL
//#define SONY_IR_PROTOCAL

#define NLS_USE_UTF 8

//#define BLUETOOTH_MOD
#define NET_MOD
//#define _DEBUG
//#define NAS_SL_IMG_ONLY
//#define BATTERY_MOD

//davison @ 2008/02/14
//for touchkey used
//#define TOUCHKEY_MOD
// Synaptics OneTouch
//#define SYNAPTICS_OT
//#define AUTOTEST

//#define GUI_STYLE_COMTEK		//ronaldyang20080626
//#define QMI_BRIGHTNESS

#ifdef NET_MOD
//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
#define NET_DISABLE			1
#define ZYDAS_SUPPORT		1//nelly add 3/3/2008
#define IP_CAM_MOD
#define SUPPORT_RSS 1   //rywu20080516 added this flag
#define WEB_APP_MOD
#endif

#ifdef WEB_APP_MOD
	#define WEB_APP_WEATHER
	#define WEB_APP_NEWS
	//#define WEB_APP_EZPEER
#endif

#ifndef DEPTH_OF_HD_NAS_SEARCH
	#define DEPTH_OF_HD_NAS_SEARCH	2
#endif

#ifdef USE_DESC_TV
  #ifndef TV_BORDER
	#define TV_BORDER 6
  #endif
#endif

///080128
#define LEN_XXL		1024//for UNICODE file path string
///
#define LEN_XL		256//for file path string
#define LEN_L		50//for screen string width
#define LEN_M		10//now using for ds name
#define LEN_S		5

#define _EXIT					_exit(errno == ENOENT ? 127 : 126)

#define MSG(str)				fprintf(stderr, "\n\n{SKYDEMO INFO}<File: %s, Line: %d, Function: %s>\n=>%s", \
						   			   __FILE__, __LINE__, __func__, str)

#define BP						MSG("{BREAK POINT}")

#define PRINTF(str, args...)   	BP;fprintf(stderr, str, ##args)
#ifdef _DEBUG
#define DMSG(str)				fprintf(stderr, "\n\n{DEBUG}<File: %s, Line: %d, Function: %s>\n=>%s", \
						   			   __FILE__, __LINE__, __func__, str)

#define DB						DMSG("{DEBUG}")

#define DPRINTF(str, args...)   	DB;fprintf(stderr, str, ##args)
#define DBG_MSG(str, args...)   	printf(str, ##args)//rywu20080516

#else
#define DBG_MSG(str, args...)//rywu20080516
#define DMSG(str)
#define DB
#define DPRINTF(str, ...)
#endif
//------------------------------------------------------------------------------------------------
typedef signed char		Sint8;
typedef signed short		Sint16;
typedef signed int			Sint32;
typedef signed long		SLint32;
typedef unsigned char		Uint8;
typedef unsigned short	Uint16;
typedef unsigned int		Uint32;
typedef unsigned long		ULint32;
//------------------------------------------------------------------------------------------------
typedef struct
{
	Uint16 x;
	Uint16 y;
	Uint16 width;
	Uint16 height;
}COORD;
#endif
