#include "events.h"
#include "parser.h"
//------------------------------------------------------------------------------------------------
void UpdateVID()
{
	FRAME *elmf;
	int PrevFrameNO, CurrFrameNO;

	elmf = &ELMachines[active_index].frame;
	
	PrevFrameNO = elmf->active_frame_index;
	CurrFrameNO = elmf->active_frame_index = elmf->active_icon_index/ICON_NUM_PER_FRAME;
	
	if(PrevFrameNO == CurrFrameNO)
		DrawFocusedICON(RGB1, 1);
	else
		VidDisplay();
}
//------------------------------------------------------------------------------------------------
// Video callbacks																					    
//------------------------------------------------------------------------------------------------
void V_UpEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;
		
	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);
	elmf->active_icon_index -= ICON_NUM_PER_ROW;
	if(elmf->active_icon_index < 0)
	{
		if(VidCount % ICON_NUM_PER_FRAME > 0)
			elmf->active_icon_index += ((int)(VidCount / ICON_NUM_PER_ROW) + 1) * ICON_NUM_PER_ROW;
		else
			elmf->active_icon_index += ((int)(VidCount / ICON_NUM_PER_ROW)) * ICON_NUM_PER_ROW;
			
		if(elmf->active_icon_index > VidCount - 1)
		{
			if(VidCount % ICON_NUM_PER_FRAME < ICON_NUM_PER_ROW)
				elmf->active_icon_index = VidCount - 1;
			else
				elmf->active_icon_index = elmf->active_icon_index - ICON_NUM_PER_ROW;
		}
		
		tmplist = VideoList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
		VidDisplay();
	}
	else
	{
		tmplist = elmf->CurrVidListPos;
		while(tmplist != NULL && i < ICON_NUM_PER_ROW)
		{
			tmplist = tmplist->prev;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
		UpdateVID();
	}
}
//------------------------------------------------------------------------------------------------
void V_DownEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;
		
	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);
	elmf->active_icon_index += ICON_NUM_PER_ROW;
	if(elmf->active_icon_index > VidCount - 1)
	{
		if(0 < (VidCount % ICON_NUM_PER_FRAME) && (VidCount % ICON_NUM_PER_FRAME) < ICON_NUM_PER_ROW)//only one row at the last frame
		{
			if(elmf->active_icon_index % ICON_NUM_PER_FRAME < ICON_NUM_PER_ROW)
				elmf->active_icon_index = VidCount - 1;
			else
				elmf->active_icon_index %= ICON_NUM_PER_ROW;
		}else
			elmf->active_icon_index %= ICON_NUM_PER_ROW;
		
		tmplist = VideoList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
		VidDisplay();
	}
	else
	{
		tmplist = elmf->CurrVidListPos;
		while(tmplist != NULL && i < ICON_NUM_PER_ROW)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
		UpdateVID();
	}
}
//------------------------------------------------------------------------------------------------
void V_LeftEvent()
{
	FRAME *elmf;
	LIST *tmplist;
	Uint32 i = 0;

	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);	
	elmf->active_icon_index -= 1;
	if(elmf->active_icon_index == -1)
	{
		elmf->active_icon_index += VidCount;
		
		tmplist = VideoList;
		while(tmplist != NULL && i < VidCount)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
		VidDisplay();
	}
	else
	{
		elmf->CurrVidListPos = elmf->CurrVidListPos->prev;
		UpdateVID();
	}
}
//------------------------------------------------------------------------------------------------
void V_RightEvent()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);
	elmf->active_icon_index += 1;
	if(elmf->active_icon_index == VidCount)
	{
		elmf->active_icon_index = 0;
		elmf->CurrVidListPos = VideoList->next;
		VidDisplay();
	}
	else
	{
		elmf->CurrVidListPos = elmf->CurrVidListPos->next;
		UpdateVID();
	}
}
//------------------------------------------------------------------------------------------------
void V_NextEvent()
{
	FRAME *elmf;
	int ICONum, MoveStep;
	LIST *tmplist;
	Uint32 i = 0;
	
	elmf = &ELMachines[active_index].frame;
	ICONum = ICON_NUM_PER_FRAME;
	MoveStep = ICONum - (elmf->active_icon_index % ICONum);
	elmf->active_icon_index = elmf->active_icon_index + MoveStep;

	if(elmf->active_icon_index > (VidCount - 1))
	{
		elmf->active_icon_index = 0;
		elmf->CurrVidListPos = VideoList->next;
	}
	else
	{
		tmplist = elmf->CurrVidListPos;
		while(tmplist != NULL && i < MoveStep)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
	}
	VidDisplay();
}
//------------------------------------------------------------------------------------------------
void V_PrevEvent()
{
	FRAME *elmf;
	int ICONum, MoveStep;
	LIST *tmplist;
	Uint32 i = 0;
	
	elmf = &ELMachines[active_index].frame;
	ICONum = ICON_NUM_PER_FRAME;
	MoveStep = ICONum + (elmf->active_icon_index % ICONum);
	elmf->active_icon_index = elmf->active_icon_index - MoveStep;

	if(elmf->active_icon_index < 0)
	{
		if((VidCount % ICONum) == 0)
			elmf->active_icon_index = VidCount -  ICONum;
		else
			elmf->active_icon_index = VidCount - (VidCount % ICONum);
				
		tmplist = VideoList->next;
		while(tmplist != NULL && i < elmf->active_icon_index)
		{
			tmplist = tmplist->next;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
	}
	else
	{
		tmplist = elmf->CurrVidListPos;
		while(tmplist != NULL && i < MoveStep)
		{
			tmplist = tmplist->prev;
			i++;
		}
		elmf->CurrVidListPos = tmplist;
	}
	VidDisplay();
}
//------------------------------------------------------------------------------------------------
void V_PlayPauseEvent()
{
	V_EnterEvent();
}
//------------------------------------------------------------------------------------------------
void V_EnterEvent()
{
	//modify for parsing video plyable by bk@070502
	FRAME *elmf;
	char s[LEN_XL];
	FileInfo finfo;
	
	elmf = &ELMachines[active_index].frame;
	GetPath(s);
	strcat(s, elmf->CurrVidListPos->fname);
	if(MediaParser(s, &finfo) == PlayableVideo)
	{
		active_index = FV_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
	//else
		//PRINTF("%s is not supported!\n", s);
}
//------------------------------------------------------------------------------------------------
void V_EscEvent()
{
	ELMachines[active_index].Shutdown(0);
	active_index = MT_ACTIVE;
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
}
