#include "webapp.h"

#ifdef WEB_APP_MOD

WEB_APP_GLOBAL_STURCT g_WebApp = {0};


//------------------------------------------------------------------------------------------------

#ifdef WEB_APP_WEATHER
//------------------------------------
//	Ѯ
//------------------------------------

void WebApp_Weather_EscEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_WEATHER) return;

	//shutdown the machine
	ELMachines[active_index].Shutdown(0);
	active_index = NET_DS_ACTIVE;
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
}

void WebApp_Weather_UpEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_WEATHER) return;
	if (   g_WebApp.curr_page == WEB_APP_PAGE_WEATHER_TODAY
		|| g_WebApp.curr_page == WEB_APP_PAGE_WEATHER_TOMORROW
	   )
	{
		FORMVIEW_DataFocus_PrevLine(g_WebApp.wt_view_weather);
	}
}

void WebApp_Weather_DownEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_WEATHER) return;
	if (   g_WebApp.curr_page == WEB_APP_PAGE_WEATHER_TODAY
		|| g_WebApp.curr_page == WEB_APP_PAGE_WEATHER_TOMORROW
	   )
	{
		FORMVIEW_DataFocus_NextLine(g_WebApp.wt_view_weather);
	}
}

void WebApp_Weather_Init()
{
	FRAME *elmf = &ELMachines[active_index].frame;
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_form);

	memset(&g_WebApp, 0, sizeof(WEB_APP_GLOBAL_STURCT));

	g_WebApp.curr_func = WEB_APP_FUNCTION_WEATHER;
	g_WebApp.curr_page = WEB_APP_PAGE_WEATHER_TODAY;

	g_WebApp.wt_form_weather = WebApp_Weather_Create_Form_Weather();
	g_WebApp.wt_view_weather = WebApp_Weather_Create_View_Weather();
}

void WebApp_Weather_Display()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_WEATHER) return;

	FRAME *elmf = &ELMachines[active_index].frame;
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGBlock2YUVBlock(elmf->rgbtemplate, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);
	pgu_switch_to_buffer(1);

	if (   g_WebApp.curr_page == WEB_APP_PAGE_WEATHER_TODAY
		|| g_WebApp.curr_page == WEB_APP_PAGE_WEATHER_TOMORROW
	   )
	{
		FORMVIEW_DrawFieldRow(g_WebApp.wt_view_weather, 1);
		FORMVIEW_DrawData(g_WebApp.wt_view_weather, 1);
	}
}

void WebApp_Weather_ShutDown()
{
	FORMVIEW_Close(&g_WebApp.wt_view_weather);
	SKYFORM_ReleaseForm(&g_WebApp.wt_form_weather);
	ResetBackgroundInfo();
}

SKYFORM* WebApp_Weather_Create_Form_Weather()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_WEATHER) return NULL;

	SKYFORM *pForm = NULL;
	char path[LEN_XL] = {0};
	char mdat[LEN_L] = {0};
	char cmd[LEN_L] = {0};
	char exe[LEN_XL] = {0};

	pid_t pid;
	int status;

	strcpy(exe, WEB_APP_WEATHER_EXE_PARSER);
	strcpy(path, WEB_APP_WEATHER_PATH_DOWNLOAD);

	switch (g_WebApp.curr_page)
	{
	case WEB_APP_PAGE_WEATHER_TODAY:
		strcpy(cmd, WEB_APP_WEATHER_CMD_TODAY);
		strcpy(mdat, WEB_APP_WEATHER_MDAT_TODAY);
		break;
	case WEB_APP_PAGE_WEATHER_TOMORROW:
		strcpy(cmd, WEB_APP_WEATHER_CMD_TOMORROW);
		strcpy(mdat, WEB_APP_WEATHER_MDAT_TOMORROW);
		break;
	case WEB_APP_PAGE_WEATHER_WEEK:
		strcpy(cmd, WEB_APP_WEATHER_CMD_WEEK);
		strcpy(mdat, WEB_APP_WEATHER_MDAT_WEEK);
		break;
	case WEB_APP_PAGE_WEATHER_UVINDEX:
		strcpy(cmd, WEB_APP_WEATHER_CMD_UVINDEX);
		strcpy(mdat, WEB_APP_WEATHER_MDAT_UVINDEX);
		break;
	case WEB_APP_PAGE_WEATHER_TRAVEL:
		strcpy(cmd, WEB_APP_WEATHER_CMD_TRAVEL);
		strcpy(mdat, WEB_APP_WEATHER_MDAT_TRAVEL);
		break;
	default:
		break;
	}

	if (!(*exe) || !(*path) || !(*cmd) || !(*mdat)) return NULL;

	pid = fork();
	switch(pid)
	{
	case -1:
		perror("Fork failed!");
		DMSG("Fork to Weather Parser Fail!");
		break;
		//exit(1);
	case 0:
		//child process
		execl(exe, strrchr(exe,'/')+1, cmd,
			  path, mdat, NULL);
		_EXIT;
	default:
		//parent process
		waitpid(pid, &status, 0);
		if(WIFEXITED(status))
		{
			strcat(path, mdat);
			pForm = SKYFORM_CreateFormFromFile(path);
			sprintf(cmd, "rm %s", path);
			system(cmd);
			system("sync");
		}
		break;
	}

	if (!pForm) return NULL;

	//Bz
	int temperature_field = 2;	//
	int temperature_key = 3;	//s
	char *pData = NULL;
	char strDegree[] = "&deg;C";
	int i, j;

	switch (g_WebApp.curr_page)
	{
	case WEB_APP_PAGE_WEATHER_TODAY:
	case WEB_APP_PAGE_WEATHER_TOMORROW:
		//h"&deg;"
		for (i=0; i<pForm->nTable; i++)
		{
			if (  pForm->Table[i].nField > temperature_field
				&&
				  pForm->nKey > temperature_key
				&&
				  pForm->Table[i].Field[temperature_field] == pForm->Key[temperature_key]
			   )
			{
				for (j=0; j<pForm->Table[i].nItem; j++)
				{
					pData = pForm->Table[i].Value[temperature_field][j]->data;
					if ((pData = strstr(pData, strDegree)))
					{
                        strcpy(pData, "");	//ȮɥhAH令CŸ
					}
				}
			}
		}
		break;
	default:
		break;
	}

	return pForm;
}
 
FORMVIEW* WebApp_Weather_Create_View_Weather()
{
	if (  g_WebApp.curr_func != WEB_APP_FUNCTION_WEATHER
		||
		  !g_WebApp.wt_form_weather
	   )
	{
		return NULL;
	}

///Weather FormviewyЩwq
Uint16 nRowPerLine = 1;
Uint16 nLinePerPage = desc->MusicBarNum;
COORD crdView = {0, 0, OUTPUT_XRES, OUTPUT_YRES};
int nCellPerRow = 4;

COORD crdFieldCell[4] = {
						{  0, 0, 120, g_pFontDB_Default->FontSize},	
						{120, 0, 120, g_pFontDB_Default->FontSize},
						{240, 0, 120, g_pFontDB_Default->FontSize},
						{360, 0, 120, g_pFontDB_Default->FontSize}
					    };
COORD crdDataRow = {0, 0, 480, g_pFontDB_Default->FontSize};
COORD crdDataCell[4] = {
						{  0, 0, 120, g_pFontDB_Default->FontSize},	
						{120, 0, 120, g_pFontDB_Default->FontSize},
						{240, 0, 120, g_pFontDB_Default->FontSize},
						{360, 0, 120, g_pFontDB_Default->FontSize}
					   };
WORD betweenrow = desc->MusicBarCoord[1].y-desc->MusicBarCoord[0].y-g_pFontDB_Default->FontSize;
COORD crdData = {desc->MusicBarCoord[0].x, desc->MusicBarCoord[0].y,
				 480, (crdDataRow.height+betweenrow)*nLinePerPage/*332*/};
COORD crdFieldRow = {crdData.x, crdData.y-betweenrow-g_pFontDB_Default->FontSize,
					480, g_pFontDB_Default->FontSize};
WORD dest_rgb = 1;
WORD dest_yuv = 1;
///
	FORMVIEW *pview = NULL;
	//FORMVIEW_CELL *pcell = NULL;
	FORMVIEW_ROW *prow = NULL;
	Uint8 bSuccess = 0, bFail = 0;
	int i, j;
	Uint16 total_rows_per_page = 0;

	for (;;)
	{
		//l@view
		pview = FORMVIEW_Create(g_WebApp.wt_form_weather);
		if (!pview) break;

        //[J
		for (j=0; j<nCellPerRow; j++)
		{
			if (!FORMVIEW_AddField(pview, 0, j))
			{
				bFail = 1; break;
			}
		}
		if (bFail) break;

		//[JƦC
		for (i=0; i<pview->pForm->nTable; i++)
		{
			for (j=0; j<pview->pForm->Table[i].nItem; j++)
			{
				if (!FORMVIEW_AddDataRow(pview, i, j))
				{
					bFail = 1; break;
				}
			}
			if (bFail) break;
		}
		if (bFail) break;

		//pview->default_use_utf = NLS_USE_UTF;
		pview->dest_rgb = dest_rgb;
		pview->dest_yuv = dest_yuv;
		pview->nRowPerLine = nRowPerLine;	//1(M櫬)
		pview->nLinePerPage = nLinePerPage;
		total_rows_per_page = pview->nRowPerLine * pview->nLinePerPage;

		//qy
		pview->crdView = crdView;
		pview->crdData = crdData;
		for (i=0; i<total_rows_per_page; i++)
		{
			pview->crdDataRow[i] = crdDataRow;
			pview->crdDataRow[i].y = i*crdDataRow.height + i*betweenrow;
		}
		for (j=0; j<nCellPerRow; j++)
		{
			pview->crdDataCell[j] = crdDataCell[j];
		}
		pview->crdFieldRow = crdFieldRow;
		for (j=0; j<nCellPerRow; j++)
		{
			pview->crdFieldCell[j] = crdFieldCell[j];
		}

		bSuccess = 1;
		break;
	}

	if (!bSuccess)
	{
		FORMVIEW_Close(&pview);
		return NULL;
	}

	return pview;
}

#endif	//weather

//------------------------------------------------------------------------------------------------

//------------------------------------
//	sD
//------------------------------------
#ifdef WEB_APP_NEWS
void WebApp_News_Init()
{
	FRAME *elmf = &ELMachines[active_index].frame;
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_form);

	memset(&g_WebApp, 0, sizeof(WEB_APP_GLOBAL_STURCT));

	g_WebApp.curr_func = WEB_APP_FUNCTION_NEWS;
	g_WebApp.curr_page = WEB_APP_PAGE_NEWS_POLITICS;

	g_WebApp.nw_form_news = WebApp_News_Create_Form_News();
	g_WebApp.nw_view_news = WebApp_News_Create_View_News();
}
void WebApp_News_Display()
{
	FRAME *elmf = &ELMachines[active_index].frame;

	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGBlock2YUVBlock(elmf->rgbtemplate, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);
	pgu_switch_to_buffer(1);

	WebApp_News_UpdateView();
}
void WebApp_News_ShutDown()
{
	FORMVIEW_Close(&g_WebApp.nw_view_news);
	SKYFORM_ReleaseForm(&g_WebApp.nw_form_news);
	ResetBackgroundInfo();
}

void WebApp_News_UpdateView()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS) return;
	if (g_WebApp.curr_page != WEB_APP_PAGE_NEWS_CONTENT)
	{
		FORMVIEW_DrawData(g_WebApp.nw_view_news, 1);
	}
	else	//Content
	{
		FORMVIEW_DrawData(g_WebApp.nw_view_content, 1);
		//FORMVIEW_DrawDataCell(g_WebApp.nw_view_content, 0, 0);
	}
}

void WebApp_News_UpEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS) return;
	if (g_WebApp.curr_page != WEB_APP_PAGE_NEWS_CONTENT)
	{
		FORMVIEW_DataFocus_PrevLine(g_WebApp.nw_view_news);
	}
	else
	{
		FORMVIEW_DataCell_ScrollUp(g_WebApp.nw_view_content, 0, 0);
	}
}

void WebApp_News_DownEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS) return;
	if (g_WebApp.curr_page != WEB_APP_PAGE_NEWS_CONTENT)
	{
		FORMVIEW_DataFocus_NextLine(g_WebApp.nw_view_news);
	}
	else
	{
		FORMVIEW_DataCell_ScrollDown(g_WebApp.nw_view_content, 0, 0);
	}
}

void WebApp_News_EnterEvent()
{
	FORMVIEW *pview = NULL;
	FORMVIEW_CELL *pcell = NULL;
	char *url = NULL;

	if (g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS) return;
	if (g_WebApp.curr_page != WEB_APP_PAGE_NEWS_CONTENT)
	{
		pview = g_WebApp.nw_view_news;
		//ourlcell
		if (!(pcell = FORMVIEW_GetDataCell(pview, pview->curr_row_index, 1))) return;

		if (pcell->value && (url=pcell->value->data))
		{
			g_WebApp.nw_form_content = WebApp_News_Create_Form_Content(url);
			if (!g_WebApp.nw_form_content) return;

			g_WebApp.nw_view_content = WebApp_News_Create_View_Content();
			if (!g_WebApp.nw_view_content) return;

			g_WebApp.prev_page = g_WebApp.curr_page;
			g_WebApp.curr_page = WEB_APP_PAGE_NEWS_CONTENT;
			WebApp_News_UpdateView();
		}
	}
}

void WebApp_News_EscEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS) return;

	if (g_WebApp.curr_page != WEB_APP_PAGE_NEWS_CONTENT)
	{
		//shutdown the machine
		ELMachines[active_index].Shutdown(0);
		active_index = NET_DS_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
	else	//Content
	{
		FORMVIEW_Close(&g_WebApp.nw_view_content);
		SKYFORM_ReleaseForm(&g_WebApp.nw_form_content);
		g_WebApp.curr_page = g_WebApp.prev_page;
		WebApp_News_UpdateView();		
	}
}


SKYFORM* WebApp_News_Create_Form_News()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS) return NULL;

	SKYFORM *pForm = NULL;
	char path[LEN_XL] = {0};
	char mdat[LEN_L] = {0};
	char cmd[LEN_L] = {0};
	char exe[LEN_XL] = {0};

	pid_t pid;
	int status;

	strcpy(exe, WEB_APP_NEWS_EXE_PARSER);
	strcpy(path, WEB_APP_NEWS_PATH_DOWNLOAD);

	switch (g_WebApp.curr_page)
	{
	case WEB_APP_PAGE_NEWS_POLITICS:
		strcpy(cmd, WEB_APP_NEWS_CMD_POLITICS);
		strcpy(mdat, WEB_APP_NEWS_MDAT_POLITICS);
		break;
	case WEB_APP_PAGE_NEWS_SOCIETY:
		strcpy(cmd, WEB_APP_NEWS_CMD_SOCIETY);
		strcpy(mdat, WEB_APP_NEWS_MDAT_SOCIETY);
		break;
	case WEB_APP_PAGE_NEWS_TAIWAN:
		strcpy(cmd, WEB_APP_NEWS_CMD_TAIWAN);
		strcpy(mdat, WEB_APP_NEWS_MDAT_TAIWAN);
		break;
	case WEB_APP_PAGE_NEWS_INTL:
		strcpy(cmd, WEB_APP_NEWS_CMD_INTL);
		strcpy(mdat, WEB_APP_NEWS_MDAT_INTL);
		break;
	default:
		break;
	}

	if (!(*exe) || !(*path) || !(*cmd) || !(*mdat)) return NULL;

	pid = fork();
	switch(pid)
	{
	case -1:
		perror("Fork failed!");
		DMSG("Fork to Weather Parser Fail!");
		break;
		//exit(1);
	case 0:
		//child process
		execl(exe, strrchr(exe,'/')+1, cmd,
			  path, mdat, NULL);
		_EXIT;
	default:
		//parent process
		waitpid(pid, &status, 0);
		if(WIFEXITED(status))
		{
			strcat(path, mdat);
			pForm = SKYFORM_CreateFormFromFile(path);
			sprintf(cmd, "rm %s", path);
			system(cmd);
			system("sync");
		}
		break;
	}

	return pForm;
}

FORMVIEW* WebApp_News_Create_View_News()
{
	if (  g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS
		||
		  !g_WebApp.nw_form_news
	   )
	{
		return NULL;
	}

///Weather FormviewyЩwq
Uint16 nRowPerLine = 1;
Uint16 nLinePerPage = desc->MusicBarNum;
COORD crdView = {0, 0, OUTPUT_XRES, OUTPUT_YRES};

int nCellPerRow = 3;
COORD crdFieldCell[3] = {
						{0, 0, 480, g_pFontDB_Default->FontSize},	
						{0, 0, 480, g_pFontDB_Default->FontSize},
						{0, 0, 480, g_pFontDB_Default->FontSize},
					    };
COORD crdDataRow = {0, 0, 480, g_pFontDB_Default->FontSize};
COORD crdDataCell[3] = {
						{0, 0, 480, g_pFontDB_Default->FontSize},	
						{0, 0, 480, g_pFontDB_Default->FontSize},
						{0, 0, 480, g_pFontDB_Default->FontSize},
					   };
WORD betweenrow = desc->MusicBarCoord[1].y-desc->MusicBarCoord[0].y-g_pFontDB_Default->FontSize;
COORD crdData = {desc->MusicBarCoord[0].x, desc->MusicBarCoord[0].y,
				 480, (crdDataRow.height+betweenrow)*nLinePerPage/*332*/};
COORD crdFieldRow = {crdData.x, crdData.y-betweenrow-g_pFontDB_Default->FontSize,
					480, g_pFontDB_Default->FontSize};
WORD dest_rgb = 1;
WORD dest_yuv = 1;
///
	FORMVIEW *pview = NULL;
	FORMVIEW_CELL *pcell = NULL;
	FORMVIEW_ROW *prow = NULL;
	Uint8 bSuccess = 0, bFail = 0;
	int i, j;
	Uint16 total_rows_per_page = 0;

	for (;;)
	{
		//l@view
		pview = FORMVIEW_Create(g_WebApp.nw_form_news);
		if (!pview) break;

		//[J
		for (j=0; j<nCellPerRow; j++)
		{
			if (!FORMVIEW_AddField(pview, 0, j))
			{
				bFail = 1; break;
			}
		}
		if (bFail) break;

		//[JƦC
		for (i=0; i<pview->pForm->nTable; i++)
		{
			for (j=0; j<pview->pForm->Table[i].nItem; j++)
			{
				if (!FORMVIEW_AddDataRow(pview, i, j))
				{
					bFail = 1; break;
				}
			}
			if (bFail) break;
		}
		if (bFail) break;

		pview->dest_rgb = dest_rgb;
		pview->dest_yuv = dest_yuv;
		pview->nRowPerLine = nRowPerLine;	//1(M櫬)
		pview->nLinePerPage = nLinePerPage;
		total_rows_per_page = pview->nRowPerLine * pview->nLinePerPage;

		//qy
		pview->crdView = crdView;
		pview->crdData = crdData;
		for (i=0; i<total_rows_per_page; i++)
		{
			pview->crdDataRow[i] = crdDataRow;
			pview->crdDataRow[i].y = i*crdDataRow.height + i*betweenrow;
		}
		for (j=0; j<nCellPerRow; j++)
		{
			pview->crdDataCell[j] = crdDataCell[j];
		}

		//ODN]
		prow = pview->datarow_list;
		while (prow)
		{
			if (  (pcell = prow->cell_list)
				&&
				  (pcell = pcell->next)	//qĤG}l
			   )
			{
				while (pcell)
				{
					pcell->invisible = 1;
					pcell = pcell->next;
				}
			}
			prow = prow->next;
		}

		bSuccess = 1;
		break;
	}

	if (!bSuccess)
	{
		FORMVIEW_Close(&pview);
		return NULL;
	}

	return pview;
}

SKYFORM* WebApp_News_Create_Form_Content(char *url)
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS) return NULL;
	if (!url || !(*url)) return NULL;

	SKYFORM *pForm = NULL;
	char path[LEN_XL] = {0};
	char mdat[LEN_L] = {0};
	char cmd[LEN_L] = {0};
	char exe[LEN_XL] = {0};

	pid_t pid;
	int status;

	strcpy(exe, WEB_APP_NEWS_EXE_PARSER);
	strcpy(path, WEB_APP_NEWS_PATH_DOWNLOAD);
	strcpy(cmd, WEB_APP_NEWS_CMD_NEWSMATTER);
	strcpy(mdat, WEB_APP_NEWS_MDAT_NEWSMATTER);

	if (!(*exe) || !(*path) || !(*cmd) || !(*mdat)) return NULL;

	pid = fork();
	switch(pid)
	{
	case -1:
		perror("Fork failed!");
		DMSG("Fork to Weather Parser Fail!");
		break;
		//exit(1);
	case 0:
		//child process
		execl(exe, strrchr(exe,'/')+1, cmd,
			  path, mdat, url, NULL);
		_EXIT;
	default:
		//parent process
		waitpid(pid, &status, 0);
		if(WIFEXITED(status))
		{
			strcat(path, mdat);
			pForm = SKYFORM_CreateFormFromFile(path);
			sprintf(cmd, "rm %s", path);
			system(cmd);
			system("sync");
		}
		break;
	}

	return pForm;
}

FORMVIEW* WebApp_News_Create_View_Content()
{
	if (  g_WebApp.curr_func != WEB_APP_FUNCTION_NEWS
		||
		  !g_WebApp.nw_form_content
	   )
	{
		return NULL;
	}

///Weather FormviewyЩwq
Uint16 nRowPerLine = 1;
Uint16 nLinePerPage = 1;
COORD crdView = {0, 0, OUTPUT_XRES, OUTPUT_YRES};
int nCellPerRow = 1;
COORD crdFieldCell[1] = {
						{0, 0, 480, g_pFontDB_Default->FontSize}	
					    };
WORD betweenrow = desc->MusicBarCoord[1].y-desc->MusicBarCoord[0].y-g_pFontDB_Default->FontSize;
COORD crdDataRow = {0, 0, 480, (desc->MusicBarCoord[0].height+betweenrow)*desc->MusicBarNum};
COORD crdDataCell[1] = {
						{0, 0, 480, crdDataRow.height}	
					   };

COORD crdData = {desc->MusicBarCoord[0].x, desc->MusicBarCoord[0].y,
				480, crdDataRow.height};
COORD crdFieldRow = {crdData.x, crdData.y-betweenrow-g_pFontDB_Default->FontSize,
					480, g_pFontDB_Default->FontSize};
WORD dest_rgb = 1;
WORD dest_yuv = 1;
///
	FORMVIEW *pview = NULL;
	FORMVIEW_CELL *pcell = NULL;
	FORMVIEW_ROW *prow = NULL;
	Uint8 bSuccess = 0, bFail = 0;
	int i, j;
	Uint16 total_rows_per_page = 0;

	for (;;)
	{
		//l@view
		pview = FORMVIEW_Create(g_WebApp.nw_form_content);
		if (!pview) break;

		//[J
		for (j=0; j<nCellPerRow; j++)
		{
			if (!FORMVIEW_AddField(pview, 0, j))
			{
				bFail = 1; break;
			}
		}
		if (bFail) break;

		//[JƦC
		for (i=0; i<pview->pForm->nTable; i++)
		{
			for (j=0; j<pview->pForm->Table[i].nItem; j++)
			{
				if (!FORMVIEW_AddDataRow(pview, i, j))
				{
					bFail = 1; break;
				}
			}
			if (bFail) break;
		}
		if (bFail) break;

		pview->dest_rgb = dest_rgb;
		pview->dest_yuv = dest_yuv;
		pview->nRowPerLine = nRowPerLine;	//1(M櫬)
		pview->nLinePerPage = nLinePerPage;
		total_rows_per_page = pview->nRowPerLine * pview->nLinePerPage;

		//qy
		pview->crdView = crdView;
		pview->crdData = crdData;
		for (i=0; i<total_rows_per_page; i++)
		{
			pview->crdDataRow[i] = crdDataRow;
			pview->crdDataRow[i].y = i*crdDataRow.height + i*betweenrow;
		}
		for (j=0; j<nCellPerRow; j++)
		{
			pview->crdDataCell[j] = crdDataCell[j];
		}

		//hBz
		if (0 != FORMVIEW_ArrangeMultiLineCell(pview, 0, 0)) break;

		bSuccess = 1;
		break;
	}

	if (!bSuccess)
	{
		FORMVIEW_Close(&pview);
		return NULL;
	}

	return pview;
}

#endif	//news

//------------------------------------------------------------------------------------------------

//------------------------------------
//	ezPeer
//------------------------------------
#ifdef WEB_APP_EZPEER

void WebApp_ezPeer_EscEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_EZPEER) return;
	if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER)
	{
		//shutdown the machine
		ELMachines[active_index].Shutdown(0);
		active_index = NET_DS_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
	else if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_IGRS)
	{
		//^qM
		WebApp_ezPeer_Stop_Audio(0);
		IGRS_SCRIPT_Release(&g_WebApp.ez_script_igrs);
		IGRSVIEW_Close(&g_WebApp.ez_view_igrs);
		g_WebApp.curr_page = WEB_APP_PAGE_EZPEER_FOLDER;
		WebApp_ezPeer_Display();
	}
}

//---------------------------------------------------------------------------
/*
//Barry 2008-05-30
void save_klr_pic(char *klr_filename)
{
	int pos=0, hdr_len=0, pic_cnt=0, idx=0;
	FILE *input_klr, *klr_pic;
	char klr_hdr[4], klr_tmp[4];
	long *klr_offset=0, *pic_len=0;
	unsigned char *pic_data;

	if (NULL == (input_klr = fopen(klr_filename, "rb")))
	{
                printf("Open KLR : Unable to open input file %s\n", klr_filename);
	}

	fseek(input_klr, 0, SEEK_SET);
	while (!feof(input_klr))
	{
		fread(&klr_hdr, 1, 3, input_klr);
		fread(&klr_tmp, 1, 4, input_klr);
		hdr_len = klr_tmp[0] | (klr_tmp[1] << 8) | (klr_tmp[2] << 16) | (klr_tmp[3] << 24);

		if ((klr_hdr[0] == 'R') && (klr_hdr[1] == 'E') && (klr_hdr[2] == 'S'))
		{
			pos += 7;
			break;
		}
		else
		{
			pos += (hdr_len+3+4);
			fseek(input_klr, pos, SEEK_SET);
		}
	}
	fread(&klr_hdr, 1, 4, input_klr);
	if ((klr_hdr[0] == 'R') && (klr_hdr[1] == 'E') && (klr_hdr[2] == 'S') && (klr_hdr[3] == 0x19))
	{
		fread(&klr_tmp, 1, 2, input_klr);
		pic_cnt = klr_tmp[0] | (klr_tmp[1] << 8);
		pos += 16;
		fseek(input_klr, pos, SEEK_SET);

		klr_offset = (long *)malloc(sizeof(long)*pic_cnt);
		pic_len = (long *)malloc(sizeof(long)*pic_cnt);

		for (idx=0; idx < pic_cnt; idx++)
		{
			fread(&klr_tmp, 1, 4, input_klr);
			klr_offset[idx] = klr_tmp[0] | (klr_tmp[1] << 8) | (klr_tmp[2] << 16) | (klr_tmp[3] << 24);
			fread(&klr_tmp, 1, 4, input_klr);
			pic_len[idx] = klr_tmp[0] | (klr_tmp[1] << 8) | (klr_tmp[2] << 16) | (klr_tmp[3] << 24);
			pos += 16;
			fseek(input_klr, pos, SEEK_SET);
		}
		
		fseek(input_klr, klr_offset[0]+4, SEEK_SET);
		if (NULL == (klr_pic = fopen("/tmp/01.jpg", "wb")))
		{
			printf("Write KLR Pic: Unable to write.\n");
		}	
		pic_data = (unsigned char *)malloc(pic_len[0]);
		fread(pic_data, 1, pic_len[0], input_klr);
		fwrite(pic_data, 1, pic_len[0], klr_pic);
		free(pic_data);
		fclose(klr_pic);

		fseek(input_klr, klr_offset[1]+4, SEEK_SET);
		if (NULL == (klr_pic = fopen("/tmp/02.jpg", "wb")))
		{
			printf("Write KLR Pic: Unable to write.\n");
		}	
		pic_data = (unsigned char *)malloc(pic_len[1]);
		fread(pic_data, 1, pic_len[1], input_klr);
		fwrite(pic_data, 1, pic_len[1], klr_pic);
		free(pic_data);
		fclose(klr_pic);

		free(klr_offset);
		free(pic_len);		
	}
	
	fclose(input_klr);
}
*/
//---------------------------------------------------------------------------

void WebApp_ezPeer_EnterEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_EZPEER) return;
	if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER)
	{
		char fn[LEN_XL] = {0}, *ext = NULL;
		FORMVIEW_CELL *pcell = NULL;
		pcell = FORMVIEW_GetDataCell(g_WebApp.ez_view_folder, g_WebApp.ez_view_folder->curr_row_index, 0);
		if (   !pcell
			|| !pcell->value->data
			|| pcell->value->format != SKYFORM_FORMAT_FILENAME
		   )
		{
			return;
		}

		//kurɮ
		sprintf(fn, "%s", pcell->value->data);
		ext = strrchr(fn, '.');
		strcpy(ext, ".klr");

		if (access(fn, R_OK) == 0)
		{
			//Barry 2008-05-30
			//save_klr_pic(fn);

			if (  (g_WebApp.ez_script_igrs = IGRS_SCRIPT_Create(fn))
				&&
				  (g_WebApp.ez_view_igrs = WebApp_ezPeer_Create_View_IGRS(g_WebApp.ez_script_igrs))
			   )
			{
				WebApp_ezPeer_Stop_Audio(0);

				IGRSVIEW_Reset_View(g_WebApp.ez_view_igrs);
				IGRSVIEW_Draw_View(g_WebApp.ez_view_igrs);

				set_mplayer_play_time(0);
				WebApp_ezPeer_Play_Audio(0, 0);
				g_WebApp.curr_page = WEB_APP_PAGE_EZPEER_IGRS;
			}
			else
			{
				IGRS_SCRIPT_Release(&g_WebApp.ez_script_igrs);
				IGRSVIEW_Close(&g_WebApp.ez_view_igrs);
			}
		}
	}
}

void WebApp_ezPeer_PlayPauseEvent()
{
	WebApp_ezPeer_Play_Audio(0, 1);
}

void WebApp_ezPeer_StopEvent()
{
	WebApp_ezPeer_Stop_Audio(1);
}

void WebApp_ezPeer_DownEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_EZPEER) return;
	if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER)
	{
		FORMVIEW_DataFocus_NextLine(g_WebApp.ez_view_folder);
	}
}

void WebApp_ezPeer_UpEvent()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_EZPEER) return;
	if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER)
	{
		FORMVIEW_DataFocus_PrevLine(g_WebApp.ez_view_folder);
	}
}

void WebApp_ezPeer_Init()
{
	FRAME *elmf = &ELMachines[active_index].frame;
	elmf->rgbtemplate = (Uint8*)InitFrameBackground(bkg_form);

	memset(&g_WebApp, 0, sizeof(WEB_APP_GLOBAL_STURCT));

	g_WebApp.curr_func = WEB_APP_FUNCTION_EZPEER;
	g_WebApp.curr_page = WEB_APP_PAGE_EZPEER_FOLDER;

	//oUؿMFORMVIEW
	g_WebApp.ez_view_folder = WebApp_ezPeer_Create_View_Folder();
}
void WebApp_ezPeer_Display()
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_EZPEER) return;

	FRAME *elmf = &ELMachines[active_index].frame;
	memcpy(RGB1, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
	RGBlock2YUVBlock(elmf->rgbtemplate, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);
	pgu_switch_to_buffer(1);

	if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER)
	{
		FORMVIEW_DrawData(g_WebApp.ez_view_folder, 1);
	}
}
void WebApp_ezPeer_ShutDown()
{
	WebApp_ezPeer_Stop_Audio(1);
	FORMVIEW_Close(&g_WebApp.ez_view_folder);
	ResetBackgroundInfo();
}

FORMVIEW* WebApp_ezPeer_Create_View_Folder()
{
///ezPeer FolderViewyЩwq
Uint16 nRowPerLine = 1;
Uint16 nLinePerPage = 10;
COORD crdView = {0, 0, 800, 600};
COORD crdData = {180, 146, 456, 332};
COORD crdDataRow = {0, 0, 456, 26};
COORD crdDataCell = {0, 0, 456, 26};
WORD betweenrow = 8;
WORD dest_rgb = 1;
WORD dest_yuv = 1;
///
	FORMVIEW *pview = NULL;
	FORMVIEW_CELL *pcell = NULL;
	FORMVIEW_ROW *prow = NULL;
	FLIST *folderlist = NULL, *pfolder = NULL;
	Uint8 bSuccess = 0, bFail = 0;
	int i, j;
	Uint16 total_rows_per_page = 0;

	for (;;)
	{
		//iJdownloaded kur list
		chdir(WEB_APP_EZPEER_PATH_DOWNLOAD);
		folderlist = FolderList_Build(WEB_APP_EZPEER_PATH_DOWNLOAD);
		if (!folderlist) break;

		//l@view
		pview = FORMVIEW_Create(NULL);
		if (!pview) break;

		pview->default_use_utf = NLS_USE_UTF;
		pview->dest_rgb = dest_rgb;
		pview->dest_yuv = dest_yuv;
		pview->nRowPerLine = nRowPerLine;	//1(M櫬)
		pview->nLinePerPage = nLinePerPage;
		total_rows_per_page = pview->nRowPerLine * pview->nLinePerPage;

		//qy
		pview->crdView = crdView;
		pview->crdData = crdData;
		for (i=0; i<total_rows_per_page; i++)
		{
			pview->crdDataRow[i] = crdDataRow;
			pview->crdDataRow[i].y = i*crdDataRow.height + i*betweenrow;
		}
		pview->crdDataCell[0] = crdDataCell;


		/*
		//إߤ@Ӫ
		pview->field_row = (FORMVIEW_ROW*)SB_Alloc(pview->pBuf, sizeof(FORMVIEW_ROW));
		if (!pview->field_row) break;
		if (!FORMVIEW_AddEmptyCell(pview, pview->field_row)) break;
		*/

		//data rowesflist
		pfolder = FolderList_GetHeadPos(folderlist);
		while (pfolder)
		{
			//uCX.kurɮ
			if (  0 == (pfolder->attribute & Mask_IsDir)
				&&
				  0 == strcasecmp(strrchr(pfolder->fname,'.'), ".kur")
			   )
			{
				//W[sdata row
				if (!(prow = FORMVIEW_AddEmptyDataRow(pview)))
				{
					bFail = 1; break;
				}
				//W[sdata cell
				if (!(pcell = FORMVIEW_AddEmptyCell(pview, prow)))
				{
					bFail = 1; break;
				}
				//W[svalue
				if (!(pcell->value = (SKYFORM_VALUE*)SB_Alloc(pview->pBuf, sizeof(SKYFORM_VALUE))))
				{
					bFail = 1; break;
				}
				//sɦW
				pcell->value->format = SKYFORM_FORMAT_FILENAME;
				if (!(pcell->value->data = SB_String(pview->pBuf, (BYTE*)pfolder->fname)))
				{
					bFail = 1; break;
				}
			}
			pfolder = pfolder->next;
		}

		if (bFail) break;

		bSuccess = 1;
		break;
	}

	FolderList_Free(&folderlist);

	if (!bSuccess)
	{
		FORMVIEW_Close(&pview);
		return NULL;
	}

	return pview;
}

IGRSVIEW* WebApp_ezPeer_Create_View_IGRS(IGRS_SCRIPT *pscript)
{
///ezPeer IGRSViewyЩwq
WORD nLyricLine = 2;
COORD crdView = {0, 0, 800, 600};
COORD crdLyricZone = {0, 500, 800, 80};
COORD crdLyricLine[] = {
						{50, 4, 750, 36},	//Barry 2008-05-30
						{50, 40, 750, 36}	//Barry 2008-05-30
					   };
COORD crdPicture = {0, 0, 800, 600};
WORD dest_rgb = 1;
WORD dest_yuv = 1;
///

	if (!pscript) return NULL;
	IGRSVIEW *pView = NULL;
	int i;

	if (!(pView = IGRSVIEW_Create(pscript))) return NULL;

	pView->crdView = crdView;
	pView->crdLyricZone = crdLyricZone;
	pView->nLyricLine = nLyricLine;
	for (i=0; i<pView->nLyricLine; i++)
	{
		pView->crdLyricLine[i] = crdLyricLine[i];
	}
	pView->crdPicture = crdPicture;
	pView->dest_rgb = dest_rgb;
	pView->dest_yuv = dest_yuv;

	return pView;
}

int WebApp_ezPeer_Stop_Audio(Uint8 updateview)
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_EZPEER) return -1;

	if (   g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER
		|| g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_IGRS
	   )
	{
		if(  g_WebApp.ez_is_aud_forked
		   &&
			 !waitpid(g_WebApp.ez_pid_aud, &g_WebApp.ez_sts_aud, WNOHANG)
		  )
		{
			KILL(g_WebApp.ez_pid_aud);
			while(waitpid(g_WebApp.ez_pid_aud, &g_WebApp.ez_sts_aud, 0) == 0);
		}
		g_WebApp.ez_is_aud_forked = 0;
		g_WebApp.ez_is_aud_playing = 0;

		//se
		if (updateview && g_WebApp.ez_view_folder)
		{
			FORMVIEW_DrawDataRow(g_WebApp.ez_view_folder, g_WebApp.ez_view_folder->curr_playing_row_index, 1);
		}
	}

	return 0;
}

int WebApp_ezPeer_Play_Audio(Uint8 playlist, Uint8 updateview)
{
	if (g_WebApp.curr_func != WEB_APP_FUNCTION_EZPEER) return -1;

	if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER)
	{
		FORMVIEW *pview = NULL;
		FORMVIEW_ROW *prow = NULL;
		FORMVIEW_CELL *pcell = NULL;

		if (!(pview = g_WebApp.ez_view_folder)) return -1;
		//mplayerwҰʡAȰmplayerέs
		if (g_WebApp.ez_is_aud_forked)
		{
			//ܪ򥿦b񪺤OP@ANs
			if (pview->curr_playing_row_index != pview->curr_row_index)
			{
				WebApp_ezPeer_Stop_Audio(1);
				//ɷ| g_WebApp.ez_is_aud_forked = 0
				//ҥHU@B|s
			}
			//ܪ򥿦b񪺬OP@APȰ/
			else
			{
				set_ir_value((unsigned long)0x70);
				g_WebApp.ez_is_aud_playing = 1 - g_WebApp.ez_is_aud_playing;
			}
		}

		//YmplayerҰʡANҰmplayer
		if (!g_WebApp.ez_is_aud_forked)
		{
			if (!playlist)	//DIɤ~Ϋ쪺q
			{
				pview->curr_playing_row_index = pview->curr_row_index;
			}

			pcell = FORMVIEW_GetDataCell(g_WebApp.ez_view_folder, pview->curr_playing_row_index, 0);
			if (  !pcell
				||
				  !pcell->value->data
				||
				  pcell->value->format != SKYFORM_FORMAT_FILENAME
				)
			{
				return -1;
			}

			char fn[LEN_XL] = {0};
			sprintf(fn, "%s", /*WEB_APP_EZPEER_PATH_DOWNLOAD,*/ pcell->value->data);
			g_WebApp.ez_pid_aud = fork();
			switch(g_WebApp.ez_pid_aud)
			{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to Draw Focus Icon Fail!");
				break;
			case 0:
				//child process
				execl("/sky/mplayer", "mplayer", "-arcdemo", "-really-quiet", "-novideo",
					  pcell->value->data, NULL);
				_EXIT;
			default:
				//parent process
				g_WebApp.ez_is_aud_forked = 1;
				g_WebApp.ez_is_aud_playing = 1;

				//prio = getpriority(PRIO_PROCESS, (int)pid_aud);
				//setpriority(PRIO_PROCESS, (int)g_WebApp.ez_pid_aud, getpriority(PRIO_PROCESS, (int)g_WebApp.ez_pid_aud) - 15);

				break;
			}

			//se
			if (updateview)
			{
				FORMVIEW_DrawDataRow(pview, pview->curr_playing_row_index, 1);
			}
		}
	}

	return 0;
}

void WebApp_ezPeer_Handle_Audio()
{
	if(waitpid(g_WebApp.ez_pid_aud, &g_WebApp.ez_sts_aud, WNOHANG))
	{
		Uint8 updateview = 0;
		FORMVIEW *pview = NULL;
		if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER) updateview = 1;

		WebApp_ezPeer_Stop_Audio(updateview);

		if (!(pview = g_WebApp.ez_view_folder)) return;

		if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_IGRS)
		{
			WebApp_ezPeer_EscEvent();
		}
		else if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_FOLDER)
		{
			switch(setup->aud_rpt_idx)
			{
			case SETUP_AV_REPEAT_OFF:
				break;
			case SETUP_AV_REPEAT_SINGLE:
				WebApp_ezPeer_Play_Audio(1, updateview);
				break;
			case SETUP_AV_REPEAT_ONELOOP:
				if (++pview->curr_playing_row_index >= pview->nDataRow)
					pview->curr_playing_row_index = 0;
				else
					WebApp_ezPeer_Play_Audio(1, updateview);
				break;
			case SETUP_AV_REPEAT_CONTI:
				if (++pview->curr_playing_row_index >= pview->nDataRow)
					pview->curr_playing_row_index = 0;
				WebApp_ezPeer_Play_Audio(1, updateview);
				break;
			}
		}
	}
	else if (g_WebApp.curr_page == WEB_APP_PAGE_EZPEER_IGRS)
	{
		IGRSVIEW_Update_View(g_WebApp.ez_view_igrs);
		//while (IGRSVIEW_Update_View(g_WebApp.ez_view_igrs) > 0);
	}
}

#endif	//ezpeer

//------------------------------------------------------------------------------------------------

void WebAppInit()
{
	InitVolumeBuffer();
	memset(&g_WebApp, 0, sizeof(WEB_APP_GLOBAL_STURCT));

	if (0)
	{}
#ifdef WEB_APP_WEATHER
	else if (!strcmp(SelectedDev, WEBAPP_WEATHER_NAME))
		WebApp_Weather_Init();
#endif
#ifdef WEB_APP_NEWS
	else if (!strcmp(SelectedDev, WEBAPP_NEWS_NAME))
		WebApp_News_Init();
#endif
#ifdef WEB_APP_EZPEER
	else if (!strcmp(SelectedDev, WEBAPP_EZPEER_NAME))
		WebApp_ezPeer_Init();
#endif
#ifdef SETTING_GPIO_MUTE
	SetGPIOMute(1);
#endif
}

void WebAppDisplay()
{
	if (0)
	{}
#ifdef WEB_APP_WEATHER
	else if (!strcmp(SelectedDev, WEBAPP_WEATHER_NAME))
		WebApp_Weather_Display();
#endif
#ifdef WEB_APP_NEWS
	else if (!strcmp(SelectedDev, WEBAPP_NEWS_NAME))
		WebApp_News_Display();
#endif
#ifdef WEB_APP_EZPEER
	else if (!strcmp(SelectedDev, WEBAPP_EZPEER_NAME))
		WebApp_ezPeer_Display();
#endif
}

void WebAppShutDown()
{
	if (0)
	{}
#ifdef WEB_APP_WEATHER
	else if (!strcmp(SelectedDev, WEBAPP_WEATHER_NAME))
		WebApp_Weather_ShutDown();
#endif
#ifdef WEB_APP_NEWS
	else if (!strcmp(SelectedDev, WEBAPP_NEWS_NAME))
		WebApp_News_ShutDown();
#endif
#ifdef WEB_APP_EZPEER
	else if (!strcmp(SelectedDev, WEBAPP_EZPEER_NAME))
		WebApp_ezPeer_ShutDown();
#endif

	memset(&g_WebApp, 0, sizeof(WEB_APP_GLOBAL_STURCT));
	FreeVolumeBuffer();
}

/*----------------------------------*/
/*	WebApp EVENTS					*/
/*----------------------------------*/
void WebApp_EscEvent()
{
	if (0) {}
#ifdef WEB_APP_WEATHER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_WEATHER)
		WebApp_Weather_EscEvent();
#endif
#ifdef WEB_APP_NEWS
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_NEWS)
		WebApp_News_EscEvent();
#endif
#ifdef WEB_APP_EZPEER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_EZPEER)
		WebApp_ezPeer_EscEvent();
#endif
}
void WebApp_EnterEvent()
{
	if (0) {}
#ifdef WEB_APP_NEWS
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_NEWS)
		WebApp_News_EnterEvent();
#endif
#ifdef WEB_APP_EZPEER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_EZPEER)
		WebApp_ezPeer_EnterEvent();
#endif
}
void WebApp_UpEvent()
{
	if (0) {}
#ifdef WEB_APP_WEATHER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_WEATHER)
		WebApp_Weather_UpEvent();
#endif
#ifdef WEB_APP_NEWS
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_NEWS)
		WebApp_News_UpEvent();
#endif
#ifdef WEB_APP_EZPEER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_EZPEER)
		WebApp_ezPeer_UpEvent();
#endif
}
void WebApp_DownEvent()
{
	if (0) {}
#ifdef WEB_APP_WEATHER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_WEATHER)
		WebApp_Weather_DownEvent();
#endif
#ifdef WEB_APP_NEWS
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_NEWS)
		WebApp_News_DownEvent();
#endif
#ifdef WEB_APP_EZPEER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_EZPEER)
		WebApp_ezPeer_DownEvent();
#endif

}
void WebApp_PlayPauseEvent()
{
	if (0) {}
#ifdef WEB_APP_EZPEER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_EZPEER)
		WebApp_ezPeer_PlayPauseEvent();
#endif

}
void WebApp_StopEvent()
{
	if (0) {}
#ifdef WEB_APP_EZPEER
	else if (g_WebApp.curr_func == WEB_APP_FUNCTION_EZPEER)
		WebApp_ezPeer_StopEvent();
#endif
}
void WebApp_LeftEvent()
{
}
void WebApp_RightEvent()
{
}
void WebApp_PrevEvent()
{
}
void WebApp_NextEvent()
{
}

#endif

