#ifndef _WEB_APP_H_
#define _WEB_APP_H_

#include "types.h"

#ifdef WEB_APP_MOD
#include "skydemo.h"
#include "skyform.h"

#ifdef WEB_APP_EZPEER
#include "webapp_igrs.h"
#endif

/*----------------------------------*/
/*	TYPES							*/
/*----------------------------------*/
enum
{
	WEB_APP_FUNCTION_NONE = 0,
#ifdef WEB_APP_WEATHER
	WEB_APP_FUNCTION_WEATHER,
#endif
#ifdef WEB_APP_NEWS
	WEB_APP_FUNCTION_NEWS,
#endif
#ifdef WEB_APP_EZPEER
	WEB_APP_FUNCTION_EZPEER,
#endif
};

#ifdef WEB_APP_WEATHER
	#define WEB_APP_WEATHER_PATH_DOWNLOAD	"/mnt/sknand/"
	#define WEB_APP_WEATHER_EXE_PARSER		"/sky/wendal_news"
	#define WEB_APP_WEATHER_MDAT_TODAY		"today.mdat"
	#define WEB_APP_WEATHER_MDAT_TOMORROW	"tomorrow.mdat"
	#define WEB_APP_WEATHER_MDAT_WEEK		"week.mdat"
	#define WEB_APP_WEATHER_MDAT_UVINDEX	"uvindex.mdat"
	#define WEB_APP_WEATHER_MDAT_TRAVEL		"travel.mdat"
	#define WEB_APP_WEATHER_CMD_TODAY		"TODAY"
	#define WEB_APP_WEATHER_CMD_TOMORROW	"TOMORROW"
	#define WEB_APP_WEATHER_CMD_WEEK		"WEEK"
	#define WEB_APP_WEATHER_CMD_UVINDEX		"UVINDEX"
	#define WEB_APP_WEATHER_CMD_TRAVEL		"TRAVEL"

	enum
	{
		WEB_APP_PAGE_WEATHER_TODAY = 0,
		WEB_APP_PAGE_WEATHER_TOMORROW,
		WEB_APP_PAGE_WEATHER_WEEK,
		WEB_APP_PAGE_WEATHER_UVINDEX,
		WEB_APP_PAGE_WEATHER_TRAVEL
	};
#endif

#ifdef WEB_APP_NEWS
	#define WEB_APP_NEWS_PATH_DOWNLOAD		"/mnt/sknand/"
	#define WEB_APP_NEWS_EXE_PARSER			"/sky/wendal_news"
	#define WEB_APP_NEWS_MDAT_NEWSMATTER	"newsmatter.mdat"
	#define WEB_APP_NEWS_MDAT_POLITICS		"politics.mdat"
	#define WEB_APP_NEWS_MDAT_SOCIETY		"society.mdat"
	#define WEB_APP_NEWS_MDAT_TAIWAN		"taiwan.mdat"
	#define WEB_APP_NEWS_MDAT_INTL			"intl.mdat"
	#define WEB_APP_NEWS_CMD_NEWSMATTER		"NEWSMATTER"
	#define WEB_APP_NEWS_CMD_POLITICS		"POLITICS"
	#define WEB_APP_NEWS_CMD_SOCIETY		"SOCIETY"
	#define WEB_APP_NEWS_CMD_TAIWAN			"TAIWAN"
	#define WEB_APP_NEWS_CMD_INTL			"INTL"

	enum
	{
		WEB_APP_PAGE_NEWS_POLITICS = 0,
		WEB_APP_PAGE_NEWS_SOCIETY,
		WEB_APP_PAGE_NEWS_TAIWAN,
		WEB_APP_PAGE_NEWS_INTL,
		WEB_APP_PAGE_NEWS_CONTENT
	};
#endif

#ifdef WEB_APP_EZPEER
	#define WEB_APP_EZPEER_PATH_DOWNLOAD "/mnt/sknand/KUROSONG/"
	enum
	{
		WEB_APP_PAGE_EZPEER_FOLDER = 0,
		WEB_APP_PAGE_EZPEER_IGRS,
		WEB_APP_PAGE_EZPEER_HOME,
		WEB_APP_PAGE_EZPEER_ARTIST
	};
#endif

/*----------------------------------*/
/*	MEMBERS							*/
/*----------------------------------*/
//Web ApplicationϥΪGlobalܼ
typedef struct _STRUCT_WEB_APP_GLOBAL_
{
	//\
	Uint16 curr_func;
	//
	Uint16 curr_page;
	Uint16 prev_page;
	//A
	Uint16 curr_status;

#ifdef WEB_APP_WEATHER
	SKYFORM *wt_form_weather;
	FORMVIEW *wt_view_weather;
#endif

#ifdef WEB_APP_NEWS
	SKYFORM *nw_form_news;
	SKYFORM *nw_form_content;
	FORMVIEW *nw_view_news;
	FORMVIEW *nw_view_content;
#endif

#ifdef WEB_APP_EZPEER
	FORMVIEW *ez_view_folder;
	IGRSVIEW *ez_view_igrs;
	IGRS_SCRIPT *ez_script_igrs;
	pid_t ez_pid_aud;
	int ez_sts_aud;
	Uint8 ez_is_aud_forked;
	Uint8 ez_is_aud_playing;
#endif
}WEB_APP_GLOBAL_STURCT;

extern WEB_APP_GLOBAL_STURCT g_WebApp;


/*----------------------------------*/
/*	HANDLERS						*/
/*----------------------------------*/
void WebApp_EscEvent();
void WebApp_EnterEvent();
void WebApp_UpEvent();
void WebApp_DownEvent();
void WebApp_LeftEvent();
void WebApp_RightEvent();
void WebApp_PrevEvent();
void WebApp_NextEvent();
void WebApp_PlayPauseEvent();
void WebApp_StopEvent();

void WebAppInit();
void WebAppDisplay();
void WebAppShutDown();

//------------------------------------
//	Ѯ
//------------------------------------
#ifdef WEB_APP_WEATHER
	void WebApp_Weather_EscEvent();
	void WebApp_Weather_UpEvent();
	void WebApp_Weather_DownEvent();
	
	SKYFORM* WebApp_Weather_Create_Form_Weather();
	FORMVIEW* WebApp_Weather_Create_View_Weather();

	void WebApp_Weather_UpdateView();
	void WebApp_Weather_Init();
	void WebApp_Weather_Display();
	void WebApp_Weather_ShutDown();
#endif

//------------------------------------
//	sD
//------------------------------------
#ifdef WEB_APP_NEWS
	void WebApp_News_EscEvent();
	void WebApp_News_UpEvent();
	void WebApp_News_DownEvent();
	void WebApp_News_EnterEvent();

	SKYFORM* WebApp_News_Create_Form_News();
	FORMVIEW* WebApp_News_Create_View_News();
	SKYFORM* WebApp_News_Create_Form_Content(char *url);
	FORMVIEW* WebApp_News_Create_View_Content();

	void WebApp_News_UpdateView();
	void WebApp_News_Init();
	void WebApp_News_Display();
	void WebApp_News_ShutDown();
#endif

//------------------------------------
//	ezPeer
//------------------------------------
#ifdef WEB_APP_EZPEER
	void WebApp_ezPeer_EscEvent();
	void WebApp_ezPeer_PlayPauseEvent();
	void WebApp_ezPeer_StopEvent();
	void WebApp_ezPeer_UpEvent();
	void WebApp_ezPeer_DownEvent();
	void WebApp_ezPeer_EnterEvent();
	
	FORMVIEW* WebApp_ezPeer_Create_View_Folder();
	IGRSVIEW* WebApp_ezPeer_Create_View_IGRS(IGRS_SCRIPT *pscript);

	int WebApp_ezPeer_Play_Audio(Uint8 playlist, Uint8 updateview);
	int WebApp_ezPeer_Stop_Audio(Uint8 updateview);
	void WebApp_ezPeer_Handle_Audio();
	
	void WebApp_ezPeer_Init();
	void WebApp_ezPeer_Display();
	void WebApp_ezPeer_ShutDown();

#endif

#endif	//WEB_APP_MOD
#endif	//_WEB_APP_H_

