///080502
#include "types.h"
///
#include "parser.h"
#include "jpgfile.c"
#include "exif.c"
#include "bmp.h"
#include "drawutil.h"
#include "generalevents.h"
#include "textutil.h"
#include "tiff.h"
//------------------------------------------------------------------------------------------------
int ShowTags = FALSE;// Do not show raw by default.
int DumpExifMap = FALSE;
int calImgIdx = 0;
int isExifAvailable = FALSE;
Uint8 isCurrMusicPlayble[NUM_OF_AUDIO_LIST];
Uint32 isCalDrawedFirstTime = FALSE;
char musicDurationList[NUM_OF_AUDIO_LIST][LEN_M];
COORD posOfCalImage;
//char musicfilename[20][LEN_XL];
//------------------------------------------------------------------------------------------------
void ErrFatal(char * msg)
{
	PRINTF("Fatal: %s\n", msg);
}
//------------------------------------------------------------------------------------------------
void ErrNonfatal(char * msg, int a1, int a2)
{
	PRINTF("Nonfatal: %s (%d, %d)\n", msg, a1, a2);
}
//------------------------------------------------------------------------------------------------
void ProcessMakerNote(unsigned char * ValuePtr, int ByteCount, unsigned char * OffsetBase, unsigned ExifLength)
{}
//------------------------------------------------------------------------------------------------
void ProcessGpsInfo(unsigned char * DirStart, int ByteCountUnused, unsigned char * OffsetBase, unsigned ExifLength)
{}
//------------------------------------------------------------------------------------------------
int ProcessJpegFile(FILE *jpgfile)
{
	ReadMode_t ReadMode = READ_EXIF;
	Section_t *ExifSection;

	ResetJpgfile();
	if (!ReadJpegSections(jpgfile, ReadMode))
		return 0;
	// ImageInfo.XXX has the info you need
	return 1;
}
//------------------------------------------------------------------------------------------------
void GetPath(char *s)
{
	memset(s, 0, LEN_XL * sizeof(char));

	//modified by bk@070409 - modified for autoslideshow
	if(!strcmp(SelectedDev, DEVICE_SDMMC_NAME))
		strcpy(s, SDMMC_PATH);
	else if(!strcmp(SelectedDev, DEVICE_CF_NAME))
		strcpy(s, CF_PATH);
	else if(!strcmp(SelectedDev, DEVICE_USB_NAME))
		strcpy(s, USB_PATH);
	else if(!strcmp(SelectedDev, DEVICE_xD_NAME))
		strcpy(s, XDSM_PATH);
	else if(!strcmp(SelectedDev, DEVICE_MS_NAME))
		strcpy(s, MS_PATH);
	else if(!strcmp(SelectedDev, DEVICE_HD_NAME))
		strcpy(s, HD_PATH);
	else if(!strcmp(SelectedDev, DEVICE_FLASH_NAME))
		strcpy(s, FLASH_PATH);
#ifdef BLUETOOTH_MOD
	else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
		strcpy(s, BT_PATH);
#endif
#ifdef NET_MOD
	else if(!strcmp(SelectedDev, DEVICE_NAS_NAME))
		strcpy(s, NET_PATH);
#endif
	else
		strcpy(s, "");
}
//-----------------------------------------------------------------------------------------------

bool ConvertFileNameOnDisplay(char *Result, char *Source,/* Uint16 StartSourcePos,*/ Uint8 bAppend)
{
	int i;
	char *p, *q;
	Uint32 len, lenR;
	if (!Result || !Source/* || StartSourcePos >= strlen(Source)*/) return false;

	if (!bAppend)
	{
		strcpy(Result, "");
	}
	else if ((lenR = strlen(Result)) > 0)
	{
		q = Result + lenR - 1;
		//q = Result;
		/*
		for (i=0; i<lenR-1; i++)
		{
			if (*q == '/') *q = '\\';	//令windowsؿŸ
			q++;
		}
		*/
		//qResult
		if (*q != '/') strcat(Result, "/");
		//if (*q != '\\') strcat(Result, "\\");

	}

	p = Source;// + StartSourcePos;		//Source}Y
	if (*p == '/') p++;

	while ((q=strchr(p, '/')) != NULL)
	{
		if ((len = (Uint32)q-(Uint32)p) <= 4)	//ؿWٰuA
		{
			strncat(Result, p, len);
			strcat(Result, "/");
			//strcat(Result, "\\");
		}
		else
		{
			strncat(Result, p, 2);
			strcat(Result, ".../");
			//strcat(Result, "...\\");
		}
		p = q + 1;
	}
	strcat(Result, p);

	return true;
}




//------------------------------------------------------------------------------------------------
void GetSuitableLengthString(char *result, char* src, char end, int len, int isShowingExtension)
{
	char* tmp;

	//just get the file name
	if(src != NULL)
		tmp = strrchr(src, '/');
	if(tmp == NULL)
		tmp = src;
	else
		tmp++;

	//cut the string
	if(strlen(tmp) <= len)
		strcpy(result, tmp);
	else
	{
		if(!isShowingExtension)
		{
			int i;
			for(i = 0; i < len; i++)
				*(result + i) = *(tmp + i);
			*(result + len - 1) = end;
			*(result + len) = '\0';
		}
		else
		{
			int i, j, l;
			char *ext;
			ext = strrchr(src, '.');
			l = len - strlen(ext) - 1;
			for(i = 0; i < l; i++)
				*(result + i) = *(tmp + i);
			*(result + i++) = end;
			for(j = 0; i < len; i++)
				*(result + i) = *(ext + j++);
			*(result + len) = '\0';
		}
	}
}
//------------------------------------------------------------------------------------------------
void DrawDSICONFocus(Uint8 *rgbuff, Uint32 idx, int Mode)
{
	FRAME *elmf;
	Uint32 fcsidx;
	ICON *fcsICON;

	elmf = &ELMachines[active_index].frame;
	//PRINTF("idx = %d\n", idx);

	///080321
	ITEM_DATA *pItem = &elmf->item_data;
	SelectedDev = IconTxtArr4DS[pItem->index[idx]];
	fcsICON = &elmf->icon_arr[idx+pItem->total_item];
	/*
	SelectedDev = IconTxtArr4DS[idx];

	//PRINTF("SelectedDev = %s\n", SelectedDev);
#ifdef NET_MOD
		if(dev_mnted_enbled_flags.net)
		{
			fcsidx = idx + num_enabled_dev - 1;
			//PRINTF("fcsidx = %d\n", fcsidx);
		}
		else
		{
			fcsidx = idx + num_enabled_dev;
		}
#else
		fcsidx = idx + num_enabled_dev;
#endif

	fcsICON = &elmf->icon_arr[fcsidx];
	*/
	///

	if (Mode >= 0)
	{
		DuplicateBitmap((Uint16 *)rgbuff, (Uint16 *)fcsICON->iconbuff,
						fcsICON->icoord.x, fcsICON->icoord.y, fcsICON->icoord.width, fcsICON->icoord.height);
		RGBlock2YUVBlock(rgbuff, 1, fcsICON->icoord.x, fcsICON->icoord.y, fcsICON->icoord.width, fcsICON->icoord.height);
	}
	else		//Mode == -1
	{
		COORD crdTemp = {fcsICON->icoord.x-1, fcsICON->icoord.y-1, fcsICON->icoord.width+2, fcsICON->icoord.height+2};
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate,
							crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
		RGBlock2YUVBlock(rgbuff, 1, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
	}
	//FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y, SelectedDev, ORANGE_1555);
}
//------------------------------------------------------------------------------------------------
void DrawMTICONFocus(Uint8 *rgbuff, Uint32 idx, int Mode)
{
	FRAME *elmf;
	Uint32 fcsidx;
	ICON *fcsICON;
	char str[LEN_XL];
	bool bNoFile = false;
	Uint16 strwidth = 0;

	elmf = &ELMachines[active_index].frame;
	SelectedMT = ICONText4MT[idx];
#if 0
	if((idx == 0 && ImgCount == 0) || (idx == 1 && AudCount == 0) || (idx == 2 && VidCount == 0))
		fcsidx = idx + MAX_NUM_MTICON * 2;
	else
		fcsidx = idx + MAX_NUM_MTICON;
#else
	if(
		(idx == 0 && ImgCount == 0) ||
		(idx == 1 && AudCount == 0) ||
		(idx == 2 && VidCount == 0) ||
		(idx == 1 && isFlashMusicUsed)
	  )
	  {
		fcsidx = idx + MAX_NUM_MTICON;
	  }
#ifdef NET_MOD
	else if(idx == 2 && !strcmp(SelectedDev, DEVICE_NAS_NAME))
		fcsidx = idx + MAX_NUM_MTICON;
#endif
	else
		fcsidx = idx;
#endif
	fcsICON = &elmf->icon_arr[fcsidx];

	if (Mode >= 0)
	{
		DuplicateBitmap((Uint16 *)rgbuff, (Uint16 *)fcsICON->iconbuff,
							fcsICON->icoord.x, fcsICON->icoord.y, fcsICON->icoord.width, fcsICON->icoord.height);
		if (Mode == 1)
		{
			RGBlock2YUVBlock(rgbuff, 1, fcsICON->icoord.x, fcsICON->icoord.y, fcsICON->icoord.width, fcsICON->icoord.height);
		}

		if((idx == 0 && ImgCount == 0) || (idx == 1 && AudCount == 0) || (idx == 2 && VidCount == 0))
		{
			bNoFile = true;

			///070611 Ȯɤ Lɮצr
			/*
			memset(str, 0, LEN_XL);
			strcat(str, SelectedMT);
			strcat(str, FrameText[setup->Language][9]);
			FontTextOut(g_pFontDB_Local, (Uint16*)rgbuff, desc->MiscTextCoord[6].x, desc->MiscTextCoord[6].y, str, LAVENDER_1555);
			*/
			///
		}

		if (bNoFile)	//Lɮ׮ܦǦr
		{
		#ifndef WINGUI
			strwidth = FontTextOutFormat(g_pFontDB_Local, (Uint16 *)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y, SelectedMT, GREY40_1555, DT_CENTER);
			//FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y, SelectedMT, GREY40_1555);
		#endif
		}
		else
		{
		#ifndef 	WINGUI
			#ifdef LEADTEK
			strwidth = FontTextOutFormat(g_pFontDB_Local, (Uint16 *)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y, SelectedMT, LTK_ORANGE, DT_CENTER);
			#else
			  #ifdef DARK_BLUE_DESIGN
			strwidth = FontTextOutFormat(g_pFontDB_Local, (Uint16 *)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y, SelectedMT, MEDIA_OPTIONS, DT_CENTER);
			  #else
			strwidth = FontTextOutFormat(g_pFontDB_Local, (Uint16 *)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y, SelectedMT, RED_1555, DT_CENTER);
			  #endif
			#endif
			//FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y, SelectedMT, RED_1555);
		#endif
		}

		if (Mode == 1)
		{
			RGBlock2YUVBlock(rgbuff, 1, fcsICON->txtcoord.x - (strwidth>>1), fcsICON->txtcoord.y,
								strwidth, g_pFontDB_Local->FontSize);
		}
	}
	else		//Mode == -1
	{
		//Icon
		COORD crdTemp = {fcsICON->icoord.x-1, fcsICON->icoord.y-1, fcsICON->icoord.width+2,  fcsICON->icoord.height+2};
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
		RGBlock2YUVBlock(rgbuff, 1, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);

	#ifndef WINGUI
		//Text
		strwidth = GetFontStringWidth(g_pFontDB_Local, SelectedMT);
		crdTemp.x = fcsICON->txtcoord.x-(strwidth>>1) - 1;
		crdTemp.y = fcsICON->txtcoord.y - 1;
		crdTemp.width = strwidth + 2;
		crdTemp.height = g_pFontDB_Local->FontSize + 2;
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
		RGBlock2YUVBlock(rgbuff, 1, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
	#endif
	}
}
//------------------------------------------------------------------------------------------------
void DrawImageThumbnailFcous(Uint8 *rgbuff, Uint32 idx, int Mode)
{
	FRAME *elmf;
	ICON *fcsICON;
	Uint32 xL, xR, yT, yB;
	char str[LEN_M], s[LEN_XL];
	Uint16 StrWidth = 0;

	elmf = &ELMachines[active_index].frame;
	fcsICON = &elmf->icon_arr[idx];

	xL = fcsICON->icoord.x - BORDER_THICK;
	xR = fcsICON->icoord.x + fcsICON->icoord.width + BORDER_THICK;
	yT = fcsICON->icoord.y - BORDER_THICK;
	yB = fcsICON->icoord.y + fcsICON->icoord.height + BORDER_THICK;

	if (Mode >= 0)
	{
		#ifndef DARK_BLUE_DESIGN
		DrawBorder((Uint16 *)rgbuff, xL, xR, yT, yB, BORDER_THICK, YELLOW_1555);
		#else
		DrawBorder((Uint16 *)rgbuff, xL, xR, yT, yB, BORDER_THICK, MEDIA_FRAMEMESSAGE);
		#endif

		//Draw the num of item, and total num
		sprintf(str, "%d/%d", elmf->active_icon_index + 1, ImgCount, elmf->active_frame_index + 1);
		#ifdef LEADTEK
		StrWidth = FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y, str, LTK_ORANGE);
		#else
			#ifdef WINGUI
			StrWidth = FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y, str, BLACK_1555);
			#else
			  #ifndef DARK_BLUE_DESIGN
			StrWidth = FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y, str, RED_1555);
			  #else
			StrWidth = FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y, str, MUSIC_SELECTEDFILE);
			  #endif
			#endif
		#endif

		//Draw File Name
		Uint16 RightBound = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width;

		#ifdef WINGUI
		StrWidth = FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y, FrameText[setup->Language][10], BLACK_1555);
		#else
		  #ifndef DARK_BLUE_DESIGN
		StrWidth = FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y, FrameText[setup->Language][10], GREY40_1555);
		  #else
		StrWidth = FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y, FrameText[setup->Language][10], SELECTED_FILEHEAD);
		  #endif
		#endif

		///080130
		#ifdef LEADTEK
		StrWidth += FontTextOutFileName(g_pFontDB_Local, elmf->CurrImgListPos->fname,
										NLS_USE_UTF,
										TRUE,
										LTK_BLUE,
										(Uint16 *)rgbuff, OUTPUT_XRES,
										desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y,
										RightBound - desc->MiscTextCoord[7].x - StrWidth, 0);
		#else
			#ifdef WINGUI
			StrWidth += FontTextOutFileName(g_pFontDB_Local, elmf->CurrImgListPos->fname,
											NLS_USE_UTF,
											TRUE,
											BLACK_1555,
											(Uint16 *)rgbuff, OUTPUT_XRES,
											desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y,
											RightBound - desc->MiscTextCoord[7].x - StrWidth, 0);
			#else
			StrWidth += FontTextOutFileName(g_pFontDB_Local, elmf->CurrImgListPos->fname,
											NLS_USE_UTF,
											TRUE,
											#ifndef DARK_BLUE_DESIGN
											BLUE_1555,
											#else
											SELECTED_FILENAME,
											#endif
											(Uint16 *)rgbuff, OUTPUT_XRES,
											desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y,
											RightBound - desc->MiscTextCoord[7].x - StrWidth, 0);
			#endif
		#endif
		/*
		ConvertFileNameOnDisplay(s, elmf->CurrImgListPos->fname, false);
		StrWidth += FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y, s, BLUE_1555);
		*/
		///

		GetPath(s);
		strcat(s, elmf->CurrImgListPos->fname);
		//PRINTF("Path of image file = %s\n", s);
		DrawEXIF(s);

		if (Mode == 1)
		{
			//Uint16 RightBound = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width;
			//c
			RGBlock2YUVBlock(rgbuff, 1, xL, yT, xR - xL, yB - yT);
			//s
			RGBlock2YUVBlock(rgbuff, 1, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y,
								RightBound - desc->MiscTextCoord[8].x, g_pFontDB_Default->FontSize);
			//ɦW
			RGBlock2YUVBlock(rgbuff, 1, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y,
								RightBound - desc->MiscTextCoord[7].x, g_pFontDB_Local->FontSize);
		}
	}
	else		//Mode == -1
	{
		COORD crdTemp = {0};
		Uint16 RightBound = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width;

		//٭cϰ
		crdTemp.x = xL - 1; crdTemp.y = yT - 1;
		crdTemp.width = xR - xL + 2; crdTemp.height = yB - yT + 2;
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
		RGBlock2YUVBlock(rgbuff, 1, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);

		//٭ɮ׽s
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate,
							desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y,
							RightBound - desc->MiscTextCoord[8].x, g_pFontDB_Default->FontSize);

		//٭ɦWϰ
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate,
							desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y,
							RightBound - desc->MiscTextCoord[7].x, g_pFontDB_Default->FontSize);
	}
}

#ifdef SUPPORT_RSS
//rywu20080516 added
void draw_thumbnail_fcous_icon(Uint8 *rgbuff, unsigned char idx, unsigned char mode)
{
	FRAME *elmf;
	ICON *fcsICON;
	Uint32 xL, xR, yT, yB;
    COORD crdTemp = {0};

	elmf = &ELMachines[active_index].frame;
	fcsICON = &elmf->icon_arr[idx];

    xL = fcsICON->icoord.x - BORDER_THICK;
    xR = fcsICON->icoord.x + fcsICON->icoord.width + BORDER_THICK;
    yT = fcsICON->icoord.y - BORDER_THICK;
    yB = fcsICON->icoord.y + fcsICON->icoord.height + BORDER_THICK;

    DBG_MSG("<skydemo> draw_thumbnail_fcous_icon(%d) -->\n", mode);
    switch (mode)
    {
        case 0:
            //٭cϰ
            crdTemp.x = xL - 1; crdTemp.y = yT - 1;
            crdTemp.width = xR - xL + 2; crdTemp.height = yB - yT + 2;
            DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
            RGBlock2YUVBlock(rgbuff, 1, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
            break;

        case 1:
            DrawBorder((Uint16 *)rgbuff, xL, xR, yT, yB, BORDER_THICK, YELLOW_1555);
            RGBlock2YUVBlock(rgbuff, 1, xL, yT, xR - xL, yB - yT);
            break;
    }
    DBG_MSG("<skydemo> draw_thumbnail_fcous_icon <--\n");
}

//rywu20080516 added
void draw_thumbnail_number(Uint8 *rgbuff, RSS_SESSION_INFO_ID rss_session)
{
	FRAME *elmf;
	char str[LEN_M];
	Uint16 RightBound;
    Uint16 StrWidth = 0;

	elmf = &ELMachines[active_index].frame;
    RightBound = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width;

    //٭ɮ׽s
    DuplicateBlockBitmap(
                    (Uint16 *)rgbuff,
                    (Uint16 *)elmf->rgbtemplate,
                    desc->MiscTextCoord[8].x,
                    desc->MiscTextCoord[8].y,
                    (RightBound - desc->MiscTextCoord[8].x)>>2, //only clear 1/4 length of field
                    g_pFontDB_Default->FontSize);

    //Draw the num of item, and total num
    if (rss_session->total_file_amount > 0)
    {
        //show x/y in screen
        sprintf(str, "%d/%d",
                rss_session->focus_image_no+1,
                rss_session->total_file_amount);
    }
    else
    {
        //show 0/0 in screen
        sprintf(str, "%d/%d",
                rss_session->focus_image_no,
                rss_session->total_file_amount);
    }

    StrWidth = FontTextOut(
                    g_pFontDB_Default,
                    (Uint16 *)rgbuff,
                    desc->MiscTextCoord[8].x,
                    desc->MiscTextCoord[8].y,
                    str,
                    RED_1555);

    //s
    RGBlock2YUVBlock(
                    rgbuff,
                    1,
                    desc->MiscTextCoord[8].x,
                    desc->MiscTextCoord[8].y,
                    (RightBound - desc->MiscTextCoord[8].x)>>2,
                    g_pFontDB_Default->FontSize);
}

//rywu20080516 added
void draw_thumbnail_filename(Uint8 *rgbuff, char *str)
{
    FRAME *elmf;
	Uint16 RightBound;
    Uint16 StrWidth = 0;

	elmf = &ELMachines[active_index].frame;

    RightBound = desc->MiscTextCoord[29].x + desc->MiscTextCoord[29].width;

    //٭ɦWϰ
    DuplicateBlockBitmap(
                (Uint16 *)rgbuff,
                (Uint16 *)elmf->rgbtemplate,
                desc->MiscTextCoord[7].x,
                desc->MiscTextCoord[7].y,
                RightBound - desc->MiscTextCoord[7].x,
                g_pFontDB_Default->FontSize);

	//Draw File Name
    StrWidth = FontTextOut(
                g_pFontDB_Local,
                (Uint16 *)rgbuff,
                desc->MiscTextCoord[7].x,
                desc->MiscTextCoord[7].y,
                FrameText[setup->Language][10],
                GREY40_1555);

    StrWidth += FontTextOutFileName(
                g_pFontDB_Local,
                str,
                NLS_USE_UTF,
                TRUE,
                GREY40_1555,//BLUE_1555,
                (Uint16 *)rgbuff,
                OUTPUT_XRES,
                desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y,
                RightBound - desc->MiscTextCoord[7].x - StrWidth, 0);

    //ɦW
    RGBlock2YUVBlock(
                rgbuff,
                1,
                desc->MiscTextCoord[7].x,
                desc->MiscTextCoord[7].y,
                RightBound - desc->MiscTextCoord[7].x,
                g_pFontDB_Local->FontSize);
}

#endif //end #ifdef SUPPORT_RSS

//rywu20080516 added
void draw_text_message(Uint8 *rgbuff, COORD *area, char *str, Uint16 color, Uint8 yuv_no)
{
    FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
    DuplicateBlockBitmap(
            (Uint16 *)rgbuff,
            (Uint16 *)elmf->rgbtemplate,
            area->x,
            area->y,
            area->width,
            area->height);

    FontTextOut(
            g_pFontDB_Local,
            (Uint16 *)rgbuff,
            area->x,
            area->y,
            str,
            color);

    RGBlock2YUVBlock(
            rgbuff,
            yuv_no,
            area->x,
            area->y,
            area->width,
            area->height);
}


//------------------------------------------------------------------------------------------------
void DrawAudioBarFcous(Uint8 *rgbuff, Uint32 idx, int Mode)
{
	FRAME *elmf;
	ICON *fcsICON;
	char str[LEN_M];
	char strfn[LEN_XL];

	elmf = &ELMachines[active_index].frame;
	fcsICON = &elmf->icon_arr[idx];

	COORD BoundFileName = desc->MiscTextCoord[30];	//one row in music overwrite area
	BoundFileName.y = fcsICON->icoord.y;
	if (fcsICON->txtcoord.y < fcsICON->icoord.y)
		BoundFileName.y = fcsICON->txtcoord.y;
	BoundFileName.height = fcsICON->icoord.y + fcsICON->icoord.height;
	if (fcsICON->txtcoord.y + fcsICON->txtcoord.height > BoundFileName.height)
		BoundFileName.height = fcsICON->txtcoord.y + fcsICON->txtcoord.height;
	BoundFileName.height -= BoundFileName.y;

	if (Mode >= 0)
	{
		//Draw the num of item, and total num
		sprintf(str, "%d/%d", elmf->active_icon_index + 1, AudCount, elmf->active_frame_index + 1);

		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[25].x, desc->MiscTextCoord[25].y, str, LTK_ORANGE);
		#else
			#ifdef WINGUI
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[25].x, desc->MiscTextCoord[25].y, str, BLACK_1555);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[25].x, desc->MiscTextCoord[25].y, str, RED_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[25].x, desc->MiscTextCoord[25].y, str, MUSIC_SELECTEDFILE);
			  #endif
			#endif
		#endif

		if(isCurrMusicPlayble[idx])
		{

			//Draw focused bar--can play
			DuplicateBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->icon_arr[MUSIC_BAR_NUM].iconbuff,
							  fcsICON->icoord.x, fcsICON->icoord.y,
							  elmf->icon_arr[MUSIC_BAR_NUM].icoord.width, elmf->icon_arr[MUSIC_BAR_NUM].icoord.height);
		}
		else
		{
			//Draw focused bar--can't play
			DuplicateBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->icon_arr[MUSIC_BAR_NUM + 1].iconbuff,
							  fcsICON->icoord.x, fcsICON->icoord.y,
							  elmf->icon_arr[MUSIC_BAR_NUM + 1].icoord.width, elmf->icon_arr[MUSIC_BAR_NUM + 1].icoord.height);
		}

		///070824 e
		DrawRectBitmap((Uint16*) rgbuff, fcsICON->txtcoord.x, BoundFileName.y,
						desc->MiscTextCoord[30].x + desc->MiscTextCoord[30].width - fcsICON->txtcoord.x,
						BoundFileName.height,
						#ifndef DARK_BLUE_DESIGN
						HIGHTLIGHT_1555
						#else
						SELECTED_BAR
						#endif
						);

		//eɦW
		///080201
		#ifdef LEADTEK
		FontTextOutFileName(g_pFontDB_Local, elmf->CurrAudListPos->fname,
							NLS_USE_UTF,
							FALSE,	//ܸ|
							LTK_GREY,
							(Uint16*)rgbuff, OUTPUT_XRES,
							fcsICON->txtcoord.x, fcsICON->txtcoord.y,
							elmf->icon_arr[idx].txtcoord.width, 0);
		#else
			#ifdef WINGUI
			FontTextOutFileName(g_pFontDB_Local, elmf->CurrAudListPos->fname,
								NLS_USE_UTF,
								FALSE,	//ܸ|
								BLACK_1555,
								(Uint16*)rgbuff, OUTPUT_XRES,
								fcsICON->txtcoord.x, fcsICON->txtcoord.y,
								elmf->icon_arr[idx].txtcoord.width, 0);
			#else
			FontTextOutFileName(g_pFontDB_Local, elmf->CurrAudListPos->fname,
								NLS_USE_UTF,
								FALSE,	//ܸ|
								#ifndef DARK_BLUE_DESIGN
								BLUE_1555,
								#else
								MUSIC_SELECTEDFILE,
								#endif
								(Uint16*)rgbuff, OUTPUT_XRES,
								fcsICON->txtcoord.x, fcsICON->txtcoord.y,
								elmf->icon_arr[idx].txtcoord.width, 0);
			#endif
		#endif
		//GetSuitableLengthString(strfn, elmf->CurrAudListPos->fname, '~', 32/*23*/, TRUE);
		//FontTextOut(g_pFontDB_Local, (WORD*)rgbuff, fcsICON->txtcoord.x, fcsICON->txtcoord.y,
		//				strfn, BLUE_1555);
		///

		//Draw duration
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff,
			elmf->icon_arr[idx].txtcoord.x + elmf->icon_arr[idx].txtcoord.width, fcsICON->txtcoord.y, musicDurationList[idx], LTK_ORANGE);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff,
			elmf->icon_arr[idx].txtcoord.x + elmf->icon_arr[idx].txtcoord.width, fcsICON->txtcoord.y, musicDurationList[idx], BLUE_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff,
			elmf->icon_arr[idx].txtcoord.x + elmf->icon_arr[idx].txtcoord.width, fcsICON->txtcoord.y, musicDurationList[idx], MUSIC_DURATION);
		  #endif
		#endif
	}

	if (Mode != 0)
	{
		COORD BoundFileNum = {desc->MiscTextCoord[30].x, desc->MiscTextCoord[25].y,
								desc->MiscTextCoord[30].width, g_pFontDB_Default->FontSize};
		if (Mode == 1)
		{
			//File Number
			RGBlock2YUVBlock(rgbuff, 1, BoundFileNum.x, BoundFileNum.y, BoundFileNum.width, BoundFileNum.height);
			//File Name
			RGBlock2YUVBlock(rgbuff, 1, BoundFileName.x, BoundFileName.y, BoundFileName.width, BoundFileName.height);
		}
		else		//Mode == -1
		{
			//File Number
			DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, BoundFileNum.x, BoundFileNum.y, BoundFileNum.width, BoundFileNum.height);
			//RGBlock2YUVBlock(rgbuff, 1, BoundFileNum.x, BoundFileNum.y, BoundFileNum.width, BoundFileNum.height);
			//File Name
			DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, BoundFileName.x, BoundFileName.y, BoundFileName.width, BoundFileName.height);
			RGBlock2YUVBlock(rgbuff, 1, BoundFileName.x, BoundFileName.y, BoundFileName.width, BoundFileName.height);
		}
	}
}
//------------------------------------------------------------------------------------------------
///070605
void DrawRepeatMode()
{
	FRAME* elmf;
	elmf = &ELMachines[active_index].frame;
	Uint16 x, y, w, h;
	char str[LEN_XL] = "";

	switch (active_index)
	{
	case A_ACTIVE:
		x = desc->MiscTextCoord[20].x;
		y = desc->MiscTextCoord[20].y;
		//w = desc->XRES - x;
		h = g_pFontDB_Local->FontSize;

		///070814
		//DuplicateBlockBitmap((Uint16*)elmf->rgbtemplate, (Uint16*)elmf->bkgrdbuff, x, y, w, h);
		///

		strcpy(str, FrameText[setup->Language][23]);
		strcat(str, setup->aud_rpt_item[setup->aud_rpt_idx]);

		w = GetFontStringWidth(g_pFontDB_Local, str);
		#ifdef LEADTEK
		FontTextOutFormat(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, x, y, str, LTK_ORANGE, DT_CENTER);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOutFormat(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, x, y, str, BLUE_1555, DT_CENTER);
		  #else
		FontTextOutFormat(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, x, y, str, REPEAT_MODE_COLOR, DT_CENTER);
		  #endif
		#endif

		///071012
		//RGBlock2YUVBlock(elmf->rgbtemplate, 1, x-(w>>1), y, w, h);
		///

		break;
	default:
		break;
	}
}
///
//------------------------------------------------------------------------------------------------
void DrawVideoThumbnailFcous(Uint8 *rgbuff, Uint32 idx, int Mode)
{
	FRAME *elmf;
	ICON *fcsICON;
	Uint32 xL, xR, yT, yB;
	char str[LEN_M], s[LEN_XL];
	Uint16 StrWidth;

	elmf = &ELMachines[active_index].frame;
	fcsICON = &elmf->icon_arr[idx];
	xL = fcsICON->icoord.x - BORDER_THICK;
	xR = fcsICON->icoord.x + fcsICON->icoord.width + BORDER_THICK;
	yT = fcsICON->icoord.y - BORDER_THICK;
	yB = fcsICON->icoord.y + fcsICON->icoord.height + BORDER_THICK;

	if (Mode >= 0)
	{
		#ifndef DARK_BLUE_DESIGN
		DrawBorder((Uint16 *)rgbuff, xL, xR, yT, yB, BORDER_THICK, YELLOW_1555);
		#else
		DrawBorder((Uint16 *)rgbuff, xL, xR, yT, yB, BORDER_THICK, MEDIA_FRAMEMESSAGE);
		#endif

		//draw the num of item, and total num
		sprintf(str, "%d/%d", elmf->active_icon_index + 1, VidCount, elmf->active_frame_index + 1);
		#ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y, str, RED_1555);
		#else
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbuff, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y, str, MUSIC_SELECTEDFILE);
		#endif

		//Draw File Name
		#ifdef LEADTEK
		StrWidth = FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y, FrameText[setup->Language][10], GREY40_1555);
		#else
			#ifdef WINGUI
			StrWidth = FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y, FrameText[setup->Language][10], BLACK_1555);
			#else
			  #ifndef DARK_BLUE_DESIGN
			StrWidth = FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y, FrameText[setup->Language][10], GREY40_1555);
			  #else
			StrWidth = FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y, FrameText[setup->Language][10], SELECTED_FILEHEAD);
			  #endif
			#endif
		#endif

		///080201
		Uint16 RightBound = desc->MiscTextCoord[31].x + desc->MiscTextCoord[31].width;
		#ifdef LEADTEK
		StrWidth += FontTextOutFileName(g_pFontDB_Local, elmf->CurrVidListPos->fname,
										NLS_USE_UTF,
										TRUE,
										BLUE_1555,
										(Uint16 *)rgbuff, OUTPUT_XRES,
										desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y,
										RightBound - desc->MiscTextCoord[7].x - StrWidth, 0);
		#else
			#ifdef WINGUI
			StrWidth += FontTextOutFileName(g_pFontDB_Local, elmf->CurrVidListPos->fname,
											NLS_USE_UTF,
											TRUE,
											BLACK_1555,
											(Uint16 *)rgbuff, OUTPUT_XRES,
											desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y,
											RightBound - desc->MiscTextCoord[7].x - StrWidth, 0);
			#else
			StrWidth += FontTextOutFileName(g_pFontDB_Local, elmf->CurrVidListPos->fname,
											NLS_USE_UTF,
											TRUE,
											#ifndef DARK_BLUE_DESIGN
											BLUE_1555,
											#else
											SELECTED_FILENAME,
											#endif
											(Uint16 *)rgbuff, OUTPUT_XRES,
											desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y,
											RightBound - desc->MiscTextCoord[7].x - StrWidth, 0);
			#endif
		#endif
		/*
		ConvertFileNameOnDisplay(s, elmf->CurrVidListPos->fname, false);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbuff, desc->MiscTextCoord[7].x + StrWidth, desc->MiscTextCoord[7].y, s, BLUE_1555);
		*/
		///


		GetPath(s);
		strcat(s, elmf->CurrVidListPos->fname);
		//PRINTF("Path of video file = %s\n", s);
		DrawVideoInfo(s);

		if (Mode == 1)
		{
			Uint16 RightBound = desc->MiscTextCoord[31].x + desc->MiscTextCoord[31].width;
			//c
			RGBlock2YUVBlock(rgbuff, 1, xL, yT, xR - xL, yB - yT);
			//s
			RGBlock2YUVBlock(rgbuff, 1, desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y,
								RightBound - desc->MiscTextCoord[8].x, g_pFontDB_Default->FontSize);
			//ɦW
			RGBlock2YUVBlock(rgbuff, 1, desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y,
								RightBound - desc->MiscTextCoord[7].x, g_pFontDB_Local->FontSize);
		}
	}
	else		//Mode == -1
	{
		COORD crdTemp = {0};
		Uint16 RightBound = desc->MiscTextCoord[31].x + desc->MiscTextCoord[31].width;

		//٭cϰ
		crdTemp.x = xL - 1; crdTemp.y = yT - 1;
		crdTemp.width = xR - xL + 2; crdTemp.height = yB - yT + 2;
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);
		RGBlock2YUVBlock(rgbuff, 1, crdTemp.x, crdTemp.y, crdTemp.width, crdTemp.height);

		//٭ɮ׽s
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate,
							desc->MiscTextCoord[8].x, desc->MiscTextCoord[8].y,
							RightBound - desc->MiscTextCoord[8].x, g_pFontDB_Default->FontSize);

		//٭ɦWϰ
		DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate,
							desc->MiscTextCoord[7].x, desc->MiscTextCoord[7].y,
							RightBound - desc->MiscTextCoord[7].x, g_pFontDB_Local->FontSize);
	}
}
//------------------------------------------------------------------------------------------------

///070626
void DrawFolderFileInfo(Uint8 *rgbuff, FLIST *pFolder)
{
	FRAME *elmf;
	int FileType = 0;					//ɮ
	int imgType = 0, imgW = 0, imgH = 0;
	struct stat FileStat = {0};			//ɮ׸T
	int x, y, dy;
	COORD coFileInfo;				//ɮ׸Ty
	char *ext, *thumbnail;			//ɦW
	pid_t pid;
	int status, isMediaPlayable = TRUE;	//uftImage, Audio, Video (FileType = 2, 3, 4)ϥ - edited by bk @ 071025
	COORD coPreview;				//wϤy
	char bufW[LEN_M], bufH[LEN_M];	//skyviewΪѼ
	struct tm *pTime;				//ɶ
	char bufStr[LEN_L];				//ɶr
	FILE* jpgfile;
	FileInfo finfo;				//vɪT by media parser
	ICON* picMediaType;// = elmf->icon_arr + (elmf->num_icon-3);
	struct bmp_state *bmp_h;
	struct tiff_hdr *tiff_h;

	elmf = &ELMachines[active_index].frame;

	coPreview.x = desc->MiscTextCoord[22].x;
	coPreview.y = desc->MiscTextCoord[22].y;
	coPreview.width = desc->MiscTextCoord[22].width;
	coPreview.height = desc->MiscTextCoord[22].height;
	coFileInfo.x = desc->MiscTextCoord[23].x;
	coFileInfo.y = desc->MiscTextCoord[23].y;
	coFileInfo.width = desc->MiscTextCoord[23].width;
	coFileInfo.height = desc->MiscTextCoord[23].height;

	if (pFolder->attribute & Mask_IsDir)
	{
		FileType = 1;	//ؿ
	}
	else if ((ext=strrchr(pFolder->fname, '.')) == NULL)	//LɦW
	{
		FileType = 0;	//Unknown
	}
	else if(IsSupportedJPG(ext))
	{
		FileType = 2;	//v
		imgType = 0;
	}
	else if(IsSupportedBMP(ext))
	{
		bmp_h = (struct bmp_state *)GetBmpHdr(pFolder->fname);
		//if (bmp_h != NULL)
			FileType = 2;	//v
		imgType = 1;
		if(bmp_h == NULL)
			isMediaPlayable = FALSE;
	}
	else if(IsSupportedTIFF(ext))
	{
		tiff_h = (struct tiff_hdr *)GetTiffHdr(pFolder->fname);
		//if (tiff_h != NULL)
			FileType = 2;	//v
		imgType = 2;
		if (tiff_h == NULL)
			isMediaPlayable = FALSE;
	}
	else if(IsSupportedAudio(ext))
	{
		FileType = 3;	//
		if(MediaParser(pFolder->fname, &finfo) != PlayableMusic)
			isMediaPlayable = FALSE;
	}
	else if(IsSupportedVideo(ext))
	{
		FileType = 4;	//v
		if(MediaParser(pFolder->fname, &finfo) != PlayableVideo)
			isMediaPlayable = FALSE;
	}
	else		//ɮ䴩
	{
		FileType = 0;	//Unknown
	}

	if (FileType == 0)		//榡䴩, I
	{
		DuplicateBlockBitmap((Uint16*)rgbuff, (Uint16*)elmf->bkgrdbuff, coPreview.x, coPreview.y, coPreview.width, coPreview.height);
		RGBlock2YUVBlock(rgbuff, 1, coPreview.x, coPreview.y, coPreview.width, coPreview.height);
	}
	else if (
			   (FileType == 2) //v, eY, 䤣䴩ne
			|| (FileType == 3 && isMediaPlayable == FALSE) //, e䴩Y
			|| (FileType == 4 && isMediaPlayable == FALSE) //v, e䴩Y
	)
	{
		if(isMediaPlayable)
			thumbnail = pFolder->fname;
		else
			thumbnail = desc->MiscICONIMG[0];//use the VideoNotSupported icon!!!

		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DPRINTF("Fork to Draw Preview Image '%s' Fail!\n", thumbnail);
				break;
				//exit(1);
			case 0:
				//child process
				sprintf(bufW, "%d", coPreview.width);
				sprintf(bufH, "%d", coPreview.height);
				memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
				execl("/sky/skyview", "skyview", "-thumbnail", "-rgb", "0", "-x", bufW, "-y", bufH, thumbnail, NULL);
				_EXIT;
			default:
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
				{
					DuplicateBitmap((Uint16*)rgbuff, (Uint16*)RGB0, coPreview.x, coPreview.y, coPreview.width, coPreview.height);
					RGBlock2YUVBlock(rgbuff, 1, coPreview.x, coPreview.y, coPreview.width, coPreview.height);
				}
				break;
		}
	}
	else if(FileType == 4 && isMediaPlayable == TRUE)//䴩v, eY
	{
		thumbnail = pFolder->fname;

		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DPRINTF("Fork to Draw Preview Image '%s' Fail!\n", thumbnail);
				break;
				//exit(1);
			case 0:
				//child process
				sprintf(bufW, "%d", coPreview.width);
				sprintf(bufH, "%d", coPreview.height);
				memset(RGB0, 0, coPreview.width * coPreview.height << 2);//070611 - raymond
				if(finfo.FileType == FILE_TYPE_AVI)
					execl("/sky/mplayer", "mplayer", "-nosound", "-demuxer", "3", "-preview", "-really-quiet", "-sx", bufW, "-sy", bufH, thumbnail, NULL);
				else if(finfo.FileType == FILE_TYPE_ASF)
					execl("/sky/mplayer", "mplayer", "-nosound", "-demuxer", "6", "-preview", "-really-quiet", "-sx", bufW, "-sy", bufH, thumbnail, NULL);
				else if(finfo.FileType == FILE_TYPE_MOV)
					execl("/sky/mplayer", "mplayer", "-nosound", "-demuxer", "7", "-preview", "-really-quiet", "-sx", bufW, "-sy", bufH, thumbnail, NULL);
				else
					execl("/sky/mplayer", "mplayer", "-nosound", "-preview", "-really-quiet", "-sx", bufW, "-sy", bufH, thumbnail, NULL);
				_EXIT;
			default:
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
				{
					DuplicateBitmap((Uint16*)rgbuff, (Uint16*)RGB0, coPreview.x, coPreview.y, coPreview.width, coPreview.height);
					RGBlock2YUVBlock(rgbuff, 1, coPreview.x, coPreview.y, coPreview.width, coPreview.height);
				}
				break;
		}
	}
	else		//֩μvθƧ, ew]wϥ
	{
		DuplicateBlockBitmap((Uint16*)rgbuff, (Uint16*)elmf->bkgrdbuff, coPreview.x, coPreview.y, coPreview.width, coPreview.height);

		/*
		if (FileType == 1)	//ؿ
			picMediaType = elmf->icon_arr + (elmf->num_icon-6);
		else if (FileType == 3)	//
			picMediaType = elmf->icon_arr + (elmf->num_icon-5);
		else if (FileType == 4)	//v
			picMediaType = elmf->icon_arr + (elmf->num_icon-4);
		DuplicateBitmap((Uint16*)rgbuff, (Uint16*)picMediaType->iconbuff, coPreview.x, coPreview.y,
							picMediaType->icoord.width, picMediaType->icoord.height);
		*/
		RGBlock2YUVBlock(rgbuff, 1, coPreview.x, coPreview.y, coPreview.width, coPreview.height);
	}

	//٭ɮ׸T϶
	DuplicateBlockBitmap((Uint16*)rgbuff, (Uint16*)elmf->bkgrdbuff, coFileInfo.x, coFileInfo.y, coFileInfo.width, coFileInfo.height);

	//ɮ׸T
	// by xenia for system - testers, 2008/08/01
	//x = coFileInfo.x + 16;	//exy
	x = coFileInfo.x;		//exy
	y = coFileInfo.y;		//yy(ʺA)
	dy = g_pFontDB_Default->FontSize;

	//ɮ
	#ifdef LEADTEK
	FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Type:", LTK_ORANGE);
	#else
	  #ifndef DARK_BLUE_DESIGN
	FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Type:", PURPLE_1555);
	  #else
	FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Type:", FOLDER_HEAD);
	  #endif
	#endif
	y += dy;
	if (FileType == 0)	//Unknown
	{
		if (ext && strlen(ext) <= 6)	//@ɦW
		{
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, ext, LTK_GREY);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, ext, GREY40_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, ext, FOLDER_DATA);
			  #endif
			#endif
		}
		else						//ɦW
		{
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, ext, LTK_GREY);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, ext, GREY40_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, ext, FOLDER_DATA);
			  #endif
			#endif
		}
	}
	else if (FileType == 1)	//ؿ
	{
		#ifndef 	DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, "folder", GREY40_1555);
		#else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, "folder", FOLDER_HEAD);
		#endif
	}
	else if (FileType == 2)	//v
	{
		sprintf(bufStr, "%s %s", ext+1, "image");
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
		  #endif
		#endif
	}
	else if (FileType == 3)	//
	{
		sprintf(bufStr, "%s %s", ext+1, "audio");
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
		  #endif
		#endif
	}
	else if (FileType == 4)	//v
	{
		sprintf(bufStr, "%s %s", ext+1, "video");
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
		  #endif
		#endif
	}

	if (lstat(pFolder->fname, &FileStat) == 0)
	{
		//ɮ׮ɶ
		y += dy;
		#ifdef WINGUI
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Date:", BLACK_1555);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Date:", PURPLE_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Date:", FOLDER_HEAD);
		  #endif
		#endif

		pTime = gmtime(&(FileStat.st_mtime));
		sprintf(bufStr, "%d/%d/%d", (1900+pTime->tm_year), (1+pTime->tm_mon),pTime->tm_mday);
		y += dy;
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
		  #endif
		#endif

		//ɮפjp
		if (FileType != 1)	//ؿɮפjp
		{
			y += dy;
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Size:", LTK_ORANGE);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Size:", PURPLE_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Size:", FOLDER_HEAD);
			  #endif
			#endif
			// by xenia, modified mb to MB and kb to KB
			if (FileStat.st_size >= 1048576)
				sprintf(bufStr, "%.2f MB", (float)FileStat.st_size / 1048576);
			else if (FileStat.st_size >= 1024)
				sprintf(bufStr, "%.2f KB", (float)FileStat.st_size / 1024);
			else
				sprintf(bufStr, "%d bytes", FileStat.st_size);
			y += dy;
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
			  #endif
			#endif
		}
	}

/*
	if (FileType == 2)	//vResolution
	{
		if((jpgfile = fopen(pFolder->fname, "r")))
		{
			if(ProcessJpegFile(jpgfile))
			{
				y += dy;
				#ifdef LEADTEK
				FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", LTK_ORANGE);
				#else
				FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", PURPLE_1555);
				#endif

				sprintf(bufStr, "%dx%d", ImageInfo.Width, ImageInfo.Height);
				y += dy;
				#ifdef LEADTEK
				FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
				#else
				FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
				#endif
			}
			fclose(jpgfile);
		}
	}
*/
	if (FileType == 2 && isMediaPlayable)	//vResolution
	{
		if(imgType == 0)//jpg
		{
			if((jpgfile = fopen(pFolder->fname, "r")))
			{
				if(ProcessJpegFile(jpgfile))
				{
					imgW = ImageInfo.Width;
					imgH = ImageInfo.Height;
				}
				fclose(jpgfile);
			}
		}
		else if(imgType == 1)//bmp
		{
			imgW = bmp_h->hdr.width;
			imgH = bmp_h->hdr.height;
			FreeBmpHdr(bmp_h);
		}
		else if(imgType == 2)//tiff
		{
			imgW = tiff_h->width;
			imgH = tiff_h->height;
			FreeTiffHdr(tiff_h);
		}

		y += dy;
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", LTK_ORANGE);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", PURPLE_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", FOLDER_HEAD);
		  #endif
		#endif

		sprintf(bufStr, "%dx%d", imgW, imgH);
		y += dy;
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
		#else
		  #ifndef DARK_BLUE_DESIGN
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
		  #else
		FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
		  #endif
		#endif
	}
	else if (FileType == 3)	//
	{
		//if (MediaParser(pFolder->fname, &finfo) == PlayableMusic)
		if (isMediaPlayable)
		{
			y += dy;
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Length:", LTK_ORANGE);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Length:", PURPLE_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Length:", FOLDER_HEAD);
			  #endif
			#endif

			sprintf(bufStr, "%d:%02d", (Uint32)finfo.AudioDuration/60, (Uint32)finfo.AudioDuration%60);
			y += dy;
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
			  #endif
			#endif
		}
	}
 	else if (FileType == 4)	//v
 	{
 		//if (MediaParser(pFolder->fname, &finfo) == PlayableVideo)
 		if (isMediaPlayable)
		{
			y += dy;
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", LTK_ORANGE);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", PURPLE_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, coFileInfo.x, y, "Resolution:", FOLDER_HEAD);
			  #endif
			#endif

			sprintf(bufStr, "%dx%d", (int)finfo.dwWidth, (int)finfo.dwHeight);
			y += dy;
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, LTK_GREY);
			#else
			  #ifndef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, GREY40_1555);
			  #else
			FontTextOut(g_pFontDB_Default, (Uint16*)rgbuff, x, y, bufStr, FOLDER_DATA);
			  #endif
			#endif
		}
 	}

	RGBlock2YUVBlock(rgbuff, 1, coFileInfo.x, coFileInfo.y, coFileInfo.width, coFileInfo.height);

}
///

//------------------------------------------------------------------------------------------------
///070617 Folder View Focus
void DrawFolderBarFocus(Uint8 *rgbuff, Uint32 idx, FLIST *pFolder, Uint8 IsReverse)
{
	FRAME *elmf;
	ICON *fcsICON;					//y
	elmf = &ELMachines[active_index].frame;
	fcsICON = &elmf->icon_arr[idx];

	//٭
	if (IsReverse)
	{
		DuplicateBlockBitmap((Uint16*)rgbuff, (Uint16*)elmf->bkgrdbuff,
								fcsICON->txtcoord.x, fcsICON->icoord.y, fcsICON->txtcoord.width, fcsICON->icoord.height);
	}
	//e
	else
	{
		DrawRectBitmap((Uint16*)rgbuff, fcsICON->txtcoord.x, fcsICON->icoord.y,
					fcsICON->txtcoord.width, fcsICON->icoord.height, 
					#ifndef DARK_BLUE_DESIGN
					HIGHTLIGHT_1555
					#else
					SELECTED_BAR
					#endif
					);
	}

	if (pFolder->attribute & Mask_IsDir)	//ؿ
	{
		///080118
		#ifdef LEADTEK
		FontTextOutFileName(g_pFontDB_Local, pFolder->fname,
							NLS_USE_UTF,
							FALSE,
							LTK_BLUE,
							(WORD*)RGB1, OUTPUT_XRES,
							fcsICON->txtcoord.x, fcsICON->txtcoord.y,
							fcsICON->txtcoord.width, 0);
		#else
			#ifdef WINGUI
				FontTextOutFileName(g_pFontDB_Local, pFolder->fname,
									NLS_USE_UTF,
									FALSE,
									BLACK_1555,
									(WORD*)RGB1, OUTPUT_XRES,
									fcsICON->txtcoord.x, fcsICON->txtcoord.y,
									fcsICON->txtcoord.width, 0);
			#else
				FontTextOutFileName(g_pFontDB_Local, pFolder->fname,
									NLS_USE_UTF,
									FALSE,
									#ifndef DARK_BLUE_DESIGN
									BLUE_1555,
									#else
									MUSIC_SELECTEDFILE,
									#endif
									(WORD*)RGB1, OUTPUT_XRES,
									fcsICON->txtcoord.x, fcsICON->txtcoord.y,
									fcsICON->txtcoord.width, 0);
			#endif
		#endif
		/*
		FontTextOutAlign(g_pFontDB_Local, (Uint16*)rgbuff, OUTPUT_XRES,
					 fcsICON->txtcoord.x,  fcsICON->txtcoord.y,
					 fcsICON->txtcoord.width, 	//̤je
					 pFolder->fname, BLUE_1555);
		*/
		///
	}
	else		//@ɮ
	{
		///080118
		#ifdef LEADTEK
		FontTextOutFileName(g_pFontDB_Local, pFolder->fname,
							NLS_USE_UTF,
							FALSE,
							LTK_BLACK,
							(WORD*)RGB1, OUTPUT_XRES,
							fcsICON->txtcoord.x, fcsICON->txtcoord.y,
							fcsICON->txtcoord.width, 0);
		#else
		FontTextOutFileName(g_pFontDB_Local, pFolder->fname,
							NLS_USE_UTF,
							FALSE,
							#ifndef DARK_BLUE_DESIGN
							BLACK_1555,
							#else
							MUSIC_SELECTEDFILE,
							#endif
							(WORD*)RGB1, OUTPUT_XRES,
							fcsICON->txtcoord.x, fcsICON->txtcoord.y,
							fcsICON->txtcoord.width, 0);
		#endif
		/*
		FontTextOutAlign(g_pFontDB_Local, (Uint16*)rgbuff, OUTPUT_XRES,
					 fcsICON->txtcoord.x,  fcsICON->txtcoord.y,
					 fcsICON->txtcoord.width,	//̤je
					 pFolder->fname,  BLACK_1555);
		*/
		///
	}

	RGBlock2YUVBlock(rgbuff, 1, fcsICON->txtcoord.x, fcsICON->icoord.y, fcsICON->txtcoord.width, fcsICON->icoord.height);

	if (!IsReverse)
	{
#ifdef IP_CAM_MOD
		if (active_index == IP_CAM_ACTIVE)
		{
			IPCAM_DATA ipcam_data[1] = {0};
			strcpy(ipcam_data->IP, pFolder->fname);
			strcpy(ipcam_data->ID, "admin");
			strcpy(ipcam_data->PW, "admin");
			ipcam_data->POS = desc->MiscTextCoord[22];
			DrawIPCam(ipcam_data, 1);
			//DrawIPCamPreview(pFolder->fname, "admin", "admin");
		}
		else
#endif
		//eɮ׸TMw
		DrawFolderFileInfo(rgbuff, pFolder);
	}
}
///

//------------------------------------------------------------------------------------------------
void DrawFocusedICON(Uint8 *rgbuff, int Mode)
{
	FRAME *elmf;
	Uint32 fcsidx;
	Uint16 x, y, w, h;
	char s[LEN_XL];
	int prio;

	elmf = &ELMachines[active_index].frame;
	fcsidx = elmf->active_icon_index;

	///080320
	ITEM_DATA *pItem = &elmf->item_data;
	///

	switch(active_index)
	{
		case DS_ACTIVE:
	///080322
	#ifdef NET_MOD
		case NET_DS_ACTIVE:
	#endif
	///
			if (Mode != 0)	//u٭έeFocus
			{
				///080320
				DrawDSICONFocus(rgbuff, elmf->active_icon_index, Mode);
				/*
#ifdef NET_MOD
				if(dev_mnted_enbled_flags.net)
				{
					fcsidx %= (num_enabled_dev - 1);
				}
				else
				{
					fcsidx %= num_enabled_dev;
				}
#else
				fcsidx %= num_enabled_dev;
#endif
				DrawDSICONFocus(rgbuff, fcsidx, Mode);
				*/
				///
			}
			else				//s
			{
				x = desc->MiscTextCoord[27].x;
				y = desc->MiscTextCoord[27].y;
				w = desc->MiscTextCoord[27].width;
				h = desc->MiscTextCoord[27].height;

				//copy the block of rgbtemplate where there are all icons and file name are located to coresponding position in RGB1
				DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, x, y, w, h);

				///080320
				DrawDSICONFocus(rgbuff, elmf->active_icon_index, 0);
                RGBlock2YUVBlock(rgbuff, 1, x, y, w, h);
				/*
#ifdef NET_MOD
				if(dev_mnted_enbled_flags.net)
				{
					fcsidx %= (num_enabled_dev - 1);
				}
				else
				{
					fcsidx %= num_enabled_dev;
				}
#else
				fcsidx %= num_enabled_dev;
#endif
				DrawDSICONFocus(rgbuff, fcsidx, 0);
				//convert the block of RGB1 where there are all icons to coresponding position in YUV1
				RGBlock2YUVBlock(rgbuff, 1, x, y, w, h);
				*/
				///
			}
			break;
		case MT_ACTIVE:
			if (Mode != 0)	//u٭έeFocus
			{
				fcsidx %= MAX_NUM_MTICON;
				DrawMTICONFocus(rgbuff, fcsidx, Mode);
			}
			else				//s
			{
				x = desc->MiscTextCoord[28].x;
				y = desc->MiscTextCoord[28].y;
				w = desc->MiscTextCoord[28].width;
				h = desc->MiscTextCoord[28].height;

				//copy the block of rgbtemplate where there are all icons and file name are located to coresponding position in RGB1
				DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, x, y, w, h);
				fcsidx %= MAX_NUM_MTICON;
				DrawMTICONFocus(rgbuff, fcsidx, 0);
				//convert the block of RGB1 where there are all icons to coresponding position in YUV1
				RGBlock2YUVBlock(rgbuff, 1, x, y, w, h);
			}
			break;
		case I_ACTIVE:
			if (Mode != 0)
			{
				fcsidx %= ICON_NUM_PER_FRAME;
				DrawImageThumbnailFcous(rgbuff, fcsidx, Mode);
			}
			else
			{
				x = desc->MiscTextCoord[29].x;
				y = desc->MiscTextCoord[29].y;
				w = desc->MiscTextCoord[29].width;
				h = desc->MiscTextCoord[29].height;

				//copy the block of rgbtemplate where there are all icons and file name are located to coresponding position in RGB1
				DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, x, y, w, h);
				fcsidx %= ICON_NUM_PER_FRAME;
				DrawImageThumbnailFcous(rgbuff, fcsidx, 0);
				//convert the block of RGB1 where there are all icons to coresponding position in YUV1
				RGBlock2YUVBlock(rgbuff, 1, x, y, w, h);
			}
			break;
		case A_ACTIVE:
			if (Mode >= 0)
			{
				KillAudioProcess();
				isOnlyAudPrcsForked = FALSE;
			}

			if (Mode != 0)
			{
				fcsidx %= MUSIC_BAR_NUM;
				DrawAudioBarFcous(rgbuff, fcsidx, Mode);
			}
			else
			{
				x = desc->MiscTextCoord[30].x;
				y = desc->MiscTextCoord[30].y;
				w = desc->MiscTextCoord[30].width;
				h = desc->MiscTextCoord[30].height;

				DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, x, y, w, h);
				fcsidx %= MUSIC_BAR_NUM;
				DrawAudioBarFcous(rgbuff, fcsidx, 0);
				//convert the block of RGB1 where there are all icons to coresponding position in YUV1
				RGBlock2YUVBlock(rgbuff, 1, x, y, w, h);
			}

			if (Mode >= 0)
			{
				if(isCurrMusicPlayble[fcsidx])
				{
					GetPath(s);
					strcat(s, elmf->CurrAudListPos->fname);
					//PRINTF("Path of audio file = %s\n", s);
					pid_aud = fork();
					switch(pid_aud)
					{
						case -1:
							perror("Fork failed!");
							DMSG("Fork to Draw Focus Icon Fail!");
							break;
							//exit(1);
						case 0:
							//child process
							execl("/sky/mplayer", "mplayer", "-arcdemo", "-really-quiet", "-novideo", s, NULL);
							//execl("/sky/mplayer", "mplayer", "-acache", "-arcdemo", "-really-quiet", "-novideo", s, NULL);
							//execl("/sky/mplayer", "mplayer", "-acache", "-really-quiet", s, NULL);
							_EXIT;
						default:
							//parent process
							isOnlyAudPrcsForked = TRUE;
							prio = getpriority(PRIO_PROCESS, (int)pid_aud);
				  			setpriority(PRIO_PROCESS, (int)pid_aud, prio - 15);
							break;
					}
					DrawID3Tag(s);
				}
			}
			
			DrawVolume4WinaccordMusicPage();
			DrawVolume4KingstonMusicPage();
			break;
		case V_ACTIVE:
			if (Mode != 0)
			{
				fcsidx %= ICON_NUM_PER_FRAME;
				DrawVideoThumbnailFcous(rgbuff, fcsidx, Mode);
			}
			else
			{
				x = desc->MiscTextCoord[31].x;
				y = desc->MiscTextCoord[31].y;
				w = desc->MiscTextCoord[31].width;
				h = desc->MiscTextCoord[31].height;

				//copy the block of rgbtemplate where there are all icons and file name are located to coresponding position in RGB1
				DuplicateBlockBitmap((Uint16 *)rgbuff, (Uint16 *)elmf->rgbtemplate, x, y, w, h);
				fcsidx %= ICON_NUM_PER_FRAME;
				DrawVideoThumbnailFcous(rgbuff, fcsidx, 0);
				//convert the block of RGB1 where there are all icons to coresponding position in YUV1
				RGBlock2YUVBlock(rgbuff, 1, x, y, w, h);
			}
			break;
		///070617 Folder View Focus
		case FLDR_ACTIVE:
			UpdateFLDR();
			break;
		///
#ifdef BLUETOOTH_MOD
		case BT_ACTIVE:
			UpdateBTFldrDisplay();
			break;
#endif
	}
	/* Flowbee@960407. */
	osd_parser();
}
//------------------------------------------------------------------------------------------------
void DrawConfirmButtonFocus()
{
	FRAME *elmf;
	Uint16 cx, cy;
	unsigned long buf_x, xres, yres;
	Uint16 FONT_HEIGHT = 26;
	if (g_pFontDB_Local) FONT_HEIGHT = g_pFontDB_Local->FontSize;

	elmf = &ELMachines[active_index].frame;
	memcpy(RGB0, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);

	pgu_get_yuv_resolution(&buf_x, &xres, &yres);
	cx = (Uint16)xres >> 1;
	cy = (Uint16)yres >> 1;

	if(isUserConfirmed)
		DrawBorder((Uint16 *)RGB0, cx+FONT_HEIGHT, cx+5*FONT_HEIGHT, cy+FONT_HEIGHT/2, cy+FONT_HEIGHT*5/2, 5, YELLOW_1555);
		//DrawBorder((Uint16 *)RGB0, (OUTPUT_XRES + 40) / 2, (OUTPUT_XRES + 240) / 2, 320, 370, 5, YELLOW_1555);
	else
		DrawBorder((Uint16 *)RGB0, cx-5*FONT_HEIGHT, cx-FONT_HEIGHT, cy+FONT_HEIGHT/2, cy+FONT_HEIGHT*5/2, 5, YELLOW_1555);
		//DrawBorder((Uint16 *)RGB0, (OUTPUT_XRES - 240) / 2, (OUTPUT_XRES -40) / 2, 320, 370, 5, YELLOW_1555);

	/* Flowbee@960407. */
	osd_parser();
}
//------------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
void DrawHDAutoCPSelectionFocus()
{
	FRAME *elmf;
	Uint16 *dest = (Uint16*)RGB1, cx1 = 0, cy1 = 0, FONT_HEIGHT = 26;

	//init
	elmf = &ELMachines[active_index].frame;
	if(g_pFontDB_Local)
		FONT_HEIGHT = g_pFontDB_Local->FontSize;

	//pos
	cx1 = updateRegion.x + (updateRegion.width >> 1);
	cy1 = updateRegion.y + FONT_HEIGHT;

	//erase selection
	DuplicateBlockBitmap(dest, (Uint16*)elmf->bkgrdbuff, updateRegion.x, cy1, updateRegion.width, updateRegion.height);

	//draw selection
	if(userSelection)
	{
		FontTextOutFormat(g_pFontDB_Local, dest, cx1 - (FONT_HEIGHT << 1), cy1, FrameText[setup->Language][15], BLACK_1555, DT_CENTER);
		FontTextOutFormat(g_pFontDB_Local, dest, cx1 + (FONT_HEIGHT << 1), cy1, FrameText[setup->Language][16], YELLOW_1555, DT_CENTER);
	}
	else
	{
		FontTextOutFormat(g_pFontDB_Local, dest, cx1 - (FONT_HEIGHT << 1), cy1, FrameText[setup->Language][15], YELLOW_1555, DT_CENTER);
		FontTextOutFormat(g_pFontDB_Local, dest, cx1 + (FONT_HEIGHT << 1), cy1, FrameText[setup->Language][16], BLACK_1555, DT_CENTER);
	}

	//convert to display - 2 lines
	RGBlock2YUVBlock((Uint8*)dest, 1, updateRegion.x, updateRegion.y, updateRegion.width, updateRegion.x << 1);
}
#endif
//------------------------------------------------------------------------------------------------
void DrawFrameBackground(Uint8 *rgbbuff)
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	if (!elmf->bkgrdbuff)
	{
		DPRINTF("No Background to Draw!active_index = %d\n", active_index);
	}

	DuplicateBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff,
				   elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height);
}
//------------------------------------------------------------------------------------------------
void DrawFrameICON(Uint8 *rgbbuff)
{
	FRAME *elmf;
	Uint32 numicon;
	Uint8 i;

	elmf = &ELMachines[active_index].frame;
	if(active_index == DS_ACTIVE)
	{
#ifdef NET_MOD
		if(dev_mnted_enbled_flags.net)
		{
			numicon = num_enabled_dev - 1;
		}
		else
		{
			numicon = num_enabled_dev;
		}
#else
		numicon = num_enabled_dev;
#endif
	}
	else if(active_index == MT_ACTIVE)
	{
		numicon = MAX_NUM_MTICON;
	}

///080320
	ITEM_DATA *pItem = &(elmf->item_data);
	ICON *pIcon = elmf->icon_arr;
	//DBG_MSG("   active = %d, item num = %d\n", active_index, pItem->total_item);
	for (i=0; i<pItem->total_item; i++)
	{
		if(!pIcon->iconbuff)
		{
			DPRINTF("No Icon to Draw!active_index = %d\n", active_index);
			continue;
		}
		DuplicateBitmap((Uint16 *)rgbbuff, (Uint16 *)pIcon->iconbuff,
					  	pIcon->icoord.x, pIcon->icoord.y,
					  	pIcon->icoord.width, pIcon->icoord.height);
		pIcon++;
	}
	/*
	for(i = 0; i < numicon; i++)
	{
		if(!elmf->icon_arr[i].iconbuff)
		{
			//DPRINTF("No Icon to Draw!active_index = %d\n", active_index);
		}

		DuplicateBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->icon_arr[i].iconbuff,
					  		elmf->icon_arr[i].icoord.x, elmf->icon_arr[i].icoord.y,
					  		elmf->icon_arr[i].icoord.width, elmf->icon_arr[i].icoord.height);

		#if 0
		if(DS_ACTIVE == active_index)
			TextOutEnglishCaption((Uint16 *)rgbbuff,
									elmf->icon_arr[i].txtcoord.x, elmf->icon_arr[i].txtcoord.y,
									IconTxtArr4DS[i], BLACK_1555);
		else if(MT_ACTIVE == active_index)
			TextOutEnglishCaption((Uint16 *)rgbbuff,
									elmf->icon_arr[i].txtcoord.x, elmf->icon_arr[i].txtcoord.y,
		#endif
	}
	*/
	///
}
//------------------------------------------------------------------------------------------------
void DrawFrameTextMessage(Uint8 *rgbbuff, Uint16 color)
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;

	if (!elmf->frametextmsg)
	{
		//DPRINTF("No Frame Text to Draw!active_index = %d\n", active_index);
	}

	switch (active_index)
	{
		case USB2PC_CONN_ACTIVE:
#ifdef NET_MOD
#ifdef SUPPORT_RSS //rywu20080526
		case RSS_ACTIVE:
#endif
#endif
			FontTextOutFormat(g_pFontDB_Local, (Uint16 *)rgbbuff, elmf->frametextmsgcoord.x, elmf->frametextmsgcoord.y,
					elmf->frametextmsg, color, DT_CENTER);
			break;
		default:
			FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, elmf->frametextmsgcoord.x, elmf->frametextmsgcoord.y,
					elmf->frametextmsg, color);
			break;
	}
}
//------------------------------------------------------------------------------------------------
int Calculate(int month, int day, int year)
{
	long total = 0;
	int months[12]= {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	int i;

	if(((( (year % 4 == 0) && (year % 100 != 0) ) || (year % 400 == 0)) && month >= 2) && year > 1752)
		months[1] += 1;
	if((year % 4 == 0) && year < 1752)
		months[1] +=1;
	if(year == 1752)
		months[1] += 1;

	if(months[month - 1] < day)
		return -1;

	for(i = 0; i < month - 1; i++)
	{
		total += months[i];
	}

	if(month < 1 || month > 12)
		return -1;
	if(year < 0)
		return -1;
	else if(year > 1752)
		return (((365 * (year - 1) + (year - 1) / 4 - (year - 1) / 100 + (year - 1) / 400) + total + day) + 2) % 7;
	else if(year < 1752)
		return ((365 * (year - 1) + (year - 1) / 4 + total + day)) % 7;
	else if(year == 1752 && month < 9)
		return ((365 * (year - 1) + (year - 1) / 4 + total + day)) % 7;
	else if(year == 1752 && month > 9)
		return (((365 * (year - 1) + (year - 1) / 4 - (year - 1) / 100 + (year - 1) / 400) + total + day) + 2) % 7;
	else if(year == 1752 && month == 9 && day < 3)
		return ((365 * (year - 1) + (year - 1) / 4 + total + day)) % 7;
	else if(year == 1752 && month == 9 && day > 13)
		return (((365 * (year - 1) + (year - 1) / 4 - (year - 1) / 100 + (year - 1) / 400) + total + day) + 2) % 7;
	else
		return -1;
}
//------------------------------------------------------------------------------------------------
void DrawDigitalClock(Uint8 *rgbbuff, struct tm tm)
{
	char  time[LEN_L];

	///070711 Ȯɤ"Current Time"r
	//FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, desc->MiscTextCoord[14].x, desc->MiscTextCoord[14].y, FrameText[setup->Language][20], PURPLE_1555);
	///

	memset(time, 0, LEN_L);

	///070712 Ȯɤܬ
	sprintf(time, "%02d:%02d", tm.tm_hour, tm.tm_min);
	//sprintf(time, "%02d:%02d:%02d", tm.tm_hour, tm.tm_min, tm.tm_sec);
	///

/*
#ifdef USE_DESC_LCD
	if (prev_active_index == FI_ACTIVE)	//ù
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, desc->MiscTextCoord[35].x, desc->MiscTextCoord[35].y, time, BLUE_1555);
	else
#endif
*/
	#ifdef LEADTEK
	FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, desc->MiscTextCoord[10].x, desc->MiscTextCoord[10].y, time, LTK_BLACK);
	#else
	FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, desc->MiscTextCoord[10].x, desc->MiscTextCoord[10].y, time, BLUE_1555);
	#endif
}
//------------------------------------------------------------------------------------------------
///070820
#define	base	8
#define	round	200
Uint8 table[base][round][2] =
{
	{{0,0}, {0,1}, {0,2}, {0,3}, {0,4}, {0,5}, {0,6}, {0,7}, {0,8}, {0,9}, {0,10}, {0,11}, {0,12}, {0,13}, {0,14}, {0,15}, {0,16}, {0,17}, {0,18}, {0,19}, {0,20}, {0,21}, {0,22}, {0,23}, {0,24}, {0,25}, {0,26}, {0,27}, {0,28}, {0,29}, {0,30}, {0,31}, {0,32}, {0,33}, {0,34}, {0,35}, {0,36}, {0,37}, {0,38}, {0,39}, {0,40}, {0,41}, {0,42}, {0,43}, {0,44}, {0,45}, {0,46}, {0,47}, {0,48}, {0,49}, {0,50}, {0,51}, {0,52}, {0,53}, {0,54}, {0,55}, {0,56}, {0,57}, {0,58}, {0,59}, {0,60}, {0,61}, {0,62}, {0,63}, {0,64}, {0,65}, {0,66}, {0,67}, {0,68}, {0,69}, {0,70}, {0,71}, {0,72}, {0,73}, {0,74}, {0,75}, {0,76}, {0,77}, {0,78}, {0,79}, {0,80}, {0,81}, {0,82}, {0,83}, {0,84}, {0,85}, {0,86}, {0,87}, {0,88}, {0,89}, {0,90}, {0,91}, {0,92}, {0,93}, {0,94}, {0,95}, {0,96}, {0,97}, {0,98}, {0,99}, {0,100}, {0,101}, {0,102}, {0,103}, {0,104}, {0,105}, {0,106}, {0,107}, {0,108}, {0,109}, {0,110}, {0,111}, {0,112}, {0,113}, {0,114}, {0,115}, {0,116}, {0,117}, {0,118}, {0,119}, {0,120}, {0,121}, {0,122}, {0,123}, {0,124}, {0,125}, {0,126}, {0,127}, {0,128}, {0,129}, {0,130}, {0,131}, {0,132}, {0,133}, {0,134}, {0,135}, {0,136}, {0,137}, {0,138}, {0,139}, {0,140}, {0,141}, {0,142}, {0,143}, {0,144}, {0,145}, {0,146}, {0,147}, {0,148}, {0,149}, {0,150}, {0,151}, {0,152}, {0,153}, {0,154}, {0,155}, {0,156}, {0,157}, {0,158}, {0,159}, {0,160}, {0,161}, {0,162}, {0,163}, {0,164}, {0,165}, {0,166}, {0,167}, {0,168}, {0,169}, {0,170}, {0,171}, {0,172}, {0,173}, {0,174}, {0,175}, {0,176}, {0,177}, {0,178}, {0,179}, {0,180}, {0,181}, {0,182}, {0,183}, {0,184}, {0,185}, {0,186}, {0,187}, {0,188}, {0,189}, {0,190}, {0,191}, {0,192}, {0,193}, {0,194}, {0,195}, {0,196}, {0,197}, {0,198}, {0,199}},
	{{0,0}, {0,1}, {0,2}, {0,3}, {0,4}, {1,5}, {1,6}, {1,7}, {1,8}, {1,9}, {1,10}, {1,11}, {1,12}, {1,13}, {1,14}, {2,15}, {2,16}, {2,17}, {2,18}, {2,19}, {2,20}, {2,21}, {2,22}, {2,23}, {3,24}, {3,25}, {3,26}, {3,27}, {3,28}, {3,29}, {3,30}, {3,31}, {3,32}, {3,33}, {4,34}, {4,35}, {4,36}, {4,37}, {4,38}, {4,39}, {4,40}, {4,41}, {4,42}, {4,43}, {5,44}, {5,45}, {5,46}, {5,47}, {5,48}, {5,49}, {5,50}, {5,51}, {5,52}, {6,53}, {6,54}, {6,55}, {6,56}, {6,57}, {6,58}, {6,59}, {6,60}, {6,61}, {6,62}, {7,63}, {7,64}, {7,65}, {7,66}, {7,67}, {7,68}, {7,69}, {7,70}, {7,71}, {8,72}, {8,73}, {8,74}, {8,75}, {8,76}, {8,77}, {8,78}, {8,79}, {8,80}, {8,81}, {9,82}, {9,83}, {9,84}, {9,85}, {9,86}, {9,87}, {9,88}, {9,89}, {9,90}, {10,91}, {10,91}, {10,92}, {10,93}, {10,94}, {10,95}, {10,96}, {10,97}, {10,98}, {10,99}, {11,100}, {11,101}, {11,102}, {11,103}, {11,104}, {11,105}, {11,106}, {11,107}, {11,108}, {11,109}, {12,110}, {12,111}, {12,112}, {12,113}, {12,114}, {12,115}, {12,116}, {12,117}, {12,118}, {13,119}, {13,120}, {13,121}, {13,122}, {13,123}, {13,124}, {13,125}, {13,126}, {13,127}, {13,128}, {14,129}, {14,130}, {14,131}, {14,132}, {14,133}, {14,134}, {14,135}, {14,136}, {14,137}, {15,138}, {15,139}, {15,140}, {15,141}, {15,142}, {15,143}, {15,144}, {15,145}, {15,146}, {15,147}, {16,148}, {16,149}, {16,150}, {16,151}, {16,152}, {16,153}, {16,154}, {16,155}, {16,156}, {17,157}, {17,158}, {17,159}, {17,160}, {17,161}, {17,162}, {17,163}, {17,164}, {17,165}, {17,166}, {18,167}, {18,168}, {18,169}, {18,170}, {18,171}, {18,172}, {18,173}, {18,174}, {18,175}, {19,176}, {19,177}, {19,178}, {19,179}, {19,180}, {19,181}, {19,182}, {19,183}, {19,184}, {19,185}, {20,186}, {20,187}, {20,188}, {20,189}, {20,190}, {20,191}, {20,192}, {20,193}, {20,194}, {20,195}, {21,196}, {21,197}, {21,198}},
	{{0,0}, {0,1}, {0,2}, {1,3}, {1,4}, {1,5}, {1,6}, {1,7}, {2,8}, {2,9}, {2,10}, {2,11}, {2,12}, {3,13}, {3,14}, {3,15}, {3,16}, {4,17}, {4,18}, {4,19}, {4,20}, {4,21}, {5,22}, {5,22}, {5,23}, {5,24}, {5,25}, {6,26}, {6,27}, {6,28}, {6,29}, {6,30}, {7,31}, {7,32}, {7,33}, {7,34}, {7,35}, {8,36}, {8,37}, {8,38}, {8,39}, {9,40}, {9,41}, {9,42}, {9,43}, {9,44}, {10,45}, {10,46}, {10,47}, {10,48}, {10,49}, {11,50}, {11,51}, {11,52}, {11,53}, {11,54}, {12,55}, {12,56}, {12,57}, {12,58}, {12,59}, {13,60}, {13,61}, {13,62}, {13,63}, {14,64}, {14,65}, {14,66}, {14,67}, {14,67}, {15,68}, {15,69}, {15,70}, {15,71}, {15,72}, {16,73}, {16,74}, {16,75}, {16,76}, {16,77}, {17,78}, {17,79}, {17,80}, {17,81}, {17,82}, {18,83}, {18,84}, {18,85}, {18,86}, {19,87}, {19,88}, {19,89}, {19,90}, {19,91}, {20,92}, {20,93}, {20,94}, {20,95}, {20,96}, {21,97}, {21,98}, {21,99}, {21,100}, {21,101}, {22,102}, {22,103}, {22,104}, {22,105}, {22,106}, {23,107}, {23,108}, {23,109}, {23,110}, {23,111}, {24,112}, {24,112}, {24,113}, {24,114}, {25,115}, {25,116}, {25,117}, {25,118}, {25,119}, {26,120}, {26,121}, {26,122}, {26,123}, {26,124}, {27,125}, {27,126}, {27,127}, {27,128}, {27,129}, {28,130}, {28,131}, {28,132}, {28,133}, {28,134}, {29,135}, {29,136}, {29,137}, {29,138}, {30,139}, {30,140}, {30,141}, {30,142}, {30,143}, {31,144}, {31,145}, {31,146}, {31,147}, {31,148}, {32,149}, {32,150}, {32,151}, {32,152}, {32,153}, {33,154}, {33,155}, {33,156}, {33,157}, {33,157}, {34,158}, {34,159}, {34,160}, {34,161}, {35,162}, {35,163}, {35,164}, {35,165}, {35,166}, {36,167}, {36,168}, {36,169}, {36,170}, {36,171}, {37,172}, {37,173}, {37,174}, {37,175}, {37,176}, {38,177}, {38,178}, {38,179}, {38,180}, {38,181}, {39,182}, {39,183}, {39,184}, {39,185}, {40,186}, {40,187}, {40,188}, {40,189}, {40,190}, {41,191}, {41,192}, {41,193}, {41,194}, {41,195}},
	{{0,0}, {0,1}, {1,2}, {1,3}, {1,4}, {2,5}, {2,6}, {2,7}, {2,8}, {3,9}, {3,10}, {3,10}, {4,11}, {4,12}, {4,13}, {5,14}, {5,15}, {5,16}, {6,17}, {6,18}, {6,19}, {6,20}, {7,21}, {7,22}, {7,23}, {8,24}, {8,25}, {8,26}, {9,27}, {9,28}, {9,29}, {10,29}, {10,30}, {10,31}, {11,32}, {11,33}, {11,34}, {11,35}, {12,36}, {12,37}, {12,38}, {13,39}, {13,40}, {13,41}, {14,42}, {14,43}, {14,44}, {15,45}, {15,46}, {15,47}, {15,48}, {16,49}, {16,49}, {16,50}, {17,51}, {17,52}, {17,53}, {18,54}, {18,55}, {18,56}, {19,57}, {19,58}, {19,59}, {19,60}, {20,61}, {20,62}, {20,63}, {21,64}, {21,65}, {21,66}, {22,67}, {22,68}, {22,68}, {23,69}, {23,70}, {23,71}, {23,72}, {24,73}, {24,74}, {24,75}, {25,76}, {25,77}, {25,78}, {26,79}, {26,80}, {26,81}, {27,82}, {27,83}, {27,84}, {28,85}, {28,86}, {28,87}, {28,87}, {29,88}, {29,89}, {29,90}, {30,91}, {30,92}, {30,93}, {31,94}, {31,95}, {31,96}, {32,97}, {32,98}, {32,99}, {32,100}, {33,101}, {33,102}, {33,103}, {34,104}, {34,105}, {34,106}, {35,107}, {35,107}, {35,108}, {36,109}, {36,110}, {36,111}, {36,112}, {37,113}, {37,114}, {37,115}, {38,116}, {38,117}, {38,118}, {39,119}, {39,120}, {39,121}, {40,122}, {40,123}, {40,124}, {40,125}, {41,126}, {41,126}, {41,127}, {42,128}, {42,129}, {42,130}, {43,131}, {43,132}, {43,133}, {44,134}, {44,135}, {44,136}, {44,137}, {45,138}, {45,139}, {45,140}, {46,141}, {46,142}, {46,143}, {47,144}, {47,145}, {47,146}, {48,146}, {48,147}, {48,148}, {49,149}, {49,150}, {49,151}, {49,152}, {50,153}, {50,154}, {50,155}, {51,156}, {51,157}, {51,158}, {52,159}, {52,160}, {52,161}, {53,162}, {53,163}, {53,164}, {53,165}, {54,165}, {54,166}, {54,167}, {55,168}, {55,169}, {55,170}, {56,171}, {56,172}, {56,173}, {57,174}, {57,175}, {57,176}, {57,177}, {58,178}, {58,179}, {58,180}, {59,181}, {59,182}, {59,183}, {60,184}, {60,185}, {60,185}, {61,186}, {61,187}, {61,188}, {61,189}},
	{{0,0}, {0,1}, {1,2}, {1,3}, {2,4}, {2,5}, {2,5}, {3,6}, {3,7}, {4,8}, {4,9}, {4,10}, {5,11}, {5,12}, {6,13}, {6,14}, {7,15}, {7,16}, {7,16}, {8,17}, {8,18}, {9,19}, {9,20}, {9,21}, {10,22}, {10,23}, {11,24}, {11,25}, {11,26}, {12,26}, {12,27}, {13,28}, {13,29}, {13,30}, {14,31}, {14,32}, {15,33}, {15,34}, {15,35}, {16,36}, {16,37}, {17,37}, {17,38}, {17,39}, {18,40}, {18,41}, {19,42}, {19,43}, {20,44}, {20,45}, {20,46}, {21,47}, {21,48}, {22,48}, {22,49}, {22,50}, {23,51}, {23,52}, {24,53}, {24,54}, {24,55}, {25,56}, {25,57}, {26,58}, {26,58}, {26,59}, {27,60}, {27,61}, {28,62}, {28,63}, {28,64}, {29,65}, {29,66}, {30,67}, {30,68}, {31,69}, {31,69}, {31,70}, {32,71}, {32,72}, {33,73}, {33,74}, {33,75}, {34,76}, {34,77}, {35,78}, {35,79}, {35,79}, {36,80}, {36,81}, {37,82}, {37,83}, {37,84}, {38,85}, {38,86}, {39,87}, {39,88}, {39,89}, {40,90}, {40,90}, {41,91}, {41,92}, {41,93}, {42,94}, {42,95}, {43,96}, {43,97}, {44,98}, {44,99}, {44,100}, {45,100}, {45,101}, {46,102}, {46,103}, {46,104}, {47,105}, {47,106}, {48,107}, {48,108}, {48,109}, {49,110}, {49,111}, {50,111}, {50,112}, {50,113}, {51,114}, {51,115}, {52,116}, {52,117}, {52,118}, {53,119}, {53,120}, {54,121}, {54,122}, {55,122}, {55,123}, {55,124}, {56,125}, {56,126}, {57,127}, {57,128}, {57,129}, {58,130}, {58,131}, {59,132}, {59,132}, {59,133}, {60,134}, {60,135}, {61,136}, {61,137}, {61,138}, {62,139}, {62,140}, {63,141}, {63,142}, {63,143}, {64,143}, {64,144}, {65,145}, {65,146}, {65,147}, {66,148}, {66,149}, {67,150}, {67,151}, {68,152}, {68,153}, {68,153}, {69,154}, {69,155}, {70,156}, {70,157}, {70,158}, {71,159}, {71,160}, {72,161}, {72,162}, {72,163}, {73,164}, {73,164}, {74,165}, {74,166}, {74,167}, {75,168}, {75,169}, {76,170}, {76,171}, {76,172}, {77,173}, {77,174}, {78,174}, {78,175}, {79,176}, {79,177}, {79,178}, {80,179}, {80,180}, {81,181}, {81,182}},
	{{0,0}, {1,1}, {1,2}, {2,3}, {2,3}, {3,4}, {3,5}, {4,6}, {4,7}, {5,8}, {5,9}, {6,10}, {6,10}, {7,11}, {7,12}, {8,13}, {8,14}, {9,15}, {9,16}, {10,16}, {10,17}, {11,18}, {11,19}, {12,20}, {12,21}, {13,22}, {13,23}, {14,23}, {14,24}, {15,25}, {15,26}, {16,27}, {16,28}, {17,29}, {17,29}, {18,30}, {18,31}, {19,32}, {19,33}, {20,34}, {20,35}, {21,36}, {21,36}, {22,37}, {22,38}, {23,39}, {23,40}, {24,41}, {24,42}, {25,42}, {25,43}, {26,44}, {26,45}, {27,46}, {27,47}, {28,48}, {28,48}, {29,49}, {29,50}, {30,51}, {30,52}, {31,53}, {31,54}, {32,55}, {32,55}, {33,56}, {33,57}, {34,58}, {34,59}, {35,60}, {35,61}, {36,61}, {36,62}, {37,63}, {37,64}, {38,65}, {38,66}, {39,67}, {39,68}, {40,68}, {40,69}, {41,70}, {41,71}, {42,72}, {42,73}, {43,74}, {43,74}, {44,75}, {44,76}, {45,77}, {45,78}, {46,79}, {46,80}, {47,81}, {47,81}, {48,82}, {48,83}, {49,84}, {49,85}, {50,86}, {50,87}, {51,87}, {51,88}, {52,89}, {52,90}, {53,91}, {53,92}, {54,93}, {54,94}, {55,94}, {55,95}, {56,96}, {56,97}, {57,98}, {57,99}, {58,100}, {58,100}, {59,101}, {59,102}, {60,103}, {60,104}, {61,105}, {61,106}, {62,107}, {62,107}, {63,108}, {63,109}, {64,110}, {64,111}, {65,112}, {65,113}, {66,113}, {66,114}, {67,115}, {67,116}, {68,117}, {68,118}, {69,119}, {69,120}, {70,120}, {70,121}, {71,122}, {71,123}, {72,124}, {72,125}, {73,126}, {73,126}, {74,127}, {74,128}, {75,129}, {75,130}, {76,131}, {76,132}, {77,133}, {77,133}, {78,134}, {78,135}, {79,136}, {79,137}, {80,138}, {80,139}, {81,139}, {81,140}, {82,141}, {82,142}, {83,143}, {83,144}, {84,145}, {84,145}, {85,146}, {85,147}, {86,148}, {86,149}, {87,150}, {87,151}, {88,152}, {88,152}, {89,153}, {89,154}, {90,155}, {90,156}, {91,157}, {91,158}, {92,158}, {92,159}, {93,160}, {93,161}, {94,162}, {94,163}, {95,164}, {95,165}, {96,165}, {96,166}, {97,167}, {97,168}, {98,169}, {98,170}, {99,171}, {99,171}, {100,172}},
	{{0,0}, {1,1}, {1,2}, {2,2}, {2,3}, {3,4}, {4,5}, {4,6}, {5,6}, {5,7}, {6,8}, {6,9}, {7,10}, {8,11}, {8,11}, {9,12}, {9,13}, {10,14}, {11,15}, {11,15}, {12,16}, {12,17}, {13,18}, {14,19}, {14,19}, {15,20}, {15,21}, {16,22}, {16,23}, {17,23}, {18,24}, {18,25}, {19,26}, {19,27}, {20,28}, {21,28}, {21,29}, {22,30}, {22,31}, {23,32}, {24,32}, {24,33}, {25,34}, {25,35}, {26,36}, {26,36}, {27,37}, {28,38}, {28,39}, {29,40}, {29,40}, {30,41}, {31,42}, {31,43}, {32,44}, {32,44}, {33,45}, {34,46}, {34,47}, {35,48}, {35,49}, {36,49}, {36,50}, {37,51}, {38,52}, {38,53}, {39,53}, {39,54}, {40,55}, {41,56}, {41,57}, {42,57}, {42,58}, {43,59}, {43,60}, {44,61}, {45,61}, {45,62}, {46,63}, {46,64}, {47,65}, {48,66}, {48,66}, {49,67}, {49,68}, {50,69}, {51,70}, {51,70}, {52,71}, {52,72}, {53,73}, {53,74}, {54,74}, {55,75}, {55,76}, {56,77}, {56,78}, {57,78}, {58,79}, {58,80}, {59,81}, {59,82}, {60,83}, {61,83}, {61,84}, {62,85}, {62,86}, {63,87}, {63,87}, {64,88}, {65,89}, {65,90}, {66,91}, {66,91}, {67,92}, {68,93}, {68,94}, {69,95}, {69,95}, {70,96}, {71,97}, {71,98}, {72,99}, {72,100}, {73,100}, {73,101}, {74,102}, {75,103}, {75,104}, {76,104}, {76,105}, {77,106}, {78,107}, {78,108}, {79,108}, {79,109}, {80,110}, {81,111}, {81,112}, {82,112}, {82,113}, {83,114}, {83,115}, {84,116}, {85,116}, {85,117}, {86,118}, {86,119}, {87,120}, {88,121}, {88,121}, {89,122}, {89,123}, {90,124}, {91,125}, {91,125}, {92,126}, {92,127}, {93,128}, {93,129}, {94,129}, {95,130}, {95,131}, {96,132}, {96,133}, {97,133}, {98,134}, {98,135}, {99,136}, {99,137}, {100,138}, {101,138}, {101,139}, {102,140}, {102,141}, {103,142}, {103,142}, {104,143}, {105,144}, {105,145}, {106,146}, {106,146}, {107,147}, {108,148}, {108,149}, {109,150}, {109,150}, {110,151}, {111,152}, {111,153}, {112,154}, {112,155}, {113,155}, {113,156}, {114,157}, {115,158}, {115,159}, {116,159}, {116,160}, {117,161}},
	{{0,0}, {1,1}, {1,1}, {2,2}, {3,3}, {3,4}, {4,4}, {5,5}, {5,6}, {6,7}, {7,7}, {7,8}, {8,9}, {9,10}, {9,10}, {10,11}, {11,12}, {11,13}, {12,13}, {13,14}, {13,15}, {14,16}, {15,16}, {15,17}, {16,18}, {17,19}, {17,19}, {18,20}, {19,21}, {19,22}, {20,22}, {21,23}, {21,24}, {22,25}, {23,25}, {23,26}, {24,27}, {25,27}, {25,28}, {26,29}, {27,30}, {27,30}, {28,31}, {29,32}, {29,33}, {30,33}, {31,34}, {31,35}, {32,36}, {33,36}, {33,37}, {34,38}, {35,39}, {35,39}, {36,40}, {37,41}, {37,42}, {38,42}, {39,43}, {39,44}, {40,45}, {41,45}, {41,46}, {42,47}, {43,48}, {43,48}, {44,49}, {45,50}, {46,51}, {46,51}, {47,52}, {48,53}, {48,54}, {49,54}, {50,55}, {50,56}, {51,56}, {52,57}, {52,58}, {53,59}, {54,59}, {54,60}, {55,61}, {56,62}, {56,62}, {57,63}, {58,64}, {58,65}, {59,65}, {60,66}, {60,67}, {61,68}, {62,68}, {62,69}, {63,70}, {64,71}, {64,71}, {65,72}, {66,73}, {66,74}, {67,74}, {68,75}, {68,76}, {69,77}, {70,77}, {70,78}, {71,79}, {72,80}, {72,80}, {73,81}, {74,82}, {74,82}, {75,83}, {76,84}, {76,85}, {77,85}, {78,86}, {78,87}, {79,88}, {80,88}, {80,89}, {81,90}, {82,91}, {82,91}, {83,92}, {84,93}, {84,94}, {85,94}, {86,95}, {86,96}, {87,97}, {88,97}, {88,98}, {89,99}, {90,100}, {90,100}, {91,101}, {92,102}, {92,103}, {93,103}, {94,104}, {94,105}, {95,106}, {96,106}, {96,107}, {97,108}, {98,108}, {98,109}, {99,110}, {100,111}, {100,111}, {101,112}, {102,113}, {102,114}, {103,114}, {104,115}, {104,116}, {105,117}, {106,117}, {106,118}, {107,119}, {108,120}, {108,120}, {109,121}, {110,122}, {110,123}, {111,123}, {112,124}, {112,125}, {113,126}, {114,126}, {114,127}, {115,128}, {116,129}, {116,129}, {117,130}, {118,131}, {118,132}, {119,132}, {120,133}, {120,134}, {121,135}, {122,135}, {122,136}, {123,137}, {124,137}, {124,138}, {125,139}, {126,140}, {126,140}, {127,141}, {128,142}, {128,143}, {129,143}, {130,144}, {130,145}, {131,146}, {132,146}, {132,147}, {133,148}}
};
///
void DrawAnalogClock(Uint8 *rgbbuff, struct tm tm, Uint16 radius)
{
	/*
	#define	base	8
	#define	round	100
	Uint8 table[base][round][2] =
	{
		{{0,0}, {0,1}, {0,2}, {0,3}, {0,4}, {0,5}, {0,6}, {0,7}, {0,8}, {0,9}, {0,10}, {0,11}, {0,12}, {0,13}, {0,14}, {0,15}, {0,16}, {0,17}, {0,18}, {0,19}, {0,20}, {0,21}, {0,22}, {0,23}, {0,24}, {0,25}, {0,26}, {0,27}, {0,28}, {0,29}, {0,30}, {0,31}, {0,32}, {0,33}, {0,34}, {0,35}, {0,36}, {0,37}, {0,38}, {0,39}, {0,40}, {0,41}, {0,42}, {0,43}, {0,44}, {0,45}, {0,46}, {0,47}, {0,48}, {0,49}, {0,50}, {0,51}, {0,52}, {0,53}, {0,54}, {0,55}, {0,56}, {0,57}, {0,58}, {0,59}, {0,60}, {0,61}, {0,62}, {0,63}, {0,64}, {0,65}, {0,66}, {0,67}, {0,68}, {0,69}, {0,70}, {0,71}, {0,72}, {0,73}, {0,74}, {0,75}, {0,76}, {0,77}, {0,78}, {0,79}, {0,80}, {0,81}, {0,82}, {0,83}, {0,84}, {0,85}, {0,86}, {0,87}, {0,88}, {0,89}, {0,90}, {0,91}, {0,92}, {0,93}, {0,94}, {0,95}, {0,96}, {0,97}, {0,98}, {0,99}},
		{{0,0}, {0,1}, {0,2}, {0,3}, {0,4}, {1,5}, {1,6}, {1,7}, {1,8}, {1,9}, {1,10}, {1,11}, {1,12}, {1,13}, {1,14}, {2,15}, {2,16}, {2,17}, {2,18}, {2,19}, {2,20}, {2,21}, {2,22}, {2,23}, {3,24}, {3,25}, {3,26}, {3,27}, {3,28}, {3,29}, {3,30}, {3,31}, {3,32}, {3,33}, {4,34}, {4,35}, {4,36}, {4,37}, {4,38}, {4,39}, {4,40}, {4,41}, {4,42}, {4,43}, {5,44}, {5,45}, {5,46}, {5,47}, {5,48}, {5,49}, {5,50}, {5,51}, {5,52}, {6,53}, {6,54}, {6,55}, {6,56}, {6,57}, {6,58}, {6,59}, {6,60}, {6,61}, {6,62}, {7,63}, {7,64}, {7,65}, {7,66}, {7,67}, {7,68}, {7,69}, {7,70}, {7,71}, {8,72}, {8,73}, {8,74}, {8,75}, {8,76}, {8,77}, {8,78}, {8,79}, {8,80}, {8,81}, {9,82}, {9,83}, {9,84}, {9,85}, {9,86}, {9,87}, {9,88}, {9,89}, {9,90}, {10,91}, {10,91}, {10,92}, {10,93}, {10,94}, {10,95}, {10,96}, {10,97}, {10,98}},
		{{0,0}, {0,1}, {0,2}, {1,3}, {1,4}, {1,5}, {1,6}, {1,7}, {2,8}, {2,9}, {2,10}, {2,11}, {2,12}, {3,13}, {3,14}, {3,15}, {3,16}, {4,17}, {4,18}, {4,19}, {4,20}, {4,21}, {5,22}, {5,22}, {5,23}, {5,24}, {5,25}, {6,26}, {6,27}, {6,28}, {6,29}, {6,30}, {7,31}, {7,32}, {7,33}, {7,34}, {7,35}, {8,36}, {8,37}, {8,38}, {8,39}, {9,40}, {9,41}, {9,42}, {9,43}, {9,44}, {10,45}, {10,46}, {10,47}, {10,48}, {10,49}, {11,50}, {11,51}, {11,52}, {11,53}, {11,54}, {12,55}, {12,56}, {12,57}, {12,58}, {12,59}, {13,60}, {13,61}, {13,62}, {13,63}, {14,64}, {14,65}, {14,66}, {14,67}, {14,67}, {15,68}, {15,69}, {15,70}, {15,71}, {15,72}, {16,73}, {16,74}, {16,75}, {16,76}, {16,77}, {17,78}, {17,79}, {17,80}, {17,81}, {17,82}, {18,83}, {18,84}, {18,85}, {18,86}, {19,87}, {19,88}, {19,89}, {19,90}, {19,91}, {20,92}, {20,93}, {20,94}, {20,95}, {20,96}, {21,97}},
		{{0,0}, {0,1}, {1,2}, {1,3}, {1,4}, {2,5}, {2,6}, {2,7}, {2,8}, {3,9}, {3,10}, {3,10}, {4,11}, {4,12}, {4,13}, {5,14}, {5,15}, {5,16}, {6,17}, {6,18}, {6,19}, {6,20}, {7,21}, {7,22}, {7,23}, {8,24}, {8,25}, {8,26}, {9,27}, {9,28}, {9,29}, {10,29}, {10,30}, {10,31}, {11,32}, {11,33}, {11,34}, {11,35}, {12,36}, {12,37}, {12,38}, {13,39}, {13,40}, {13,41}, {14,42}, {14,43}, {14,44}, {15,45}, {15,46}, {15,47}, {15,48}, {16,49}, {16,49}, {16,50}, {17,51}, {17,52}, {17,53}, {18,54}, {18,55}, {18,56}, {19,57}, {19,58}, {19,59}, {19,60}, {20,61}, {20,62}, {20,63}, {21,64}, {21,65}, {21,66}, {22,67}, {22,68}, {22,68}, {23,69}, {23,70}, {23,71}, {23,72}, {24,73}, {24,74}, {24,75}, {25,76}, {25,77}, {25,78}, {26,79}, {26,80}, {26,81}, {27,82}, {27,83}, {27,84}, {28,85}, {28,86}, {28,87}, {28,87}, {29,88}, {29,89}, {29,90}, {30,91}, {30,92}, {30,93}, {31,94}},
		{{0,0}, {0,1}, {1,2}, {1,3}, {2,4}, {2,5}, {2,5}, {3,6}, {3,7}, {4,8}, {4,9}, {4,10}, {5,11}, {5,12}, {6,13}, {6,14}, {7,15}, {7,16}, {7,16}, {8,17}, {8,18}, {9,19}, {9,20}, {9,21}, {10,22}, {10,23}, {11,24}, {11,25}, {11,26}, {12,26}, {12,27}, {13,28}, {13,29}, {13,30}, {14,31}, {14,32}, {15,33}, {15,34}, {15,35}, {16,36}, {16,37}, {17,37}, {17,38}, {17,39}, {18,40}, {18,41}, {19,42}, {19,43}, {20,44}, {20,45}, {20,46}, {21,47}, {21,48}, {22,48}, {22,49}, {22,50}, {23,51}, {23,52}, {24,53}, {24,54}, {24,55}, {25,56}, {25,57}, {26,58}, {26,58}, {26,59}, {27,60}, {27,61}, {28,62}, {28,63}, {28,64}, {29,65}, {29,66}, {30,67}, {30,68}, {31,69}, {31,69}, {31,70}, {32,71}, {32,72}, {33,73}, {33,74}, {33,75}, {34,76}, {34,77}, {35,78}, {35,79}, {35,79}, {36,80}, {36,81}, {37,82}, {37,83}, {37,84}, {38,85}, {38,86}, {39,87}, {39,88}, {39,89}, {40,90}, {40,90}},
		{{0,0}, {1,1}, {1,2}, {2,3}, {2,3}, {3,4}, {3,5}, {4,6}, {4,7}, {5,8}, {5,9}, {6,10}, {6,10}, {7,11}, {7,12}, {8,13}, {8,14}, {9,15}, {9,16}, {10,16}, {10,17}, {11,18}, {11,19}, {12,20}, {12,21}, {13,22}, {13,23}, {14,23}, {14,24}, {15,25}, {15,26}, {16,27}, {16,28}, {17,29}, {17,29}, {18,30}, {18,31}, {19,32}, {19,33}, {20,34}, {20,35}, {21,36}, {21,36}, {22,37}, {22,38}, {23,39}, {23,40}, {24,41}, {24,42}, {25,42}, {25,43}, {26,44}, {26,45}, {27,46}, {27,47}, {28,48}, {28,48}, {29,49}, {29,50}, {30,51}, {30,52}, {31,53}, {31,54}, {32,55}, {32,55}, {33,56}, {33,57}, {34,58}, {34,59}, {35,60}, {35,61}, {36,61}, {36,62}, {37,63}, {37,64}, {38,65}, {38,66}, {39,67}, {39,68}, {40,68}, {40,69}, {41,70}, {41,71}, {42,72}, {42,73}, {43,74}, {43,74}, {44,75}, {44,76}, {45,77}, {45,78}, {46,79}, {46,80}, {47,81}, {47,81}, {48,82}, {48,83}, {49,84}, {49,85}, {50,86}},
		{{0,0}, {1,1}, {1,2}, {2,2}, {2,3}, {3,4}, {4,5}, {4,6}, {5,6}, {5,7}, {6,8}, {6,9}, {7,10}, {8,11}, {8,11}, {9,12}, {9,13}, {10,14}, {11,15}, {11,15}, {12,16}, {12,17}, {13,18}, {14,19}, {14,19}, {15,20}, {15,21}, {16,22}, {16,23}, {17,23}, {18,24}, {18,25}, {19,26}, {19,27}, {20,28}, {21,28}, {21,29}, {22,30}, {22,31}, {23,32}, {24,32}, {24,33}, {25,34}, {25,35}, {26,36}, {26,36}, {27,37}, {28,38}, {28,39}, {29,40}, {29,40}, {30,41}, {31,42}, {31,43}, {32,44}, {32,44}, {33,45}, {34,46}, {34,47}, {35,48}, {35,49}, {36,49}, {36,50}, {37,51}, {38,52}, {38,53}, {39,53}, {39,54}, {40,55}, {41,56}, {41,57}, {42,57}, {42,58}, {43,59}, {43,60}, {44,61}, {45,61}, {45,62}, {46,63}, {46,64}, {47,65}, {48,66}, {48,66}, {49,67}, {49,68}, {50,69}, {51,70}, {51,70}, {52,71}, {52,72}, {53,73}, {53,74}, {54,74}, {55,75}, {55,76}, {56,77}, {56,78}, {57,78}, {58,79}, {58,80}},
		{{0,0}, {1,1}, {1,1}, {2,2}, {3,3}, {3,4}, {4,4}, {5,5}, {5,6}, {6,7}, {7,7}, {7,8}, {8,9}, {9,10}, {9,10}, {10,11}, {11,12}, {11,13}, {12,13}, {13,14}, {13,15}, {14,16}, {15,16}, {15,17}, {16,18}, {17,19}, {17,19}, {18,20}, {19,21}, {19,22}, {20,22}, {21,23}, {21,24}, {22,25}, {23,25}, {23,26}, {24,27}, {25,27}, {25,28}, {26,29}, {27,30}, {27,30}, {28,31}, {29,32}, {29,33}, {30,33}, {31,34}, {31,35}, {32,36}, {33,36}, {33,37}, {34,38}, {35,39}, {35,39}, {36,40}, {37,41}, {37,42}, {38,42}, {39,43}, {39,44}, {40,45}, {41,45}, {41,46}, {42,47}, {43,48}, {43,48}, {44,49}, {45,50}, {46,51}, {46,51}, {47,52}, {48,53}, {48,54}, {49,54}, {50,55}, {50,56}, {51,56}, {52,57}, {52,58}, {53,59}, {54,59}, {54,60}, {55,61}, {56,62}, {56,62}, {57,63}, {58,64}, {58,65}, {59,65}, {60,66}, {60,67}, {61,68}, {62,68}, {62,69}, {63,70}, {64,71}, {64,71}, {65,72}, {66,73}, {66,74}}
	};
	*/
	int sec = tm.tm_sec, min = tm.tm_min, hour = tm.tm_hour, i, j, k, t, l;
	int lenOfSec = radius;					//1.0 * r
	int lenOfMin = radius - radius / 10;	//0.9 * r
	int lenOfHour = radius - radius / 3;	//0.66 * r
	Uint16 *buff = (Uint16 *)rgbbuff, color = BLACK_555;
	COORD center;

	if (prev_active_index == FI_ACTIVE)
		center = desc->MiscTextCoord[34];
	else
		center = desc->MiscTextCoord[15];

 	///070821 centerXYm_
	int *CXYTable = NULL;
	int bottom = center.y + radius;
	MEMALLOC(CXYTable, int, OUTPUT_YRES);
	if (!CXYTable) return;
	 i = center.y - radius;
	 CXYTable[i] = i * OUTPUT_XRES + center.x;
	 i++;
	for (; i<=bottom; i++)
	{
		CXYTable[i] = CXYTable[i-1] + OUTPUT_XRES;
	}
	///

	//
	//0: draw sec; 1: draw min; 2: draw hour
	for(k = 0; k <= 2;k++)
	{
		switch(k)
		{
			case 0:
				t = sec;
				l = lenOfSec;
				break;
			case 1:
				t = min;
				l = lenOfMin;
				break;
			case 2:
				t = (hour % 12) * 5 + min / 12;
				l = lenOfHour;
				break;
			default:
				break;
		}
///
		if (t <= 30)
		{
			if (t <= 7)
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y - table[t][i][1]] + (j + table[t][i][0])] = color;
			else if (t <= 15)
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y - table[15 - t][i][0]] + (j + table[15 - t][i][1])] = color;
			else if (t <= 22)
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y + table[t - 15][i][0]] + (j + table[t - 15][i][1])] = color;
			else
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y + table[30 - t][i][1]] + (j + table[30 - t][i][0])] = color;
		}
		else
		{
			if (t <= 37)
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y + table[t - 30][i][1]] + (j - table[t - 30][i][0])] = color;
			else if (t <= 45)
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y + table[45 - t][i][0]] + (j - table[45 - t][i][1])] = color;
			else if (t <= 52)
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y - table[t - 45][i][0]] + (j - table[t - 45][i][1])] = color;
			else
				for(i = 0; i < l; i++)
				for(j = 0 - k; j <= k; j++)
					buff[CXYTable[center.y - table[60 - t][i][1]] + (j - table[60 - t][i][0])] = color;
		}

///
		/*
		for(i = 0; i < l; i++)
		{
			if(t <= 7)//0~7
				for(j = 0 - k; j <= k; j++)
					buff[(center.y - table[t][i][1]) * OUTPUT_XRES + (center.x + j + table[t][i][0])] = color;
			else if(t <= 15)//8~15
				for(j = 0 - k; j <= k; j++)
					buff[(center.y - table[15 - t][i][0]) * OUTPUT_XRES + (center.x + j + table[15 - t][i][1])] = color;
			else if(t <= 22)//16~22
				for(j = 0 - k; j <= k; j++)
					buff[(center.y + table[t - 15][i][0]) * OUTPUT_XRES + (center.x + j + table[t - 15][i][1])] = color;
			else if(t <= 30)//22~30
				for(j = 0 - k; j <= k; j++)
					buff[(center.y + table[30 - t][i][1]) * OUTPUT_XRES + (center.x + j + table[30 - t][i][0])] = color;
			else if(t <= 37)//30~37
				for(j = 0 - k; j <= k; j++)
					buff[(center.y + table[t - 30][i][1]) * OUTPUT_XRES + (center.x + j - table[t - 30][i][0])] = color;
			else if(t <= 45)//38~45
				for(j = 0 - k; j <= k; j++)
					buff[(center.y + table[45 - t][i][0]) * OUTPUT_XRES + (center.x + j - table[45 - t][i][1])] = color;
			else if(t <= 52)//46~52
				for(j = 0 - k; j <= k; j++)
					buff[(center.y - table[t - 45][i][0]) * OUTPUT_XRES + (center.x + j - table[t - 45][i][1])] = color;
			else//53~59
				for(j = 0 - k; j <= k; j++)
					buff[(center.y - table[60 - t][i][1]) * OUTPUT_XRES + (center.x + j - table[60 - t][i][0])] = color;
		}
		*/
	}
	FREEMEMORY(CXYTable);
}
//------------------------------------------------------------------------------------------------
///071003 ū׭p
#ifdef USE_THERMOMETER
void DrawTemperature(Uint8 *rgbbuff)
{
	char strTemprature[16] = {0};
	float CurrTemprature;
	int fd = open("/dev/temperature", O_RDONLY);
	if (fd < 0)
	{
		DMSG("can not open /dev/temperature");
		return;
	}
	read(fd, strTemprature, 16);
	CurrTemprature = atof(strTemprature);
	sprintf(strTemprature, "%.1fC", CurrTemprature);
	close(fd);

	FontTextOut(g_pFontDB_Default, (Uint16*)rgbbuff, desc->MiscTextCoord[41].x, desc->MiscTextCoord[41].y, strTemprature, GREEN_1555);
}
#endif
///
//------------------------------------------------------------------------------------------------
void DrawCalendar(Uint8 *rgbbuff, struct tm tm, Uint8 bDrawFocus)
{
#if defined(GUI_STYLE_COMTEK)
	Uint16 textx, texty;
	char string[14/*LEN_S*/];
	Uint16 FONT_HEIGHT = 26, FONT_WIDTH = 13;
	Uint8 DayIndex, ItemIndex;

	if(g_pFontDB_Default){
		FONT_HEIGHT = g_pFontDB_Default->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Default, "0");
	}

	textx = desc->MiscTextCoord[11].x;
	texty = desc->MiscTextCoord[11].y;

	//Highlight Selected Item
	DayIndex = CalSelectedAutoPwrOnOffTime / 5;
	ItemIndex = CalSelectedAutoPwrOnOffTime % 5;
	DrawRectBitmap((Uint16 *)rgbbuff, textx+3*ItemIndex*FONT_WIDTH, texty+DayIndex*(FONT_HEIGHT+20), 2*FONT_WIDTH, FONT_HEIGHT, YELLOW_1555);

	memset(string, 0, 14/*LEN_S*/);
	for(DayIndex=0; DayIndex<7; DayIndex++){
		//Program Download
		if(setup->cal_program_download[DayIndex] == 1)
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, textx+6*FONT_WIDTH+6, texty+DayIndex*(FONT_HEIGHT+20), "*", GREEN_1555);
		else
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, textx+6*FONT_WIDTH+6, texty+DayIndex*(FONT_HEIGHT+20), " ", GREEN_1555);

		//OnHr:OnMin
		sprintf(string, "%02d:%02d    %02d:%02d", setup->cal_autopwr_on_hour[DayIndex], setup->cal_autopwr_on_minute[DayIndex]
						, setup->cal_autopwr_off_hour[DayIndex], setup->cal_autopwr_off_minute[DayIndex]);
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, textx, texty+DayIndex*(FONT_HEIGHT+20), string, GREEN_1555);
	}
#else
	char/* *months[12] = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}
		,*/ year[LEN_L], day[LEN_S];
	//char *days[7] = {"Sun", "Mon", "Tue", "Wed", "Thr", "Fri", "Sat"};
	int adjust[7] = {6, 7, 1, 2, 3, 4, 5}, date, temp, counter = 0, i, j, mon, yr, today;
	Uint16 X, tmpX, Y, tmpY;
	Uint8 mon_len, yr_len, lmt;
	char str[LEN_M];

	///070816
	Uint16 FONT_HEIGHT = 26, FONT_WIDTH = 13;
	if (g_pFontDB_Default)
	{
		FONT_HEIGHT = g_pFontDB_Default->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Default, "0");	//wre
	}
	///

	mon = tm.tm_mon + 1;
	yr = tm.tm_year + 1900;
	today = tm.tm_mday;
	memset(year, 0, LEN_L);
	sprintf(year, "%d", yr);

	mon_len = strlen(calStr[setup->Language][mon - 1]);
	yr_len = strlen(year);

	if (prev_active_index == FI_ACTIVE)	//ùnq 2xxx/xx/xx Mon.
	{
		tmpX = desc->MiscTextCoord[32].x;		//date coordinate
		tmpY = desc->MiscTextCoord[32].y;
		sprintf(str, "%d/%02d/%02d %s", yr, mon, today, calStr[setup->Language][adjust[Calculate(mon, today, yr)]+11]);
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, tmpX, tmpY, str, LTK_WHITE);
		#else
		FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, tmpX, tmpY, str, BLUE_1555);
		#endif
	}
	else		//uqP~
	{
		tmpX = desc->MiscTextCoord[26].x;		//date coordinate
		tmpY = desc->MiscTextCoord[26].y;
		#ifdef LEADTEK
		tmpX += FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX, tmpY, calStr[setup->Language][mon - 1], LTK_YELLOW);
		#else
		tmpX += FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX, tmpY, calStr[setup->Language][mon - 1], GREEN_1555);
		#endif
		tmpX += GetFontStringWidth(g_pFontDB_Local, " ");	//Ť@
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX, tmpY, year, LTK_WHITE);
		#else
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX, tmpY, year, BLUE_1555);
		#endif
	}

	if (prev_active_index != FI_ACTIVE)	//ùζ
	{
		tmpX = X = desc->MiscTextCoord[11].x;
		tmpY = Y = desc->MiscTextCoord[11].y;

		int columnWidth = FONT_WIDTH >> 1, diff = (FONT_WIDTH * 3) + columnWidth;
		X += columnWidth;
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += FONT_WIDTH, tmpY, calStr[0][12], LTK_RED);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[0][13], LTK_GREY);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[0][14], LTK_GREY);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[0][15], LTK_GREY);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[0][16], LTK_GREY);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[0][17], LTK_GREY);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[0][18], LTK_GREEN);
		#else
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += columnWidth, tmpY, calStr[setup->Language][12], RED_1555);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[setup->Language][13], BLUE_1555);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[setup->Language][14], BLUE_1555);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[setup->Language][15], BLUE_1555);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[setup->Language][16], BLUE_1555);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[setup->Language][17], BLUE_1555);
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, tmpX += diff, tmpY, calStr[setup->Language][18], GREEN_1555);
		#endif

		tmpX = X;
		tmpY += FONT_HEIGHT;
		for(i = 1; i <= 31; i++)
		{
			temp = Calculate(mon, i, yr);
			if(temp >= 0)
			{
				date = adjust[temp];
				if(date)
				{
					if(i == 1)
					{
						for(j = 1; j < date; j++)
						{
							tmpX += (3 * FONT_WIDTH) + columnWidth;
							counter += 1;
						}
						tmpX += FONT_WIDTH;
					}
					else
					{
						tmpX += (i == 10 ? (2 * FONT_WIDTH) : (3 * FONT_WIDTH)) + columnWidth;
						counter += 1;
					}
					if(!(counter % 7))
					{
						tmpX = (i >= 10 ? X : (X + FONT_WIDTH));
						if(i != 1)
							tmpY += FONT_HEIGHT;
					}
					memset(day, 0, LEN_S);
					sprintf(day, "%d", i);
					if(bDrawFocus && i == today)
					{
						if(i < 10)
							DrawRectBitmap((Uint16 *)rgbbuff, tmpX - FONT_WIDTH, tmpY, 2 * FONT_WIDTH, FONT_HEIGHT, YELLOW_1555);
						else
							DrawRectBitmap((Uint16 *)rgbbuff, tmpX, tmpY, 2 * FONT_WIDTH, FONT_HEIGHT, YELLOW_1555);
					}

					if (date == 1)		//Sunday
						FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, tmpX, tmpY, day, RED_1555);
					else if (date == 7)		//Saturday
						FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, tmpX, tmpY, day, GREEN_1555);
					else
						FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, tmpX, tmpY, day, BLUE_1555);

				}
			}
		}
	}
#endif
}
//------------------------------------------------------------------------------------------------
void DrawCalImage(Uint8 *rgbbuff)
{
#ifdef MEDIALINK
	return;
#endif
	int i = 0, status, tempCalImgIdx = calImgIdx;
	pid_t pid;
	char s[LEN_XL], tmpW[LEN_S], tmpH[LEN_S];
	LIST *tmpList;

	if(ImgCount > 0)
	{
		tmpList = ImageList->next;		///070713
		posOfCalImage = desc->MiscTextCoord[16];
		//posOfCalImage.x = desc->MiscTextCoord[16].x;
		//posOfCalImage.y = desc->MiscTextCoord[16].y;
		///
		if(prev_active_index == I_ACTIVE)
		{
			while(tmpList != NULL && i < CurrPhotoIdx4SSCal)
			{
				tmpList = tmpList->next;
				i++;
			}
		}
		else
		{
			while(ImgCount > 1 && calImgIdx == tempCalImgIdx)
			{
				srand((int)time(0));
				tempCalImgIdx = (int)(ImgCount * (rand() / (RAND_MAX + 1.0)));
			}
			if(ImgCount > 1)
				calImgIdx = tempCalImgIdx;
			else
				calImgIdx = 0;
			//
			for(i = 0; i < calImgIdx; i++)
				tmpList = tmpList->next;
		}
		GetPath(s);
		strcat(s, tmpList->fname);
		//PRINTF("---%d-%d-%s---\n", calImgIdx, ImgCount, s);
		sprintf(tmpW, "%d", posOfCalImage.width);
		sprintf(tmpH, "%d", posOfCalImage.height);
		//
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to Draw Calendar Image Fail!");
				break;
				//exit(1);
			case 0:
				//child process
				memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
				execl("/sky/skyview", "skyview", "-rgb", "0", "-x", tmpW, "-y", tmpH, s, NULL);
				_EXIT;
			default:
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
					DuplicateBitmap((Uint16 *)rgbbuff, (Uint16 *)RGB0, posOfCalImage.x, posOfCalImage.y, posOfCalImage.width, posOfCalImage.height);
				break;
		}
	}
}
//------------------------------------------------------------------------------------------------
void DrawAlarmInfo(Uint8 *rgbbuff, Uint8 yuvNo)
{
	char temp[LEN_M];
	FRAME *elmf;

	//COORD pOfText = {desc->MiscTextCoord[17].x, desc->MiscTextCoord[17].y, 0, 0};
	COORD pOfTime, pOfAlrmingMsg;
	pOfAlrmingMsg = desc->MiscTextCoord[19];

	if (prev_active_index == FI_ACTIVE)
	{
		pOfTime = desc->MiscTextCoord[36];
	}
	else
	{
		pOfTime = desc->MiscTextCoord[18];
	}
	///

	elmf = &ELMachines[active_index].frame;
	memset(temp, 0, LEN_M);
	sprintf(temp, "%02d:%02d", setup->alarm_hour, setup->alarm_minute);

	//duplicate
	if(!isCalDrawedFirstTime)
	{
//#ifdef USE_DESC_LCD
		if (prev_active_index == FI_ACTIVE)
		{
			CopyBlockBitmap((Uint16*)rgbbuff, OUTPUT_XRES, pOfTime.x, pOfTime.y,
							(Uint16*)elmf->bkgrdbuff, elmf->framecoord.width,
							pOfTime.x -elmf->framecoord.x, pOfTime.y - elmf->framecoord.y,
							pOfTime.width, pOfTime.height);
			/*
			CopyBlockBitmap((Uint16*)rgbbuff, OUTPUT_XRES, pOfAlrmingMsg.x, pOfAlrmingMsg.y,
							(Uint16*)elmf->bkgrdbuff, elmf->framecoord.width,
							pOfAlrmingMsg.x -elmf->framecoord.x, pOfAlrmingMsg.y - elmf->framecoord.y,
							pOfAlrmingMsg.width, pOfAlrmingMsg.height);
			*/
		}
		else
//#endif
		{
			//Alarm Time
			DuplicateBlockBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff, pOfTime.x, pOfTime.y, pOfTime.width, pOfTime.height);
			//Alarm Msg
			DuplicateBlockBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff, pOfAlrmingMsg.x, pOfAlrmingMsg.y, pOfAlrmingMsg.width, pOfAlrmingMsg.height);
		}
	}

	//text out

	///070711 Ȯɤ"Alarm Time"r
	/*
	if(isCalDrawedFirstTime)
		FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, pOfText.x, pOfText.y, FrameText[setup->Language][21], RED_1555);
	*/
	///

	if(setup->alarm_setup_idx == SETUP_OFF)
	{
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, pOfTime.x, pOfTime.y, "--:--", LTK_GREY);
			#else
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, pOfTime.x, pOfTime.y, "--:--", GREY40_1555);
			#endif
	}
	else if(setup->alarm_setup_idx == SETUP_ON)
	{
			#ifdef LEADTEK
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, pOfTime.x, pOfTime.y, temp, LTK_RED);
			#else
			FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, pOfTime.x, pOfTime.y, temp, RED_1555/*BLUE_1555*/);
			#endif
	}

	if(isCalAlarmRinging == 1)
	{
//#ifdef USE_DESC_LCD
		if (prev_active_index == FI_ACTIVE)
			;
		else
//#endif
			FontTextOut(g_pFontDB_Local, (Uint16 *)rgbbuff, pOfAlrmingMsg.x, pOfAlrmingMsg.y, FrameText[setup->Language][22], RED_1555);
	}

	//convert
	if(!isCalDrawedFirstTime)
	{
		if(prev_active_index != FI_ACTIVE)
		{
			RGBlock2YUVBlock(rgbbuff, yuvNo, pOfTime.x, pOfTime.y, pOfTime.width, pOfTime.height);
			RGBlock2YUVBlock(rgbbuff, yuvNo, pOfAlrmingMsg.x, pOfAlrmingMsg.y, pOfAlrmingMsg.width, pOfAlrmingMsg.height);
		}
		else
		{
			SetRGBuffBlockMSB(0, rgbbuff, 1, pOfTime.x, pOfTime.y, pOfTime.width, pOfTime.height, WHITE_555);
			//marked by bk @ 070821
			//SetRGBuffBlockMSB(0, rgbbuff, 1, pOfAlrmingMsg.x, pOfAlrmingMsg.y, pOfAlrmingMsg.width, pOfAlrmingMsg.height, WHITE_555);
		}
	}
}
//------------------------------------------------------------------------------------------------
void DrawCalendarTime(Uint8 *rgbbuff, Uint8 yuvNo, Sint8 pls_mns)//-1 for minus; 1 for plus; 0 for otherwise
{
	FRAME *elmf;
	int fd;
	static Uint8 preHour = 0, preSec = -1, preDate = -1;
//	struct rtc_time tm;
	time_t t;
	struct tm tm;
	///071031 Oܦ~B
	static int RecordMonth = 0, RecordYear = 0;
	static Uint8 isThisMonth = TRUE;
	///

	Uint16 ClockRadius = 0;	//AnalogClockWidthNb|

	elmf = &ELMachines[active_index].frame;

	COORD posOfAnlgClck, posOfDgtlClck, posOfDate, posOfClndr;
///071003 ū׭p
#ifdef USE_THERMOMETER
	COORD posOfTemperature;
#endif
///

	if (prev_active_index == FI_ACTIVE)	//full imagecalendarίSI
	{
		//xenia
		ClockRadius = desc->MiscTextCoord[34].width;
		posOfAnlgClck.x = desc->MiscTextCoord[34].x - ClockRadius;
		posOfAnlgClck.y = desc->MiscTextCoord[34].y - ClockRadius;
		posOfAnlgClck.width= (ClockRadius << 1) + 1;
		posOfAnlgClck.height= (ClockRadius << 1) + 1;
		//posOfDgtlClck	= desc->MiscTextCoord[35];
		posOfDate = desc->MiscTextCoord[32];
		//posOfClndr = desc->MiscTextCoord[33];
	}
	else		//@뱡pcalencdar
	{
		//xenia
		ClockRadius = desc->MiscTextCoord[15].width;
		posOfAnlgClck.x = desc->MiscTextCoord[15].x - ClockRadius;
		posOfAnlgClck.y = desc->MiscTextCoord[15].y - ClockRadius;
		posOfAnlgClck.width= (ClockRadius << 1) + 1;
		posOfAnlgClck.height= (ClockRadius << 1) + 1;
		posOfDgtlClck	= desc->MiscTextCoord[10];
		posOfDate = desc->MiscTextCoord[26];
		posOfClndr = desc->MiscTextCoord[11];
///071003 ū׭p
#ifdef USE_THERMOMETER
		posOfTemperature = desc->MiscTextCoord[41];
#endif
///
	}
	///

//	if((fd = open("/dev/rtc", O_RDONLY)) == -1)
//	{
//		perror("/dev/rtc");
//		exit(1);
//	}
//	if(ioctl(fd, RTC_RD_TIME, &tm) == -1)
//	{
//		perror("ioctl");
//		exit(1);
//	}
//	//PRINTF("%d/%d/%d %02d:%02d:%02d\n\n", rtc_tm.tm_year, rtc_tm.tm_mon, rtc_tm.tm_mday, rtc_tm.tm_hour, rtc_tm.tm_min, rtc_tm.tm_sec);
	time(&t);
	memcpy(&tm, localtime(&t), sizeof(tm));
//	PRINTF("%d/%d/%d %02d:%02d:%02d\n\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);

	//Digital Clock & Analog Clock
	if(preSec < tm.tm_sec || (preSec == 59 && tm.tm_sec == 0))//preSec update at end of the function
	{
		if (prev_active_index == FI_ACTIVE)
		{
			/*
			CopyBlockBitmap((Uint16*)rgbbuff, OUTPUT_XRES, posOfDgtlClck.x, posOfDgtlClck.y,
							(Uint16*)elmf->bkgrdbuff, elmf->framecoord.width,
							posOfDgtlClck.x - elmf->framecoord.x, posOfDgtlClck.y - elmf->framecoord.y,
							posOfDgtlClck.width, posOfDgtlClck.height);
			*/
			CopyBlockBitmap((Uint16*)rgbbuff, OUTPUT_XRES, posOfAnlgClck.x, posOfAnlgClck.y,
							(Uint16*)elmf->bkgrdbuff, elmf->framecoord.width,
							posOfAnlgClck.x - elmf->framecoord.x, posOfAnlgClck.y - elmf->framecoord.y,
							posOfAnlgClck.width, posOfAnlgClck.height);
		}
		else
		{
			DuplicateBlockBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff, posOfDgtlClck.x, posOfDgtlClck.y, posOfDgtlClck.width, posOfDgtlClck.height);
			DuplicateBlockBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff, posOfAnlgClck.x, posOfAnlgClck.y, posOfAnlgClck.width, posOfAnlgClck.height);
///071003 ū׭p
#ifdef USE_THERMOMETER
			DuplicateBlockBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff, posOfTemperature.x, posOfTemperature.y, posOfTemperature.width, posOfTemperature.height);
			DrawTemperature(rgbbuff);
#endif
///
		#if !defined(GUI_STYLE_COMTEK)
			//Digital Clock
			DrawDigitalClock(rgbbuff, tm);
		#endif
		}

		//Analog Clock
		DrawAnalogClock(rgbbuff, tm, ClockRadius);

		if(prev_active_index != FI_ACTIVE)
		{
		#if !defined(GUI_STYLE_COMTEK)
			RGBlock2YUVBlock(rgbbuff, yuvNo, posOfDgtlClck.x, posOfDgtlClck.y, posOfDgtlClck.width, posOfDgtlClck.height);
		#endif
			RGBlock2YUVBlock(rgbbuff, yuvNo, posOfAnlgClck.x, posOfAnlgClck.y, posOfAnlgClck.width, posOfAnlgClck.height);
///071003 ū׭p
#ifdef USE_THERMOMETER
			RGBlock2YUVBlock(rgbbuff, yuvNo, posOfTemperature.x, posOfTemperature.y, posOfTemperature.width, posOfTemperature.height);
#endif
///
		}
	}

	//Calendar
	if (isCalDrawedFirstTime)
	{
		RecordMonth = tm.tm_mon;
		RecordYear = tm.tm_year;
		isThisMonth = TRUE;
	}

	switch (pls_mns)
	{
	case 0:		//ܨϥΪ̿쪺,nO_w
		if (  tm.tm_mday == 1 && preDate != tm.tm_mday 	//
		    &&
		    	isThisMonth == TRUE
		   )
		{
			RecordMonth = tm.tm_mon;
			RecordYear = tm.tm_year;
		}
		break;
	case 1:		//Vk
		if ((++RecordMonth) == 12)
		{
			RecordMonth = 0;
			if ((++RecordYear) > 137)	//O2038/1/19
			{
				RecordYear = 100;		//^2000~
			}
		}
		break;
	case -1:		//V
		if ((--RecordMonth) < 0)
		{
			RecordMonth = 11;
			if ((--RecordYear) < 100)
			{
				RecordYear = 100;		//b2000~H
				RecordMonth = 0;
			}
		}
		break;
	case -127:	//ɶPB(CalendarAEnter)
		RecordMonth = tm.tm_mon;
		RecordYear = tm.tm_year;
		break;
	default:
		break;
	}

	if (tm.tm_mon == RecordMonth && tm.tm_year == RecordYear)
	{
		isThisMonth = TRUE;
	}
	else
	{
		isThisMonth = FALSE;
	}

	tm.tm_mon = RecordMonth;
	tm.tm_year = RecordYear;

	if(isCalDrawedFirstTime || pls_mns != 0 || preDate != tm.tm_mday)
	{
		if (prev_active_index == FI_ACTIVE)
		{
			CopyBlockBitmap((Uint16*)rgbbuff, OUTPUT_XRES, posOfDate.x, posOfDate.y,
							(Uint16*)elmf->bkgrdbuff, elmf->framecoord.width,
							posOfDate.x - elmf->framecoord.x, posOfDate.y - elmf->framecoord.y,
							posOfDate.width, posOfDate.height);
		}
		else
		{
		#if !defined(GUI_STYLE_COMTEK)
			DuplicateBlockBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff, posOfDate.x, posOfDate.y, posOfDate.width, posOfDate.height);
		#endif
			DuplicateBlockBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->bkgrdbuff, posOfClndr.x, posOfClndr.y, posOfClndr.width, posOfClndr.height);
		}

		DrawCalendar(rgbbuff, tm, isThisMonth);

		if(prev_active_index != FI_ACTIVE)
		{
		#if !defined(GUI_STYLE_COMTEK)
			RGBlock2YUVBlock(rgbbuff, yuvNo, posOfDate.x, posOfDate.y, posOfDate.width, posOfDate.height);
		#endif
			RGBlock2YUVBlock(rgbbuff, yuvNo, posOfClndr.x, posOfClndr.y, posOfClndr.width, posOfClndr.height);
		}
	}

	//CalImage
	if(prev_active_index != FI_ACTIVE)
	{
		//if(tm.tm_sec == 00 && preSec == 59)//test
		//if(tm.tm_hour == 00 && preHour == 23)//cross date
		if(tm.tm_hour == 00 && tm.tm_min == 00 && tm.tm_sec == 02 && preSec == 01)//cross date, avoiding trigger interval (0.00 ~ 1.99 sec)
		{
		#if !defined(GUI_STYLE_COMTEK)
			DrawCalImage(rgbbuff);
			RGBlock2YUVBlock(rgbbuff, yuvNo, posOfCalImage.x, posOfCalImage.y, posOfCalImage.width, posOfCalImage.height);
		#endif
		}
		preHour = tm.tm_hour;
	}

	preSec = tm.tm_sec;
	preDate = tm.tm_mday;

}
//------------------------------------------------------------------------------------------------
void DrawStorageText(Uint8 *rgbbuff, Uint16 color)
{
	FRAME *elmf;
	COORD pos;

	elmf = &ELMachines[active_index].frame;
	pos = elmf->icon_arr[elmf->num_icon - 1].txtcoord;

	FontTextOut(g_pFontDB_Default, (Uint16 *)rgbbuff, pos.x, pos.y, SelectedDev, color);
}
//------------------------------------------------------------------------------------------------
void DrawStorageICON(Uint8 *rgbbuff)
{
	FRAME *elmf;
	Uint32 idx;
	Uint8 i;

	elmf = &ELMachines[active_index].frame;
	i = elmf->num_icon - 1;
	DuplicateBitmap((Uint16 *)rgbbuff, (Uint16 *)elmf->icon_arr[i].iconbuff,
				  elmf->icon_arr[i].icoord.x, elmf->icon_arr[i].icoord.y,
				  elmf->icon_arr[i].icoord.width, elmf->icon_arr[i].icoord.height);
}
//------------------------------------------------------------------------------------------------
void DrawThumbnail(Uint8 *rgbbuff, Uint8 n, Uint8 w, Uint8 h)
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	DuplicateBitmap((Uint16 *)rgbbuff, (Uint16 *)RGB0,
					  elmf->icon_arr[n].icoord.x, elmf->icon_arr[n].icoord.y, w, h);
}
//------------------------------------------------------------------------------------------------
/*
void DrawThumbnail2(Uint8 *rgbbuff, Uint8 n, Uint8 w, Uint8 h)
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	DuplicateBitmap((Uint16 *)rgbbuff, (Uint16 *)(RGB0+(w*h*2*n)),
					  elmf->icon_arr[n].icoord.x, elmf->icon_arr[n].icoord.y, w, h);
}
*/
//------------------------------------------------------------------------------------------------
#if 0//API release for LBC
#include "skyview.h"
#include "img_ident.c"
Uint8 isImgThumbnailAvailable(char* fName)
{
#define USABLE_FB_SIZE		fb_size - (OUTPUT_XRES * OUTPUT_YRES * 7) - ((256 + 8) << 10)
	//PRINTF("usage fb size: %d\n", USABLE_FB_SIZE);
	
	char* ext = NULL;
	long fSize = 0L;
	FILE *file = NULL;
	int img_type = IMG_FMT_UNKNOWN;
	
	//check file name
	if(fName == NULL)
	{
		PRINTF("Image FileName Error - %s\n", fName);
		return FALSE;
	}
	
	//open file
	if(!(file = fopen(fName, "r")))
	{
		PRINTF("Unable to open file - %s\n", fName);
		return FALSE;
	}
	
	//get img_type
	img_type = img_identify(file);
	
	//check bmp, tiff type (the same rule)
	if(img_type == IMG_FMT_BMP|| img_type == IMG_FMT_TIFF_BE || img_type == IMG_FMT_TIFF_LE)
	{
		fseek(file, 0, SEEK_END);
		fSize = ftell(file);
		
		//if the file size is smaller than 7M, the thumbnail is available
		if(fSize < (8 << 20))//7M
			return TRUE;
		else
			return FALSE;
	}
	
	//check jpg type
	else if(img_type == IMG_FMT_JPEG)
	{
		//get exif
		if(ProcessJpegFile(file))
		{
			//contains thumbnail (exif info)
			if(ImageInfo.ThumbnailOffset != 0 && ImageInfo.ThumbnailSize != 0)
				return TRUE;
			
			//contains no thumbnail
			else
			{
				DPRINTF("Image contains no thumbnail\n");
				
				fseek(file, 0, SEEK_END);
				fSize = ftell(file);
				
				//ˬdѤѱoXY
				if(((fSize >> 1) + ImageInfo.Width * ImageInfo.Height * 3) < USABLE_FB_SIZE)
					return TRUE;
				else
					return FALSE;
			}
		}
		else
			return FALSE;
	}
	
	fclose(file);
	
	return FALSE;
}
#endif
//------------------------------------------------------------------------------------------------
void DrawEXIF(char *str)
{
	FRAME *elmf;
	FILE *jpgfile;
	char s[LEN_XL];
//	char imginfo = 0;
	struct bmp_state *bmp_h;
	struct tiff_hdr *tiff_h;
	char *file_ext_ptr;

	///070817
	Uint16 x, y, border;
	COORD EXIFPos;
	Uint16 FONT_HEIGHT = 26, FONT_WIDTH = 13;
	if (g_pFontDB_Default)
	{
		FONT_HEIGHT = g_pFontDB_Default->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Default, "W");
	}
	border = (FONT_HEIGHT>>2);
	EXIFPos.width = (FONT_WIDTH<<4) + (FONT_WIDTH<<3) + (border<<1);	//20*FONT_WIDTH - extended to 24 by bk @ 070827
	EXIFPos.height = (FONT_HEIGHT<<3) + (border<<1);					//8*FONT_HEIGHT
	EXIFPos.x = (OUTPUT_XRES>>1) - (EXIFPos.width>>1);
	EXIFPos.y = OUTPUT_YRES - EXIFPos.height - FONT_HEIGHT;
	///

	isExifAvailable = FALSE;
	elmf = &ELMachines[active_index].frame;
	if(!(jpgfile = fopen(str, "r")))
	{
		DPRINTF("Unable to open jpg file %s\n", str);
		return;
		//exit(1);
	}

	///070814
	if (isInfoPressed)
	{
		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);//070827 by bk @ 070827
		#ifdef DARK_BLUE_DESIGN
		DrawRectBitmap((Uint16 *)RGB0, EXIFPos.x, EXIFPos.y, EXIFPos.width, EXIFPos.height, INFO_BACKGROUND);
		#else
		DrawRectBitmap((Uint16 *)RGB0, EXIFPos.x, EXIFPos.y, EXIFPos.width, EXIFPos.height, YELLOW_1555);
		#endif
		//DrawRectBitmap((Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 500) / 2, OUTPUT_YRES - 240, 500, 220, YELLOW_1555);
	}
	///

	file_ext_ptr = strrchr(str, '.');
	if(!strcasecmp(file_ext_ptr, ".bmp"))
	{
		memset(&ImageInfo, 0, sizeof(ImageInfo_t));
		bmp_h = (struct bmp_state *)GetBmpHdr(str);
		if (bmp_h != NULL)
		{
			ImageInfo.Width = bmp_h->hdr.width;
			ImageInfo.Height = bmp_h->hdr.height;
			FreeBmpHdr(bmp_h);
			isExifAvailable = TRUE;
			//imginfo = 1;
		}
	}
	else if(!strcasecmp(file_ext_ptr, ".tif") || !strcasecmp(file_ext_ptr, ".tiff"))//tiff
	{
		memset(&ImageInfo, 0, sizeof(ImageInfo_t));
		tiff_h = (struct tiff_hdr *)GetTiffHdr(str);
		if (tiff_h != NULL)
		{
			ImageInfo.Width = tiff_h->width;
			ImageInfo.Height = tiff_h->height;
			snprintf(ImageInfo.CameraMake, 32, "%s", tiff_h->CameraMake);
			snprintf(ImageInfo.DateTime, 20, "%s", tiff_h->DateTime);
			snprintf(ImageInfo.CameraModel, 40, "%s", tiff_h->CameraModel);
			FreeTiffHdr(tiff_h);
			isExifAvailable = TRUE;
			//imginfo = 1;
		}
	}
	else//jpg
	{
		isExifAvailable = ProcessJpegFile(jpgfile);
	}
	
	//PRINTF("isImgThumbnailAvailable: %d\n", isImgThumbnailAvailable(str));
	
	x = EXIFPos.x + border;
	y = EXIFPos.y + border;

	if(isExifAvailable)
	{
		sprintf(s, "%d x %d", ImageInfo.Width, ImageInfo.Height);

		///070814
		if(isInfoPressed)
		{
			#ifdef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "CameraMaker:", INFO_DATA_HEAD);
			#else
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "CameraMaker:", RED_1555);
			#endif
			y += FONT_HEIGHT;
			//modified by bk @ 070827
			FontTextOutAlign(g_pFontDB_Default, (Uint16 *)RGB0, OUTPUT_XRES, x, y, EXIFPos.width - (border<<1), ImageInfo.CameraMake, BLACK_1555);
			//FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, ImageInfo.CameraMake, BLACK_1555);
			y += FONT_HEIGHT;
			#ifdef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "DateTime:", INFO_DATA_HEAD);
			#else
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "DateTime:", RED_1555);
			#endif
			y += FONT_HEIGHT;
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, ImageInfo.DateTime, BLACK_1555);
			y += FONT_HEIGHT;
			#ifdef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "Resolution:", INFO_DATA_HEAD);
			#else
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "Resolution:", RED_1555);
			#endif
			y += FONT_HEIGHT;
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, s, BLACK_1555);
			y += FONT_HEIGHT;
			#ifdef DARK_BLUE_DESIGN
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "FileSize:", INFO_DATA_HEAD);
			#else
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "FileSize:", RED_1555);
			#endif
			y += FONT_HEIGHT;
		}
		/*
		FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 0, "CameraMaker:", RED_1555);
		FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 1, ImageInfo.CameraMake, BLACK_1555);
		FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 2, "DateTime:", RED_1555);
		FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 3, ImageInfo.DateTime, BLACK_1555);
		FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 4, "Resolution:", RED_1555);
		FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 5, s, BLACK_1555);
		FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 6, "FileSize:", RED_1555);
		*/
		///


		//get file size
		fseek(jpgfile, 0, SEEK_END);
		sprintf(s, "%ld bytes", ftell(jpgfile));

		///070814
		if(isInfoPressed)
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, s, BLACK_1555);
		//FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 7, s, BLACK_1555);
		///


	}
	else
	{
		///070814
		if(isInfoPressed)
			FontTextOut(g_pFontDB_Default, (Uint16 *)RGB0, x, y, "Not Available!", BLACK_1555);
		//FontTextOut(g_pFontDB_Default, (Uint16 *)elmf->osdbuff, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 235 + 26 * 0, "Not Available!", BLACK_1555);
		///
	}

	//modified by bk@070423 - refresh exif info when set focus
	///070814
	/*
	if(isInfoPressed)
		memcpy(RGB0, elmf->osdbuff, RGB_FRAMEBUFF_SIZE);
	*/
	///

	fclose(jpgfile);
}
//------------------------------------------------------------------------------------------------
#ifdef BATTERY_MOD
Uint32 DrawBattery()
{
	Uint32 idx;

	while(BatteryVal == -1)
	{
		BatteryVal = pgu_read_battery_val();
	}

	DPRINTF("Battery Val = %d\n", BatteryVal);

	if(BatteryVal < 660 && BatteryVal >= 0)
		idx = 0;
	else if(BatteryVal < 690 && BatteryVal >= 660)
		idx = 1;
	else if(BatteryVal < 710 && BatteryVal >= 690)
		idx = 2;
	else if(BatteryVal < 728 && BatteryVal >= 710)
		idx = 3;
	else if(BatteryVal < 755 && BatteryVal >= 728)
		idx = 4;
	else if(BatteryVal >= 755)
		idx = 5;

	if(active_index != SETUP_L3_ACTIVE)
		terawins_show_battery(idx);

	return idx;
}
#endif
//------------------------------------------------------------------------------------------------
void DrawID3Tag(char *str)
{
	FRAME *elmf;
	FileInfo finfo;
	///070814 HUelmf->osdbuffҴdest
	Uint16 *dest = (Uint16*)RGB0;	//elmf->osdbuff
	///

	///070817
	Uint16 x, y, border, maxw;
	COORD ID3Pos;
	Uint16 FONT_HEIGHT = 26, FONT_WIDTH = 13;
	if (g_pFontDB_Default)
	{
		FONT_HEIGHT = g_pFontDB_Default->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Default, "W");
	}
	border = (FONT_HEIGHT>>2);
	ID3Pos.width = (FONT_WIDTH*24) + (border<<1);			//20*FONT_WIDTH
	ID3Pos.height = (FONT_HEIGHT*14) + (border<<1);			//14*FONT_HEIGHT
	ID3Pos.x = (OUTPUT_XRES>>1) - (ID3Pos.width>>1);
	ID3Pos.y = OUTPUT_YRES - ID3Pos.height - FONT_HEIGHT;
	///

	elmf = &ELMachines[active_index].frame;

	///070814
	if (isInfoPressed)
	///
		#ifdef DARK_BLUE_DESIGN
		DrawRectBitmap(dest, ID3Pos.x, ID3Pos.y, ID3Pos.width, ID3Pos.height, INFO_BACKGROUND);
		#else
		DrawRectBitmap(dest, ID3Pos.x, ID3Pos.y, ID3Pos.width, ID3Pos.height, YELLOW_1555);
		#endif
		//DrawRectBitmap(dest, (OUTPUT_XRES - 500) / 2, OUTPUT_YRES - 390, 500, 370, YELLOW_1555);

	x = ID3Pos.x + border;
	y = ID3Pos.y + border;
	maxw = ID3Pos.width - border;

	// ID3 Tag Information
	if(MediaParser(str, &finfo) == PlayableMusic && finfo.bTag == 1)	//palayable and tag found
	{
		///070814
		if (isInfoPressed)		//Finfo~e
		///
		{
			char trk[5], gnr[5], tmp[LEN_XL];

			#ifdef DARK_BLUE_DESIGN
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Title:", INFO_DATA_HEAD);
			#else
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Title:", RED_1555);
			#endif
			y += FONT_HEIGHT;

			strcpy(tmp, finfo.ID3Tag.Title);
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);
			y += FONT_HEIGHT;

			#ifdef DARK_BLUE_DESIGN
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Artist:", INFO_DATA_HEAD);
			#else			
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Artist:", RED_1555);
			#endif
			y += FONT_HEIGHT;

			strcpy(tmp, finfo.ID3Tag.Artist);
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);
			y += FONT_HEIGHT;

			#ifdef DARK_BLUE_DESIGN
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Album:", INFO_DATA_HEAD);
			#else
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Album:", RED_1555);
			#endif
			y += FONT_HEIGHT;

			strcpy(tmp, finfo.ID3Tag.Album);
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);
			y += FONT_HEIGHT;

			#ifdef DARK_BLUE_DESIGN
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Year:", INFO_DATA_HEAD);
			#else
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Year:", RED_1555);
			#endif
			y += FONT_HEIGHT;

			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, finfo.ID3Tag.Year, BLACK_1555);
			y += FONT_HEIGHT;

			#ifdef DARK_BLUE_DESIGN
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Comment:", INFO_DATA_HEAD);
			#else
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Comment:", RED_1555);
			#endif
			y += FONT_HEIGHT;

			strcpy(tmp, finfo.ID3Tag.Comment);
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);
			y += FONT_HEIGHT;

			#ifdef DARK_BLUE_DESIGN
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Track:", INFO_DATA_HEAD);
			#else
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Track:", RED_1555);
			#endif
			y += FONT_HEIGHT;

			sprintf(trk, "%d", finfo.ID3Tag.Track);
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, trk, BLACK_1555);
			y += FONT_HEIGHT;

			#ifdef DARK_BLUE_DESIGN
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Genre:", INFO_DATA_HEAD);
			#else
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Genre:", RED_1555);
			#endif
			y += FONT_HEIGHT;

#if 1		// Raymond 2008/05/30
			if(finfo.ID3Tag.GenreString != NULL)
			{
				strcpy(tmp, finfo.ID3Tag.GenreString);
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);
			}
#else
			sprintf(gnr, "%d", finfo.ID3Tag.Genre);
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, gnr, BLACK_1555);
#endif
/*
			FontTextOut(g_pFontDB_Default, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 0, "Title:", RED_1555);
			GetSuitableLengthString(tmp, finfo.ID3Tag.Title, ' ', 30, FALSE);
			FontTextOut(g_pFontDB_Local, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 1, tmp, BLACK_1555);
			FontTextOut(g_pFontDB_Default, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 2, "Artist:", RED_1555);
			GetSuitableLengthString(tmp, finfo.ID3Tag.Artist, ' ', 30, FALSE);
			FontTextOut(g_pFontDB_Local, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 3, tmp, BLACK_1555);
			FontTextOut(g_pFontDB_Default, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 4, "Album:", RED_1555);
			GetSuitableLengthString(tmp, finfo.ID3Tag.Album, ' ', 30, FALSE);
			FontTextOut(g_pFontDB_Local, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 5, tmp, BLACK_1555);
			FontTextOut(g_pFontDB_Default, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 6, "Year:", RED_1555);
			FontTextOut(g_pFontDB_Local, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 7, finfo.ID3Tag.Year, BLACK_1555);
			FontTextOut(g_pFontDB_Default, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 8, "Comment:", RED_1555);
			GetSuitableLengthString(tmp, finfo.ID3Tag.Comment, ' ', 30, FALSE);
			FontTextOut(g_pFontDB_Local, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 9, tmp, BLACK_1555);
			FontTextOut(g_pFontDB_Default, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 10, "Track:", RED_1555);
			sprintf(trk, "%d", finfo.ID3Tag.Track);
			FontTextOut(g_pFontDB_Local, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 11, trk, BLACK_1555);
			FontTextOut(g_pFontDB_Default, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 12, "Genre:", RED_1555);
			sprintf(gnr, "%d", finfo.ID3Tag.Genre);
			FontTextOut(g_pFontDB_Local, dest, (OUTPUT_XRES - 480) / 2, OUTPUT_YRES - 385 + FONT_HEIGHT * 13, gnr, BLACK_1555);
*/
		}
	}
	else
	{
		///070814
		if (isInfoPressed)		//Finfo~e
		///
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Not Available!", BLACK_1555);
	}

	///070814
	/*
	if(isInfoPressed)
		memcpy(RGB0, elmf->osdbuff, RGB_FRAMEBUFF_SIZE);
	*/
	///
}
//------------------------------------------------------------------------------------------------
void DrawVideoInfo(char *str)
{
	//FRAME *elmf;
	FileInfo finfo;
	FILE *file;
	//elmf = &ELMachines[active_index].frame;

	//using when collecting info
	char tmp[LEN_XL];
	struct stat fStat = {0};
	struct tm *pTime;

	///070814 HUelmf->osdbuffҴdest
	Uint16 *dest = (Uint16*)RGB0;	//elmf->osdbuff
	///

	///070817
	Uint16 x, y, border, maxw;
	COORD pos;
	Uint16 FONT_HEIGHT = 26, FONT_WIDTH = 13;
	if (g_pFontDB_Default)
	{
		FONT_HEIGHT = g_pFontDB_Default->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Default, "W");
	}
	border = (FONT_HEIGHT>>2);
	pos.width = (FONT_WIDTH*24) + (border<<1);			//20*FONT_WIDTH
	pos.height = (FONT_HEIGHT*14) + (border<<1);		//14*FONT_HEIGHT
	pos.x = (OUTPUT_XRES>>1) - (pos.width>>1);
	pos.y = OUTPUT_YRES - pos.height - FONT_HEIGHT;
	///
	x = pos.x + border;
	y = pos.y + border;
	maxw = pos.width - border;

	memset(dest, 0, RGB_FRAMEBUFF_SIZE);
	///070814
	if (isInfoPressed)
	///
	#ifdef DARK_BLUE_DESIGN
		DrawRectBitmap(dest, pos.x, pos.y, pos.width, pos.height, INFO_BACKGROUND);
	#else
		DrawRectBitmap(dest, pos.x, pos.y, pos.width, pos.height, YELLOW_1555);
	#endif

	// Video Information
	MediaParser(str, &finfo);
	//if(MediaParser(str, &finfo) == PlayableVideo/* && finfo.bTag == 1*/)	//palayable and tag found
	{
		///070814
		if (isInfoPressed)		//Finfo~e
		///
		{
			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Format:", RED_1555);
			y += FONT_HEIGHT;

			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, finfo.VideoFormat, BLACK_1555);
			y += FONT_HEIGHT;

			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Size:", RED_1555);
			y += FONT_HEIGHT;

			if(!(file = fopen(str, "r")))//can not open file to get file size
			{
				DPRINTF("Unable to open video file %s\n", str);
			}
			else
			{
				fseek(file, 0, SEEK_END);
				sprintf(tmp, "%ld bytes", ftell(file));
				fclose(file);

				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);
			}
			y += FONT_HEIGHT;

			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Date:", RED_1555);
			y += FONT_HEIGHT;

			if (lstat(str, &fStat) == 0)
			{
				pTime = gmtime(&(fStat.st_mtime));
				sprintf(tmp, "%d/%02d/%02d", 1900 + pTime->tm_year, 1 + pTime->tm_mon, pTime->tm_mday);
			}
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);
			y += FONT_HEIGHT;

			FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Time:", RED_1555);
			y += FONT_HEIGHT;

			sprintf(tmp, " %02d:%02d:%02d", finfo.FileDuration / 3600 , (finfo.FileDuration % 3600) / 60, finfo.FileDuration % 60);
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, x, y, maxw, tmp, BLACK_1555);

		}
	}
	//else
	//{
	//	///070814
	//	if (isInfoPressed)		//Finfo~e
	//	///
	//		FontTextOutAlign(g_pFontDB_Default, dest, OUTPUT_XRES, x, y, maxw, "Not Available!", BLACK_1555);
	//}

	///070814
	/*
	if(isInfoPressed)
		memcpy(RGB0, elmf->osdbuff, RGB_FRAMEBUFF_SIZE);
	*/
	///
}
//------------------------------------------------------------------------------------------------
void DrawL1Menu(int Mode)
{
	FRAME *elmf;
	Uint16 i, x, y, h, w, textx, texty;

	elmf = &ELMachines[active_index].frame;

	///071011 ITEM_DATA
	ITEM_DATA *pItem = &(elmf->item_data);
	///

	Uint16 *dest = (Uint16*)RGB0;
	Uint16 FONT_HEIGHT = 26;
	if (g_pFontDB_Local) FONT_HEIGHT = g_pFontDB_Local->FontSize;

	// xenia
	Uint16 BorderTop = desc->MiscTextCoord[38].x;
	Uint16 BorderLR = desc->MiscTextCoord[38].y;

	//OSDsd
	osd_info.current_mode = prev_active_index;
	osd_info.rgb_src = RGB_0;
	osd_info.yuv_osd = RGB_1;
	osd_info.blend_all = FB_YES;
	if (prev_active_index == FI_ACTIVE)
		osd_info.yuv_bkg = (1 - yuv_idx);
	else
		osd_info.yuv_bkg = YUV_1;
	osd_info.start_line = 0;
	osd_info.total_line = OUTPUT_YRES;

	if (Mode == 0)
	{
		CopyBlockBitmap(dest, OUTPUT_XRES, elmf->framecoord.x, elmf->framecoord.y,
						(Uint16*)elmf->rgbtemplate, elmf->framecoord.width, 0, 0, elmf->framecoord.width, elmf->framecoord.height);

		//L1 menu title
		// xenia
		FontTextOutFormat(g_pFontDB_Local, dest,
						elmf->framecoord.x + desc->MiscTextCoord[38].width, elmf->framecoord.y + desc->MiscTextCoord[38].height,
						FrameText[setup->Language][5]/*"Setup Menu"*/, OSD_TITLE_COLOR, DT_CENTER);
	}

	//Highlight Selected Item
	w = elmf->framecoord.width - 2 * BorderLR;
	h = FONT_HEIGHT + 2 * BORDER_WIDTH;
	x = elmf->framecoord.x + BorderLR;
	y = elmf->framecoord.y + BorderTop + h * pItem->curr_item;

    if (Mode >= 0)	//e
	{
		#ifndef DARK_BLUE_DESIGN
		DrawRectBitmap(dest, x, y, w, h, OSD_HIGHLIGHT_COLOR);
		#else
		DrawRectBitmap(dest, x, y, w, h, SETUP_HIGHLIGHT_BAR);
		#endif
	}
	else				//Mode == -1 ٭
	{
		CopyBlockBitmap(dest, OUTPUT_XRES, x, y,
						  (Uint16*)elmf->rgbtemplate, elmf->framecoord.width,
						  x - elmf->framecoord.x, y - elmf->framecoord.y, w, h);
	}

	if (Mode != 0)
	{
		#ifdef LEADTEK
		SetRGBuffMSB(0, (Uint8*)dest, 1, x, y, w, h, LTK_ORANGE);
		#else
		SetRGBuffMSB(0, (Uint8*)dest, 1, x, y, w, h, WHITE_555);
		#endif
		osd_info.start_line = elmf->framecoord.y;//y;
		osd_info.total_line = elmf->framecoord.height;//h;
		osd_info.blend_all = FB_NO;
	}
	else		//Mode == 0
	{
		#ifdef LEADTEK
		SetRGBuffMSB(0, (Uint8*)dest, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, LTK_ORANGE);
		#else
		SetRGBuffMSB(0, (Uint8*)dest, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
		#endif
	}

	//Main Menu Item Text
	textx = x + BORDER_WIDTH;
	texty = elmf->framecoord.y + BorderTop+ BORDER_WIDTH;
	for(i = 0, texty; i < pItem->total_item; i++, texty += h)
	{
		if (Mode != 0 && i != pItem->curr_item) continue;

		#ifdef LEADTEK
		FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w,
						setup->main_menu_item[pItem->index[i]], LTK_ORANGE);
		#else
		FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w,
						setup->main_menu_item[pItem->index[i]], OSD_FOREGROUND_COLOR);
		#endif
	}

	if (Mode >= 0)	//٭ɤΧsAeήɶKs
	{
		pgu_update_osd(osd_info);
	}
	//osd_parser();
}
//------------------------------------------------------------------------------------------------
void DrawL2Menu(int Mode)
{
	FRAME *elmf;
	Uint16 i, x, y, h, w, textx, texty;
	Uint16 item_num, index;
	char **item_array;

	elmf = &ELMachines[active_index].frame;
	ITEM_DATA *pItem = &(elmf->item_data);

	Uint16 *dest = (Uint16*)RGB0;
	Uint16 FONT_HEIGHT = 26;
	if (g_pFontDB_Local) FONT_HEIGHT = g_pFontDB_Local->FontSize;

	//xenia
	Uint16 BorderTop = desc->MiscTextCoord[38].x;
	Uint16 BorderLR = desc->MiscTextCoord[38].y;

	//OSDsd
	osd_info.current_mode = prev_active_index;
	osd_info.rgb_src = RGB_0;
	osd_info.yuv_osd = RGB_1;
	osd_info.blend_all = FB_YES;
	if (prev_active_index == FI_ACTIVE)
		osd_info.yuv_bkg = (1 - yuv_idx);
	else
		osd_info.yuv_bkg = YUV_1;
	osd_info.start_line = 0;
	osd_info.total_line = OUTPUT_YRES;

	if (Mode == 0)
	{
		CopyBlockBitmap(dest, OUTPUT_XRES, elmf->framecoord.x, elmf->framecoord.y,
						(Uint16*)elmf->rgbtemplate, elmf->framecoord.width, 0, 0, elmf->framecoord.width, elmf->framecoord.height);

		//L2 menu title
		//xenia
		#ifdef LEADTEK
		FontTextOutFormat(g_pFontDB_Local, dest,
						elmf->framecoord.x + desc->MiscTextCoord[38].width, elmf->framecoord.y + desc->MiscTextCoord[38].height,
				   		setup->main_menu_item[setup->main_menu_idx], LTK_ORANGE, DT_CENTER);
		#else
		FontTextOutFormat(g_pFontDB_Local, dest,
						elmf->framecoord.x + desc->MiscTextCoord[38].width, elmf->framecoord.y + desc->MiscTextCoord[38].height,
				   		setup->main_menu_item[setup->main_menu_idx], OSD_TITLE_COLOR, DT_CENTER);
		#endif
	}

	//Highlight Selected Item
	w = elmf->framecoord.width - 2 * BorderLR;
	h = FONT_HEIGHT + 2 * BORDER_WIDTH;
	x = elmf->framecoord.x + BorderLR;
	y = elmf->framecoord.y + BorderTop + h * pItem->curr_item;

	if (Mode >= 0)
	{
		#ifdef LEADTEK
		DrawRectBitmap(dest, x, y, w, h, LTK_YELLOW);
		#else
		  #ifndef DARK_BLUE_DESIGN
		DrawRectBitmap(dest, x, y, w, h, OSD_HIGHLIGHT_COLOR);
		  #else
		DrawRectBitmap(dest, x, y, w, h, SETUP_HIGHLIGHT_BAR);
		  #endif
		#endif
	}
	else				//Mode == -1 ٭
	{
		CopyBlockBitmap(dest, OUTPUT_XRES, x, y,
						  (Uint16*)elmf->rgbtemplate, elmf->framecoord.width,
						  x - elmf->framecoord.x, y - elmf->framecoord.y, w, h);
	}

	if (Mode != 0)
	{
		SetRGBuffMSB(0, (Uint8*)dest, 1, x, y, w, h, WHITE_555);
		osd_info.start_line = elmf->framecoord.y;//y;
		osd_info.total_line = elmf->framecoord.height;//h;
		osd_info.blend_all = FB_NO;
	}
	else		//Mode == 0
	{
		#ifdef LEADTEK
		SetRGBuffMSB(0, (Uint8*)dest, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, LTK_ORANGE);
		#else
		SetRGBuffMSB(0, (Uint8*)dest, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
		#endif
	}

	//Main Menu Item Text
	textx = x + BORDER_WIDTH;
	texty = elmf->framecoord.y + BorderTop + BORDER_WIDTH;

	for(i = 0, texty; i < pItem->total_item; i++, texty += h)
	{
		if (Mode != 0 && i != pItem->curr_item) continue;
		#ifdef LEADTEK
		FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w,
						pItem->item_array[pItem->index[i]], (pItem->status[i]==0 ? LTK_ORANGE : LTK_GREY));
		#else
		FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w,
						pItem->item_array[pItem->index[i]], (pItem->status[i]==0 ? OSD_FOREGROUND_COLOR : RED_1555));
		#endif
	}

	if (Mode >= 0)	//٭ɤΧsAeήɶKs
	{
		pgu_update_osd(osd_info);
	}
	//osd_parser();
}
//------------------------------------------------------------------------------------------------
void DrawL3Menu(int Mode)
{
	FRAME *elmf;
	Uint16 i, x, y, h, w, textx, texty;
	//Uint16 item_num index;
	static Uint16 prev_index = 0;
	//char *title;
	//char **item_array;
	Uint8 ITEMPERPAGE = 10;
	static Uint8 flag = 1;
	char temp[LEN_S];
	char year[LEN_S];
	char month[LEN_S];
	char day[LEN_S];
	char hour[LEN_S];
	char minute[LEN_S];
	char second[LEN_S];
	char out[LEN_L];

	Uint16 *dest = (Uint16*)RGB0;
	Uint16 FONT_HEIGHT = 26, FONT_WIDTH = 13;
	if (g_pFontDB_Local)
	{
		FONT_HEIGHT = g_pFontDB_Local->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Local, "0");
	}

	//xenia
	Uint16 BorderTop = desc->MiscTextCoord[38].x;
	Uint16 BorderLR = desc->MiscTextCoord[38].y;

	//OSDsd
	osd_info.current_mode = prev_active_index;
	osd_info.rgb_src = RGB_0;
	osd_info.yuv_osd = RGB_1;
	osd_info.blend_all = FB_YES;
	if (prev_active_index == FI_ACTIVE)
		osd_info.yuv_bkg = (1 - yuv_idx);
	else
		osd_info.yuv_bkg = YUV_1;
	osd_info.start_line = 0;
	osd_info.total_line = OUTPUT_YRES;

	elmf = &ELMachines[active_index].frame;
	///071129
	ITEM_DATA *pItem = &(elmf->item_data);
	///

	CopyBlockBitmap(dest, OUTPUT_XRES, elmf->framecoord.x, elmf->framecoord.y,
					(Uint16*)elmf->rgbtemplate, elmf->framecoord.width, 0, 0, elmf->framecoord.width, elmf->framecoord.height);

	//L3 menu title
	#ifdef LEADTEK
	FontTextOutFormat(g_pFontDB_Local, dest,
				   elmf->framecoord.x + desc->MiscTextCoord[38].width, elmf->framecoord.y + desc->MiscTextCoord[38].height,
				   pItem->title, LTK_ORANGE, DT_CENTER);
	#else
	FontTextOutFormat(g_pFontDB_Local, dest,
				   elmf->framecoord.x + desc->MiscTextCoord[38].width, elmf->framecoord.y + desc->MiscTextCoord[38].height,
				   pItem->title, OSD_TITLE_COLOR, DT_CENTER);
	#endif

	w = elmf->framecoord.width - 2 * BorderLR;
	h = FONT_HEIGHT + 2 * BORDER_WIDTH;
	x = elmf->framecoord.x + BorderLR;
	y = elmf->framecoord.y /*+ BORDER_WIDTH*/ + BorderTop;
	textx = x + BORDER_WIDTH;
	texty = y + BORDER_WIDTH;

	//Item text
	if(setup->main_menu_idx == L1_System_Setup && setup->sys_idx == L2_System_Status)
	{
		for(i = 0; i < SYS_STS_ITEM_NUM; i++, texty += h)
		{
			if(i == 0)
			{
				sprintf(out, "%s", setup->sys_sts_item[i]);
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w, out, OSD_FOREGROUND_COLOR);
			}
			if(i == 1)//firmware version
			{
//#ifdef LEADTEK
//				sprintf(out, "%s%s", setup->sys_sts_item[i], CURRENT_VERSION);
//#else
//				sprintf(out, "%s%s", setup->sys_sts_item[i], FIRMWARE_VERSION);
//#endif
				#ifdef LEADTEK
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w, setup->sys_sts_item[i], OSD_FOREGROUND_COLOR);
				texty += h;
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w, FIRMWARE_VERSION, LTK_ORANGE);
				#else
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w, setup->sys_sts_item[i], OSD_FOREGROUND_COLOR);
				texty += h;
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w, FIRMWARE_VERSION, OSD_FOREGROUND_COLOR);
				#endif
			}
			else if(i == 2)//flash free size
			{
				sprintf(out, "%s%dM", setup->sys_sts_item[i], GetFlashFreeSize() >> 20);
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w, out, OSD_FOREGROUND_COLOR);
			}
#ifdef BATTERY_MOD
			else if(i == 3)//Battery
			{
				sprintf(out, "%s%d%s", setup->sys_sts_item[i], DrawBattery() * 20, "%");
				FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w, out, OSD_FOREGROUND_COLOR);
			}
#endif
		}
	}
    ///071129
    else if (  pItem->pvalue == &setup->sys_alpha
             ||
               pItem->pvalue == &setup->cal_alpha
            )
    //else if((setup->main_menu_idx == L1_System_Setup && setup->sys_idx == L2_System_AlphaValue) ||
    //	     (setup->main_menu_idx == L1_CalendarTimeAlarm_Setup && setup->caltimealarm_idx == L2_CalTimeAlarm_AlphaValue))
    ///
    {
        sprintf(out, "%d", *((Sint8*)pItem->pvalue));
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest, textx, texty, out, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Local, dest, textx, texty, out, OSD_FOREGROUND_COLOR);
		#endif
    }
    ///071129
    else if (pItem->pvalue == &SelectedBrightContrast)
    //else if(setup->main_menu_idx == L1_System_Setup && setup->sys_idx == L2_System_BrightnessContrast)
    ///
    {
    	#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest, textx, texty, pItem->title, LTK_ORANGE);
        FontTextOut(g_pFontDB_Local, dest, textx + 4 * FONT_WIDTH, texty + h, "/", LTK_ORANGE);
    	#else
        FontTextOut(g_pFontDB_Local, dest, textx, texty, pItem->title, OSD_FOREGROUND_COLOR);
        FontTextOut(g_pFontDB_Local, dest, textx + 4 * FONT_WIDTH, texty + h, "/", OSD_FOREGROUND_COLOR);
		#endif

        //Highlight Selected Item
        w = 3 * FONT_WIDTH + 2 * BORDER_WIDTH;
        if(SelectedBrightContrast == Brightness)
        {
        	#ifdef LEADTEK
            DrawRectBitmap(dest, x, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN	
            DrawRectBitmap(dest, x, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
            DrawRectBitmap(dest, x, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
        }
        else if(SelectedBrightContrast == Contrast)
        {
        	#ifdef LEADTEK
            DrawRectBitmap(dest, x + 5 * FONT_WIDTH, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
            DrawRectBitmap(dest, x + 5 * FONT_WIDTH, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
            DrawRectBitmap(dest, x + 5 * FONT_WIDTH, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
        }

        ///071130
        #ifdef LEADTEK
        //Brightness Item text
        FontTextOut(g_pFontDB_Local, dest, textx, texty + h,
                       setup->brightness_item[setup->brightness_idx], LTK_ORANGE);
        //Contrast Item text
        FontTextOut(g_pFontDB_Local, dest, textx + 5 * FONT_WIDTH, texty + h,
                       setup->contrast_item[setup->contrast_idx], LTK_ORANGE);
		#else
        //Brightness Item text
        FontTextOut(g_pFontDB_Local, dest, textx, texty + h,
                       setup->brightness_item[setup->brightness_idx], OSD_FOREGROUND_COLOR);

        //Contrast Item text
        FontTextOut(g_pFontDB_Local, dest, textx + 5 * FONT_WIDTH, texty + h,
                       setup->contrast_item[setup->contrast_idx], OSD_FOREGROUND_COLOR);
		#endif
        ///
    }
    ///071129
    else if (pItem->pvalue == &SelectedCalTime)
    //else if(setup->main_menu_idx == L1_CalendarTimeAlarm_Setup && setup->caltimealarm_idx == L2_CalTimeAlarm_CalendarTime)
    ///
	{
		char string[LEN_S];
		Uint16 CnstFontWidth = FONT_WIDTH;
		if (g_pFontDB_Default)
		{
			CnstFontWidth = GetFontStringWidth(g_pFontDB_Default, "0");
		}

		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Local, dest, textx, texty, FrameText[setup->Language][24], LTK_ORANGE);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * CnstFontWidth, texty + h, "/", LTK_ORANGE);
		FontTextOut(g_pFontDB_Local, dest, textx + 5 * CnstFontWidth, texty + h, "/", LTK_ORANGE);

		FontTextOut(g_pFontDB_Local, dest, textx, texty + 2 * h, FrameText[setup->Language][25], LTK_ORANGE);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * CnstFontWidth, texty + 3 * h, "/", LTK_ORANGE);
		FontTextOut(g_pFontDB_Local, dest, textx + 5 * CnstFontWidth, texty + 3 * h, "/", LTK_ORANGE);
		#else
		FontTextOut(g_pFontDB_Local, dest, textx, texty, FrameText[setup->Language][24], OSD_FOREGROUND_COLOR);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * CnstFontWidth, texty + h, "/", OSD_FOREGROUND_COLOR);
		FontTextOut(g_pFontDB_Local, dest, textx + 5 * CnstFontWidth, texty + h, "/", OSD_FOREGROUND_COLOR);

		FontTextOut(g_pFontDB_Local, dest, textx, texty + 2 * h, FrameText[setup->Language][25], OSD_FOREGROUND_COLOR);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * CnstFontWidth, texty + 3 * h, "/", OSD_FOREGROUND_COLOR);
		FontTextOut(g_pFontDB_Local, dest, textx + 5 * CnstFontWidth, texty + 3 * h, "/", OSD_FOREGROUND_COLOR);
		#endif

        //Highlight Selected Item
        if(SelectedCalTime == dd)
		{
			w = 2 * CnstFontWidth;
			#ifdef LEADTEK
			DrawRectBitmap(dest, x, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedCalTime == mm)
		{
			w = 2 * CnstFontWidth;
			#ifdef LEADTEK
			DrawRectBitmap(dest, x + 3 * CnstFontWidth, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x + 3 * CnstFontWidth, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x + 3 * CnstFontWidth, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedCalTime == yyyy)
		{
			w = 4 * CnstFontWidth;
			#ifdef LEADTEK
			DrawRectBitmap(dest, x + 6 * CnstFontWidth, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x + 6 * CnstFontWidth, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x + 6 * CnstFontWidth, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedCalTime == sec)
		{
			w = 2 * CnstFontWidth;
			#ifdef LEADTEK
			DrawRectBitmap(dest, x, y + 3 * h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x, y + 3 * h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x, y + 3 * h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedCalTime == min)
		{
			w = 2 * CnstFontWidth;
			#ifdef LEADTEK
			DrawRectBitmap(dest, x + 3 * CnstFontWidth, y + 3 * h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x + 3 * CnstFontWidth, y + 3 * h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x + 3 * CnstFontWidth, y + 3 * h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedCalTime == hr)
		{
			w = 2 * CnstFontWidth;
			#ifdef LEADTEK
			DrawRectBitmap(dest, x + 6 * CnstFontWidth, y + 3 * h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x + 6 * CnstFontWidth, y + 3 * h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x + 6 * CnstFontWidth, y + 3 * h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}

        ///071130
        Sint16 t;
        //day
        t = setup->day;
        sprintf(string, "%d", t);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx : textx + CnstFontWidth), texty + h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx : textx + CnstFontWidth), texty + h, string, OSD_FOREGROUND_COLOR);
		#endif
        //month
        t = setup->month;
        sprintf(string, "%d", t);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx + 3 * CnstFontWidth : textx + 4 * CnstFontWidth), texty + h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx + 3 * CnstFontWidth : textx + 4 * CnstFontWidth), texty + h, string, OSD_FOREGROUND_COLOR);
		#endif
        //year
        t = setup->year;
        sprintf(string, "%d", t);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Default, dest, textx + 6 * CnstFontWidth, texty + h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Default, dest, textx + 6 * CnstFontWidth, texty + h, string, OSD_FOREGROUND_COLOR);
		#endif
        //second
        t = setup->second;
        sprintf(string, "%d", t);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx : textx + CnstFontWidth), texty + 3 * h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx : textx + CnstFontWidth), texty + 3 * h, string, OSD_FOREGROUND_COLOR);
		#endif
        //minute
        t = setup->minute;
        sprintf(string, "%d", t);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx + 3 * CnstFontWidth : textx + 4 * CnstFontWidth), texty + 3 * h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx + 3 * CnstFontWidth : textx + 4 * CnstFontWidth), texty + 3 * h, string, OSD_FOREGROUND_COLOR);
		#endif
        //hour
        t = setup->hour;
        sprintf(string, "%d", t);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx + 6 * CnstFontWidth : textx + 7 * CnstFontWidth), texty + 3 * h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Default, dest,
                       (t > 9 ? textx + 6 * CnstFontWidth : textx + 7 * CnstFontWidth), texty + 3 * h, string, OSD_FOREGROUND_COLOR);
		#endif
        ///
	}
    ///071129
    else if (pItem->pvalue == &SelectedAlarmTime)
	//else if(setup->main_menu_idx == L1_CalendarTimeAlarm_Setup && setup->caltimealarm_idx == L2_CalTimeAlarm_Alarm)
    ///
	{
		char string[LEN_S];

		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Local, dest, textx, texty, FrameText[setup->Language][26], LTK_ORANGE);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * FONT_WIDTH, texty + h, "/", LTK_ORANGE);
		#else
		FontTextOut(g_pFontDB_Local, dest, textx, texty, FrameText[setup->Language][26], OSD_FOREGROUND_COLOR);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * FONT_WIDTH, texty + h, "/", OSD_FOREGROUND_COLOR);
		#endif

        //Highlight Selected Item
		w = 2 * FONT_WIDTH;
        if(SelectedAlarmTime == min)
		{
			#ifdef LEADTEK
			DrawRectBitmap(dest, x, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedAlarmTime == hr)
		{
			#ifdef LEADTEK
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}

        ///071130
        sprintf(string, "%d", setup->alarm_minute);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->alarm_minute > 9 ? textx : textx + FONT_WIDTH), texty + h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->alarm_minute > 9 ? textx : textx + FONT_WIDTH), texty + h, string, OSD_FOREGROUND_COLOR);
		#endif
        sprintf(string, "%d", setup->alarm_hour);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->alarm_hour > 9 ? textx + 3 * FONT_WIDTH : textx + 4 * FONT_WIDTH), texty + h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->alarm_hour > 9 ? textx + 3 * FONT_WIDTH : textx + 4 * FONT_WIDTH), texty + h, string, OSD_FOREGROUND_COLOR);
		#endif
        ///
	}
    ///071129
    else if (pItem->pvalue == &SelectedAutoPwrOnOffTime)
	//else if(setup->main_menu_idx == L1_AutoPower_Setup && setup->autopwr_idx == L2_AutoPower_OnOffTime)
    ///
	{
		char string[LEN_S];
		#ifdef LEADTEK
		FontTextOut(g_pFontDB_Local, dest, textx, texty, FrameText[setup->Language][27], LTK_ORANGE);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * FONT_WIDTH, texty + h, "/", LTK_ORANGE);

		FontTextOut(g_pFontDB_Local, dest, textx, texty + 2 * h, FrameText[setup->Language][28], LTK_ORANGE);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * FONT_WIDTH, texty + 3 * h, "/", LTK_ORANGE);
		#else
		FontTextOut(g_pFontDB_Local, dest, textx, texty, FrameText[setup->Language][27], OSD_FOREGROUND_COLOR);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * FONT_WIDTH, texty + h, "/", OSD_FOREGROUND_COLOR);

		FontTextOut(g_pFontDB_Local, dest, textx, texty + 2 * h, FrameText[setup->Language][28], OSD_FOREGROUND_COLOR);
		FontTextOut(g_pFontDB_Local, dest, textx + 2 * FONT_WIDTH, texty + 3 * h, "/", OSD_FOREGROUND_COLOR);
		#endif
        //Highlight Selected Item
		w = 2 * FONT_WIDTH;
        if(SelectedAutoPwrOnOffTime == OnMin)
		{
			#ifdef LEADTEK
			DrawRectBitmap(dest, x, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedAutoPwrOnOffTime == OnHr)
		{
			#ifdef LEADTEK
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedAutoPwrOnOffTime == OffMin)
		{
			#ifdef LEADTEK
			DrawRectBitmap(dest, x, y + 3 * h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x, y + 3 * h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x, y + 3 * h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}
		else if(SelectedAutoPwrOnOffTime == OffHr)
		{
			#ifdef LEADTEK
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + 3 * h, w, h, LTK_YELLOW);
			#else
			  #ifndef DARK_BLUE_DESIGN
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + 3 * h, w, h, OSD_HIGHLIGHT_COLOR);
			  #else
			DrawRectBitmap(dest, x + 3 * FONT_WIDTH, y + 3 * h, w, h, SETUP_HIGHLIGHT_BAR);
			  #endif
			#endif
		}

        ///071130
        //OnMin
        sprintf(string, "%d", setup->autopwr_on_minute);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_on_minute > 9 ? textx : textx + FONT_WIDTH), texty + h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_on_minute > 9 ? textx : textx + FONT_WIDTH), texty + h, string, OSD_FOREGROUND_COLOR);
		#endif
        //OnHr
        sprintf(string, "%d", setup->autopwr_on_hour);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_on_hour > 9 ? textx + 3 * FONT_WIDTH : textx + 4 * FONT_WIDTH), texty + h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_on_hour > 9 ? textx + 3 * FONT_WIDTH : textx + 4 * FONT_WIDTH), texty + h, string, OSD_FOREGROUND_COLOR);
		#endif
        //OffMin
        sprintf(string, "%d", setup->autopwr_off_minute);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_off_minute > 9 ? textx : textx + FONT_WIDTH), texty + 3 * h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_off_minute > 9 ? textx : textx + FONT_WIDTH), texty + 3 * h, string, OSD_FOREGROUND_COLOR);
		#endif
        //OffHr
        sprintf(string, "%d", setup->autopwr_off_hour);
		#ifdef LEADTEK
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_off_hour > 9 ? textx + 3 * FONT_WIDTH : textx + 4 * FONT_WIDTH), texty + 3 * h, string, LTK_ORANGE);
		#else
        FontTextOut(g_pFontDB_Local, dest,
                       (setup->autopwr_off_hour > 9 ? textx + 3 * FONT_WIDTH : textx + 4 * FONT_WIDTH), texty + 3 * h, string, OSD_FOREGROUND_COLOR);
		#endif
        ///
	}
	///080514
	else if (pItem->pvalue == &(setup->lang_idx))
	{
		FONT_DB *FontDB[NUM_OF_FONT_FILE] = {0};
		int UseFontNum = 0;
		char strCode[LEN_L] = {0};
		Uint8 bUseUCS2 = 0;

		if (access(desc->FontFileName[NUM_OF_FONT_FILE-1], R_OK) == 0)
		{
			bUseUCS2 = 1;
			UseFontNum = NUM_OF_FONT_FILE-1;
		}

        Uint16 tempy = y + h * (pItem->curr_item-pItem->head_item);
		#ifdef LEADTEK
        DrawRectBitmap(dest, x, tempy, w, h, LTK_YELLOW);
		#else
		  #ifndef DARK_BLUE_DESIGN
        DrawRectBitmap(dest, x, tempy, w, h, OSD_HIGHLIGHT_COLOR);
		  #else
        DrawRectBitmap(dest, x, tempy, w, h, SETUP_HIGHLIGHT_BAR);
		  #endif
		#endif
        for(i = pItem->head_item; i < pItem->total_item; i++, texty += h)
        {
            if (i - pItem->head_item >= pItem->items_per_page) break;

			switch (pItem->index[i])
			{
			case SETUP_LANG_English:
			case SETUP_LANG_Italiano:
			case SETUP_LANG_Deutsch:
			case SETUP_LANG_Francais:
			case SETUP_LANG_Espanol:
			case SETUP_LANG_Portuguese:
			case SETUP_LANG_Dutch:
				strcpy(strCode, CODE_PAGE_NAME_ISO8859_1);
				if (!bUseUCS2) UseFontNum = 1;
                break;
			case SETUP_LANG_CHT:
				strcpy(strCode, CODE_PAGE_NAME_BIG_5);
				if (!bUseUCS2) UseFontNum = 2;
				break;
			case SETUP_LANG_CHS:
				strcpy(strCode, CODE_PAGE_NAME_GB2312);
				if (!bUseUCS2) UseFontNum = 3;
				break;
			case SETUP_LANG_JP:
				strcpy(strCode, CODE_PAGE_NAME_SJIS);
				if (!bUseUCS2) UseFontNum = 4;
				break;
			case SETUP_LANG_KR:
				strcpy(strCode, CODE_PAGE_NAME_KSC);
				if (!bUseUCS2) UseFontNum = 5;
				break;
			///080601 Russian
			case SETUP_LANG_RUS:
				strcpy(strCode, CODE_PAGE_NAME_CYRILLIC);
				break;
			///
			}

			if (!FontDB[UseFontNum])
			{
				FontDB[UseFontNum] = Create_FontDB(desc->FontFileName[UseFontNum]);
#ifdef FONTDB_PRIVATE_CODEPAGE
				FontDB_Set_Private_CodePage(FontDB[UseFontNum], (char*)strCode);
#endif
			}
			else if (bUseUCS2)
			{
#ifdef FONTDB_PRIVATE_CODEPAGE
				FontDB_Set_Private_CodePage(FontDB[UseFontNum], (char*)strCode);
#endif
			}

            //if (Mode != 0 && i != pItem->curr_item) continue;
         	#ifdef LEADTEK
            FontTextOutAlign(FontDB[UseFontNum], dest, OUTPUT_XRES, textx, texty, w,
                            pItem->item_array[pItem->index[i]], (pItem->status[i]==0 ? LTK_ORANGE : LTK_RED));
	     	#else
            FontTextOutAlign(FontDB[UseFontNum], dest, OUTPUT_XRES, textx, texty, w,
                            pItem->item_array[pItem->index[i]], (pItem->status[i]==0 ? OSD_FOREGROUND_COLOR : RED_1555));
	     	#endif
        }

		for (i=0; i<NUM_OF_FONT_FILE; i++)
		{
			Release_FontDB(&FontDB[i]);
		}

		//ebY
		if (pItem->head_item > 0)
		{
			//ebĤ@k
			DrawArrowHead(dest, OUTPUT_XRES,
						  textx+w-h, y,
						  h, (h>>1), 0, BLUE_1555);
		}
		if (pItem->head_item+pItem->items_per_page < pItem->total_item)
		{
			//eb̫@k
			DrawArrowHead(dest, OUTPUT_XRES,
						  textx+w-h,
						  y + h*pItem->items_per_page - (h>>1),
						  h, (h>>1), 1, BLUE_1555);
		}
	}
	///
	else
	{
		///071129
		Uint16 tempy = y/*elmf->framecoord.y + BorderTop*/ + h * (pItem->curr_item-pItem->head_item);
		#ifdef LEADTEK
		DrawRectBitmap(dest, x, tempy, w, h, LTK_YELLOW);
		#else
		  #ifndef DARK_BLUE_DESIGN
		DrawRectBitmap(dest, x, tempy, w, h, OSD_HIGHLIGHT_COLOR);
		  #else
		DrawRectBitmap(dest, x, tempy, w, h, SETUP_HIGHLIGHT_BAR);
		  #endif
		#endif
		for(i = pItem->head_item; i < pItem->total_item; i++, texty += h)
		{
			if (i - pItem->head_item >= pItem->items_per_page) break;
			//if (Mode != 0 && i != pItem->curr_item) continue;
			#ifdef LEADTEK
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w,
					pItem->item_array[pItem->index[i]], (pItem->status[i]==0 ? LTK_ORANGE : LTK_RED));
			#else
			FontTextOutAlign(g_pFontDB_Local, dest, OUTPUT_XRES, textx, texty, w,
					pItem->item_array[pItem->index[i]], (pItem->status[i]==0 ? OSD_FOREGROUND_COLOR : RED_1555));
			#endif
		}
		///
		///080417 ebY
		if (pItem->head_item > 0)
		{
			//ebĤ@k
			DrawArrowHead(dest, OUTPUT_XRES,
						  textx+w-h, y,
						  h, (h>>1), 0, BLUE_1555);
		}
		if (pItem->head_item+pItem->items_per_page < pItem->total_item)
		{
			//eb̫@k
			DrawArrowHead(dest, OUTPUT_XRES,
						  textx+w-h,
						  y + h*pItem->items_per_page - (h>>1),
						  h, (h>>1), 1, BLUE_1555);
		}
		///
	}

	if (Mode != 0)
	{
		osd_info.start_line = elmf->framecoord.y;//y;
		osd_info.total_line = elmf->framecoord.height;//h;
		osd_info.blend_all = FB_NO;
	}

	#ifdef LEADTEK
	SetRGBuffMSB(0, (Uint8*)dest, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, LTK_ORANGE);
	#else
	SetRGBuffMSB(0, (Uint8*)dest, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
	#endif
	pgu_update_osd(osd_info);
	//osd_parser();
}
//------------------------------------------------------------------------------------------------
void DrawReactionIcon(int KeyNum, int Mode)
{
	static int active = -1;
	static int dest = YUV_1;
	int newdest, bkgno;
	REACTION_ICON *pIcon;

	if (g_pReaction_Icon_Group == NULL) return;

	pIcon = g_pReaction_Icon_Group->KeyIconTable[KeyNum];
	if (pIcon == NULL) return;

	if (active == -1)	//Ĥ@
	{
		active = active_index;
		if (active == FI_ACTIVE) dest = 1 - yuv_idx;
		else if (active == SETUP_L1_ACTIVE) dest = RGB_1;
	}

	if (Mode == 1)	//eF|
	{
		if (  isSetupPressed	//Software OSDwҰʪA
		    ||
			(active_index == CAL_ACTIVE && prev_active_index == FI_ACTIVE)
		   )
		{
			newdest = RGB_1;

			//ƥثeA
			CopyBlockYUV420(pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
								(Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
								pIcon->icoord.width, pIcon->icoord.height);

			RGBShape2YUV(pIcon->iconbuff, newdest, pIcon->icoord.x, pIcon->icoord.y, pIcon->icoord.width, pIcon->icoord.height);
		}
		else if (isInfoPressed)
		{
			bkgno = YUV_1;
			newdest = YUV_0;
			if (active_index == FI_ACTIVE)
			{
				bkgno = 1 - yuv_idx;
				newdest = RGB_1;
			}

			//ƥثeA(oرpusI)
			if (newdest == RGB_1)
			{
				CopyBlockYUV420(pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									RGB1, RGB1+yuv.u_offset, RGB1+yuv.v_offset, OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->icoord.width, pIcon->icoord.height);
			}
			else
			{
				CopyBlockYUV420(pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									(Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->icoord.width, pIcon->icoord.height);
			}

			RGBShape2YUV(pIcon->iconbuff, newdest, pIcon->icoord.x, pIcon->icoord.y, pIcon->icoord.width, pIcon->icoord.height);
		}
		else if (active_index == FI_ACTIVE || active_index == FLDR_FI_ACTIVE)
		{
			//rgbsrc = NULL;
			newdest = 1 - yuv_idx;
			if (active_index == FLDR_FI_ACTIVE)
				newdest = YUV_0;

			//for fashionstar switching resolution request - bk @ 071115
			//the resolution is not changed, keep original action
			if(currFIDspMode == origDisplayMode)
			{
				//ƥثeA
				CopyBlockYUV420(pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									(Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->icoord.width, pIcon->icoord.height);

				RGBShape2YUV(pIcon->iconbuff, newdest, pIcon->icoord.x, pIcon->icoord.y, pIcon->icoord.width, pIcon->icoord.height);
			}
			//the resolution is changed, Yp
			//TODO: eShŶsYp᪺,spgu_get_yuv_resolution->tempBuff1/4
			else
			{
				Uint16 i, j, *pRowSrc, *pRowDest, *pSrc, *pDest, *pD;
				Uint16 scale, w, h, x, y;
				Uint32 RowScale;

				//init parameters
				scale = 2;
				w = pIcon->icoord.width / scale;
				h = pIcon->icoord.height / scale;
				x = (OUTPUT_XRES - w) >> 1;
				y = (OUTPUT_YRES - h) >> 1;

				//scale down
				RowScale = (Uint32)pIcon->icoord.width * scale;
				pRowSrc = (Uint16*)pIcon->iconbuff;
				pRowDest = (Uint16*)g_pReaction_Icon_Group->tempbuff + (pIcon->icoord.width * pIcon->icoord.height * 3) / 2;
				pD = pRowDest;
				for (i=0; i<h; i++)
				{
					pSrc = pRowSrc;
					pDest = pRowDest;
					for (j=0; j<w; j++)
					{
						*pDest = *pSrc;
						pSrc += scale;
						pDest++;
					}
					pRowSrc += RowScale;
					pRowDest += w;
				}

				//ƥثeA
				CopyBlockYUV420(pIcon->pY, pIcon->pU, pIcon->pV, 	w, 0, 0,
									(Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest],
									OUTPUT_XRES, x, y, w, h);

				RGBShape2YUV((Uint8*)pD, newdest, x, y, w, h);
			}
		}
		else if (active_index == FV_ACTIVE || active_index == FLDR_FV_ACTIVE)
		{
			unsigned long buf_w, xres, yres;
			Uint16 i, j, *pRowSrc, *pRowDest, *pSrc, *pDest;
			Uint16 scale, w, h, x, y;
			Uint32 RowScale;

			newdest = YUV_1;
			pgu_get_yuv_resolution(&buf_w, &xres, &yres);

			///071008 full videoYp
			if (OUTPUT_YRES < desc->YRES)
			{
				scale = desc->YRES / OUTPUT_YRES;
				if (desc->YRES%OUTPUT_YRES >= (OUTPUT_YRES>>1)) scale++;
				w = pIcon->icoord.width / scale;
				h = pIcon->icoord.height / scale;
				x = (xres - w) >> 1;
				y = (yres - h) >> 1;

				if (xres > w && yres > h)
				{
					RowScale = (Uint32)scale * pIcon->icoord.width;
					pRowSrc = (Uint16*)pIcon->iconbuff;
					pRowDest = ((Uint16*)RGB0) + (Uint32)y * buf_w + x;
					for (i=0; i<h; i++)
					{
						pSrc = pRowSrc;
						pDest = pRowDest;
						for (j=0; j<w; j++)
						{
							*pDest = *pSrc;
							pSrc += scale;
							pDest++;
						}
						pRowSrc += RowScale;
						pRowDest += buf_w;
					}
					SetMSB((Uint16*)RGB0, buf_w, x, y, w, h, 1, BLACK_555);
				}
			}
			else
			///
			{
				w = pIcon->icoord.width;
				h = pIcon->icoord.height;
				x = (xres - w) >> 1;
				y = (yres - h) >> 1;

				if (xres > w && yres > h)
				{
					CopyBlockBitmap((Uint16*)RGB0, buf_w, x, y,
									 (Uint16*)pIcon->iconbuff, pIcon->icoord.width, 0, 0,
									 w, h);
					SetMSB((Uint16*)RGB0, buf_w, x, y, w, h, 1, BLACK_555);
				}
			}
			///080306 }hardware osd
			pgu_enable_tv_osd(1);
			///
		}
		/*
		else if (active_index == SS_ACTIVE)
		{
		}
		*/
		else		//ѾlLp(@벾focusδ)
		{
			newdest = YUV_1;
			if (active_index == CAL_ACTIVE) newdest = YUV_0;

			//ƥثeA
			CopyBlockYUV420(pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
								(Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
								pIcon->icoord.width, pIcon->icoord.height);


			RGBShape2YUV(pIcon->iconbuff, newdest, pIcon->icoord.x, pIcon->icoord.y, pIcon->icoord.width, pIcon->icoord.height);
		}
	}
	else if (Mode == -1)	//MF|
	{
		if (  isSetupPressed	//Software OSDwҰʪA
		    ||
			(active_index == CAL_ACTIVE && prev_active_index == FI_ACTIVE)
		   )
		{
			newdest = RGB_1;
			bkgno = YUV_1;
			if (prev_active_index == FI_ACTIVE) bkgno = 1 - yuv_idx;

			if (dest != newdest)	//^_W@hA
			{
				CopyBlockYUV420((Uint8*)planes.Y[bkgno], (Uint8*)planes.U[bkgno], (Uint8*)planes.V[bkgno], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									pIcon->icoord.width, pIcon->icoord.height);
			}

			BlendBlock(RGB1, RGB1+yuv.u_offset, RGB1+yuv.v_offset, OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
						(Uint16*)RGB0, OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
						(Uint8*)planes.Y[bkgno], (Uint8*)planes.U[bkgno], (Uint8*)planes.V[bkgno], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
						pIcon->icoord.width, pIcon->icoord.height
					   );
		}
		else if (isInfoPressed)
		{
			bkgno = YUV_1;
			newdest = YUV_0;
			if (active_index == FI_ACTIVE)
			{
				bkgno = 1 - yuv_idx;
				newdest = RGB_1;
			}

			if (dest != newdest && active == active_index)	//^_W@hA
			{
				CopyBlockYUV420((Uint8*)planes.Y[bkgno], (Uint8*)planes.U[bkgno], (Uint8*)planes.V[bkgno], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									pIcon->icoord.width, pIcon->icoord.height);
			}

			if (newdest == RGB_1)
			{
				BlendBlock(RGB1, RGB1+yuv.u_offset, RGB1+yuv.v_offset, OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
							(Uint16*)RGB0, OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
							(Uint8*)planes.Y[bkgno], (Uint8*)planes.U[bkgno], (Uint8*)planes.V[bkgno], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
							pIcon->icoord.width, pIcon->icoord.height
						   );
			}
			else		//newdest == YUV_0
			{
				BlendBlock((Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
							(Uint16*)RGB0, OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
							(Uint8*)planes.Y[bkgno], (Uint8*)planes.U[bkgno], (Uint8*)planes.V[bkgno], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
							pIcon->icoord.width, pIcon->icoord.height
						   );
			}
		}
		else if (active_index == FI_ACTIVE || active_index == FLDR_FI_ACTIVE)
		{
			newdest = 1 - yuv_idx;
			if (active_index == FLDR_FI_ACTIVE)
				newdest = YUV_0;

			if (dest == newdest)
			{
//for fashionstar switching resolution request - bk @ 071115
#ifndef TV_FI_SWITCH_RESOLUTION//ӭӪWh^
				CopyBlockYUV420((Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									pIcon->icoord.width, pIcon->icoord.height);
#else
				if(KeyNum != REPEAT)
				{
					//lѪRסAӭӪWh^
					if(currFIDspMode == origDisplayMode)
					{
						CopyBlockYUV420((Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									pIcon->icoord.width, pIcon->icoord.height);
					}
					//L᪺ѪRסA^ɤexsYpI
					else
					{
						Uint16 scale = 2, w, h, x, y;
						scale = 2;
						w = pIcon->icoord.width / scale;
						h = pIcon->icoord.height / scale;
						x = (OUTPUT_XRES - w) >> 1;
						y = (OUTPUT_YRES - h) >> 1;
						CopyBlockYUV420((Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, x, y,
											pIcon->pY, pIcon->pU, pIcon->pV, w, 0, 0,
											w, h);
					}
				}
#endif
			}
		}
		else if (active_index == FV_ACTIVE || active_index == FLDR_FV_ACTIVE)
		{
			unsigned long buf_w, xres, yres;
			Uint16 scale, w, h, x, y;

			newdest = YUV_1;
			if (active == active_index)		//u٭PbFull VideoAUͪϥ
			{
				pgu_get_yuv_resolution(&buf_w, &xres, &yres);

				///071008 full videoYp
				if (OUTPUT_YRES < desc->YRES)
				{
					scale = desc->YRES / OUTPUT_YRES;
					if (desc->YRES%OUTPUT_YRES >= (OUTPUT_YRES>>1)) scale++;
					w = pIcon->icoord.width / scale;
					h = pIcon->icoord.height / scale;
				}
				else
				{
					w = pIcon->icoord.width;
					h = pIcon->icoord.height;
				}
				x = (xres - w) >> 1;
				y = (yres - h) >> 1;

				if (xres > w && yres > h)
				{
					NewDrawRectBitMap(buf_w, (Uint16*)RGB0, x, y, w, h, BLACK_555);
				}
				///
			}
		}
		/*
		else if (active_index == SS_ACTIVE)
		{
		}
		*/
		else		//ѾlLp(@벾focusδ)
		{
			newdest = YUV_1;
			if (active_index == CAL_ACTIVE) newdest = YUV_0;

			if (dest == newdest && active == active_index)
			{
				CopyBlockYUV420((Uint8*)planes.Y[newdest], (Uint8*)planes.U[newdest], (Uint8*)planes.V[newdest], OUTPUT_XRES, pIcon->icoord.x, pIcon->icoord.y,
									pIcon->pY, pIcon->pU, pIcon->pV, pIcon->icoord.width, 0, 0,
									pIcon->icoord.width, pIcon->icoord.height);
			}
		}
	}

	dest = newdest;
	active = active_index;
}
//------------------------------------------------------------------------------------------------
void DrawVolume4WinaccordMusicPage()
{
#if defined(WINGUI) && defined(USE_DESC_TV)
	
	if(!(active_index == A_ACTIVE && GetDisplayIndex() == DISP_HDTV))
		return;
	
	//locate
	FRAME *elmf;
	COORD volOfWA = {1550, 950, 100, g_pFontDB_Local->FontSize};//vol pos of WA music page
	static char strVol[10]= {'\0'};
	
	//set string
	elmf = &ELMachines[active_index].frame;
	if(isMutePressed)
		sprintf(strVol, "%d", 0);
	else
		sprintf(strVol, "%d", volume);
	
	//erase
	DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate, volOfWA.x, volOfWA.y, volOfWA.width, volOfWA.height);
	//font
	FontTextOut(g_pFontDB_Default, (Uint16 *)RGB1, volOfWA.x, volOfWA.y, strVol, BLACK_1555);
	//rgb2yuv
	RGBlock2YUVBlock(RGB1, 1, volOfWA.x, volOfWA.y, volOfWA.width, volOfWA.height);
#endif
}
//------------------------------------------------------------------------------------------------
void DrawVolume4KingstonMusicPage()
{
#if defined(KINGSTON) && defined(USE_DESC_TV)
	
	if(active_index != A_ACTIVE)
		return;
	
	//locate
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	Uint8 showMuteVol = 0, i = 0, 
		//0: LR, 1: LL, 2: RR, 3: mute, 4: vol, 5:volx1
		idx = MUSIC_BAR_NUM + 3;
	
	//erase - from the header of LR to the footbar of mute
	DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate, 
		elmf->icon_arr[idx].icoord.x, elmf->icon_arr[idx].icoord.y, 
		elmf->icon_arr[idx].icoord.width, 
		elmf->icon_arr[idx + 3].icoord.y+ elmf->icon_arr[idx + 3].icoord.height - elmf->icon_arr[idx].icoord.y);
	
	//LR, LL, RR
	DuplicateBitmap((Uint16 *)RGB1, (Uint16 *)elmf->icon_arr[setup->aud_chnl_idx + idx].iconbuff,
		elmf->icon_arr[setup->aud_chnl_idx + idx].icoord.x, elmf->icon_arr[setup->aud_chnl_idx + idx].icoord.y,
		elmf->icon_arr[setup->aud_chnl_idx + idx].icoord.width, elmf->icon_arr[setup->aud_chnl_idx + idx].icoord.height);
	
	//mute, vol
	if(isMutePressed || volume == 0)
		showMuteVol = idx + 3;
	else
		showMuteVol = idx + 4;
	DuplicateBitmap((Uint16 *)RGB1, (Uint16 *)elmf->icon_arr[showMuteVol].iconbuff,
		elmf->icon_arr[showMuteVol].icoord.x, elmf->icon_arr[showMuteVol].icoord.y,
		elmf->icon_arr[showMuteVol].icoord.width, elmf->icon_arr[showMuteVol].icoord.height);
	
	//volumize
	for(i = 0; i < volume; i++)
	{
		DuplicateBitmap((Uint16 *)RGB1, (Uint16 *)elmf->icon_arr[idx + 5].iconbuff,
			elmf->icon_arr[idx + 5].icoord.x, 
			elmf->icon_arr[idx + 5].icoord.y - elmf->icon_arr[idx + 5].icoord.height * i,
			elmf->icon_arr[idx + 5].icoord.width, 
			elmf->icon_arr[idx + 5].icoord.height);
	}
	
	//rgb2yuv
	RGBlock2YUVBlock(RGB1, 1, elmf->icon_arr[idx].icoord.x, elmf->icon_arr[idx].icoord.y, 
		elmf->icon_arr[idx].icoord.width, 
		elmf->icon_arr[idx + 3].icoord.y+ elmf->icon_arr[idx + 3].icoord.height - elmf->icon_arr[idx].icoord.y);
#endif
}
//------------------------------------------------------------------------------------------------
void DrawMute()
{
#ifdef FASHIONSTAR
	return;
#endif

#if defined(KINGSTON)
	if(active_index == A_ACTIVE)
		return;
#endif

	FRAME *elmf;
	unsigned long buf_w, w, h;
	int disp;

	pgu_get_yuv_resolution(&buf_w, &w, &h);
	//PRINTF("buf_w:%d, w:%d, h:%d\n", buf_w, w, h);
	elmf = &ELMachines[active_index].frame;

	if(elmf->volumebuff == NULL)
	{
		PRINTF("Drawing Mute Error!!! VolBuff is NULL!!!");
		return;
	}

	disp = GetDisplayIndex();

	//-- Flowbee 2008-05-14
	#ifdef USE_DESC_TV
	if(buf_w > 630)
	{
		posOfMute.x = 42;
		posOfMute.y = 24;
	}else
	{
		posOfMute.x = 10;
		posOfMute.y = 10;
	}
	#endif

#if USE_TERAWINS_TCON	// Flowbee@960621. use terawins osd to display mute icon.

#ifdef USE_DESC_TV
	///070820 HDTVܭq
	if (disp == DISP_HDTV)
	{
		return;
	}
	///
	else if( (disp == DISP_NTSC) || (disp == DISP_PAL) )
	{
		if(active_index == CAL_ACTIVE && prev_active_index == FI_ACTIVE)
		{
			NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)RGB0, posOfMute.x, posOfMute.y, posOfMute.width, posOfMute.height, BLACK_1555);
			FontTextOutAlign(g_pFontDB_Default, (Uint16 *)RGB0, (Uint16)(buf_w) , posOfMute.x + 1, posOfMute.y + 1, 0, "MUTE", WHITE_1555);
		}else
		{
			memset(elmf->volumebuff, 0, RGB_VOLBUFF_SIZE);
			NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)elmf->volumebuff, posOfMute.x, 0, posOfMute.width, posOfMute.height, BLACK_1555);
			FontTextOutAlign(g_pFontDB_Default, (Uint16 *)elmf->volumebuff, (Uint16)(buf_w), posOfMute.x + 1, 1, 0, "MUTE", WHITE_1555);
			//if(active_index != FV_ACTIVE)
			if(active_index != FV_ACTIVE && active_index != FLDR_FV_ACTIVE)//bk @ 071030
				memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
			else
			{
				memset(RGB0 + buf_w * 2 * posOfMute.y, 0, RGB_VOLBUFF_SIZE);
				memset(RGB0 + ((Uint16)(buf_w))  * 2 * posOfVol.y, 0, RGB_VOLBUFF_SIZE);
			}
			memcpy(RGB0 + buf_w * 2 * posOfMute.y, elmf->volumebuff, RGB_VOLBUFF_SIZE);
			pgu_enable_tv_osd(1);
		}
	}
	else
#endif	//USE_DESC_TV
	{
		tcon_show_mute_vol(OSD_MUTE);
	}

	//pgu_enable_mute_vol_osd(MUTE_ADDRESS_X, MUTE_ADDRESS_Y, OSD_MUTE);
#else	// Software OSD

///070820 HDTVܭq
#ifdef USE_DESC_TV
	if (disp == DISP_HDTV)
	{
		return;
	}
	else
#endif
///
	if(active_index == CAL_ACTIVE && prev_active_index == FI_ACTIVE)
	{
		NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)RGB0, posOfMute.x, posOfMute.y, posOfMute.width, posOfMute.height, BLACK_1555);
		FontTextOutAlign(g_pFontDB_Default, (Uint16 *)RGB0, (Uint16)(buf_w) , posOfMute.x + 1, posOfMute.y + 1, 0, "MUTE", WHITE_1555);
	}else
	{
		memset(elmf->volumebuff, 0, RGB_VOLBUFF_SIZE);
		NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)elmf->volumebuff, posOfMute.x, 0, posOfMute.width, posOfMute.height, BLACK_1555);
		FontTextOutAlign(g_pFontDB_Default, (Uint16 *)elmf->volumebuff, (Uint16)(buf_w), posOfMute.x + 1, 1, 0, "MUTE", WHITE_1555);
		//if(active_index != FV_ACTIVE)
		if(active_index != FV_ACTIVE && active_index != FLDR_FV_ACTIVE)//bk @ 071030
			memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
		else
		{
			memset(RGB0 + buf_w * 2 * posOfMute.y, 0, RGB_VOLBUFF_SIZE);
			memset(RGB0 + ((Uint16)(buf_w))  * 2 * posOfVol.y, 0, RGB_VOLBUFF_SIZE);
		}
		memcpy(RGB0 + buf_w * 2 * posOfMute.y, elmf->volumebuff, RGB_VOLBUFF_SIZE);
		pgu_enable_tv_osd(1);
	}
#endif	//USE_TERAWINS_TCON
}
//------------------------------------------------------------------------------------------------
void DrawVolume()
{
#if defined(KINGSTON)
	if(active_index == A_ACTIVE)
		return;
#endif

//for fashionstar switching resolution request - bk @ 071114
#ifdef USE_DESC_TV
  #ifdef TV_FI_SWITCH_RESOLUTION

	if(active_index == FI_ACTIVE || active_index == FLDR_FI_ACTIVE)
		//the resolution is different from original display mode
		if(currFIDspMode != origDisplayMode)
			return;//draw nothing

  #endif
#endif

	FRAME *elmf;
	int i, disp;
	unsigned long buf_w, w, h;
	///070820
	Uint16 Len;
	Uint16 /*FONT_HEIGHT = 26, */FONT_WIDTH = 13, TVBorderH = 22;
	if (g_pFontDB_Default)
	{
//		FONT_HEIGHT = g_pFontDB_Default->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Default, "W");
	}
	///

	pgu_get_yuv_resolution(&buf_w, &w, &h);
	posOfVol.x = ((Uint16)(w) - posOfVol.width) / 2;
	posOfVol.y = (Uint16)(h) - 32;
#ifdef VIDEO_TIME_DISPLAY_MOD
	if((active_index == FV_ACTIVE || active_index == FLDR_FV_ACTIVE) && setup->vid_time_dsply_idx == SETUP_ON)
		posOfVol.y = posOfVol.y - 26;
#endif
	if(h >= 450)
		posOfVol.y = posOfVol.y  - TVBorderH;
/*
// Xenia 03/12/2008
#ifdef USE_DESC_TV
	if (pgu_get_display_index() == DISP_NTSC)
		posOfVol.y = (Uint16)posOfVol.y - (16 * 2);
#endif
*/
	//PRINTF("buf_w:%d, w:%d, h:%d\n", buf_w, w, h);
	elmf = &ELMachines[active_index].frame;

	if(elmf->volumebuff == NULL)
	{
		PRINTF("Drawing Volume Error!!! VolBuff is NULL!!!");
		return;
	}

	disp = GetDisplayIndex();

#if USE_TERAWINS_TCON	//-- TeraWins T-CON

#ifdef USE_DESC_TV
	///070820 HDTVܭq
	if (disp == DISP_HDTV)
	{
		return;
	}
	///
	else if( (disp == DISP_NTSC) || (disp == DISP_PAL) )
	{
		if(active_index == CAL_ACTIVE && prev_active_index == FI_ACTIVE)
		{
			NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)RGB0, posOfVol.x, posOfVol.y, posOfVol.width, posOfVol.height, BLACK_1555);
			Len = FontTextOutAlign(g_pFontDB_Default, (Uint16 *)RGB0, (Uint16)(buf_w), posOfVol.x + 2, posOfVol.y + 1, 0, "VOL", WHITE_1555);
			for(i = 0; i < volume; i++)
				NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)RGB0, (posOfVol.x + FONT_WIDTH * i + Len + 3), posOfVol.y + 2, FONT_WIDTH-4, posOfVol.height-4, WHITE_1555);
		}else
		{
			memset(elmf->volumebuff, 0, RGB_VOLBUFF_SIZE);
			NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)elmf->volumebuff, posOfVol.x, 0, posOfVol.width, posOfVol.height, BLACK_1555);
			Len = FontTextOutAlign(g_pFontDB_Default, (Uint16 *)elmf->volumebuff, (Uint16)(buf_w), posOfVol.x + 2, 1, 0, "VOL", WHITE_1555);
			for(i = 0; i < volume; i++)
				NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)elmf->volumebuff, (posOfVol.x + FONT_WIDTH * i + Len + 3), 2, FONT_WIDTH-4, posOfVol.height-4, WHITE_1555);
			/* Flowbee@960505. */
			//if(active_index != FV_ACTIVE)
			if(active_index != FV_ACTIVE && active_index != FLDR_FV_ACTIVE)//bk @ 071030
				memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
			else
			{
				memset(RGB0 + buf_w * 2 * posOfMute.y, 0, RGB_VOLBUFF_SIZE);
				memset(RGB0 + ((Uint16)(buf_w))  * 2 * posOfVol.y, 0, buf_w * 2 * posOfVol.height);
			}
			memcpy(RGB0 + ((Uint16)(buf_w))  * 2 * posOfVol.y, elmf->volumebuff, buf_w * 2 * posOfVol.height);
			pgu_enable_tv_osd(1);
		}
	}
	else
#endif	//USE_DESC_TV
	{
		tcon_show_mute_vol(volume);
	}

	//pgu_enable_vol_osd((unsigned long)volume);
#else

///070820 HDTVܭq
#ifdef USE_DESC_TV
	if (disp == DISP_HDTV)
	{
		return;
	}
	else
#endif
///
	if(active_index == CAL_ACTIVE && prev_active_index == FI_ACTIVE)
	{
		NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)RGB0, posOfVol.x, posOfVol.y, posOfVol.width, posOfVol.height, BLACK_1555);
		Len = FontTextOutAlign(g_pFontDB_Default, (Uint16 *)RGB0, (Uint16)(buf_w), posOfVol.x + 2, posOfVol.y + 1, 0, "VOL", WHITE_1555);
		for(i = 0; i < volume; i++)
			NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)RGB0, (posOfVol.x + FONT_WIDTH * i + Len + 3), posOfVol.y + 2, FONT_WIDTH-4, posOfVol.height-4, WHITE_1555);
	}else
	{
		memset(elmf->volumebuff, 0, RGB_VOLBUFF_SIZE);
		NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)elmf->volumebuff, posOfVol.x, 0, posOfVol.width, posOfVol.height, BLACK_1555);
		Len = FontTextOutAlign(g_pFontDB_Default, (Uint16 *)elmf->volumebuff, (Uint16)(buf_w), posOfVol.x + 2, 1, 0, "VOL", WHITE_1555);
		for(i = 0; i < volume; i++)
			NewDrawRectBitMap((Uint16)(buf_w), (Uint16 *)elmf->volumebuff, (posOfVol.x + FONT_WIDTH * i + Len + 3), 2, FONT_WIDTH-4, posOfVol.height-4, WHITE_1555);
		/* Flowbee@960505. */
		//if(active_index != FV_ACTIVE)
		if(active_index != FV_ACTIVE && active_index != FLDR_FV_ACTIVE)//bk @ 071030
			memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
		else
		{
			memset(RGB0 + buf_w * 2 * posOfMute.y, 0, RGB_VOLBUFF_SIZE);
			memset(RGB0 + ((Uint16)(buf_w))  * 2 * posOfVol.y, 0, buf_w * 2 * posOfVol.height);
		}
		memcpy(RGB0 + ((Uint16)(buf_w))  * 2 * posOfVol.y, elmf->volumebuff, buf_w * 2 * posOfVol.height);
		pgu_enable_tv_osd(1);
	}
#endif	//USE_TERAWINS_TCON
}
